# QEpy - Quantum ESPRESSO in Python
   `QEpy` turns Quantum ESPRESSO (QE) into a Python DFT engine for nonstandard workflows.

   <!--Check out a [YouTube video](https://www.youtube.com/watch?v=cWt0BVQs-_U) with additional information (installation and examples).-->

## Contributors and funding
 - [The Quantum-Multiscale collaboration](http://www.quantum-multiscale.org/)
 - Main author: [Xuecheng Shao](mailto:xuecheng.shao@rutgers.edu) (Rutgers)
 - Oliviero Andreussi (UNT), Davide Ceresoli (CNR, Italy), Matthew Truscott (UNT), Andrew Baczewski (Sandia), Quinn Campbell (Sandia), Michele Pavanello (Rutgers)


## Thanks to ...
 - The Quantum ESPRESSO developers for the QE codebase
 - NSF for funding the Quantum-Multiscale collaboration

## Requirements
 - [Python](https://www.python.org/) (>=3.7)
 - [NumPy](https://docs.scipy.org/doc/numpy/reference/) (>=1.18.0)
 - [f90wrap](https://github.com/jameskermode/f90wrap) (>=0.2.8)
 - [Quantum ESPRESSO ](https://gitlab.com/QEF/q-e/-/releases/qe-6.5) (=6.5)
 - Compiler ([GNU](https://gcc.gnu.org/fortran/)(Recommended) or [Intel](https://software.intel.com/content/www/us/en/develop/tools/oneapi/components/fortran-compiler.html))

## Install
 - **QE**

	All static libraries should be compiled with the `-fPIC` compuiler option. Add `-fPIC` to the configuration options. E.g.,

     ```shell
	 ./configure CFLAGS=-fPIC FFLAGS=-fPIC try_foxflags=-fPIC MPIF90=mpif90
     ```

	Intel compiler:


     ```shell
	 ./configure CFLAGS=-fPIC FFLAGS=-fPIC try_foxflags=-fPIC MPIF90=mpiifort
	 ```

   + `make pw` or `make pwlibs`.

 - **QEpy**

     ```shell
	 git clone --recurse-submodules https://gitlab.com/shaoxc/qepy.git
     qedir=${QE} oldxml=yes ldau=yes tddft=yes python -m pip install -U ./qepy
	 ```

## Manual and Tutorials

  See [QEpy's website](http://qepy.rutgers.edu) for details.

!
! Copyright (C) 2001-2016 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
!
!----------------------------------------------------------------------------
SUBROUTINE qepy_potinit(starting)
  !----------------------------------------------------------------------------
  !
  ! ... This routine initializes the self consistent potential in the array
  ! ... vr. There are three possible cases:
  !
  ! ... a) the code is restarting from a broken run:
  ! ...    read rho from data stored during the previous run
  ! ... b) the code is performing a non-scf calculation following a scf one:
  ! ...    read rho from the file produced by the scf calculation
  ! ... c) the code starts a new calculation:
  ! ...    calculate rho as a sum of atomic charges
  ! 
  ! ... In all cases the scf potential is recalculated and saved in vr
  !
  USE kinds,                ONLY : DP
  USE constants,            ONLY : pi
  USE io_global,            ONLY : stdout
  USE cell_base,            ONLY : alat, omega
  USE ions_base,            ONLY : nat, ityp, ntyp => nsp
  USE basis,                ONLY : starting_pot
  USE klist,                ONLY : nelec
  USE lsda_mod,             ONLY : lsda, nspin
  USE fft_base,             ONLY : dfftp
  USE fft_interfaces,       ONLY : fwfft
  USE gvect,                ONLY : ngm, gstart, g, gg, ig_l2g
  USE gvecs,                ONLY : doublegrid
  USE control_flags,        ONLY : lscf, gamma_only
  USE scf,                  ONLY : rho, rho_core, rhog_core, &
                                   vltot, v, vrs, kedtau
  USE funct,                ONLY : dft_is_meta
  USE ener,                 ONLY : ehart, etxc, vtxc, epaw
  USE ldaU,                 ONLY : lda_plus_u, Hubbard_lmax, eth, &
                                   niter_with_fixed_ns
  USE noncollin_module,     ONLY : noncolin, report
  USE io_files,             ONLY : restart_dir, input_drho, check_file_exist
  USE spin_orb,             ONLY : domag, lforcet
  USE mp,                   ONLY : mp_sum
  USE mp_bands ,            ONLY : intra_bgrp_comm, root_bgrp
  USE io_global,            ONLY : ionode, ionode_id
  USE io_rho_xml,           ONLY : read_scf
  USE io_base,              ONLY : read_rhog
  USE fft_rho,              ONLY : rho_g2r, rho_r2g
  !
  USE uspp,                 ONLY : becsum
  USE paw_variables,        ONLY : okpaw, ddd_PAW
  USE paw_init,             ONLY : PAW_atomic_becsum
  USE paw_onecenter,        ONLY : PAW_potential
  !
  USE klist,                ONLY : nelup, neldw
  !
  IMPLICIT NONE
  !
  REAL(DP)              :: charge           ! the starting charge
  REAL(DP)              :: etotefield       !
  REAL(DP)              :: fact
  INTEGER               :: is
  LOGICAL               :: exst 
  CHARACTER(LEN=320)    :: filename
  !
  CHARACTER(LEN=*), INTENT(IN), OPTIONAL :: starting
  !
  CALL start_clock('potinit')
  !
  filename = TRIM (restart_dir( )) // 'charge-density'
#if defined __HDF5
  exst     =  check_file_exist( TRIM(filename) // '.hdf5' )
#else 
  exst     =  check_file_exist( TRIM(filename) // '.dat' )
#endif
  !
  IF (present(starting)) THEN
     IF (len_trim(starting)>1) starting_pot = trim(starting)
  ENDIF
  !
  IF ( starting_pot == 'file' .AND. exst ) THEN
     !
     ! ... Cases a) and b): the charge density is read from file
     ! ... this also reads rho%ns if lda+U, rho%bec if PAW, rho%kin if metaGGA
     !
     IF ( .NOT.lforcet ) THEN
        CALL read_scf ( rho, nspin, gamma_only )
     ELSE
        !
        ! ... 'force theorem' calculation of MAE: read rho only from previous
        ! ... lsda calculation, set noncolinear magnetization from angles
        !
        CALL read_rhog ( filename, root_bgrp, intra_bgrp_comm, &
             ig_l2g, nspin, rho%of_g, gamma_only )
        CALL nc_magnetization_from_lsda ( dfftp%ngm, nspin, rho%of_g )
     END IF
     !
     IF ( lscf ) THEN
        !
        WRITE( stdout, '(/5X, &
             & "The initial density is read from file :"/5X,A,/)' ) &
            TRIM( filename )
        !
     ELSE
        !
        WRITE( stdout, '(/5X, &
             & "The potential is recalculated from file :"/5X,A,/)' ) &
            TRIM( filename )
        !
     END IF
     !
  ELSE
     !
     ! ... Case c): the potential is built from a superposition 
     ! ... of atomic charges contained in the array rho_at
     !
     IF ( starting_pot == 'file' .AND. .NOT. exst ) &
        WRITE( stdout, '(5X,"Cannot read rho : file not found")' )
     !
     WRITE( UNIT = stdout, &
            FMT = '(/5X,"Initial potential from superposition of free atoms")' )
     !
     CALL atomic_rho_g( rho%of_g, nspin )

     ! ... in the lda+U case set the initial value of ns
     IF (lda_plus_u) THEN
        !
        IF (noncolin) THEN
           CALL init_ns_nc()
        ELSE
           CALL init_ns()
        ENDIF
        !
     ENDIF

     ! ... in the paw case uses atomic becsum
     IF ( okpaw )      CALL PAW_atomic_becsum()
     !
     IF ( input_drho /= ' ' ) THEN
        !
        IF ( nspin > 1 ) CALL errore &
             ( 'potinit', 'spin polarization not allowed in drho', 1 )
        !
        filename = TRIM( restart_dir( )) // input_drho
        CALL read_rhog ( filename, root_bgrp, intra_bgrp_comm, &
             ig_l2g, nspin, v%of_g, gamma_only )
        !
        WRITE( UNIT = stdout, &
               FMT = '(/5X,"a scf correction to at. rho is read from",A)' ) &
            TRIM( filename )
        !
        rho%of_g = rho%of_g + v%of_g
        !
     END IF
     !
  END IF
  !
  ! ... check the integral of the starting charge, renormalize if needed
  !
  charge = 0.D0
  IF ( gstart == 2 ) THEN
     charge = omega*REAL( rho%of_g(1,1) )
  END IF
  CALL mp_sum(  charge , intra_bgrp_comm )
  !
  IF ( lscf .AND. ABS( charge - nelec ) > ( 1.D-7 * charge ) ) THEN
     !
     IF ( charge > 1.D-8 .AND. nat > 0 ) THEN
        WRITE( stdout, '(/,5X,"starting charge ",F10.5, &
                         & ", renormalised to ",F10.5)') charge, nelec
        rho%of_g = rho%of_g / charge * nelec
     ELSE 
        WRITE( stdout, '(/,5X,"Starting from uniform charge")')
        rho%of_g(:,1:nspin) = (0.0_dp,0.0_dp)
        IF ( gstart == 2 ) rho%of_g(1,1) = nelec / omega
     ENDIF
     !
  ELSE IF ( .NOT. lscf .AND. ABS( charge - nelec ) > (1.D-3 * charge ) ) THEN
     !
     CALL errore( 'potinit', 'starting and expected charges differ', 1 )
     !
  END IF
  !qepy --> scale charge for spin
  IF ( nspin == 2 ) THEN
     rho%of_g(1,2) = (nelup-neldw) / omega
  ENDIF
  !qepy <-- scale charge for spin
  !
  ! ... bring starting rho from G- to R-space
  !
  CALL rho_g2r (dfftp, rho%of_g, rho%of_r)
  !
  IF  ( dft_is_meta() ) THEN
     IF (starting_pot /= 'file') THEN
        ! ... define a starting (TF) guess for rho%kin_r from rho%of_r
        ! ... to be verified for LSDA: rho is (tot,magn), rho_kin is (up,down)
        fact = (3.d0/5.d0)*(3.d0*pi*pi)**(2.0/3.0)
        DO is = 1, nspin
           rho%kin_r(:,is) = fact * abs(rho%of_r(:,is)*nspin)**(5.0/3.0)/nspin
        END DO
        !if (nspin==2) then
        !     rho%kin_r(:,1) = fact * abs(rho%of_r(:,1)+rho%of_r(:,2))**(5.0/3.0)/2.0
        !     rho%kin_r(:,2) = fact * abs(rho%of_r(:,1)-rho%of_r(:,2))**(5.0/3.0)/2.0
        !endif
        ! ... bring it to g-space
        CALL rho_r2g (dfftp, rho%kin_r, rho%kin_g)
     ELSE
        ! ... rho%kin was read from file in G-space, bring it to R-space
        CALL rho_g2r (dfftp, rho%kin_g, rho%kin_r)
     ENDIF
     !
  END IF
  !
  ! ... plugin contribution to local potential
  !
  CALL plugin_scf_potential(rho,.FALSE.,-1.d0,vltot)
  !
  ! ... compute the potential and store it in v
  !
  CALL v_of_rho( rho, rho_core, rhog_core, &
                 ehart, etxc, vtxc, eth, etotefield, charge, v )
  IF (okpaw) CALL PAW_potential(rho%bec, ddd_PAW, epaw)
  !
  ! ... define the total local potential (external+scf)
  !
  CALL set_vrs( vrs, vltot, v%of_r, kedtau, v%kin_r, dfftp%nnr, nspin, doublegrid )
  !
  ! ... write on output the parameters used in the lda+U calculation
  !
  IF ( lda_plus_u ) THEN
     !
     WRITE( stdout, '(5X,"Number of +U iterations with fixed ns =",I3)') &
         niter_with_fixed_ns
     WRITE( stdout, '(5X,"Starting occupations:")')
     !
     IF (noncolin) THEN
       CALL write_ns_nc()
     ELSE
       CALL write_ns()
     ENDIF
     !
  END IF
  !
  IF ( report /= 0 .AND. &
       noncolin .AND. domag .AND. lscf ) CALL report_mag()
  !
  CALL stop_clock('potinit')
  !
  RETURN
  !
END SUBROUTINE qepy_potinit
!
!-------------
!SUBROUTINE nc_magnetization_from_lsda ( ngm, nspin, rho )
!  !-------------
!  !
!  USE kinds,     ONLY: dp
!  USE constants, ONLY: pi
!  USE io_global, ONLY: stdout
!  USE noncollin_module, ONLY: angle1, angle2
!  !
!  IMPLICIT NONE
!  INTEGER, INTENT (in):: ngm, nspin
!  COMPLEX(dp), INTENT (inout):: rho(ngm,nspin)
!  !---  
!  !  set up noncollinear m_x,y,z from collinear m_z (AlexS) 
!  !
!  WRITE(stdout,*)
!  WRITE(stdout,*) '-----------'
!  WRITE(stdout,'("Spin angles Theta, Phi (degree) = ",2f8.4)') &
!       angle1(1)/PI*180.d0, angle2(1)/PI*180.d0 
!  WRITE(stdout,*) '-----------'
!  !
!  ! now set rho(2)=magn*sin(theta)*cos(phi)   x
!  !         rho(3)=magn*sin(theta)*sin(phi)   y
!  !         rho(4)=magn*cos(theta)            z
!  !
!  rho(:,2) = rho(:,4)*sin(angle1(1))
!  rho(:,3) = rho(:,2)*sin(angle2(1))
!  rho(:,4) = rho(:,4)*cos(angle1(1))
!  rho(:,2) = rho(:,2)*cos(angle2(1))
!  !
!  RETURN
!  !
!END SUBROUTINE nc_magnetization_from_lsda

!
! Copyright (C) 2001 PWSCF group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
!----------------------------------------------------------------------------
! TB
! setup of the gate, search for 'TB'
!----------------------------------------------------------------------------
!
!----------------------------------------------------------------------
SUBROUTINE qepy_setlocal(exttype)
  !----------------------------------------------------------------------
  !! This routine computes the local potential in real space vltot(ir).
  !
  USE io_global,         ONLY : stdout
  USE kinds,             ONLY : DP
  USE constants,         ONLY : eps8
  USE ions_base,         ONLY : zv, ntyp => nsp
  USE cell_base,         ONLY : omega
  USE extfield,          ONLY : tefield, dipfield, etotefield, gate, &
                                etotgatefield !TB
  USE gvect,             ONLY : igtongl, gg
  USE scf,               ONLY : rho, v_of_0, vltot
  USE vlocal,            ONLY : strf, vloc
  USE fft_base,          ONLY : dfftp
  USE fft_interfaces,    ONLY : invfft
  USE gvect,             ONLY : ngm
  USE control_flags,     ONLY : gamma_only
  USE mp_bands,          ONLY : intra_bgrp_comm
  USE mp,                ONLY : mp_sum
  USE martyna_tuckerman, ONLY : wg_corr_loc, do_comp_mt
  USE esm,               ONLY : esm_local, esm_bc, do_comp_esm
  USE qmmm,              ONLY : qmmm_add_esf
  USE Coul_cut_2D,       ONLY : do_cutoff_2D, cutoff_local 
  !
  IMPLICIT NONE
  !
  COMPLEX(DP), ALLOCATABLE :: aux(:), v_corr(:)
  ! auxiliary variable
  INTEGER :: nt, ng
  ! counter on atom types
  ! counter on g vectors
  integer, intent(in), optional      :: exttype
  logical              :: have = .true.
  !
  if (present(exttype)) then
     if (iand(exttype,1) == 1) have = .false.
  endif
  !
  if (have) then
  ALLOCATE( aux(dfftp%nnr) )
  aux(:) = (0.d0,0.d0)
  !
  IF (do_comp_mt) THEN
     ALLOCATE( v_corr(ngm) )
     CALL wg_corr_loc( omega, ntyp, ngm, zv, strf, v_corr )
     aux(dfftp%nl(:)) = v_corr(:)
     DEALLOCATE( v_corr )
  ENDIF
  !
  DO nt = 1, ntyp
     DO ng = 1, ngm
        aux(dfftp%nl(ng)) = aux(dfftp%nl(ng)) + vloc(igtongl(ng),nt) &
                            * strf(ng,nt)
     ENDDO
  ENDDO
  !
  IF (gamma_only) THEN
     DO ng = 1, ngm
        aux(dfftp%nlm(ng)) = CONJG( aux(dfftp%nl(ng)) )
     ENDDO
  ENDIF
  !
  IF ( do_comp_esm .AND. ( esm_bc .NE. 'pbc' ) ) THEN
     !
     ! ... Perform ESM correction to local potential
     !
     CALL esm_local( aux )
     !
  ENDIF
  !
  ! 2D: re-add the erf/r function
  IF ( do_cutoff_2D ) THEN
     !
     ! ... re-add the CUTOFF fourier transform of erf function
     !
     CALL cutoff_local( aux )
     !
  ENDIF 
  !
  ! ... v_of_0 is (Vloc)(G=0)
  !
  v_of_0 = 0.0_DP
  IF (gg(1) < eps8) v_of_0 = DBLE( aux(dfftp%nl(1)) )
  !
  CALL mp_sum( v_of_0, intra_bgrp_comm )
  !
  ! ... aux = potential in G-space . FFT to real space
  !
  CALL invfft( 'Rho', aux, dfftp )
  !
  vltot(:) =  DBLE( aux(:) )
  else
  vltot(:) =  0.0_DP
  endif
  !
  ! ... If required add an electric field to the local potential 
  !
  IF ( tefield .AND. ( .NOT. dipfield ) )  &
      CALL add_efield( vltot, etotefield, rho%of_r, .TRUE. )
  !
  ! TB
  ! if charged plate, call add_gatefield and add the linear potential,
  ! together with the background charge
  IF (gate) CALL add_gatefield( vltot, etotgatefield, .TRUE., .TRUE. )
  !
  !  ... Add the electrostatic field generated by MM atoms
  !  in a QM/MM calculation to the local potential
  !
  CALL qmmm_add_esf( vltot, dfftp )
  !
  ! ... Save vltot for possible modifications in plugins
  !
  CALL plugin_init_potential( vltot )
  !
  if (have) then
  DEALLOCATE( aux )
  endif
  !
  !
  RETURN
  !
END SUBROUTINE qepy_setlocal

!
! Copyright (C) 2001-2006 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
!----------------------------------------------------------------------------
SUBROUTINE qepy_init_run(oldxml)
  !----------------------------------------------------------------------------
  !
  USE klist,              ONLY : nkstot
  USE symme,              ONLY : sym_rho_init
  USE wvfct,              ONLY : nbnd, et, wg, btype
  USE control_flags,      ONLY : lmd, gamma_only, smallmem, ts_vdw
  USE gvect,              ONLY : g, gg, mill, gcutm, ig_l2g, ngm, ngm_g, &
                                 gshells, gstart ! to be comunicated to the Solvers if gamma_only
  USE gvecs,              ONLY : gcutms, ngms
  USE cell_base,          ONLY : at, bg, set_h_ainv
  USE cellmd,             ONLY : lmovecell
  USE dynamics_module,    ONLY : allocate_dyn_vars
  USE paw_variables,      ONLY : okpaw
  USE paw_init,           ONLY : paw_init_onecenter, allocate_paw_internals
#if defined(__MPI)
  USE paw_init,           ONLY : paw_post_init
#endif
  USE mp_images,          ONLY : intra_image_comm
  USE mp,                 ONLY : mp_barrier
  USE bp,                 ONLY : allocate_bp_efield, bp_global_map
  USE fft_base,           ONLY : dfftp, dffts
  USE funct,              ONLY : dft_is_hybrid
  USE recvec_subs,        ONLY : ggen, ggens
  USE wannier_new,        ONLY : use_wannier    
  USE dfunct,             ONLY : newd
  USE esm,                ONLY : do_comp_esm, esm_init
  USE tsvdw_module,       ONLY : tsvdw_initialize
  USE Coul_cut_2D,        ONLY : do_cutoff_2D, cutoff_fact 
  !
  IMPLICIT NONE
  LOGICAL, INTENT(IN), OPTIONAL :: oldxml
  LOGICAL               :: oldver
  !
  if (present(oldxml)) then
     oldver = oldxml
  else
     oldver = .FALSE.
  endif
#if !defined (__OLDXML) 
if (oldver) then
   CALL errore( 'qepy_init_run', 'Do no use oldxml in normal version. Please rebuild with -D__OLDXML.', 1 )
endif
#endif
  !
  CALL start_clock( 'init_run' )
  !
  ! ... calculate limits of some indices, used in subsequent allocations
  !
  CALL pre_init()
  !
  ! ... determine the data structure for fft arrays
  !
  CALL data_structure( gamma_only )
  !
  ! ... print a summary and a memory estimate before starting allocating
  !
  CALL summary()
  CALL memory_report()
  !
  ! ... allocate memory for G- and R-space fft arrays
  !
  CALL allocate_fft()
  !
  ! ... generate reciprocal-lattice vectors and fft indices
  !
  IF( smallmem ) THEN
     CALL ggen( dfftp, gamma_only, at, bg, gcutm, ngm_g, ngm, &
          g, gg, mill, ig_l2g, gstart, no_global_sort = .TRUE. )
  ELSE
     CALL ggen( dfftp, gamma_only, at, bg, gcutm, ngm_g, ngm, &
       g, gg, mill, ig_l2g, gstart )
  END IF
  CALL ggens( dffts, gamma_only, at, g, gg, mill, gcutms, ngms )
  if (gamma_only) THEN
     ! ... Solvers need to know gstart
     call export_gstart_2_solvers(gstart)
  END IF
  !
  IF (do_comp_esm) CALL esm_init()
  !
  ! ... setup the 2D cutoff factor
  !
  IF (do_cutoff_2D) CALL cutoff_fact()
  !
  CALL gshells ( lmovecell )
  !
  ! ... variable initialization for parallel symmetrization
  !
  CALL sym_rho_init (gamma_only )
  !
  ! ... allocate memory for all other arrays (potentials, wavefunctions etc)
  !
  CALL allocate_nlpot()
  IF (okpaw) THEN
     CALL allocate_paw_internals()
     CALL paw_init_onecenter()
  ENDIF
  CALL allocate_locpot()
  CALL allocate_bp_efield()
  CALL bp_global_map()
  !
  call plugin_initbase()
  !
  ALLOCATE( et( nbnd, nkstot ) , wg( nbnd, nkstot ), btype( nbnd, nkstot ) )
  !
  et(:,:) = 0.D0
  wg(:,:) = 0.D0
  !
  btype(:,:) = 1
  !
  IF (ts_vdw) THEN
     CALL tsvdw_initialize()
     CALL set_h_ainv()
  END IF
  !
  CALL allocate_wfc_k()
  CALL openfil()
  !
  CALL hinit0()
  !
  CALL mp_barrier( intra_image_comm ) ! for oldxml
  if (oldver) then
#if defined (__OLDXML) 
     call oldxml_potinit()
#else
   CALL errore( 'qepy_init_run', 'Do no use oldxml in normal version. Please rebuild with -D__OLDXML.', 1 )
#endif
  else
  !CALL potinit()
  CALL qepy_potinit('')
  endif
  !
  CALL newd()
  !
  CALL mp_barrier( intra_image_comm ) ! for oldxml
  if (oldver) then
#if defined (__OLDXML) 
     call oldxml_wfcinit()
#else
   CALL errore( 'qepy_init_run', 'Do no use oldxml in normal version. Please rebuild with -D__OLDXML.', 1 )
#endif
  else
  !CALL wfcinit()
  CALL qepy_wfcinit('')
  endif
  !
  IF(use_wannier) CALL wannier_init()
  !
#if defined(__MPI)
  ! Cleanup PAW arrays that are only used for init
  IF (okpaw) CALL paw_post_init() ! only parallel!
#endif
  !
  IF ( lmd ) CALL allocate_dyn_vars()
  !
  CALL stop_clock( 'init_run' )
  !
  RETURN
  !
END SUBROUTINE qepy_init_run
  !
!----------------------------------------------------------------------------
!SUBROUTINE pre_init()
!  !----------------------------------------------------------------------------
!  !
!  USE ions_base,        ONLY : nat, nsp, ityp
!  USE uspp_param,       ONLY : upf, lmaxkb, nh, nhm, nbetam
!  USE uspp,             ONLY : nkb, nkbus
!  IMPLICIT NONE
!  INTEGER :: na, nt, nb
!  !
!  !     calculate the number of beta functions for each atomic type
!  !
!  lmaxkb = - 1
!  DO nt = 1, nsp
!     !
!     nh (nt) = 0
!     !
!     ! do not add any beta projector if pseudo in 1/r fmt (AF)
!     IF ( upf(nt)%tcoulombp ) CYCLE 
!     !
!     DO nb = 1, upf(nt)%nbeta
!        nh (nt) = nh (nt) + 2 * upf(nt)%lll(nb) + 1
!        lmaxkb = MAX (lmaxkb, upf(nt)%lll(nb) )
!     ENDDO
!     !
!  ENDDO
!  !
!  ! calculate the maximum number of beta functions
!  !
!  nhm = MAXVAL (nh (1:nsp))
!  nbetam = MAXVAL (upf(:)%nbeta)
!  !
!  ! calculate the number of beta functions of the solid
!  !
!  nkb = 0
!  nkbus = 0
!  do na = 1, nat
!     nt = ityp(na)
!     nkb = nkb + nh (nt)
!     if (upf(nt)%tvanp) nkbus = nkbus + nh (nt)
!  enddo


!END SUBROUTINE pre_init

!
! Copyright (C) 2001-2015 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
!
!----------------------------------------------------------------------------
SUBROUTINE qepy_sum_band(update_occupations)
  !----------------------------------------------------------------------------
  !
  ! ... Calculates the symmetrized charge density and related quantities
  ! ... Also computes the occupations and the sum of occupied eigenvalues.
  !
  USE kinds,                ONLY : DP
  USE ener,                 ONLY : eband
  USE control_flags,        ONLY : diago_full_acc, gamma_only, lxdm, tqr
  USE cell_base,            ONLY : at, bg, omega, tpiba
  USE ions_base,            ONLY : nat, ntyp => nsp, ityp
  USE fft_base,             ONLY : dfftp, dffts
  USE fft_interfaces,       ONLY : fwfft, invfft
  USE gvect,                ONLY : ngm, g
  USE gvecs,                ONLY : doublegrid
  USE klist,                ONLY : nks, nkstot, wk, xk, ngk, igk_k
  USE fixed_occ,            ONLY : one_atom_occupations
  USE ldaU,                 ONLY : lda_plus_U
  USE lsda_mod,             ONLY : lsda, nspin, current_spin, isk
  USE scf,                  ONLY : rho, rhoz_or_updw
  USE symme,                ONLY : sym_rho
  USE io_files,             ONLY : iunwfc, nwordwfc
  USE buffers,              ONLY : get_buffer
  USE uspp,                 ONLY : nkb, vkb, becsum, ebecsum, nhtol, nhtoj, indv, okvan
  USE uspp_param,           ONLY : upf, nh, nhm
  USE wavefunctions, ONLY : evc, psic, psic_nc
  USE noncollin_module,     ONLY : noncolin, npol, nspin_mag
  USE spin_orb,             ONLY : lspinorb, domag, fcoef
  USE wvfct,                ONLY : nbnd, npwx, wg, et, btype
  USE mp_pools,             ONLY : inter_pool_comm
  USE mp_bands,             ONLY : inter_bgrp_comm, intra_bgrp_comm, nbgrp
  USE mp,                   ONLY : mp_sum
  USE funct,                ONLY : dft_is_meta
  USE paw_symmetry,         ONLY : PAW_symmetrize
  USE paw_variables,        ONLY : okpaw
  USE becmod,               ONLY : allocate_bec_type, deallocate_bec_type, &
                                   becp
  !
  IMPLICIT NONE
  !
  ! ... local variables
  !
  INTEGER :: ir,   &! counter on 3D r points
             is,   &! counter on spin polarizations
             ig,   &! counter on g vectors
             ibnd, &! counter on bands
             ik,   &! counter on k points
             npol_,&! auxiliary dimension for noncolin case
             ibnd_start, ibnd_end, this_bgrp_nbnd ! first, last and number of band in this bgrp
  REAL (DP), ALLOCATABLE :: kplusg (:)
  logical, optional      :: update_occupations
  logical                :: update_occupations_
  !
  !
  CALL start_clock( 'sum_band' )
  !
  becsum(:,:,:) = 0.D0
  if (tqr) ebecsum(:,:,:) = 0.D0
  rho%of_r(:,:)      = 0.D0
  rho%of_g(:,:)      = (0.D0, 0.D0)
  if ( dft_is_meta() .OR. lxdm ) then
     rho%kin_r(:,:)      = 0.D0
     rho%kin_g(:,:)      = (0.D0, 0.D0)
  end if
  !
  ! ... calculates weights of Kohn-Sham orbitals used in calculation of rho
  !
  !qepy --> update occupations
  update_occupations_ = .true.
  if (present(update_occupations)) then
     if (.not. update_occupations) update_occupations_ = .false.
  endif
  if (update_occupations_) then
  CALL weights ( )
  endif
  !qepy <-- update occupations
  !
  IF (one_atom_occupations) CALL new_evc()
  !
  ! ... btype, used in diagonalization, is set here: a band is considered empty
  ! ... and computed with low accuracy only when its occupation is < 0.01, and
  ! ... only if option diago_full_acc is false; otherwise, use full accuracy
  !
  btype(:,:) = 1
  IF ( .NOT. diago_full_acc ) THEN
     !
     FORALL( ik = 1:nks, wk(ik) > 0.D0 )
        WHERE( wg(:,ik) / wk(ik) < 0.01D0 ) btype(:,ik) = 0
     END FORALL
     !
  END IF
  !
  ! ... Needed for LDA+U: compute occupations of Hubbard states
  !
  IF (lda_plus_u) THEN
     IF(noncolin) THEN
        CALL new_ns_nc(rho%ns_nc)
     ELSE
        CALL new_ns(rho%ns)
     ENDIF
  ENDIF
  !
  ! ... for band parallelization: set band computed by this processor
  !
  call divide ( inter_bgrp_comm, nbnd, ibnd_start, ibnd_end )
  this_bgrp_nbnd = ibnd_end - ibnd_start + 1
  !
  ! ... Allocate (and later deallocate) arrays needed in specific cases
  !
  IF ( okvan ) CALL allocate_bec_type (nkb,nbnd, becp,intra_bgrp_comm)
  IF (dft_is_meta() .OR. lxdm) ALLOCATE (kplusg(npwx))
  !
  ! ... specialized routines are called to sum at Gamma or for each k point 
  ! ... the contribution of the wavefunctions to the charge
  ! ... The band energy contribution eband is computed together with the charge
  !
  eband         = 0.D0
  !
  IF ( gamma_only ) THEN
     !
     CALL sum_band_gamma()
     !
  ELSE
     !
     CALL sum_band_k()
     !
  END IF
  CALL mp_sum( eband, inter_pool_comm )
  CALL mp_sum( eband, inter_bgrp_comm )
  !
  IF (dft_is_meta() .OR. lxdm) DEALLOCATE (kplusg)
  IF ( okvan ) CALL deallocate_bec_type ( becp )
  !
  ! ... sum charge density over pools (distributed k-points) and bands
  !
  CALL mp_sum( rho%of_r, inter_pool_comm )
  CALL mp_sum( rho%of_r, inter_bgrp_comm )
  IF ( noncolin .AND. .NOT. domag ) rho%of_r(:,2:4)=0.D0
  !
  ! ... bring the unsymmetrized rho(r) to G-space (use psic as work array)
  !
  DO is = 1, nspin
     psic(1:dffts%nnr) = rho%of_r(1:dffts%nnr,is)
     psic(dffts%nnr+1:) = 0.0_dp
     CALL fwfft ('Rho', psic, dffts)
     rho%of_g(1:dffts%ngm,is) = psic(dffts%nl(1:dffts%ngm))
     rho%of_g(dffts%ngm+1:,is) = (0.0_dp,0.0_dp)
  END DO

  IF( okvan )  THEN
     !
     ! ... becsum is summed over bands (if bgrp_parallelization is done)
     ! ... and over k-points (but it is not symmetrized)
     !
     CALL mp_sum(becsum, inter_bgrp_comm )
     CALL mp_sum(becsum, inter_pool_comm )
     !
     ! ... same for ebecsum, a correction to becsum (?) in real space
     !
     IF (tqr) CALL mp_sum(ebecsum, inter_pool_comm )
     IF (tqr) CALL mp_sum(ebecsum, inter_bgrp_comm )
     !
     ! ... PAW: symmetrize becsum and store it
     ! ... FIXME: the same should be done for USPP as well
     !
     IF ( okpaw ) THEN
        rho%bec(:,:,:) = becsum(:,:,:)
        CALL PAW_symmetrize(rho%bec)
     END IF
     !
     ! ... Here we add the (unsymmetrized) Ultrasoft contribution to the charge
     !
     CALL addusdens(rho%of_g(:,:))
     !
  ENDIF
  !
  ! ... symmetrize rho(G) 
  !
  CALL sym_rho ( nspin_mag, rho%of_g )
  !
  ! ... synchronize rho%of_r to the calculated rho%of_g (use psic as work array)
  !
  DO is = 1, nspin_mag
     psic(:) = ( 0.D0, 0.D0 )
     psic(dfftp%nl(:)) = rho%of_g(:,is)
     IF ( gamma_only ) psic(dfftp%nlm(:)) = CONJG( rho%of_g(:,is) )
     CALL invfft ('Rho', psic, dfftp)
     rho%of_r(:,is) = psic(:)
  END DO
  !
  ! ... rho_kin(r): sum over bands, k-points, bring to G-space, symmetrize,
  ! ... synchronize with rho_kin(G)
  !
  IF ( dft_is_meta() .OR. lxdm) THEN
     !
     CALL mp_sum( rho%kin_r, inter_pool_comm )
     CALL mp_sum( rho%kin_r, inter_bgrp_comm )
     DO is = 1, nspin
        psic(1:dffts%nnr) = rho%kin_r(1:dffts%nnr,is)
        psic(dffts%nnr+1:) = 0.0_dp
        CALL fwfft ('Rho', psic, dffts)
        rho%kin_g(1:dffts%ngm,is) = psic(dffts%nl(1:dffts%ngm))
     END DO
     !
     IF (.NOT. gamma_only) CALL sym_rho( nspin, rho%kin_g )
     !
     DO is = 1, nspin
        psic(:) = ( 0.D0, 0.D0 )
        psic(dfftp%nl(:)) = rho%kin_g(:,is)
        IF ( gamma_only ) psic(dfftp%nlm(:)) = CONJG( rho%kin_g(:,is) )
        CALL invfft ('Rho', psic, dfftp)
        rho%kin_r(:,is) = psic(:)
     END DO
     !
  END IF
  !
  ! ... if LSDA rho%of_r and rho%of_g are converted from (up,dw) to
  ! ... (up+dw,up-dw) format.
  !
  IF ( nspin == 2 ) CALL rhoz_or_updw( rho, 'r_and_g', '->rhoz' )
  !
  CALL stop_clock( 'sum_band' )
  !
  RETURN
  !
  CONTAINS
     !
     ! ... internal procedures
     !
     !-----------------------------------------------------------------------
     SUBROUTINE sum_band_gamma()
       !-----------------------------------------------------------------------
       !
       ! ... gamma version
       !
       USE becmod,        ONLY : becp
       USE mp_bands,      ONLY : me_bgrp
       USE mp,            ONLY : mp_sum, mp_get_comm_null
       USE fft_helper_subroutines, ONLY : fftx_ntgrp, fftx_tgpe, &
                          tg_reduce_rho, tg_get_nnr, tg_get_group_nr3
       !
       IMPLICIT NONE
       !
       ! ... local variables
       !
       REAL(DP) :: w1, w2
         ! weights
       INTEGER  :: npw, idx, ioff, ioff_tg, nxyp, incr, v_siz, j, ir3
       COMPLEX(DP), ALLOCATABLE :: tg_psi(:)
       REAL(DP),    ALLOCATABLE :: tg_rho(:)
       LOGICAL :: use_tg
       INTEGER :: right_nnr, right_nr3, right_inc, ntgrp
       !
       !
       ! ... here we sum for each k point the contribution
       ! ... of the wavefunctions to the charge
       !
       use_tg = ( dffts%has_task_groups ) .AND. ( .NOT. (dft_is_meta() .OR. lxdm) )
       !
       incr = 2

       IF( use_tg ) THEN
          !
          v_siz = dffts%nnr_tg 
          !
          ALLOCATE( tg_psi( v_siz ) )
          ALLOCATE( tg_rho( v_siz ) )
          !
          incr  = 2 *  fftx_ntgrp(dffts)
          !
       END IF
       !
       k_loop: DO ik = 1, nks
          !
          IF ( use_tg ) tg_rho = 0.0_DP
          IF ( lsda ) current_spin = isk(ik)
          !
          npw = ngk(ik)
          !
          IF ( nks > 1 ) &
             CALL get_buffer ( evc, nwordwfc, iunwfc, ik )
          !
          IF ( nkb > 0 ) &
             CALL init_us_2( npw, igk_k(1,ik), xk(1,ik), vkb )
          !
          ! ... here we compute the band energy: the sum of the eigenvalues
          !
          DO ibnd = ibnd_start, ibnd_end
             !
             ! ... the sum of eband and demet is the integral for
             ! ... e < ef of e n(e) which reduces for degauss=0 to the sum of
             ! ... the eigenvalues.
             !
             eband = eband + et(ibnd,ik) * wg(ibnd,ik)
             !
          END DO
          !
          DO ibnd = ibnd_start, ibnd_end, incr
             !
             IF( use_tg ) THEN
                !
                tg_psi(:) = ( 0.D0, 0.D0 )
                ioff   = 0
                !
                CALL tg_get_nnr( dffts, right_nnr )
                ntgrp = fftx_ntgrp(dffts)
                !
                DO idx = 1, 2*ntgrp, 2
                   !
                   ! ... 2*ntgrp ffts at the same time
                   !
                   IF( idx + ibnd - 1 < ibnd_end ) THEN
                      DO j = 1, npw
                         tg_psi(dffts%nl (j)+ioff)=     evc(j,idx+ibnd-1)+&
                              (0.0d0,1.d0) * evc(j,idx+ibnd)
                         tg_psi(dffts%nlm(j)+ioff)=CONJG(evc(j,idx+ibnd-1) -&
                              (0.0d0,1.d0) * evc(j,idx+ibnd) )
                      END DO
                   ELSE IF( idx + ibnd - 1 == ibnd_end ) THEN
                      DO j = 1, npw
                         tg_psi(dffts%nl (j)+ioff)=       evc(j,idx+ibnd-1)
                         tg_psi(dffts%nlm(j)+ioff)=CONJG( evc(j,idx+ibnd-1) )
                      END DO
                   END IF

                   ioff = ioff + right_nnr

                END DO
                !
                CALL invfft ('tgWave', tg_psi, dffts )
                !
                ! Now the first proc of the group holds the first two bands
                ! of the 2*ntgrp bands that we are processing at the same time,
                ! the second proc. holds the third and fourth band
                ! and so on
                !
                ! Compute the proper factor for each band
                !
                idx = fftx_tgpe(dffts) + 1
                !
                ! Remember two bands are packed in a single array :
                ! proc 0 has bands ibnd   and ibnd+1
                ! proc 1 has bands ibnd+2 and ibnd+3
                ! ....
                !
                idx = 2 * idx - 1
                !
                IF( idx + ibnd - 1 < ibnd_end ) THEN
                   w1 = wg( idx + ibnd - 1, ik) / omega
                   w2 = wg( idx + ibnd    , ik) / omega
                ELSE IF( idx + ibnd - 1 == ibnd_end ) THEN
                   w1 = wg( idx + ibnd - 1, ik) / omega
                   w2 = w1
                ELSE
                   w1 = 0.0d0
                   w2 = w1
                END IF
                !
                CALL tg_get_group_nr3( dffts, right_nr3 )
                !
                CALL get_rho_gamma(tg_rho, dffts%nr1x*dffts%nr2x*right_nr3, w1, w2, tg_psi)
                !
             ELSE
                !
                psic(:) = ( 0.D0, 0.D0 )
                !
                IF ( ibnd < ibnd_end ) THEN
                   !
                   ! ... two ffts at the same time
                   !
                   psic(dffts%nl(1:npw))  = evc(1:npw,ibnd) + &
                                           ( 0.D0, 1.D0 ) * evc(1:npw,ibnd+1)
                   psic(dffts%nlm(1:npw)) = CONJG( evc(1:npw,ibnd) - &
                                           ( 0.D0, 1.D0 ) * evc(1:npw,ibnd+1) )
                   !
                ELSE
                   !
                   psic(dffts%nl (1:npw))  = evc(1:npw,ibnd)
                   psic(dffts%nlm(1:npw)) = CONJG( evc(1:npw,ibnd) )
                   !
                END IF
                !
                CALL invfft ('Wave', psic, dffts)
                !
                w1 = wg(ibnd,ik) / omega
                !
                ! ... increment the charge density ...
                !
                IF ( ibnd < ibnd_end ) THEN
                   !
                   ! ... two ffts at the same time
                   !
                   w2 = wg(ibnd+1,ik) / omega
                   !
                ELSE
                   !
                   w2 = w1
                   !
                END IF
                !
                CALL get_rho_gamma(rho%of_r(:,current_spin), dffts%nnr, w1, w2, psic)
                !
             END IF
             !
             IF (dft_is_meta() .OR. lxdm) THEN
                DO j=1,3
                   psic(:) = ( 0.D0, 0.D0 )
                   !
                   kplusg (1:npw) = (xk(j,ik)+g(j,1:npw)) * tpiba

                   IF ( ibnd < ibnd_end ) THEN
                      ! ... two ffts at the same time
                      psic(dffts%nl (1:npw))=CMPLX(0d0, kplusg(1:npw),kind=DP) * &
                                            ( evc(1:npw,ibnd) + &
                                            ( 0.D0, 1.D0 ) * evc(1:npw,ibnd+1) )
                      psic(dffts%nlm(1:npw)) = CMPLX(0d0, -kplusg(1:npw),kind=DP) * &
                                       CONJG( evc(1:npw,ibnd) - &
                                            ( 0.D0, 1.D0 ) * evc(1:npw,ibnd+1) )
                   ELSE
                      psic(dffts%nl(1:npw)) = CMPLX(0d0, kplusg(1:npw),kind=DP) * &
                                              evc(1:npw,ibnd)
                      psic(dffts%nlm(1:npw)) = CMPLX(0d0, -kplusg(1:npw),kind=DP) * &
                                       CONJG( evc(1:npw,ibnd) )
                   END IF
                   !
                   CALL invfft ('Wave', psic, dffts)
                   !
                   ! ... increment the kinetic energy density ...
                   !
                   DO ir = 1, dffts%nnr
                      rho%kin_r(ir,current_spin) = &
                                           rho%kin_r(ir,current_spin) + &
                                           w1 *  DBLE( psic(ir) )**2 + &
                                           w2 * AIMAG( psic(ir) )**2
                   END DO
                   !
                END DO
             END IF
             !
             !
          END DO
          !
          IF( use_tg ) THEN

             CALL tg_reduce_rho( rho%of_r, tg_rho, current_spin, dffts )
             !
          END IF
          !
          ! ... If we have a US pseudopotential we compute here the becsum term
          !
          IF ( okvan ) CALL sum_bec ( ik, current_spin, ibnd_start,ibnd_end,this_bgrp_nbnd ) 
          !
       END DO k_loop
       !
       ! ... with distributed <beta|psi>, sum over bands
       !
       IF( okvan .AND. becp%comm /= mp_get_comm_null() ) CALL mp_sum( becsum, becp%comm )
       IF( okvan .AND. becp%comm /= mp_get_comm_null() .and. tqr ) CALL mp_sum( ebecsum, becp%comm )
       !
       IF( use_tg ) THEN
          DEALLOCATE( tg_psi )
          DEALLOCATE( tg_rho )
       END IF
       !
       RETURN
       !
     END SUBROUTINE sum_band_gamma
     !
     !
     !-----------------------------------------------------------------------
     SUBROUTINE sum_band_k()
       !-----------------------------------------------------------------------
       !
       ! ... k-points version
       !
       USE mp_bands,     ONLY : me_bgrp
       USE mp,           ONLY : mp_sum, mp_get_comm_null
       USE fft_helper_subroutines, ONLY : fftx_ntgrp, fftx_tgpe, &
                          tg_reduce_rho, tg_get_nnr, tg_get_group_nr3
       !
       IMPLICIT NONE
       !
       ! ... local variables
       !
       REAL(DP) :: w1
       ! weights
       INTEGER :: npw, ipol, na, np
       !
       INTEGER  :: idx, ioff, ioff_tg, nxyp, incr, v_siz, j, ir3
       COMPLEX(DP), ALLOCATABLE :: tg_psi(:), tg_psi_nc(:,:)
       REAL(DP),    ALLOCATABLE :: tg_rho(:), tg_rho_nc(:,:)
       LOGICAL  :: use_tg
       INTEGER :: right_nnr, right_nr3, right_inc, ntgrp
       !
       ! chunking parameters
       INTEGER, PARAMETER :: blocksize = 256
       INTEGER :: numblock
       !
       ! ... here we sum for each k point the contribution
       ! ... of the wavefunctions to the charge
       !
       use_tg = ( dffts%has_task_groups ) .AND. ( .NOT. (dft_is_meta() .OR. lxdm) )
       !
       incr = 1
       !
       IF( use_tg ) THEN
          !
          v_siz = dffts%nnr_tg
          !
          IF (noncolin) THEN
             ALLOCATE( tg_psi_nc( v_siz, npol ) )
             ALLOCATE( tg_rho_nc( v_siz, nspin_mag ) )
          ELSE
             ALLOCATE( tg_psi( v_siz ) )
             ALLOCATE( tg_rho( v_siz ) )
          ENDIF
          !
          incr  = fftx_ntgrp(dffts)
          !
       END IF
       !
       k_loop: DO ik = 1, nks
          !
          IF( use_tg ) THEN
            IF (noncolin) THEN
               tg_rho_nc = 0.0_DP
            ELSE
               tg_rho = 0.0_DP
            ENDIF
          ENDIF

          IF ( lsda ) current_spin = isk(ik)
          npw = ngk (ik)
          !
          IF ( nks > 1 ) &
             CALL get_buffer ( evc, nwordwfc, iunwfc, ik )
          !
          IF ( nkb > 0 ) &
             CALL init_us_2( npw, igk_k(1,ik), xk(1,ik), vkb )
          !
          ! ... here we compute the band energy: the sum of the eigenvalues
          !
          DO ibnd = ibnd_start, ibnd_end, incr
             !
             IF( use_tg ) THEN
                DO idx = 1, fftx_ntgrp(dffts)
                   IF( idx + ibnd - 1 <= ibnd_end ) eband = eband + et( idx + ibnd - 1, ik ) * wg( idx + ibnd - 1, ik )
                END DO
             ELSE
                eband = eband + et( ibnd, ik ) * wg( ibnd, ik )
             END IF
             !
             ! ... the sum of eband and demet is the integral for e < ef of
             ! ... e n(e) which reduces for degauss=0 to the sum of the
             ! ... eigenvalues
             w1 = wg(ibnd,ik) / omega
             !
             IF (noncolin) THEN
                IF( use_tg ) THEN
                   !
                   tg_psi_nc = ( 0.D0, 0.D0 )
                   !
                   CALL tg_get_nnr( dffts, right_nnr )
                   ntgrp = fftx_ntgrp( dffts )
                   !
                   ioff   = 0
                   !
                   DO idx = 1, ntgrp
                      !
                      ! ... ntgrp ffts at the same time
                      !
                      IF( idx + ibnd - 1 <= ibnd_end ) THEN
                         DO j = 1, npw
                            tg_psi_nc( dffts%nl(igk_k(j,ik) ) + ioff, 1 ) = &
                                                       evc( j, idx+ibnd-1 )
                            tg_psi_nc( dffts%nl(igk_k(j,ik) ) + ioff, 2 ) = &
                                                       evc( j+npwx, idx+ibnd-1 )
                         END DO
                      END IF

                      ioff = ioff + right_nnr

                   END DO
                   !
                   CALL invfft ('tgWave', tg_psi_nc(:,1), dffts )
                   CALL invfft ('tgWave', tg_psi_nc(:,2), dffts)
                   !
                   ! Now the first proc of the group holds the first band
                   ! of the ntgrp bands that we are processing at the same time,
                   ! the second proc. holds the second and so on
                   !
                   ! Compute the proper factor for each band
                   !
                   idx = fftx_tgpe(dffts) + 1 
                   !
                   ! Remember
                   ! proc 0 has bands ibnd
                   ! proc 1 has bands ibnd+1
                   ! ....
                   !
                   IF( idx + ibnd - 1 <= ibnd_end ) THEN
                      w1 = wg( idx + ibnd - 1, ik) / omega
                   ELSE
                      w1 = 0.0d0
                   END IF
                   !
                   CALL tg_get_group_nr3( dffts, right_nr3 )
                   !
                   DO ipol=1,npol
                      CALL get_rho(tg_rho_nc(:,1), dffts%nr1x * dffts%nr2x* right_nr3, w1, tg_psi_nc(:,ipol))
                   ENDDO
                   !
                   IF (domag) CALL get_rho_domag(tg_rho_nc(:,:), dffts%nr1x*dffts%nr2x*dffts%my_nr3p, w1, tg_psi_nc(:,:))
                   !
                ELSE
!
!     Noncollinear case without task groups
!
                   psic_nc = (0.D0,0.D0)
                   DO ig = 1, npw
                      psic_nc(dffts%nl(igk_k(ig,ik)),1)=evc(ig     ,ibnd)
                      psic_nc(dffts%nl(igk_k(ig,ik)),2)=evc(ig+npwx,ibnd)
                   END DO
                   CALL invfft ('Wave', psic_nc(:,1), dffts)
                   CALL invfft ('Wave', psic_nc(:,2), dffts)
                   !
                   ! increment the charge density ...
                   !
                   DO ipol=1,npol
                      CALL get_rho(rho%of_r(:,1), dffts%nnr, w1, psic_nc(:,ipol))
                   END DO
                   !
                   ! In this case, calculate also the three
                   ! components of the magnetization (stored in rho%of_r(ir,2-4))
                   !
                   IF (domag) THEN
                      CALL get_rho_domag(rho%of_r(:,:), dffts%nnr, w1, psic_nc(:,:))
                   ELSE
                      rho%of_r(:,2:4)=0.0_DP
                   END IF
                   !
                END IF
                !
             ELSE
                !
                IF( use_tg ) THEN
                   !
                   CALL tg_get_nnr( dffts, right_nnr )
                   !
                   ntgrp = fftx_ntgrp( dffts )
                   !
                   ! compute the number of chuncks
                   numblock  = (npw+blocksize-1)/blocksize
                   !
!$omp parallel
                   CALL threaded_barrier_memset(tg_psi, 0.D0, ntgrp*right_nnr*2)
                   !
                   ! ... ntgrp ffts at the same time
                   !
                   !$omp do collapse(2)
                   DO idx = 0, MIN(ntgrp-1, ibnd_end-ibnd)
                      DO j = 1, numblock
                         tg_psi( dffts%nl(igk_k((j-1)*blocksize+1:MIN(j*blocksize, npw),ik))+right_nnr*idx ) = &
                            evc((j-1)*blocksize+1:MIN(j*blocksize, npw),idx+ibnd)
                      END DO
                   END DO
                   !$omp end do nowait
!$omp end parallel
                   !
                   CALL invfft ('tgWave', tg_psi, dffts)
                   !
                   ! Now the first proc of the group holds the first band
                   ! of the ntgrp bands that we are processing at the same time,
                   ! the second proc. holds the second and so on
                   !
                   ! Compute the proper factor for each band
                   !
                   idx = fftx_tgpe(dffts) + 1
                   !
                   ! Remember
                   ! proc 0 has bands ibnd
                   ! proc 1 has bands ibnd+1
                   ! ....
                   !
                   IF( idx + ibnd - 1 <= ibnd_end ) THEN
                      w1 = wg( idx + ibnd - 1, ik) / omega
                   ELSE
                      w1 = 0.0d0
                   END IF
                   !
                   CALL tg_get_group_nr3( dffts, right_nr3 )
                   !
                   CALL get_rho(tg_rho, dffts%nr1x * dffts%nr2x * right_nr3, w1, tg_psi)
                   !
                ELSE
                   !
!$omp parallel
                   CALL threaded_barrier_memset(psic, 0.D0, dffts%nnr*2)
                   !
                   !$omp do
                   DO j = 1, npw
                      psic(dffts%nl(igk_k(j,ik))) = evc(j,ibnd)
                   ENDDO
                   !$omp end do nowait
!$omp end parallel
                   !
                   CALL invfft ('Wave', psic, dffts)
                   !
                   ! ... increment the charge density ...
                   !
                   CALL get_rho(rho%of_r(:,current_spin), dffts%nnr, w1, psic)

                END IF
                !
                IF (dft_is_meta() .OR. lxdm) THEN
                   DO j=1,3
                      psic(:) = ( 0.D0, 0.D0 )
                      !
                      kplusg (1:npw) = (xk(j,ik)+g(j,igk_k(1:npw,ik))) * tpiba
                      psic(dffts%nl(igk_k(1:npw,ik)))=CMPLX(0d0,kplusg(1:npw),kind=DP) * &
                                              evc(1:npw,ibnd)
                      !
                      CALL invfft ('Wave', psic, dffts)
                      !
                      ! ... increment the kinetic energy density ...
                      !
                      CALL get_rho(rho%kin_r(:,current_spin), dffts%nnr, w1, psic)
                   END DO
                END IF
                !
             END IF
             !
          END DO
          !
          IF( use_tg ) THEN
             !
             ! reduce the charge across task group
             !
             CALL tg_reduce_rho( rho%of_r, tg_rho_nc, tg_rho, current_spin, noncolin, domag, dffts )
             !
          END IF
          !
          ! ... If we have a US pseudopotential we compute here the becsum term
          !
          IF ( okvan ) CALL sum_bec ( ik, current_spin, ibnd_start,ibnd_end,this_bgrp_nbnd ) 
          !
       END DO k_loop
       !
       ! ... with distributed <beta|psi>, sum over bands
       !
       IF( okvan .AND. becp%comm /= mp_get_comm_null() ) CALL mp_sum( becsum, becp%comm )
       IF( okvan .AND. becp%comm /= mp_get_comm_null() .and. tqr ) CALL mp_sum( ebecsum, becp%comm )
       !
       IF( use_tg ) THEN
          IF (noncolin) THEN
             DEALLOCATE( tg_psi_nc )
             DEALLOCATE( tg_rho_nc )
          ELSE
             DEALLOCATE( tg_psi )
             DEALLOCATE( tg_rho )
          END IF
       END IF
       !
       RETURN
       !
     END SUBROUTINE sum_band_k
     !
     !
     SUBROUTINE get_rho(rho_loc, nrxxs_loc, w1_loc, psic_loc)

        IMPLICIT NONE

        INTEGER :: nrxxs_loc
        REAL(DP) :: rho_loc(nrxxs_loc)
        REAL(DP) :: w1_loc
        COMPLEX(DP) :: psic_loc(nrxxs_loc)

        INTEGER :: ir

!$omp parallel do
        DO ir = 1, nrxxs_loc
           !
           rho_loc(ir) = rho_loc(ir) + &
                         w1_loc * ( DBLE( psic_loc(ir) )**2 + &
                                   AIMAG( psic_loc(ir) )**2 )
           !
        END DO
!$omp end parallel do

     END SUBROUTINE get_rho

     SUBROUTINE get_rho_gamma(rho_loc, nrxxs_loc, w1_loc, w2_loc, psic_loc)

        IMPLICIT NONE

        INTEGER :: nrxxs_loc
        REAL(DP) :: rho_loc(nrxxs_loc)
        REAL(DP) :: w1_loc, w2_loc
        COMPLEX(DP) :: psic_loc(nrxxs_loc)

        INTEGER :: ir

!$omp parallel do
        DO ir = 1, nrxxs_loc
           !
           rho_loc(ir) = rho_loc(ir) + &
                         w1_loc * DBLE( psic_loc(ir) )**2 + &
                         w2_loc * AIMAG( psic_loc(ir) )**2
           !
        END DO
!$omp end parallel do

     END SUBROUTINE get_rho_gamma


     SUBROUTINE get_rho_domag(rho_loc, nrxxs_loc, w1_loc, psic_loc)

        IMPLICIT NONE

        INTEGER :: nrxxs_loc
        REAL(DP) :: rho_loc(:, :)
        REAL(DP) :: w1_loc
        COMPLEX(DP) :: psic_loc(:, :)

        INTEGER :: ir

!$omp parallel do
        DO ir = 1, nrxxs_loc
           !
           rho_loc(ir,2) = rho_loc(ir,2) + w1_loc*2.D0* &
                          (DBLE(psic_loc(ir,1))* DBLE(psic_loc(ir,2)) + &
                          AIMAG(psic_loc(ir,1))*AIMAG(psic_loc(ir,2)))
 
           rho_loc(ir,3) = rho_loc(ir,3) + w1_loc*2.D0* &
                          (DBLE(psic_loc(ir,1))*AIMAG(psic_loc(ir,2)) - &
                           DBLE(psic_loc(ir,2))*AIMAG(psic_loc(ir,1)))

           rho_loc(ir,4) = rho_loc(ir,4) + w1_loc* &
                          (DBLE(psic_loc(ir,1))**2+AIMAG(psic_loc(ir,1))**2 &
                          -DBLE(psic_loc(ir,2))**2-AIMAG(psic_loc(ir,2))**2)
           !
        END DO
!$omp end parallel do

     END SUBROUTINE get_rho_domag

END SUBROUTINE qepy_sum_band

!----------------------------------------------------------------------------
!SUBROUTINE sum_bec ( ik, current_spin, ibnd_start, ibnd_end, this_bgrp_nbnd ) 
!  !----------------------------------------------------------------------------
!  !
!  ! This routine computes the sum over bands
!  !     \sum_i <\psi_i|\beta_l>w_i<\beta_m|\psi_i>
!  ! for point "ik" and, for LSDA, spin "current_spin" 
!  ! Calls calbec to compute "becp"=<beta_m|psi_i> 
!  ! Output is accumulated (unsymmetrized) into "becsum", module "uspp"
!  !
!  ! Routine used in sum_band (if okvan) and in compute_becsum, called by hinit1 (if okpaw)
!  !
!  USE kinds,         ONLY : DP
!  USE becmod,        ONLY : becp, calbec, allocate_bec_type
!  USE control_flags, ONLY : gamma_only, tqr
!  USE ions_base,     ONLY : nat, ntyp => nsp, ityp
!  USE uspp,          ONLY : nkb, vkb, becsum, ebecsum, indv_ijkb0
!  USE uspp_param,    ONLY : upf, nh, nhm
!  USE wvfct,         ONLY : nbnd, wg, et, current_k
!  USE klist,         ONLY : ngk
!  USE noncollin_module,     ONLY : noncolin, npol
!  USE wavefunctions, ONLY : evc
!  USE realus,        ONLY : real_space, &
!                            invfft_orbital_gamma, calbec_rs_gamma, &
!                            invfft_orbital_k, calbec_rs_k
!  USE us_exx,        ONLY : store_becxx0
!  USE mp_bands,      ONLY : nbgrp,inter_bgrp_comm
!  USE mp,            ONLY : mp_sum
!  !
!  IMPLICIT NONE
!  INTEGER, INTENT(IN) :: ik, current_spin, ibnd_start, ibnd_end, this_bgrp_nbnd
!  !
!  COMPLEX(dp), ALLOCATABLE :: auxk1(:,:), auxk2(:,:), aux_nc(:,:)
!  REAL(dp), ALLOCATABLE :: auxg(:,:), aux_gk(:,:), aux_egk(:,:)
!  INTEGER :: ibnd, ibnd_loc, nbnd_loc  ! counters on bands
!  INTEGER :: npw, ikb, jkb, ih, jh, ijh, na, np, is, js
!  ! counters on beta functions, atoms, atom types, spin
!  !
!  npw = ngk(ik)
!  IF ( .NOT. real_space ) THEN
!     ! calbec computes becp = <vkb_i|psi_j>
!     CALL calbec( npw, vkb, evc, becp )
!  ELSE
!     if (gamma_only) then
!        do ibnd = ibnd_start, ibnd_end, 2
!           call invfft_orbital_gamma(evc,ibnd,ibnd_end) 
!           call calbec_rs_gamma(ibnd,ibnd_end,becp%r)
!        enddo
!        call mp_sum(becp%r,inter_bgrp_comm)
!     else
!        current_k = ik
!        becp%k = (0.d0,0.d0)
!        do ibnd = ibnd_start, ibnd_end
!           call invfft_orbital_k(evc,ibnd,ibnd_end) 
!           call calbec_rs_k(ibnd,ibnd_end)
!        enddo
!       call mp_sum(becp%k,inter_bgrp_comm)
!     endif
!  ENDIF
!  !
!  ! In the EXX case with ultrasoft or PAW, a copy of becp will be
!  ! saved in a global variable to be rotated later
!  CALL store_becxx0(ik, becp)
!  !
!  CALL start_clock( 'sum_band:becsum' )
!  !
!  DO np = 1, ntyp
!     !
!     IF ( upf(np)%tvanp ) THEN
!        !
!        ! allocate work space used to perform GEMM operations
!        !
!        IF ( gamma_only ) THEN
!           nbnd_loc = becp%nbnd_loc
!           ALLOCATE( auxg( nbnd_loc, nh(np) ) )
!        ELSE
!           ALLOCATE( auxk1( ibnd_start:ibnd_end, nh(np)*npol ), &
!                     auxk2( ibnd_start:ibnd_end, nh(np)*npol ) )
!        END IF
!        IF ( noncolin ) THEN
!           ALLOCATE ( aux_nc( nh(np)*npol,nh(np)*npol ) ) 
!        ELSE
!           ALLOCATE ( aux_gk( nh(np),nh(np) ) ) 
!           if (tqr) ALLOCATE ( aux_egk( nh(np),nh(np) ) ) 
!        END IF
!        !
!        !   In becp=<vkb_i|psi_j> terms corresponding to atom na of type nt
!        !   run from index i=indv_ijkb0(na)+1 to i=indv_ijkb0(na)+nh(nt)
!        !
!        DO na = 1, nat
!           !
!           IF (ityp(na)==np) THEN
!              !
!              ! sum over bands: \sum_i <psi_i|beta_l><beta_m|psi_i> w_i
!              ! copy into aux1, aux2 the needed data to perform a GEMM
!              !
!              IF ( noncolin ) THEN
!                 !
!!$omp parallel do default(shared), private(is,ih,ikb,ibnd)
!                 DO is = 1, npol
!                    DO ih = 1, nh(np)
!                       ikb = indv_ijkb0(na) + ih
!                       DO ibnd = ibnd_start, ibnd_end
!                          auxk1(ibnd,ih+(is-1)*nh(np))= becp%nc(ikb,is,ibnd)
!                          auxk2(ibnd,ih+(is-1)*nh(np))= wg(ibnd,ik) * &
!                                                        becp%nc(ikb,is,ibnd)
!                       END DO
!                    END DO
!                 END DO
!!$omp end parallel do
!                 !
!                 CALL ZGEMM ( 'C', 'N', npol*nh(np), npol*nh(np), this_bgrp_nbnd, &
!                      (1.0_dp,0.0_dp), auxk1, this_bgrp_nbnd, auxk2, this_bgrp_nbnd, &
!                      (0.0_dp,0.0_dp), aux_nc, npol*nh(np) )
!                 !
!              ELSE IF ( gamma_only ) THEN
!                 !
!!$omp parallel do default(shared), private(ih,ikb,ibnd,ibnd_loc)
!                 DO ih = 1, nh(np)
!                    ikb = indv_ijkb0(na) + ih
!                    DO ibnd_loc = 1, nbnd_loc
!                       ibnd = ibnd_loc + becp%ibnd_begin - 1
!                       auxg(ibnd_loc,ih)= wg(ibnd,ik)*becp%r(ikb,ibnd_loc) 
!                    END DO
!                 END DO
!!$omp end parallel do
!                 !
!                 ! NB: band parallelizazion has not been performed in this case because 
!                 !     bands were already distributed across R&G processors.
!                 !     Contribution to aux_gk is scaled by 1.d0/nbgrp so that the becsum
!                 !     summation across bgrps performed outside will gives the right value.
!                 !
!                 CALL DGEMM ( 'N', 'N', nh(np), nh(np), nbnd_loc, &
!                      1.0_dp/nbgrp, becp%r(indv_ijkb0(na)+1,1), nkb,    &
!                      auxg, nbnd_loc, 0.0_dp, aux_gk, nh(np) )
!               if (tqr) then
!!$omp parallel do default(shared), private(ih,ikb,ibnd,ibnd_loc)
!                 DO ih = 1, nh(np)
!                    ikb = indv_ijkb0(na) + ih
!                    DO ibnd_loc = 1, nbnd_loc
!                    auxg(ibnd_loc,ih) = et(ibnd_loc,ik) * auxg(ibnd_loc,ih)
!                    END DO
!                 END DO
!!$omp end parallel do
!                 CALL DGEMM ( 'N', 'N', nh(np), nh(np), nbnd_loc, &
!                      1.0_dp/nbgrp, becp%r(indv_ijkb0(na)+1,1), nkb,    &
!                      auxg, nbnd_loc, 0.0_dp, aux_egk, nh(np) )
!               end if
!                 !
!              ELSE
!                 !
!!$omp parallel do default(shared), private(ih,ikb,ibnd)
!                 DO ih = 1, nh(np)
!                    ikb = indv_ijkb0(na) + ih
!                    DO ibnd = ibnd_start, ibnd_end
!                       auxk1(ibnd,ih) = becp%k(ikb,ibnd) 
!                       auxk2(ibnd,ih) = wg(ibnd,ik)*becp%k(ikb,ibnd)
!                    END DO
!                 END DO
!!$omp end parallel do
!                 !
!                 ! only the real part is computed
!                 !
!                 CALL DGEMM ( 'C', 'N', nh(np), nh(np), 2*this_bgrp_nbnd, &
!                      1.0_dp, auxk1, 2*this_bgrp_nbnd, auxk2, 2*this_bgrp_nbnd, &
!                      0.0_dp, aux_gk, nh(np) )
!                 !
!               if (tqr) then
!!$omp parallel do default(shared), private(ih,ikb,ibnd)
!                 DO ih = 1, nh(np)
!                    ikb = indv_ijkb0(na) + ih
!                    DO ibnd = ibnd_start, ibnd_end
!                       auxk2(ibnd,ih) = et(ibnd,ik)*auxk2(ibnd,ih)
!                    END DO
!                 END DO
!!$omp end parallel do
!                 CALL DGEMM ( 'C', 'N', nh(np), nh(np), 2*this_bgrp_nbnd, &
!                      1.0_dp, auxk1, 2*this_bgrp_nbnd, auxk2, 2*this_bgrp_nbnd, &
!                      0.0_dp, aux_egk, nh(np) )
!               end if
!
!              END IF
!              !
!              ! copy output from GEMM into desired format
!              !
!              IF (noncolin .AND. .NOT. upf(np)%has_so) THEN
!                 CALL add_becsum_nc (na, np, aux_nc, becsum )
!              ELSE IF (noncolin .AND. upf(np)%has_so) THEN
!                 CALL add_becsum_so (na, np, aux_nc,becsum )
!              ELSE
!                 ijh = 0
!                 DO ih = 1, nh(np)
!                    DO jh = ih, nh(np)
!                       ijh = ijh + 1
!                       !
!                       ! nondiagonal terms summed and collapsed into a
!                       ! single index (matrix is symmetric wrt (ih,jh))
!                       !
!                       IF ( jh == ih ) THEN
!                          becsum(ijh,na,current_spin) = &
!                               becsum(ijh,na,current_spin) + aux_gk (ih,jh)
!                          if (tqr) ebecsum(ijh,na,current_spin) = &
!                               ebecsum(ijh,na,current_spin) + aux_egk (ih,jh)
!                       ELSE
!                          becsum(ijh,na,current_spin) = &
!                               becsum(ijh,na,current_spin) + aux_gk(ih,jh)*2.0_dp
!                          if (tqr) ebecsum(ijh,na,current_spin) = &
!                               ebecsum(ijh,na,current_spin) + aux_egk(ih,jh)*2.0_dp
!                       END IF
!                    END DO
!                 END DO
!                 !
!              END IF
!           END IF
!           !
!        END DO
!        !
!        IF ( noncolin ) THEN
!           DEALLOCATE ( aux_nc )
!        ELSE
!           DEALLOCATE ( aux_gk  ) 
!           if (tqr) DEALLOCATE ( aux_egk  ) 
!        END IF
!        IF ( gamma_only ) THEN
!           DEALLOCATE( auxg )
!        ELSE
!           DEALLOCATE( auxk2, auxk1 )
!        END IF
!        !
!     END IF
!     !
!  END DO
!  !
!  CALL stop_clock( 'sum_band:becsum' )
!  !
!END SUBROUTINE sum_bec
!!
!!----------------------------------------------------------------------------
!SUBROUTINE add_becsum_nc ( na, np, becsum_nc, becsum )
!!----------------------------------------------------------------------------
!  !
!  ! This routine multiplies becsum_nc by the identity and the Pauli matrices,
!  ! saves it in becsum for the calculation of augmentation charge and
!  ! magnetization.
!  !
!  USE kinds,                ONLY : DP
!  USE ions_base,            ONLY : nat, ntyp => nsp, ityp
!  USE uspp_param,           ONLY : nh, nhm
!  USE lsda_mod,             ONLY : nspin
!  USE noncollin_module,     ONLY : npol, nspin_mag
!  USE spin_orb,             ONLY : domag
!  !
!  IMPLICIT NONE
!  !
!  INTEGER, INTENT(IN) :: na, np
!  COMPLEX(DP), INTENT(IN) :: becsum_nc(nh(np),npol,nh(np),npol)
!  REAL(DP), INTENT(INOUT) :: becsum(nhm*(nhm+1)/2,nat,nspin_mag)
!  !
!  ! ... local variables
!  !
!  INTEGER :: ih, jh, ijh
!  REAL(dp) :: fac
!  !
!  ijh=0
!  DO ih = 1, nh(np)
!     DO jh = ih, nh(np)
!        ijh=ijh+1
!        IF ( ih == jh ) THEN
!           fac = 1.0_dp
!        ELSE
!           fac = 2.0_dp
!        END IF
!        becsum(ijh,na,1)= becsum(ijh,na,1) + fac * &
!                DBLE( becsum_nc(ih,1,jh,1) + becsum_nc(ih,2,jh,2) )
!        IF (domag) THEN
!           becsum(ijh,na,2)= becsum(ijh,na,2) + fac *  &
!                DBLE( becsum_nc(ih,1,jh,2) + becsum_nc(ih,2,jh,1) )
!           becsum(ijh,na,3)= becsum(ijh,na,3) + fac * DBLE( (0.d0,-1.d0)* &
!               (becsum_nc(ih,1,jh,2) - becsum_nc(ih,2,jh,1)) )
!           becsum(ijh,na,4)= becsum(ijh,na,4) + fac * &
!                DBLE( becsum_nc(ih,1,jh,1) - becsum_nc(ih,2,jh,2) )
!        END IF
!     END DO
!  END DO
!  
!END SUBROUTINE add_becsum_nc
!!
!!----------------------------------------------------------------------------
!SUBROUTINE add_becsum_so( na, np, becsum_nc, becsum )
!  !----------------------------------------------------------------------------
!  !
!  ! This routine multiplies becsum_nc by the identity and the Pauli matrices,
!  ! rotates it as appropriate for the spin-orbit case, saves it in becsum
!  ! for the calculation of augmentation charge and magnetization.
!  !
!  USE kinds,                ONLY : DP
!  USE ions_base,            ONLY : nat, ntyp => nsp, ityp
!  USE uspp_param,           ONLY : nh, nhm
!  USE uspp,                 ONLY : ijtoh, nhtol, nhtoj, indv
!  USE noncollin_module,     ONLY : npol, nspin_mag
!  USE spin_orb,             ONLY : fcoef, domag
!  !
!  IMPLICIT NONE
!  
!  INTEGER, INTENT(IN) :: na, np
!  COMPLEX(DP), INTENT(IN) :: becsum_nc(nh(np),npol,nh(np),npol)
!  REAL(DP), INTENT(INOUT) :: becsum(nhm*(nhm+1)/2,nat,nspin_mag)
!  !
!  ! ... local variables
!  !
!  INTEGER :: ih, jh, lh, kh, ijh, is1, is2
!  COMPLEX(DP) :: fac
!  
!  DO ih = 1, nh(np)
!     DO jh = 1, nh(np)
!        ijh=ijtoh(ih,jh,np)
!        DO kh = 1, nh(np)
!           IF (same_lj(kh,ih,np)) THEN
!              DO lh=1,nh(np)
!                 IF (same_lj(lh,jh,np)) THEN
!                    DO is1=1,npol
!                       DO is2=1,npol
!                          fac=becsum_nc(kh,is1,lh,is2)
!                          becsum(ijh,na,1)=becsum(ijh,na,1) + fac * &
!                               (fcoef(kh,ih,is1,1,np)*fcoef(jh,lh,1,is2,np) + &
!                               fcoef(kh,ih,is1,2,np)*fcoef(jh,lh,2,is2,np)  )
!                          IF (domag) THEN
!                            becsum(ijh,na,2)=becsum(ijh,na,2)+fac * &
!                                (fcoef(kh,ih,is1,1,np)*fcoef(jh,lh,2,is2,np) +&
!                                fcoef(kh,ih,is1,2,np)*fcoef(jh,lh,1,is2,np)  )
!                            becsum(ijh,na,3)=becsum(ijh,na,3)+fac*(0.d0,-1.d0)*&
!                               (fcoef(kh,ih,is1,1,np)*fcoef(jh,lh,2,is2,np) - &
!                                fcoef(kh,ih,is1,2,np)*fcoef(jh,lh,1,is2,np)  )
!                           becsum(ijh,na,4)=becsum(ijh,na,4) + fac * &
!                               (fcoef(kh,ih,is1,1,np)*fcoef(jh,lh,1,is2,np) - &
!                                fcoef(kh,ih,is1,2,np)*fcoef(jh,lh,2,is2,np)  )
!                        END IF
!                     END DO
!                  END DO
!               END IF
!            END DO
!         END IF
!      END DO
!   END DO
!END DO
!!
!CONTAINS
!   LOGICAL FUNCTION same_lj(ih,jh,np)
!   INTEGER :: ih, jh, np
!   !
!   same_lj = ((nhtol(ih,np)==nhtol(jh,np)).AND. &
!             (ABS(nhtoj(ih,np)-nhtoj(jh,np))<1.d8).AND. &
!             (indv(ih,np)==indv(jh,np)) )
!   !
!   END FUNCTION same_lj
!
!END SUBROUTINE add_becsum_so

!
! Copyright (C) 2001-2013 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
!----------------------------------------------------------------------------
SUBROUTINE qepy_v_of_rho_all( rho, rho_core, rhog_core, &
                     ehart, etxc, vtxc, eth, etotefield, charge, v, embed)
  !----------------------------------------------------------------------------
  !! This routine computes the Hartree and Exchange and Correlation
  !! potential and energies which corresponds to a given charge density
  !! The XC potential is computed in real space, while the
  !! Hartree potential is computed in reciprocal space.
  !
  USE kinds,            ONLY : DP
  USE fft_base,         ONLY : dfftp
  USE gvect,            ONLY : ngm
  USE noncollin_module, ONLY : noncolin, nspin_lsda
  USE ions_base,        ONLY : nat, tau
  USE ldaU,             ONLY : lda_plus_U 
  USE funct,            ONLY : dft_is_meta, get_meta
  USE scf,              ONLY : scf_type
  USE cell_base,        ONLY : alat
  USE control_flags,    ONLY : ts_vdw
  USE tsvdw_module,     ONLY : tsvdw_calculate, UtsvdW
  USE scf,                  ONLY : vltot, vrs, kedtau, vnew
  USE gvecs,                ONLY : doublegrid
  USE lsda_mod,             ONLY : lsda, nspin, magtot, absmag, isk
  USE plugin_variables,     ONLY : plugin_etot
  USE dfunct,               ONLY : newd
  USE paw_variables,        ONLY : okpaw, ddd_paw, total_core_energy, only_paw
  USE paw_onecenter,        ONLY : PAW_potential
  USE paw_symmetry,         ONLY : PAW_symmetrize_ddd
  USE ener,                 ONLY : epaw
  !
  USE qepy_common,             ONLY : embed_base
  !
  IMPLICIT NONE
  !
  TYPE(embed_base), INTENT(INOUT)    :: embed
  !
  TYPE(scf_type), INTENT(INOUT) :: rho
  !! the valence charge
  TYPE(scf_type), INTENT(INOUT) :: v
  !! the scf (Hxc) potential 
  !=================> NB: NOTE that in F90 derived data type must be INOUT and 
  !=================> not just OUT because otherwise their allocatable or pointer
  !=================> components are NOT defined 
  REAL(DP), INTENT(IN) :: rho_core(dfftp%nnr)
  !! the core charge
  COMPLEX(DP), INTENT(IN) :: rhog_core(ngm)
  !! the core charge in reciprocal space
  REAL(DP), INTENT(OUT) :: vtxc
  !! the integral V_xc * rho
  REAL(DP), INTENT(OUT) :: etxc
  !! the E_xc energy
  REAL(DP), INTENT(OUT) :: ehart
  !! the hartree energy
  REAL(DP), INTENT(OUT) :: eth
  !! the hubbard energy
  REAL(DP), INTENT(OUT) :: charge
  !! the integral of the charge
  REAL(DP), INTENT(INOUT) :: etotefield
  !! electric field energy - inout due to the screwed logic of add_efield
  !
  INTEGER :: is, ir
  LOGICAL :: conv_elec
  REAL(DP) :: dr2
  REAL(DP) :: etot_cmp_paw(nat,2,2)

  call qepy_v_of_rho( rho, rho_core, rhog_core, &
                     ehart, etxc, vtxc, eth, etotefield, charge, v, embed)
  IF (okpaw) THEN
     CALL PAW_potential( rho%bec, ddd_paw, epaw, etot_cmp_paw )
     CALL PAW_symmetrize_ddd( ddd_paw )
  ENDIF

  CALL plugin_scf_energy(plugin_etot,rho)
  !
  CALL plugin_scf_potential(rho,conv_elec,dr2,vltot)
  !
  ! ... define the total local potential (external + scf)
  !
  CALL embed%allocate_extpot()
  v%of_r = v%of_r + embed%extpot
  !
  CALL sum_vrs( dfftp%nnr, nspin, vltot, v%of_r, vrs )
  !
  ! ... interpolate the total local potential
  !
  CALL interpolate_vrs( dfftp%nnr, nspin, doublegrid, kedtau, v%kin_r, vrs )
  !
  ! ... in the US case we have to recompute the self-consistent
  ! ... term in the nonlocal potential
  ! ... PAW: newd contains PAW updates of NL coefficients
  !
  CALL newd()
  END SUBROUTINE 
!----------------------------------------------------------------------------
SUBROUTINE qepy_v_of_rho( rho, rho_core, rhog_core, &
                     ehart, etxc, vtxc, eth, etotefield, charge, v, embed)
  !----------------------------------------------------------------------------
  !! This routine computes the Hartree and Exchange and Correlation
  !! potential and energies which corresponds to a given charge density
  !! The XC potential is computed in real space, while the
  !! Hartree potential is computed in reciprocal space.
  !
  USE kinds,            ONLY : DP
  USE fft_base,         ONLY : dfftp
  USE gvect,            ONLY : ngm
  USE noncollin_module, ONLY : noncolin, nspin_lsda
  USE ions_base,        ONLY : nat, tau
  USE ldaU,             ONLY : lda_plus_U 
  USE funct,            ONLY : dft_is_meta, get_meta
  USE scf,              ONLY : scf_type
  USE cell_base,        ONLY : alat
  USE control_flags,    ONLY : ts_vdw
  USE tsvdw_module,     ONLY : tsvdw_calculate, UtsvdW
  USE qepy_common,         ONLY : embed_base
  !
  IMPLICIT NONE
  !
  type(embed_base), intent(in)    :: embed
  !
  TYPE(scf_type), INTENT(INOUT) :: rho
  !! the valence charge
  TYPE(scf_type), INTENT(INOUT) :: v
  !! the scf (Hxc) potential 
  !=================> NB: NOTE that in F90 derived data type must be INOUT and 
  !=================> not just OUT because otherwise their allocatable or pointer
  !=================> components are NOT defined 
  REAL(DP), INTENT(IN) :: rho_core(dfftp%nnr)
  !! the core charge
  COMPLEX(DP), INTENT(IN) :: rhog_core(ngm)
  !! the core charge in reciprocal space
  REAL(DP), INTENT(OUT) :: vtxc
  !! the integral V_xc * rho
  REAL(DP), INTENT(OUT) :: etxc
  !! the E_xc energy
  REAL(DP), INTENT(OUT) :: ehart
  !! the hartree energy
  REAL(DP), INTENT(OUT) :: eth
  !! the hubbard energy
  REAL(DP), INTENT(OUT) :: charge
  !! the integral of the charge
  REAL(DP), INTENT(INOUT) :: etotefield
  !! electric field energy - inout due to the screwed logic of add_efield
  !
  INTEGER :: is, ir
  !
  CALL start_clock( 'v_of_rho' )
  !
  ! ... calculate exchange-correlation potential
  !
  if (iand(embed%exttype,4) == 0) then ! XC
  IF (dft_is_meta()) then
     CALL v_xc_meta( rho, rho_core, rhog_core, etxc, vtxc, v%of_r, v%kin_r )
  ELSE
     CALL v_xc( rho, rho_core, rhog_core, etxc, vtxc, v%of_r )
  ENDIF
  else
  v%of_r(:,:) = 0.0
  etxc = 0.0
  end if
  !
  ! ... add a magnetic field  (if any)
  !
  CALL add_bfield( v%of_r, rho%of_r )
  !
  ! ... calculate hartree potential
  !
  if (iand(embed%exttype,2) == 0) then ! Hartree
  CALL v_h( rho%of_g(:,1), ehart, charge, v%of_r )
  else
     ehart=0.0
  end if
  !
  ! ... LDA+U: build up Hubbard potential 
  !
  IF (lda_plus_u) then
     IF (noncolin) then
        CALL v_hubbard_nc(rho%ns_nc,v%ns_nc,eth)
     ELSE
        CALL v_hubbard(rho%ns,v%ns,eth)
     ENDIF
  ENDIF
  !
  ! ... add an electric field
  ! 
  DO is = 1, nspin_lsda
     CALL add_efield(v%of_r(1,is), etotefield, rho%of_r(:,1), .false. )
  END DO
  !
  ! ... add Tkatchenko-Scheffler potential (factor 2: Ha -> Ry)
  !
  IF (ts_vdw) THEN
     CALL tsvdw_calculate(tau*alat,rho%of_r(:,1))
     DO is = 1, nspin_lsda
        DO ir=1,dfftp%nnr
           v%of_r(ir,is)=v%of_r(ir,is)+2.0d0*UtsvdW(ir)
        END DO
     END DO
  END IF
  !
  CALL stop_clock( 'v_of_rho' )
  !
  RETURN
  !
END SUBROUTINE qepy_v_of_rho
!
!
!----------------------------------------------------------------------------
!SUBROUTINE v_xc_meta( rho, rho_core, rhog_core, etxc, vtxc, v, kedtaur )
  !!----------------------------------------------------------------------------
  !!! Exchange-Correlation potential (meta) Vxc(r) from n(r)
  !!
  !USE kinds,            ONLY : DP
  !USE constants,        ONLY : e2, eps8
  !USE io_global,        ONLY : stdout
  !USE fft_base,         ONLY : dfftp
  !USE gvect,            ONLY : g, ngm
  !USE lsda_mod,         ONLY : nspin
  !USE cell_base,        ONLY : omega
  !USE funct,            ONLY : get_meta, dft_is_nonlocc, nlc, is_libxc
  !USE xc_mgga,          ONLY : xc_metagcx
  !USE scf,              ONLY : scf_type, rhoz_or_updw
  !USE mp,               ONLY : mp_sum
  !USE mp_bands,         ONLY : intra_bgrp_comm
  !!
  !IMPLICIT NONE
  !!
  !TYPE (scf_type), INTENT(INOUT) :: rho
  !!! the valence charge
  !REAL(DP), INTENT(IN) :: rho_core(dfftp%nnr)
  !!! the core charge in real space
  !COMPLEX(DP), INTENT(IN) :: rhog_core(ngm)
  !!! the core charge in reciprocal space
  !REAL(DP), INTENT(INOUT) :: v(dfftp%nnr,nspin)
  !!! V_xc potential
  !REAL(DP), INTENT(INOUT) :: kedtaur(dfftp%nnr,nspin)
  !!! local K energy density                     
  !REAL(DP), INTENT(INOUT) :: vtxc
  !!! integral V_xc * rho
  !REAL(DP), INTENT(INOUT) :: etxc
  !!! E_xc energy
  !!
  !! ... local variables
  !!
  !REAL(DP) :: zeta, rh, sgn(2)
  !INTEGER  :: k, ipol, is, np
  !!
  !REAL(DP), ALLOCATABLE :: ex(:), ec(:)
  !REAL(DP), ALLOCATABLE :: v1x(:,:), v2x(:,:), v3x(:,:)
  !REAL(DP), ALLOCATABLE :: v1c(:,:), v2c(:,:,:), v3c(:,:)
  !!
  !REAL(DP) :: fac
       
  !REAL(DP), DIMENSION(2) :: grho2, rhoneg
  !REAL(DP), DIMENSION(3) :: grhoup, grhodw
  !!
  !REAL(DP), ALLOCATABLE :: grho(:,:,:), h(:,:,:), dh(:)
  !REAL(DP), ALLOCATABLE :: rhoout(:)
  !COMPLEX(DP), ALLOCATABLE :: rhogsum(:)
  !REAL(DP), PARAMETER :: eps12 = 1.0d-12, zero=0._dp
  !!
  !CALL start_clock( 'v_xc_meta' )
  !!
  !etxc = zero
  !vtxc = zero
  !v(:,:) = zero
  !rhoneg(:) = zero
  !sgn(1) = 1._dp  ;   sgn(2) = -1._dp
  !fac = 1.D0 / DBLE( nspin )
  !np = 1
  !IF (nspin==2) np=3
  !!
  !ALLOCATE( grho(3,dfftp%nnr,nspin) )
  !ALLOCATE( h(3,dfftp%nnr,nspin) )
  !ALLOCATE( rhogsum(ngm) )
  !!
  !ALLOCATE( ex(dfftp%nnr), ec(dfftp%nnr) )
  !ALLOCATE( v1x(dfftp%nnr,nspin), v2x(dfftp%nnr,nspin)   , v3x(dfftp%nnr,nspin) )
  !ALLOCATE( v1c(dfftp%nnr,nspin), v2c(np,dfftp%nnr,nspin), v3c(dfftp%nnr,nspin) )
  !!
  !! ... calculate the gradient of rho + rho_core in real space
  !! ... in LSDA case rhogsum is in (up,down) format
  !!
  !DO is = 1, nspin
     !!
     !rhogsum(:) = fac*rhog_core(:) + ( rho%of_g(:,1) + sgn(is)*rho%of_g(:,nspin) )*0.5D0
     !!
     !CALL fft_gradient_g2r( dfftp, rhogsum, g, grho(1,1,is) )
     !!
  !ENDDO
  !DEALLOCATE(rhogsum)
  !!
  !!
  !IF (nspin == 1) THEN
    !!
    !CALL xc_metagcx( dfftp%nnr, 1, np, rho%of_r, grho, rho%kin_r/e2, ex, ec, &
                      !v1x, v2x, v3x, v1c, v2c, v3c )
    !!
    !DO k = 1, dfftp%nnr
       !!
       !v(k,1) = (v1x(k,1)+v1c(k,1)) * e2
       !!
       !! h contains D(rho*Exc)/D(|grad rho|) * (grad rho) / |grad rho|
       !h(:,k,1) = (v2x(k,1)+v2c(1,k,1)) * grho(:,k,1) * e2 
       !!
       !kedtaur(k,1) = (v3x(k,1)+v3c(k,1)) * 0.5d0 * e2
       !!
       !etxc = etxc + (ex(k)+ec(k)) * e2
       !vtxc = vtxc + (v1x(k,1)+v1c(k,1)) * e2 * ABS(rho%of_r(k,1))
       !!
       !IF (rho%of_r(k,1) < zero) rhoneg(1) = rhoneg(1)-rho%of_r(k,1)
       !!
    !ENDDO
    !!
  !ELSE
    !!
    !CALL rhoz_or_updw( rho, 'only_r', '->updw' )
    !!
    !CALL xc_metagcx( dfftp%nnr, 2, np, rho%of_r, grho, rho%kin_r/e2, ex, ec, &
                     !v1x, v2x, v3x, v1c, v2c, v3c )
    !!
    !! first term of the gradient correction : D(rho*Exc)/D(rho)
    !!
    !DO k = 1, dfftp%nnr
       !!
       !v(k,1) = (v1x(k,1) + v1c(k,1)) * e2
       !v(k,2) = (v1x(k,2) + v1c(k,2)) * e2
       !!
       !! h contains D(rho*Exc)/D(|grad rho|) * (grad rho) / |grad rho|
       !!
       !h(:,k,1) = (v2x(k,1) * grho(:,k,1) + v2c(:,k,1)) * e2                     !^^1
       !h(:,k,2) = (v2x(k,2) * grho(:,k,2) + v2c(:,k,2)) * e2
       !!
       !kedtaur(k,1) = (v3x(k,1) + v3c(k,1)) * 0.5d0 * e2
       !kedtaur(k,2) = (v3x(k,2) + v3c(k,2)) * 0.5d0 * e2
       !!
       !etxc = etxc + (ex(k)+ec(k)) * e2
       !vtxc = vtxc + (v1x(k,1)+v1c(k,1)) * ABS(rho%of_r(k,1)) * e2
       !vtxc = vtxc + (v1x(k,2)+v1c(k,2)) * ABS(rho%of_r(k,2)) * e2
       !!
       !IF ( rho%of_r(k,1) < 0.d0 ) rhoneg(1) = rhoneg(1) - rho%of_r(k,1)
       !IF ( rho%of_r(k,2) < 0.d0 ) rhoneg(2) = rhoneg(2) - rho%of_r(k,2)
       !!
    !ENDDO
    !!
    !CALL rhoz_or_updw( rho, 'only_r', '->rhoz' )
    !!
  !ENDIF
  !!
  !DEALLOCATE( ex, ec )
  !DEALLOCATE( v1x, v2x, v3x )
  !DEALLOCATE( v1c, v2c, v3c )
  !!
  !!
  !ALLOCATE( dh( dfftp%nnr ) )    
  !!
  !! ... second term of the gradient correction :
  !! ... \sum_alpha (D / D r_alpha) ( D(rho*Exc)/D(grad_alpha rho) )
  !!
  !ALLOCATE (rhoout(dfftp%nnr))
  !DO is = 1, nspin
     !!
     !CALL fft_graddot( dfftp, h(1,1,is), g, dh )
     !!
     !v(:,is) = v(:,is) - dh(:)
     !!
     !! ... rhoout is in (up,down) format 
     !!
     !rhoout(:) = ( rho%of_r(:,1) + sgn(is)*rho%of_r(:,nspin) )*0.5D0
     !vtxc = vtxc - SUM( dh(:) * rhoout(:) )
     !!
  !END DO
  !DEALLOCATE(rhoout)
  !DEALLOCATE(dh)
  !!
  !CALL mp_sum( rhoneg, intra_bgrp_comm )
  !!
  !rhoneg(:) = rhoneg(:) * omega / ( dfftp%nr1*dfftp%nr2*dfftp%nr3 )
  !!
  !IF ((rhoneg(1) > eps8) .OR. (rhoneg(2) > eps8)) THEN
    !write (stdout, '(/,5x, "negative rho (up,down): ", 2es10.3)') rhoneg(:)
  !ENDIF
  !!
  !vtxc = omega * vtxc / ( dfftp%nr1*dfftp%nr2*dfftp%nr3 ) 
  !etxc = omega * etxc / ( dfftp%nr1*dfftp%nr2*dfftp%nr3 )
  !!
  !IF ( dft_is_nonlocc() ) CALL nlc( rho%of_r, rho_core, nspin, etxc, vtxc, v )
  !!
  !CALL mp_sum(  vtxc , intra_bgrp_comm )
  !CALL mp_sum(  etxc , intra_bgrp_comm )
  !!
  !DEALLOCATE(grho)
  !DEALLOCATE(h)
  !!
  !CALL stop_clock( 'v_xc_meta' )
  !!
  !RETURN
  !!
!END SUBROUTINE v_xc_meta
!!
!!
!SUBROUTINE v_xc( rho, rho_core, rhog_core, etxc, vtxc, v )
  !!----------------------------------------------------------------------------
  !!! Exchange-Correlation potential Vxc(r) from n(r)
  !!
  !USE kinds,            ONLY : DP
  !USE constants,        ONLY : e2, eps8
  !USE io_global,        ONLY : stdout
  !USE fft_base,         ONLY : dfftp
  !USE gvect,            ONLY : ngm
  !USE lsda_mod,         ONLY : nspin
  !USE cell_base,        ONLY : omega
  !USE spin_orb,         ONLY : domag
  !USE funct,            ONLY : nlc, dft_is_nonlocc
  !USE xc_lda_lsda,      ONLY : xc
  !USE scf,              ONLY : scf_type
  !USE mp_bands,         ONLY : intra_bgrp_comm
  !USE mp,               ONLY : mp_sum
  !!
  !IMPLICIT NONE
  !!
  !TYPE (scf_type), INTENT(INOUT) :: rho
  !!! the valence charge
  !REAL(DP), INTENT(IN) :: rho_core(dfftp%nnr)
  !!! the core charge
  !COMPLEX(DP), INTENT(IN) :: rhog_core(ngm)
  !!! the core charge in reciprocal space
  !REAL(DP), INTENT(OUT) :: v(dfftp%nnr,nspin)
  !!! V_xc potential
  !REAL(DP), INTENT(OUT) :: vtxc
  !!! integral V_xc * rho
  !REAL(DP), INTENT(OUT) :: etxc
  !!! E_xc energy
  !!
  !! ... local variables
  !!
  !REAL(DP) :: rhoneg(2), vs
  !!
  !!REAL(DP), ALLOCATABLE :: arhox(:), amag(:), zeta(:)
  !REAL(DP) :: arho, amag
  !REAL(DP) :: rhoup2, rhodw2
  !REAL(DP), ALLOCATABLE :: ex(:), ec(:)
  !REAL(DP), ALLOCATABLE :: vx(:,:), vc(:,:)
  !! In order:
    !! the absolute value of the total charge
    !! the absolute value of the magnetization
    !! zeta = amag / arhox
    !! local exchange energy
    !! local correlation energy
    !! local exchange potential
    !! local correlation potential
  !INTEGER :: ir, ipol
    !! counter on mesh points
    !! counter on nspin
  !!
  !REAL(DP), PARAMETER :: vanishing_charge = 1.D-10, &
                         !vanishing_mag    = 1.D-20
  !!
  !!
  !CALL start_clock( 'v_xc' )
  !!
  !ALLOCATE( ex(dfftp%nnr) )
  !ALLOCATE( ec(dfftp%nnr) )
  !ALLOCATE( vx(dfftp%nnr,nspin) )
  !ALLOCATE( vc(dfftp%nnr,nspin) )
  !!
  !etxc   = 0.D0
  !vtxc   = 0.D0
  !v(:,:) = 0.D0
  !rhoneg = 0.D0
  !!
  !!
  !rho%of_r(:,1) = rho%of_r(:,1) + rho_core(:)
  !!
  !IF ( nspin == 1 .OR. ( nspin == 4 .AND. .NOT. domag ) ) THEN
     !! ... spin-unpolarized case
     !!
     !CALL xc( dfftp%nnr, 1, 1, rho%of_r(:,1), ex, ec, vx(:,1), vc(:,1) )
     !!
     !DO ir = 1, dfftp%nnr
        !v(ir,1) = e2*( vx(ir,1) + vc(ir,1) )
        !etxc = etxc + e2*( ex(ir) + ec(ir) )*rho%of_r(ir,1)
        !rho%of_r(ir,1) = rho%of_r(ir,1) - rho_core(ir)
        !vtxc = vtxc + v(ir,1)*rho%of_r(ir,1)
        !IF (rho%of_r(ir,1) < 0.D0) rhoneg(1) = rhoneg(1)-rho%of_r(ir,1)
     !ENDDO
     !!
     !!
  !ELSEIF ( nspin == 2 ) THEN
     !! ... spin-polarized case
     !!
     !CALL xc( dfftp%nnr, 2, 2, rho%of_r, ex, ec, vx, vc )
     !!
     !DO ir = 1, dfftp%nnr   !OMP ?
        !v(ir,:) = e2*( vx(ir,:) + vc(ir,:) )
        !etxc = etxc + e2*( (ex(ir) + ec(ir))*rho%of_r(ir,1) )
        !rho%of_r(ir,1) = rho%of_r(ir,1) - rho_core(ir)
        !vtxc = vtxc + ( ( v(ir,1) + v(ir,2) )*rho%of_r(ir,1) + &
                        !( v(ir,1) - v(ir,2) )*rho%of_r(ir,2) )
        !!
        !rhoup2 = rho%of_r(ir,1)+rho%of_r(ir,2)
        !rhodw2 = rho%of_r(ir,1)-rho%of_r(ir,2)
        !IF (rhoup2 < 0.d0) rhoneg(1) = rhoneg(1) + rhoup2
        !IF (rhodw2 < 0.d0) rhoneg(2) = rhoneg(2) + rhodw2
     !ENDDO
     !!
     !vtxc   = 0.5d0 * vtxc
     !rhoneg = 0.5d0 * rhoneg
     !!
     !!
  !ELSE IF ( nspin == 4 ) THEN
     !! ... noncolinear case
     !!
     !CALL xc( dfftp%nnr, 4, 2, rho%of_r, ex, ec, vx, vc )
     !!
     !DO ir = 1, dfftp%nnr  !OMP ?
        !arho = ABS( rho%of_r(ir,1) )
        !IF ( arho < vanishing_charge ) CYCLE
        !vs = 0.5D0*( vx(ir,1) + vc(ir,1) - vx(ir,2) - vc(ir,2) )
        !v(ir,1) = e2*( 0.5D0*( vx(ir,1) + vc(ir,1) + vx(ir,2) + vc(ir,2) ) )
        !!
        !amag = SQRT( SUM( rho%of_r(ir,2:4)**2 ) )
        !IF ( amag > vanishing_mag ) THEN
           !v(ir,2:4) = e2 * vs * rho%of_r(ir,2:4) / amag
           !vtxc = vtxc + SUM( v(ir,2:4) * rho%of_r(ir,2:4) )
        !ENDIF
        !etxc = etxc + e2*( ex(ir) + ec(ir) ) * arho
        !!
        !rho%of_r(ir,1) = rho%of_r(ir,1) - rho_core(ir)
        !IF ( rho%of_r(ir,1) < 0.D0 )  rhoneg(1) = rhoneg(1) - rho%of_r(ir,1)
        !IF ( amag / arho > 1.D0 )  rhoneg(2) = rhoneg(2) + 1.D0/omega
        !vtxc = vtxc + v(ir,1) * rho%of_r(ir,1)
     !ENDDO
     !!
     !!
  !ENDIF
  !!
  !DEALLOCATE( ex, ec )
  !DEALLOCATE( vx, vc )
  !!
  !CALL mp_sum(  rhoneg , intra_bgrp_comm )
  !!
  !rhoneg(:) = rhoneg(:) * omega / ( dfftp%nr1*dfftp%nr2*dfftp%nr3 )
  !!
  !IF ( rhoneg(1) > eps8 .OR. rhoneg(2) > eps8 ) &
     !WRITE( stdout,'(/,5X,"negative rho (up, down): ",2ES10.3)') rhoneg
  !!
  !! ... energy terms, local-density contribution
  !!
  !vtxc = omega * vtxc / ( dfftp%nr1*dfftp%nr2*dfftp%nr3 )
  !etxc = omega * etxc / ( dfftp%nr1*dfftp%nr2*dfftp%nr3 )
  !!
  !! ... add gradient corrections (if any)
  !!
  !CALL gradcorr( rho%of_r, rho%of_g, rho_core, rhog_core, etxc, vtxc, v )
  !!
  !! ... add non local corrections (if any)
  !!
  !IF ( dft_is_nonlocc() ) CALL nlc( rho%of_r, rho_core, nspin, etxc, vtxc, v )
  !!
  !CALL mp_sum(  vtxc , intra_bgrp_comm )
  !CALL mp_sum(  etxc , intra_bgrp_comm )
  !!
  !CALL stop_clock( 'v_xc' )
  !!
  !RETURN
  !!
!END SUBROUTINE v_xc
!!
!!----------------------------------------------------------------------------
!SUBROUTINE v_h( rhog, ehart, charge, v )
  !!----------------------------------------------------------------------------
  !!! Hartree potential VH(r) from n(G)
  !!
  !USE constants,         ONLY : fpi, e2
  !USE kinds,             ONLY : DP
  !USE fft_base,          ONLY : dfftp
  !USE fft_interfaces,    ONLY : invfft
  !USE gvect,             ONLY : ngm, gg, gstart
  !USE lsda_mod,          ONLY : nspin
  !USE cell_base,         ONLY : omega, tpiba2
  !USE control_flags,     ONLY : gamma_only
  !USE mp_bands,          ONLY : intra_bgrp_comm
  !USE mp,                ONLY : mp_sum
  !USE martyna_tuckerman, ONLY : wg_corr_h, do_comp_mt
  !USE esm,               ONLY : do_comp_esm, esm_hartree, esm_bc
  !USE Coul_cut_2D,       ONLY : do_cutoff_2D, cutoff_2D, cutoff_hartree  
  !!
  !IMPLICIT NONE
  !!
  !COMPLEX(DP), INTENT(IN) :: rhog(ngm)
  !!! the charge density in reciprocal space
  !REAL(DP), INTENT(INOUT) :: v(dfftp%nnr,nspin)
  !!! Hartree potential
  !REAL(DP), INTENT(OUT) :: ehart
  !!! Hartree energy
  !REAL(DP), INTENT(OUT) :: charge
  !!
  !!  ... local variables
  !!
  !REAL(DP)              :: fac
  !REAL(DP), ALLOCATABLE :: aux1(:,:)
  !REAL(DP)              :: rgtot_re, rgtot_im, eh_corr
  !INTEGER               :: is, ig
  !COMPLEX(DP), ALLOCATABLE :: aux(:), rgtot(:), vaux(:)
  !INTEGER               :: nt
  !!
  !CALL start_clock( 'v_h' )
  !!
  !ALLOCATE( aux( dfftp%nnr ), aux1( 2, ngm ) )
  !charge = 0.D0
  !!
  !IF ( gstart == 2 ) THEN
     !!
     !charge = omega*REAL( rhog(1) )
     !!
  !END IF
  !!
  !CALL mp_sum(  charge , intra_bgrp_comm )
  !!
  !! ... calculate hartree potential in G-space (NB: V(G=0)=0 )
  !!
  !IF ( do_comp_esm .and. ( esm_bc .ne. 'pbc' ) ) THEN
     !!
     !! ... calculate modified Hartree potential for ESM
     !!
     !CALL esm_hartree (rhog, ehart, aux)
     !!
  !ELSE
     !!
     !ehart     = 0.D0
     !aux1(:,:) = 0.D0
     !!
     !IF (do_cutoff_2D) THEN  !TS
        !CALL cutoff_hartree(rhog(:), aux1, ehart)
     !ELSE
!!$omp parallel do private( fac, rgtot_re, rgtot_im ), reduction(+:ehart)
        !DO ig = gstart, ngm
           !!
           !fac = 1.D0 / gg(ig) 
           !!
           !rgtot_re = REAL(  rhog(ig) )
           !rgtot_im = AIMAG( rhog(ig) )
           !!
           !ehart = ehart + ( rgtot_re**2 + rgtot_im**2 ) * fac
           !!
           !aux1(1,ig) = rgtot_re * fac
           !aux1(2,ig) = rgtot_im * fac
           !!
        !ENDDO
!!$omp end parallel do
     !ENDIF
     !!
     !fac = e2 * fpi / tpiba2
     !!
     !ehart = ehart * fac
     !!
     !aux1 = aux1 * fac
     !!
     !IF ( gamma_only ) THEN
        !!
        !ehart = ehart * omega
        !!
     !ELSE 
        !!
        !ehart = ehart * 0.5D0 * omega
        !!
     !END IF
     !! 
     !if (do_comp_mt) then
        !ALLOCATE( vaux( ngm ), rgtot(ngm) )
        !rgtot(:) = rhog(:)
        !CALL wg_corr_h (omega, ngm, rgtot, vaux, eh_corr)
        !aux1(1,1:ngm) = aux1(1,1:ngm) + REAL( vaux(1:ngm))
        !aux1(2,1:ngm) = aux1(2,1:ngm) + AIMAG(vaux(1:ngm))
        !ehart = ehart + eh_corr
        !DEALLOCATE( rgtot, vaux )
     !end if
     !!
     !CALL mp_sum(  ehart , intra_bgrp_comm )
     !! 
     !aux(:) = 0.D0
     !!
     !aux(dfftp%nl(1:ngm)) = CMPLX( aux1(1,1:ngm), aux1(2,1:ngm), KIND=dp )
     !!
     !IF ( gamma_only ) THEN
        !!
        !aux(dfftp%nlm(1:ngm)) = CMPLX( aux1(1,1:ngm), -aux1(2,1:ngm), KIND=dp )
        !!
     !END IF
  !END IF
  !!
  !! ... transform hartree potential to real space
  !!
  !CALL invfft('Rho', aux, dfftp)
  !!
  !! ... add hartree potential to the xc potential
  !!
  !IF ( nspin == 4 ) THEN
     !!
     !v(:,1) = v(:,1) + DBLE(aux(:))
     !!
  !ELSE
     !!
     !DO is = 1, nspin
        !!
        !v(:,is) = v(:,is) + DBLE(aux(:))
        !!
     !END DO
     !!
  !END IF
  !!
  !DEALLOCATE( aux, aux1 )
  !!
  !CALL stop_clock( 'v_h' )
  !!
  !RETURN
  !!
!END SUBROUTINE v_h
!!
!!-----------------------------------------------------------------------
!SUBROUTINE v_hubbard( ns, v_hub, eth )
  !!---------------------------------------------------------------------
  !!! Computes Hubbard potential and Hubbard energy
  !!
  !USE kinds,                ONLY : DP
  !USE ions_base,            ONLY : nat, ityp
  !USE ldaU,                 ONLY : Hubbard_lmax, Hubbard_l, Hubbard_U, &
                                   !Hubbard_J, Hubbard_alpha, lda_plus_u_kind,&
                                   !Hubbard_J0, Hubbard_beta
  !USE lsda_mod,             ONLY : nspin
  !USE control_flags,        ONLY : iverbosity
  !USE io_global,            ONLY : stdout
  !!
  !IMPLICIT NONE
  !!
  !REAL(DP), INTENT(IN)  :: ns(2*Hubbard_lmax+1,2*Hubbard_lmax+1,nspin,nat)
  !!! Occupation matrix
  !REAL(DP), INTENT(OUT) :: v_hub(2*Hubbard_lmax+1,2*Hubbard_lmax+1,nspin,nat)
  !!! Hubbard potential
  !REAL(DP), INTENT(OUT) :: eth
  !!! Hubbard energy
  !!
  !!  ... local variables
  !!
  !REAL(DP) :: n_tot, n_spin, eth_dc, eth_u, mag2, effU, sgn(2) 
  !INTEGER  :: is, isop, is1, na, nt, m1, m2, m3, m4
  !REAL(DP), ALLOCATABLE :: u_matrix(:,:,:,:)
  !!
  !ALLOCATE( u_matrix(2*Hubbard_lmax+1, 2*Hubbard_lmax+1, 2*Hubbard_lmax+1, 2*Hubbard_lmax+1) )
  !!
  !eth    = 0.d0
  !eth_dc = 0.d0
  !eth_u  = 0.d0
  !!
  !sgn(1)=1.d0  ;   sgn(2)=-1.d0
  !!
  !v_hub(:,:,:,:) = 0.d0
  !!
  !IF (lda_plus_u_kind==0) THEN
    !!
    !DO na = 1, nat
       !nt = ityp (na)
       !IF (Hubbard_U(nt) /= 0.d0 .OR. Hubbard_alpha(nt) /= 0.d0) THEN
          !IF (Hubbard_J0(nt) /= 0.d0) THEN
             !effU = Hubbard_U(nt) - Hubbard_J0(nt)
          !ELSE
             !effU = Hubbard_U(nt)
          !END IF  
          !DO is = 1, nspin
             !DO m1 = 1, 2 * Hubbard_l(nt) + 1
                !eth = eth + ( Hubbard_alpha(nt) + 0.5D0*effU )*ns(m1,m1,is,na)
                !v_hub(m1,m1,is,na) = v_hub(m1,m1,is,na) + &
                                     !Hubbard_alpha(nt)  + 0.5D0*effU
                !DO m2 = 1, 2 * Hubbard_l(nt) + 1
                   !eth = eth - 0.5D0 * effU * ns(m2,m1,is,na)* ns(m1,m2,is,na)
                   !v_hub(m1,m2,is,na) = v_hub(m1,m2,is,na) - &
                                        !effU * ns(m2,m1,is,na)
                !ENDDO
             !ENDDO
          !ENDDO
       !ENDIF
       !!
       !IF (Hubbard_J0(nt) /= 0.d0 .OR. Hubbard_beta(nt) /= 0.d0) THEN
          !DO is=1, nspin
             !isop = 1
             !IF ( nspin == 2 .AND. is == 1) isop = 2
             !DO m1 = 1, 2 * Hubbard_l(nt) + 1
                !eth = eth + sgn(is)*Hubbard_beta(nt) * ns(m1,m1,is,na)
                !v_hub(m1,m1,is,na) = v_hub(m1,m1,is,na) + sgn(is)*Hubbard_beta(nt)
                !DO m2 = 1, 2*Hubbard_l(nt)+1
                   !eth = eth + 0.5D0*Hubbard_J0(nt)*ns(m2,m1,is,na)*ns(m1,m2,isop,na)
                   !v_hub(m1,m2,is,na) = v_hub(m1,m2,is,na) + Hubbard_J0(nt) * &
                                                             !ns(m2,m1,isop,na)
                !END DO
             !END DO
          !END DO
       !END IF
        
    !END DO
    !!
    !IF (nspin==1) eth = 2.d0 * eth
    !!
!!-- output of hubbard energies:
    !IF ( iverbosity > 0 ) THEN
      !write(stdout,*) '--- in v_hubbard ---'
      !write(stdout,'("Hubbard energy ",f9.4)') eth
      !write(stdout,*) '-------'
    !ENDIF
!!--
    !!
  !ELSE
    !!
    !DO na = 1, nat
       !nt = ityp (na)
       !IF (Hubbard_U(nt)/=0.d0) THEN
          !!
!!       initialize U(m1,m2,m3,m4) matrix 
          !CALL hubbard_matrix( Hubbard_lmax, Hubbard_l(nt), Hubbard_U(nt), &
                               !Hubbard_J(1,nt), u_matrix )
          !!
!!---      total N and M^2 for DC (double counting) term
          !n_tot = 0.d0
          !DO is = 1, nspin
            !DO m1 = 1, 2 * Hubbard_l(nt) + 1
              !n_tot = n_tot + ns(m1,m1,is,na)
            !ENDDO
          !ENDDO
          !IF (nspin==1) n_tot = 2.d0 * n_tot
          !!
          !mag2  = 0.d0
          !IF (nspin==2) THEN
            !DO m1 = 1, 2 * Hubbard_l(nt) + 1
              !mag2 = mag2 + ns(m1,m1,1,na) - ns(m1,m1,2,na)
            !ENDDO
          !ENDIF
          !mag2  = mag2**2
!!---

!!---      hubbard energy: DC term

          !eth_dc = eth_dc + 0.5d0*( Hubbard_U(nt)*n_tot*(n_tot-1.d0) - &
                                    !Hubbard_J(1,nt)*n_tot*(0.5d0*n_tot-1.d0) - &
                                    !0.5d0*Hubbard_J(1,nt)*mag2 )
!!--
          !DO is = 1, nspin
            !!
!!---        n_spin = up/down N

            !n_spin = 0.d0
            !DO m1 = 1, 2 * Hubbard_l(nt) + 1
               !n_spin = n_spin + ns(m1,m1,is,na)
            !ENDDO
!!---

            !DO m1 = 1, 2 * Hubbard_l(nt) + 1

!!             hubbard potential: DC contribution  

              !v_hub(m1,m1,is,na) = v_hub(m1,m1,is,na) + Hubbard_J(1,nt)*n_spin + &
                      !0.5d0*(Hubbard_U(nt)-Hubbard_J(1,nt)) - Hubbard_U(nt)*n_tot

!!             +U contributions 

              !DO m2 = 1, 2 * Hubbard_l(nt) + 1
                !DO m3 = 1, 2 * Hubbard_l(nt) + 1
                  !DO m4 = 1, 2 * Hubbard_l(nt) + 1

                    !DO is1 = 1, nspin
                       !v_hub(m1,m2,is,na) = v_hub(m1,m2,is,na) + (MOD(nspin,2)+1) * &
                                         !u_matrix(m1,m3,m2,m4) * ns(m3,m4,is1,na)
                    !ENDDO
                    !!
                    !v_hub(m1,m2,is,na) = v_hub(m1,m2,is,na) - &
                                      !u_matrix(m1,m3,m4,m2) * ns(m3,m4,is,na)
                    !!
                    !eth_u = eth_u + 0.5d0*( ( u_matrix(m1,m2,m3,m4)-u_matrix(m1,m2,m4,m3) ) * &
                                    !ns(m1,m3,is,na)*ns(m2,m4,is,na)+u_matrix(m1,m2,m3,m4)   * &
                                    !ns(m1,m3,is,na)*ns(m2,m4,nspin+1-is,na) )
                  !ENDDO
                !ENDDO
              !ENDDO
            !ENDDO
            !!
          !ENDDO
          !!
       !ENDIF
    !ENDDO
    !!
    !IF (nspin==1) eth_u = 2.d0 * eth_u
    !eth = eth_u - eth_dc

!!-- output of hubbard energies:
    !IF ( iverbosity > 0 ) THEN
      !write(stdout,*) '--- in v_hubbard ---'
      !write(stdout,'("Hubbard energies (dc, U, total) ",3f9.4)') eth_dc, eth_u, eth
      !write(stdout,*) '-------'
    !ENDIF
!!--

  !ENDIF

  !DEALLOCATE (u_matrix)
  !RETURN

!END SUBROUTINE v_hubbard
!!-------------------------------------

!SUBROUTINE v_hubbard_nc( ns, v_hub, eth )
  !!-------------------------------------
  !!! Noncollinear version of v_hubbard.
  !!
  !USE kinds,                ONLY : DP
  !USE ions_base,            ONLY : nat, ityp
  !USE ldaU,                 ONLY : Hubbard_lmax, Hubbard_l, &
                                   !Hubbard_U, Hubbard_J, Hubbard_alpha
  !USE lsda_mod,             ONLY : nspin
  !USE control_flags,        ONLY : iverbosity
  !USE io_global,            ONLY : stdout
  !!
  !IMPLICIT NONE
  !!
  !COMPLEX(DP) :: ns(2*Hubbard_lmax+1,2*Hubbard_lmax+1,nspin,nat)
  !!! Occupation matrix
  !COMPLEX(DP) :: v_hub(2*Hubbard_lmax+1,2*Hubbard_lmax+1,nspin,nat)
  !!! Hubbard potential
  !REAL(DP) :: eth
  !!! Hubbard matrix
  !!
  !!  ... local variables
  !!
  !REAL(DP) :: eth_dc, eth_noflip, eth_flip, psum, mx, my, mz, mag2
  !INTEGER :: is, is1, js, i, j, na, nt, m1, m2, m3, m4
  !COMPLEX(DP) :: n_tot, n_aux
  !REAL(DP), ALLOCATABLE :: u_matrix(:,:,:,:)
  !!
  !ALLOCATE( u_matrix(2*Hubbard_lmax+1, 2*Hubbard_lmax+1, 2*Hubbard_lmax+1, 2*Hubbard_lmax+1) )
  !!
  !eth        = 0.d0
  !eth_dc     = 0.d0  
  !eth_noflip = 0.d0  
  !eth_flip   = 0.d0  
  !!
  !v_hub(:,:,:,:) = 0.d0
  !!
  !DO na = 1, nat  
     !nt = ityp (na)  
     !IF (Hubbard_U(nt) /= 0.d0) THEN  

!!       !initialize U(m1,m2,m3,m4) matrix 
        !CALL hubbard_matrix( Hubbard_lmax, Hubbard_l(nt), Hubbard_U(nt), &
                             !Hubbard_J(1,nt), u_matrix )

!!---    !total N and M^2 for DC (double counting) term
        !n_tot = 0.d0
        !mx    = 0.d0
        !my    = 0.d0
        !mz    = 0.d0
        !DO m1 = 1, 2*Hubbard_l(nt)+1
          !n_tot = n_tot + ns(m1,m1,1,na) + ns(m1,m1,4,na)
          !mx = mx + DBLE( ns(m1, m1, 2, na) + ns(m1, m1, 3, na) )
          !my = my + 2.d0 * AIMAG( ns(m1, m1, 2, na) )
          !mz = mz + DBLE( ns(m1, m1, 1, na) - ns(m1, m1, 4, na) )
        !ENDDO  
        !mag2 = mx**2 + my**2 + mz**2  
!!---

!!---    !hubbard energy: DC term
        !mx = REAL(n_tot)
        !eth_dc = eth_dc + 0.5d0*( Hubbard_U(nt)*mx*(mx-1.d0) - &
                                  !Hubbard_J(1,nt)*mx*(0.5d0*mx-1.d0) - &
                                  !0.5d0*Hubbard_J(1,nt)*mag2 )   
!!--
        !DO is = 1, nspin  
           !IF (is == 2) THEN
            !is1 = 3
           !ELSEIF (is == 3) THEN
            !is1 = 2
           !ELSE
            !is1 = is
           !ENDIF

!!---       !hubbard energy:
           !IF (is1 == is) THEN
!!--         !non spin-flip contribution
            !DO m1 = 1, 2*Hubbard_l(nt)+1
             !DO m2 = 1, 2*Hubbard_l(nt)+1
               !DO m3 = 1, 2*Hubbard_l(nt)+1
                !DO m4 = 1, 2*Hubbard_l(nt)+1
                  !!
                  !eth_noflip = eth_noflip + 0.5d0*(                            &
                             !( u_matrix(m1,m2,m3,m4)-u_matrix(m1,m2,m4,m3) )*  & 
                             !ns(m1,m3,is,na)*ns(m2,m4,is,na) +                 &
                     !u_matrix(m1,m2,m3,m4)*ns(m1,m3,is,na)*ns(m2,m4,nspin+1-is,na) )
                  !!
                !ENDDO
               !ENDDO
              !ENDDO
             !ENDDO
             !!
           !ELSE
!!--         !spin-flip contribution
            !DO m1 = 1, 2*Hubbard_l(nt)+1
             !DO m2 = 1, 2*Hubbard_l(nt)+1
               !DO m3 = 1, 2*Hubbard_l(nt)+1
                !DO m4 = 1, 2*Hubbard_l(nt)+1
                  !!
                  !eth_flip = eth_flip - 0.5d0*u_matrix(m1,m2,m4,m3)* &
                                    !ns(m1,m3,is,na)*ns(m2,m4,is1,na) 
                  !!
                !ENDDO
               !ENDDO
              !ENDDO
             !ENDDO
             !!
           !ENDIF
!!---

!!---       !hubbard potential: non spin-flip contribution 
           !IF (is1 == is) THEN
            !DO m1 = 1, 2*Hubbard_l(nt)+1
             !DO m2 = 1, 2*Hubbard_l(nt)+1

               !DO m3 = 1, 2*Hubbard_l(nt)+1
                !DO m4 = 1, 2*Hubbard_l(nt)+1
                  !v_hub(m1,m2,is,na) = v_hub(m1,m2,is,na) + &
                    !u_matrix(m1,m3,m2,m4)*( ns(m3,m4,1,na)+ns(m3,m4,4,na) ) 
                !ENDDO 
               !ENDDO
               !!
              !ENDDO
             !ENDDO
           !ENDIF
!!---
            
!!---       !n_aux = /sum_{i} n_{i,i}^{sigma2, sigma1} for DC term
           !n_aux = 0.d0
           !DO m1 = 1, 2*Hubbard_l(nt)+1
              !n_aux = n_aux + ns(m1,m1,is1,na)  
           !ENDDO
!!---

           !DO m1 = 1, 2*Hubbard_l(nt)+1
           
!!---          !hubbard potential: DC contribution  
              !v_hub(m1,m1,is,na) = v_hub(m1,m1,is,na) + Hubbard_J(1,nt)*n_aux
              !IF (is1 == is) THEN
                 !v_hub(m1,m1,is,na) = v_hub(m1,m1,is,na) + &
                 !0.5d0*(Hubbard_U(nt)-Hubbard_J(1,nt)) - Hubbard_U(nt)*n_tot  
              !ENDIF
!!---
              
!!---          !hubbard potential: spin-flip contribution
              !DO m2 = 1, 2*Hubbard_l(nt)+1  
                !!
                !DO m3 = 1, 2*Hubbard_l(nt)+1
                  !DO m4 = 1, 2*Hubbard_l(nt)+1
                          !v_hub(m1,m2,is,na) = v_hub(m1,m2,is,na) - &
                                    !u_matrix(m1,m3,m4,m2) * ns(m3,m4,is1,na) 
                  !ENDDO 
                !ENDDO

              !ENDDO
!!---
           !ENDDO
        !ENDDO

     !ENDIF
  !ENDDO

  !eth = eth_noflip + eth_flip - eth_dc

!!-- output of hubbard energies:
  !IF ( iverbosity > 0 ) THEN
    !write(stdout,*) '--- in v_hubbard ---'
    !write(stdout,'("Hub. E (dc, noflip, flip, total) ",4f9.4)') &
                                 !eth_dc, eth_noflip, eth_flip, eth 
    !write(stdout,*) '-------'
  !ENDIF
!!--

  !DEALLOCATE (u_matrix)
  !RETURN
!END SUBROUTINE v_hubbard_nc
!!-------------------------------------------

!!----------------------------------------------------------------------------
!SUBROUTINE v_h_of_rho_r( rhor, ehart, charge, v )
  !!----------------------------------------------------------------------------
  !!! Hartree potential VH(r) from a density in R space n(r) 
  !!
  !USE kinds,           ONLY : DP
  !USE fft_base,        ONLY : dfftp
  !USE fft_interfaces,  ONLY : fwfft
  !USE lsda_mod,        ONLY : nspin
  !!
  !IMPLICIT NONE
  !!
  !! ... Declares variables
  !!
  !REAL( DP ), INTENT(IN)     :: rhor( dfftp%nnr )
  !REAL( DP ), INTENT(INOUT)  :: v( dfftp%nnr )
  !REAL( DP ), INTENT(OUT)    :: ehart, charge
  !!
  !! ... Local variables
  !!
  !COMPLEX( DP ), ALLOCATABLE :: rhog( : )
  !COMPLEX( DP ), ALLOCATABLE :: aux( : )
  !REAL( DP ), ALLOCATABLE :: vaux(:,:)
  !INTEGER :: is
  !!
  !! ... bring the (unsymmetrized) rho(r) to G-space (use aux as work array)
  !!
  !ALLOCATE( rhog( dfftp%ngm ) )
  !ALLOCATE( aux( dfftp%nnr ) )
  !aux = CMPLX(rhor,0.D0,kind=dp)
  !CALL fwfft ('Rho', aux, dfftp)
  !rhog(:) = aux(dfftp%nl(:))
  !DEALLOCATE( aux )
  !!
  !! ... compute VH(r) from n(G)
  !!
  !ALLOCATE( vaux( dfftp%nnr, nspin ) )
  !vaux = 0.D0
  !CALL v_h( rhog, ehart, charge, vaux )
  !v(:) = v(:) + vaux(:,1)
  !!
  !DEALLOCATE( rhog )
  !DEALLOCATE( vaux )
  !!
  !RETURN
  !!
!END SUBROUTINE v_h_of_rho_r
!!----------------------------------------------------------------------------
!SUBROUTINE gradv_h_of_rho_r( rho, gradv )
  !!----------------------------------------------------------------------------
  !!! Gradient of Hartree potential in R space from a total 
  !!! (spinless) density in R space n(r)
  !!
  !USE kinds,           ONLY : DP
  !USE fft_base,        ONLY : dfftp
  !USE fft_interfaces,  ONLY : fwfft, invfft
  !USE constants,       ONLY : fpi, e2
  !USE control_flags,   ONLY : gamma_only
  !USE cell_base,       ONLY : tpiba, omega
  !USE gvect,           ONLY : ngm, gg, gstart, g
  !USE martyna_tuckerman, ONLY : wg_corr_h, do_comp_mt
  !!
  !IMPLICIT NONE
  !!
  !! ... Declares variables
  !!
  !REAL( DP ), INTENT(IN)     :: rho(dfftp%nnr)
  !REAL( DP ), INTENT(OUT)    :: gradv(3, dfftp%nnr)
  !!
  !! ... Local variables
  !!
  !COMPLEX( DP ), ALLOCATABLE :: rhoaux(:)
  !COMPLEX( DP ), ALLOCATABLE :: gaux(:)
  !COMPLEX( DP ), ALLOCATABLE :: rgtot(:), vaux(:)
  !REAL( DP )                 :: fac, eh_corr
  !INTEGER                    :: ig, ipol
  !!
  !! ... Bring rho to G space
  !!
  !ALLOCATE( rhoaux( dfftp%nnr ) )
  !rhoaux( : ) = CMPLX( rho( : ), 0.D0, KIND=dp ) 
  !!
  !CALL fwfft( 'Rho', rhoaux, dfftp )
  !!
  !! ... Compute total potential in G space
  !!
  !ALLOCATE( gaux( dfftp%nnr ) )
  !!
  !DO ipol = 1, 3
    !!
    !gaux(:) = (0.0_dp,0.0_dp)
    !!
    !DO ig = gstart, ngm
      !!
      !fac = g(ipol,ig) / gg(ig)
      !gaux(dfftp%nl(ig)) = CMPLX(-AIMAG(rhoaux(dfftp%nl(ig))),REAL(rhoaux(dfftp%nl(ig))),KIND=dp)*fac 
      !!
    !ENDDO
    !!
    !! ...and add the factor e2*fpi/2\pi/a coming from the missing prefactor of 
    !!  V = e2 * fpi divided by the 2\pi/a factor missing in G  
    !!
    !fac = e2 * fpi / tpiba
    !gaux = gaux * fac 
    !!
    !! ...add martyna-tuckerman correction, if needed
    !! 
    !IF (do_comp_mt) THEN
       !ALLOCATE( vaux( ngm ), rgtot(ngm) )
       !rgtot(1:ngm) = rhoaux(dfftp%nl(1:ngm))
       !CALL wg_corr_h( omega, ngm, rgtot, vaux, eh_corr )
       !DO ig = gstart, ngm
         !fac = g(ipol,ig) * tpiba
         !gaux(dfftp%nl(ig)) = gaux(dfftp%nl(ig)) + CMPLX(-AIMAG(vaux(ig)),REAL(vaux(ig)),kind=dp)*fac 
       !END DO
       !DEALLOCATE( rgtot, vaux )
    !ENDIF
    !!
    !IF ( gamma_only ) THEN
      !!
      !gaux(dfftp%nlm(:)) = &
        !CMPLX( REAL( gaux(dfftp%nl(:)) ), -AIMAG( gaux(dfftp%nl(:)) ) ,kind=DP)
       !!
    !END IF
    !!
    !! ... bring back to R-space, (\grad_ipol a)(r) ...
    !!
    !CALL invfft( 'Rho', gaux, dfftp )
    !!
    !gradv(ipol,:) = REAL( gaux(:) )
    !!
  !ENDDO
  !!
  !DEALLOCATE(gaux)
  !!
  !DEALLOCATE(rhoaux)
  !!
  !RETURN
  !!
!END SUBROUTINE gradv_h_of_rho_r

!
! Copyright (C) 2005-2014 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
!----------------------------------------------------------------------------
! TB
! included gate related variables, search for 'TB'
!----------------------------------------------------------------------------
!
!----------------------------------------------------------------------------
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!Modified based on QE6.3 version
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
MODULE oldxml_pw_restart
  !----------------------------------------------------------------------------
  !
  ! ... this module contains methods to read and write data produced by PWscf
  !
  ! ... originally written by Carlo Sbraccia  (2005)
  !
#if defined(__OLDXML)
  !
  USE iotk_module
  !
  USE oldxml_qexml_module, ONLY: qexml_init,qexml_openfile, qexml_closefile, &
                          qexml_write_header, qexml_write_control ,   &
                          qexml_write_cell, qexml_write_moving_cell,  &
                          qexml_write_ions, qexml_write_symmetry,     &
                          qexml_write_efield, qexml_write_planewaves, &
                          qexml_write_spin, qexml_write_magnetization, &
                          qexml_write_xc, qexml_write_exx, qexml_write_occ, &
                          qexml_write_bz,qexml_write_para, qexml_write_bands_info, &
                          qexml_write_bands_pw, qexml_write_esm, qexml_wfc_filename, &
                          default_fmt_version => qexml_default_version, &
                          qexml_kpoint_dirname, &
                          qexml_read_header, qexml_read_cell, qexml_read_moving_cell, &
                          qexml_read_planewaves, qexml_read_ions, qexml_read_spin, &
                          qexml_read_magnetization, qexml_read_xc, qexml_read_occ, qexml_read_bz, &
                          qexml_read_bands_info, qexml_read_bands_pw, qexml_read_symmetry, &
                          qexml_read_efield, qexml_read_para, qexml_read_exx, qexml_read_esm
  !
  USE oldxml_xml_io_base, ONLY : rho_binary,read_wfc, write_wfc
  USE oldxml_xml_io_base, ONLY : xmlpun, qexml_version, qexml_version_init
  !
  !
  USE kinds,     ONLY : DP
  USE constants, ONLY : e2, PI
  !
  !USE io_files,  ONLY : tmp_dir, prefix, iunpun, xmlpun, delete_if_present, &
  !                      qexml_version, qexml_version_init, pseudo_dir,      &
  !                      create_directory, postfix
  USE io_files,  ONLY : tmp_dir, prefix, iunpun, delete_if_present, &
                        pseudo_dir,      &
                        create_directory, postfix
  !
  USE io_global, ONLY : ionode, ionode_id
  USE mp_images, ONLY : intra_image_comm
  USE mp_pools,  ONLY : my_pool_id
  USE mp_bands,  ONLY : intra_bgrp_comm
  USE mp,        ONLY : mp_bcast, mp_sum, mp_max
  USE parser,    ONLY : version_compare
  !
  !
  IMPLICIT NONE
  !
  CHARACTER(LEN=256), external :: trimcheck
  !
  SAVE
  !
  PRIVATE
  !
  PUBLIC :: pw_readfile, pw_writefile, pp_check_file
  PUBLIC :: gk_l2gmap, gk_l2gmap_kdip
  !
  INTEGER, PRIVATE :: iunout
  !
  LOGICAL :: lcell_read   = .FALSE., &
             lpw_read     = .FALSE., &
             lions_read   = .FALSE., &
             lspin_read   = .FALSE., &
             lstarting_mag_read   = .FALSE., &
             lxc_read     = .FALSE., &
             locc_read    = .FALSE., &
             lbz_read     = .FALSE., &
             lbs_read     = .FALSE., &
             lefield_read = .FALSE., &
             lwfc_read    = .FALSE., &
             lsymm_read   = .FALSE.
  !
  LOGICAL :: twfcollect    = .FALSE. ! Collect wave function in the restart file at the end of run.
  LOGICAL :: lkpoint_dir   = .TRUE.  ! save each k point in a different directory
  !
  !
  CONTAINS
  !
    !------------------------------------------------------------------------
    SUBROUTINE pw_writefile( what )
      !------------------------------------------------------------------------
      !
      USE control_flags,        ONLY : conv_ions, &
                                       lscf, gamma_only, &
                                       tqr, tq_smoothing, tbeta_smoothing, &
                                       noinv, do_makov_payne, smallmem, &
                                       llondon, lxdm, ts_vdw 
      USE realus,               ONLY : real_space
      USE global_version,       ONLY : version_number
      USE cell_base,            ONLY : at, bg, alat, tpiba, tpiba2, &
                                       ibrav, celldm
      USE gvect,                ONLY : ig_l2g
      USE ions_base,            ONLY : nsp, ityp, atm, nat, tau, if_pos
      USE noncollin_module,     ONLY : noncolin, npol
      USE io_files,             ONLY : nwordwfc, iunwfc, psfile
      USE buffers,              ONLY : get_buffer
      !USE wavefunctions_module, ONLY : evc
      USE wavefunctions, ONLY : evc
      USE klist,                ONLY : nks, nkstot, xk, ngk, igk_k, wk, qnorm, &
                                       lgauss, ngauss, degauss, nelec, &
                                       two_fermi_energies, nelup, neldw, ltetra
      USE start_k,              ONLY : nk1, nk2, nk3, k1, k2, k3, &
                                       nks_start, xk_start, wk_start
      USE ktetra,               ONLY : ntetra, tetra, tetra_type
      USE klist,                ONLY : ltetra
      USE gvect,                ONLY : ngm, ngm_g, g, mill
      USE fft_base,             ONLY : dfftp
      USE basis,                ONLY : natomwfc
      USE gvecs,                ONLY : ngms_g, dual
      USE fft_base,             ONLY : dffts
      USE wvfct,                ONLY : npw, npwx, et, wg, nbnd
      USE gvecw,                ONLY : ecutwfc
      USE ener,                 ONLY : ef, ef_up, ef_dw
      USE fixed_occ,            ONLY : tfixed_occ, f_inp
      USE ldaU,                 ONLY : lda_plus_u, lda_plus_u_kind, U_projection, &
                                       Hubbard_lmax, Hubbard_l, Hubbard_U, Hubbard_J, &
                                       Hubbard_alpha, Hubbard_J0, Hubbard_beta
      USE spin_orb,             ONLY : lspinorb, domag, lforcet
      USE symm_base,            ONLY : nrot, nsym, invsym, s, ft, irt, &
                                       t_rev, sname, time_reversal, no_t_rev
      USE lsda_mod,             ONLY : nspin, isk, lsda, starting_magnetization
      USE noncollin_module,     ONLY : angle1, angle2, i_cons, mcons, bfield, &
                                       lambda
      USE ions_base,            ONLY : amass
      USE funct,                ONLY : get_dft_name, get_inlc
      !USE kernel_table,         ONLY : vdw_table_name
      USE input_parameters, ONLY : vdw_table_name
      USE scf,                  ONLY : rho
      USE extfield,             ONLY : tefield, dipfield, edir, &
                                       emaxpos, eopreg, eamp, & !TB
                                       gate, zgate, block, block_1, &
                                       block_2, block_height, relaxz
      USE oldxml_io_rho_xml,           ONLY : write_scf
      USE mp_world,             ONLY : nproc
      USE mp_images,            ONLY : nproc_image
      USE mp_pools,             ONLY : kunit, nproc_pool, me_pool, root_pool, &
                                       intra_pool_comm, inter_pool_comm
      USE mp_bands,             ONLY : nproc_bgrp, me_bgrp, root_bgrp, &
                                       intra_bgrp_comm, nbgrp, ntask_groups
      USE mp_diag,              ONLY : nproc_ortho
      USE funct,                ONLY : get_exx_fraction, dft_is_hybrid, &
                                       get_gau_parameter, &
                                       get_screening_parameter, exx_is_active
      USE exx_base,             ONLY : x_gamma_extrapolation, nq1, nq2, nq3, &
                                       exxdiv_treatment, yukawa, ecutvcut 
      USE exx,                   ONLY:  ecutfock
      USE cellmd,               ONLY : lmovecell, cell_factor 
      USE martyna_tuckerman,    ONLY : do_comp_mt
      USE esm,                  ONLY : do_comp_esm, esm_nfit, esm_efield, esm_w, &
                                       esm_a, esm_bc
      USE acfdt_ener,           ONLY : acfdt_in_pw 
      USE london_module,        ONLY : scal6, lon_rcut, in_C6, in_rvdw
      USE tsvdw_module,         ONLY : vdw_isolated
      USE Coul_cut_2D,          ONLY : do_cutoff_2D 
      
      !
      IMPLICIT NONE
      !
      CHARACTER(LEN=*), INTENT(IN) :: what
      !
      CHARACTER(LEN=20)     :: dft_name
      CHARACTER(LEN=256)    :: dirname, filename
      INTEGER               :: i, ig, ik, ngg, ierr, ipol, num_k_points
      INTEGER               :: nkl, nkr, npwx_g
      INTEGER               :: ike, iks, npw_g, ispin, inlc
      INTEGER, EXTERNAL     :: global_kpoint_index
      INTEGER,  ALLOCATABLE :: ngk_g(:)
      INTEGER,  ALLOCATABLE :: igk_l2g(:,:), igk_l2g_kdip(:,:), mill_g(:,:)
      LOGICAL               :: lwfc, lrho, lxsd
      CHARACTER(iotk_attlenx)  :: attr
      !
      !
      SELECT CASE( what )
      CASE( "all" )
         !
         ! ... do not overwrite the scf charge density with a non-scf one
         ! ... (except in the 'force theorem' calculation of MAE where the
         ! ...  charge density differs from the one read from disk)
         !
         lrho  = lscf .OR. lforcet
         lwfc  = twfcollect
         !
      CASE( "config" )
         ! 
         ! ... write just the xml data file, not the charge density and the wavefunctions
         !
         lwfc  = .FALSE.
         lrho  = .FALSE.
         !
      CASE DEFAULT
         !
         CALL errore( 'pw_writefile', 'unexpected case: '//TRIM(what), 1 )
         ! 
      END SELECT
      !
      IF ( ionode ) THEN
         !
         ! ... look for an empty unit (only ionode needs it)
         !
         CALL iotk_free_unit( iunout, ierr )
         !
      END IF
      !
      CALL mp_bcast( ierr, ionode_id, intra_image_comm )
      !
      CALL errore( 'pw_writefile ', &
                   'no free units to write wavefunctions', ierr )
      !
      dirname = TRIM( tmp_dir ) // TRIM( prefix ) // postfix
      !
      ! ... create the main restart directory
      !
      CALL create_directory( dirname )
      !
      ! ... create the k-points subdirectories
      !
      IF ( nspin == 2 ) THEN
         num_k_points = nkstot / 2
      ELSE
         num_k_points = nkstot
      END IF
      !
      IF (lkpoint_dir) THEN
         !
         DO i = 1, num_k_points
            !
            CALL create_directory( qexml_kpoint_dirname( dirname, i ) )
            !
         END DO
         !
      END IF
      !
      iks =  global_kpoint_index (nkstot, 1  )
      ike = iks + nks - 1
      !
      ! ... find out the global number of G vectors: ngm_g
      !
      ngm_g = ngm
      !
      CALL mp_sum( ngm_g, intra_bgrp_comm )
      !
      ! ... collect all G-vectors across processors within the pools
      !
      ALLOCATE( mill_g( 3, ngm_g ) )
      !
      mill_g = 0
      !
      DO ig = 1, ngm
         !
         mill_g(1,ig_l2g(ig)) = mill(1,ig)
         mill_g(2,ig_l2g(ig)) = mill(2,ig)
         mill_g(3,ig_l2g(ig)) = mill(3,ig)
         !
      END DO
      !
      CALL mp_sum( mill_g, intra_bgrp_comm )
      !
      ! ... build the igk_l2g array, yielding the correspondence between
      ! ... the local k+G index and the global G index - see also ig_l2g
      ! ... igk_l2g is build from arrays igk, previously stored in hinit0
      ! ... Beware: for variable-cell case, one has to use starting G and 
      ! ... k+G vectors
      !
      ALLOCATE ( igk_l2g( npwx, nks ) )
      igk_l2g = 0
      !
      DO ik = 1, nks
         npw = ngk (ik)
         CALL gk_l2gmap( ngm, ig_l2g(1), npw, igk_k(1,ik), igk_l2g(1,ik) )
      END DO
      !
      ! ... compute the global number of G+k vectors for each k point
      !
      ALLOCATE( ngk_g( nkstot ) )
      !
      ngk_g = 0
      ngk_g(iks:ike) = ngk(1:nks)
      !
      CALL mp_sum( ngk_g, inter_pool_comm)
      CALL mp_sum( ngk_g, intra_pool_comm)
      !
      ngk_g = ngk_g / nbgrp
      !
      ! ... compute the maximum G vector index among all G+k an processors
      !
      npw_g = MAXVAL( igk_l2g(:,:) )
      !
      CALL mp_max( npw_g, inter_pool_comm )
      CALL mp_max( npw_g, intra_pool_comm )
      !
      ! ... compute the maximum number of G vector among all k points
      !
      npwx_g = MAXVAL( ngk_g(1:nkstot) )
      !
      ! ... define a further l2g map to write gkvectors and wfc coherently
      !
      ALLOCATE ( igk_l2g_kdip( npwx_g, nks ) )
      !
      igk_l2g_kdip = 0
      !
      DO ik = iks, ike
         !
         CALL gk_l2gmap_kdip( npw_g, ngk_g(ik), ngk(ik-iks+1), &
                              igk_l2g(1,ik-iks+1), igk_l2g_kdip(1,ik-iks+1) )
      END DO
      !
      IF ( ionode ) THEN
         !
         ! ... open XML descriptor
         !
         CALL qexml_init( iunpun )
         CALL qexml_openfile( TRIM( dirname ) // '/' // TRIM( xmlpun ), &
                              'write', BINARY = .FALSE., IERR = ierr  )
         !
         IF (.NOT.(lkpoint_dir)) &
            CALL iotk_open_write( iunout, FILE = TRIM( dirname ) // '/' // &
                    & TRIM( xmlpun )//'.eig', BINARY = .FALSE., IERR = ierr )
         !
      END IF
      !
      !
      CALL mp_bcast( ierr, ionode_id, intra_image_comm )
      !
      CALL errore( 'pw_writefile ', &
                   'cannot open restart file for writing', ierr )
      !
      IF ( ionode ) THEN  
         !
         ! ... here we start writing the punch-file
         !
!-------------------------------------------------------------------------------
! ... HEADER
!-------------------------------------------------------------------------------
         !
         CALL qexml_write_header( "PWSCF", TRIM(version_number) )
         !
!-------------------------------------------------------------------------------
! ... CONTROL 
!-------------------------------------------------------------------------------
         !
         CALL qexml_write_control( PP_CHECK_FLAG=conv_ions, LKPOINT_DIR=lkpoint_dir, &
                            Q_REAL_SPACE=tqr, TQ_SMOOTHING=tq_smoothing, &
                            BETA_REAL_SPACE=real_space, TBETA_SMOOTHING=tbeta_smoothing )
         !
!-------------------------------------------------------------------------------
! ... CELL
!-------------------------------------------------------------------------------
         !
         CALL qexml_write_cell( ibrav, celldm, alat, &
                          at(:,1), at(:,2), at(:,3), bg(:,1), bg(:,2), bg(:,3), &
                      "Bohr","Bohr","2 pi / a", &  
                       do_makov_payne, do_comp_mt, do_comp_esm, do_cutoff_2D ) 
         !
         IF (lmovecell) CALL qexml_write_moving_cell(lmovecell, cell_factor)
         !
!-------------------------------------------------------------------------------
! ... IONS
!-------------------------------------------------------------------------------
         !
         CALL qexml_write_ions( nsp, nat, atm, ityp, psfile, &
                       pseudo_dir, amass, 'a.m.u.', tau, 'Bohr', if_pos, dirname, alat )
         !
!-------------------------------------------------------------------------------
! ... SYMMETRIES
!-------------------------------------------------------------------------------
         !
         CALL qexml_write_symmetry( ibrav, nrot, nsym, invsym, noinv, &
                              time_reversal, no_t_rev, ft, s, sname, "Crystal", irt,  &
                              nat, t_rev )
         !
!-------------------------------------------------------------------------------
! ... ELECTRIC FIELD
!-------------------------------------------------------------------------------
         !
         CALL qexml_write_efield( tefield, dipfield, edir, emaxpos, eopreg, eamp, &
                                  gate, zgate, relaxz, block, block_1, block_2,&
                                  block_height ) 
         !
!
!-------------------------------------------------------------------------------
! ... PLANE_WAVES
!-------------------------------------------------------------------------------
         !
         CALL qexml_write_planewaves( ecutwfc/e2, ecutwfc*dual/e2, npwx_g, gamma_only, &
                                dfftp%nr1, dfftp%nr2, dfftp%nr3, ngm_g, &
                                dffts%nr1, dffts%nr2, dffts%nr3, ngms_g, dfftp%nr1, &
                                dfftp%nr2, dfftp%nr3, mill_g, lwfc,'Hartree' )
         !
!-------------------------------------------------------------------------------
! ... SPIN
!-------------------------------------------------------------------------------
         !
         CALL qexml_write_spin( lsda, noncolin, npol, lspinorb, domag )
         !
         CALL qexml_write_magnetization(starting_magnetization, &
                                  angle1*180.0_DP/PI , angle2*180.0_DP/PI, nsp, &
                                  two_fermi_energies, i_cons, mcons, bfield, &
                                  ef_up/e2, ef_dw/e2, nelup, neldw, lambda,'Hartree')
         !
!-------------------------------------------------------------------------------
! ... EXCHANGE_CORRELATION
!-------------------------------------------------------------------------------
         !
         dft_name = get_dft_name()
         inlc = get_inlc()
         !
         CALL qexml_write_xc( DFT = dft_name, NSP = nsp, LDA_PLUS_U = lda_plus_u,      &
                        LDA_PLUS_U_KIND = lda_plus_u_kind, U_PROJECTION = U_projection, &
                        HUBBARD_LMAX = Hubbard_lmax, HUBBARD_L = Hubbard_l, &
                        HUBBARD_U = Hubbard_U, HUBBARD_J = Hubbard_J, &
                        HUBBARD_J0 = Hubbard_J0, HUBBARD_BETA = Hubbard_beta, &
                        HUBBARD_ALPHA = Hubbard_alpha, &
                        INLC = inlc, VDW_TABLE_NAME = vdw_table_name, &
                        PSEUDO_DIR = pseudo_dir, DIRNAME = dirname, &
                        ACFDT_IN_PW = acfdt_in_pw, &
                        LLONDON = llondon, LONDON_S6 = scal6,         &
                        LONDON_RCUT = lon_rcut, LONDON_C6 = in_C6, LONDON_RVDW = in_rvdw, &
                        LXDM = lxdm, TS_VDW = ts_vdw, VDW_ISOLATED = vdw_isolated )


         IF ( dft_is_hybrid() ) CALL qexml_write_exx &
                       ( x_gamma_extrapolation, nq1, nq2, nq3, &
                         exxdiv_treatment, yukawa, ecutvcut, &
                         get_exx_fraction(), get_gau_parameter(), &
                         get_screening_parameter(), exx_is_active(), ecutfock )
         !
!-------------------------------------------------------------------------------
! ... ESM
!-------------------------------------------------------------------------------
         !
         CALL qexml_write_esm( esm_nfit, esm_efield, esm_w, esm_a, esm_bc )
         !
!-------------------------------------------------------------------------------
! ... OCCUPATIONS
!-------------------------------------------------------------------------------
         !
         CALL qexml_write_occ( LGAUSS = lgauss, NGAUSS = ngauss, &
                         DEGAUSS = degauss/e2,DEGAUSS_UNITS='Hartree', LTETRA = ltetra, NTETRA = ntetra, &
                         TETRA_TYPE = tetra_type, TETRA = tetra, TFIXED_OCC = tfixed_occ, LSDA = lsda, &
                         NSTATES_UP = nbnd, NSTATES_DW = nbnd, INPUT_OCC = f_inp )
         !
!-------------------------------------------------------------------------------
! ... BRILLOUIN_ZONE
!-------------------------------------------------------------------------------
         !
         CALL qexml_write_bz( num_k_points, xk, wk, k1, k2, k3, nk1, nk2, nk3, &
                        '2 pi / a',qnorm, nks_start, xk_start, wk_start )
         !
!-------------------------------------------------------------------------------
! ... PARALLELISM
!-------------------------------------------------------------------------------
         !
         !
         CALL qexml_write_para( kunit, nproc, nproc_pool, nproc_image, &
                                ntask_groups, nproc_bgrp, nproc_ortho )
         !
!-------------------------------------------------------------------------------
! ... CHARGE DENSITY
!-------------------------------------------------------------------------------
         !
         !
         filename = "./charge-density.dat"
         IF ( .NOT. rho_binary ) filename = "./charge-density.xml"
         !
         CALL iotk_link( iunpun, "CHARGE-DENSITY", TRIM(filename), &
                                  CREATE=.FALSE., BINARY=.TRUE. )
         !
!-------------------------------------------------------------------------------
! ... BAND_STRUCTURE_INFO
!-------------------------------------------------------------------------------
         !
         CALL qexml_write_bands_info(  num_k_points, natomwfc, &
                                       nbnd, nbnd, nbnd, &
                                       nspin, nelec,NINT(nelup),NINT(neldw), &
                                       "Hartree", "2 pi / a", &
                                       ef=ef/e2, two_fermi_energies=two_fermi_energies ,&
                                       ef_up=ef_up/e2, ef_down=ef_dw/e2, noncolin=noncolin )
         !
!-------------------------------------------------------------------------------
! ... EIGENVALUES
!-------------------------------------------------------------------------------
         !
         CALL qexml_write_bands_pw( nbnd, num_k_points, nspin, xk, wk, wg,et/e2,"Hartree" , lkpoint_dir , iunout , dirname )
         !
         !
         IF (.NOT. lkpoint_dir ) CALL iotk_close_write( iunout )
         !
!-------------------------------------------------------------------------------
! ... EIGENVECTORS
!-------------------------------------------------------------------------------
         !
         CALL iotk_write_begin( iunpun, "EIGENVECTORS" )
         !
         CALL iotk_write_dat  ( iunpun, "MAX_NUMBER_OF_GK-VECTORS", npwx_g )
         !
      END IF
      !
      k_points_loop2: DO ik = 1, num_k_points
         !
         IF ( ionode ) THEN
            !
            CALL iotk_write_begin( iunpun, "K-POINT" // TRIM( iotk_index( ik ) ) )
            !
            ! ... G+K vectors
            !
            CALL iotk_write_dat( iunpun, "NUMBER_OF_GK-VECTORS", ngk_g(ik) )
            !
            IF ( lwfc ) THEN
               !
               filename = qexml_wfc_filename( ".", 'gkvectors', ik, DIR=lkpoint_dir )
               !
               CALL iotk_link( iunpun, "GK-VECTORS", &
                               filename, CREATE = .FALSE., BINARY = .TRUE. )
               !
               filename = qexml_wfc_filename( dirname, 'gkvectors', ik, &
                                         DIR=lkpoint_dir )
            END IF
            !
         END IF
         !
         IF ( lwfc ) THEN
            !
            IF ( .NOT. smallmem ) CALL write_gk( iunout, ik, filename )
            !
            CALL write_this_wfc ( iunout, ik )
            !
         END IF
         !
         IF ( ionode ) THEN
            !
            CALL iotk_write_end( iunpun, "K-POINT" // TRIM( iotk_index(ik) ) )
            !
         END IF
         !
      END DO k_points_loop2
      !
      IF ( ionode ) THEN
         !
         CALL iotk_write_end( iunpun, "EIGENVECTORS" )
         !
         CALL qexml_closefile( 'write', IERR=ierr)
         !
         !
         CALL delete_if_present( TRIM( dirname ) // '/' // TRIM( xmlpun ) // '.bck' )
         !
      END IF
      !
      DEALLOCATE ( igk_l2g )
      DEALLOCATE ( igk_l2g_kdip )
      !
!-------------------------------------------------------------------------------
! ... CHARGE-DENSITY FILES
!-------------------------------------------------------------------------------
      !
      ! ... also writes rho%ns if lda+U and rho%bec if PAW
      !
      IF ( lrho ) CALL write_scf( rho, nspin )
!-------------------------------------------------------------------------------
! ... END RESTART SECTIONS
!-------------------------------------------------------------------------------
      !
      DEALLOCATE( mill_g )
      DEALLOCATE( ngk_g )
      !
      CALL mp_bcast( ierr, ionode_id, intra_image_comm )
      !
      CALL errore( 'pw_writefile ', 'cannot save history', ierr )
      !
      CALL mp_bcast( ierr, ionode_id, intra_image_comm )
      !
      CALL errore( 'pw_writefile ', 'cannot save history', ierr )
      !
      RETURN
      !
      CONTAINS
        !
        !--------------------------------------------------------------------
        SUBROUTINE write_gk( iun, ik, filename )
          !--------------------------------------------------------------------
          !
#if defined __HDF5
          USE hdf5_qe,   ONLY :  prepare_for_writing_final, write_gkhdf5, &
                                 gk_hdf5_write, h5fclose_f
          USE io_files,  ONLY : tmp_dir
#endif

          IMPLICIT NONE
          !
          INTEGER,            INTENT(IN) :: iun, ik
          CHARACTER(LEN=256), INTENT(IN) :: filename
          !
          INTEGER, ALLOCATABLE :: igwk(:,:)
          INTEGER, ALLOCATABLE :: itmp(:)
          CHARACTER(LEN = 256) :: filename_hdf5
          INTEGER              :: ierr 
          !
          !
          ALLOCATE( igwk( npwx_g, nkstot ) )
          !
          igwk(:,ik) = 0
          !
          ALLOCATE( itmp( npw_g ) )
          !
          itmp = 0
          !
          IF ( ik >= iks .AND. ik <= ike ) THEN
             !
             DO ig = 1, ngk(ik-iks+1)
                !
                itmp(igk_l2g(ig,ik-iks+1)) = igk_l2g(ig,ik-iks+1)
                !
             END DO
             !
          END IF
          !
          CALL mp_sum( itmp, inter_pool_comm )
          CALL mp_sum( itmp, intra_pool_comm )
          !
          ngg = 0
          !
          DO ig = 1, npw_g
             !
             if ( itmp(ig) == ig ) THEN
                !
                ngg = ngg + 1
                !
                igwk(ngg,ik) = ig
                !
             END IF
             !
          END DO
          !
          DEALLOCATE( itmp )
          !
          IF ( ionode ) THEN
             !
#if defined __HDF5
             filename_hdf5=trim(tmp_dir) //"gk.hdf5"
             CALL prepare_for_writing_final(gk_hdf5_write,inter_pool_comm,filename_hdf5,ik)
             CALL write_gkhdf5(gk_hdf5_write,xk(:,ik),igwk(1:ngk_g(ik),ik), &
                              mill_g(1:3,igwk(1:ngk_g(ik),ik)),ik)
             CALL h5fclose_f(gk_hdf5_write%file_id, ierr)
#else

             CALL iotk_open_write( iun, FILE = TRIM( filename ), &
                                   ROOT="GK-VECTORS", BINARY = .TRUE. )
             !
             CALL iotk_write_dat( iun, "NUMBER_OF_GK-VECTORS", ngk_g(ik) )
             CALL iotk_write_dat( iun, "MAX_NUMBER_OF_GK-VECTORS", npwx_g )
             CALL iotk_write_dat( iun, "GAMMA_ONLY", gamma_only )
             !
             CALL iotk_write_attr ( attr, "UNITS", "2 pi / a", FIRST = .TRUE. )
             CALL iotk_write_dat( iun, "K-POINT_COORDS", xk(:,ik), ATTR = attr )
             !
             CALL iotk_write_dat( iun, "INDEX", igwk(1:ngk_g(ik),ik) )
             CALL iotk_write_dat( iun, "GRID", mill_g(1:3,igwk(1:ngk_g(ik),ik)), &
                                  COLUMNS = 3 )
             !
             CALL iotk_close_write( iun )
             !
#endif
          END IF
          !
          DEALLOCATE( igwk )
          !
        END SUBROUTINE write_gk
        !
        !
        !--------------------------------------------------------------------
        SUBROUTINE write_this_wfc ( iun, ik )
          !--------------------------------------------------------------------
          !
          IMPLICIT NONE
          !
          INTEGER, INTENT(IN) :: iun, ik
          CHARACTER(LEN=256)  :: filename
          INTEGER :: ispin,ik_eff
          !
          ! ... wavefunctions - do not read if already in memory (nsk==1)
          ! ...                 read only if on this pool (iks <= ik <= ike )
          !
          IF ( ( nks > 1 ) .AND. ( ik >= iks ) .AND. ( ik <= ike ) ) THEN
             CALL get_buffer ( evc, nwordwfc, iunwfc, (ik-iks+1) )
          END IF
          !
          IF ( nspin == 2 ) THEN
             !
             ! ... beware: with pools, isk(ik) has the correct value for 
             ! ... all k-points only on first pool (ionode proc is ok)
             !
             ispin = isk(ik)
             !
             IF ( ionode ) THEN
                !
                filename = qexml_wfc_filename( ".", 'evc', ik, ispin, &
                     DIR=lkpoint_dir )
                !
                CALL iotk_link( iunpun, "WFC" // TRIM( iotk_index (ispin) ), &
                     filename, CREATE = .FALSE., BINARY = .TRUE. )
                !
                filename = qexml_wfc_filename( dirname, 'evc', ik, ispin, & 
                     DIR=lkpoint_dir )
                !
             END IF
             !
             CALL write_wfc( iunout, ik, nkstot, kunit, ispin, nspin, &
                  evc, npw_g, gamma_only, nbnd, igk_l2g_kdip(:,ik-iks+1),   &
                  ngk(ik-iks+1), filename, 1.D0, &
                  ionode, root_pool, intra_pool_comm, inter_pool_comm, intra_image_comm )
             !
             ik_eff = ik + num_k_points
             !
             ispin = isk(ik_eff)
             !
             ! ... LSDA: now read minority wavefunctions (if not already
             ! ... in memory and if they are on this pool)
             !
             IF ( ( nks > 1 ) .AND. ( ik_eff >= iks ) .AND. ( ik_eff <= ike ) ) THEN
                !
                CALL get_buffer ( evc, nwordwfc, iunwfc, (ik_eff-iks+1) )
                !
             END IF
             !
             IF ( ionode ) THEN
                !
                filename = qexml_wfc_filename( ".", 'evc', ik, ispin, &
                     DIR=lkpoint_dir )
                !
                CALL iotk_link( iunpun, "WFC"//TRIM( iotk_index( ispin ) ), &
                     filename, CREATE = .FALSE., BINARY = .TRUE. )
                !
                filename = qexml_wfc_filename( dirname, 'evc', ik, ispin, &
                     DIR=lkpoint_dir )
                !
             END IF
             !
             CALL write_wfc( iunout, ik_eff, nkstot, kunit, ispin, nspin, &
                  evc, npw_g, gamma_only, nbnd, igk_l2g_kdip(:,ik_eff-iks+1), &
                  ngk(ik_eff-iks+1), filename, 1.D0, &
                  ionode, root_pool, intra_pool_comm, inter_pool_comm, intra_image_comm )
             !
          ELSE
             !
             IF ( noncolin ) THEN
                !
                DO ipol = 1, npol
                   !
                   IF ( ionode ) THEN
                      !
                      filename = qexml_wfc_filename( ".", 'evc', ik, ipol, &
                           DIR=lkpoint_dir )
                      !
                      CALL iotk_link(iunpun,"WFC"//TRIM(iotk_index(ipol)), &
                           filename, CREATE = .FALSE., BINARY = .TRUE. )
                      !
                      filename = qexml_wfc_filename( dirname, 'evc', ik, ipol, &
                           DIR=lkpoint_dir)
                      !
                   END IF
                   !
                   ! TEMP  spin-up and spin-down spinor components are written
                   ! TEMP  to different files, like in LSDA - not a smart way
                   !
                   nkl=(ipol-1)*npwx+1
                   nkr= ipol   *npwx
                   CALL write_wfc( iunout, ik, nkstot, kunit, ipol, npol,   &
                        evc(nkl:nkr,:), npw_g, gamma_only, nbnd, &
                        igk_l2g_kdip(:,ik-iks+1), ngk(ik-iks+1), &
                        filename, 1.D0, &
                        ionode, root_pool, intra_pool_comm, inter_pool_comm, intra_image_comm )
                   !
                END DO
                !
             ELSE
                !
                ispin = 1
                !
                IF ( ionode ) THEN
                   !
                   filename = qexml_wfc_filename( ".", 'evc', ik, DIR=lkpoint_dir )
                   !
                   CALL iotk_link( iunpun, "WFC", filename, &
                        CREATE = .FALSE., BINARY = .TRUE. )
                   !
                   filename =qexml_wfc_filename( dirname, 'evc', ik, &
                        DIR=lkpoint_dir )
                   !
                END IF
                !
                CALL write_wfc( iunout, ik, nkstot, kunit, ispin, nspin, &
                     evc, npw_g, gamma_only, nbnd,            &
                     igk_l2g_kdip(:,ik-iks+1),                &
                     ngk(ik-iks+1), filename, 1.D0, &
                     ionode, root_pool, intra_pool_comm, inter_pool_comm, intra_image_comm )
                !
             END IF
             !
          END IF
          !
        END SUBROUTINE write_this_wfc
        !
      END SUBROUTINE pw_writefile
    !
    !------------------------------------------------------------------------
    SUBROUTINE pw_readfile( what, ierr )
      !------------------------------------------------------------------------
      !
      USE oldxml_io_rho_xml,    ONLY : read_scf
      USE scf,           ONLY : rho
      USE lsda_mod,      ONLY : nspin
      USE mp_bands,      ONLY : intra_bgrp_comm
      USE mp,            ONLY : mp_sum
      !
      IMPLICIT NONE
      !
      CHARACTER(LEN=*), INTENT(IN)  :: what
      INTEGER,          INTENT(OUT) :: ierr
      !
      CHARACTER(LEN=256) :: dirname
      CHARACTER(LEN=80)  :: errmsg
      LOGICAL            :: lcell, lpw, lions, lspin, linit_mag, &
                            lxc, locc, lbz, lbs, lwfc, lheader,          &
                            lsymm, lrho, lefield, ldim, &
                            lef, lexx, lesm
      !
      INTEGER            :: tmp
      !
      ierr = 0
      !
      dirname = TRIM( tmp_dir ) // TRIM( prefix ) // postfix
      !
      ! ... look for an empty unit
      !
      CALL iotk_free_unit( iunout, ierr )
      !
      CALL errore( 'pw_readfile', &
                   'no free units to read wavefunctions', ierr )
      !
      lheader = .NOT. qexml_version_init
      !
      ldim    = .FALSE.
      lcell   = .FALSE.
      lpw     = .FALSE.
      lions   = .FALSE.
      lspin   = .FALSE.
      linit_mag = .FALSE.
      lxc     = .FALSE.
      locc    = .FALSE.
      lbz     = .FALSE.
      lbs     = .FALSE.
      lwfc    = .FALSE.
      lsymm   = .FALSE.
      lrho    = .FALSE.
      lefield = .FALSE.
      lef     = .FALSE.
      lexx    = .FALSE.
      lesm    = .FALSE.
      !
      SELECT CASE( what )
      CASE( 'header' )
         !
         lheader = .TRUE.
         !
      CASE( 'dim' )
         !
         ldim = .TRUE.
         lbz  = .TRUE.
         !
      CASE( 'pseudo' )
         !
         lions = .TRUE.
         !
      CASE( 'config' )
         !
         lcell = .TRUE.
         lions = .TRUE.
         !
      CASE( 'wave' )
         !
         lpw   = .TRUE.
         lwfc  = .TRUE.
         !
      CASE( 'nowavenobs' )
         !
         lcell   = .TRUE.
         lpw     = .TRUE.
         lions   = .TRUE.
         lspin   = .TRUE.
         linit_mag   = .TRUE.
         lxc     = .TRUE.
         locc    = .TRUE.
         lbz     = .TRUE.
         lsymm   = .TRUE.
         lefield = .TRUE.
         !
      CASE( 'nowave' )
         !
         lcell   = .TRUE.
         lpw     = .TRUE.
         lions   = .TRUE.
         lspin   = .TRUE.
         linit_mag   = .TRUE.
         lxc     = .TRUE.
         locc    = .TRUE.
         lbz     = .TRUE.
         lbs     = .TRUE.
         lsymm   = .TRUE.
         lefield = .TRUE.
         !
      CASE( 'all' )
         !
         lcell   = .TRUE.
         lpw     = .TRUE.
         lions   = .TRUE.
         lspin   = .TRUE.
         linit_mag  = .TRUE.
         lxc     = .TRUE.
         locc    = .TRUE.
         lbz     = .TRUE.
         lbs     = .TRUE.
         lwfc    = .TRUE.
         lsymm   = .TRUE.
         lefield = .TRUE.
         lrho    = .TRUE.
         !
      CASE( 'reset' )
         !
         lcell_read   = .FALSE.
         lpw_read     = .FALSE.
         lions_read   = .FALSE.
         lspin_read   = .FALSE.
         lstarting_mag_read   = .FALSE.
         lxc_read     = .FALSE.
         locc_read    = .FALSE.
         lbz_read     = .FALSE.
         lbs_read     = .FALSE.
         lwfc_read    = .FALSE.
         lsymm_read   = .FALSE.
         lefield_read = .FALSE.
         !
      CASE( 'ef' )
         !
         lef        = .TRUE.
         !
      CASE( 'exx' )
         !
         lexx       = .TRUE.
         !
      CASE( 'esm' )
         !
         lesm       = .TRUE.
         !
      CASE( 'spin' )
         !
         lspin       = .TRUE.
         !
      CASE( 'occ' )
         !
         lef        = .TRUE.
         locc  = .TRUE.
         !
      CASE( 'bs' )
         !
         lef        = .TRUE.
         lspin       = .TRUE.
         locc  = .TRUE.
         lbs     = .TRUE.
         !
      CASE( 'bz' )
         !
         lbz     = .TRUE.
         !
      CASE DEFAULT
         !
         CALL errore( 'pw_readfile', 'unknown case '//TRIM(what), 1 )
         !
      END SELECT
      !
      IF ( .NOT. lheader .AND. .NOT. qexml_version_init) &
         CALL errore( 'pw_readfile', 'qexml version not set', 71 )
      !
      IF (  ionode ) THEN
         !
         CALL qexml_init( iunpun )
         CALL qexml_openfile( TRIM( dirname ) // '/' // TRIM( xmlpun ), &
                              'read', BINARY = .FALSE., IERR = ierr  )
         !
      ENDIF
      !
      CALL mp_bcast( ierr, ionode_id, intra_image_comm )
      IF ( ierr /=0 ) THEN
         errmsg='error opening xml data file'
         GOTO 100
      END IF
      !
      IF ( lheader ) THEN
         !
         CALL read_header( ierr )
         IF ( ierr > 0 ) THEN
            errmsg='error reading header of xml data file'
            GOTO 100
         END IF
         !
      ENDIF
      !
      IF ( ldim ) THEN
         !
         CALL read_dim( ierr )
         IF ( ierr > 0 ) THEN
            errmsg='error reading dimensions in xml data file'
            GOTO 100
         END IF
         !
      ENDIF
      !
      IF ( lcell ) THEN
         !
         CALL read_cell( ierr )
         IF ( ierr > 0 ) THEN
            errmsg='error reading cell info in xml data file'
            GOTO 100
         END IF
         !
      END IF
      IF ( lpw ) THEN
         !
         CALL read_planewaves( ierr )
         IF ( ierr > 0 ) THEN
            errmsg='error reading plane-wave info in xml data file'
            GOTO 100
         END IF
         !
      END IF
      IF ( lions ) THEN
         !
         CALL read_ions( dirname, ierr )
         IF ( ierr > 0 ) THEN
            errmsg='error reading info on ions in xml data file'
            GOTO 100
         END IF
         !
      END IF
      IF ( lspin ) THEN
         !
         CALL read_spin( ierr )
         IF ( ierr > 0 ) THEN
            errmsg='error reading spin in xml data file'
            GOTO 100
         END IF
         !
      END IF
      IF (linit_mag) THEN
         !
         CALL read_magnetization( ierr ) 
         IF ( ierr > 0 ) THEN
            errmsg='error reading magnetization in xml data file'
            GOTO 100
         END IF
        !
      ENDIF
      IF ( lxc ) THEN
         !
         CALL read_xc( ierr )
         IF ( ierr > 0 ) THEN
            errmsg='error reading XC functional in xml data file'
            GOTO 100
         END IF
         !
      END IF
      IF ( locc ) THEN
         !
         CALL read_occupations( ierr )
         IF ( ierr > 0 ) THEN
            errmsg='error reading occupation numbers in xml data file'
            GOTO 100
         END IF
         !
      END IF
      IF ( lbz ) THEN
         !
         CALL read_brillouin_zone( ierr )
         IF ( ierr > 0 ) THEN
            errmsg='error reading Brillouin Zone in xml data file'
            GOTO 100
         END IF
         !
      END IF
      IF ( lbs ) THEN
         !
         CALL read_band_structure( dirname, ierr )
         IF ( ierr > 0 ) THEN
            errmsg='error reading band structure in xml data file'
            GOTO 100
         END IF
         !
      END IF
      IF ( lwfc ) THEN
         !
         CALL read_wavefunctions( dirname, ierr )
         IF ( ierr > 0 ) THEN
            errmsg='error reading wavefunctions in xml data file'
            GOTO 100
         END IF
         !
      END IF
      IF ( lsymm ) THEN
         !
         CALL read_symmetry( ierr )
         IF ( ierr > 0 ) THEN
            errmsg='error reading symmetry in xml data file'
            GOTO 100
         END IF
         !
      END IF
      IF ( lefield ) THEN
         !
         CALL read_efield( ierr )
         IF ( ierr > 0 ) THEN
            errmsg='error reading electric fields in xml data file'
            GOTO 100
         END IF
         !
      END IF

      IF ( lrho ) THEN
         !
         ! ... to read the charge-density we use the routine from io_rho_xml 
         ! ... it also reads ns for ldaU and becsum for PAW
         !
         CALL read_scf( rho, nspin )
         !
      END IF

      IF ( lef ) THEN
         !
         CALL read_ef( ierr )
         IF ( ierr > 0 ) THEN
            errmsg='error reading Fermi energy and number of electrons in xml data file'
            GOTO 100
         END IF
         !
      END IF
      IF ( lexx ) THEN
         !
         CALL read_exx( ierr )
         IF ( ierr > 0 ) THEN
            errmsg='error reading hybrid functional in xml data file'
            GOTO 100
         END IF
         !
      END IF
      IF ( lesm ) THEN
         !
         CALL read_esm( ierr )
         IF ( ierr > 0 ) THEN
            errmsg='error reading ESM restart data in xml data file'
            GOTO 100
         END IF
         !
      END IF
      !
      IF (ionode) THEN
         !
         CALL qexml_closefile( 'read', IERR=ierr)
         !
      ENDIF
      !
      CALL mp_bcast( ierr, ionode_id, intra_image_comm )
      IF ( ierr > 0 ) THEN
         errmsg='error closing xml data file'
         GOTO 100
      END IF
      !

      RETURN
      !
      ! uncomment to continue execution after an error occurs
      ! 100 IF (ionode) THEN
      !        CALL qexml_closefile( 'read', IERR=tmp)
      !     ENDIF
      !     RETURN
      ! comment to continue execution after an error occurs


100   CALL errore('pw_readfile',TRIM(errmsg),ierr)
      !
    END SUBROUTINE pw_readfile
    !
    !------------------------------------------------------------------------
    SUBROUTINE read_header( ierr )
      !------------------------------------------------------------------------
      !
      ! ... this routine reads the format version of the current xml datafile
      !
      IMPLICIT NONE
      !
      INTEGER,          INTENT(OUT) :: ierr
      !
      ierr = 0
      !
      IF ( qexml_version_init ) RETURN
      !
      IF ( ionode ) THEN
         !
         CALL qexml_read_header( FORMAT_VERSION = qexml_version, ierr = ierr )
         !
         qexml_version_init = .TRUE.
         !
      ENDIF
      !
      CALL mp_bcast( ierr, ionode_id, intra_image_comm )
      !
      IF ( ierr /=0 ) RETURN
      !
      CALL mp_bcast( qexml_version,       ionode_id, intra_image_comm )
      CALL mp_bcast( qexml_version_init,  ionode_id, intra_image_comm )
      !
      !
    END SUBROUTINE read_header
    !
    !------------------------------------------------------------------------
    SUBROUTINE read_dim( ierr )
      !------------------------------------------------------------------------
      !
      ! ... this routine collects array dimensions from various sections
      ! ... plus with some other variables needed for array allocation 
      !
      USE ions_base,        ONLY : nat, nsp
      USE symm_base,        ONLY : nsym
      USE gvect,            ONLY : ngm_g, ecutrho
      USE fft_base,         ONLY : dfftp
      USE gvecs,            ONLY : ngms_g, dual
      USE fft_base,         ONLY : dffts
      USE lsda_mod,         ONLY : lsda
      USE noncollin_module, ONLY : noncolin
      USE ktetra,           ONLY : ntetra, tetra_type
      USE klist,            ONLY : nkstot, nelec
      USE wvfct,            ONLY : nbnd, npwx
      USE gvecw,            ONLY : ecutwfc
      USE control_flags,    ONLY : gamma_only
      USE mp_pools,         ONLY : kunit
      USE mp_global,        ONLY : nproc_file, nproc_pool_file, &
                                   nproc_image_file, ntask_groups_file, &
                                   nproc_bgrp_file, nproc_ortho_file
      !
      IMPLICIT NONE
      !
      !CHARACTER(LEN=*), INTENT(IN)  :: dirname
      INTEGER,          INTENT(OUT) :: ierr
      !
      INTEGER  :: npwx_
      LOGICAL  :: found, found2
      CHARACTER(iotk_attlenx)  :: attr
      !
      !
      ! ... first the entire CELL section is read
      ! ... 
      ierr=0
      !
      CALL read_cell( ierr )
      IF ( ierr /= 0) GOTO 100
      !
      IF ( ionode ) THEN
         !
         CALL qexml_read_ions( NAT=nat, NSP=nsp, IERR=ierr)
         IF ( ierr /= 0) GOTO 100
         !
         CALL qexml_read_symmetry(NSYM=nsym, FOUND=found, IERR=ierr)
         IF ( ierr /= 0) GOTO 100
         !
         IF ( .NOT. found ) THEN
            !
            nsym = 1
            !
         ENDIF
         !
         CALL qexml_read_planewaves(  ECUTWFC=ecutwfc, ECUTRHO=ecutrho, NPWX=npwx_,GAMMA_ONLY=gamma_only, &
                                      NR1  = dfftp%nr1, NR2  = dfftp%nr2, NR3  = dfftp%nr3, NGM  = ngm_g, &
                                      NR1S = dffts%nr1, NR2S = dffts%nr2, NR3S = dffts%nr3, NGMS = ngms_g, IERR=ierr )
         IF ( ierr /= 0) GOTO 100
         !
         ecutwfc = ecutwfc * e2
         ecutrho = ecutrho * e2
         !
         dual = ecutrho / ecutwfc
         !
         CALL qexml_read_spin( LSDA = lsda, NONCOLIN = noncolin, IERR=ierr )
         IF ( ierr /= 0) GOTO 100
         !
         CALL qexml_read_occ( NTETRA = ntetra, TETRA_TYPE = tetra_type, IERR=ierr )
         IF ( ierr /= 0) GOTO 100
         !
         CALL qexml_read_bz( NUM_K_POINTS= nkstot, IERR =  ierr )
         IF ( ierr /= 0) GOTO 100
         !
         IF ( lsda ) nkstot = nkstot * 2
         !
         CALL qexml_read_bands_info( NBND=nbnd, NELEC=nelec, IERR=ierr )
         IF ( ierr /= 0) GOTO 100
         !
         CALL qexml_read_para( KUNIT=kunit, NPROC=nproc_file, NPROC_POOL=nproc_pool_file, &
              NPROC_IMAGE=nproc_image_file, NTASK_GROUPS = ntask_groups_file, &
              NPROC_BGRP=nproc_bgrp_file, NPROC_ORTHO=nproc_ortho_file, FOUND=found, IERR=ierr )
         IF ( ierr /= 0) GOTO 100
         !
         IF ( .NOT. found ) THEN
            !
            kunit = 1
            nproc_file=1
            nproc_pool_file=1
            nproc_image_file=1
            ntask_groups_file=1
            nproc_bgrp_file=1
            nproc_ortho_file=1
            !
         ENDIF
         !
      END IF
      !
100   CALL mp_bcast( ierr, ionode_id, intra_image_comm )
      !
      IF ( ierr > 0 ) RETURN
      !
      CALL mp_bcast( nat,        ionode_id, intra_image_comm )
      CALL mp_bcast( nsp,        ionode_id, intra_image_comm )
      CALL mp_bcast( nsym,       ionode_id, intra_image_comm )
      CALL mp_bcast( ecutwfc,    ionode_id, intra_image_comm )
      CALL mp_bcast( ecutrho,    ionode_id, intra_image_comm )
      CALL mp_bcast( dual,       ionode_id, intra_image_comm )
      CALL mp_bcast( npwx_,      ionode_id, intra_image_comm )
      CALL mp_bcast( gamma_only, ionode_id, intra_image_comm )
      CALL mp_bcast( dfftp%nr1,  ionode_id, intra_image_comm )
      CALL mp_bcast( dfftp%nr2,  ionode_id, intra_image_comm )
      CALL mp_bcast( dfftp%nr3,  ionode_id, intra_image_comm )
      CALL mp_bcast( ngm_g,      ionode_id, intra_image_comm )
      CALL mp_bcast( dffts%nr1,  ionode_id, intra_image_comm )
      CALL mp_bcast( dffts%nr2,  ionode_id, intra_image_comm )
      CALL mp_bcast( dffts%nr3,  ionode_id, intra_image_comm )
      CALL mp_bcast( ngms_g,     ionode_id, intra_image_comm )
      CALL mp_bcast( lsda,       ionode_id, intra_image_comm )
      CALL mp_bcast( noncolin,   ionode_id, intra_image_comm )
      CALL mp_bcast( ntetra,     ionode_id, intra_image_comm )
      CALL mp_bcast( nkstot,     ionode_id, intra_image_comm )
      CALL mp_bcast( nelec,      ionode_id, intra_image_comm )
      CALL mp_bcast( nbnd,       ionode_id, intra_image_comm )
      CALL mp_bcast( kunit,      ionode_id, intra_image_comm )
      CALL mp_bcast( nproc_file, ionode_id, intra_image_comm )
      CALL mp_bcast( nproc_pool_file,    ionode_id, intra_image_comm )
      CALL mp_bcast( nproc_image_file,   ionode_id, intra_image_comm )
      CALL mp_bcast( ntask_groups_file,  ionode_id, intra_image_comm )
      CALL mp_bcast( nproc_bgrp_file,    ionode_id, intra_image_comm )
      CALL mp_bcast( nproc_ortho_file,   ionode_id, intra_image_comm )
      !-----------------------------------------------------------------------
      npwx=npwx_
      lpw_read = .TRUE.
      !-----------------------------------------------------------------------
      !
      RETURN
      !
    END SUBROUTINE read_dim
    ! 
    !--------------------------------------------------------------------------
    SUBROUTINE read_cell( ierr )
      !------------------------------------------------------------------------
      !
      USE run_info,          ONLY : title
      USE cell_base,         ONLY : ibrav, alat, at, bg, celldm
      USE cell_base,         ONLY : tpiba, tpiba2, omega
      USE cellmd,            ONLY : lmovecell, cell_factor
      USE control_flags,     ONLY : do_makov_payne
      USE martyna_tuckerman, ONLY : do_comp_mt
      USE esm,               ONLY : do_comp_esm
      USE Coul_cut_2D,       ONLY : do_cutoff_2D 
      
      !
      IMPLICIT NONE
      !
      INTEGER,          INTENT(OUT) :: ierr
      !
      CHARACTER(LEN=80) :: bravais_lattice, es_corr
      !
      !
      ierr = 0
      IF ( lcell_read ) RETURN
      !
      IF ( ionode ) THEN
         !
         CALL qexml_read_cell( BRAVAIS_LATTICE=bravais_lattice,CELLDM=celldm, ALAT=alat, &
              A1=at(:,1), A2=at(:,2), A3=at(:,3), ES_CORR=es_corr, IERR=ierr )
         !
      END IF
      !
      CALL mp_bcast( ierr, ionode_id, intra_image_comm )
      IF ( ierr > 0 ) RETURN
      !
      IF ( ionode ) THEN
         !
         SELECT CASE ( TRIM(es_corr))
         CASE ("Makov-Payne")
            do_makov_payne = .true.
            do_comp_mt     = .false.
            do_comp_esm    = .false.
            do_cutoff_2D   = .false.
         CASE ("Martyna-Tuckerman")
            do_makov_payne = .false.
            do_comp_mt     = .true.
            do_comp_esm    = .false.
            do_cutoff_2D   = .false.
         CASE ("ESM")
            do_makov_payne = .false.
            do_comp_mt     = .false.
            do_comp_esm    = .true.
            do_cutoff_2D   = .false.
         CASE ("2D")
            do_makov_payne = .false.
            do_comp_mt     = .false.
            do_comp_esm    = .false.
            do_cutoff_2D   = .true.
         CASE ("None")
            do_makov_payne = .false.
            do_comp_mt     = .false.
            do_comp_esm    = .false.
            do_cutoff_2D   = .false.
         END SELECT
         !
         SELECT CASE ( TRIM(bravais_lattice) )
         CASE( "free" )
            ibrav = 0
         CASE( "cubic P (sc)" )
            ibrav = 1
         CASE( "cubic F (fcc)" )
            ibrav = 2
         CASE( "cubic I (bcc)" )
            ibrav = 3
         CASE( "Hexagonal and Trigonal P" )
            ibrav = 4
         CASE( "Trigonal R" )
            ibrav = 5 
         CASE( "Tetragonal P (st)" )
            ibrav = 6
         CASE( "Tetragonal I (bct)" )
            ibrav = 7
         CASE( "Orthorhombic P" )
            ibrav = 8
         CASE( "Orthorhombic base-centered(bco)" )
            ibrav = 9
         CASE( "Orthorhombic face-centered" )
            ibrav = 10
         CASE( "Orthorhombic body-centered" )
            ibrav = 11
         CASE( "Monoclinic P" )
            ibrav = 12
         CASE( "Monoclinic base-centered" )
            ibrav = 13
         CASE( "Triclinic P" )
            ibrav = 14
         CASE DEFAULT
            ibrav = 0
         END SELECT
         !
         ! ... some internal variables
         !
         tpiba  = 2.D0 * pi / alat
         tpiba2 = tpiba**2 
         !
         ! ... to alat units
         !
         at(:,:) = at(:,:) / alat
         !
         CALL volume( alat, at(1,1), at(1,2), at(1,3), omega )
         !
         ! ... Generate the reciprocal lattice vectors
         !
         CALL recips( at(1,1), at(1,2), at(1,3), bg(1,1), bg(1,2), bg(1,3) )
         !
         CALL qexml_read_moving_cell(lmovecell, cell_factor, ierr)
         !
         !
      END IF
      !
      CALL mp_bcast( ierr, ionode_id, intra_image_comm )
      IF ( ierr > 0 ) RETURN
      !
      CALL mp_bcast( ibrav,     ionode_id, intra_image_comm )
      CALL mp_bcast( alat,      ionode_id, intra_image_comm )
      CALL mp_bcast( celldm,    ionode_id, intra_image_comm )
      CALL mp_bcast( tpiba,     ionode_id, intra_image_comm )
      CALL mp_bcast( tpiba2,    ionode_id, intra_image_comm )
      CALL mp_bcast( omega,     ionode_id, intra_image_comm )
      CALL mp_bcast( at,        ionode_id, intra_image_comm )
      CALL mp_bcast( bg,        ionode_id, intra_image_comm )
      CALL mp_bcast( do_makov_payne, ionode_id, intra_image_comm )
      CALL mp_bcast( do_comp_mt,     ionode_id, intra_image_comm )
      CALL mp_bcast( do_comp_esm,    ionode_id, intra_image_comm )
      CALL mp_bcast( do_cutoff_2D,   ionode_id, intra_image_comm ) 
      CALL mp_bcast( lmovecell, ionode_id, intra_image_comm )
      IF (lmovecell) THEN
         CALL mp_bcast( cell_factor,  ionode_id, intra_image_comm )
      ELSE
         cell_factor=1.0_DP
      END IF
      !
      title = ' '
      !
      lcell_read = .TRUE.
      !
      RETURN
      !
    END SUBROUTINE read_cell
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE read_ions( dirname, ierr )
      !------------------------------------------------------------------------
      !
      USE ions_base, ONLY : nat, nsp, ityp, amass, atm, tau, if_pos
      USE cell_base, ONLY : alat
      USE io_files,  ONLY : psfile, pseudo_dir, pseudo_dir_cur
      !
      IMPLICIT NONE
      !
      CHARACTER(LEN=*), INTENT(IN)  :: dirname
      INTEGER,          INTENT(OUT) :: ierr
      !
      INTEGER :: i
      LOGICAL :: exst
      !
      ierr = 0
      IF ( lions_read ) RETURN
      !
      IF ( .NOT. lcell_read ) &
         CALL errore( 'read_ions', 'read cell first', 1 )
      !
      ! this is where PP files should be read from
      !
      pseudo_dir_cur = trimcheck ( dirname ) 
      !
      IF ( ionode ) THEN
         !
         CALL qexml_read_ions( NSP=nsp, NAT=nat, ATM=atm, ITYP=ityp, &
                               PSFILE=psfile, AMASS=amass, &
                               TAU=tau, IF_POS=if_pos, PSEUDO_DIR=pseudo_dir, &
                               IERR=ierr )
         !
      ENDIF
      !
      CALL mp_bcast( ierr, ionode_id, intra_image_comm )
      !
      IF ( ierr > 0 ) RETURN
      !
      IF ( ionode ) THEN
         !
         DO i = 1, nat
            !
            tau(:,i) = tau(:,i) / alat
            !
         END DO
         !
      END IF
      !
      CALL mp_bcast( nat,    ionode_id, intra_image_comm )
      CALL mp_bcast( nsp,    ionode_id, intra_image_comm )
      CALL mp_bcast( atm,    ionode_id, intra_image_comm )
      CALL mp_bcast( amass,  ionode_id, intra_image_comm )
      CALL mp_bcast( psfile, ionode_id, intra_image_comm )
      CALL mp_bcast( pseudo_dir, ionode_id, intra_image_comm )
      CALL mp_bcast( ityp,   ionode_id, intra_image_comm )
      CALL mp_bcast( tau,    ionode_id, intra_image_comm )
      CALL mp_bcast( if_pos, ionode_id, intra_image_comm )
      !
      lions_read = .TRUE.
      !
      RETURN
      !
    END SUBROUTINE read_ions
    !
    !------------------------------------------------------------------------
    SUBROUTINE read_symmetry( ierr )
      !------------------------------------------------------------------------
      !
      !USE symm_base,       ONLY : nrot, nsym, invsym, s, ft,ftau, irt, t_rev, &
      USE symm_base,       ONLY : nrot, nsym, invsym, s, ft, irt, t_rev, &
                                  sname, sr, invs, inverse_s, s_axis_to_cart, &
                                  time_reversal, no_t_rev
      USE control_flags,   ONLY : noinv
      USE fft_base,        ONLY : dfftp
      !
      IMPLICIT NONE
      !
      INTEGER,          INTENT(OUT) :: ierr
      CHARACTER(iotk_attlenx)  :: attr
      !
      INTEGER  :: i
      LOGICAL  :: found
      !
      ierr = 0
      IF ( lsymm_read ) RETURN
      !
      IF ( .NOT. lpw_read ) &
         CALL errore( 'read_symmetry', 'read planewaves first', 1 )
      !
      IF ( ionode ) THEN
         !
         CALL qexml_read_symmetry( NSYM=nsym, NROT=nrot, INVSYM=invsym, NOINV=noinv, &
              TIME_REVERSAL=time_reversal, NO_T_REV=no_t_rev, &
              TRASL=ft, S=s, SNAME=sname, T_REV=t_rev, &
              IRT=irt, FOUND=found, IERR=ierr )
         !
      ENDIF
      !
      CALL mp_bcast( ierr, ionode_id, intra_image_comm )
      !
      IF ( ierr > 0 ) RETURN
      !
      IF ( ionode ) THEN
         !
         IF ( .NOT. found ) THEN
            !
            nsym = 1
            s(:,:,nsym) = 0
            s(1,1,nsym) = 1
            s(2,2,nsym) = 1
            s(3,3,nsym) = 1
            sr(:,:,nsym) = DBLE(s(:,:,nsym))
            !ftau(:,nsym)= 0
            ft  (:,nsym)= 0.0_DP
            sname(nsym) = 'identity'
            do i = 1, SIZE( irt, 2 )
               irt(nsym,i) = i
            end do
            invsym = .FALSE.
            noinv=.FALSE.
            t_rev(nsym) = 0
            invs(1)=1
            time_reversal=.TRUE.
            no_t_rev=.FALSE.
            !
         ELSE
            !
            !DO i = 1, nsym
            !   !
            !   ftau(1,i) = NINT( ft(1,i)*DBLE( dfftp%nr1 ) )
            !   ftau(2,i) = NINT( ft(2,i)*DBLE( dfftp%nr2 ) )
            !   ftau(3,i) = NINT( ft(3,i)*DBLE( dfftp%nr3 ) )
            !   !
            !END DO
            !
            ! indices of inverse operations and matrices in cartesian axis
            ! are not saved to disk (maybe they should), are recalculated here 
            !
            CALL inverse_s ()
            CALL s_axis_to_cart ()
            !
         END IF
         !
         !
      END IF
      !
      CALL mp_bcast( nsym,   ionode_id, intra_image_comm )
      CALL mp_bcast( nrot,   ionode_id, intra_image_comm )
      CALL mp_bcast( invsym, ionode_id, intra_image_comm )
      CALL mp_bcast( noinv,  ionode_id, intra_image_comm )
      CALL mp_bcast( time_reversal,  ionode_id, intra_image_comm )
      CALL mp_bcast( no_t_rev,       ionode_id, intra_image_comm )
      CALL mp_bcast( s,      ionode_id, intra_image_comm )
      !CALL mp_bcast( ftau,   ionode_id, intra_image_comm )
      CALL mp_bcast( ft,     ionode_id, intra_image_comm )
      CALL mp_bcast( sname,  ionode_id, intra_image_comm )
      CALL mp_bcast( irt,    ionode_id, intra_image_comm )
      CALL mp_bcast( t_rev,  ionode_id, intra_image_comm )
      CALL mp_bcast( invs,   ionode_id, intra_image_comm )
      CALL mp_bcast( sr,     ionode_id, intra_image_comm )
      !
      lsymm_read = .TRUE.
      !
      RETURN
      !
    END SUBROUTINE read_symmetry
    !
    !------------------------------------------------------------------------
    SUBROUTINE read_efield( ierr )
      !----------------------------------------------------------------------
      !
      USE extfield, ONLY : tefield, dipfield, edir, emaxpos, eopreg, eamp, & !TB
                           gate, zgate, relaxz, block, block_1, block_2, block_height
      !
      IMPLICIT NONE
      !
      INTEGER,          INTENT(OUT) :: ierr
      LOGICAL                       :: found
      !
      ierr = 0
      IF ( lefield_read ) RETURN
      !
      !
      IF ( ionode ) THEN
         !
         CALL qexml_read_efield( TEFIELD=tefield, DIPFIELD=dipfield, EDIR=edir, &
                                 EMAXPOS=emaxpos, EOPREG=eopreg, EAMP=eamp, &
                                 GATE=gate, ZGATE=zgate, RELAXZ=relaxz, & !TB
                                 BLOCK=block, BLOCK_1=block_1, BLOCK_2=block_2, &
                                 BLOCK_HEIGHT=block_height, FOUND=found, IERR=ierr )
      ENDIF
      !
      CALL mp_bcast( ierr, ionode_id, intra_image_comm )
      !
      IF ( ierr > 0 ) RETURN
      !
      IF ( (ionode).AND.(.NOT.found) ) THEN
         !
         tefield  = .FALSE.
         dipfield = .FALSE.
         gate     = .FALSE.
         !
      END IF
      !
      CALL mp_bcast( tefield,  ionode_id, intra_image_comm )
      CALL mp_bcast( dipfield, ionode_id, intra_image_comm )
      CALL mp_bcast( edir,     ionode_id, intra_image_comm )
      CALL mp_bcast( emaxpos,  ionode_id, intra_image_comm )
      CALL mp_bcast( eopreg,   ionode_id, intra_image_comm )
      CALL mp_bcast( eamp,     ionode_id, intra_image_comm )
      CALL mp_bcast( gate,     ionode_id, intra_image_comm )
      CALL mp_bcast( zgate,    ionode_id, intra_image_comm )
      CALL mp_bcast( relaxz,   ionode_id, intra_image_comm )
      CALL mp_bcast( block,    ionode_id, intra_image_comm )
      CALL mp_bcast( block_1,  ionode_id, intra_image_comm )
      CALL mp_bcast( block_2,  ionode_id, intra_image_comm )
      CALL mp_bcast( block_height, ionode_id, intra_image_comm )
      !
      lefield_read = .TRUE.
      !
      RETURN
      !
    END SUBROUTINE read_efield
    !
    !------------------------------------------------------------------------
    SUBROUTINE read_planewaves( ierr )
      !------------------------------------------------------------------------
      !
      USE gvect,           ONLY : ngm_g, ecutrho
      USE gvecs,           ONLY : ngms_g, dual
      USE gvecw,           ONLY : ecutwfc
      USE fft_base,        ONLY : dfftp
      USE fft_base,        ONLY : dffts
      USE wvfct,           ONLY : npwx
      USE control_flags,   ONLY : gamma_only
      !
      IMPLICIT NONE
      !
      INTEGER,          INTENT(OUT) :: ierr
      !
      INTEGER  :: npwx_
      !
      ierr = 0
      IF ( lpw_read ) RETURN
      !
      !
      IF ( ionode ) CALL qexml_read_planewaves( ECUTWFC=ecutwfc, ECUTRHO=ecutrho, NPWX=npwx_, &
                                     GAMMA_ONLY=gamma_only, &
                                     NR1 = dfftp%nr1, NR2 = dfftp%nr2, NR3 = dfftp%nr3, NGM=ngm_g, &
                                     NR1S= dffts%nr1, NR2S= dffts%nr2, NR3S= dffts%nr3, &
                                     NGMS=ngms_g, IERR=ierr )

      CALL mp_bcast( ierr, ionode_id, intra_image_comm )
      !
      IF ( ierr > 0 ) RETURN
      !
      IF ( ionode ) THEN
         !
         ecutwfc = ecutwfc * e2
         ecutrho = ecutrho * e2
         !
         dual = ecutrho / ecutwfc
         !
      END IF
      !
      CALL mp_bcast( ecutwfc,    ionode_id, intra_image_comm )
      CALL mp_bcast( ecutrho,    ionode_id, intra_image_comm )
      CALL mp_bcast( dual,       ionode_id, intra_image_comm )
      CALL mp_bcast( npwx_,      ionode_id, intra_image_comm )
      CALL mp_bcast( gamma_only, ionode_id, intra_image_comm )
      CALL mp_bcast( dfftp%nr1,        ionode_id, intra_image_comm )
      CALL mp_bcast( dfftp%nr2,        ionode_id, intra_image_comm )
      CALL mp_bcast( dfftp%nr3,        ionode_id, intra_image_comm )
      CALL mp_bcast( ngm_g,      ionode_id, intra_image_comm )
      CALL mp_bcast( dffts%nr1,       ionode_id, intra_image_comm )
      CALL mp_bcast( dffts%nr2,       ionode_id, intra_image_comm )
      CALL mp_bcast( dffts%nr3,       ionode_id, intra_image_comm )
      CALL mp_bcast( ngms_g,     ionode_id, intra_image_comm )
      !
      lpw_read = .TRUE.
      !
      RETURN
      !
    END SUBROUTINE read_planewaves  
    !
    !------------------------------------------------------------------------
    SUBROUTINE read_spin( ierr )
      !------------------------------------------------------------------------
      !
      USE spin_orb,         ONLY : lspinorb, domag
      USE lsda_mod,         ONLY : nspin, lsda
      USE noncollin_module, ONLY : noncolin, npol
      !
      IMPLICIT NONE
      !
      INTEGER,          INTENT(OUT) :: ierr
      !
      LOGICAL :: found
      !
      ierr = 0
      IF ( lspin_read ) RETURN
      !
      IF ( ionode ) THEN
         !
         CALL qexml_read_spin( lsda, noncolin, npol, lspinorb, domag, ierr )
         !
         IF ( lsda ) THEN
            !
            nspin = 2
            !
         ELSE IF ( noncolin ) THEN
            !
            nspin = 4
            !
         ELSE
            !
            nspin = 1
            !
         END IF
         !
      END IF
      !
      CALL mp_bcast( lsda,     ionode_id, intra_image_comm )
      CALL mp_bcast( nspin,    ionode_id, intra_image_comm )
      CALL mp_bcast( noncolin, ionode_id, intra_image_comm )
      CALL mp_bcast( npol,     ionode_id, intra_image_comm )
      CALL mp_bcast( lspinorb, ionode_id, intra_image_comm )
      CALL mp_bcast( domag,    ionode_id, intra_image_comm )
      !
      lspin_read = .TRUE.
      !
      RETURN
      !
    END SUBROUTINE read_spin
    !
    !--------------------------------------------------------------------------
    SUBROUTINE read_magnetization( ierr )
      !------------------------------------------------------------------------
      !
      USE klist,            ONLY : two_fermi_energies, nelup, neldw
      USE ener,             ONLY : ef_up, ef_dw
      USE lsda_mod,         ONLY : starting_magnetization
      USE noncollin_module, ONLY : angle1, angle2, i_cons, mcons, bfield, &
                                   lambda
      !
      IMPLICIT NONE
      !
      INTEGER,          INTENT(OUT) :: ierr
      !
      LOGICAL :: found
      INTEGER :: i, nsp
      !
      ierr = 0
      IF ( lstarting_mag_read ) RETURN
      !
      !
      IF ( ionode ) THEN
         !
         CALL qexml_read_magnetization(STARTING_MAGNETIZATION=starting_magnetization, &
              ANGLE1=angle1, ANGLE2=angle2, &
              TWO_FERMI_ENERGIES=two_fermi_energies, I_CONS=i_cons, MCONS=mcons, &
              BFIELD=bfield, EF_UP=ef_up, EF_DW=ef_dw, NELUP=nelup, NELDW=neldw, &
              LAMBDA=lambda, FOUND=found, IERR= ierr)
         !
         angle1(:)=angle1(:)*PI/180.d0
         angle2(:)=angle2(:)*PI/180.d0
         !
         IF (two_fermi_energies) THEN
            !
            ef_up = ef_up * e2 
            ef_dw = ef_dw * e2
            !
         ENDIF
         !
      END IF
      !
      CALL mp_bcast( found,  ionode_id, intra_image_comm )
      !
      IF( found ) THEN
         !
         CALL mp_bcast( starting_magnetization,  ionode_id, intra_image_comm )
         CALL mp_bcast( angle1,                  ionode_id, intra_image_comm )
         CALL mp_bcast( angle2,                  ionode_id, intra_image_comm )
         CALL mp_bcast( two_fermi_energies,      ionode_id, intra_image_comm )
         CALL mp_bcast( i_cons,                  ionode_id, intra_image_comm )
         CALL mp_bcast( mcons,                   ionode_id, intra_image_comm )
         CALL mp_bcast( bfield,                  ionode_id, intra_image_comm )
         CALL mp_bcast( nelup,                   ionode_id, intra_image_comm )
         CALL mp_bcast( neldw,                   ionode_id, intra_image_comm )
         CALL mp_bcast( ef_up,                   ionode_id, intra_image_comm )
         CALL mp_bcast( ef_dw,                   ionode_id, intra_image_comm )
         CALL mp_bcast( lambda,                  ionode_id, intra_image_comm )
         !
      ENDIF
      !
      lstarting_mag_read = .TRUE.
      !
      RETURN
      !
    END SUBROUTINE read_magnetization
    !
    !------------------------------------------------------------------------
    SUBROUTINE read_xc( ierr )
      !------------------------------------------------------------------------
      !
      USE ions_base, ONLY : nsp
      USE funct,     ONLY : enforce_input_dft
      USE ldaU,      ONLY : lda_plus_u, lda_plus_u_kind, Hubbard_lmax, &
                            Hubbard_l, Hubbard_U, Hubbard_J, Hubbard_alpha, &
                            Hubbard_J0, Hubbard_beta, U_projection
      !USE kernel_table, ONLY : vdw_table_name
      USE input_parameters, ONLY : vdw_table_name
      USE acfdt_ener,   ONLY : acfdt_in_pw
      USE control_flags,ONLY : llondon, lxdm, ts_vdw
      USE london_module,ONLY : scal6, lon_rcut, in_C6, in_rvdw
      USE tsvdw_module, ONLY : vdw_isolated
      !
      IMPLICIT NONE
      !
      INTEGER,          INTENT(OUT) :: ierr
      !
      CHARACTER(LEN=20) :: dft_name
      INTEGER           :: nsp_, inlc
      LOGICAL           :: nomsg = .true.
      !
      ierr = 0
      IF ( lxc_read ) RETURN
      !
      IF ( .NOT. lions_read ) &
         CALL errore( 'read_xc', 'read ions first', 1 )
      !
      IF ( ionode ) THEN
         !
         CALL qexml_read_xc( dft_name, lda_plus_u, lda_plus_u_kind, U_projection,&
                             Hubbard_lmax, Hubbard_l, nsp_, Hubbard_U, Hubbard_J, &
                             Hubbard_J0, Hubbard_alpha, Hubbard_beta, &
                             inlc, vdw_table_name,  acfdt_in_pw, llondon, scal6, &
                             lon_rcut, in_C6, in_rvdw, lxdm, ts_vdw, vdw_isolated, ierr )
         !
      END IF
      !
      CALL mp_bcast( dft_name,   ionode_id, intra_image_comm )
      CALL mp_bcast( lda_plus_u, ionode_id, intra_image_comm )
      CALL mp_bcast( inlc, ionode_id, intra_image_comm )
      CALL mp_bcast( llondon,    ionode_id, intra_image_comm )
      CALL mp_bcast( lxdm,       ionode_id, intra_image_comm )
      CALL mp_bcast( ts_vdw,     ionode_id, intra_image_comm )
      !
      IF ( lda_plus_u ) THEN
         !
         CALL mp_bcast( lda_plus_u_kind, ionode_id, intra_image_comm )
         CALL mp_bcast( Hubbard_lmax,  ionode_id, intra_image_comm )
         CALL mp_bcast( Hubbard_l ,    ionode_id, intra_image_comm )
         CALL mp_bcast( U_projection,  ionode_id, intra_image_comm )
         CALL mp_bcast( Hubbard_U,     ionode_id, intra_image_comm )
         CALL mp_bcast( Hubbard_J,     ionode_id, intra_image_comm )
         CALL mp_bcast( Hubbard_J0,    ionode_id, intra_image_comm )
         CALL mp_bcast( Hubbard_alpha, ionode_id, intra_image_comm )
         CALL mp_bcast( Hubbard_beta,  ionode_id, intra_image_comm )
         !
      END IF
      !
      IF ( llondon ) THEN
         CALL mp_bcast( scal6, ionode_id, intra_image_comm )
         CALL mp_bcast( lon_rcut, ionode_id, intra_image_comm )
      END IF
      !
      IF ( ts_vdw ) THEN
         CALL mp_bcast( vdw_isolated, ionode_id, intra_image_comm )
      END IF
      !
      ! SCF EXX/RPA
      !
      CALL mp_bcast( acfdt_in_pw, ionode_id, intra_image_comm )
      !
      IF (acfdt_in_pw) dft_name = 'NOX-NOC'

      IF ( inlc > 0 ) THEN
         CALL mp_bcast( vdw_table_name,  ionode_id, intra_image_comm )
      END IF
      !
      IF ( llondon ) THEN
         CALL mp_bcast( scal6, ionode_id, intra_image_comm )
         CALL mp_bcast( lon_rcut, ionode_id, intra_image_comm )
      END IF
      !
      IF ( ts_vdw ) THEN
         CALL mp_bcast( vdw_isolated, ionode_id, intra_image_comm )
      END IF
      !
      ! SCF EXX/RPA
      !
      CALL mp_bcast( acfdt_in_pw, ionode_id, intra_image_comm )
      !
      IF (acfdt_in_pw) dft_name = 'NOX-NOC'

      ! discard any further attempt to set a different dft
      CALL enforce_input_dft( dft_name, nomsg )
      !
      lxc_read = .TRUE.
      !
      RETURN
      !
    END SUBROUTINE read_xc
    !

    !------------------------------------------------------------------------
    SUBROUTINE read_brillouin_zone( ierr )
      !------------------------------------------------------------------------
      !
      USE lsda_mod, ONLY : lsda
      USE klist,    ONLY : nkstot, xk, wk, qnorm
      USE start_k,    ONLY : nks_start, xk_start, wk_start, &
                              nk1, nk2, nk3, k1, k2, k3
      USE symm_base,   ONLY : nrot, s, sname
      !
      IMPLICIT NONE
      !
      INTEGER,          INTENT(OUT) :: ierr
      CHARACTER(iotk_attlenx)  :: attr
      !
      INTEGER :: i, ik, num_k_points
      LOGICAL :: found
      !
      ierr = 0
      IF ( lbz_read ) RETURN
      !
      !
      IF ( ionode ) THEN
         !
         ! xk_start and wk_start are ALLOCATABLE inside the function
         CALL qexml_read_bz( NUM_K_POINTS=num_k_points, XK=xk, WK=wk, K1=k1, K2=k2, K3=k3, &
              NK1=nk1, NK2=nk2, NK3=nk3, &
              NKS_START=nks_start, XK_START=xk_start, WK_START=wk_start, QNORM=qnorm, IERR=ierr )
         !
         nkstot = num_k_points
         !
         IF ( lsda ) nkstot = num_k_points * 2
         !
         DO ik = 1, num_k_points
            !
            IF ( lsda ) THEN
               !
               xk(:,ik+num_k_points) = xk(:,ik)
               !
               wk(ik+num_k_points) = wk(ik)
               !
            END IF
            !
         END DO
         !
      END IF
      !
      CALL mp_bcast( nkstot, ionode_id, intra_image_comm )
      CALL mp_bcast( xk,     ionode_id, intra_image_comm )
      CALL mp_bcast( wk,     ionode_id, intra_image_comm )
      CALL mp_bcast( nk1, ionode_id, intra_image_comm )
      CALL mp_bcast( nk2, ionode_id, intra_image_comm )
      CALL mp_bcast( nk3, ionode_id, intra_image_comm )
      CALL mp_bcast( k1, ionode_id, intra_image_comm )
      CALL mp_bcast( k2, ionode_id, intra_image_comm )
      CALL mp_bcast( k3, ionode_id, intra_image_comm )
      CALL mp_bcast( qnorm, ionode_id, intra_image_comm)

      CALL mp_bcast( nks_start, ionode_id, intra_image_comm )
      IF (nks_start>0.and..NOT.ionode) THEN
         IF (.NOT.ALLOCATED(xk_start)) ALLOCATE(xk_start(3,nks_start))
         IF (.NOT.ALLOCATED(wk_start)) ALLOCATE(wk_start(nks_start))
      ENDIF
      IF (nks_start>0) THEN
         CALL mp_bcast( xk_start, ionode_id, intra_image_comm )
         CALL mp_bcast( wk_start, ionode_id, intra_image_comm )
      ENDIF
      CALL mp_bcast(  nrot, ionode_id, intra_image_comm )
      CALL mp_bcast(     s, ionode_id, intra_image_comm )
      CALL mp_bcast( sname, ionode_id, intra_image_comm )
      !
      lbz_read = .TRUE.
      !
      RETURN
      !
    END SUBROUTINE read_brillouin_zone
    !
    !------------------------------------------------------------------------
    SUBROUTINE read_occupations( ierr )
      !------------------------------------------------------------------------
      !
      USE lsda_mod,       ONLY : lsda, nspin
      USE fixed_occ,      ONLY : tfixed_occ, f_inp
      USE ktetra,         ONLY : ntetra, tetra, tetra_type
      USE klist,          ONLY : ltetra, lgauss, ngauss, degauss, smearing
      USE electrons_base, ONLY : nupdwn 
      USE wvfct,          ONLY : nbnd
      !
      IMPLICIT NONE
      !
      INTEGER,          INTENT(OUT) :: ierr
      CHARACTER(iotk_attlenx)  :: attr
      !
      INTEGER :: i
      LOGICAL :: found
      !
      ierr = 0
      IF ( locc_read ) RETURN
      !
      IF ( ionode ) THEN
         !
         ! necessary to don't send nbnd and nspin as input in read_occ
         IF ( .NOT. ALLOCATED( f_inp ) ) THEN
            !
            IF ( nspin == 4 ) THEN
               ALLOCATE( f_inp( nbnd, 1 ) )
            ELSE
               ALLOCATE( f_inp( nbnd, nspin ) )
            ENDIF
            !
         ENDIF
         !
         f_inp( :, :) = 0.0d0
         !
         CALL qexml_read_occ( LGAUSS=lgauss, NGAUSS=ngauss, DEGAUSS=degauss, &
                               LTETRA=ltetra, NTETRA=ntetra, TETRA_TYPE= tetra_type, TFIXED_OCC=tfixed_occ, &
                               NSTATES_UP=nupdwn(1), NSTATES_DW=nupdwn(2), INPUT_OCC=f_inp, IERR=ierr )
         !
      ENDIF
      !
      CALL mp_bcast( ierr, ionode_id, intra_image_comm )
      !
      IF ( ierr > 0 ) RETURN
      !
      IF ( ionode ) THEN
         !
         IF ( lgauss ) THEN
            !
            SELECT CASE (ngauss )
            CASE (0)
               smearing = 'gaussian'
            CASE (1)
               smearing = 'Methfessel-Paxton'
            CASE (-1)
               smearing = 'Marzari-Vanderbilt'
            CASE (-99)
               smearing = 'Fermi-Dirac'
            CASE DEFAULT
               CALL errore('read_occupations',&
                    'wrong smearing index', abs(1000+ngauss) )
            END SELECT
            !
            degauss = degauss * e2
            !
         ELSE
            !
            ngauss = 0
            degauss = 0.d0
            !
         END IF
         !
         IF ( .NOT. ltetra ) THEN
            !
            ntetra = 0
            !
         END IF
         !
         IF ( .NOT. tfixed_occ ) THEN
            !
            DEALLOCATE( f_inp )
            !
         ENDIF
         !
         !
      END IF
      !
      CALL mp_bcast( lgauss, ionode_id, intra_image_comm )
      !
      IF ( lgauss ) THEN
         !
         CALL mp_bcast( ngauss,  ionode_id, intra_image_comm )
         CALL mp_bcast( degauss, ionode_id, intra_image_comm )
         CALL mp_bcast( smearing, ionode_id, intra_image_comm )
         !
      END IF
      !
      CALL mp_bcast( ltetra, ionode_id, intra_image_comm )
      !
      IF ( ltetra ) THEN
         !
         CALL mp_bcast( ntetra, ionode_id, intra_image_comm )
         CALL mp_bcast( tetra_type, ionode_id, intra_image_comm )
         if(tetra_type == 0) CALL mp_bcast( tetra,  ionode_id, intra_image_comm )
         !
      END IF
      !
      CALL mp_bcast( tfixed_occ, ionode_id, intra_image_comm )
      !
      IF ( tfixed_occ ) THEN
         !
         CALL mp_bcast( nupdwn, ionode_id, intra_image_comm )
         !
         IF ( .NOT. ALLOCATED( f_inp ) ) THEN
            !
            IF ( nspin == 4 ) THEN
               ALLOCATE( f_inp( nbnd, 1 ) )
            ELSE
               ALLOCATE( f_inp( nbnd, nspin ) )
            END IF
            !
         ENDIF
         !
         CALL mp_bcast( f_inp, ionode_id, intra_image_comm )
         !
      ENDIF
      !
      locc_read = .TRUE.
      !
      RETURN
      !
    END SUBROUTINE read_occupations
    !
        
 
    !------------------------------------------------------------------------
    SUBROUTINE read_band_structure( dirname, ierr )
      !------------------------------------------------------------------------
      !
      !USE control_flags, ONLY : lkpoint_dir
      USE basis,    ONLY : natomwfc
      USE lsda_mod, ONLY : lsda, isk
      USE klist,    ONLY : nkstot, wk, nelec
      USE wvfct,    ONLY : et, wg, nbnd
      USE ener,     ONLY : ef, ef_up, ef_dw
      !
      IMPLICIT NONE
      !
      CHARACTER(LEN=*), INTENT(IN)  :: dirname
      INTEGER,          INTENT(OUT) :: ierr
      !
      INTEGER :: ik, ik_eff, num_k_points
      LOGICAL :: found, two_fermi_energies_
      CHARACTER(LEN=256) :: filename
      !
      ierr = 0
      IF ( lbs_read ) RETURN
      !
      IF ( .NOT. lspin_read ) &
         CALL errore( 'read_band_structure', 'read spin first', 1 )
      IF ( .NOT. lbz_read ) &
         CALL errore( 'read_band_structure', 'read band_structure first', 1 )
      !
      !
      IF ( ionode ) THEN
         ! we don't need to read nspin, noncolin
         CALL qexml_read_bands_info( NBND=nbnd, NUM_K_POINTS=num_k_points, NATOMWFC=natomwfc, &
                                     NELEC=nelec, EF=ef, TWO_FERMI_ENERGIES=two_fermi_energies_, &
                                     EF_UP=ef_up, EF_DW=ef_dw, IERR=ierr )
         !
      ENDIF
      !
      CALL mp_bcast( ierr, ionode_id, intra_image_comm )
      !
      IF ( ierr > 0 ) RETURN
      !
      IF ( ionode ) THEN
         IF ( .NOT. two_fermi_energies_) THEN
            ef = ef * e2
         ELSE
            ef = 0.d0
            ef_up = ef_up * e2
            ef_dw = ef_dw * e2
         END IF
         !
      END IF
      !
      num_k_points = nkstot
      !
      IF ( lsda ) num_k_points = nkstot / 2
      !
      IF ( ionode ) THEN
         !
         IF (.NOT.lkpoint_dir) filename = TRIM( dirname ) // '/' // TRIM( xmlpun )//'.eig'
         !
         CALL qexml_read_bands_pw( num_k_points, nbnd, nkstot, lsda, lkpoint_dir, filename , ISK=isk, ET=et, WG=wg , IERR=ierr)
         !
         et(:,:) = et(:,:) * e2
         !
         FORALL( ik = 1:nkstot ) wg(:,ik) = wg(:,ik)*wk(ik)
         !
      END IF
      !
      CALL mp_bcast( ierr, ionode_id, intra_image_comm )
      !
      IF ( ierr > 0 ) RETURN
      !
      CALL mp_bcast( nelec,    ionode_id, intra_image_comm )
      CALL mp_bcast( natomwfc, ionode_id, intra_image_comm )
      CALL mp_bcast( nbnd,     ionode_id, intra_image_comm )
      CALL mp_bcast( isk,      ionode_id, intra_image_comm )
      CALL mp_bcast( et,       ionode_id, intra_image_comm )
      CALL mp_bcast( wg,       ionode_id, intra_image_comm )
      CALL mp_bcast( ef,       ionode_id, intra_image_comm )
      !
      lbs_read = .TRUE.
      !
      RETURN
      !
    END SUBROUTINE read_band_structure
    !
    !------------------------------------------------------------------------
    SUBROUTINE read_wavefunctions( dirname, ierr )
      !------------------------------------------------------------------------
      !
      ! ... This routines reads wavefunctions from the new file format and
      ! ... writes them into the old format
      !
      !USE control_flags,        ONLY : twfcollect, lkpoint_dir
      USE cell_base,            ONLY : tpiba2
      USE lsda_mod,             ONLY : nspin, isk
      USE klist,                ONLY : nkstot, wk, nks, xk, ngk
      USE wvfct,                ONLY : npw, npwx, et, wg, nbnd
      USE gvecw,                ONLY : ecutwfc
      !USE wavefunctions_module, ONLY : evc
      USE wavefunctions, ONLY : evc
      USE io_files,             ONLY : nwordwfc, iunwfc
      USE buffers,              ONLY : save_buffer
      USE gvect,                ONLY : ngm, ngm_g, g, ig_l2g
      USE noncollin_module,     ONLY : noncolin, npol
      USE mp_images,            ONLY : nproc_image, intra_image_comm
      USE mp_pools,             ONLY : kunit, nproc_pool, me_pool, root_pool, &
                                       intra_pool_comm, inter_pool_comm
      USE mp_bands,             ONLY : me_bgrp, nbgrp, root_bgrp, &
                                       intra_bgrp_comm
      !
#if defined __HDF5
      USE hdf5_qe,              ONLY : evc_hdf5_write, read_attributes_hdf5, &
                                       prepare_for_reading_final
      USE mp_pools,             ONLY : inter_pool_comm
#endif

      IMPLICIT NONE
      !
      CHARACTER(LEN=*), INTENT(IN)  :: dirname
      INTEGER,          INTENT(OUT) :: ierr
      !
      CHARACTER(LEN=256)   :: filename
      INTEGER              :: ik, ipol, ik_eff, num_k_points
      INTEGER, ALLOCATABLE :: kisort(:)
      INTEGER              :: nkl, nkr, npwx_g
      INTEGER              :: nupdwn(2), ike, iks, npw_g, ispin
      INTEGER, EXTERNAL    :: global_kpoint_index
      INTEGER, ALLOCATABLE :: ngk_g(:)
      INTEGER, ALLOCATABLE :: igk_l2g(:,:), igk_l2g_kdip(:,:)
      LOGICAL              :: opnd
      REAL(DP),ALLOCATABLE :: gk(:)
      REAL(DP)             :: scalef

      !
      ! The ierr output var is actually not given any value
      ! except this initialization
      !
      ierr = 0
      !
      iks = global_kpoint_index (nkstot, 1)
      ike = iks + nks - 1
      !
      ! ... find out the global number of G vectors: ngm_g  
      !
      ngm_g = ngm
      !
      CALL mp_sum( ngm_g, intra_bgrp_comm )
      !
      ! ... build the igk_l2g array, yielding the correspondence between
      ! ... the local k+G index and the global G index - see also ig_l2g
      !
      ALLOCATE ( igk_l2g( npwx, nks ) )
      igk_l2g = 0
      !
      ALLOCATE( kisort( npwx ), gk(npwx) )
      !
      DO ik = 1, nks
         !
         kisort = 0
         npw    = npwx
         !
         CALL gk_sort( xk(1,ik+iks-1), ngm, g, &
                       ecutwfc/tpiba2, npw, kisort(1), gk )
         !
         CALL gk_l2gmap( ngm, ig_l2g(1), npw, kisort(1), igk_l2g(1,ik) )
         !
         ngk(ik) = npw
         !
      END DO
      !
      DEALLOCATE( gk, kisort )
      !
      ! ... compute the global number of G+k vectors for each k point
      !
      ALLOCATE( ngk_g( nkstot ) )
      !
      ngk_g = 0
      ngk_g(iks:ike) = ngk(1:nks)
      !
      CALL mp_sum( ngk_g, inter_pool_comm )
      CALL mp_sum( ngk_g, intra_pool_comm )
      ngk_g = ngk_g / nbgrp
      !
      ! ... compute the Maximum G vector index among all G+k an processors
      !
      npw_g = MAXVAL( igk_l2g(:,:) )
      !
      CALL mp_max( npw_g, inter_pool_comm )
      CALL mp_max( npw_g, intra_pool_comm )

      !
      ! ... compute the Maximum number of G vector among all k points
      !
      npwx_g = MAXVAL( ngk_g(1:nkstot) )
      !
      ! 
      ! ... define a further l2g map to read gkvectors and wfc coherently 
      ! 
      ALLOCATE( igk_l2g_kdip( npwx_g, nks ) )
      igk_l2g_kdip = 0
      !
      DO ik = iks, ike
         !
         CALL gk_l2gmap_kdip( npw_g, ngk_g(ik), ngk(ik-iks+1), &
                              igk_l2g(1,ik-iks+1), igk_l2g_kdip(1,ik-iks+1) )
      END DO
      !
      !
      IF ( ionode ) THEN
         !
         CALL iotk_scan_begin( iunpun, "EIGENVECTORS" )
         !
      END IF
      !
      num_k_points = nkstot
      !
      IF ( nspin == 2 ) num_k_points = nkstot / 2
      !
      k_points_loop: DO ik = 1, num_k_points
         !
         IF ( ionode ) THEN
            !
            CALL iotk_scan_begin( iunpun, "K-POINT" // TRIM( iotk_index( ik ) ) )
            !
            IF ( nspin == 2 .OR. noncolin ) THEN
                !
                CALL iotk_scan_begin( iunpun, "WFC.1", FOUND = twfcollect  )
                IF ( twfcollect ) CALL iotk_scan_end( iunpun, "WFC.1" )
                !
            ELSE
                !
                CALL iotk_scan_begin( iunpun, "WFC", FOUND = twfcollect  )
                IF ( twfcollect ) CALL iotk_scan_end( iunpun, "WFC" )
                !
            ENDIF
            !
         END IF
         !
         CALL mp_bcast( twfcollect, ionode_id, intra_image_comm )
         !
         IF ( .NOT. twfcollect ) THEN
            !
            IF ( ionode ) THEN
               !
               CALL iotk_scan_end( iunpun, &
                                   "K-POINT" // TRIM( iotk_index( ik ) ) )
               !
            END IF
            !
            EXIT k_points_loop
            !
         END IF
         !
         IF ( nspin == 2 ) THEN
            !
            ispin = 1 
            evc=(0.0_DP, 0.0_DP)
            !
            ! ... no need to read isk here: they are read from band structure
            ! ... and correctly distributed across pools in read_file
            !!! isk(ik) = 1
            !
            IF ( ionode ) THEN
               !
               filename = TRIM( qexml_wfc_filename( dirname, 'evc', ik, ispin, &
                                  DIR=lkpoint_dir ) )
               !
            END IF
            !
            CALL read_wfc( iunout, ik, nkstot, kunit, ispin, nspin,      &
                           evc, npw_g, nbnd, igk_l2g_kdip(:,ik-iks+1),   &
                           ngk(ik-iks+1), filename, scalef, &
                           ionode, root_pool, intra_pool_comm, inter_pool_comm, intra_image_comm )
            !
            IF ( ( ik >= iks ) .AND. ( ik <= ike ) ) THEN
               !
               CALL save_buffer ( evc, nwordwfc, iunwfc, (ik-iks+1) )
               !
            END IF
            !
            ispin = 2
            ik_eff = ik + num_k_points
            evc=(0.0_DP, 0.0_DP)
            !
            ! ... no need to read isk here (see above why)
            !isk(ik_eff) = 2
            !
            IF ( ionode ) THEN
               !
               filename = TRIM( qexml_wfc_filename( dirname, 'evc', ik, ispin, &
                                DIR=lkpoint_dir ) )
               !
            END IF
            !
            CALL read_wfc( iunout, ik_eff, nkstot, kunit, ispin, nspin,      &
                           evc, npw_g, nbnd, igk_l2g_kdip(:,ik_eff-iks+1),   &
                           ngk(ik_eff-iks+1), filename, scalef, &
                           ionode, root_pool, intra_pool_comm, inter_pool_comm, intra_image_comm )
            !
            IF ( ( ik_eff >= iks ) .AND. ( ik_eff <= ike ) ) THEN
               !
               CALL save_buffer ( evc, nwordwfc, iunwfc, (ik_eff-iks+1) )
               !
            END IF
            !
         ELSE
            !
            ! ... no need to read isk here (see above why)
            !isk(ik) = 1
            !
            evc=(0.0_DP, 0.0_DP)
            IF ( noncolin ) THEN
               !
               DO ipol = 1, npol
                  !
                  IF ( ionode ) THEN
                     !
                     filename = TRIM( qexml_wfc_filename( dirname, 'evc', ik, ipol, &
                                         DIR=lkpoint_dir ) )
                     !
                  END IF
                  !
                  !!! TEMP
                  nkl=(ipol-1)*npwx+1
                  nkr= ipol   *npwx
                  CALL read_wfc( iunout, ik, nkstot, kunit, ispin,          &
                                 npol, evc(nkl:nkr,:), npw_g, nbnd,         &
                                 igk_l2g_kdip(:,ik-iks+1), ngk(ik-iks+1),   &
                                 filename, scalef, & 
                                 ionode, root_pool, intra_pool_comm, inter_pool_comm, intra_image_comm )
                  !
               END DO
               !
            ELSE
               !
               IF ( ionode ) THEN
                  !
                  filename = TRIM( qexml_wfc_filename( dirname, 'evc', ik, &
                                         DIR=lkpoint_dir ) )
                  !
               END IF
               !
               ! workaround for pot parallelization ( Viet Nguyen / SdG )
               ! -pot parallelization uses mp_image communicators
               ! note that ionode must be also reset in the similar way 
               ! to image parallelization
               CALL read_wfc( iunout, ik, nkstot, kunit, ispin, nspin,         &
                              evc, npw_g, nbnd, igk_l2g_kdip(:,ik-iks+1),      &
                              ngk(ik-iks+1), filename, scalef, &
                              ionode, root_pool, intra_pool_comm, inter_pool_comm, intra_image_comm )
               !
            END IF
            !
            IF ( ( ik >= iks ) .AND. ( ik <= ike ) ) THEN
               !
               CALL save_buffer ( evc, nwordwfc, iunwfc, (ik-iks+1) )
               !
               ! the following two line can be used to debug read_wfc
               ! WRITE(200+10*ik+me_pool,fmt="(2D18.10)") evc
               ! CLOSE(200+10*ik+me_pool )
               !
            END IF
            !
         END IF
         !
         IF ( ionode ) THEN
            !
            CALL iotk_scan_end( iunpun, "K-POINT" // TRIM( iotk_index( ik ) ) )
            !
         END IF
         !
      END DO k_points_loop
      !
      DEALLOCATE ( igk_l2g )
      DEALLOCATE ( igk_l2g_kdip )
      !
      IF ( ionode ) THEN
         !
         CALL iotk_scan_end( iunpun, "EIGENVECTORS" )
         !
         !CALL iotk_close_read( iunpun )
         !
      END IF
      !
      RETURN
      !
    END SUBROUTINE read_wavefunctions
    !
    !------------------------------------------------------------------------
    SUBROUTINE read_ef( ierr )
      !------------------------------------------------------------------------
      !
      ! ... this routine reads the Fermi energy and the number of electrons
      !
      USE ener,  ONLY : ef, ef_up, ef_dw
      USE klist, ONLY : two_fermi_energies, nelec
      !
      IMPLICIT NONE
      INTEGER, INTENT(OUT) :: ierr
      !
      ! ... then selected tags are read from the other sections
      !
      IF ( ionode ) THEN
         !
         CALL qexml_read_bands_info( EF = ef, EF_UP=ef_up, EF_DW=ef_dw, &
            TWO_FERMI_ENERGIES=two_fermi_energies, NELEC=nelec, IERR=ierr )
         !
      END IF
      !
      CALL mp_bcast( ierr, ionode_id, intra_image_comm )
      IF ( ierr > 0 ) RETURN
      !
      IF (ionode) THEN
         !
         IF (.NOT. two_fermi_energies) THEN
            ef = ef * e2
            ef_up = 0.d0
            ef_dw = 0.d0
         ELSE
            ef = 0.d0
            ef_up = ef_up * e2
            ef_dw = ef_dw * e2
         END IF
         !
      END IF
      !
      CALL mp_bcast( two_fermi_energies, ionode_id, intra_image_comm )
      CALL mp_bcast( ef, ionode_id, intra_image_comm )
      CALL mp_bcast( ef_up, ionode_id, intra_image_comm )
      CALL mp_bcast( ef_dw, ionode_id, intra_image_comm )
      CALL mp_bcast( nelec, ionode_id, intra_image_comm )
      !
      RETURN
      !
    END SUBROUTINE read_ef
    !
    !------------------------------------------------------------------------
    SUBROUTINE read_exx( ierr )
      !------------------------------------------------------------------------
      !
      ! ... read EXX variables
      !
      USE funct,                ONLY : set_exx_fraction, set_screening_parameter, &
                                       set_gau_parameter, enforce_input_dft, start_exx
      USE exx_base,             ONLY : x_gamma_extrapolation, nq1, nq2, nq3, &
                                       exxdiv_treatment, yukawa, ecutvcut 
      USE exx,                  ONLY : ecutfock
      IMPLICIT NONE
      !
      INTEGER,          INTENT(OUT) :: ierr
      REAL(DP) :: exx_fraction, screening_parameter, gau_parameter
      LOGICAL :: exx_is_active, found
      !
      IF ( ionode ) THEN
         CALL qexml_read_exx( X_GAMMA_EXTRAPOLATION=x_gamma_extrapolation, &
              NQX1=nq1, NQX2=nq2, NQX3=nq3, EXXDIV_TREATMENT=exxdiv_treatment, &
              YUKAWA = yukawa, ECUTVCUT=ecutvcut, EXX_FRACTION=exx_fraction, &
              SCREENING_PARAMETER=screening_parameter, GAU_PARAMETER=gau_parameter, &
              EXX_IS_ACTIVE=exx_is_active, ECUTFOCK=ecutfock, FOUND=found, IERR=ierr )
         !
      ENDIF
      !
      CALL mp_bcast( ierr, ionode_id, intra_image_comm )
      IF ( ierr > 0 ) RETURN
      !
      CALL mp_bcast( found, ionode_id, intra_image_comm )
      !
      IF ( .NOT. found ) RETURN
      !
      CALL mp_bcast( x_gamma_extrapolation, ionode_id, intra_image_comm )
      CALL mp_bcast( nq1, ionode_id, intra_image_comm )
      CALL mp_bcast( nq2, ionode_id, intra_image_comm )
      CALL mp_bcast( nq3, ionode_id, intra_image_comm )
      CALL mp_bcast( exxdiv_treatment, ionode_id, intra_image_comm )
      CALL mp_bcast( yukawa, ionode_id, intra_image_comm )
      CALL mp_bcast( ecutvcut, ionode_id, intra_image_comm )
      CALL mp_bcast( exx_fraction, ionode_id, intra_image_comm )
      CALL mp_bcast( screening_parameter, ionode_id, intra_image_comm )
      CALL mp_bcast( gau_parameter, ionode_id, intra_image_comm )
      CALL mp_bcast( exx_is_active, ionode_id, intra_image_comm )
      CALL mp_bcast( ecutfock, ionode_id, intra_image_comm )
      !
      CALL set_exx_fraction(exx_fraction)
      CALL set_screening_parameter(screening_parameter)
      CALL set_gau_parameter(gau_parameter)
      IF (exx_is_active) CALL start_exx( ) 
      !
      RETURN
      !
    END SUBROUTINE read_exx
    !
    !------------------------------------------------------------------------
    SUBROUTINE read_esm( ierr )
      !------------------------------------------------------------------------
      !
      ! ... this routine reads only nelec and ef
      !
      USE esm, ONLY : esm_nfit, esm_efield, esm_w, esm_a, esm_bc
      !
      IMPLICIT NONE
      INTEGER, INTENT(OUT) :: ierr
      !
      ! ... then selected tags are read from the other sections
      !
      IF ( ionode ) THEN
         !
         CALL qexml_read_esm( ESM_NFIT = esm_nfit, ESM_EFIELD = esm_efield, &
           ESM_W = esm_w, ESM_A = esm_a, ESM_BC = esm_bc, IERR=ierr )
         !
      END IF
      !
      CALL mp_bcast( ierr, ionode_id, intra_image_comm )
      IF ( ierr > 0 ) RETURN
      !
      CALL mp_bcast( esm_nfit,    ionode_id, intra_image_comm )
      CALL mp_bcast( esm_efield,  ionode_id, intra_image_comm )
      CALL mp_bcast( esm_w,       ionode_id, intra_image_comm )
      CALL mp_bcast( esm_a,       ionode_id, intra_image_comm )
      CALL mp_bcast( esm_bc,      ionode_id, intra_image_comm )
      !
      RETURN
      !
    END SUBROUTINE read_esm
    !
    !------------------------------------------------------------------------
    SUBROUTINE read_( dirname, ierr )
      !------------------------------------------------------------------------
      !
      ! ... this is a template for a "read section" subroutine
      !
      IMPLICIT NONE
      !
      CHARACTER(LEN=*), INTENT(IN)  :: dirname
      INTEGER,          INTENT(OUT) :: ierr
      !
      INTEGER :: idum
      !
      !
      IF ( ionode ) THEN
         !
         CALL iotk_open_read( iunpun, FILE = TRIM( dirname ) // '/' // &
                            & TRIM( xmlpun ), IERR = ierr )
         !
      END IF
      !
      CALL mp_bcast( ierr, ionode_id, intra_image_comm )
      !
      IF ( ierr > 0 ) RETURN
      !
      IF ( ionode ) THEN
         !
         CALL iotk_scan_begin( iunpun, "" )
         !
         CALL iotk_scan_end( iunpun, "" )
         !
         CALL iotk_close_read( iunpun )
         !
      END IF
      !
      CALL mp_bcast( idum, ionode_id, intra_image_comm )
      !
      RETURN
      !
    END SUBROUTINE read_
    !
    !----------------------------------------------------------------------------
    SUBROUTINE gk_l2gmap( ngm, ig_l2g, ngk, igk, igk_l2g )
      !----------------------------------------------------------------------------
      !
      ! ... This subroutine maps local G+k index to the global G vector index
      ! ... the mapping is used to collect wavefunctions subsets distributed
      ! ... across processors.
      ! ... Written by Carlo Cavazzoni
      !
      IMPLICIT NONE
      !
      ! ... Here the dummy variables
      !
      INTEGER, INTENT(IN)  :: ngm, ngk, igk(ngk), ig_l2g(ngm)
      INTEGER, INTENT(OUT) :: igk_l2g(ngk)
      INTEGER              :: ig
      !
      ! ... input: mapping between local and global G vector index
      !
      DO ig = 1, ngk
         !
         igk_l2g(ig) = ig_l2g(igk(ig))
         !
      END DO
      !
      RETURN
      !
    END SUBROUTINE gk_l2gmap
    !
    !-----------------------------------------------------------------------
    SUBROUTINE gk_l2gmap_kdip( npw_g, ngk_g, ngk, igk_l2g, igk_l2g_kdip, igwk )
      !-----------------------------------------------------------------------
      !
      ! ... This subroutine maps local G+k index to the global G vector index
      ! ... the mapping is used to collect wavefunctions subsets distributed
      ! ... across processors.
      ! ... This map is used to obtained the G+k grids related to each kpt
      !
      IMPLICIT NONE
      !
      ! ... Here the dummy variables
      !
      INTEGER,           INTENT(IN)  :: npw_g, ngk_g, ngk
      INTEGER,           INTENT(IN)  :: igk_l2g(ngk)
      INTEGER, OPTIONAL, INTENT(OUT) :: igwk(ngk_g), igk_l2g_kdip(ngk)
      !
      INTEGER, ALLOCATABLE :: igwk_(:), itmp(:), igwk_lup(:)
      INTEGER              :: ig, ig_, ngg
      !
      !
      ALLOCATE( itmp( npw_g ) )
      ALLOCATE( igwk_( ngk_g ) )
      !
      itmp(:)  = 0
      igwk_(:) = 0
      !
      !
      DO ig = 1, ngk
         !
         itmp(igk_l2g(ig)) = igk_l2g(ig)
         !
      END DO
      
      !
      CALL mp_sum( itmp, intra_bgrp_comm )
      !
      ngg = 0
      DO ig = 1, npw_g
         !
         IF ( itmp(ig) == ig ) THEN
            !
            ngg = ngg + 1
            !
            igwk_(ngg) = ig
            !
         END IF
         !
      END DO
      !
      IF ( ngg /= ngk_g ) &
         CALL errore( 'gk_l2gmap_kdip', 'unexpected dimension in ngg', 1 )
      !
      IF ( PRESENT( igwk ) ) THEN
         !
         igwk(1:ngk_g) = igwk_(1:ngk_g)
         !
      END IF
      !
      IF ( PRESENT( igk_l2g_kdip ) ) THEN
         !
         ALLOCATE( igwk_lup( npw_g ) )
         !
!$omp parallel private(ig_, ig)
!$omp workshare
         igwk_lup = 0
!$omp end workshare
!$omp do
         do ig_ = 1, ngk_g
            igwk_lup(igwk_(ig_)) = ig_
         end do
!$omp end do
!$omp do
         do ig = 1, ngk
            igk_l2g_kdip(ig) = igwk_lup(igk_l2g(ig))
         end do
!$omp end do
!$omp end parallel
         !
         DEALLOCATE( igwk_lup )

      END IF
      !
      DEALLOCATE( itmp, igwk_ )
      !
      RETURN
      !
    END SUBROUTINE gk_l2gmap_kdip
    !------------------------------------------------------------------------
    FUNCTION pp_check_file()
      !------------------------------------------------------------------------
      !
      USE io_global,         ONLY : ionode, ionode_id
      USE mp_images,         ONLY : intra_image_comm
      USE control_flags,     ONLY : tqr, tq_smoothing, tbeta_smoothing
      !
      IMPLICIT NONE
      !
      LOGICAL            :: pp_check_file
      CHARACTER(LEN=256) :: dirname, filename
      INTEGER            :: ierr
      LOGICAL            :: lval, found, back_compat
      !
      !
      dirname  = TRIM( tmp_dir ) // TRIM( prefix ) // postfix
      filename = TRIM( dirname ) // TRIM( xmlpun )
      !
      IF ( ionode ) &
         CALL iotk_open_read( iunpun, FILE = filename, IERR = ierr )
      !
      CALL mp_bcast ( ierr, ionode_id, intra_image_comm )
      !
      CALL errore( 'pp_check_file', 'file ' // &
                 & TRIM( dirname ) // ' not found', ierr )
      !
      ! set a flag for back compatibility (before fmt v1.4.0)
      !
      back_compat = .FALSE.
      !
      IF ( TRIM( version_compare( qexml_version, "1.4.0" )) == "older") &
         back_compat = .TRUE.
      !
      IF ( ionode ) THEN
         !
         IF ( .NOT. back_compat ) THEN
             !
             CALL iotk_scan_begin( iunpun, "CONTROL" ) 
             !
         ENDIF
         !
         CALL iotk_scan_dat( iunpun, "PP_CHECK_FLAG", lval, FOUND = found)
         !
         IF ( .NOT. found ) lval = .FALSE. 
         !
         CALL iotk_scan_dat( iunpun, "LKPOINT_DIR", lkpoint_dir, FOUND = found)
         !
         IF ( .NOT. found ) lkpoint_dir = .TRUE. 
         !
         CALL iotk_scan_dat( iunpun, "Q_REAL_SPACE", tqr, FOUND = found)
         !
         IF ( .NOT. found ) tqr = .FALSE. 
         !
         CALL iotk_scan_dat( iunpun, "TQ_SMOOTHING", tq_smoothing, FOUND = found)
         !
         IF ( .NOT. found ) tq_smoothing = .FALSE. 
         !
         CALL iotk_scan_dat( iunpun, "TBETA_SMOOTHING", tbeta_smoothing, FOUND = found)
         !
         IF ( .NOT. found ) tbeta_smoothing = .FALSE. 
         !
         IF ( .NOT. back_compat ) THEN
             !
             CALL iotk_scan_end( iunpun, "CONTROL" ) 
             !
         ENDIF
         !
         CALL iotk_close_read( iunpun )
         !
      END IF
      !
      CALL mp_bcast( lval, ionode_id, intra_image_comm )
      !
      CALL mp_bcast( lkpoint_dir, ionode_id, intra_image_comm )
      !
      CALL mp_bcast( tqr, ionode_id, intra_image_comm )
      !
      CALL mp_bcast( tq_smoothing, ionode_id, intra_image_comm )
      !
      CALL mp_bcast( tbeta_smoothing, ionode_id, intra_image_comm )
      !
      pp_check_file = lval
      !
      RETURN
      !
    END FUNCTION pp_check_file
    !
#endif
    !
END MODULE oldxml_pw_restart

MODULE qepy_common
   USE kinds,                ONLY : DP
   IMPLICIT NONE
   PRIVATE
   !
   PUBLIC :: arr2pointer, allocate_extpot, allocate_extforces
   !
   type, public :: input_base
      INTEGER            :: my_world_comm = 0
      LOGICAL            :: start_images = .false.
      CHARACTER(len=256) :: filename = ''
      CHARACTER(len=256) :: code = 'QEPY'
      CHARACTER(len=256) :: tmp_dir = './'
      CHARACTER(len=256) :: wfc_dir = 'undefined'
      CHARACTER(len=256) :: prefix  = 'os'
      ! ...  If needwf=.t. performs wavefunction-related initialization as well
      LOGICAL            :: needwf
   end type input_base
   !
   type, public :: tddft_base
      logical                         :: initial = .true.
      logical                         :: finish = .false.
      integer                         :: istep = 0
      integer                         :: nstep = 1
      logical                         :: iterative = .false.
      real(kind=dp), allocatable      :: dipole(:,:)
   end type tddft_base
   !
   type, public :: energies_base
      real(kind=dp)                   :: etot           !'Total energy'
      real(kind=dp)                   :: ek             !'Kinetic energy'
      real(kind=dp)                   :: eloc           !'Local energy'
      real(kind=dp)                   :: enl            !'Non-Local energy'
      real(kind=dp)                   :: ewld           !'Ewald energy'
      real(kind=dp)                   :: exc            !'xc contribution'
      real(kind=dp)                   :: ehart          !'hartree energy'
      real(kind=dp)                   :: fock2          !'EXX energy'
      real(kind=dp)                   :: demet          !'Smearing (-TS)'
      real(kind=dp)                   :: elondon        !'Dispersion Correction'
      real(kind=dp)                   :: edftd3         !'DFT-D3 Dispersion'
      real(kind=dp)                   :: exdm           !'Dispersion XDM Correction'
      real(kind=dp)                   :: etsvdw         !'Dispersion T-S Correction'
      real(kind=dp)                   :: eext           !'External forces energy'
      real(kind=dp)                   :: etotefield     !'electric field correction'
      real(kind=dp)                   :: etotgatefield  !'gate field correction'
      real(kind=dp)                   :: eth            !'Hubbard energy'
      real(kind=dp)                   :: epaw           !'one-center paw contrib.'
      real(kind=dp)                   :: ept            !'potentiostat contribution'
      !
      real(kind=dp)                   :: extene         !'External energy0'
      real(kind=dp)                   :: ehf            !'Harris-Foulkes estimate'
      ! some energies details -->
      real(kind=dp)                   :: etxc           ! the exchange and correlation energy
      real(kind=dp)                   :: etxcc          ! the nlcc exchange and correlation
      real(kind=dp)                   :: paw_ehart_ae   !'PAW hartree energy AE'
      real(kind=dp)                   :: paw_ehart_ps   !'PAW hartree energy PS'
      real(kind=dp)                   :: paw_exc_ae     !'PAW xc energy AE'
      real(kind=dp)                   :: paw_exc_ps     !'PAW xc energy PS'
      ! <--
   end type energies_base
   !
   type, public :: embed_base
      type(input_base)                :: input
      type(tddft_base)                :: tddft
      type(energies_base)             :: energies
      real(kind=dp), allocatable      :: extpot(:,:)
      real(kind=dp)                   :: extene = 0.0
      integer                         :: exttype = 0
      real(kind=dp), allocatable      :: extforces(:,:)
      real(kind=dp)                   :: extstress(3,3)
      logical                         :: initial = .true.
      real(kind=dp)                   :: mix_coef = -1.0
      logical                         :: finish = .false.
      real(kind=dp)                   :: etotal = 0.0
      real(kind=dp)                   :: dnorm = 1.0
      logical                         :: lewald = .true.
      logical                         :: nlpp = .true.
      real(kind=dp)                   :: diag_conv = 1.D-2
      logical                         :: ldescf = .false.
      !! add scf correction energy
      logical                         :: iterative = .false.
      !! add correction for variational energy
      logical                         :: lmovecell = .false.
      !! allow change the cell
      logical                         :: oldxml = .false.
      !! Olderversion QE (XML file name is 'data-file.xml')
   CONTAINS
      !--------------------------------------------------------------------------------
      PROCEDURE :: allocate_extpot => allocate_extpot_class
      PROCEDURE :: allocate_extforces => allocate_extforces_class
   end type embed_base
   !
   !
   TYPE ( embed_base ), public :: messenger
   !
   !
   INTERFACE arr2pointer
      MODULE PROCEDURE arr2pointer_real_1, arr2pointer_real_2, arr2pointer_real_3, arr2pointer_real_4
   END INTERFACE
   !
CONTAINS
   !
   SUBROUTINE allocate_extpot_class(embed)
      USE kinds,                ONLY : DP
      USE fft_base,             ONLY : dfftp
      USE lsda_mod,             ONLY : lsda, nspin
      !
      IMPLICIT NONE
      CLASS(embed_base), INTENT(INOUT) :: embed
      !
      CALL allocate_extpot(embed)
      !
   END SUBROUTINE
   !
   SUBROUTINE allocate_extpot(embed)
      USE kinds,                ONLY : DP
      USE fft_base,             ONLY : dfftp
      USE lsda_mod,             ONLY : lsda, nspin
      !
      IMPLICIT NONE
      TYPE(embed_base), INTENT(INOUT) :: embed
      !
      IF (ALLOCATED(embed%extpot)) THEN
         IF (SIZE(embed%extpot, 1) /= dfftp%nnr) DEALLOCATE(embed%extpot)
      ENDIF
      IF (.NOT.ALLOCATED(embed%extpot)) THEN
         ALLOCATE(embed%extpot(dfftp%nnr, nspin))
         embed%extpot = 0.0_DP
      ENDIF
   END SUBROUTINE
   !
   SUBROUTINE allocate_extforces_class(embed)
      USE kinds,                ONLY : DP
      USE fft_base,             ONLY : dfftp
      USE ions_base,            ONLY : nat
      !
      IMPLICIT NONE
      CLASS(embed_base), INTENT(INOUT) :: embed
      !
      CALL allocate_extforces(embed)
      !
   END SUBROUTINE
   !
   SUBROUTINE allocate_extforces(embed)
      USE kinds,                ONLY : DP
      USE fft_base,             ONLY : dfftp
      USE ions_base,            ONLY : nat
      !
      IMPLICIT NONE
      TYPE(embed_base), INTENT(INOUT) :: embed
      !
      IF (ALLOCATED(embed%extforces)) THEN
         IF (SIZE(embed%extforces,2) /= nat) DEALLOCATE(embed%extforces)
      ENDIF
      IF (.NOT.ALLOCATED(embed%extforces)) THEN
         ALLOCATE(embed%extforces(3, nat))
         embed%extforces = 0.0_DP
      ENDIF
   END SUBROUTINE
   !
   SUBROUTINE arr2pointer_real_1(arr, p, n1)
      USE kinds,                ONLY : DP
      !
      IMPLICIT NONE
      REAL(DP), INTENT(IN), TARGET :: arr(n1)
      REAL(DP), POINTER :: p(:)
      INTEGER,INTENT(IN) :: n1
      !
      p => arr
      !
   END SUBROUTINE
   !
   SUBROUTINE arr2pointer_real_2(arr, p, n1, n2)
      USE kinds,                ONLY : DP
      !
      IMPLICIT NONE
      REAL(DP), INTENT(IN), TARGET :: arr(n1, n2)
      REAL(DP), POINTER :: p(:,:)
      INTEGER,INTENT(IN) :: n1,n2
      !
      p => arr
      !
   END SUBROUTINE
   !
   SUBROUTINE arr2pointer_real_3(arr, p, n1, n2, n3)
      USE kinds,                ONLY : DP
      !
      IMPLICIT NONE
      REAL(DP), INTENT(IN), TARGET :: arr(n1, n2, n3)
      REAL(DP), POINTER :: p(:,:,:)
      INTEGER,INTENT(IN) :: n1,n2,n3
      !
      p => arr
      !
   END SUBROUTINE
   !
   SUBROUTINE arr2pointer_real_4(arr, p, n1, n2, n3, n4)
      USE kinds,                ONLY : DP
      !
      IMPLICIT NONE
      REAL(DP), INTENT(IN), TARGET :: arr(n1, n2, n3, n4)
      REAL(DP), POINTER :: p(:,:,:,:)
      INTEGER,INTENT(IN) :: n1,n2,n3,n4
      !
      p => arr
      !
   END SUBROUTINE
   !
END MODULE qepy_common

!
! Copyright (C) 2005-2014 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
!----------------------------------------------------------------------------
MODULE oldxml_xml_io_base
  !----------------------------------------------------------------------------
  !
  ! ... this module contains some common subroutines used to read and write
  ! ... in XML format the data produced by Quantum ESPRESSO package
  !
  ! ... written by Carlo Sbraccia (2005)
  ! ... modified by Andrea Ferretti (2006-08)
  !
  USE iotk_module
  !
  USE kinds,     ONLY : DP
  !USE io_files,  ONLY : tmp_dir, prefix, iunpun, xmlpun, check_file_exist, &
  USE io_files,  ONLY : tmp_dir, prefix, iunpun, check_file_exist, &
       create_directory
  USE io_global, ONLY : ionode, ionode_id, stdout
  USE mp,        ONLY : mp_bcast, mp_sum, mp_get, mp_put, mp_max, mp_rank, &
       mp_size
  USE parser,    ONLY : version_compare
  !
  IMPLICIT NONE
  PRIVATE
  !
  CHARACTER(iotk_attlenx)  :: attr
  LOGICAL,       SAVE      :: rho_binary = .TRUE.
  !
  CHARACTER (LEN=13), PARAMETER :: xmlpun      = 'data-file.xml'
  CHARACTER(len=256) :: qexml_version = ' '       ! the format of the current qexml datafile 
  LOGICAL            :: qexml_version_init = .FALSE.  ! whether the fmt has been read or not
  !
  PUBLIC :: xmlpun, qexml_version, qexml_version_init
  PUBLIC :: rho_binary
  PUBLIC :: attr
  !
  PUBLIC :: read_wfc, write_wfc, read_rho, write_rho, &
       save_print_counter, read_print_counter, restart_dir
  !
  CONTAINS
    !
    !------------------------------------------------------------------------
    FUNCTION restart_dir( outdir, runit )
      !------------------------------------------------------------------------
      !
      ! KNK_nimage
      ! USE mp_images, ONLY:  my_image_id
      CHARACTER(LEN=256)           :: restart_dir
      CHARACTER(LEN=*), INTENT(IN) :: outdir
      INTEGER,          INTENT(IN) :: runit
      !
      CHARACTER(LEN=256)         :: dirname
      INTEGER                    :: strlen
      CHARACTER(LEN=6), EXTERNAL :: int_to_char
      !
      ! ... main restart directory
      !
      dirname = TRIM( prefix ) // '_' // TRIM( int_to_char( runit ) )// '.save/'
      !
      IF ( LEN( outdir ) > 1 ) THEN
         !
         strlen = INDEX( outdir, ' ' ) - 1
         !
         dirname = outdir(1:strlen) // '/' // dirname
         !
      END IF
      !
      restart_dir = TRIM( dirname )
      !
      RETURN
      !
    END FUNCTION restart_dir
    !
    !------------------------------------------------------------------------
    FUNCTION check_restartfile( outdir, ndr )
      !------------------------------------------------------------------------
      !
      USE mp_images, ONLY : intra_image_comm
      !
      IMPLICIT NONE
      !
      LOGICAL                      :: check_restartfile
      INTEGER,          INTENT(IN) :: ndr
      CHARACTER(LEN=*), INTENT(IN) :: outdir
      CHARACTER(LEN=256)           :: filename
      LOGICAL                      :: lval
      !
      !
      filename = restart_dir( outdir, ndr )
      !
      IF ( ionode ) THEN
         !
         filename = TRIM( filename ) // '/' // TRIM( xmlpun )
         !
         INQUIRE( FILE = TRIM( filename ), EXIST = lval )
         !
      END IF
      !
      CALL mp_bcast( lval, ionode_id, intra_image_comm )
      !
      check_restartfile = lval
      !
      RETURN
      !
    END FUNCTION check_restartfile
    !
    !------------------------------------------------------------------------
    SUBROUTINE save_print_counter( iter, outdir, wunit )
      !------------------------------------------------------------------------
      !
      ! ... a counter indicating the last successful printout iteration is saved
      !
      USE mp_images, ONLY : intra_image_comm
      !
      IMPLICIT NONE
      !
      INTEGER,          INTENT(IN) :: iter
      CHARACTER(LEN=*), INTENT(IN) :: outdir
      INTEGER,          INTENT(IN) :: wunit
      !
      INTEGER            :: ierr
      CHARACTER(LEN=256) :: filename, dirname
      !
      !
      dirname = restart_dir( outdir, wunit )
      !
      CALL create_directory( TRIM( dirname ) )
      !
      IF ( ionode ) THEN
         !
         filename = TRIM( dirname ) // 'print_counter.xml'
         !
         CALL iotk_open_write( iunpun, FILE = filename, &
                             & ROOT = "PRINT_COUNTER",  IERR = ierr )
         !
      END IF
      !
      CALL mp_bcast( ierr, ionode_id, intra_image_comm )
      !
      CALL errore( 'save_print_counter', &
                   'cannot open restart file for writing', ierr )
      !
      IF ( ionode ) THEN
         !
         CALL iotk_write_begin( iunpun, "LAST_SUCCESSFUL_PRINTOUT" )
         CALL iotk_write_dat(   iunpun, "STEP", iter )
         CALL iotk_write_end(   iunpun, "LAST_SUCCESSFUL_PRINTOUT" )
         !
         CALL iotk_close_write( iunpun )
         !
      END IF
      !
      RETURN
      !
    END SUBROUTINE save_print_counter
    !
    !------------------------------------------------------------------------
    SUBROUTINE read_print_counter( nprint_nfi, outdir, runit )
      !------------------------------------------------------------------------
      !
      ! ... the counter indicating the last successful printout iteration 
      ! ... is read here
      !
      USE mp_images, ONLY : intra_image_comm
      !
      IMPLICIT NONE
      !
      INTEGER,          INTENT(OUT) :: nprint_nfi
      CHARACTER(LEN=*), INTENT(IN)  :: outdir
      INTEGER,          INTENT(IN)  :: runit
      !
      INTEGER            :: ierr
      CHARACTER(LEN=256) :: filename, dirname
      !
      !
      dirname = restart_dir( outdir, runit )
      !
      IF ( ionode ) THEN
         !
         filename = TRIM( dirname ) // 'print_counter.xml'
         !
         CALL iotk_open_read( iunpun, FILE = filename, IERR = ierr )
         !
         IF ( ierr > 0 ) THEN
            !
            nprint_nfi = -1
            !
         ELSE
            !
            CALL iotk_scan_begin( iunpun, "LAST_SUCCESSFUL_PRINTOUT" )
            CALL iotk_scan_dat(   iunpun, "STEP", nprint_nfi )
            CALL iotk_scan_end(   iunpun, "LAST_SUCCESSFUL_PRINTOUT" )
            !
            CALL iotk_close_read( iunpun )
            !
         END IF
         !
      END IF
      !
      CALL mp_bcast( nprint_nfi, ionode_id, intra_image_comm )
      !
      RETURN
      !
    END SUBROUTINE read_print_counter   
    !
    !------------------------------------------------------------------------
    SUBROUTINE set_kpoints_vars( ik, nk, kunit, ngwl, igl, &
                                 ngroup, ikt, iks, ike, igwx, ipmask, ipsour, &
                                 ionode, root_in_group, intra_group_comm, inter_group_comm, parent_group_comm )
      !------------------------------------------------------------------------
      !
      ! ... set working variables for k-point index (ikt) and 
      ! ... k-points number (nkt)
      !
      IMPLICIT NONE
      !
      INTEGER, INTENT(IN)  :: ik, nk, kunit
      INTEGER, INTENT(IN)  :: ngwl, igl(:)
      INTEGER, INTENT(OUT) :: ngroup
      INTEGER, INTENT(OUT) :: ikt, iks, ike, igwx
      INTEGER, INTENT(OUT) :: ipmask(:), ipsour
      LOGICAL, INTENT(IN)  :: ionode
      INTEGER, INTENT(IN)  :: root_in_group, intra_group_comm, inter_group_comm, parent_group_comm
      !
      INTEGER :: ierr, i
      INTEGER :: nkl, nkr, nkbl, nkt
      INTEGER :: nproc_parent, nproc_group, my_group_id, me_in_group, me_in_parent, io_in_parent
      !
      nproc_parent = mp_size( parent_group_comm )
      nproc_group  = mp_size( intra_group_comm )
      my_group_id  = mp_rank( inter_group_comm )
      me_in_group  = mp_rank( intra_group_comm )
      me_in_parent = mp_rank( parent_group_comm )
      !
      ! find the ID (io_in_parent) of the io PE ( where ionode == .true. )
      !
      io_in_parent = 0
      IF( ionode ) io_in_parent = me_in_parent
      CALL mp_sum( io_in_parent, parent_group_comm )
      !
      ikt = ik
      nkt = nk
      !
      ! ... find out the number of pools
      !
      ngroup = nproc_parent / nproc_group 
      !
      ! ... find out number of k points blocks
      !
      nkbl = nkt / kunit  
      !
      ! ... k points per pool
      !
      nkl = kunit * ( nkbl / ngroup )
      !
      ! ... find out the reminder
      !
      nkr = ( nkt - nkl * ngroup ) / kunit
      !
      ! ... Assign the reminder to the first nkr pools
      !
      IF ( my_group_id < nkr ) nkl = nkl + kunit
      !
      ! ... find out the index of the first k point in this pool
      !
      iks = nkl * my_group_id + 1
      !
      IF ( my_group_id >= nkr ) iks = iks + nkr * kunit
      !
      ! ... find out the index of the last k point in this pool
      !
      ike = iks + nkl - 1
      !
      ipmask = 0
      ipsour = io_in_parent
      !
      ! ... find out the index of the processor which collect the data 
      ! ... in the pool of ik
      !
      IF ( ngroup > 1 ) THEN
         !
         IF ( ( ikt >= iks ) .AND. ( ikt <= ike ) ) THEN
            !
            IF ( me_in_group == root_in_group ) ipmask( me_in_parent + 1 ) = 1
            !
         END IF
         !
         ! ... Collect the mask for all proc in the image
         !
         CALL mp_sum( ipmask, parent_group_comm )
         !
         DO i = 1, nproc_parent
            !
            IF( ipmask(i) == 1 ) ipsour = ( i - 1 )
            !
         END DO
         !
      END IF
      !
      igwx = 0
      ierr = 0
      !
      IF ( ( ikt >= iks ) .AND. ( ikt <= ike ) ) THEN
         !
         IF ( ngwl > SIZE( igl ) ) THEN
            !
            ierr = 1
            !
         ELSE
            !
            igwx = MAXVAL( igl(1:ngwl) )
            !
         END IF
         !
      END IF
      !
      ! ... get the maximum index within the pool
      !
      CALL mp_max( igwx, intra_group_comm )
      !
      ! ... now notify all procs if an error has been found 
      !
      CALL mp_max( ierr, parent_group_comm )
      !
      CALL errore( 'set_kpoint_vars ', 'wrong size ngl', ierr )
      !
      IF ( ipsour /= io_in_parent ) &
         CALL mp_get( igwx, igwx, me_in_parent, io_in_parent, ipsour, 1, parent_group_comm )
      !
      RETURN
      !
    END SUBROUTINE set_kpoints_vars
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE write_rho( dirname, rho, nspin, extension )
      !------------------------------------------------------------------------
      !
      ! ... this routine writes the charge-density in xml format into the
      ! ... $dirname directory - $dirname must exist and end with '/'
      !
      USE fft_base, ONLY : dfftp
      USE mp_bands, ONLY : intra_bgrp_comm, inter_bgrp_comm
      !
      IMPLICIT NONE
      !
      INTEGER,          INTENT(IN)           :: nspin
      REAL(DP),         INTENT(IN)           :: rho(dfftp%nnr,nspin)
      CHARACTER(LEN=*), INTENT(IN)           :: dirname
      CHARACTER(LEN=*), INTENT(IN), OPTIONAL :: extension
      !
      CHARACTER(LEN=256)    :: file_base
      CHARACTER(LEN=6)      :: ext
      REAL(DP), ALLOCATABLE :: rhoaux(:)
      !
      !
      ext = ' '
      IF ( PRESENT( extension ) ) ext = '.' // TRIM( extension )
      !
      file_base = TRIM( dirname ) // 'charge-density' // TRIM( ext )
      !
      IF ( nspin == 1 ) THEN
         !
         CALL write_rho_xml( file_base, rho(:,1), dfftp, ionode, inter_bgrp_comm )
         !
      ELSE IF ( nspin == 2 ) THEN
         !
         ALLOCATE( rhoaux( dfftp%nnr ) )
         !
         rhoaux(:) = rho(:,1) + rho(:,2)
         !
         CALL write_rho_xml( file_base, rhoaux, dfftp, ionode, inter_bgrp_comm )
         !
         file_base = TRIM( dirname ) // 'spin-polarization' // TRIM( ext )
         !
         rhoaux(:) = rho(:,1) - rho(:,2)
         !
         CALL write_rho_xml( file_base, rhoaux,  dfftp, ionode, inter_bgrp_comm )
         !
         DEALLOCATE( rhoaux )
         !
      ELSE IF ( nspin == 4 ) THEN
         !
         CALL write_rho_xml( file_base, rho(:,1), dfftp, ionode, inter_bgrp_comm )
         !
         file_base = TRIM( dirname ) // 'magnetization.x' // TRIM( ext )
         !
         CALL write_rho_xml( file_base, rho(:,2), dfftp, ionode, inter_bgrp_comm )
         !
         file_base = TRIM( dirname ) // 'magnetization.y' // TRIM( ext )
         !
         CALL write_rho_xml( file_base, rho(:,3), dfftp, ionode, inter_bgrp_comm )
         !
         file_base = TRIM( dirname ) // 'magnetization.z' // TRIM( ext )
         !
         CALL write_rho_xml( file_base, rho(:,4), dfftp, ionode, inter_bgrp_comm )
         !
      END IF
      !
      RETURN
      !
    END SUBROUTINE write_rho
    !
    !------------------------------------------------------------------------
    SUBROUTINE read_rho( dirname, rho, nspin, extension)
      !------------------------------------------------------------------------
      !
      ! ... this routine reads the charge-density in xml format from the
      ! ... files saved into the '.save' directory
      !
      USE fft_base,  ONLY : dfftp
      !
      IMPLICIT NONE
      !
      INTEGER,          INTENT(IN)           :: nspin
      CHARACTER(LEN=*), INTENT(IN)           :: dirname
      CHARACTER(LEN=*), INTENT(IN), OPTIONAL :: extension
      REAL(DP),         INTENT(OUT)          :: rho(dfftp%nnr,nspin)
      !
      CHARACTER(LEN=256)  :: file_base
      CHARACTER(LEN=6)    :: ext
      REAL(DP), ALLOCATABLE :: rhoaux(:)
      !
      ext = ' '
      IF ( PRESENT( extension ) ) ext = '.' // TRIM( extension )
      !
      file_base = TRIM( dirname ) // 'charge-density' // TRIM( ext )
      CALL read_rho_xml ( file_base, dfftp, rho(:,1) ) 
      !
      IF ( nspin == 2 ) THEN
         !
         rho(:,2) = rho(:,1)
         !
         ALLOCATE( rhoaux( dfftp%nnr ) )
         !
         file_base = TRIM( dirname ) // 'spin-polarization' // TRIM( ext )
         CALL read_rho_xml ( file_base, dfftp, rhoaux ) 
         !
         rho(:,1) = 0.5D0*( rho(:,1) + rhoaux(:) )
         rho(:,2) = 0.5D0*( rho(:,2) - rhoaux(:) )
         !
         DEALLOCATE( rhoaux )
         !
      ELSE IF ( nspin == 4 ) THEN
         !
         file_base = TRIM( dirname ) // 'magnetization.x' // TRIM( ext )
         CALL read_rho_xml ( file_base, dfftp, rho(:,2) ) 
         !
         file_base = TRIM( dirname ) // 'magnetization.y' // TRIM( ext )
         CALL read_rho_xml ( file_base, dfftp, rho(:,3) ) 
         !
         file_base = TRIM( dirname ) // 'magnetization.z' // TRIM( ext )
         CALL read_rho_xml ( file_base, dfftp, rho(:,4) ) 
         !
      END IF
      !
      RETURN
      !
    END SUBROUTINE read_rho
    !------------------------------------------------------------------------
    SUBROUTINE write_rho_xml( rho_file_base, rho, fft_desc, ionode, inter_group_comm )
      !------------------------------------------------------------------------
      !
      ! ... Writes charge density rho, one plane at a time.
      ! ... If ipp and npp are specified, planes are collected one by one from
      ! ... all processors, avoiding an overall collect of the charge density
      ! ... on a single proc.
      !
#if defined __HDF5
      USE hdf5_qe,  ONLY  : write_rho_hdf5, h5fclose_f, &
                            prepare_for_writing_final, add_attributes_hdf5, rho_hdf5_write  
#endif
      USE fft_types
      !
      IMPLICIT NONE
      !
      CHARACTER(LEN=*),  INTENT(IN) :: rho_file_base
      REAL(DP),          INTENT(IN) :: rho(:)
      TYPE(fft_type_descriptor),INTENT(IN) :: fft_desc
      INTEGER,           INTENT(IN) :: inter_group_comm
      LOGICAL,           INTENT(IN) :: ionode
      !
      INTEGER               :: nr1,nr2,nr3, nr1x, nr2x,nr3x
      INTEGER               :: rhounit, ierr, i, j, jj, k, kk, ldr, ip
      CHARACTER(LEN=256)    :: rho_file
      CHARACTER(LEN=256)    :: rho_file_hdf5
      CHARACTER(LEN=10)     :: rho_extension
      REAL(DP), ALLOCATABLE :: rho_plane(:)
      INTEGER,  ALLOCATABLE :: kowner(:)
      INTEGER               :: my_group_id, me_group, me_group2, me_group3, &
                                            nproc_group, nproc_group2, nproc_group3, &
                                            io_group_id, io_group2, io_group3
      INTEGER,  EXTERNAL    :: find_free_unit
      !

      my_group_id = mp_rank( inter_group_comm )

      me_group = fft_desc%mype ; me_group2 = fft_desc%mype2 ; me_group3 = fft_desc%mype3
      nproc_group = fft_desc%nproc ; nproc_group2 = fft_desc%nproc2 ; nproc_group3 = fft_desc%nproc3
      !
      nr1  = fft_desc%nr1  ; nr2  = fft_desc%nr2  ; nr3  = fft_desc%nr3
      nr1x = fft_desc%nr1x ; nr2x = fft_desc%nr2x ; nr3x = fft_desc%nr3x
      !
      rho_extension = '.dat'
      IF ( .NOT. rho_binary ) rho_extension = '.xml'
      !
      rho_file = TRIM( rho_file_base ) // TRIM( rho_extension )
      rhounit = find_free_unit ()
      !
      IF ( ionode ) THEN 
#if defined  __HDF5
         rho_file_hdf5 = TRIM( rho_file_base ) // '.hdf5'
         CALL prepare_for_writing_final(rho_hdf5_write, 0 ,rho_file_hdf5)
         CALL add_attributes_hdf5(rho_hdf5_write,nr1,"nr1")
         CALL add_attributes_hdf5(rho_hdf5_write,nr2,"nr2")
         CALL add_attributes_hdf5(rho_hdf5_write,nr3,"nr3")
#else
         CALL iotk_open_write( rhounit, FILE = rho_file,  BINARY = rho_binary, IERR = ierr )
         CALL errore( 'write_rho_xml', 'cannot open ' // TRIM( rho_file ) // ' file for writing', ierr )
#endif
      END IF 
      !
#if !defined __HDF5
      IF ( ionode ) THEN
         !
         CALL iotk_write_begin( rhounit, "CHARGE-DENSITY" )
         !
         CALL iotk_write_attr( attr, "nr1", nr1, FIRST = .TRUE. )
         CALL iotk_write_attr( attr, "nr2", nr2 )
         CALL iotk_write_attr( attr, "nr3", nr3 )
         !
         CALL iotk_write_empty( rhounit, "INFO", attr )
         !
      END IF
#endif
      !
      ALLOCATE( rho_plane( nr1*nr2 ) )
      ALLOCATE( kowner( nr3 ) )
      !
      ! ... find the index of the group (pool) that will write rho
      !
      io_group_id = 0
      !
      IF ( ionode ) io_group_id = my_group_id
      !
      CALL mp_sum( io_group_id, fft_desc%comm )
      CALL mp_sum( io_group_id, inter_group_comm ) ! io_group_id is the (pool) group that contains the ionode
      !
      ! ... find the index of the ionode within Y and Z  groups
      !
      io_group2 = 0 ; IF ( ionode ) io_group2 = me_group2
      CALL mp_sum( io_group2, fft_desc%comm )  ! io_group2 is the group index of the ionode in the Y group (nproc2)
      io_group3 = 0 ; IF ( ionode ) io_group3 = me_group3
      CALL mp_sum( io_group3, fft_desc%comm )  ! io_group3 is the group index of the ionode in the Z group (nproc3)
      !
      ! ... find out the owner of each "z" plane
      !
      DO ip = 1, nproc_group3
         !
         kowner( (fft_desc%i0r3p(ip)+1):(fft_desc%i0r3p(ip)+fft_desc%nr3p(ip)) ) = ip - 1
         !
      END DO
      !
      ldr = nr1x*fft_desc%my_nr2p
      !
      IF ( ( my_group_id == io_group_id ) ) THEN ! only the group of ionode collects and writes the data
         !
         DO k = 1, nr3
            !
            !  Only one subgroup write the charge density
            ! 
            rho_plane = 0.d0
            IF( ( kowner(k) == me_group3 ) ) THEN
               !
               kk = k - fft_desc%my_i0r3p
               ! 
               DO jj = 1, fft_desc%my_nr2p
                  !
                  j = jj + fft_desc%my_i0r2p
                  DO i = 1, nr1
                     !
                     rho_plane(i+(j-1)*nr1) = rho(i+(jj-1)*nr1x+(kk-1)*ldr)
                     !
                  END DO
                  !
               END DO
               call mp_sum(rho_plane, fft_desc%comm2 ) ! collect the data over the Y group (nproc2)
               !
            END IF
            !
            ! if this processor is in the same comm3 group as ionode (me_group2==io_group2) 
            IF ( kowner(k) /= io_group3 .and. me_group2==io_group2) & 
               CALL mp_get( rho_plane, rho_plane, me_group3, io_group3, kowner(k), k, fft_desc%comm3 )
            !
            IF ( ionode ) THEN
#if defined __HDF5
            CALL write_rho_hdf5(rho_hdf5_write,k,rho_plane)
#else
               CALL iotk_write_dat( rhounit, "z" // iotk_index( k ), rho_plane )
#endif
            ENDIF
            !
         END DO
         !
      END IF
      !
      DEALLOCATE( rho_plane )
      DEALLOCATE( kowner )
      !
      IF ( ionode ) THEN
#if defined __HDF5
         CALL h5fclose_f(rho_hdf5_write%file_id,ierr)
#else
   !
         CALL iotk_write_end( rhounit, "CHARGE-DENSITY" )
         !
         CALL iotk_close_write( rhounit )
#endif       
         !
      END IF
      !
      RETURN
      !
    END SUBROUTINE write_rho_xml
    !
    !------------------------------------------------------------------------
    SUBROUTINE read_rho_xml( rho_file_base, fft_desc, rho )
      !------------------------------------------------------------------------
      !
      ! ... Reads charge density rho, one plane at a time, to avoid 
      ! ... collecting the entire charge density on a single processor
      !
      USE mp_images, ONLY : intra_image_comm
#if defined __HDF5
      USE hdf5_qe,   ONLY : read_rho_hdf5, read_attributes_hdf5, &
           prepare_for_reading_final, h5fclose_f, rho_hdf5_write, hdf5_type
#endif
      USE fft_types
      !
      IMPLICIT NONE
      !
      CHARACTER(LEN=*),  INTENT(IN)  :: rho_file_base
      TYPE(fft_type_descriptor),INTENT(IN) :: fft_desc
      REAL(DP),          INTENT(OUT) :: rho(:)
      !
      INTEGER               :: rhounit, ierr, i, j, jj, k, kk, ldr, ip
      INTEGER               :: nr( 3 ), nr1_, nr2_, nr3_, nr1, nr2, nr3, nr1x, nr2x, nr3x
      INTEGER               :: me_group, me_group2, me_group3, &
                               nproc_group, nproc_group2, nproc_group3
      CHARACTER(LEN=256)    :: rho_file
      CHARACTER(LEN=256)    :: rho_file_hdf5
      REAL(DP), ALLOCATABLE :: rho_plane(:)
      INTEGER,  ALLOCATABLE :: kowner(:)
      LOGICAL               :: exst
      INTEGER,  EXTERNAL    :: find_free_unit
#if defined(__HDF5)
      TYPE(hdf5_type),ALLOCATABLE   :: h5desc
#endif
      !
      me_group = fft_desc%mype ; me_group2 = fft_desc%mype2 ; me_group3 = fft_desc%mype3
      nproc_group = fft_desc%nproc ; nproc_group2 = fft_desc%nproc2 ; nproc_group3 = fft_desc%nproc3
      !
      nr1  = fft_desc%nr1  ; nr2  = fft_desc%nr2  ; nr3  = fft_desc%nr3
      nr1x = fft_desc%nr1x ; nr2x = fft_desc%nr2x ; nr3x = fft_desc%nr3x
      !
#if defined(__HDF5)
      rho_file_hdf5 = TRIM( rho_file_base ) // '.hdf5'
      exst = check_file_exist(TRIM(rho_file_hdf5))
      IF ( .NOT. exst ) CALL errore ('read_rho_xml', 'searching for '// TRIM(rho_file_hdf5),10)
#else 
      rhounit = find_free_unit ( )
      rho_file = TRIM( rho_file_base ) // ".dat"
      exst = check_file_exist( TRIM(rho_file) ) 
      !
      IF ( .NOT. exst ) CALL errore('read_rho_xml', 'searching for '//TRIM(rho_file), 10)
#endif
      !
      IF ( ionode ) THEN
#if defined (__HDF5)
         ALLOCATE ( h5desc)
         CALL prepare_for_reading_final(h5desc, 0 ,rho_file_hdf5)
         CALL read_attributes_hdf5(h5desc, nr1_,"nr1")
         CALL read_attributes_hdf5(h5desc, nr2_,"nr2")
         CALL read_attributes_hdf5(h5desc, nr3_,"nr3")
         nr = [nr1_,nr2_,nr3_]
#else
         CALL iotk_open_read( rhounit, FILE = rho_file, IERR = ierr )
         CALL errore( 'read_rho_xml', 'cannot open ' // TRIM( rho_file ) // ' file for reading', ierr )
         CALL iotk_scan_begin( rhounit, "CHARGE-DENSITY" )
         !
         CALL iotk_scan_empty( rhounit, "INFO", attr )
         !
         CALL iotk_scan_attr( attr, "nr1", nr(1) )
         CALL iotk_scan_attr( attr, "nr2", nr(2) )
         CALL iotk_scan_attr( attr, "nr3", nr(3) )
#endif
         !
         IF ( nr1 /= nr(1) .OR. nr2 /= nr(2) .OR. nr3 /= nr(3) ) &
            CALL errore( 'read_rho_xml', 'dimensions do not match', 1 )
         !
      END IF
      !
      ALLOCATE( rho_plane( nr1*nr2 ) )
      ALLOCATE( kowner( nr3 ) )
      !
      DO ip = 1, nproc_group3
         !
         kowner( (fft_desc%i0r3p(ip)+1):(fft_desc%i0r3p(ip)+fft_desc%nr3p(ip)) ) = ip - 1
         !
      END DO
      !
      ldr = nr1x*fft_desc%my_nr2p
      !
      ! ... explicit initialization to zero is needed because the physical
      ! ... dimensions of rho may exceed the true size of the FFT grid 
      !
      rho(:) = 0.0_DP
      !
      DO k = 1, nr3
         !
         ! ... only ionode reads the charge planes
         !
         IF ( ionode ) THEN
#if defined __HDF5
            CALL  read_rho_hdf5(h5desc , k,rho_plane)
#else
            CALL iotk_scan_dat( rhounit, "z" // iotk_index( k ), rho_plane )
#endif
         ENDIF
         !
         ! ... planes are sent to the destination processor (all processors in this image)
         !
         CALL mp_bcast( rho_plane, ionode_id, intra_image_comm )
         !
         IF( kowner(k) == me_group3 ) THEN
            !
            kk = k - fft_desc%my_i0r3p
            DO jj = 1, fft_desc%my_nr2p
               j = jj + fft_desc%my_i0r2p
               DO i = 1, nr1
                  rho(i+(jj-1)*nr1x+(kk-1)*ldr) = rho_plane(i+(j-1)*nr1)
               END DO
            END DO
            !
         END IF
         !
      END DO
      !
      DEALLOCATE( rho_plane )
      DEALLOCATE( kowner )
      !
      IF ( ionode ) THEN
         !
#if defined __HDF5
         CALL h5fclose_f(h5desc%file_id,ierr)
         DEALLOCATE ( h5desc)
#else
   !
         CALL iotk_scan_end( rhounit, "CHARGE-DENSITY" )
         !
         CALL iotk_close_read( rhounit )
#endif    
      END IF
      !
      RETURN
      !
    END SUBROUTINE read_rho_xml
    !
    !------------------------------------------------------------------------
    ! ... methods to write and read wavefunctions
    !
    !------------------------------------------------------------------------
    SUBROUTINE write_wfc( iuni, ik, nk, kunit, ispin, nspin, wf0, ngw,   &
                          gamma_only, nbnd, igl, ngwl, filename, scalef, &
                          ionode, root_in_group, intra_group_comm,       &
                          inter_group_comm, parent_group_comm )
      !------------------------------------------------------------------------
      !
      USE mp_wave,    ONLY : mergewf
      USE control_flags,     ONLY : lwfnscf, lwfpbe0nscf  ! Lingzhu Kong
#if defined  __HDF5
      !USE hdf5_qe,    ONLY : evc_hdf5, read_data_hdf5, write_data_hdf5, &
      !                        evc_hdf5_write,  &
      !                       setup_file_property_hdf5, &
      !                       write_final_data, prepare_for_writing_final, &
      USE hdf5_qe                
      USE mp_global,    ONLY : inter_pool_comm, world_comm
      USE HDF5
#endif
      !
      IMPLICIT NONE
      !
      INTEGER,            INTENT(IN) :: iuni
      INTEGER,            INTENT(IN) :: ik, nk, kunit, ispin, nspin
      COMPLEX(DP),        INTENT(IN) :: wf0(:,:)
      INTEGER,            INTENT(IN) :: ngw
      LOGICAL,            INTENT(IN) :: gamma_only
      INTEGER,            INTENT(IN) :: nbnd
      INTEGER,            INTENT(IN) :: ngwl
      INTEGER,            INTENT(IN) :: igl(:)
      CHARACTER(LEN=256), INTENT(IN) :: filename
      REAL(DP),           INTENT(IN) :: scalef    
        ! scale factor, usually 1.0 for pw and 1/SQRT( omega ) for CP
      LOGICAL,            INTENT(IN) :: ionode
      INTEGER,            INTENT(IN) :: root_in_group, intra_group_comm, inter_group_comm, parent_group_comm
      !
      INTEGER                  :: j
      INTEGER                  :: iks, ike, ikt, igwx
      INTEGER                  :: ierr
      INTEGER                  :: ngroup, ipsour
      INTEGER,     ALLOCATABLE :: ipmask(:)
      INTEGER                  :: me_in_group, nproc_in_group, io_in_parent, nproc_in_parent, me_in_parent, my_group, io_group
#if defined __HDF5
      CHARACTER(LEN=256) :: filename_hdf5
#endif
      COMPLEX(DP), ALLOCATABLE :: wtmp(:)
      !
      ngroup          = mp_size( inter_group_comm )
      my_group        = mp_rank( inter_group_comm )
      me_in_group     = mp_rank( intra_group_comm )
      nproc_in_group  = mp_size( intra_group_comm )
      me_in_parent    = mp_rank( parent_group_comm )
      nproc_in_parent = mp_size( parent_group_comm )
      !
      ALLOCATE( ipmask( nproc_in_parent ) )
      !
      ! find out the group containing the ionode
      !
      io_group = 0
      IF( ionode ) io_group = my_group
      CALL mp_sum( io_group, parent_group_comm )
      !
      io_in_parent = 0
      IF( ionode ) io_in_parent = me_in_parent
      CALL mp_sum( io_in_parent, parent_group_comm )
      !
      CALL set_kpoints_vars( ik, nk, kunit, ngwl, igl, &
                             ngroup, ikt, iks, ike, igwx, ipmask, ipsour, &
                             ionode, root_in_group, intra_group_comm, inter_group_comm, parent_group_comm )
      !
      IF ( ionode ) THEN
#if defined  __HDF5
      filename_hdf5=trim(tmp_dir) //"evc.hdf5"
      CALL prepare_for_writing_final(evc_hdf5_write,inter_pool_comm,filename_hdf5,ik)
      CALL add_attributes_hdf5(evc_hdf5_write,ngw,"ngw",ik)
      CALL add_attributes_hdf5(evc_hdf5_write,gamma_only,"gamma_only",ik)
      CALL add_attributes_hdf5(evc_hdf5_write,igwx,"igwx",ik)
      CALL add_attributes_hdf5(evc_hdf5_write,nbnd,"nbnd",ik)
      CALL add_attributes_hdf5(evc_hdf5_write,ik,"ik",ik)
      CALL add_attributes_hdf5(evc_hdf5_write,nk,"nk",ik)
      CALL add_attributes_hdf5(evc_hdf5_write,ispin,"ispin",ik)
      CALL add_attributes_hdf5(evc_hdf5_write,nspin,"nspin",ik)
      CALL add_attributes_hdf5(evc_hdf5_write,scalef,"scale_factor",ik)
         !
#else
         CALL iotk_open_write( iuni, FILE = TRIM( filename ), ROOT="WFC", BINARY = .TRUE. )
         !
         CALL iotk_write_attr( attr, "ngw",          ngw, FIRST = .TRUE. )
         CALL iotk_write_attr( attr, "igwx",         igwx )
         CALL iotk_write_attr( attr, "gamma_only",   gamma_only )
         CALL iotk_write_attr( attr, "nbnd",         nbnd )
         CALL iotk_write_attr( attr, "ik",           ik )
         CALL iotk_write_attr( attr, "nk",           nk )
         CALL iotk_write_attr( attr, "ispin",        ispin )
         CALL iotk_write_attr( attr, "nspin",        nspin )
         CALL iotk_write_attr( attr, "scale_factor", scalef )
         !
         CALL iotk_write_empty( iuni, "INFO", attr )
#endif

         !
      END IF
      !
      ALLOCATE( wtmp( MAX( igwx, 1 ) ) )
      !
      wtmp = 0.0_DP
      ! Next 3 lines: Lingzhu Kong
      IF ( ( index(filename,'evc0') > 0 ) .and. (lwfnscf .or. lwfpbe0nscf) )THEN
         IF ( ionode ) OPEN(60,file='cp_wf.dat',status='unknown',form='unformatted')
      ENDIF

      DO j = 1, nbnd
         !
         IF ( ngroup > 1 ) THEN
            !
            IF( nk > 1 ) THEN
               IF ( ikt >= iks .AND. ikt <= ike ) &      
                  CALL mergewf( wf0(:,j), wtmp, ngwl, igl, me_in_group, &
                                nproc_in_group, root_in_group, intra_group_comm )
               !
               IF ( ipsour /= io_in_parent ) &
                  CALL mp_get( wtmp, wtmp, me_in_parent, &
                               io_in_parent, ipsour, j, parent_group_comm )
               !
            ELSE IF( my_group == io_group ) THEN
               !
               CALL mergewf( wf0(:,j), wtmp, ngwl, igl, &
                             me_in_group, nproc_in_group, root_in_group, intra_group_comm )
            END IF
            !
         ELSE
            !
            CALL mergewf( wf0(:,j), wtmp, ngwl, igl, &
                          me_in_parent, nproc_in_parent, io_in_parent, parent_group_comm )
            !
         END IF
         !
         IF ( ionode ) THEN

#if defined  __HDF5
            CALL write_evc(evc_hdf5_write,j,wtmp(1:igwx), ik)
#else
            CALL iotk_write_dat( iuni, "evc" // iotk_index( j ), wtmp(1:igwx) )
#endif
         ENDIF
         ! Next 3 lines : Lingzhu Kong
         IF ( ( index(filename,'evc0') > 0 ) .and. (lwfnscf .or. lwfpbe0nscf) ) THEN
            IF ( ionode ) write(60)wtmp(1:igwx) 
         ENDIF
         !
      END DO
      ! Next 4 lines : Lingzhu Kong
      IF ( ( index(filename,'evc0') > 0 ) .and. (lwfnscf .or. lwfpbe0nscf) )THEN
          IF ( ionode ) close(60)   !Lingzhu Kong
          write(*,*)'done writing evc0'
      ENDIF
      IF ( ionode ) then
#if defined __HDF5
         CALL h5fclose_f(evc_hdf5_write%file_id, ierr)
#else
         CALL iotk_close_write( iuni )
#endif
      endif
      !
      DEALLOCATE( wtmp )
      DEALLOCATE( ipmask )
      !
      RETURN
      !
    END SUBROUTINE write_wfc
    !
    !------------------------------------------------------------------------
    SUBROUTINE read_wfc( iuni, ik, nk, kunit, ispin, &
                         nspin, wf, ngw, nbnd, igl, ngwl, filename, scalef, &
                         ionode, root_in_group, intra_group_comm, inter_group_comm, parent_group_comm, &
                         flink )
      !------------------------------------------------------------------------
      !
      USE mp_wave,   ONLY : splitwf

#if defined  __HDF5
      USE hdf5_qe
#endif
      !
      IMPLICIT NONE
      !
      INTEGER,            INTENT(IN)    :: iuni
      COMPLEX(DP),        INTENT(OUT)   :: wf(:,:)
      INTEGER,            INTENT(IN)    :: ik, nk
      INTEGER,            INTENT(IN)    :: kunit
      INTEGER,            INTENT(INOUT) :: ngw, nbnd, ispin, nspin
      INTEGER,            INTENT(IN)    :: ngwl
      INTEGER,            INTENT(IN)    :: igl(:)
      CHARACTER(LEN=256), INTENT(IN)    :: filename
      REAL(DP),           INTENT(OUT)   :: scalef
      LOGICAL,            INTENT(IN)    :: ionode
      INTEGER,            INTENT(IN)    :: root_in_group, intra_group_comm, inter_group_comm, parent_group_comm
      LOGICAL, OPTIONAL,  INTENT(IN)    :: flink
      !
      CHARACTER(LEN=256) :: filename_hdf5
      INTEGER                  :: j
      COMPLEX(DP), ALLOCATABLE :: wtmp(:)
      INTEGER                  :: ierr
      INTEGER                  :: iks, ike, ikt
      INTEGER                  :: igwx, igwx_, ik_, nk_
      INTEGER                  :: ngroup, ipdest
      INTEGER,     ALLOCATABLE :: ipmask(:)
      LOGICAL                  :: flink_
      INTEGER                  :: me_in_group, nproc_in_group, io_in_parent, nproc_in_parent, me_in_parent, my_group, io_group
      !
      flink_ = .FALSE.
      IF( PRESENT( flink ) ) flink_ = flink
      !
      ngroup          = mp_size( inter_group_comm )
      my_group        = mp_rank( inter_group_comm )
      me_in_group     = mp_rank( intra_group_comm )
      nproc_in_group  = mp_size( intra_group_comm )
      me_in_parent    = mp_rank( parent_group_comm )
      nproc_in_parent = mp_size( parent_group_comm )
      !
      ALLOCATE( ipmask( nproc_in_parent ) )
      !
      ! find out the group containing the ionode
      !
      io_group = 0
      IF( ionode ) io_group = my_group
      CALL mp_sum( io_group, parent_group_comm )
      !
      ! find out the io task id in the parent group
      !
      io_in_parent = 0
      IF( ionode ) io_in_parent = me_in_parent
      CALL mp_sum( io_in_parent, parent_group_comm )
      !
      CALL set_kpoints_vars( ik, nk, kunit, ngwl, igl, &
                             ngroup, ikt, iks, ike, igwx, ipmask, ipdest, &
                             ionode, root_in_group, intra_group_comm, inter_group_comm, parent_group_comm )
      !
      !  if flink = .true. we are following a link and the file is
      !  already opened for read
      !
      ierr = 0
      !
#if !defined __HDF5
      IF ( ionode .AND. .NOT. flink_ ) &
         CALL iotk_open_read( iuni, FILE = filename, &
                              BINARY = .TRUE., IERR = ierr )
      !
      CALL mp_bcast( ierr, io_in_parent, parent_group_comm )
      !
      CALL errore( 'read_wfc ', &
                   'cannot open restart file for reading', ierr )
#endif
      !
      IF ( ionode ) THEN
          !
#if defined  __HDF5
          !filename_hdf5=trim(tmp_dir) //"evc.hdf5"
          filename_hdf5=filename
          CALL prepare_for_reading_final(evc_hdf5_write,evc_hdf5_write%comm,filename_hdf5,ik)
          CALL read_attributes_hdf5(evc_hdf5_write,ngw,"ngw",ik)
          CALL read_attributes_hdf5(evc_hdf5_write,nbnd,"nbnd",ik)
          CALL read_attributes_hdf5(evc_hdf5_write,ik_,"ik",ik)
          CALL read_attributes_hdf5(evc_hdf5_write,nk_,"ik",ik)
          CALL read_attributes_hdf5(evc_hdf5_write,ispin,"ispin",ik)
          CALL read_attributes_hdf5(evc_hdf5_write,nspin,"nspin",ik)
          CALL read_attributes_hdf5(evc_hdf5_write,igwx_,"igwx",ik)
          CALL read_attributes_hdf5(evc_hdf5_write,scalef,"scale_factor",ik)
#else
          CALL iotk_scan_empty( iuni, "INFO", attr )
          !
          CALL iotk_scan_attr( attr, "ngw",          ngw )
          CALL iotk_scan_attr( attr, "nbnd",         nbnd )
          CALL iotk_scan_attr( attr, "ik",           ik_ )
          CALL iotk_scan_attr( attr, "nk",           nk_ )
          CALL iotk_scan_attr( attr, "ispin",        ispin )
          CALL iotk_scan_attr( attr, "nspin",        nspin )
          CALL iotk_scan_attr( attr, "igwx",         igwx_ )
          CALL iotk_scan_attr( attr, "scale_factor", scalef )
          !
#endif

      END IF
      !
      CALL mp_bcast( ngw,    io_in_parent, parent_group_comm )
      CALL mp_bcast( nbnd,   io_in_parent, parent_group_comm )
      CALL mp_bcast( ik_,    io_in_parent, parent_group_comm )
      CALL mp_bcast( nk_,    io_in_parent, parent_group_comm )
      CALL mp_bcast( ispin,  io_in_parent, parent_group_comm )
      CALL mp_bcast( nspin,  io_in_parent, parent_group_comm )
      CALL mp_bcast( igwx_,  io_in_parent, parent_group_comm )
      CALL mp_bcast( scalef, io_in_parent, parent_group_comm )
      !
      ALLOCATE( wtmp( MAX( igwx_, igwx ) ) )
      !
      DO j = 1, nbnd
         !
         IF ( j <= SIZE( wf, 2 ) ) THEN
            !
            IF ( ionode ) THEN 
               !
#if defined __HDF5
             CALL read_evc(evc_hdf5_write,j,wtmp(1:igwx_),ik)
             !  CALL iotk_scan_dat( iuni, &
             !                      "evc" // iotk_index( j ), wtmp(1:igwx_) )
#else
               CALL iotk_scan_dat( iuni, &
                                   "evc" // iotk_index( j ), wtmp(1:igwx_) )
 
#endif
               !
               IF ( igwx > igwx_ ) wtmp((igwx_+1):igwx) = 0.0_DP
               ! ===========================================================
               !       Lingzhu Kong
               !IF ( j .eq. 1)write(*,'(10f12.5)')(wtmp(i),i=1,igwx_)
               ! ===========================================================
               !
            END IF
            !
            IF ( ngroup > 1 ) THEN
               !
               IF( nk_ > 1 ) THEN
                  !
                  IF ( ipdest /= io_in_parent ) &
                     CALL mp_put( wtmp, wtmp, me_in_parent, &
                               io_in_parent, ipdest, j, parent_group_comm )
                  !
                  IF ( ( ikt >= iks ) .AND. ( ikt <= ike ) ) &
                     CALL splitwf( wf(:,j), wtmp, ngwl, igl, me_in_group, &
                                nproc_in_group, root_in_group, intra_group_comm )
                  !
               ELSE IF( my_group == io_group ) THEN

                  CALL splitwf( wf(:,j), wtmp, ngwl, igl, &
                             me_in_group, nproc_in_group, root_in_group, intra_group_comm )
               END IF
               !
            ELSE
               !
               CALL splitwf( wf(:,j), wtmp, ngwl, igl, &
                             me_in_parent, nproc_in_parent, io_in_parent, parent_group_comm )
               !
            END IF
            !
         END IF
         !
      END DO
      !
#if !defined __HDF5
      IF ( ionode .AND. .NOT. flink_ ) CALL iotk_close_read( iuni )
#endif
      !
      DEALLOCATE( wtmp )
      DEALLOCATE( ipmask )
      !
      RETURN
      !
    END SUBROUTINE read_wfc
    !        
END MODULE oldxml_xml_io_base

!
! Copyright (C) Quantum ESPRESSO group
!
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
!----------------------------------------------------------------------
! FFT base Module.
! Written by Carlo Cavazzoni, modified by Paolo Giannozzi
! Rewritten by Stefano de Gironcoli
!----------------------------------------------------------------------
!
!=----------------------------------------------------------------------=!
   MODULE scatter_mod
!=----------------------------------------------------------------------=!

        USE fft_types, ONLY: fft_type_descriptor
        USE fft_param
        !qepy fix --> import 
        USE mp,                   ONLY : mp_bcast
        !qepy fix <-- import 

        IMPLICIT NONE

        INTERFACE gather_grid
           MODULE PROCEDURE gather_real_grid, gather_complex_grid
        END INTERFACE

        INTERFACE scatter_grid
           MODULE PROCEDURE scatter_real_grid, scatter_complex_grid
        END INTERFACE

        SAVE

        PRIVATE

        PUBLIC :: fft_type_descriptor
        PUBLIC :: gather_grid, scatter_grid
        PUBLIC :: fft_scatter_xy, fft_scatter_yz, fft_scatter_tg, fft_scatter_tg_opt
        PUBLIC :: cgather_sym, cgather_sym_many, cscatter_sym_many

!=----------------------------------------------------------------------=!
      CONTAINS
!=----------------------------------------------------------------------=!
!
!
!-----------------------------------------------------------------------
SUBROUTINE fft_scatter_xy ( desc, f_in, f_aux, nxx_, isgn )
  !-----------------------------------------------------------------------
  !
  ! transpose of the fft xy planes across the desc%comm2 communicator
  !
  ! a) From Y-oriented columns to X-oriented partial slices (isgn > 0)
  !    Active columns along the Y direction corresponding to a subset of the 
  !    active X values and a range of Z values (in this order) are stored 
  !    consecutively for each processor and are such that the subgroup owns
  !    all data for a range of Z values.
  !
  !    The Y pencil -> X-oriented partial slices transposition is performed 
  !    in the subgroup of processors (desc%comm2) owning this range of Z values.
  !
  !    The transpose takes place in two steps:
  !    1) on each processor the columns are sliced into sections along Y
  !       that are stored one after the other. On each processor, slices for
  !       processor "iproc2" are desc%nr2p(iproc2)*desc%nr1p(me2)*desc%my_nr3p big.
  !    2) all processors communicate to exchange slices (all sectin of columns with 
  !       Y in the slice belonging to "me" must be received, all the others 
  !       must be sent to "iproc2")
  !
  !    Finally one gets the "partial slice" representation: each processor has 
  !    all the X values of desc%my_nr2p Y and desc%my_nr3p Z values. 
  !    Data are organized with the X index running fastest, then Y, then Z.
  !
  !    f_in  contains the input Y columns, is destroyed on output
  !    f_aux contains the output X-oriented partial slices.
  !
  !  b) From planes to columns (isgn < 0)
  !
  !    Quite the same in the opposite direction
  !    f_aux contains the input X-oriented partial slices, is destroyed on output
  !    f_in  contains the output Y columns.
  !
  IMPLICIT NONE

  TYPE (fft_type_descriptor), INTENT(in) :: desc
  INTEGER, INTENT(in)           :: nxx_, isgn
  COMPLEX (DP), INTENT(inout)   :: f_in (nxx_), f_aux (nxx_)

  INTEGER :: nr1_temp(1)

#if defined(__MPI)
  CALL start_clock ('fft_scatt_xy')
  !
  if ( abs (isgn) == 1 ) then          ! It's a potential FFT
     CALL impl_xy( MAXVAL ( desc%nr2p ), desc%nproc2, desc%my_nr2p, desc%nr1p, desc%indp, desc%iplp)
  else if ( abs (isgn) == 2 ) then     ! It's a wavefunction FFT
     CALL impl_xy( MAXVAL ( desc%nr2p ), desc%nproc2, desc%my_nr2p, desc%nr1w, desc%indw, desc%iplw)
  else if ( abs (isgn) == 3 ) then     ! It's a wavefunction FFT with task group
     ! in task group FFTs whole Y colums are distributed
     nr1_temp = desc%nr1w_tg
     CALL impl_xy( desc%nr2x, 1, desc%nr2x, nr1_temp, desc%indw_tg, desc%iplw)
  end if
  !
  CALL stop_clock ('fft_scatt_xy')

  RETURN

  CONTAINS

  SUBROUTINE impl_xy(nr2px, nproc2, my_nr2p, nr1p_, indx, iplx)
  IMPLICIT NONE
  !
  INTEGER, INTENT(in):: nr2px, nproc2, my_nr2p
  INTEGER, INTENT(in):: nr1p_(nproc2), indx(desc%nr1x,nproc2), iplx(desc%nr1x)
  !
  INTEGER :: ierr, me2, iproc2, ncpx
  INTEGER :: i, it, j, k, kfrom, kdest, mc, m1, m3, i1, icompact, sendsize
  !
#if defined(__NON_BLOCKING_SCATTER)
  INTEGER :: sh(desc%nproc2), rh(desc%nproc2)
#endif

  me2    = desc%mype2 + 1
  ncpx = MAXVAL(nr1p_) * desc%my_nr3p       ! maximum number of Y columns to be disributed
  ! calculate the message size
  sendsize = ncpx * nr2px       ! dimension of the scattered chunks (safe value)

  ierr = 0
  IF (isgn.gt.0) THEN
     !
     IF (nproc2==1) GO TO 10
     !
     ! "forward" scatter from columns to planes
     !
     ! step one: store contiguously the slices
     !
!$omp parallel do collapse(2) private(kdest,kfrom)
     DO iproc2 = 1, nproc2
        DO k = 0, nr1p_(me2)*desc%my_nr3p-1
           kdest = ( iproc2 - 1 ) * sendsize + nr2px * k
           kfrom = desc%nr2p_offset(iproc2) + desc%nr2x *k
           DO i = 1, desc%nr2p( iproc2 )
              f_aux ( kdest + i ) =  f_in ( kfrom + i )
           ENDDO
        ENDDO
     ENDDO
!$omp end parallel do
#if defined(__NON_BLOCKING_SCATTER)
     DO iproc2 = 1, nproc2
        CALL mpi_isend( f_aux( (iproc2-1)*sendsize + 1 ), sendsize, &
                        MPI_DOUBLE_COMPLEX, iproc2-1, me2, desc%comm2, &
                        sh( iproc2 ), ierr )
     ENDDO
#endif
     !
     ! step two: communication  across the    nproc3    group
     !
#if defined(__NON_BLOCKING_SCATTER)
     DO iproc2 = 1, nproc2
        !
        ! now post the receive
        !
        CALL mpi_irecv( f_in( (iproc2-1)*sendsize + 1 ), sendsize, &
                        MPI_DOUBLE_COMPLEX, iproc2-1, MPI_ANY_TAG, &
                        desc%comm2, rh( iproc2 ), ierr )
        !IF( abs(ierr) /= 0 ) CALL fftx_error__ ('fft_scatter', ' forward receive info<>0', abs(ierr) )
     ENDDO
     
     call mpi_waitall( nproc2, sh, MPI_STATUSES_IGNORE, ierr )
     !
#else
     CALL mpi_alltoall (f_aux(1), sendsize, MPI_DOUBLE_COMPLEX, f_in(1), &
                        sendsize, MPI_DOUBLE_COMPLEX, desc%comm2, ierr)
     !
     IF( abs(ierr) /= 0 ) CALL fftx_error__ ('fft_scatter', 'info<>0', abs(ierr) )
#endif
     !
10   CONTINUE
     !
#if defined(__NON_BLOCKING_SCATTER)
     if (nproc2 > 1) call mpi_waitall( nproc2, rh, MPI_STATUSES_IGNORE, ierr )
#endif
     !
!$omp parallel
!$omp do collapse(2) private(it,m3,i1,m1,icompact)
     DO iproc2 = 1, nproc2
        DO i = 0, ncpx-1
           IF(i>=nr1p_(iproc2)*desc%my_nr3p) CYCLE ! control i from 0 to nr1p_(iproc2)*desc%my_nr3p-1
           it = ( iproc2 - 1 ) * sendsize + nr2px * i
           m3 = i/nr1p_(iproc2)+1
           i1 = mod(i,nr1p_(iproc2))+1
           m1 = indx(i1,iproc2)
           icompact = m1 + (m3-1)*desc%nr1x*my_nr2p
           DO j = 1, my_nr2p
              !f_aux( m1 + (j-1)*desc%nr1x + (m3-1)*desc%nr1x*my_nr2p ) = f_in( j + it )
              f_aux( icompact ) = f_in( j + it )
              icompact = icompact + desc%nr1x
           ENDDO
        ENDDO
     ENDDO
!$omp end do nowait
     !
     ! clean extra array elements in each stick
     !
!$omp do
     DO k = 1, my_nr2p*desc%my_nr3p
        DO i1 = 1, desc%nr1x
           IF(iplx(i1)==0) f_aux(desc%nr1x*(k-1)+i1) = (0.0_DP, 0.0_DP)
        ENDDO
     ENDDO
!$omp end do nowait
!$omp end parallel
     !
  ELSE
     !
     !  "backward" scatter from planes to columns
     !
!$omp parallel do collapse(2) private(it,m3,i1,m1,icompact)
     DO iproc2 = 1, nproc2
        DO i = 0, ncpx-1
           IF(i>=nr1p_(iproc2)*desc%my_nr3p) CYCLE ! control i from 0 to nr1p_(iproc2)*desc%my_nr3p-1
           it = ( iproc2 - 1 ) * sendsize + nr2px * i
           m3 = i/nr1p_(iproc2)+1
           i1 = mod(i,nr1p_(iproc2))+1
           m1 = indx(i1,iproc2)
           icompact = m1 + (m3-1)*desc%nr1x*my_nr2p
           DO j = 1, my_nr2p
              !f_in( j + it ) = f_aux( m1 + (j-1)*desc%nr1x + (m3-1)*desc%nr1x*my_nr2p )
              f_in( j + it ) = f_aux( icompact )
              icompact = icompact + desc%nr1x
           ENDDO
        ENDDO
     ENDDO
!$omp end parallel do
#if defined(__NON_BLOCKING_SCATTER)
     DO iproc2 = 1, nproc2
        IF( nproc2 > 1 ) CALL mpi_isend( f_in( ( iproc2 - 1 ) * sendsize + 1 ), &
                              sendsize, MPI_DOUBLE_COMPLEX, iproc2-1, me2, &
                              desc%comm2, sh( iproc2 ), ierr )
     ENDDO
#endif
     IF (nproc2==1) GO TO 20

     !
     !  step two: communication
     !
#if ! defined(__NON_BLOCKING_SCATTER)
     CALL mpi_alltoall (f_in(1), sendsize, MPI_DOUBLE_COMPLEX, f_aux(1), &
                        sendsize, MPI_DOUBLE_COMPLEX, desc%comm2, ierr)

     IF( abs(ierr) /= 0 ) CALL fftx_error__ ('fft_scatter', 'info<>0', abs(ierr) )
#else
     DO iproc2 = 1, nproc2
        CALL mpi_irecv( f_aux( (iproc2-1)*sendsize + 1 ), sendsize, &
                        MPI_DOUBLE_COMPLEX, iproc2-1, MPI_ANY_TAG, &
                        desc%comm2, rh(iproc2), ierr )
        ! IF( abs(ierr) /= 0 ) CALL fftx_error__ ('fft_scatter', ' backward receive info<>0', abs(ierr) )
     ENDDO
        
     call mpi_waitall( nproc2, sh, MPI_STATUSES_IGNORE, ierr )
     call mpi_waitall( nproc2, rh, MPI_STATUSES_IGNORE, ierr )
#endif
     !
     !  step one: store contiguously the columns
     !
!$omp parallel do collapse(2) private(kdest,kfrom)
     DO iproc2 = 1, nproc2
        DO k = 0, nr1p_(me2)*desc%my_nr3p-1
           kdest = ( iproc2 - 1 ) * sendsize + nr2px * k
           kfrom = desc%nr2p_offset(iproc2) + desc%nr2x * k
           DO i = 1, desc%nr2p( iproc2 )
              f_in ( kfrom + i ) = f_aux ( kdest + i )
           ENDDO
        ENDDO
     ENDDO
!$omp end parallel do
     !
     ! clean extra array elements in each stick
     !
     IF( desc%nr2x /= desc%nr2 ) THEN
        DO k = 1, nr1p_(me2)*desc%my_nr3p
           f_in(desc%nr2x*(k-1)+desc%nr2+1:desc%nr2x*k) = (0.0_DP, 0.0_DP)
        ENDDO
     ENDIF

20   CONTINUE

  ENDIF

  END SUBROUTINE impl_xy

#endif

END SUBROUTINE fft_scatter_xy
!
!-----------------------------------------------------------------------
SUBROUTINE fft_scatter_yz ( desc, f_in, f_aux, nxx_, isgn )
  !-----------------------------------------------------------------------
  !
  ! transpose of the fft yz planes across the desc%comm3 communicator
  !
  ! a) From Z-oriented columns to Y-oriented colums (isgn > 0)
  !    Active columns (or sticks or pencils) along the Z direction for each 
  !    processor are stored consecutively and are such that they correspond 
  !    to a subset of the active X values.
  !
  !    The pencil -> slices transposition is performed in the subgroup 
  !    of processors (desc%comm3) owning these X values.
  !
  !    The transpose takes place in two steps:
  !    1) on each processor the columns are sliced into sections along Z
  !       that are stored one after the other. On each processor, slices for
  !       processor "iproc3" are desc%nr3p(iproc3)*desc%nsw/nsp(me) big.
  !    2) all processors communicate to exchange slices (all columns with 
  !       Z in the slice belonging to "me" must be received, all the others 
  !       must be sent to "iproc3")
  !
  !    Finally one gets the "slice" representation: each processor has 
  !    desc%nr3p(mype3) Z values of all the active pencils along Y for the
  !    X values of the current group. Data are organized with the Y index
  !    running fastest, then the reordered X values, then Z.
  !
  !    f_in  contains the input Z columns, is destroyed on output
  !    f_aux contains the output Y colums.
  !
  !  b) From planes to columns (isgn < 0)
  !
  !    Quite the same in the opposite direction
  !    f_aux contains the input Y columns, is destroyed on output
  !    f_in  contains the output Z columns.
  !
  IMPLICIT NONE

  TYPE (fft_type_descriptor), INTENT(in) :: desc
  INTEGER, INTENT(in)           :: nxx_, isgn
  COMPLEX (DP), INTENT(inout)   :: f_in (nxx_), f_aux (nxx_)

#if defined(__MPI)
  !
  CALL start_clock ('fft_scatt_yz')

  if ( abs (isgn) == 1 ) then      ! It's a potential FFT
     CALL impl_yz(desc%mype2+1, desc%mype2+1, desc%nsp, desc%ir1p, desc%nsp_offset)
  else if ( abs (isgn) == 2 ) then ! It's a wavefunction FFT
     CALL impl_yz(desc%mype2+1, desc%mype2+1, desc%nsw, desc%ir1w, desc%nsw_offset)
  else if ( abs (isgn) == 3 ) then ! It's a wavefunction FFT with task group
     CALL impl_yz(1, desc%nproc2, desc%nsw, desc%ir1w_tg, desc%nsw_offset)
  end if

  CALL stop_clock ('fft_scatt_yz')

  RETURN

  CONTAINS

  SUBROUTINE impl_yz(me2_start, me2_end, ncp_, ir1p_, me2_iproc3_offset)
  IMPLICIT NONE
  !
  INTEGER, INTENT(in) :: me2_start, me2_end
  INTEGER, INTENT(in) :: ncp_(desc%nproc), ir1p_(desc%nr1x), me2_iproc3_offset(desc%nproc2, desc%nproc3)
  !
  INTEGER :: ierr, me2, me3, nproc3, iproc3, ncpx, nr3px, ip
  INTEGER :: i, it, k, kfrom, kdest, mc, m1, m2, i1, sendsize
  INTEGER :: my_nr1p_
  !
#if defined(__NON_BLOCKING_SCATTER)
  INTEGER :: sh(desc%nproc3), rh(desc%nproc3)
#endif
  !
  me3    = desc%mype3 + 1
  nproc3 = desc%nproc3
  !
  my_nr1p_ = count (ir1p_ > 0)
  !
  ! calculate the message size
  !
  nr3px = MAXVAL ( desc%nr3p )  ! maximum number of Z values to be exchanged
  ncpx  = MAXVAL ( ncp_ )       ! maximum number of Z columns to be exchanged
  sendsize = ncpx * nr3px * ( me2_end - me2_start + 1 )  ! dimension of the scattered chunks
  !
  ierr = 0
  IF (isgn.gt.0) THEN
     !
     IF (nproc3==1) GO TO 10
     !
     ! "forward" scatter from columns to planes
     !
     ! step one: store contiguously the slices
     !
!$omp parallel do collapse(3) private(kdest,kfrom)
     DO iproc3 = 1, nproc3
        DO me2 = me2_start, me2_end
           DO k = 0, ncpx-1   ! was ncp_(me3)
              IF (k>=ncp_(desc%iproc(me2,me3))) CYCLE ! control k from 0 to ncp_(desc%iproc(me2,me3))-1
              kdest = ( iproc3 - 1 ) * sendsize + nr3px * ( me2_iproc3_offset( me2 - me2_start + 1, me3 ) + k )
              kfrom = desc%nr3p_offset(iproc3) + desc%nr3x * ( me2_iproc3_offset( me2 - me2_start + 1, me3 ) + k )
              DO i = 1, desc%nr3p( iproc3 )
                 f_aux ( kdest + i ) =  f_in ( kfrom + i )
              ENDDO
           ENDDO
        ENDDO
     ENDDO
!$omp end parallel do
#if defined(__NON_BLOCKING_SCATTER)
     DO iproc3 = 1, nproc3
        CALL mpi_isend( f_aux( ( iproc3 - 1 ) * sendsize + 1 ), sendsize, &
                        MPI_DOUBLE_COMPLEX, iproc3-1, me3, desc%comm3, &
                        sh( iproc3 ), ierr )
     ENDDO
#endif
     !
     ! step two: communication  across the    nproc3    group
     !
#if defined(__NON_BLOCKING_SCATTER)
     DO iproc3 = 1, nproc3
        !
        ! now post the receive
        !
        CALL mpi_irecv( f_in( (iproc3-1)*sendsize + 1 ), sendsize, &
                        MPI_DOUBLE_COMPLEX, iproc3-1, MPI_ANY_TAG, &
                        desc%comm3, rh( iproc3 ), ierr )
        !IF( abs(ierr) /= 0 ) CALL fftx_error__ ('fft_scatter', ' forward receive info<>0', abs(ierr) )
        !
        !
     ENDDO
     
     call mpi_waitall( nproc3, sh, MPI_STATUSES_IGNORE, ierr )
     !
#else
     CALL mpi_alltoall (f_aux(1), sendsize, MPI_DOUBLE_COMPLEX, f_in(1), &
                        sendsize, MPI_DOUBLE_COMPLEX, desc%comm3, ierr)

     IF( abs(ierr) /= 0 ) CALL fftx_error__ ('fft_scatter', 'info<>0', abs(ierr) )
#endif     
     !
10   CONTINUE
     !
#if defined(__NON_BLOCKING_SCATTER)
     if (nproc3 > 1) call mpi_waitall( nproc3, rh, MPI_STATUSES_IGNORE, ierr )
#endif
     !
!$omp parallel
     ! ensures that no garbage is present in the output
     !
!$omp do
     DO k = 1, desc%my_nr3p*my_nr1p_*desc%nr2x
        f_aux(k) = (0.0_DP, 0.0_DP)
     ENDDO
!$omp end do
!$omp do collapse(3) private(ip,it,mc,m1,m2,i1)
     DO iproc3 = 1, desc%nproc3
        DO me2 = me2_start, me2_end
           DO i = 1, ncpx ! was ncp_(iproc3)
              ip = desc%iproc( me2, iproc3)
              IF ( i>ncp_(ip) ) CYCLE
              it = ( iproc3 - 1 ) * sendsize + nr3px * ( me2_iproc3_offset( me2 - me2_start + 1, iproc3 ) + i - 1 )
              mc = desc%ismap( i + desc%iss(ip) ) ! this is  m1+(m2-1)*nr1x  of the  current pencil
              m1 = mod (mc-1,desc%nr1x) + 1
              m2 = (mc-1)/desc%nr1x + 1
              i1 = m2 + ( ir1p_(m1) - 1 ) * desc%nr2x
              DO k = 1, desc%my_nr3p
                 f_aux( i1 ) = f_in( k + it )
                 i1 = i1 + desc%nr2x*my_nr1p_
              ENDDO
           ENDDO
        ENDDO
     ENDDO
!$omp end do nowait
!$omp end parallel
     !
  ELSE
     !
     !  "backward" scatter from planes to columns
     !
!$omp parallel do collapse(3) private(ip,it,mc,m1,m2,i1)
     DO iproc3 = 1, desc%nproc3
        DO me2 = me2_start, me2_end
           DO i = 1, ncpx
              ip = desc%iproc( me2, iproc3)
              IF ( i>ncp_(ip) ) CYCLE
              it = ( iproc3 - 1 ) * sendsize + nr3px * ( me2_iproc3_offset( me2 - me2_start + 1, iproc3 ) + i - 1 )
              mc = desc%ismap( i + desc%iss(ip) ) ! this is  m1+(m2-1)*nr1x  of the  current pencil
              m1 = mod (mc-1,desc%nr1x) + 1
              m2 = (mc-1)/desc%nr1x + 1
              i1 = m2 + ( ir1p_(m1) - 1 ) * desc%nr2x
              DO k = 1, desc%my_nr3p
                 f_in( k + it ) = f_aux( i1 )
                 i1 = i1 + desc%nr2x * my_nr1p_
              ENDDO
           ENDDO
        ENDDO
     ENDDO
!$omp end parallel do
#if defined(__NON_BLOCKING_SCATTER)
     DO iproc3 = 1, desc%nproc3
        IF( nproc3 > 1 ) CALL mpi_isend( f_in( ( iproc3 - 1 ) * sendsize + 1 ), &
                                        sendsize, MPI_DOUBLE_COMPLEX, iproc3-1, &
                                        me3, desc%comm3, sh( iproc3 ), ierr )
     ENDDO
#endif
     
     IF( nproc3 == 1 ) GO TO 20
     !
     !  step two: communication
     !
#if ! defined(__NON_BLOCKING_SCATTER)
     CALL mpi_alltoall (f_in(1), sendsize, MPI_DOUBLE_COMPLEX, f_aux(1), &
                        sendsize, MPI_DOUBLE_COMPLEX, desc%comm3, ierr)

     IF( abs(ierr) /= 0 ) CALL fftx_error__ ('fft_scatter', 'info<>0', abs(ierr) )
#else
     DO iproc3 = 1, desc%nproc3
        CALL mpi_irecv( f_aux( (iproc3-1)*sendsize + 1 ), sendsize, &
                        MPI_DOUBLE_COMPLEX, iproc3-1, MPI_ANY_TAG, &
                        desc%comm3, rh(iproc3), ierr )
        ! IF( abs(ierr) /= 0 ) CALL fftx_error__ ('fft_scatter', ' backward receive info<>0', abs(ierr) )
     ENDDO
        
     call mpi_waitall( desc%nproc3, sh, MPI_STATUSES_IGNORE, ierr )
     call mpi_waitall( desc%nproc3, rh, MPI_STATUSES_IGNORE, ierr )
#endif
     !
     !  step one: store contiguously the columns
     !
!$omp parallel do collapse(3) private(kdest,kfrom)
     DO iproc3 = 1, nproc3
        DO me2 = me2_start, me2_end
           DO k = 0, ncpx-1   ! was ncp_(me3)
              IF (k>=ncp_(desc%iproc(me2,me3))) CYCLE ! control k from 0 to ncp_(desc%iproc(me2,me3))-1
              kdest = ( iproc3 - 1 ) * sendsize + nr3px * ( me2_iproc3_offset( me2 - me2_start + 1, me3 ) + k )
              kfrom = desc%nr3p_offset(iproc3) + desc%nr3x * ( me2_iproc3_offset( me2 - me2_start + 1, me3 ) + k )
              DO i = 1, desc%nr3p( iproc3 )
                 f_in ( kfrom + i ) = f_aux ( kdest + i )
              ENDDO
           ENDDO
        ENDDO
     ENDDO
!$omp end parallel do

     ! clean extra array elements in each stick

     IF( desc%nr3x /= desc%nr3 ) THEN
        DO k = 1, ncp_(desc%mype+1)
           f_in(desc%nr3x*(k-1)+desc%nr3+1:desc%nr3x*k) = (0.0_DP, 0.0_DP)
        END DO
     END IF

20   CONTINUE

  ENDIF

  END SUBROUTINE impl_yz

#endif

END SUBROUTINE fft_scatter_yz
!
!-----------------------------------------------------------------------
SUBROUTINE fft_scatter_tg ( desc, f_in, f_aux, nxx_, isgn )
  !-----------------------------------------------------------------------
  !
  ! task group wavefunction redistribution
  !
  ! a) (isgn >0 ) From many-wfc partial-plane arrangement to single-wfc whole-plane one
  !
  ! b) (isgn <0 ) From single-wfc whole-plane arrangement to many-wfc partial-plane one
  !
  ! in both cases:
  !    f_in  contains the input data, is overwritten with the desired output
  !    f_aux is used as working array, may contain garbage in output
  !
  IMPLICIT NONE

  TYPE (fft_type_descriptor), INTENT(in) :: desc
  INTEGER, INTENT(in)           :: nxx_, isgn
  COMPLEX (DP), INTENT(inout)   :: f_in (nxx_), f_aux (nxx_)

  INTEGER :: ierr

  CALL start_clock ('fft_scatt_tg')

  if ( abs (isgn) /= 3 ) call fftx_error__ ('fft_scatter_tg', 'wrong call', 1 )

#if defined(__MPI)
  !
  f_aux = f_in
  if ( isgn > 0 ) then

     CALL MPI_ALLTOALLV( f_aux,  desc%tg_snd, desc%tg_sdsp, MPI_DOUBLE_COMPLEX, &
                         f_in, desc%tg_rcv, desc%tg_rdsp, MPI_DOUBLE_COMPLEX, desc%comm2, ierr)
     IF( ierr /= 0 ) CALL fftx_error__( 'fft_scatter_tg', ' alltoall error 1 ', abs(ierr) )

  else

     CALL MPI_ALLTOALLV( f_aux,  desc%tg_rcv, desc%tg_rdsp, MPI_DOUBLE_COMPLEX, &
                         f_in, desc%tg_snd, desc%tg_sdsp, MPI_DOUBLE_COMPLEX, desc%comm2, ierr)
     IF( ierr /= 0 ) CALL fftx_error__( 'fft_scatter_tg', ' alltoall error 2 ', abs(ierr) )
   end if

#endif
  CALL stop_clock ('fft_scatt_tg')

  RETURN

END SUBROUTINE fft_scatter_tg
!
!-----------------------------------------------------------------------
SUBROUTINE fft_scatter_tg_opt ( desc, f_in, f_out, nxx_, isgn )
  !-----------------------------------------------------------------------
  !
  ! task group wavefunction redistribution
  !
  ! a) (isgn >0 ) From many-wfc partial-plane arrangement to single-wfc whole-plane one
  !
  ! b) (isgn <0 ) From single-wfc whole-plane arrangement to many-wfc partial-plane one
  !
  ! in both cases:
  !    f_in  contains the input data
  !    f_out contains the output data
  !
  IMPLICIT NONE

  TYPE (fft_type_descriptor), INTENT(in) :: desc
  INTEGER, INTENT(in)           :: nxx_, isgn
  COMPLEX (DP), INTENT(inout)   :: f_in (nxx_), f_out (nxx_)

  INTEGER :: ierr

  CALL start_clock ('fft_scatt_tg')

  if ( abs (isgn) /= 3 ) call fftx_error__ ('fft_scatter_tg', 'wrong call', 1 )

#if defined(__MPI)
  !
  if ( isgn > 0 ) then

     CALL MPI_ALLTOALLV( f_in,  desc%tg_snd, desc%tg_sdsp, MPI_DOUBLE_COMPLEX, &
                         f_out, desc%tg_rcv, desc%tg_rdsp, MPI_DOUBLE_COMPLEX, desc%comm2, ierr)
     IF( ierr /= 0 ) CALL fftx_error__( 'fft_scatter_tg', ' alltoall error 1 ', abs(ierr) )

  else

     CALL MPI_ALLTOALLV( f_in,  desc%tg_rcv, desc%tg_rdsp, MPI_DOUBLE_COMPLEX, &
                         f_out, desc%tg_snd, desc%tg_sdsp, MPI_DOUBLE_COMPLEX, desc%comm2, ierr)
     IF( ierr /= 0 ) CALL fftx_error__( 'fft_scatter_tg', ' alltoall error 2 ', abs(ierr) )
   end if

#endif
  CALL stop_clock ('fft_scatt_tg')

  RETURN

END SUBROUTINE fft_scatter_tg_opt
!
!----------------------------------------------------------------------------
SUBROUTINE gather_real_grid ( dfft, f_in, f_out )
  !----------------------------------------------------------------------------
  !
  ! ... gathers a distributed real-space FFT grid to dfft%root, that is,
  ! ... the first processor of input descriptor dfft - version for real arrays
  !
  ! ... REAL*8  f_in  = distributed variable (dfft%nnr)
  ! ... REAL*8  f_out = gathered variable (dfft%nr1x*dfft%nr2x*dfft%nr3x)
  !
  IMPLICIT NONE
  !
  REAL(DP), INTENT(in) :: f_in (:)
  REAL(DP), INTENT(inout):: f_out(:)
  TYPE ( fft_type_descriptor ), INTENT(IN) :: dfft
  !
#if defined(__MPI)
  !
  INTEGER :: proc, info, offset_in, offset_aux, ir3
  ! ... the following are automatic arrays
  INTEGER :: displs(0:dfft%nproc-1), recvcount(0:dfft%nproc-1)
  REAL(DP), ALLOCATABLE ::  f_aux(:) 
  !
  IF( size( f_in ) < dfft%nnr ) &
     CALL fftx_error__( ' gather_real_grid ', ' f_in too small ', dfft%nnr-size( f_in ) )
  !
  CALL start_clock( 'rgather_grid' )

  !write (6,*) 'gather grid ok 0 ', dfft%nproc, dfft%nproc2, dfft%nproc3
  ALLOCATE ( f_aux(dfft%nr1x * dfft%nr2x * dfft%my_nr3p) )
  ! 1) gather within the comm2 communicator
  displs = 0
  DO proc =0, ( dfft%nproc2 -1 )
     recvcount(proc) = dfft%nr1x * dfft%nr2p(proc+1) 
     if (proc > 0) displs(proc) = displs(proc-1) + recvcount(proc-1)
  end do
  offset_in = 1; offset_aux = 1
  do ir3 = 1, dfft%my_nr3p
    !write (6,*) 'gather grid ok 1 ir3=', ir3
     info = 0
     CALL MPI_GATHERV( f_in(offset_in) , recvcount(dfft%mype2), MPI_DOUBLE_PRECISION, &
                       f_aux(offset_aux), recvcount, displs, MPI_DOUBLE_PRECISION, dfft%root,      &
                       dfft%comm2, info )
     CALL fftx_error__( 'gather_real_grid', 'info<>0', info )
    !write (6,*) 'gather grid ok 2 ir3=', ir3
     offset_in  = offset_in + dfft%nr1x * dfft%my_nr2p
     offset_aux = offset_aux + dfft%nr1x * dfft%nr2
  end do

  ! 2) gather within the comm3 communicator 
  displs = 0
  DO proc = 0, ( dfft%nproc3 - 1 )
     recvcount(proc) = dfft%nr1x * dfft%nr2x * dfft%nr3p(proc+1) 
     if (proc > 0) displs(proc) = displs(proc-1) + recvcount(proc-1)
  ENDDO
  info = 0
  !write (6,*) 'gather grid ok 3'
  CALL MPI_GATHERV( f_aux, recvcount(dfft%mype3), MPI_DOUBLE_PRECISION, &
                    f_out, recvcount, displs, MPI_DOUBLE_PRECISION, dfft%root,      &
                    dfft%comm3, info )
  !write (6,*) 'gather grid ok 4'
  CALL fftx_error__( ' gather_real_grid', 'info<>0', info )
  !
  ! ... the following check should be performed only on processor dfft%root
  ! ... otherwise f_out must be allocated on all processors even if not used
  !
  info = size( f_out ) - displs( dfft%nproc3-1 ) - recvcount( dfft%nproc3-1 )
  !qepy --> only check root processor
  CALL mp_bcast( info, dfft%root, dfft%comm)
  !qepy <-- only check root processor
  IF( info < 0 ) &
     CALL fftx_error__( ' gather_real_grid ', ' f_out too small ', -info )
  !
  DEALLOCATE ( f_aux )
  !
  CALL stop_clock( 'rgather_grid' )
  !
#else
  CALL fftx_error__(' gather_real_grid', 'do not use in serial execution', 1)
#endif
  !
  RETURN
  !
END SUBROUTINE gather_real_grid

!----------------------------------------------------------------------------
SUBROUTINE gather_complex_grid ( dfft, f_in, f_out )
  !----------------------------------------------------------------------------
  !
  ! ... gathers a distributed real-space FFT grid to dfft%root, that is,
  ! ... the first processor of input descriptor dfft - complex arrays
  !
  ! ... COMPLEX*16  f_in  = distributed variable (dfft%nnr)
  ! ... COMPLEX*16  f_out = gathered variable (dfft%nr1x*dfft%nr2x*dfft%nr3x)
  !
  IMPLICIT NONE
  !
  COMPLEX(DP), INTENT(in) :: f_in (:)
  COMPLEX(DP), INTENT(inout):: f_out(:)
  TYPE ( fft_type_descriptor ), INTENT(IN) :: dfft
  COMPLEX(DP), ALLOCATABLE ::  f_aux(:) 
  !
#if defined(__MPI)
  !
  INTEGER :: proc, info, offset_in, offset_aux, ir3
  ! ... the following are automatic arrays
  INTEGER :: displs(0:dfft%nproc-1), recvcount(0:dfft%nproc-1)
  !
  
  CALL start_clock( 'cgather_grid' )
  !write (*,*) 'gcgather_grid size(f_in),dfft%nnr',size(f_in), dfft%nnr ; FLUSH(6)
  IF( 2*size( f_in ) < dfft%nnr ) &
     CALL fftx_error__( ' gather_complex_grid ', ' f_in too small ', dfft%nnr-size( f_in ) )
  !
  !write (6,*) 'gather grid ok 0 ', dfft%nproc, dfft%nproc2, dfft%nproc3
  ALLOCATE ( f_aux(dfft%nr1x * dfft%nr2x * dfft%my_nr3p ) )
  ! 1) gather within the comm2 communicator
  displs = 0
  DO proc =0, ( dfft%nproc2 -1 )
     recvcount(proc) = 2 * dfft%nr1x * dfft%nr2p(proc+1) 
     if (proc > 0) displs(proc) = displs(proc-1) + recvcount(proc-1)
  end do
  offset_in = 1; offset_aux = 1
  do ir3 = 1, dfft%my_nr3p
     info = 0
     !write (6,*) 'gather grid ok 1 ir3=', ir3
     CALL MPI_GATHERV( f_in(offset_in) , recvcount(dfft%mype2), MPI_DOUBLE_PRECISION, &
                       f_aux(offset_aux), recvcount, displs, MPI_DOUBLE_PRECISION, dfft%root,      &
                       dfft%comm2, info )
     CALL fftx_error__( 'gather_complex_grid', 'info<>0', info )
     !write (6,*) 'gather grid ok 2 ir3=', ir3
     offset_in  = offset_in + dfft%nr1x * dfft%my_nr2p
     offset_aux = offset_aux + dfft%nr1x * dfft%nr2
  end do

  ! 2) gather within the comm3 communicator 
  displs = 0
  DO proc = 0, ( dfft%nproc3 - 1 )
     recvcount(proc) = 2 * dfft%nr1x * dfft%nr2x * dfft%nr3p(proc+1) 
     if (proc > 0) displs(proc) = displs(proc-1) + recvcount(proc-1)
  ENDDO
  !
  ! ... the following check should be performed only on processor dfft%root
  ! ... otherwise f_out must be allocated on all processors even if not used
  !
  !write (*,*) 'gcgather_grid 2*size(f_out)',2*size(f_out) ; FLUSH(6)
  !write (*,*) 'gcgather_grid displ+recv',dfft%nproc3, displs(dfft%nproc3-1) + recvcount(dfft%nproc3-1); FLUSH(6)
  info = 2*size( f_out ) - displs( dfft%nproc3 - 1 ) - recvcount( dfft%nproc3-1 ) ; FLUSH(6)
  !qepy --> only check root processor
  CALL mp_bcast( info, dfft%root, dfft%comm)
  !qepy <-- only check root processor
  IF( info < 0 ) CALL fftx_error__( ' gather_complex_grid ', ' f_out too small ', -info )

  info = 0
  !write (6,*) 'gather grid ok 3'
  CALL MPI_GATHERV( f_aux, recvcount(dfft%mype3), MPI_DOUBLE_PRECISION, &
                    f_out, recvcount, displs, MPI_DOUBLE_PRECISION, dfft%root,      &
                    dfft%comm3, info )
  !write (6,*) 'gather grid ok 4'
  CALL fftx_error__( 'gather_complex_grid', 'info<>0', info )
  !
  DEALLOCATE ( f_aux )
  !
  CALL stop_clock( 'cgather_grid' )
  !
#else
  CALL fftx_error__('gather_complex_grid', 'do not use in serial execution', 1)
#endif
  !
  RETURN
  !
END SUBROUTINE gather_complex_grid

!----------------------------------------------------------------------------
SUBROUTINE scatter_real_grid ( dfft, f_in, f_out )
  !----------------------------------------------------------------------------
  !
  ! ... scatters a real-space FFT grid from dfft%root, first processor of
  ! ... input descriptor dfft, to all others - opposite of "gather_grid"
  !
  ! ... REAL*8  f_in  = gathered variable (dfft%nr1x*dfft%nr2x*dfft%nr3x)
  ! ... REAL*8  f_out = distributed variable (dfft%nnr)
  !
  IMPLICIT NONE
  !
  REAL(DP), INTENT(in) :: f_in (:)
  REAL(DP), INTENT(inout):: f_out(:)
  TYPE ( fft_type_descriptor ), INTENT(IN) :: dfft
  REAL(DP), ALLOCATABLE ::  f_aux(:) 
  !
#if defined(__MPI)
  !
  INTEGER :: proc, info, offset_in, offset_aux, ir3
  ! ... the following are automatic arrays
  INTEGER :: displs(0:dfft%nproc-1), sendcount(0:dfft%nproc-1)
  !
  !
  CALL start_clock( 'rscatter_grid' )
  !
  !write (6,*) 'scatter grid ok 0'
  ALLOCATE ( f_aux(dfft%nr1x * dfft%nr2x * dfft%my_nr3p) )
  ! 1) scatter within the comm3 communicator 
  displs = 0
  DO proc = 0, ( dfft%nproc3 - 1 )
     sendcount(proc) = dfft%nr1x * dfft%nr2x * dfft%nr3p(proc+1) 
     if (proc > 0) displs(proc) = displs(proc-1) + sendcount(proc-1)
  ENDDO
  info = size( f_in ) - displs( dfft%nproc3 - 1 ) - sendcount( dfft%nproc3 - 1 )
  !qepy --> only check root processor
  CALL mp_bcast( info, dfft%root, dfft%comm)
  !qepy <-- only check root processor
  IF( info < 0 ) CALL fftx_error__( ' scatter_real_grid ', ' f_in too small ', -info )
  info = 0
  !write (6,*) 'scatter grid ok 1'
  CALL MPI_SCATTERV( f_in, sendcount, displs, MPI_DOUBLE_PRECISION,   &
                     f_aux, sendcount(dfft%mype3), MPI_DOUBLE_PRECISION, &
                     dfft%root, dfft%comm3, info )
  !write (6,*) 'scatter grid ok 2'
  CALL fftx_error__( 'scatter_real_grid', 'info<>0', info )

  ! 2) scatter within the comm2 communicator
  IF( size( f_out ) < dfft%nnr ) &
     CALL fftx_error__( ' scatter_real_grid ', ' f_out too small ', dfft%nnr-size( f_out ) )
  !
  displs = 0 ; f_out = 0.0D0
  DO proc =0, ( dfft%nproc2 -1 )
     sendcount(proc) = dfft%nr1x * dfft%nr2p(proc+1) 
     if (proc > 0) displs(proc) = displs(proc-1) + sendcount(proc-1)
  end do
  offset_in = 1 ; offset_aux = 1
  do ir3 = 1, dfft%my_nr3p
     info = 0
  !write (6,*) 'scatter grid ok 3, ir3=', ir3
     CALL MPI_SCATTERV( f_aux(offset_aux), sendcount, displs, MPI_DOUBLE_PRECISION,   &
                        f_out(offset_in), sendcount(dfft%mype2), MPI_DOUBLE_PRECISION, &
                        dfft%root, dfft%comm2, info )
  !write (6,*) 'scatter grid ok 4, ir3=', ir3
     CALL fftx_error__( 'scatter_real_grid', 'info<>0', info )
     offset_in  = offset_in + dfft%nr1x * dfft%my_nr2p
     offset_aux = offset_aux + dfft%nr1x * dfft%nr2
  end do
  !
  DEALLOCATE ( f_aux )
  !
  CALL stop_clock( 'rscatter_grid' )
  !
#else
  CALL fftx_error__('scatter_real_grid', 'do not use in serial execution', 1)
#endif
  !
  RETURN
  !
END SUBROUTINE scatter_real_grid
!----------------------------------------------------------------------------
SUBROUTINE scatter_complex_grid ( dfft, f_in, f_out )
  !----------------------------------------------------------------------------
  !
  ! ... scatters a real-space FFT grid from dfft%root, first processor of
  ! ... input descriptor dfft, to all others - opposite of "gather_grid"
  !
  ! ... COMPLEX*16  f_in  = gathered variable (dfft%nr1x*dfft%nr2x*dfft%nr3x)
  ! ... COMPLEX*16  f_out = distributed variable (dfft%nnr)
  !
  IMPLICIT NONE
  !
  COMPLEX(DP), INTENT(in) :: f_in (:)
  COMPLEX(DP), INTENT(inout):: f_out(:)
  TYPE ( fft_type_descriptor ), INTENT(IN) :: dfft
  COMPLEX(DP), ALLOCATABLE ::  f_aux(:) 
  !
#if defined(__MPI)
  !
  INTEGER :: proc, info, offset_in, offset_aux, ir3
  ! ... the following are automatic arrays
  INTEGER :: displs(0:dfft%nproc-1), sendcount(0:dfft%nproc-1)
  !
  CALL start_clock( 'cscatter_grid' )
  !
  !write (6,*) 'scatter grid ok 0'
  ALLOCATE ( f_aux(dfft%nr1x * dfft%nr2x * dfft%my_nr3p ) )
  ! 1) scatter within the comm3 communicator 
  displs = 0
  DO proc = 0, ( dfft%nproc3 - 1 )
     sendcount(proc) = 2 * dfft%nr1x * dfft%nr2x * dfft%nr3p(proc+1) 
     if (proc > 0) displs(proc) = displs(proc-1) + sendcount(proc-1)
  ENDDO
  !
  !write(*,*) 'cscatter_grid 2*size(f_in) ', 2*size(f_in); FLUSH(6)
  !write(*,*) 'cscatter_grid displ+send ', dfft%nproc3, displs(dfft%nproc3-1) + sendcount(dfft%nproc3-1); FLUSH(6)
  info = 2*size( f_in ) - displs( dfft%nproc3 - 1 ) - sendcount( dfft%nproc3 - 1 )
  !qepy --> only check root processor
  CALL mp_bcast( info, dfft%root, dfft%comm)
  !qepy <-- only check root processor
  IF( info < 0 ) &
     CALL fftx_error__( ' scatter_complex_grid ', ' f_in too small ', -info )
  !
  info = 0
  !write (6,*) 'scatter grid ok 1'
  CALL MPI_SCATTERV( f_in, sendcount, displs, MPI_DOUBLE_PRECISION,   &
                     f_aux, sendcount(dfft%mype3), MPI_DOUBLE_PRECISION, &
                     dfft%root, dfft%comm3, info )
  !write (6,*) 'scatter grid ok 2'
  CALL fftx_error__( ' scatter_complex_grid', 'info<>0', info )

  ! 2) scatter within the comm2 communicator
  !write(*,*) 'cscatter_grid size(f_out), dfft%nnr ', size(f_out),dfft%nnr; FLUSH(6)
  IF( size( f_out ) < dfft%nnr ) &
     CALL fftx_error__( ' scatter_complex_grid ', ' f_out too small ', dfft%nnr-size( f_out ) )
  !
  displs = 0 ; f_out = 0.0D0
  DO proc =0, ( dfft%nproc2 -1 )
     sendcount(proc) = 2 * dfft%nr1x * dfft%nr2p(proc+1) 
     if (proc > 0) displs(proc) = displs(proc-1) + sendcount(proc-1)
  end do
  offset_in = 1 ; offset_aux = 1
  do ir3 = 1, dfft%my_nr3p
     info = 0
  !write (6,*) 'scatter grid ok 3, ir3=', ir3
     CALL MPI_SCATTERV( f_aux(offset_aux), sendcount, displs, MPI_DOUBLE_PRECISION,   &
                        f_out(offset_in), sendcount(dfft%mype2), MPI_DOUBLE_PRECISION, &
                        dfft%root, dfft%comm2, info )
  !write (6,*) 'scatter grid ok 4, ir3=', ir3
     CALL fftx_error__( 'scatter_complex_grid', 'info<>0', info )
     offset_in  = offset_in + dfft%nr1x * dfft%my_nr2p
     offset_aux = offset_aux + dfft%nr1x * dfft%nr2x
  end do
  !
  ! ... the following check should be performed only on processor dfft%root
  ! ... otherwise f_in must be allocated on all processors even if not used
  !
  DEALLOCATE ( f_aux )
  !
  CALL stop_clock( 'cscatter_grid' )
  !
#else
  CALL fftx_error__('scatter_complex_grid', 'do not use in serial execution', 1)
#endif
  !
  RETURN
  !
END SUBROUTINE scatter_complex_grid
!
! ... "gather"-like subroutines
!
!-----------------------------------------------------------------------
SUBROUTINE cgather_sym( dfftp, f_in, f_out )
  !-----------------------------------------------------------------------
  !
  ! ... gather complex data for symmetrization (used in phonon code)
  ! ... Differs from gather_grid because mpi_allgatherv is used instead
  ! ... of mpi_gatherv - all data is gathered on ALL processors
  ! ... COMPLEX*16  f_in  = distributed variable (nrxx)
  ! ... COMPLEX*16  f_out = gathered variable (nr1x*nr2x*nr3x)
  !
  IMPLICIT NONE
  !
  TYPE (fft_type_descriptor), INTENT(in) :: dfftp
  COMPLEX(DP) :: f_in( : ), f_out(:)
  COMPLEX(DP), ALLOCATABLE ::  f_aux(:) 
  !
#if defined(__MPI)
  !
  INTEGER :: proc, info, offset_in, offset_aux, ir3
  ! ... the following are automatic arrays
  INTEGER :: displs(0:dfftp%nproc-1), recvcount(0:dfftp%nproc-1)
  !
  CALL start_clock( 'cgather' )

  ALLOCATE ( f_aux(dfftp%nr1x * dfftp%nr2x * dfftp%my_nr3p ) )
  !
  CALL MPI_BARRIER( dfftp%comm, info )
  !
  ! 1) gather within the comm2 communicator
  displs = 0
  DO proc =0, ( dfftp%nproc2 -1 )
     recvcount(proc) = 2 * dfftp%nr1x * dfftp%nr2p(proc+1) 
     if (proc > 0) displs(proc) = displs(proc-1) + recvcount(proc-1)
  end do
  offset_in = 1; offset_aux = 1
  do ir3 = 1, dfftp%my_nr3p
     info = 0
     CALL MPI_ALLGATHERV( f_in(offset_in), recvcount(dfftp%mype2), MPI_DOUBLE_PRECISION, &
                          f_aux(offset_aux),recvcount, displs, MPI_DOUBLE_PRECISION, &
                          dfftp%comm2, info )
     CALL fftx_error__( 'cgather_sym', 'info<>0', info )
     offset_in  = offset_in  + dfftp%nr1x * dfftp%my_nr2p
     offset_aux = offset_aux + dfftp%nr1x * dfftp%nr2x
  end do

  ! 2) gather within the comm3 communicator 
  displs = 0
  DO proc = 0, ( dfftp%nproc3 - 1 )
     recvcount(proc) = 2 * dfftp%nr1x * dfftp%nr2x * dfftp%nr3p(proc+1) 
     if (proc > 0) displs(proc) = displs(proc-1) + recvcount(proc-1)
  ENDDO
  info = 0
  CALL MPI_ALLGATHERV( f_aux, recvcount(dfftp%mype3), MPI_DOUBLE_PRECISION, &
                       f_out, recvcount, displs, MPI_DOUBLE_PRECISION, &
                       dfftp%comm3, info )
  CALL fftx_error__( 'cgather_sym', 'info<>0', info )
  !
  ! ... the following check should be performed only on processor dfft%root
  ! ... otherwise f_out must be allocated on all processors even if not used
  !
  DEALLOCATE ( f_aux )
  !
  CALL stop_clock( 'cgather' )
  !
#else
  CALL fftx_error__('cgather_sym', 'do not use in serial execution', 1)
#endif
  !
  RETURN
  !
END SUBROUTINE cgather_sym
!
!
!-----------------------------------------------------------------------
SUBROUTINE cgather_sym_many( dfftp, f_in, f_out, nbnd, nbnd_proc, start_nbnd_proc )
  !-----------------------------------------------------------------------
  !
  ! ... Written by A. Dal Corso
  !
  ! ... This routine generalizes cgather_sym, receiveng nbnd complex 
  ! ... distributed functions and collecting nbnd_proc(dfftp%mype+1) 
  ! ... functions in each processor.
  ! ... start_nbnd_proc(dfftp%mype+1), says where the data for each processor
  ! ... start in the distributed variable
  ! ... COMPLEX*16  f_in  = distributed variable (nrxx,nbnd)
  ! ... COMPLEX*16  f_out = gathered variable (nr1x*nr2x*nr3x,nbnd_proc(dfftp%mype+1))
  !
  IMPLICIT NONE
  !
  TYPE (fft_type_descriptor), INTENT(in) :: dfftp
  INTEGER :: nbnd, nbnd_proc(dfftp%nproc), start_nbnd_proc(dfftp%nproc)
  COMPLEX(DP) :: f_in(dfftp%nnr,nbnd)
  COMPLEX(DP) :: f_out(dfftp%nr1x*dfftp%nr2x*dfftp%nr3x,nbnd_proc(dfftp%mype+1))
  COMPLEX(DP), ALLOCATABLE ::  f_aux(:) 
  !
#if defined(__MPI)
  !
  INTEGER :: proc_, proc2_, proc3_, proc, info, offset_in, offset_aux, ir3, nr2px
  INTEGER :: ibnd, jbnd, iii
  INTEGER :: displs(0:dfftp%nproc-1), recvcount(0:dfftp%nproc-1)
  !
  !
  CALL start_clock( 'cgather' )
  !
  ALLOCATE ( f_aux(dfftp%nr1x * dfftp%nr2x * dfftp%my_nr3p ) )
  !
  CALL MPI_BARRIER( dfftp%comm, info )
  !
  f_out = (0.d0,0.d0)

  !write (*,*) 'enter cgather ', nbnd
  !write (*,*) nbnd_proc
  !write (*,*) start_nbnd_proc
  !write (*,*) 'dfftp%nproc',dfftp%nproc 
  !do ibnd =1,3
  !write (*,*) 'evc = ',ibnd
  !write (*,*) f_in(1:3,ibnd)
  !end do


  nr2px = MAXVAL ( dfftp%nr2p )  ! maximum number of Y values to be disributed

  DO proc_ = 0, dfftp%nproc - 1
     ! define the processor index of the two sub-communicators
     proc2_ = dfftp%iproc2(proc_ + 1) -1 ; proc3_ = dfftp%iproc3(proc_ + 1) -1
     !write (*,*) ' proc_, proc2_, proc3_, dfftp%mype2', proc_, proc2_, proc3_, dfftp%mype2
     DO ibnd = 1, nbnd_proc(proc_ +1)
        jbnd = start_nbnd_proc(proc_ +1) + ibnd - 1
        !write (*,*) ' proc_, ibnd, jbnd ', proc_, ibnd, jbnd
        f_aux(:) = (0.d0,0.d0)
        ! 1) gather within the comm2 communicator
        displs = 0
        DO proc =0, ( dfftp%nproc2 -1 )
           recvcount(proc) = 2 * dfftp%nr1x * dfftp%nr2p(proc+1)
           if (proc > 0) displs(proc) = displs(proc-1) + recvcount(proc-1)
        end do
        !write (*,*) 'dfftp%nr1x ', dfftp%nr1x
        !write (*,*) 'dfftp%nr2x ', dfftp%nr2x
        !write (*,*) 'dfftp%nr3x ', dfftp%nr3x
        !write (*,*) 'dfftp%nr2p ', dfftp%nr2p, ' nnr3px ', nr2px
        !write (*,*) 'recvcount ', recvcount(0:dfftp%nproc2 -1)
        !write (*,*) 'displs ', displs(0:dfftp%nproc2 -1)
        offset_in = 1; offset_aux = 1
        do ir3 = 1, dfftp%my_nr3p
           info = 0
           CALL MPI_GATHERV( f_in(offset_in,jbnd), recvcount(dfftp%mype2), MPI_DOUBLE_PRECISION, &
                             f_aux(offset_aux), recvcount, displs, MPI_DOUBLE_PRECISION, &
                             proc2_, dfftp%comm2, info )
           CALL fftx_error__( 'cgather_sym_many', 'info<>0', info )
           offset_in  = offset_in  + dfftp%nr1x * dfftp%my_nr2p
           offset_aux = offset_aux + dfftp%nr1x * dfftp%nr2x
        end do
        !write(*,*) ' -> f_in(...+1:...+3,jbnd) ',jbnd
        !offset_in = 0
        !do iii =1,2*dfftp%nr2x
        !   write(*,'(i4,3("(",2f10.7,") "))') iii, f_in(offset_in+1:offset_in+3, jbnd)
        !   offset_in  = offset_in  + dfftp%nr1x 
        !enddo
        IF (dfftp%mype2==proc2_) THEN
        !   write(*,*) ' -> f_aux(...+1:...+3)'
        !   offset_aux = 0
        !   do iii =1,4*dfftp%nr2x
        !      write(*,'(i4,3("(",2f10.7,") "))') iii, f_aux(offset_aux+1:offset_aux+3)
        !      offset_aux = offset_aux + dfftp%nr1x
        !   enddo
        !   write(*,*) ' -> F_AUX(...+1:...+3)'
        !   offset_aux = 0
        !   do iii =1,dfftp%my_nr3p
        !      write(*,'(i4,3("(",2f10.7,") "))') iii, f_aux(offset_aux+1:offset_aux+3)
        !      offset_aux  = offset_aux  + dfftp%nr1x*dfftp%nr2x
        !   enddo
           ! 2) gather within the comm3 communicator 
           displs = 0
           DO proc = 0, ( dfftp%nproc3 - 1 )
              recvcount(proc) = 2 * dfftp%nr1x * dfftp%nr2x * dfftp%nr3p(proc+1) 
              if (proc > 0) displs(proc) = displs(proc-1) + recvcount(proc-1)
           ENDDO
           info = 0
           CALL MPI_GATHERV( f_aux, recvcount(dfftp%mype3), MPI_DOUBLE_PRECISION, &
                             f_out(1,ibnd), recvcount, displs, MPI_DOUBLE_PRECISION, &
                             proc3_, dfftp%comm3, info )
           CALL fftx_error__( 'cgather_sym_many', 'info<>0', info )
   
        !   IF (dfftp%mype3==proc3_) THEN
        !      write(*,*) ' -> f_out(...+1:...+3,ibnd) ',ibnd
        !      offset_in  = 0
        !      do iii =1,dfftp%nr3x
        !         write(*,'(i4,3("(",2f10.7,") "))') iii, f_out(offset_in+1:offset_in+3, ibnd)
        !         offset_in  = offset_in  + dfftp%nr1x*dfftp%nr2x
        !      enddo
        !   END IF
        END IF

     END DO
  END DO
  !
  DEALLOCATE ( f_aux )
  !
  CALL stop_clock( 'cgather' )
  !
#else
  CALL fftx_error__('cgather_sym_many', 'do not use in serial execution', 1)
#endif
  !
  RETURN
  !
END SUBROUTINE cgather_sym_many
!
!----------------------------------------------------------------------------
SUBROUTINE cscatter_sym_many( dfftp, f_in, f_out, target_ibnd, nbnd, nbnd_proc, &
                              start_nbnd_proc   )
  !----------------------------------------------------------------------------
  !
  ! ... Written by A. Dal Corso
  !
  ! ... generalizes cscatter_sym. It assumes that each processor has
  ! ... a certain number of bands (nbnd_proc(dfftp%mype+1)). The processor 
  ! ... that has target_ibnd scatters it to all the other processors 
  ! ... that receive a distributed part of the target function. 
  ! ... start_nbnd_proc(dfftp%mype+1) is used to identify the processor
  ! ... that has the required band
  !
  ! ... COMPLEX*16  f_in  = gathered variable (nr1x*nr2x*nr3x, nbnd_proc(dfftp%mype+1) )
  ! ... COMPLEX*16  f_out = distributed variable (nrxx)
  !
  IMPLICIT NONE
  !
  TYPE (fft_type_descriptor), INTENT(in) :: dfftp
  INTEGER :: nbnd, nbnd_proc(dfftp%nproc), start_nbnd_proc(dfftp%nproc)
  COMPLEX(DP) :: f_in(dfftp%nr1x*dfftp%nr2x*dfftp%nr3x,nbnd_proc(dfftp%mype+1))
  COMPLEX(DP) :: f_out(dfftp%nnr)
  COMPLEX(DP), ALLOCATABLE ::  f_aux(:) 
  INTEGER :: target_ibnd
  !
#if defined(__MPI)
  !
  INTEGER :: proc_, proc2_, proc3_, proc, info, offset_out, offset_aux, ir3
  INTEGER :: displs(0:dfftp%nproc-1), sendcount(0:dfftp%nproc-1)
  INTEGER :: ibnd, jbnd
  !
  CALL start_clock( 'cscatter_sym' )
  !
  ALLOCATE ( f_aux(dfftp%nr1x * dfftp%nr2x * dfftp%my_nr3p ) )
  !
  f_out = (0.0_DP, 0.0_DP)
  !
  CALL MPI_BARRIER( dfftp%comm, info )
  !
  DO proc_ = 0, dfftp%nproc - 1
     ! define the processor index of the two sub-communicators
     proc2_ = dfftp%iproc2(proc_ + 1) -1 ; proc3_ = dfftp%iproc3(proc_ + 1) -1
     DO ibnd = 1, nbnd_proc(proc_+1)
        jbnd = start_nbnd_proc(proc_+1) + ibnd - 1
        IF (jbnd/=target_ibnd) CYCLE
        IF (dfftp%mype2==proc2_) THEN
           ! 1) scatter within the comm3 communicator 
           displs = 0
           DO proc = 0, ( dfftp%nproc3 - 1 )
              sendcount(proc) = 2 * dfftp%nr1x * dfftp%nr2x * dfftp%nr3p(proc+1) 
              if (proc > 0) displs(proc) = displs(proc-1) + sendcount(proc-1)
           ENDDO
           info = 0
           CALL MPI_SCATTERV( f_in(1,ibnd), sendcount, displs, MPI_DOUBLE_PRECISION,   &
                              f_aux, sendcount(dfftp%mype3), MPI_DOUBLE_PRECISION, &
                              proc3_, dfftp%comm3, info )
        ELSE
           f_aux=(0.d0,0.d0)
        END IF
        ! 2) scatter within the comm2 communicator
        displs = 0 ; f_out = 0.0D0
        DO proc =0, ( dfftp%nproc2 -1 )
           sendcount(proc) = 2 * dfftp%nr1x * dfftp%nr2p(proc+1) 
           if (proc > 0) displs(proc) = displs(proc-1) + sendcount(proc-1)
        end do
        offset_out = 1 ; offset_aux = 1
        do ir3 = 1, dfftp%my_nr3p
           info = 0
           CALL MPI_SCATTERV( f_aux(offset_aux), sendcount, displs, MPI_DOUBLE_PRECISION,   &
                              f_out(offset_out), sendcount(dfftp%mype2), MPI_DOUBLE_PRECISION, &
                              proc2_, dfftp%comm2, info )
           CALL fftx_error__( 'gather_grid', 'info<>0', info )
           offset_out = offset_out + dfftp%nr1x * dfftp%my_nr2p
           offset_aux = offset_aux + dfftp%nr1x * dfftp%nr2x
        end do
     ENDDO
  ENDDO
  !
  DEALLOCATE ( f_aux )
  !
  CALL stop_clock( 'cscatter_sym' )
  !
#else
  CALL fftx_error__('cscatter_sym_many', 'do not use in serial execution', 1)
#endif
  !
  RETURN
  !
END SUBROUTINE cscatter_sym_many


!=----------------------------------------------------------------------=!
   END MODULE scatter_mod
!=----------------------------------------------------------------------=!
!
!
!---------------------------------------------------------------------
subroutine fftsort (n, ia)  
  !---------------------------------------------------------------------
  ! sort an integer array ia(1:n) into ascending order using heapsort algorithm.
  ! n is input, ia is replaced on output by its sorted rearrangement.
  ! create an index table (ind) by making an exchange in the index array
  ! whenever an exchange is made on the sorted data array (ia).
  ! in case of equal values in the data array (ia) the values in the
  ! index array (ind) are used to order the entries.
  ! if on input ind(1)  = 0 then indices are initialized in the routine,
  ! if on input ind(1) != 0 then indices are assumed to have been
  !                initialized before entering the routine and these
  !                indices are carried around during the sorting process
  !
  ! no work space needed !
  ! free us from machine-dependent sorting-routines !
  !
  ! adapted from Numerical Recipes pg. 329 (new edition)
  !
  implicit none  
  !-input/output variables
  integer :: n  
  integer :: ia (2,n)  
  !-local variables
  integer :: i, ir, j, l
  integer :: iia(2)  
  ! nothing to order
  if (n.lt.2) return  
  ! initialize indices for hiring and retirement-promotion phase
  l = n / 2 + 1  
  ir = n  
10 continue  
  ! still in hiring phase
  if (l.gt.1) then  
     l = l - 1  
     iia(:) = ia (:,l)  
     ! in retirement-promotion phase.
  else  
     ! clear a space at the end of the array
     iia(:) = ia (:,ir)  
     !
     ! retire the top of the heap into it
     ia (:,ir) = ia (:,1)  
     !
     ! decrease the size of the corporation
     ir = ir - 1  
     ! done with the last promotion
     if (ir.eq.1) then  
        ! the least competent worker at all !
        ia (:,1) = iia(:)  
        !
        return  
     endif
  endif
  ! wheter in hiring or promotion phase, we
  i = l  
  ! set up to place iia in its proper level
  j = l + l  
  !
  do while (j.le.ir)  
     if (j.lt.ir) then  
        if (ia (1,j) .lt. ia (1,j + 1) ) then  
           j = j + 1  
        endif
     endif
     ! demote iia
     if (iia(1).lt.ia (1,j) ) then  
        ia (:,i) = ia (:,j)  
        i = j  
        j = j + j  
     else  
        ! set j to terminate do-while loop
        j = ir + 1  
     endif
  enddo
  ia (:,i) = iia(:)  
  goto 10  
  !
end subroutine fftsort

!
! Copyright (C) 2001-2019 Quantum-ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!

!-----------------------------------------------------------------------
MODULE qepy_tddft_common
  !----------------------------------------------------------------------
  !  ... Compute optical absorption spectrum by real-time TDDFT 
  !  ... References:
  !      (1) Phys. Rev. B 73, 035408 (2006)
  !      (2) http://www.netlib.org/linalg/html_templates/Templates.html
  !                                             Xiaofeng Qian, MIT (2008)
  !----------------------------------------------------------------------
  USE kinds,                       ONLY : dp
  !
  IMPLICIT NONE

  !-- tddft variables ----------------------------------------------------
  complex(dp), allocatable :: tddft_psi(:,:,:), b(:,:)
  complex(dp), allocatable :: tddft_hpsi(:,:), tddft_spsi(:,:)
  complex(dp), allocatable :: tddft_Ppsi(:,:)        ! PAW correction to forces (Ehrenfest)
  real(dp), allocatable :: charge(:), dipole(:,:), quadrupole(:,:,:)
  complex(dp), allocatable :: circular(:,:), circular_local(:)

END MODULE qepy_tddft_common

!
! Copyright (C) 2001-2012 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
#if defined(__OLDXML)
!----------------------------------------------------------------------------
! TB
! included allocation of the force field of the gate, search for 'TB'
!----------------------------------------------------------------------------
!
!----------------------------------------------------------------------------
SUBROUTINE oldxml_read_file()
  !----------------------------------------------------------------------------
  !
  ! Wrapper routine, for compatibility
  !
  USE io_files,             ONLY : nwordwfc, iunwfc, prefix, tmp_dir, wfc_dir, diropn
  USE io_global,            ONLY : stdout, ionode
  USE buffers,              ONLY : open_buffer, close_buffer
  USE wvfct,                ONLY : nbnd, npwx
  USE noncollin_module,     ONLY : npol
  USE paw_variables,        ONLY : okpaw, ddd_PAW
  USE paw_onecenter,        ONLY : paw_potential
  USE uspp,                 ONLY : becsum
  USE scf,                  ONLY : rho
  USE realus,               ONLY : betapointlist, &
                                   init_realspace_vars,real_space
  USE dfunct,               ONLY : newd
  USE ldaU,                 ONLY : lda_plus_u, U_projection
  USE oldxml_pw_restart,    ONLY : pw_readfile
  USE control_flags,        ONLY : io_level
  USE klist,                ONLY : init_igk
  USE gvect,                ONLY : ngm, g
  USE gvecw,                ONLY : gcutw
#if defined (__HDF5)
  USE hdf5_qe
#endif
  USE klist,                ONLY : nks
  USE wavefunctions,        ONLY : evc
  USE buffers,              ONLY : get_buffer, save_buffer
  !
  IMPLICIT NONE 
  INTEGER :: ierr
  LOGICAL :: exst, exst_mem, exst_file, opnd_file
  CHARACTER( 256 )  :: dirname
  INTEGER  :: ik
  INTEGER  :: file_size
  !
  !
  ierr = 0 
  !
  ! ... Read the contents of the xml data file
  !
  IF ( ionode ) WRITE( stdout, '(/,5x,A,/,5x,A)') &
     'Reading data from directory:', TRIM( tmp_dir ) // TRIM( prefix ) // '.save'
#if defined(__HDF5)
  CALL initialize_hdf5()
#endif
  !
  CALL oldxml_read_xml_file ( )
  !
  ! ... Open unit iunwfc, for Kohn-Sham orbitals - we assume that wfcs
  ! ... have been written to tmp_dir, not to a different directory!
  ! ... io_level = 1 so that a real file is opened
  !
  wfc_dir = tmp_dir
  nwordwfc = nbnd*npwx*npol
  io_level = 1
  !CALL open_buffer ( iunwfc, 'wfc', nwordwfc, io_level, exst )
  CALL open_buffer( iunwfc, 'wfc', nwordwfc, io_level, exst_mem, exst_file )
  !
  ! ... Allocate and compute k+G indices and number of plane waves
  ! ... FIXME: should be read from file, not re-computed
  !
  CALL init_igk ( npwx, ngm, g, gcutw ) 
  !
  !CALL pw_readfile( 'wave', ierr )
  !IF ( nks == 1 ) CALL get_buffer( evc, nwordwfc, iunwfc, 1 )
  !-----------------------------------------------------------------------
  !CALL open_buffer( iunwfc, 'wfc', nwordwfc, io_level, exst_mem, exst_file )
  !
  ! ... now the various possible wavefunction initializations
  ! ... first a check: is "tmp_dir"/"prefix".wfc found on disk?
  !
  IF ( .NOT. exst_file) THEN
     !
     ! ... "tmp_dir"/"prefix".wfc not found on disk: try to read
     ! ... wavefunctions in "collected" format from "prefix".save/, 
     ! ... rewrite them (in pw_readfile) using the internal format
     !
     ierr = 1
     CALL pw_readfile( 'wave', ierr )
     IF ( ierr > 0 ) THEN
        WRITE( stdout, '(5x,A)') &
             'oldxml_read_file: Wavefunctions in collected format not available'
        !CALL errore( 'read_file ', 'file not found', ierr )
     !END IF
     ELSE
     !
     ! ... workaround: with k-point parallelization and 1 k-point per pool,
     ! ... pw_readfile does not leave evc properly initialized on all pools
     !
     inquire (unit = iunwfc, size = file_size)
     !qepy --> skip empty file
     if (file_size /= 0) then
     IF ( nks == 1 ) CALL get_buffer( evc, nwordwfc, iunwfc, 1 )
     else
        WRITE( stdout, '(5x,A)') 'oldxml_read_file: Wavefunctions is empty!'
     endif
     !qepy <-- skip empty file
     END IF
     !
  ELSE
     !
     ! ... wavefunctions are read from file (or buffer) in routine 
     ! ... c_bands, but not if there is a single k-point. In such
     ! ... a case, we read wavefunctions (directly from file in 
     ! ... order to avoid a useless buffer allocation) here
     !
     IF ( nks == 1 ) THEN
         inquire (unit = iunwfc, opened = opnd_file)
         if (.not.opnd_file) CALL diropn( iunwfc, 'wfc', 2*nwordwfc, exst )
         inquire (unit = iunwfc, size = file_size)
         !qepy --> skip empty file
         if (file_size /= 0) then
         CALL davcio ( evc, 2*nwordwfc, iunwfc, nks, -1 )
         else
            WRITE( stdout, '(5x,A)') 'oldxml_read_file: Wavefunctions is empty!'
         endif
         !qepy <-- skip empty file
         if(.not.opnd_file) CLOSE ( UNIT=iunwfc, STATUS='keep' )
     END IF
     !
  END IF
  !-----------------------------------------------------------------------
  !
  ! ... Assorted initialization: pseudopotentials, PAW
  ! ... Not sure which ones (if any) should be done here
  !
  CALL init_us_1()
  !
  IF (lda_plus_u .AND. (U_projection == 'pseudo')) CALL init_q_aeps()
  !
  IF (okpaw) THEN
     becsum = rho%bec
     CALL PAW_potential(rho%bec, ddd_PAW)
  ENDIF 
  !
  IF ( real_space ) THEN
    CALL betapointlist()
    CALL init_realspace_vars()
    IF( ionode ) WRITE(stdout,'(5x,"Real space initialisation completed")')
  ENDIF
  CALL newd()
  !-----------------------------------------------------------------------
  !IF ( wfc_is_collected ) THEN
  !   !
  !   WRITE( stdout, '(5x,A)') &
  !        'Reading collected, re-writing distributed wavefunctions'
  !   DO ik = 1, nks
  !      CALL read_collected_wfc ( restart_dir(), ik, evc )
  !      CALL save_buffer ( evc, nwordwfc, iunwfc, ik )
  !   END DO
  !   !
  !ELSE
  !   WRITE( stdout, '(5x,A)') &
  !        'read_file: Wavefunctions in collected format not available'
  !END IF
  !-----------------------------------------------------------------------
  !
  !CALL close_buffer  ( iunwfc, 'KEEP' )
  !
END SUBROUTINE oldxml_read_file
!
SUBROUTINE oldxml_read_xml_file()
  ! wrapper routine to call the default behavior
  call oldxml_read_xml_file_internal(.true.)
END SUBROUTINE oldxml_read_xml_file

SUBROUTINE oldxml_read_xml_file_nobs()
  ! wrapper routine to load everything except for the band structure
  call oldxml_read_xml_file_internal(.false.)
END SUBROUTINE oldxml_read_xml_file_nobs

!----------------------------------------------------------------------------
SUBROUTINE oldxml_read_xml_file_internal(withbs)
  !----------------------------------------------------------------------------
  !
  ! ... This routine allocates space for all quantities already computed
  ! ... in the pwscf program and reads them from the data file.
  ! ... All quantities that are initialized in subroutine "setup" when
  ! ... starting from scratch should be initialized here when restarting
  !
  USE kinds,                ONLY : DP
  USE ions_base,            ONLY : nat, nsp, ityp, tau, if_pos, extfor
  USE cell_base,            ONLY : tpiba2, alat,omega, at, bg, ibrav
  USE force_mod,            ONLY : force
  USE klist,                ONLY : nkstot, nks, xk, wk
  USE lsda_mod,             ONLY : lsda, nspin, current_spin, isk
  USE wvfct,                ONLY : nbnd, nbndx, et, wg
  USE symm_base,            ONLY : irt, d1, d2, d3, checkallsym, nsym
  USE extfield,             ONLY : forcefield, tefield, gate, forcegate
  USE cellmd,               ONLY : cell_factor, lmovecell
  USE fft_base,             ONLY : dfftp
  USE fft_interfaces,       ONLY : fwfft
  USE fft_types,            ONLY : fft_type_allocate
  USE recvec_subs,          ONLY : ggen, ggens
  USE gvect,                ONLY : gg, ngm, g, gcutm, mill, ngm_g, ig_l2g, &
                                   eigts1, eigts2, eigts3, gstart, gshells
  USE Coul_cut_2D,          ONLY : do_cutoff_2D, cutoff_fact
  USE fft_base,             ONLY : dfftp, dffts
  USE gvecs,                ONLY : ngms, gcutms 
  USE spin_orb,             ONLY : lspinorb, domag
  USE scf,                  ONLY : rho, rho_core, rhog_core, v
  USE wavefunctions,        ONLY : psic
  USE vlocal,               ONLY : strf
  USE io_files,             ONLY : tmp_dir, prefix, iunpun, nwordwfc, iunwfc
  USE noncollin_module,     ONLY : noncolin, npol, nspin_lsda, nspin_mag, nspin_gga
  USE oldxml_pw_restart,           ONLY : pw_readfile, pp_check_file
  USE oldxml_io_rho_xml,           ONLY : read_scf
  USE read_pseudo_mod,      ONLY : readpp
  USE uspp,                 ONLY : becsum
  USE uspp_param,           ONLY : upf
  USE paw_variables,        ONLY : okpaw, ddd_PAW
  USE paw_init,             ONLY : paw_init_onecenter, allocate_paw_internals
  USE ldaU,                 ONLY : lda_plus_u, eth, init_lda_plus_u
  USE control_flags,        ONLY : gamma_only
  USE funct,                ONLY : get_inlc, get_dft_name
  !USE kernel_table,         ONLY : initialize_kernel_table
  USE esm,                  ONLY : do_comp_esm, esm_init
  USE mp_bands,             ONLY : intra_bgrp_comm, nyfft
  USE spin_orb,             ONLY : lforcet
  USE io_files,             ONLY : postfix
  USE oldxml_xml_io_base,          ONLY : read_rho
  USE wvfct,                ONLY : nbnd, npwx
  !
  IMPLICIT NONE

  ! Used to specify whether to read the band structure (files 
  ! K??????/eigenval.xml), so one can skip it if not needed by
  ! the post-processing tool. 
  ! Set to True for the 'default' behavior of reading these files.
  LOGICAL :: withbs

  INTEGER  :: i, is, ik, ibnd, nb, nt, ios, isym, ierr, inlc
  REAL(DP) :: rdum(1,1), ehart, etxc, vtxc, etotefield, charge
  REAL(DP) :: sr(3,3,48)
  CHARACTER(LEN=20) dft_name
  CHARACTER(LEN=256)    :: dirname, filename
  !
  !
  ! ... first we get the version of the qexml file
  !     if not already read
  CALL pw_readfile( 'header', ierr )
  CALL errore( 'read_xml_file ', 'unable to determine qexml version', ABS(ierr) )
  !
  ! ... then we check if the file can be used for post-processing
  !
  IF ( .NOT. pp_check_file() ) CALL infomsg( 'read_xml_file', &
               & 'file ' // TRIM( tmp_dir ) // TRIM( prefix ) &
               & // '.save not guaranteed to be safe for post-processing' )
  !
  ! ... here we read the variables that dimension the system
  ! ... in parallel execution, only root proc reads the file
  ! ... and then broadcasts the values to all other procs
  !
  CALL pw_readfile( 'reset', ierr )
  CALL pw_readfile( 'dim',   ierr )
  CALL errore( 'read_xml_file ', 'problem reading file ' // &
             & TRIM( tmp_dir ) // TRIM( prefix ) // '.save', ierr )
  !
  ! ... allocate space for atomic positions, symmetries, forces
  !
  IF ( nat < 0 ) CALL errore( 'read_xml_file', 'wrong number of atoms', 1 )
  !
  ! ... allocation
  !
  ALLOCATE( ityp( nat ) )
  ALLOCATE( tau(    3, nat ) )
  ALLOCATE( if_pos( 3, nat ) )
  ALLOCATE( force(  3, nat ) )
  ALLOCATE( extfor(  3, nat ) )
  !
  IF ( tefield ) ALLOCATE( forcefield( 3, nat ) )
  IF ( gate ) ALLOCATE( forcegate( 3, nat ) ) ! TB
  !
  ALLOCATE( irt( 48, nat ) )
  !
  CALL oldxml_set_dimensions()
  CALL fft_type_allocate ( dfftp, at, bg, gcutm, intra_bgrp_comm, nyfft=nyfft )
  CALL fft_type_allocate ( dffts, at, bg, gcutms, intra_bgrp_comm, nyfft=nyfft )
  !
  ! ... check whether LSDA
  !
  IF ( lsda ) THEN
     !
     nspin = 2
     npol  = 1
     !
  ELSE IF ( noncolin ) THEN
     !
     nspin        = 4
     npol         = 2
     current_spin = 1
     !
  ELSE
     !
     nspin        = 1
     npol         = 1
     current_spin = 1
     !
  END IF
  !
  if (cell_factor == 0.d0) cell_factor = 1.D0
  !
  ! ... allocate memory for eigenvalues and weights (read from file)
  !
  nbndx = nbnd
  ALLOCATE( et( nbnd, nkstot ) , wg( nbnd, nkstot ) )
  !
  ! ... here we read all the variables defining the system
  !
  IF  ( withbs .EQV. .TRUE. ) THEN  
     CALL pw_readfile( 'nowave', ierr )
  ELSE
     CALL pw_readfile( 'nowavenobs', ierr )
  END IF
  !
  ! ... distribute across pools k-points and related variables.
  ! ... nks is defined by the following routine as the number 
  ! ... of k-points in the current pool
  !
  CALL divide_et_impera( nkstot, xk, wk, isk, nks )
  !
  CALL poolscatter( nbnd, nkstot, et, nks, et )
  CALL poolscatter( nbnd, nkstot, wg, nks, wg )
  !
  ! ... check on symmetry
  !
  IF (nat > 0) CALL checkallsym( nat, tau, ityp )
  !
  !  Set the different spin indices
  !
  nspin_mag  = nspin
  nspin_lsda = nspin
  nspin_gga  = nspin
  IF (nspin==4) THEN
     nspin_lsda=1
     IF (domag) THEN
        nspin_gga=2
     ELSE
        nspin_gga=1
        nspin_mag=1
     ENDIF
  ENDIF
  !
  ! ... read pseudopotentials
  !
  CALL pw_readfile( 'pseudo', ierr )

  dft_name = get_dft_name () ! already set, should not be set again
  CALL readpp ( dft_name )
  !
  ! ... read the vdw kernel table if needed
  !
  inlc = get_inlc()
  !if (inlc > 0 ) then
  !    call initialize_kernel_table(inlc)
  !endif
  !
  okpaw = ANY ( upf(1:nsp)%tpawp )
  !
  IF ( .NOT. lspinorb ) CALL average_pp ( nsp )
  !
  ! ... allocate memory for G- and R-space fft arrays
  !
  CALL pre_init()
  CALL data_structure ( gamma_only )
  CALL allocate_fft()
  CALL ggen ( dfftp, gamma_only, at, bg, gcutm, ngm_g, ngm, &
       g, gg, mill, ig_l2g, gstart ) 
  CALL ggens( dffts, gamma_only, at, g, gg, mill, gcutms, ngms ) 
  IF (do_comp_esm) THEN
    CALL pw_readfile( 'esm', ierr )
    CALL esm_init()
  END IF
  CALL gshells ( lmovecell ) 
  !
  ! ... allocate the potential and wavefunctions
  !
  CALL allocate_locpot()
  CALL allocate_nlpot()
  IF (okpaw) THEN
     CALL allocate_paw_internals()
     CALL paw_init_onecenter()
     CALL d_matrix(d1,d2,d3)
  ENDIF
  !
  IF ( lda_plus_u ) THEN
     CALL init_lda_plus_u ( upf(1:nsp)%psd, noncolin )
  ENDIF
  !
  !CALL allocate_wfc()
  CALL allocate_wfc_k()
  !
  ! ... read the charge density
  !
  CALL read_scf( rho, nspin )
!  IF ( .NOT.lforcet ) THEN
!     CALL read_scf ( rho, nspin, gamma_only )
!  ELSE
!     !
!     ! ... 'force theorem' calculation of MAE: read rho only from previous
!     ! ... lsda calculation, set noncolinear magnetization from angles
!     !
!     dirname = TRIM(tmp_dir) // TRIM (prefix) // postfix
!#if defined __HDF5
!     filename = TRIM(dirname) // 'charge-density.hdf5'
!#else 
!     filename = TRIM(dirname) // 'charge-density.dat'
!#endif
!     CALL read_rho ( dirname, rho%of_r, 2 )
!     CALL nc_magnetization_from_lsda ( dfftp%nnr, nspin, rho%of_r )
!  END IF
  !
  ! ... re-calculate the local part of the pseudopotential vltot
  ! ... and the core correction charge (if any) - This is done here
  ! ... for compatibility with the previous version of read_file
  !
  ! 2D calculations: re-initialize cutoff fact before calculating potentials
  IF(do_cutoff_2D) CALL cutoff_fact()
  !
  CALL init_vloc()
  CALL struc_fact( nat, tau, nsp, ityp, ngm, g, bg, dfftp%nr1, dfftp%nr2, &
                   dfftp%nr3, strf, eigts1, eigts2, eigts3 )
  CALL setlocal()
  CALL set_rhoc()
  !
  ! ... bring rho to G-space
  !
  DO is = 1, nspin
     !
     psic(:) = rho%of_r(:,is)
     CALL fwfft ('Rho', psic, dfftp)
     rho%of_g(:,is) = psic(dfftp%nl(:))
     !
  END DO
  !
  ! ... read info needed for hybrid functionals
  !
  CALL pw_readfile('exx', ierr)
  !
  ! ... recalculate the potential
  !
  CALL v_of_rho( rho, rho_core, rhog_core, &
                 ehart, etxc, vtxc, eth, etotefield, charge, v )
  !
  !
  RETURN
  !
  CONTAINS
    !
    !------------------------------------------------------------------------
    SUBROUTINE oldxml_set_dimensions()
      !------------------------------------------------------------------------
      !
      USE constants, ONLY : pi, eps8
      USE cell_base, ONLY : alat, tpiba, tpiba2
      USE gvect,     ONLY : ecutrho, gcutm
      USE gvecs,     ONLY : gcutms, dual, doublegrid
      USE gvecw,     ONLY : gcutw, ecutwfc
      !
      !
      ! ... Set the units in real and reciprocal space
      !
      tpiba  = 2.D0 * pi / alat
      tpiba2 = tpiba**2
      !
      ! ... Compute the cut-off of the G vectors
      !
      gcutw =        ecutwfc / tpiba2
      gcutm = dual * ecutwfc / tpiba2
      ecutrho=dual * ecutwfc
      !
      doublegrid = ( dual > 4.0_dp + eps8 )
      IF ( doublegrid ) THEN
         gcutms = 4.D0 * ecutwfc / tpiba2
      ELSE
         gcutms = gcutm
      END IF
      !
    END SUBROUTINE oldxml_set_dimensions
    !
  END SUBROUTINE oldxml_read_xml_file_internal
#endif

!
! Copyright (C) 2016 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
!----------------------------------------------------------------------------
MODULE qepy_pw_restart_new
!----------------------------------------------------------------------------
  !
  ! ... New PWscf I/O using xml schema and (optionally) hdf5 binaries
  ! ... Parallel execution: the xml file is written by one processor only
  ! ... ("ionode_id"), read by all processors ;
  ! ... the wavefunction files are written / read by one processor per pool,
  ! ... collected on / distributed to all other processors in pool
  !
  USE kinds, ONLY: dp
  USE qes_types_module, ONLY : output_type, parallel_info_type, &
       general_info_type, input_type, gateInfo_type, dipoleOutput_type, &
       BerryPhaseOutput_type, hybrid_type, vdw_type, dftU_type, smearing_type
  USE qes_write_module, ONLY: qes_write
  USE qes_reset_module, ONLY: qes_reset 
  USE qes_bcast_module,ONLY : qes_bcast
  USE qexsd_module, ONLY: qexsd_xf, qexsd_openschema, qexsd_closeschema, &
       qexsd_readschema
  USE qexsd_input,  ONLY : qexsd_input_obj, qexsd_init_k_points_ibz, &
       qexsd_init_occupations, qexsd_init_smearing
  USE qexsd_init,   ONLY: qexsd_init_convergence_info, qexsd_init_algorithmic_info,    & 
                          qexsd_init_atomic_species, qexsd_init_atomic_structure,      &
                          qexsd_init_symmetries, qexsd_init_basis_set, qexsd_init_dft, &
                          qexsd_init_magnetization,qexsd_init_band_structure,          &
                          qexsd_init_dipole_info, qexsd_init_total_energy,             &
                          qexsd_init_vdw, qexsd_init_forces, qexsd_init_stress,        &
                          qexsd_init_outputElectricField, qexsd_init_outputPBC,        &
                          qexsd_init_gate_info, qexsd_init_hybrid,  qexsd_init_dftU,   &
                          qexsd_occ_obj, qexsd_bp_obj, qexsd_start_k_obj
  USE qexsd_copy,      ONLY : qexsd_copy_parallel_info, &
       qexsd_copy_algorithmic_info, qexsd_copy_atomic_species, &
       qexsd_copy_atomic_structure, qexsd_copy_symmetry, &
       qexsd_copy_basis_set, qexsd_copy_dft, qexsd_copy_efield, &
       qexsd_copy_band_structure, qexsd_copy_magnetization, &
       qexsd_copy_kpoints
  USE io_global, ONLY : ionode, ionode_id
  USE io_files,  ONLY : iunpun, xmlfile
  !
  IMPLICIT NONE
  !
  CHARACTER(LEN=6), EXTERNAL :: int_to_char
  PRIVATE
  PUBLIC :: pw_write_schema, pw_write_binaries
  !PUBLIC :: read_xml_file, read_collected_wfc
  PUBLIC :: qepy_read_xml_file, read_collected_wfc
  !
  CONTAINS
    !------------------------------------------------------------------------
    SUBROUTINE pw_write_schema( only_init, wf_collect )
      !------------------------------------------------------------------------
      !
      ! only_init  = T  write only variables that are known after the 
      !                 initial steps of initialization (e.g. structure)
      !            = F  write the complete xml file
      ! wf_collect = T  if final wavefunctions in portable format are written,
      !              F  if wavefunctions are either not written or are written
      !                 in binary non-portable form (for checkpointing)
      !                 NB: wavefunctions are not written here in any case
      !
      USE control_flags,        ONLY : istep, conv_ions, &
                                       lscf, gamma_only, &
                                       tqr, tq_smoothing, tbeta_smoothing, &
                                       noinv, smallmem, &
                                       llondon, lxdm, ts_vdw, scf_error, n_scf_steps
      USE constants,            ONLY : e2
      USE realus,               ONLY : real_space
      USE uspp,                 ONLY : okvan
      USE paw_variables,        ONLY : okpaw
      USE uspp_param,           ONLY : upf
      USE global_version,       ONLY : version_number
      USE cell_base,            ONLY : at, bg, alat, ibrav
      USE ions_base,            ONLY : nsp, ityp, atm, nat, tau, zv, amass
      USE noncollin_module,     ONLY : noncolin, npol
      USE io_files,             ONLY : psfile, pseudo_dir
      USE klist,                ONLY : nks, nkstot, xk, ngk, wk, &
                                       lgauss, ngauss, smearing, degauss, nelec, &
                                       two_fermi_energies, nelup, neldw, tot_charge, ltetra 
      USE start_k,              ONLY : nk1, nk2, nk3, k1, k2, k3, &
                                       nks_start, xk_start, wk_start
      USE gvect,                ONLY : ngm, ngm_g, g
      USE fft_base,             ONLY : dfftp
      USE basis,                ONLY : natomwfc
      USE gvecs,                ONLY : ngms_g, dual
      USE fft_base,             ONLY : dffts
      USE wvfct,                ONLY : npwx, et, wg, nbnd
      USE ener,                 ONLY : ef, ef_up, ef_dw, vtxc, etxc, ewld, etot, &
                                       ehart, eband, demet, edftd3, elondon, exdm
      USE tsvdw_module,         ONLY : EtsvdW
      USE gvecw,                ONLY : ecutwfc
      USE fixed_occ,            ONLY : tfixed_occ, f_inp
      USE ldaU,                 ONLY : lda_plus_u, lda_plus_u_kind, U_projection, &
                                       Hubbard_lmax, Hubbard_l, Hubbard_U, Hubbard_J, &
                                       Hubbard_alpha, Hubbard_J0, Hubbard_beta,&
                                       is_hubbard
      USE spin_orb,             ONLY : lspinorb, domag
      USE symm_base,            ONLY : nrot, nsym, invsym, s, ft, irt, &
                                       t_rev, sname, time_reversal, no_t_rev,&
                                       spacegroup
      USE lsda_mod,             ONLY : nspin, isk, lsda, starting_magnetization, magtot, absmag
      USE noncollin_module,     ONLY : angle1, angle2, i_cons, mcons, bfield, magtot_nc, &
                                       lambda
      USE funct,                ONLY : get_dft_short, get_inlc, get_nonlocc_name, dft_is_nonlocc
      USE scf,                  ONLY : rho
      USE force_mod,            ONLY : lforce, sumfor, force, sigma, lstres
      USE extfield,             ONLY : tefield, dipfield, edir, etotefield, &
                                       emaxpos, eopreg, eamp, el_dipole, ion_dipole,&
                                       gate, zgate, relaxz, block, block_1,&
                                       block_2, block_height, etotgatefield ! TB
      USE mp,                   ONLY : mp_sum
      USE mp_bands,             ONLY : intra_bgrp_comm
      USE funct,                ONLY : get_exx_fraction, dft_is_hybrid, &
                                       get_gau_parameter, &
                                       get_screening_parameter, exx_is_active
      USE exx_base,             ONLY : x_gamma_extrapolation, nq1, nq2, nq3, &
                                       exxdiv_treatment, yukawa, ecutvcut
      USE exx,                  ONLY : ecutfock, local_thr 
      USE london_module,        ONLY : scal6, lon_rcut, c6_i
      USE xdm_module,           ONLY : xdm_a1=>a1i, xdm_a2=>a2i
      USE tsvdw_module,         ONLY : vdw_isolated, vdw_econv_thr
      USE input_parameters,     ONLY : verbosity, calculation, ion_dynamics, starting_ns_eigenvalue, &
                                       vdw_corr, london, k_points, assume_isolated, &  
                                       input_parameters_occupations => occupations, dftd3_threebody, &
                                       dftd3_version
      USE bp,                   ONLY : lelfield, lberry, el_pol, ion_pol
      !
      USE rap_point_group,      ONLY : elem, nelem, name_class
      USE rap_point_group_so,   ONLY : elem_so, nelem_so, name_class_so
      USE bfgs_module,          ONLY : bfgs_get_n_iter
      USE fcp_variables,        ONLY : lfcpopt, lfcpdyn, fcp_mu  
      USE control_flags,        ONLY : conv_elec, conv_ions, ldftd3, do_makov_payne 
      USE Coul_cut_2D,          ONLY : do_cutoff_2D 
      USE esm,                  ONLY : do_comp_esm 
      USE martyna_tuckerman,    ONLY : do_comp_mt 
      USE run_info,             ONLY : title
      !
      IMPLICIT NONE
      !
      LOGICAL, INTENT(IN) :: only_init, wf_collect
      !
      CHARACTER(LEN=20)     :: dft_name
      CHARACTER(LEN=8)      :: smearing_loc
      CHARACTER(LEN=8), EXTERNAL :: schema_smearing
      INTEGER               :: i, ig, ngg, ipol
      INTEGER               :: npwx_g, ispin, inlc
      INTEGER,  ALLOCATABLE :: ngk_g(:)
      LOGICAL               :: occupations_are_fixed
      INTEGER                  :: iclass, isym, ielem
      CHARACTER(LEN=15)        :: symop_2_class(48)
      LOGICAL                  :: opt_conv_ispresent, dft_is_vdw, empirical_vdw
      INTEGER                  :: n_opt_steps, n_scf_steps_, h_band
      REAL(DP),TARGET                 :: h_energy
      TYPE(gateInfo_type),TARGET      :: gate_info_temp
      TYPE(gateInfo_type),POINTER     :: gate_info_ptr
      TYPE(dipoleOutput_type),TARGET  :: dipol_obj 
      TYPE(dipoleOutput_type),POINTER :: dipol_ptr 
      TYPE(BerryPhaseOutput_type),  POINTER :: bp_obj_ptr
      TYPE(hybrid_type), POINTER            :: hybrid_obj 
      TYPE(vdW_type), POINTER               :: vdw_obj
      TYPE(dftU_type), POINTER              :: dftU_obj 
      REAL(DP), TARGET                      :: lumo_tmp, ef_targ, dispersion_energy_term 
      REAL(DP), POINTER                     :: lumo_energy, ef_point 
      REAL(DP), ALLOCATABLE                 :: ef_updw(:)
      !
      !
      !
      TYPE(output_type)   :: output_obj
      REAL(DP),POINTER    :: degauss_, demet_, efield_corr, potstat_corr,  gatefield_corr  
      LOGICAL, POINTER    :: optimization_has_converged 
      LOGICAL, TARGET     :: conv_opt  
      LOGICAL             :: scf_has_converged 
      INTEGER             :: itemp = 1
      REAL(DP),ALLOCATABLE :: london_c6_(:), bp_el_pol(:), bp_ion_pol(:), U_opt(:), J0_opt(:), alpha_opt(:), &
                              J_opt(:,:), beta_opt(:) 
      CHARACTER(LEN=3),ALLOCATABLE :: species_(:)
      CHARACTER(LEN=20),TARGET   :: dft_nonlocc_
      INTEGER,TARGET             :: dftd3_version_
      CHARACTER(LEN=20),TARGET   :: vdw_corr_, pbc_label 
      CHARACTER(LEN=20),POINTER  :: non_local_term_pt, vdw_corr_pt 
      REAL(DP),TARGET            :: temp(20), lond_rcut_, lond_s6_, ts_vdw_econv_thr_, xdm_a1_, xdm_a2_, ectuvcut_,&
                                    scr_par_, loc_thr_  
      REAL(DP),POINTER           :: vdw_term_pt, ts_thr_pt, london_s6_pt, london_rcut_pt, xdm_a1_pt, xdm_a2_pt, &
                                    ts_vdw_econv_thr_pt, ectuvcut_opt, scr_par_opt, loc_thr_p, h_energy_ptr
      LOGICAL,TARGET             :: dftd3_threebody_, ts_vdw_isolated_
      LOGICAL,POINTER            :: ts_isol_pt, dftd3_threebody_pt, ts_vdw_isolated_pt 
      INTEGER,POINTER            :: dftd3_version_pt
      TYPE(smearing_type),TARGET :: smear_obj 
      TYPE(smearing_type),POINTER:: smear_obj_ptr 

      NULLIFY( degauss_, demet_, efield_corr, potstat_corr, gatefield_corr) 
      NULLIFY( gate_info_ptr, dipol_ptr, bp_obj_ptr, hybrid_obj, vdw_obj, dftU_obj, lumo_energy, ef_point)  
      NULLIFY ( optimization_has_converged, non_local_term_pt, &
           vdw_corr_pt, vdw_term_pt, ts_thr_pt, london_s6_pt, london_rcut_pt, &
           xdm_a1_pt, xdm_a2_pt, ts_vdw_econv_thr_pt, ts_isol_pt, &
           dftd3_threebody_pt, ts_vdw_isolated_pt, dftd3_version_pt )
      NULLIFY ( ectuvcut_opt, scr_par_opt, loc_thr_p, h_energy_ptr, smear_obj_ptr) 

      !
      ! Global PW dimensions need to be properly computed, reducing across MPI tasks
      ! If local PW dimensions are not available, set to 0
      !
      ALLOCATE( ngk_g( nkstot ) )
      ngk_g(:) = 0
      IF ( ALLOCATED (ngk) ) THEN
         ngk_g(1:nks) = ngk(:)
         CALL mp_sum( ngk_g(1:nks), intra_bgrp_comm )
         CALL ipoolrecover( ngk_g, 1, nkstot, nks )
      END IF
      ! BEWARE: only the first pool has ngk_g for all k-points
      !
      ! ... compute the maximum number of G vector among all k points
      !
      npwx_g = MAXVAL( ngk_g(1:nkstot) )
      !
      ! XML descriptor
      ! 
      IF ( ionode ) THEN  
         !
         ! ... here we init the variables and finally write them to file
         !
!-------------------------------------------------------------------------------
! ... HEADER
!-------------------------------------------------------------------------------
         !
         output_obj%tagname="output"
         output_obj%lwrite = .TRUE.
         output_obj%lread  = .TRUE.
         !
!-------------------------------------------------------------------------------
! ... CONVERGENCE_INFO
!-------------------------------------------------------------------------------
         SELECT CASE (TRIM( calculation )) 
            CASE ( "relax","vc-relax" )
                conv_opt = conv_ions  
                optimization_has_converged  => conv_opt
                IF (TRIM( ion_dynamics) == 'bfgs' ) THEN 
                    n_opt_steps = bfgs_get_n_iter('bfgs_iter ') 
                ELSE 
                    n_opt_steps = istep 
                END IF 
                scf_has_converged = conv_elec 
                n_scf_steps_ = n_scf_steps
            CASE ("nscf", "bands" )
                n_opt_steps = 0
                scf_has_converged = .FALSE. 
                n_scf_steps_ = 1
            CASE default
                n_opt_steps        = 0 
                scf_has_converged = conv_elec 
                n_scf_steps_ = n_scf_steps
         END SELECT
         ! 
            call qexsd_init_convergence_info(output_obj%convergence_info,   &
                        SCf_HAS_CONVERGED = scf_has_converged, &
                        OPTIMIZATION_HAS_CONVERGED = optimization_has_converged,& 
                        N_SCF_STEPS = n_scf_steps_, SCF_ERROR=scf_error/e2,&
                        N_OPT_STEPS = n_opt_steps, GRAD_NORM = sumfor)
            output_obj%convergence_info_ispresent = .TRUE.
         !
            
!-------------------------------------------------------------------------------
! ... ALGORITHMIC_INFO
!-------------------------------------------------------------------------------
         !
         CALL qexsd_init_algorithmic_info(output_obj%algorithmic_info, &
              REAL_SPACE_BETA = real_space, REAL_SPACE_Q=tqr , USPP=okvan, PAW=okpaw)
         !
!-------------------------------------------------------------------------------
! ... ATOMIC_SPECIES
!-------------------------------------------------------------------------------
         !
         ! while amass's are always present, starting_mag should not be passed
         ! for nspin==1 or contrained magnetization calculations
         !
         IF (noncolin) THEN
            CALL qexsd_init_atomic_species(output_obj%atomic_species, nsp, atm, psfile, &
                 amass, STARTING_MAGNETIZATION = starting_magnetization, &
                 ANGLE1=angle1, ANGLE2=angle2)
         ELSE IF (nspin==2) THEN 
            CALL qexsd_init_atomic_species(output_obj%atomic_species, nsp, atm, psfile, &
                 amass, STARTING_MAGNETIZATION=starting_magnetization)
         ELSE 
            CALL qexsd_init_atomic_species(output_obj%atomic_species, nsp, atm,psfile, &
                 amass)
         END IF
         output_obj%atomic_species%pseudo_dir = TRIM(pseudo_dir)
         output_obj%atomic_species%pseudo_dir_ispresent = .TRUE.
         !
!-------------------------------------------------------------------------------
! ... ATOMIC_STRUCTURE
!-------------------------------------------------------------------------------
         !         
         CALL qexsd_init_atomic_structure(output_obj%atomic_structure, nsp, atm, ityp, &
              nat, alat*tau, alat, alat*at(:,1), alat*at(:,2), alat*at(:,3), ibrav)
         !
!-------------------------------------------------------------------------------
! ... SYMMETRIES
!-------------------------------------------------------------------------------
         !
         symop_2_class="not found"
         IF (TRIM (verbosity) == 'medium' .OR. TRIM(verbosity) == 'high') THEN
            IF ( noncolin )  THEN 
               symmetries_so_loop:DO isym = 1, nrot 
                  classes_so_loop:DO iclass = 1, 24
                     elements_so_loop:DO ielem=1, nelem_so(iclass)
                        IF ( elem_so(ielem,iclass) == isym) THEN 
                           symop_2_class(isym) = name_class_so(iclass)
                           EXIT symmetries_so_loop
                        END IF
                     END DO elements_so_loop 
                     END DO classes_so_loop
               END DO symmetries_so_loop
            !
            ELSE
               symmetries_loop:DO isym = 1, nrot
                  classes_loop:DO iclass = 1, 12
                     elements_loop:DO ielem=1, nelem (iclass)
                        IF ( elem(ielem,iclass) == isym) THEN
                           symop_2_class(isym) = name_class(iclass)
                           EXIT classes_loop
                        END IF
                     END DO elements_loop
                  END DO classes_loop
               END DO symmetries_loop
            END IF
         END IF
         CALL qexsd_init_symmetries(output_obj%symmetries, nsym, nrot, spacegroup,&
              s, ft, sname, t_rev, nat, irt,symop_2_class(1:nrot), verbosity, &
              noncolin)
         output_obj%symmetries_ispresent=.TRUE. 
         !
!-------------------------------------------------------------------------------
! ... BASIS SET
!-------------------------------------------------------------------------------
         !
         CALL qexsd_init_basis_set(output_obj%basis_set, gamma_only, ecutwfc/e2, ecutwfc*dual/e2, &
              dfftp%nr1, dfftp%nr2, dfftp%nr3, dffts%nr1, dffts%nr2, dffts%nr3, &
              .FALSE., dfftp%nr1, dfftp%nr2, dfftp%nr3, ngm_g, ngms_g, npwx_g, &
              bg(:,1), bg(:,2), bg(:,3) )
         !
!-------------------------------------------------------------------------------
! ... DFT
!-------------------------------------------------------------------------------
         !
         IF (dft_is_hybrid() ) THEN 
            ALLOCATE ( hybrid_obj)
            IF (get_screening_parameter() > 0.0_DP) THEN
               scr_par_ = get_screening_parameter() 
               scr_par_opt=> scr_par_ 
            END IF 
            IF (ecutvcut > 0.0_DP) THEN 
               ectuvcut_ = ecutvcut/e2 
               ectuvcut_opt => ectuvcut_
            END IF 
            IF ( local_thr > 0._DP) THEN 
               loc_thr_ = local_thr 
               loc_thr_p => loc_thr_ 
            END IF 
            CALL qexsd_init_hybrid(hybrid_obj, DFT_IS_HYBRID = .TRUE., NQ1 = nq1 , NQ2 = nq2, NQ3 =nq3, ECUTFOCK = ecutfock/e2, &
                                   EXX_FRACTION = get_exx_fraction(), SCREENING_PARAMETER = scr_par_opt, &
                                   EXXDIV_TREATMENT = exxdiv_treatment, X_GAMMA_EXTRAPOLATION = x_gamma_extrapolation,&
                                   ECUTVCUT = ectuvcut_opt, LOCAL_THR = loc_thr_p )
         END IF 

         empirical_vdw = (llondon .OR. ldftd3 .OR. lxdm .OR. ts_vdw )
         dft_is_vdw = dft_is_nonlocc() 
         IF ( dft_is_vdw .OR. empirical_vdw ) THEN 
            ALLOCATE (vdw_obj)
            IF ( empirical_vdw) THEN
                vdw_term_pt => dispersion_energy_term
                vdw_corr_ = TRIM(vdw_corr)
                vdw_corr_pt => vdw_corr_
                IF (llondon ) THEN
                    dispersion_energy_term = elondon/e2
                    lond_s6_ = scal6
                    london_s6_pt => lond_s6_
                    lond_rcut_ = lon_rcut
                    london_rcut_pt => lond_rcut_
                    IF (ANY( c6_i(1:nsp) .NE. -1._DP )) THEN
                       ALLOCATE (london_c6_(nsp), species_(nsp))
                       london_c6_(1:nsp) = c6_i(1:nsp)
                       species_(1:nsp)  = atm(1:nsp)
                   END IF
                   !
                ELSE IF ( lxdm ) THEN
                    dispersion_energy_term = exdm/e2
                    xdm_a1_ = xdm_a1
                    xdm_a1_pt => xdm_a1_
                    xdm_a2_ = xdm_a2
                    xdm_a2_pt => xdm_a2_
                    !
                ELSE IF ( ldftd3) THEN
                    dispersion_energy_term = edftd3/e2
                    dftd3_version_ = dftd3_version
                    dftd3_version_pt => dftd3_version_
                    dftd3_threebody_ = dftd3_threebody
                    dftd3_threebody_pt => dftd3_threebody_
                ELSE IF ( ts_vdw ) THEN
                    dispersion_energy_term = 2._DP * EtsvdW/e2
                    ts_vdw_isolated_ = vdw_isolated
                    ts_vdw_isolated_pt => ts_vdw_isolated_
                    ts_vdw_econv_thr_ = vdw_econv_thr
                    ts_vdw_econv_thr_pt => ts_vdw_econv_thr_
                END IF
            ELSE
                vdw_corr_ = 'none'
                vdw_corr_pt => vdw_corr_
            END IF 
            IF (dft_is_vdw) THEN
                dft_nonlocc_ = TRIM(get_nonlocc_name())
                non_local_term_pt => dft_nonlocc_
            END IF
            CALL qexsd_init_vdw(vdw_obj, non_local_term_pt, vdw_corr_pt, vdw_term_pt, &
                                ts_thr_pt, ts_isol_pt, london_s6_pt, LONDON_C6 = london_c6_, &
                                LONDON_RCUT =   london_rcut_pt, XDM_A1 = xdm_a1_pt, XDM_A2 = xdm_a2_pt,&
                                 DFTD3_VERSION = dftd3_version_pt, DFTD3_THREEBODY = dftd3_threebody_pt)
         END IF 
         IF ( lda_plus_u) THEN 
            ALLOCATE (dftU_obj)  
            CALL check_and_allocate(U_opt, Hubbard_U)
            CALL check_and_allocate(J0_opt, Hubbard_J0) 
            CALL check_and_allocate(alpha_opt, Hubbard_alpha) 
            CALL check_and_allocate(beta_opt, Hubbard_beta) 
            IF ( ANY(Hubbard_J(:,1:nsp) /= 0.0_DP)) THEN
               ALLOCATE (J_opt(3,nsp)) 
               J_opt(:, 1:nsp) = Hubbard_J(:, 1:nsp) 
            END IF 
            CALL qexsd_init_dftU (dftU_obj, NSP = nsp, SPECIES = atm(1:nsp), ITYP = ityp(1:nat),                     &
                                  IS_HUBBARD = is_hubbard, PSD = upf(1:nsp)%psd, NONCOLIN = noncolin, U =U_opt, &
                                  LDA_PLUS_U_KIND = lda_plus_u_kind, U_PROJECTION_TYPE = U_projection,               &
                                  J0 = J0_opt, alpha = alpha_opt, beta = beta_opt, J = J_opt,        & 
                                  starting_ns = starting_ns_eigenvalue, Hub_ns = rho%ns, Hub_ns_nc = rho%ns_nc ) 
         END IF 
         dft_name = get_dft_short()
         inlc = get_inlc()
         !
         CALL qexsd_init_dft  (output_obj%dft, dft_name, hybrid_obj, vdw_obj, dftU_obj)
         IF (ASSOCIATED (hybrid_obj)) THEN
            CALL qes_reset(hybrid_obj) 
            DEALLOCATE (hybrid_obj) 
         END IF 
         IF (ASSOCIATED (vdw_obj)) THEN
            CALL qes_reset(vdw_obj) 
            DEALLOCATE (vdw_obj) 
         END IF 
         IF (ASSOCIATED (dftU_obj)) THEN 
            CALL qes_reset( dftU_obj) 
            DEALLOCATE (dftU_obj) 
         END IF 
         !
!-------------------------------------------------------------------------------
! ... PERIODIC BOUNDARY CONDITIONS 
!-------------------------------------------------------------------------------
         !
         IF (ANY([do_makov_payne, do_comp_mt, do_comp_esm, do_cutoff_2D]))  THEN
            output_obj%boundary_conditions_ispresent=.TRUE.
            IF (do_makov_payne) THEN 
               pbc_label = 'makov_payne' 
            ELSE IF ( do_comp_mt) THEN 
               pbc_label = 'martyna_tuckerman' 
            ELSE IF ( do_comp_esm) THEN 
               pbc_label = 'esm' 
            ELSE IF ( do_cutoff_2D) THEN 
               pbc_label = '2D'
            ELSE 
               CALL errore ('pw_restart_new.f90: ', 'internal error line 470', 1) 
            END IF 
            CALL qexsd_init_outputPBC(output_obj%boundary_conditions, TRIM(pbc_label) )  
         ENDIF
         !
!-------------------------------------------------------------------------------
! ... MAGNETIZATION
!-------------------------------------------------------------------------------
         !
         CALL qexsd_init_magnetization(output_obj%magnetization, lsda, noncolin, lspinorb, &
              magtot, magtot_nc, absmag, domag )
         !

!--------------------------------------------------------------------------------------
! ... BAND STRUCTURE
!-------------------------------------------------------------------------------------
         !
         ! skip if not yet computed
         !
         IF ( only_init ) GO TO 10
         !
         IF ( .NOT. ( lgauss .OR. ltetra )) THEN 
            occupations_are_fixed = .TRUE.
            CALL get_homo_lumo( h_energy, lumo_tmp)
            h_energy = h_energy/e2
            h_energy_ptr => h_energy 
            IF ( lumo_tmp .LT. 1.d+6 ) THEN
                lumo_tmp = lumo_tmp/e2
                lumo_energy => lumo_tmp
            END IF
         ELSE 
            occupations_are_fixed = .FALSE. 
         END IF
         IF (nks_start == 0 .AND. nk1*nk2*nk3 > 0 ) THEN 
            CALL qexsd_init_k_points_ibz(qexsd_start_k_obj, "automatic", calculation, &
                 nk1, nk2, nk3, k1, k2, k3, nks_start, xk_start, wk_start, alat, at(:,1), .TRUE.)
         ELSE
            CALL qexsd_init_k_points_ibz(qexsd_start_k_obj, k_points, calculation, &
                                nk1, nk2, nk3, k1, k2, k3, nks_start, xk_start, wk_start, alat, at(:,1), .TRUE.)
         END IF
         qexsd_start_k_obj%tagname = 'starting_kpoints'
         IF ( TRIM (qexsd_input_obj%tagname) == 'input') THEN 
            qexsd_occ_obj = qexsd_input_obj%bands%occupations
         ELSE 
            CALL qexsd_init_occupations ( qexsd_occ_obj, input_parameters_occupations, nspin)
         END IF 
         qexsd_occ_obj%tagname = 'occupations_kind' 
         IF ( two_fermi_energies ) THEN
            ALLOCATE ( ef_updw (2) )
               IF (TRIM(input_parameters_occupations) == 'fixed') THEN  
                  ef_updw(1)  = MAXVAL(et(INT(nelup),1:nkstot/2))/e2
                  ef_updw (2)  = MAXVAL(et(INT(neldw),nkstot/2+1:nkstot))/e2 
               ELSE 
                  ef_updw = [ef_up/e2, ef_dw/e2]
               END IF
         ELSE IF (ltetra .OR. lgauss) THEN  
                ef_targ = ef/e2
                ef_point => ef_targ
         END IF


         IF ( lgauss ) THEN
            IF (TRIM(qexsd_input_obj%tagname) == 'input') THEN 
               smear_obj = qexsd_input_obj%bands%smearing
            ELSE
               smearing_loc = schema_smearing( smearing )
               CALL qexsd_init_smearing(smear_obj, smearing_loc, degauss/e2)
            END IF  
            smear_obj_ptr => smear_obj  
         END IF 
         !  
            
         CALL qexsd_init_band_structure(  output_obj%band_structure,lsda,noncolin,lspinorb, nelec, natomwfc, &
                                 et, wg, nkstot, xk, ngk_g, wk, SMEARING = smear_obj_ptr,  &
                                 STARTING_KPOINTS = qexsd_start_k_obj, OCCUPATIONS_KIND = qexsd_occ_obj, &
                                 WF_COLLECTED = wf_collect, NBND = nbnd, FERMI_ENERGY = ef_point, EF_UPDW = ef_updw,& 
                                 HOMO = h_energy_ptr, LUMO = lumo_energy )
         ! 
         IF (lgauss)  CALL qes_reset (smear_obj)
         CALL qes_reset (qexsd_start_k_obj)
         CALL qes_reset (qexsd_occ_obj)
         !
!-------------------------------------------------------------------------------------------
! ... TOTAL ENERGY
!-------------------------------------------------------------------------------------------
         !
         IF ( degauss > 0.0d0 ) THEN
            !
            itemp = itemp + 1 
            temp(itemp)  = degauss/e2
            degauss_ => temp(itemp)
            !
            itemp = itemp+1
            temp(itemp)   = demet/e2
            demet_ => temp(itemp) 
         END IF
         IF ( tefield ) THEN 
            itemp = itemp+1 
            temp(itemp) = etotefield/e2
            efield_corr => temp(itemp) 
         END IF
         IF (lfcpopt .OR. lfcpdyn ) THEN 
            itemp = itemp +1 
            temp(itemp) = ef * tot_charge/e2
            potstat_corr => temp(itemp) 
            output_obj%FCP_tot_charge_ispresent = .TRUE.
            output_obj%FCP_tot_charge = tot_charge
            output_obj%FCP_force_ispresent = .TRUE.
            !FIXME ( decide what units to use here ) 
            output_obj%FCP_force = fcp_mu - ef 
         END IF 
         IF ( gate) THEN
            itemp = itemp + 1 
            temp(itemp) = etotgatefield/e2
            gatefield_corr => temp(itemp)  
         END IF

         CALL  qexsd_init_total_energy(output_obj%total_energy, etot/e2, eband/e2, ehart/e2, vtxc/e2, &
                                       etxc/e2, ewld/e2, degauss_, demet_, efield_corr, potstat_corr,&
                                       gatefield_corr, DISPERSION_CONTRIBUTION = vdw_term_pt) 
         !
         NULLIFY(degauss_, demet_, efield_corr, potstat_corr, gatefield_corr)
         itemp = 0
          !
!---------------------------------------------------------------------------------------------
! ... FORCES
!----------------------------------------------------------------------------------------------
         !
         IF ( lforce ) THEN 
            output_obj%forces_ispresent = .TRUE.
            CALL qexsd_init_forces(output_obj%forces,nat,force,lforce)
         ELSE 
            output_obj%forces_ispresent = .FALSE.
            output_obj%forces%lwrite = .FALSE.  
         END IF 
         !
!------------------------------------------------------------------------------------------------
! ... STRESS 
!------------------------------------------------------------------------------------------------
         IF ( lstres) THEN
            output_obj%stress_ispresent=.TRUE.
            CALL qexsd_init_stress(output_obj%stress, sigma, lstres ) 
         ELSE 
            output_obj%stress_ispresent=.FALSE.
            output_obj%stress%lwrite=.FALSE.
         END IF
!-------------------------------------------------------------------------------------------------
! ... ELECTRIC FIELD
!-------------------------------------------------------------------------------------------------
         output_obj%electric_field_ispresent = ( gate .OR. lelfield .OR. lberry .OR. tefield ) 

         IF ( gate ) THEN 
            CALL qexsd_init_gate_info(gate_info_temp,"gateInfo", etotgatefield/e2, zgate, nelec, &
                   alat, at, bg, zv, ityp) 
            gate_info_ptr => gate_info_temp    
         END IF             
         IF ( lelfield ) THEN
            ALLOCATE (bp_el_pol(2), bp_ion_pol(3) )
            bp_el_pol = el_pol 
            bp_ion_pol(1:3) = ion_pol(1:3)
         END IF
         IF ( tefield .AND. dipfield) THEN 
            CALL qexsd_init_dipole_info(dipol_obj, el_dipole, ion_dipole, edir, eamp, &
                                  emaxpos, eopreg )  
            dipol_ptr => dipol_obj
         END IF
         IF ( lberry ) bp_obj_ptr => qexsd_bp_obj
         IF (output_obj%electric_field_ispresent) &
            CALL qexsd_init_outputElectricField(output_obj%electric_field, lelfield, tefield, dipfield, &
                 lberry, BP_OBJ = bp_obj_ptr, EL_POL = bp_el_pol, ION_POL = bp_ion_pol,          &
                 GATEINFO = gate_info_ptr, DIPOLE_OBJ =  dipol_ptr) 
         ! 
         IF (ASSOCIATED(gate_info_ptr)) THEN 
            CALL qes_reset (gate_info_ptr)
            NULLIFY(gate_info_ptr)
         ENDIF
         IF (ASSOCIATED (dipol_ptr) ) THEN
            CALL qes_reset (dipol_ptr)
            NULLIFY(dipol_ptr)
         ENDIF
         NULLIFY ( bp_obj_ptr) 
!-------------------------------------------------------------------------------
! ... ACTUAL WRITING
!-------------------------------------------------------------------------------
 10      CONTINUE
         !
         CALL qexsd_openschema( xmlfile(), iunpun, 'PWSCF', title )
         CALL qes_write (qexsd_xf,output_obj)
         CALL qes_reset (output_obj) 
         CALL qexsd_closeschema()
         !
!-------------------------------------------------------------------------------
         !
      END IF
      DEALLOCATE (ngk_g)
      !
      RETURN
       !
    CONTAINS
       SUBROUTINE check_and_allocate(alloc, mydata)
          IMPLICIT NONE
          REAL(DP),ALLOCATABLE  :: alloc(:) 
          REAL(DP)              :: mydata(:)  
          IF ( ANY(mydata(1:nsp) /= 0.0_DP)) THEN 
             ALLOCATE(alloc(nsp)) 
             alloc(1:nsp) = mydata(1:nsp) 
          END IF 
          RETURN
       END SUBROUTINE check_and_allocate 
       !
    END SUBROUTINE pw_write_schema
    !
    !------------------------------------------------------------------------
    SUBROUTINE pw_write_binaries( )
      !------------------------------------------------------------------------
      !
      USE mp,                   ONLY : mp_sum, mp_max
      USE io_base,              ONLY : write_wfc
      USE io_files,             ONLY : restart_dir, iunwfc, nwordwfc
      USE cell_base,            ONLY : tpiba, alat, bg
      USE control_flags,        ONLY : gamma_only, smallmem
      USE gvect,                ONLY : ig_l2g
      USE noncollin_module,     ONLY : noncolin, npol

      USE buffers,              ONLY : get_buffer
      USE wavefunctions, ONLY : evc
      USE klist,                ONLY : nks, nkstot, xk, ngk, igk_k
      USE gvect,                ONLY : ngm, g, mill
      USE fft_base,             ONLY : dfftp
      USE basis,                ONLY : natomwfc
      USE wvfct,                ONLY : npwx, et, wg, nbnd
      USE lsda_mod,             ONLY : nspin, isk, lsda
      USE mp_pools,             ONLY : intra_pool_comm, inter_pool_comm
      USE mp_bands,             ONLY : my_bgrp_id, root_bgrp, intra_bgrp_comm,&
                                       root_bgrp_id
      !
      IMPLICIT NONE
      !
      INTEGER               :: i, ig, ngg, ipol, ispin
      INTEGER               :: ik, ik_g, ike, iks, npw_g
      INTEGER, EXTERNAL     :: global_kpoint_index
      INTEGER,  ALLOCATABLE :: ngk_g(:), mill_k(:,:)
      INTEGER,  ALLOCATABLE :: igk_l2g(:), igk_l2g_kdip(:)
      CHARACTER(LEN=2), DIMENSION(2) :: updw = (/ 'up', 'dw' /)
      CHARACTER(LEN=256)    :: dirname
      CHARACTER(LEN=320)    :: filename
      !
      dirname = restart_dir () 
      !
      ! ... write wavefunctions and k+G vectors
      !
      iks = global_kpoint_index (nkstot, 1)
      ike = iks + nks - 1
      !
      ! ... ngk_g: global number of k+G vectors
      !
      ALLOCATE( ngk_g( nks ) )
      ngk_g(1:nks) = ngk(1:nks)
      CALL mp_sum( ngk_g, intra_bgrp_comm)
      !
      ! ... The igk_l2g array yields the correspondence between the
      ! ... local k+G index and the global G index
      !
      ALLOCATE ( igk_l2g( npwx ) )
      !
      ! ... the igk_l2g_kdip local-to-global map yields the correspondence
      ! ... between the global order of k+G and the local index for k+G.
      !
      ALLOCATE ( igk_l2g_kdip( npwx ) )
      !
      ALLOCATE ( mill_k( 3, npwx ) )
      !
      k_points_loop: DO ik = 1, nks
         !
         ! ik_g is the index of k-point ik in the global list
         !
         ik_g = ik + iks - 1
         !
         ! ... Compute the igk_l2g array from previously computed arrays
         ! ... igk_k (k+G indices) and ig_l2g (local to global G index map)
         !
         igk_l2g = 0
         DO ig = 1, ngk (ik)
            igk_l2g(ig) = ig_l2g(igk_k(ig,ik))
         END DO
         !
         ! ... npw_g is the maximum G vector index among all processors
         !
         npw_g = MAXVAL( igk_l2g(1:ngk(ik)) )
         CALL mp_max( npw_g, intra_pool_comm )
         !
         igk_l2g_kdip = 0
         CALL gk_l2gmap_kdip( npw_g, ngk_g(ik), ngk(ik), igk_l2g, &
                              igk_l2g_kdip )
         !
         ! ... mill_k(:,i) contains Miller indices for (k+G)_i
         !
         DO ig = 1, ngk (ik)
            mill_k(:,ig) = mill(:,igk_k(ig,ik))
         END DO
         !
         ! ... read wavefunctions - do not read if already in memory (nsk==1)
         !
         IF ( nks > 1 ) CALL get_buffer ( evc, nwordwfc, iunwfc, ik )
         !
         IF ( nspin == 2 ) THEN
            !
            ! ... LSDA: spin mapped to k-points, isk(ik) tracks up and down spin
            !
            ik_g = MOD ( ik_g-1, nkstot/2 ) + 1 
            ispin = isk(ik)
            filename = TRIM(dirname) // 'wfc' // updw(ispin) // &
                 & TRIM(int_to_char(ik_g))
            !
         ELSE
            !
            ispin = 1
            filename = TRIM(dirname) // 'wfc' // TRIM(int_to_char(ik_g))
            !
         ENDIF
         !
         ! ... Only the first band group of each pool writes
         ! ... No warranty it works for more than one band group
         !
         IF ( my_bgrp_id == root_bgrp_id ) CALL write_wfc( iunpun, &
              filename, root_bgrp, intra_bgrp_comm, ik_g, tpiba*xk(:,ik), &
              ispin, nspin, evc, npw_g, gamma_only, nbnd, &
              igk_l2g_kdip(:), ngk(ik), tpiba*bg(:,1), tpiba*bg(:,2), &
              tpiba*bg(:,3), mill_k, 1.D0 )
         !
      END DO k_points_loop
      !
      DEALLOCATE ( mill_k )
      DEALLOCATE ( igk_l2g_kdip )
      DEALLOCATE ( igk_l2g )
      DEALLOCATE ( ngk_g )
      !
      RETURN
      !
    END SUBROUTINE pw_write_binaries
    !
    !-----------------------------------------------------------------------
    SUBROUTINE gk_l2gmap_kdip( npw_g, ngk_g, ngk, igk_l2g, igk_l2g_kdip, igwk )
      !-----------------------------------------------------------------------
      !
      ! ... This subroutine maps local G+k index to the global G vector index
      ! ... the mapping is used to collect wavefunctions subsets distributed
      ! ... across processors.
      ! ... This map is used to obtained the G+k grids related to each kpt
      !
      USE mp_bands,             ONLY : intra_bgrp_comm
      USE mp,                   ONLY : mp_sum
      !
      IMPLICIT NONE
      !
      ! ... Here the dummy variables
      !
      INTEGER, INTENT(IN)  :: npw_g, ngk_g, ngk
      INTEGER, INTENT(IN)  :: igk_l2g(ngk)
      INTEGER, INTENT(OUT) :: igk_l2g_kdip(ngk)
      INTEGER, OPTIONAL, INTENT(OUT) :: igwk(ngk_g)
      !
      INTEGER, ALLOCATABLE :: igwk_(:), itmp(:), igwk_lup(:)
      INTEGER              :: ig, ig_, ngg
      !
      !
      ALLOCATE( itmp( npw_g ) )
      ALLOCATE( igwk_( ngk_g ) )
      !
      itmp(:)  = 0
      igwk_(:) = 0
      !
      DO ig = 1, ngk
         itmp(igk_l2g(ig)) = igk_l2g(ig)
      END DO
      !
      CALL mp_sum( itmp, intra_bgrp_comm )
      !
      ngg = 0
      DO ig = 1, npw_g
         !
         IF ( itmp(ig) == ig ) THEN
            !
            ngg = ngg + 1
            igwk_(ngg) = ig
            !
         END IF
         !
      END DO
      !
      IF ( ngg /= ngk_g ) &
         CALL errore( 'gk_l2gmap_kdip', 'unexpected dimension in ngg', 1 )
      !
      IF ( PRESENT( igwk ) ) THEN
         !
         igwk(1:ngk_g) = igwk_(1:ngk_g)
         !
      END IF
      !
      ALLOCATE( igwk_lup( npw_g ) )
      !
!$omp parallel private(ig_, ig)
!$omp workshare
      igwk_lup = 0
!$omp end workshare
!$omp do
      DO ig_ = 1, ngk_g
         igwk_lup(igwk_(ig_)) = ig_
      END DO
!$omp end do
!$omp do
      DO ig = 1, ngk
         igk_l2g_kdip(ig) = igwk_lup(igk_l2g(ig))
      END DO
!$omp end do
!$omp end parallel
      !
      DEALLOCATE( igwk_lup )
      !
      DEALLOCATE( itmp, igwk_ )
      !
      RETURN
      !
    END SUBROUTINE gk_l2gmap_kdip
    !
    !--------------------------------------------------------------------------
    SUBROUTINE qepy_read_xml_file ( wfc_is_collected, alloc )
      !------------------------------------------------------------------------
      !
      ! ... This routine allocates space for all quantities already computed
      ! ... in the pwscf program and reads them from the data file.
      ! ... All quantities that are initialized in subroutine "setup" when
      ! ... starting from scratch should be initialized here when restarting
      !
      USE kinds,           ONLY : dp
      USE constants,       ONLY : e2
      USE gvect,           ONLY : ngm_g, ecutrho
      USE gvecs,           ONLY : ngms_g, dual
      USE gvecw,           ONLY : ecutwfc
      USE fft_base,        ONLY : dfftp, dffts
      USE io_global,       ONLY : stdout
      USE io_files,        ONLY : psfile, pseudo_dir, pseudo_dir_cur, &
           restart_dir
      USE mp_global,       ONLY : nproc_file, nproc_pool_file, &
           nproc_image_file, ntask_groups_file, &
           nproc_bgrp_file, nproc_ortho_file
      USE ions_base,       ONLY : nat, nsp, ityp, amass, atm, tau, extfor
      USE cell_base,       ONLY : alat, at, bg, ibrav, celldm, omega
      USE force_mod,       ONLY : force
      USE klist,           ONLY : nks, nkstot, xk, wk, tot_magnetization, &
           nelec, nelup, neldw, smearing, degauss, ngauss, lgauss, ltetra,&
           two_fermi_energies
      USE ktetra,          ONLY : ntetra, tetra_type
      USE start_k,         ONLY : nks_start, xk_start, wk_start, &
           nk1, nk2, nk3, k1, k2, k3
      USE ener,            ONLY : ef, ef_up, ef_dw
      USE electrons_base,  ONLY : nupdwn, set_nelup_neldw
      USE wvfct,           ONLY : npwx, nbnd, et, wg
      USE extfield,        ONLY : forcefield, forcegate, tefield, dipfield, &
           edir, emaxpos, eopreg, eamp, el_dipole, ion_dipole, gate, zgate, &
           relaxz, block, block_1, block_2, block_height
      USE symm_base,       ONLY : nrot, nsym, invsym, s, ft, irt, t_rev, &
           sname, inverse_s, s_axis_to_cart, &
           time_reversal, no_t_rev, nosym, checkallsym
      USE ldaU,            ONLY : lda_plus_u, lda_plus_u_kind, Hubbard_lmax, &
           Hubbard_l, Hubbard_U, Hubbard_J, Hubbard_alpha, &
           Hubbard_J0, Hubbard_beta, U_projection
      USE funct,           ONLY : set_exx_fraction, set_screening_parameter, &
           set_gau_parameter, enforce_input_dft,  &
           start_exx, dft_is_hybrid
      USE london_module,   ONLY : scal6, lon_rcut, in_C6
      USE tsvdw_module,    ONLY : vdw_isolated
      USE exx_base,        ONLY : x_gamma_extrapolation, nq1, nq2, nq3, &
           exxdiv_treatment, yukawa, ecutvcut
      USE exx,             ONLY : ecutfock, local_thr
      USE control_flags,   ONLY : noinv, gamma_only, tqr, llondon, ldftd3, &
           lxdm, ts_vdw
      USE Coul_cut_2D,     ONLY : do_cutoff_2D
      USE noncollin_module,ONLY : noncolin, npol, angle1, angle2, bfield, &
           nspin_lsda, nspin_gga, nspin_mag
      USE spin_orb,        ONLY : domag, lspinorb
      USE lsda_mod,        ONLY : nspin, isk, lsda, starting_magnetization,&
           current_spin
      USE realus,          ONLY : real_space
      USE basis,           ONLY : natomwfc
      USE uspp,            ONLY : okvan
      USE paw_variables,   ONLY : okpaw
      !
      USE mp_images,       ONLY : intra_image_comm
      USE mp,              ONLY : mp_bcast
      !
      !qepy --> other parameters
      USE tsvdw_module,         ONLY : vdw_econv_thr
      USE input_parameters,     ONLY : verbosity, calculation, ion_dynamics, starting_ns_eigenvalue, &
                                       vdw_corr, london, k_points, assume_isolated, &  
                                       input_parameters_occupations => occupations, dftd3_threebody, &
                                       dftd3_version
      !qepy <-- other parameters
      !
      IMPLICIT NONE
      LOGICAL, INTENT(OUT) :: wfc_is_collected
      !
      LOGICAL, INTENT(IN), OPTIONAL :: alloc
      LOGICAL :: lalloc
      !
      INTEGER  :: i, is, ik, ierr, dum1,dum2,dum3
      LOGICAL  :: magnetic_sym, lvalid_input, lfixed
      !qepy --> 
      !CHARACTER(LEN=20) :: dft_name, vdw_corr, occupations
      CHARACTER(LEN=20) :: dft_name, occupations
      !qepy <-- 
      CHARACTER(LEN=320):: filename
      REAL(dp) :: exx_fraction, screening_parameter
      TYPE (output_type)        :: output_obj 
      TYPE (parallel_info_type) :: parinfo_obj
      TYPE (general_info_type ) :: geninfo_obj
      TYPE (input_type)         :: input_obj
      !
      if (present(alloc)) then
         lalloc = alloc
      else
         lalloc = .TRUE.
      endif
      !
      !
      filename = xmlfile ( )
      !
      IF (ionode) CALL qexsd_readschema ( filename, &
           ierr, output_obj, parinfo_obj, geninfo_obj, input_obj)
      CALL mp_bcast(ierr, ionode_id, intra_image_comm)
      IF ( ierr > 0 ) CALL errore ( 'read_xml_file', 'fatal error reading xml file', ierr ) 
      CALL qes_bcast(output_obj, ionode_id, intra_image_comm)
      CALL qes_bcast(parinfo_obj, ionode_id, intra_image_comm)
      CALL qes_bcast(geninfo_obj, ionode_id, intra_image_comm) 
      CALL qes_bcast(input_obj, ionode_id, intra_image_comm)
      !
      ! ... Now read all needed variables from xml objects
      !
      wfc_is_collected = output_obj%band_structure%wf_collected
      lvalid_input = (TRIM(input_obj%tagname) == "input")
      !
      CALL qexsd_copy_parallel_info (parinfo_obj, nproc_file, &
           nproc_pool_file, nproc_image_file, ntask_groups_file, &
           nproc_bgrp_file, nproc_ortho_file)
      !
      pseudo_dir_cur = restart_dir ( )
      CALL qexsd_copy_atomic_species ( output_obj%atomic_species, &
           nsp, atm, amass, angle1, angle2, starting_magnetization, &
           psfile, pseudo_dir ) 
      IF ( pseudo_dir == ' ' ) pseudo_dir=pseudo_dir_cur
      !! Atomic structure section
      !! tau and ityp are allocated inside qexsd_copy_atomic_structure
      !
      CALL qexsd_copy_atomic_structure (output_obj%atomic_structure, nsp, &
           atm, nat, tau, ityp, alat, at(:,1), at(:,2), at(:,3), ibrav )
      !
      !! More initializations needed for atomic structure:
      !! bring atomic positions and crystal axis into "alat" units;
      !! recalculate celldm; compute cell volume, reciprocal lattice vectors
      !
      at = at / alat
      tau(:,1:nat) = tau(:,1:nat)/alat  
      CALL at2celldm (ibrav,alat,at(:,1),at(:,2),at(:,3),celldm)
      CALL volume (alat,at(:,1),at(:,2),at(:,3),omega)
      !!
      !! Basis set section
      if (lalloc) then
      !qepy: Here, npwx is npwx_g, which is greater than npwx in mpi
      CALL qexsd_copy_basis_set ( output_obj%basis_set, gamma_only, ecutwfc,&
           ecutrho, dffts%nr1,dffts%nr2,dffts%nr3, dfftp%nr1,dfftp%nr2,dfftp%nr3, &
           dum1,dum2,dum3, ngm_g, ngms_g, npwx, bg(:,1), bg(:,2), bg(:,3) )
      ecutwfc = ecutwfc*e2
      ecutrho = ecutrho*e2
      endif
      dual = ecutrho/ecutwfc
      ! FIXME: next line ensures exact consistency between reciprocal and
      ! direct lattice vectors, preventing weird phonon symmetry errors
      ! (due to lousy algorithms, extraordinarily sensitive to tiny errors)
      CALL recips ( at(1,1), at(1,2), at(1,3), bg(1,1), bg(1,2), bg(1,3) )
      !!
      !! DFT section
      CALL qexsd_copy_dft ( output_obj%dft, nsp, atm, &
           dft_name, nq1, nq2, nq3, ecutfock, exx_fraction, screening_parameter, &
           exxdiv_treatment, x_gamma_extrapolation, ecutvcut, local_thr, &
           lda_plus_U, lda_plus_U_kind, U_projection, Hubbard_l, Hubbard_lmax, &
           Hubbard_U, Hubbard_J0, Hubbard_alpha, Hubbard_beta, Hubbard_J, &
           vdw_corr, scal6, lon_rcut, vdw_isolated )
      !! More DFT initializations
      CALL set_vdw_corr ( vdw_corr, llondon, ldftd3, ts_vdw, lxdm )
      CALL enforce_input_dft ( dft_name, .TRUE. )
      IF ( dft_is_hybrid() ) THEN
         ecutvcut=ecutvcut*e2
         ecutfock=ecutfock*e2
         CALL set_exx_fraction( exx_fraction ) 
         CALL set_screening_parameter ( screening_parameter )
         CALL start_exx ()
      END IF
      !! Band structure section
      !! et and wg are allocated inside qexsd_copy_band_structure
      CALL qexsd_copy_band_structure( output_obj%band_structure, lsda, &
           nkstot, isk, natomwfc, nbnd, nupdwn(1), nupdwn(2), nelec, xk, &
           wk, wg, ef, ef_up, ef_dw, et )
      ! convert to Ry
      ef = ef*e2
      ef_up = ef_up*e2
      ef_dw = ef_dw*e2
      two_fermi_energies = ( ef_up /= 0.0_dp ) .AND. ( ef_dw /= 0.0_dp )
      et(:,:) = et(:,:)*e2
      !
      ! ... until pools are activated, the local number of k-points nks
      ! ... should be equal to the global number nkstot - k-points are replicated
      !
      nks = nkstot
      !!
      !! Magnetization section
      CALL qexsd_copy_magnetization ( output_obj%magnetization, lsda, noncolin,&
           lspinorb, domag, tot_magnetization )
      !
      bfield = 0.d0
      CALL set_spin_vars( lsda, noncolin, lspinorb, domag, &
           npol, nspin, nspin_lsda, nspin_mag, nspin_gga, current_spin )
      !! Information for generating k-points and occupations
      CALL qexsd_copy_kpoints( output_obj%band_structure, &
           nks_start, xk_start, wk_start, nk1, nk2, nk3, k1, k2, k3, &
           occupations, smearing, degauss )
      degauss = degauss * e2 
      !
      CALL set_occupations( occupations, smearing, degauss, &
           lfixed, ltetra, tetra_type, lgauss, ngauss )
      IF (ltetra) ntetra = 6* nk1 * nk2 * nk3 
      IF (lfixed) CALL errore('read_file','bad occupancies',1)
      IF ( lsda ) &
           CALL set_nelup_neldw(tot_magnetization, nelec, nelup, neldw) 
      !! Symmetry section
      if (lalloc) then
      ALLOCATE ( irt(48,nat) )
      endif
      IF ( lvalid_input ) THEN 
         CALL qexsd_copy_symmetry ( output_obj%symmetries, &
              nsym, nrot, s, ft, sname, t_rev, invsym, irt, &
              noinv, nosym, no_t_rev, input_obj%symmetry_flags )
         
         CALL qexsd_copy_efield ( input_obj%electric_field, &
              tefield, dipfield, edir, emaxpos, eopreg, eamp, &
              gate, zgate, block, block_1, block_2, block_height, relaxz )
         
      ELSE 
         CALL qexsd_copy_symmetry ( output_obj%symmetries, &
              nsym, nrot, s, ft, sname, t_rev, invsym, irt, &
              noinv, nosym, no_t_rev )
      ENDIF
      !! More initialization needed for symmetry
      magnetic_sym = noncolin .AND. domag
      time_reversal = (.NOT.magnetic_sym) .AND. (.NOT.noinv) 
      CALL inverse_s()
      CALL s_axis_to_cart()
      !! symmetry check - FIXME: is this needed?
      IF (nat > 0) CALL checkallsym( nat, tau, ityp)
      !! Algorithmic info
      do_cutoff_2D = (output_obj%boundary_conditions%assume_isolated == "2D")
      CALL qexsd_copy_algorithmic_info ( output_obj%algorithmic_info, &
           real_space, tqr, okvan, okpaw )
      !qepy --> additional parameters
      dftd3_version   = output_obj%dft%vdW%dftd3_version
      dftd3_threebody = output_obj%dft%vdW%dftd3_threebody
      !vdw_econv_thr   = output_obj%dft%vdW%ts_vdw_econv_thr
      !!ts_vdw_econv_thr not in output but in input
      vdw_econv_thr   = input_obj%dft%vdW%ts_vdw_econv_thr
      !qepy <-- additional parameters
      !
      ! ... xml data no longer needed, can be discarded
      !
      CALL qes_reset  ( output_obj )
      CALL qes_reset  ( geninfo_obj )
      CALL qes_reset  ( parinfo_obj )
      IF ( TRIM(input_obj%tagname) == "input") CALL qes_reset ( input_obj) 
      !
      ! END OF READING VARIABLES FROM XML DATA FILE
      !
      if (lalloc) then
      ALLOCATE( force ( 3, nat ) )
      ALLOCATE( extfor( 3, nat ) )
      IF ( tefield ) ALLOCATE( forcefield( 3, nat ) )
      IF ( gate ) ALLOCATE( forcegate( 3, nat ) )
      endif
      !
    END SUBROUTINE qepy_read_xml_file
    !
    !------------------------------------------------------------------------
    SUBROUTINE read_collected_wfc ( dirname, ik, evc )
      !------------------------------------------------------------------------
      !
      ! ... reads from directory "dirname" (new file format) for k-point "ik"
      ! ... wavefunctions from collected format into distributed array "evc"
      !
      USE control_flags,        ONLY : gamma_only
      USE lsda_mod,             ONLY : nspin, isk
      USE noncollin_module,     ONLY : noncolin, npol
      USE klist,                ONLY : nkstot, nks, xk, ngk, igk_k
      USE wvfct,                ONLY : npwx, g2kin, et, wg, nbnd
      USE gvect,                ONLY : ig_l2g
      USE mp_bands,             ONLY : root_bgrp, intra_bgrp_comm
      USE mp_pools,             ONLY : me_pool, root_pool, &
                                       intra_pool_comm, inter_pool_comm
      USE mp,                   ONLY : mp_sum, mp_max
      USE io_base,              ONLY : read_wfc
      !
      IMPLICIT NONE
      !
      CHARACTER(LEN=*), INTENT(IN) :: dirname
      INTEGER, INTENT(IN) :: ik
      COMPLEX(dp), INTENT(OUT) :: evc(:,:)
      !
      CHARACTER(LEN=2), DIMENSION(2) :: updw = (/ 'up', 'dw' /)
      CHARACTER(LEN=320)   :: filename, msg
      INTEGER              :: i, ik_g, ig, ipol, ik_s
      INTEGER              :: npol_, nbnd_
      INTEGER              :: nupdwn(2), ike, iks, ngk_g, npw_g, ispin
      INTEGER, EXTERNAL    :: global_kpoint_index
      INTEGER, ALLOCATABLE :: mill_k(:,:)
      INTEGER, ALLOCATABLE :: igk_l2g(:), igk_l2g_kdip(:)
      LOGICAL              :: opnd, ionode_k
      REAL(DP)             :: scalef, xk_(3), b1(3), b2(3), b3(3)
      !
      ! ... the root processor of each pool reads
      !
      ionode_k = (me_pool == root_pool)
      !
      iks = global_kpoint_index (nkstot, 1)
      ike = iks + nks - 1
      !
      ! ik_g: index of k-point ik in the global list
      !
      ik_g = ik + iks - 1
      !
      ! ... the igk_l2g_kdip local-to-global map is needed to read wfcs
      !
      ALLOCATE ( igk_l2g_kdip( npwx ) )
      !
      ! ... The igk_l2g array yields the correspondence between the
      ! ... local k+G index and the global G index - requires arrays
      ! ... igk_k (k+G indices) and ig_l2g (local to global G index map)
      !
      ALLOCATE ( igk_l2g( npwx ) )
      igk_l2g = 0
      DO ig = 1, ngk(ik)
         igk_l2g(ig) = ig_l2g(igk_k(ig,ik))
      END DO
      !
      ! ... npw_g: the maximum G vector index among all processors
      ! ... ngk_g: global number of k+G vectors for all k points
      !
      npw_g = MAXVAL( igk_l2g(1:ngk(ik)) )
      CALL mp_max( npw_g, intra_pool_comm )
      ngk_g = ngk(ik)
      CALL mp_sum( ngk_g, intra_bgrp_comm)
      !
      ! ... now compute the igk_l2g_kdip local-to-global map
      !
      igk_l2g_kdip = 0
      CALL gk_l2gmap_kdip( npw_g, ngk_g, ngk(ik), igk_l2g, &
           igk_l2g_kdip )
      DEALLOCATE ( igk_l2g )
      !
      IF ( nspin == 2 ) THEN
         !
         ! ... LSDA: spin mapped to k-points, isk(ik) tracks up and down spin
         !
         ik_g = MOD ( ik_g-1, nkstot/2 ) + 1 
         ispin = isk(ik)
         filename = TRIM(dirname) // 'wfc' // updw(ispin) // &
              & TRIM(int_to_char(ik_g))
         !
      ELSE
         !
         filename = TRIM(dirname) // 'wfc' // TRIM(int_to_char(ik_g))
         !
      ENDIF
      !
      ! ... Miller indices are read from file (but not used)
      !
      ALLOCATE( mill_k ( 3,npwx ) )
      !
      evc=(0.0_DP, 0.0_DP)
      !
      CALL read_wfc( iunpun, filename, root_bgrp, intra_bgrp_comm, &
           ik_g, xk_, ispin, npol_, evc, npw_g, gamma_only, nbnd_, &
           igk_l2g_kdip(:), ngk(ik), b1, b2, b3, mill_k, scalef )
      !
      DEALLOCATE ( mill_k )
      DEALLOCATE ( igk_l2g_kdip )
      !
      ! ... here one should check for consistency between what is read
      ! ... and what is expected
      !
      IF ( nbnd_ < nbnd ) THEN
         WRITE (msg,'("The number of bands for this run is",I6,", but only",&
              & I6," bands were read from file")')  nbnd, nbnd_  
         CALL errore ('pw_restart - read_collected_wfc', msg, 1 )
      END IF
      !
      RETURN
      !
    END SUBROUTINE read_collected_wfc
    !
    !------------------------------------------------------------------------
  END MODULE qepy_pw_restart_new

!
! Copyright (C) 2004-2016 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
!-------------------------------------------------------------------
MODULE funct
  !-------------------------------------------------------------------
  !! This module contains data defining the DFT functional in use
  !! and a number of functions and subroutines to manage them.  
  !! Data are PRIVATE and are accessed and set only by function calls.
  !
  !   setting routines:  set_dft_from_name (previously which_dft)
  !                      set_dft_from_indices
  !                      enforce_input_dft
  !                      start_exx
  !                      stop_exx
  !                      set_finite_size_volume
  !   retrieve functions: get_dft_name, get_dft_short, get_dft_long
  !                      get_iexch
  !                      get_icorr
  !                      get_igcx
  !                      get_igcc
  !                      get_exx_fraction
  !                      write_dft_name
  !  logical functions:  dft_is_gradient
  !                      dft_is_meta
  !                      dft_is_hybrid
  !                      dft_is_nonlocc
  !                      exx_is_active
  !                      dft_has_finite_size_correction
  !
  !
  USE io_global,   ONLY: stdout
  USE kinds,       ONLY: DP
#if defined(__LIBXC)
  USE xc_f90_types_m
  USE xc_f90_lib_m
#endif
  !
  IMPLICIT NONE
  !
  PRIVATE
  SAVE
  !
  ! subroutines/functions managing dft name and indices
  PUBLIC  :: set_dft_from_indices, set_dft_from_name
  PUBLIC  :: enforce_input_dft, write_dft_name
  PUBLIC  :: get_dft_name, get_dft_short, get_dft_long,&
             get_nonlocc_name
  PUBLIC  :: get_iexch, get_icorr, get_igcx, get_igcc, get_meta, get_metac, get_inlc
  PUBLIC  :: dft_is_gradient, dft_is_meta, dft_is_hybrid, dft_is_nonlocc, igcc_is_lyp
  PUBLIC  :: set_auxiliary_flags
  !
  ! additional subroutines/functions for hybrid functionals
  PUBLIC  :: start_exx, stop_exx, get_exx_fraction, exx_is_active, scan_exx
  PUBLIC  :: set_exx_fraction, dft_force_hybrid
  PUBLIC  :: set_screening_parameter, get_screening_parameter
  PUBLIC  :: set_gau_parameter, get_gau_parameter
  !
  ! additional subroutines/functions for finite size corrections
  PUBLIC  :: dft_has_finite_size_correction, set_finite_size_volume
  PUBLIC  :: get_finite_size_cell_volume
  ! rpa specific
  PUBLIC  :: init_dft_exxrpa, enforce_dft_exxrpa
  !
  ! driver subroutines computing XC
  PUBLIC  :: is_libxc
  PUBLIC  :: nlc
  !
  ! PRIVATE variables defining the DFT functional
  !
  PRIVATE :: iexch, icorr, igcx, igcc, imeta, imetac, inlc
  PRIVATE :: dft, discard_input_dft
  PRIVATE :: isgradient, ismeta, ishybrid
  PRIVATE :: exx_fraction, exx_started
  PRIVATE :: has_finite_size_correction, &
             finite_size_cell_volume,  finite_size_cell_volume_set
  !
  CHARACTER(LEN=25) :: dft = 'not set'
  !
  ! ------------------------------------------------------------------------
  ! "dft" is the exchange-correlation functional label, as set by the user,
  ! using either set_dft_from_name or set_dft_from_indices. It can contain
  ! either the short names or a series of the keywords listed below.
  ! All operations on names are case-insensitive.
  !
  !           short name       complete name       Short description
  !              "pz"    = "sla+pz"            = Perdew-Zunger LDA
  !              "bp"    = "b88+p86"           = Becke-Perdew grad.corr.
  !              "pw91"  = "sla+pw+ggx+ggc"    = PW91 (aka GGA)
  !              "blyp"  = "sla+b88+lyp+blyp"  = BLYP
  !              "pbe"   = "sla+pw+pbx+pbc"    = PBE
  !              "revpbe"= "sla+pw+rpb+pbc"    = revPBE (Zhang-Yang)
  !              "pw86pbe" = "sla+pw+pw86+pbc" = PW86 exchange + PBE correlation
  !              "b86bpbe" = "sla+pw+b86b+pbc" = B86b exchange + PBE correlation
  !              "pbesol"= "sla+pw+psx+psc"    = PBEsol
  !              "q2d"   = "sla+pw+q2dx+q2dc"  = PBEQ2D
  !              "hcth"  = "nox+noc+hcth+hcth" = HCTH/120
  !              "olyp"  = "nox+lyp+optx+blyp" = OLYP
  !              "wc"    = "sla+pw+wcx+pbc"    = Wu-Cohen
  !              "sogga" = "sla+pw+sox+pbec"   = SOGGA
  !              "optbk88"="sla+pw+obk8+p86"   = optB88
  !              "optb86b"="sla+pw+ob86+p86"   = optB86
  !              "ev93"  = "sla+pw+evx+nogc"   = Engel-Vosko
  !              "tpss"  = "sla+pw+tpss+tpss"  = TPSS Meta-GGA
  !              "m06l"  = "nox+noc+m6lx+m6lc" = M06L Meta-GGA
  !              "tb09"  = "sla+pw+tb09+tb09"  = TB09 Meta-GGA
  !              "pbe0"  = "pb0x+pw+pb0x+pbc"  = PBE0
  !              "b86bx" = "pb0x+pw+b86x+pbc"  = B86bPBE hybrid
  !              "bhahlyp"="pb0x+pw+b88x+blyp" = Becke half-and-half LYP
  !              "hse"   = "sla+pw+hse+pbc"    = Heyd-Scuseria-Ernzerhof (HSE 06, see note below)
  !              "b3lyp"                        = B3LYP
  !              "b3lyp-v1r"                    = B3LYP-VWN1-RPA
  !              "x3lyp"                        = X3LYP
  !              "vwn-rpa" = VWN LDA using vwn1-rpa parametrization
  !              "gaupbe"= "sla+pw+gaup+pbc"   = Gau-PBE (also "gaup")
  !              "vdw-df"       ="sla+pw+rpb +vdw1"   = vdW-DF1
  !              "vdw-df2"      ="sla+pw+rw86+vdw2"   = vdW-DF2
  !              "vdw-df-c09"   ="sla+pw+c09x+vdw1"   = vdW-DF-C09
  !              "vdw-df2-c09"  ="sla+pw+c09x+vdw2"   = vdW-DF2-C09
  !              "vdw-df-obk8"  ="sla+pw+obk8+vdw1"   = vdW-DF-obk8 (optB88-vdW)
  !              "vdw-df-ob86"  ="sla+pw+ob86+vdw1"   = vdW-DF-ob86 (optB86b-vdW)
  !              "vdw-df2-b86r" ="sla+pw+b86r+vdw2"   = vdW-DF2-B86R (rev-vdw-df2)
  !              "vdw-df-cx"    ="sla+pw+cx13+vdW1"   = vdW-DF-cx
  !              "vdw-df-cx0"    ="sla+pw+cx13+vdW1+HF/4"   = vdW-DF-cx-0
  !              "vdw-df2-0"     ="sla+pw+rw86+vdw2+HF/4"   = vdW-DF2-0
  !              "vdw-df2-br0"  ="sla+pw+b86r+vdW2+HF/4"   = vdW-DF2-b86r-0
  !              "vdw-df-c090"   ="sla+pw+c09x+vdw1+HF/4"   = vdW-DF-C09-0
  !              "vdw-df-x"     ="sla+pw+????+vdwx"   = vdW-DF-x, reserved Thonhauser, not implemented
  !              "vdw-df-y"     ="sla+pw+????+vdwy"   = vdW-DF-y, reserved Thonhauser, not implemented
  !              "vdw-df-z"     ="sla+pw+????+vdwz"   = vdW-DF-z, reserved Thonhauser, not implemented
  !              "rvv10" = "sla+pw+rw86+pbc+vv10"     = rVV10
  !
  ! Any nonconflicting combination of the following keywords is acceptable:
  !
  ! Exchange:    "nox"    none                           iexch=0
  !              "sla"    Slater (alpha=2/3)             iexch=1 (default)
  !              "sl1"    Slater (alpha=1.0)             iexch=2
  !              "rxc"    Relativistic Slater            iexch=3
  !              "oep"    Optimized Effective Potential  iexch=4
  !              "hf"     Hartree-Fock                   iexch=5
  !              "pb0x"   (Slater*0.75+HF*0.25)          iexch=6 for PBE0 and vdW-DF-cx0 and vdW-DF2-0 etc
  !              "b3lp"   B3LYP(Slater*0.80+HF*0.20)     iexch=7
  !              "kzk"    Finite-size corrections        iexch=8
  !              "x3lp"   X3LYP(Slater*0.782+HF*0.218)   iexch=9
  !              "kli"    KLI aproximation for exx       iexch=10
  !
  ! Correlation: "noc"    none                           icorr=0
  !              "pz"     Perdew-Zunger                  icorr=1 (default)
  !              "vwn"    Vosko-Wilk-Nusair              icorr=2
  !              "lyp"    Lee-Yang-Parr                  icorr=3
  !              "pw"     Perdew-Wang                    icorr=4
  !              "wig"    Wigner                         icorr=5
  !              "hl"     Hedin-Lunqvist                 icorr=6
  !              "obz"    Ortiz-Ballone form for PZ      icorr=7
  !              "obw"    Ortiz-Ballone form for PW      icorr=8
  !              "gl"     Gunnarson-Lunqvist             icorr=9
  !              "kzk"    Finite-size corrections        icorr=10
  !              "vwn-rpa" Vosko-Wilk-Nusair, alt param  icorr=11
  !              "b3lp"   B3LYP (0.19*vwn+0.81*lyp)      icorr=12
  !              "b3lpv1r"  B3LYP-VWN-1-RPA
  !                         (0.19*vwn_rpa+0.81*lyp)      icorr=13
  !              "x3lp"   X3LYP (0.129*vwn_rpa+0.871*lyp)icorr=14
  !
  ! Gradient Correction on Exchange:
  !              "nogx"   none                           igcx =0 (default)
  !              "b88"    Becke88 (beta=0.0042)          igcx =1
  !              "ggx"    Perdew-Wang 91                 igcx =2
  !              "pbx"    Perdew-Burke-Ernzenhof exch    igcx =3
  !              "rpb"    revised PBE by Zhang-Yang      igcx =4
  !              "hcth"   Cambridge exch, Handy et al    igcx =5
  !              "optx"   Handy's exchange functional    igcx =6
  !              "pb0x"   PBE0 (PBE exchange*0.75)       igcx =8
  !              "b3lp"   B3LYP (Becke88*0.72)           igcx =9
  !              "psx"    PBEsol exchange                igcx =10
  !              "wcx"    Wu-Cohen                       igcx =11
  !              "hse"    HSE screened exchange          igcx =12
  !              "rw86"   revised PW86                   igcx =13
  !              "pbe"    same as PBX, back-comp.        igcx =14
  !              "c09x"   Cooper 09                      igcx =16
  !              "sox"    sogga                          igcx =17
  !              "q2dx"   Q2D exchange grad corr         igcx =19
  !              "gaup"   Gau-PBE hybrid exchange        igcx =20
  !              "pw86"   Perdew-Wang (1986) exchange    igcx =21
  !              "b86b"   Becke (1986) exchange          igcx =22
  !              "obk8"   optB88  exchange               igcx =23
  !              "ob86"   optB86b exchange               igcx =24
  !              "evx"    Engel-Vosko exchange           igcx =25
  !              "b86r"   revised Becke (b86b)           igcx =26
  !              "cx13"   consistent exchange            igcx =27
  !              "x3lp"   X3LYP (Becke88*0.542 +
  !                              Perdew-Wang91*0.167)    igcx =28
  !              "cx0"    vdW-DF-cx+HF/4 (cx13-0)        igcx =29 
  !              "r860"   rPW86+HF/4 (rw86-0)            igcx =30 (for DF0)
  !              "cx0p"   vdW-DF-cx+HF/5 (cx13-0p)       igcx =31 
  !              "ahcx"   vdW-DF-cx based not yet in use igcx =32 reserved PH
  !              "ahf2"   vdW-DF2 based not yet in use   igcx =33 reserved PH
  !              "ahpb"   PBE based not yet in use       igcx =34 reserved PH
  !              "ahps"   PBE-sol based not in use       igcx =35 reserved PH
  !              "cx14"   Exporations                    igcx =36 reserved PH
  !              "cx15"   Exporations                    igcx =37 reserved PH
  !              "br0"    vdW-DF2-b86r+HF/4 (b86r-0)     igcx =38 
  !              "cx16"   Exporations                    igcx =39 reserved PH
  !              "c090"   vdW-DF-c09+HF/4 (c09-0)        igcx =40 
  !              "b86x"   B86b exchange * 0.75           igcx =41
  !              "b88x"   B88 exchange * 0.50            igcx =42
  !
  ! Gradient Correction on Correlation:
  !              "nogc"   none                           igcc =0 (default)
  !              "p86"    Perdew86                       igcc =1
  !              "ggc"    Perdew-Wang 91 corr.           igcc =2
  !              "blyp"   Lee-Yang-Parr                  igcc =3
  !              "pbc"    Perdew-Burke-Ernzenhof corr    igcc =4
  !              "hcth"   Cambridge corr, Handy et al    igcc =5
  !              "b3lp"   B3LYP (Lee-Yang-Parr*0.81)     igcc =7
  !              "psc"    PBEsol corr                    igcc =8
  !              "pbe"    same as PBX, back-comp.        igcc =9
  !              "q2dc"   Q2D correlation grad corr      igcc =12
  !              "x3lp"   X3LYP (Lee-Yang-Parr*0.871)    igcc =13
  !
  ! Meta-GGA functionals
  !              "tpss"   TPSS Meta-GGA                  imeta=1
  !              "m6lx"   M06L Meta-GGA                  imeta=2
  !              "tb09"   TB09 Meta-GGA                  imeta=3
  !              "+meta"  activate MGGA even without MGGA-XC   imeta=4
  !              "scan"   SCAN Meta-GGA                  imeta=5
  !              "sca0"   SCAN0  Meta-GGA                imeta=6
  !
  ! Van der Waals functionals (nonlocal term only)
  !              "nonlc"  none                           inlc =0 (default)
  !              "vdw1"   vdW-DF1                        inlc =1
  !              "vdw2"   vdW-DF2                        inlc =2
  !              "vv10"   rVV10                          inlc =3
  !              "vdwx"   vdW-DF-x                       inlc =4, reserved Thonhauser, not implemented
  !              "vdwy"   vdW-DF-y                       inlc =5, reserved Thonhauser, not implemented
  !              "vdwz"   vdW-DF-z                       inlc =6, reserved Thonhauser, not implemented
  !
  ! Meta-GGA with Van der Waals
  !              "rvv10-scan" rVV10 (with b=15.7) and scan inlc=3 (PRX 6, 041005 (2016))
  !
  ! Note: as a rule, all keywords should be unique, and should be different
  ! from the short name, but there are a few exceptions.
  !
  ! References:
  !              pz      J.P.Perdew and A.Zunger, PRB 23, 5048 (1981)
  !              vwn     S.H.Vosko, L.Wilk, M.Nusair, Can.J.Phys. 58,1200(1980)
  !              vwn1-rpa S.H.Vosko, L.Wilk, M.Nusair, Can.J.Phys. 58,1200(1980)
  !              wig     E.P.Wigner, Trans. Faraday Soc. 34, 67 (1938)
  !              hl      L.Hedin and B.I.Lundqvist, J. Phys. C4, 2064 (1971)
  !              gl      O.Gunnarsson and B.I.Lundqvist, PRB 13, 4274 (1976)
  !              pw      J.P.Perdew and Y.Wang, PRB 45, 13244 (1992)
  !              obpz    G.Ortiz and P.Ballone, PRB 50, 1391 (1994)
  !              obpw    as above
  !              b88     A.D.Becke, PRA 38, 3098 (1988)
  !              p86     J.P.Perdew, PRB 33, 8822 (1986)
  !              pw86    J.P.Perdew, PRB 33, 8800 (1986)
  !              b86b    A.D.Becke, J.Chem.Phys. 85, 7184 (1986)
  !              ob86    Klimes, Bowler, Michaelides, PRB 83, 195131 (2011)
  !              b86r    I. Hamada, Phys. Rev. B 89, 121103(R) (2014)
  !              pbe     J.P.Perdew, K.Burke, M.Ernzerhof, PRL 77, 3865 (1996)
  !              pw91    J.P.Perdew and Y. Wang, PRB 46, 6671 (1992)
  !              blyp    C.Lee, W.Yang, R.G.Parr, PRB 37, 785 (1988)
  !              hcth    Handy et al, JCP 109, 6264 (1998)
  !              olyp    Handy et al, JCP 116, 5411 (2002)
  !              revPBE  Zhang and Yang, PRL 80, 890 (1998)
  !              pbesol  J.P. Perdew et al., PRL 100, 136406 (2008)
  !              q2d     L. Chiodo et al., PRL 108, 126402 (2012)
  !              rw86    Eamonn D. Murray et al, J. Chem. Theory Comput. 5, 2754 (2009)
  !              wc      Z. Wu and R. E. Cohen, PRB 73, 235116 (2006)
  !              kzk     H.Kwee, S. Zhang, H. Krakauer, PRL 100, 126404 (2008)
  !              pbe0    J.P.Perdew, M. Ernzerhof, K.Burke, JCP 105, 9982 (1996)
  !              hse     Heyd, Scuseria, Ernzerhof, J. Chem. Phys. 118, 8207 (2003)
  !                      Heyd, Scuseria, Ernzerhof, J. Chem. Phys. 124, 219906 (2006).
  !              b3lyp   P.J. Stephens,F.J. Devlin,C.F. Chabalowski,M.J. Frisch
  !                      J.Phys.Chem 98, 11623 (1994)
  !              x3lyp   X. Xu, W.A Goddard III, PNAS 101, 2673 (2004)
  !              vdW-DF       M. Dion et al., PRL 92, 246401 (2004)
  !                           T. Thonhauser et al., PRL 115, 136402 (2015)
  !              vdW-DF2      Lee et al., Phys. Rev. B 82, 081101 (2010)
  !              rev-vdW-DF2  I. Hamada, Phys. Rev. B 89, 121103(R) (2014)
  !              vdW-DF-cx    K. Berland and P. Hyldgaard, PRB 89, 035412 (2014)
  !              vdW-DF-cx0   K. Berland, Y. Jiao, J.-H. Lee, T. Rangel, J. B. Neaton and P. Hyldgaard,
  !                           J. Chem. Phys. 146, 234106 (2017)
  !              vdW-DF-cx0p  Y. Jiao, E. Schröder and P. Hyldgaard, 
  !                           J. Chem. Phys. 148, 194115 (2018)
  !              vdW-DF-obk8  Klimes et al, J. Phys. Cond. Matter, 22, 022201 (2010)
  !              vdW-DF-ob86  Klimes et al, Phys. Rev. B, 83, 195131 (2011)
  !              c09x    V. R. Cooper, Phys. Rev. B 81, 161104(R) (2010)
  !              tpss    J.Tao, J.P.Perdew, V.N.Staroverov, G.E. Scuseria,
  !                      PRL 91, 146401 (2003)
  !              tb09    F Tran and P Blaha, Phys.Rev.Lett. 102, 226401 (2009)
  !              scan    J Sun, A Ruzsinszky and J Perdew, PRL 115, 36402 (2015)
  !              scan0   K Hui and J-D. Chai, JCP 144, 44114 (2016)
  !              sogga   Y. Zhao and D. G. Truhlar, JCP 128, 184109 (2008)
  !              m06l    Y. Zhao and D. G. Truhlar, JCP 125, 194101 (2006)
  !              gau-pbe J.-W. Song, K. Yamashita, K. Hirao JCP 135, 071103 (2011)
  !              rVV10   R. Sabatini et al. Phys. Rev. B 87, 041108(R) (2013)
  !              ev93     Engel-Vosko, Phys. Rev. B 47, 13164 (1993)
  !
  ! NOTE ABOUT HSE: there are two slight deviations with respect to the HSE06
  ! functional as it is in Gaussian code (that is considered as the reference
  ! in the chemistry community):
  ! - The range separation in Gaussian is precisely 0.11 bohr^-1,
  !   instead of 0.106 bohr^-1 in this implementation
  ! - The gradient scaling relation is a bit more complicated
  !   [ see: TM Henderson, AF Izmaylov, G Scalmani, and GE Scuseria,
  !          J. Chem. Phys. 131, 044108 (2009) ]
  ! These two modifications accounts only for a 1e-5 Ha difference for a
  ! single He atom. Info by Fabien Bruneval.
  !
  ! NOTE FOR LIBXC USERS: to use libxc functionals you must enforce them from input (use
  ! 'input_dft' in &system) and write their names in the input string. The order is not
  ! relevant, neither the separation between one name and the other. The 'XC_' prefix
  ! is not necessary.
  ! You can use combinations of qe and libxc functionals, when they are compatible.
  !
  ! ------------------------------------------------------------------------
  !
  INTEGER, PARAMETER :: notset = -1
  !
  ! internal indices for exchange-correlation
  !    iexch: type of exchange
  !    icorr: type of correlation
  !    igcx:  type of gradient correction on exchange
  !    igcc:  type of gradient correction on correlation
  !    inlc:  type of non local correction on correlation
  !    imeta: type of meta-GGA
  INTEGER :: iexch = notset
  INTEGER :: icorr = notset
  INTEGER :: igcx  = notset
  INTEGER :: igcc  = notset
  INTEGER :: imeta = notset
  INTEGER :: imetac= notset
  INTEGER :: inlc  = notset
  !
  ! is_libxc(i)==.TRUE. if the the i-th term of xc is from libxc
  LOGICAL :: is_libxc(7)
  !
  REAL(DP):: exx_fraction = 0.0_DP
  REAL(DP):: screening_parameter = 0.0_DP
  REAL(DP):: gau_parameter = 0.0_DP
  LOGICAL :: islda       = .FALSE.
  LOGICAL :: isgradient  = .FALSE.
  LOGICAL :: ismeta      = .FALSE.
  LOGICAL :: ishybrid    = .FALSE.
  LOGICAL :: isnonlocc   = .FALSE.
  LOGICAL :: exx_started = .FALSE.
  LOGICAL :: scan_exx    = .FALSE.
  LOGICAL :: has_finite_size_correction = .FALSE.
  LOGICAL :: finite_size_cell_volume_set = .FALSE.
  REAL(DP):: finite_size_cell_volume = notset
  LOGICAL :: discard_input_dft = .FALSE.
  !
  INTEGER, PARAMETER :: nxc=8, ncc=10, ngcx=42, ngcc=12, nmeta=6, ncnl=6
  CHARACTER(LEN=4) :: exc, corr, gradx, gradc, meta, nonlocc
  DIMENSION :: exc(0:nxc), corr(0:ncc), gradx(0:ngcx), gradc(0:ngcc), &
               meta(0:nmeta), nonlocc(0:ncnl)
  !
  DATA exc  / 'NOX', 'SLA', 'SL1', 'RXC', 'OEP', 'HF', 'PB0X', 'B3LP', 'KZK' /
  DATA corr / 'NOC', 'PZ', 'VWN', 'LYP', 'PW', 'WIG', 'HL', 'OBZ', &
              'OBW', 'GL' , 'KZK' /
  !
  DATA gradx / 'NOGX', 'B88', 'GGX', 'PBX',  'RPB', 'HCTH', 'OPTX',&
               'xxxx', 'PB0X', 'B3LP','PSX', 'WCX', 'HSE', 'RW86', 'PBE', &
               'xxxx', 'C09X', 'SOX', 'xxxx', 'Q2DX', 'GAUP', 'PW86', 'B86B', &
               'OBK8', 'OB86', 'EVX', 'B86R', 'CX13', 'X3LP', &
               'CX0', 'R860', 'CX0P', 'AHCX', 'AHF2', &
               'AHPB', 'AHPS', 'CX14', 'CX15', 'BR0', 'CX16', 'C090', &
               'B86X', 'B88X'/
  !
  DATA gradc / 'NOGC', 'P86', 'GGC', 'BLYP', 'PBC', 'HCTH', 'NONE',&
               'B3LP', 'PSC', 'PBE', 'xxxx', 'xxxx', 'Q2DC' /
  !
  DATA meta  / 'NONE', 'TPSS', 'M06L', 'TB09', 'META', 'SCAN', 'SCA0' /
  !
  DATA nonlocc/'NONE', 'VDW1', 'VDW2', 'VV10', 'VDWX', 'VDWY', 'VDWZ' /
  !
#if defined(__LIBXC)
  INTEGER :: libxc_major=0, libxc_minor=0, libxc_micro=0
  PUBLIC :: libxc_major, libxc_minor, libxc_micro, get_libxc_version
  PUBLIC :: get_libxc_flags_exc
#endif
  !
CONTAINS
  !
  !-----------------------------------------------------------------------
  SUBROUTINE set_dft_from_name( dft_ )
    !-----------------------------------------------------------------------
    !! Translates a string containing the exchange-correlation name
    !! into internal indices iexch, icorr, igcx, igcc, inlc, imeta.
    !
#if defined(__LIBXC)
    USE xc_f03_lib_m
#endif
    !
    IMPLICIT NONE
    !
    CHARACTER(LEN=*), INTENT(IN) :: dft_
    INTEGER :: len, l, i
    CHARACTER(len=150):: dftout
    LOGICAL :: dft_defined = .FALSE.
    LOGICAL :: check_libxc
#if defined(__LIBXC)
    INTEGER :: ii, id_vec(6), n_ext_params
    TYPE(xc_f03_func_t) :: xc_func03
    TYPE(xc_f03_func_info_t) :: xc_info03
#endif
    CHARACTER(LEN=1), EXTERNAL :: capital
    INTEGER ::  save_iexch, save_icorr, save_igcx, save_igcc, save_meta, &
                save_metac, save_inlc
    !
    ! Exit if set to discard further input dft
    !
    IF ( discard_input_dft ) RETURN
    !
    ! save current status of XC indices
    !
    save_iexch = iexch
    save_icorr = icorr
    save_igcx  = igcx
    save_igcc  = igcc
    save_meta  = imeta
    save_metac = imetac
    save_inlc  = inlc
    !
    ! convert to uppercase
    !
    len = LEN_TRIM(dft_)
    dftout = ' '
    !
    DO l = 1, len
       dftout(l:l) = capital( dft_(l:l) )
    ENDDO
    !
    ! ----------------------------------------------
    ! NOW WE CHECK ALL THE SHORT NAMES
    ! Note: comparison is done via exact matching
    ! ----------------------------------------------
    !
    SELECT CASE( TRIM(dftout) )
    ! special cases : PZ  (LDA is equivalent to PZ)
    CASE( 'PZ', 'LDA' )
       dft_defined = set_dft_values(1,1,0,0,0,0)
    ! speciale cases : PW ( LDA with PW correlation )
    CASE( 'PW' )
       dft_defined = set_dft_values(1,4,0,0,0,0)
    ! special cases : VWN-RPA
    CASE( 'VWN-RPA' )
       dft_defined = set_dft_values(1,11,0,0,0,0)
    ! special cases : OEP no GC part (nor LDA...) and no correlation by default
    CASE( 'OEP' )
       dft_defined = set_dft_values(4,0,0,0,0,0)
    !
    CASE( 'KLI' )
       dft_defined = set_dft_values(10,0,0,0,0,0)
    ! special cases : HF no GC part (nor LDA...) and no correlation by default
    CASE( 'HF' )
       dft_defined = set_dft_values(5,0,0,0,0,0)
    ! special case : PBE
    CASE( 'PBE' )
       dft_defined = set_dft_values(1,4,3,4,0,0)
    ! special case : B88
    CASE( 'B88' )
       dft_defined = set_dft_values(1,1,1,0,0,0)
    ! special case : BP = B88 + P86
    CASE( 'BP' )
       dft_defined = set_dft_values(1,1,1,1,0,0)
    ! special case : PW91 = GGX + GGC
    CASE( 'PW91' )
       dft_defined = set_dft_values(1,4,2,2,0,0)
    ! special case : revPBE
    CASE( 'REVPBE' )
       dft_defined = set_dft_values(1,4,4,4,0,0)
    ! special case : PBEsol
    CASE( 'PBESOL' )
       dft_defined = set_dft_values(1,4,10,8,0,0)
    ! special cases : BLYP (note, BLYP=>B88)
    CASE( 'BLYP' )
       dft_defined = set_dft_values(1,3,1,3,0,0)
    ! Special case optB88
    CASE( 'OPTBK88' )
       dft_defined = set_dft_values(1,4,23,1,0,0)
    ! Special case optB86b
    CASE( 'OPTB86B' )
       dft_defined = set_dft_values(1,4,24,1,0,0)
    ! special case : PBC  = PW + PBC
    CASE( 'PBC' )
       dft_defined = set_dft_values(1,4,0,4,0,0)
    ! special case : HCTH
    CASE( 'HCTH' )
       dft_defined = set_dft_values(0,0,5,5,0,0)
       CALL errore( 'set_dft_from_name', 'HCTH yields suspicious results', 1 )
    ! special case : OLYP = OPTX + LYP
    CASE( 'OLYP' )
       dft_defined = set_dft_values(0,3,6,3,0,0)
       CALL errore( 'set_dft_from_name', 'OLYP yields suspicious results', 1 )
    ! special case : Wu-Cohen
    CASE( 'WC' )
       dft_defined = set_dft_values(1,4,11,4,0,0)
    ! special case : PW86PBE
    CASE( 'PW86PBE' )
       dft_defined = set_dft_values(1,4,21,4,0,0)
    ! special case : B86BPBE
    CASE( 'B86BPBE' )
       dft_defined = set_dft_values(1,4,22,4,0,0)
    ! special case : PBEQ2D
    CASE( 'PBEQ2D', 'Q2D' )
       dft_defined = set_dft_values(1,4,19,12,0,0)
    ! special case : SOGGA = SOX + PBEc
    CASE( 'SOGGA' )
       dft_defined = set_dft_values(1,4,17,4,0,0)
    ! special case : Engel-Vosko
    CASE( 'EV93' )
       dft_defined = set_dft_values(1,4,25,0,0,0)
    ! special case : RPBE
    CASE( 'RPBE' )
       CALL errore( 'set_dft_from_name', &
                    'RPBE (Hammer-Hansen-Norskov) not implemented (revPBE is)', 1 )
    ! special case : PBE0
    CASE( 'PBE0' )
       dft_defined = set_dft_values(6,4,8,4,0,0)
    ! special case : B86BPBEX
    CASE( 'B86BPBEX' )
       dft_defined = set_dft_values(6,4,41,4,0,0)
    !
    CASE( 'BHAHLYP', 'BHANDHLYP' )
       dft_defined = set_dft_values(6,4,42,3,0,0)
    ! special case : HSE
    CASE( 'HSE' )
       dft_defined = set_dft_values(1,4,12,4,0,0)
    ! special case : GAUPBE
    CASE( 'GAUP', 'GAUPBE' )
       dft_defined = set_dft_values(1,4,20,4,0,0)
    ! Special case vdW-DF
    CASE( 'VDW-DF' )
       dft_defined = set_dft_values(1,4,4,0,1,0)
    ! Special case vdW-DF2
    CASE( 'VDW-DF2' )
       dft_defined = set_dft_values(1,4,13,0,2,0)
    ! Special case vdW-DF with C09 exchange
    CASE( 'VDW-DF-C09' )
       dft_defined = set_dft_values(1,4,16,0,1,0)
    ! Special case vdW-DF2 with C09 exchange
    CASE( 'VDW-DF2-C09' )
       dft_defined = set_dft_values(1,4,16,0,2,0)
    ! Special case vdW-DF-obk8, or vdW-DF + optB88
    CASE( 'VDW-DF-OBK8' )
       dft_defined = set_dft_values(1,4,23,0,1,0)
    ! Special case vdW-DF-ob86, or vdW-DF + optB86
    CASE( 'VDW-DF-OB86' )
       dft_defined = set_dft_values(1,4,24,0,1,0)
    ! Special case vdW-DF2 with B86R
    CASE( 'VDW-DF2-B86R' )
       dft_defined = set_dft_values(1,4,26,0,2,0)
    ! Special case vdW-DF-CX
    CASE( 'VDW-DF-CX' )
       dft_defined = set_dft_values(1,4,27,0,1,0)
    ! Special case vdW-DF-CX0
    CASE( 'VDW-DF-CX0' )
       dft_defined = set_dft_values(6,4,29,0,1,0)
    ! Special case vdW-DF-CX0P
    CASE( 'VDW-DF-CX0P' )
       dft_defined = set_dft_values(6,4,31,0,1,0)
    ! Special case vdW-DF2-0
    CASE( 'VDW-DF2-0' )
       dft_defined = set_dft_values(6,4,30,0,2,0)
    ! Special case vdW-DF2-BR0
    CASE( 'VDW-DF2-BR0' )
       dft_defined = set_dft_values(6,4,38,0,2,0)
    ! Special case vdW-DF-C090
    CASE( 'VDW-DF-C090' )
       dft_defined = set_dft_values(6,4,40,0,1,0)
    ! Special case rVV10
    CASE( 'RVV10' )
       dft_defined = set_dft_values(1,4,13,4,3,0)
    ! Special case rVV10+scan
    CASE( 'RVV10-SCAN' )
       dft_defined = set_dft_values(0,0,0,0,3,5)
    ! special case : B3LYP hybrid
    CASE( 'B3LYP' )
       dft_defined = set_dft_values(7,12,9,7,0,0)
    ! special case : B3LYP-VWN-1-RPA hybrid
    CASE( 'B3LYP-V1R' )
       dft_defined = set_dft_values(7,13,9,7,0,0)
    ! special case : X3LYP hybrid
    CASE( 'X3LYP' )
       dft_defined = set_dft_values(9,14,28,13,0,0)
    ! special case : TPSS meta-GGA Exc
    CASE( 'TPSS' )
       dft_defined = set_dft_values(1,4,7,6,0,1)
    ! special case : M06L Meta GGA
    CASE( 'M06L' )
       dft_defined = set_dft_values(0,0,0,0,0,2)
    ! special case : TB09 meta-GGA Exc
    CASE( 'TB09' )
       dft_defined = set_dft_values(0,0,0,0,0,3)
    ! special case : SCAN Meta GGA
    CASE( 'SCAN' )
       dft_defined = set_dft_values(0,0,0,0,0,5)
    ! special case : SCAN0
    CASE( 'SCAN0' )
       dft_defined = set_dft_values(0,0,0,0,0,6)
    ! special case : PZ/LDA + null meta-GGA
    CASE( 'PZ+META', 'LDA+META' )
       dft_defined = set_dft_values(1,1,0,0,0,4)
    ! special case : PBE + null meta-GGA
    CASE( 'PBE+META' )
       dft_defined = set_dft_values(1,4,3,4,0,4)
    !
    CASE( 'REV-VDW-DF2' )
       CALL errore( 'set_dft_from_name', 'obsolete XC label, use VDW-DF2-B86R', 1 )
    !
    CASE( 'VDW-DF3' )
       CALL errore( 'set_dft_from_name', 'obsolete XC label, use VDW-DF-OBK8', 1 )
    !
    CASE( 'VDW-DF4', 'OPTB86B-VDW' )
       CALL errore( 'set_dft_from_name', 'obsolete XC label, use VDW-DF-OB86', 1 )
    ! Special case vdW-DF-X
    CASE( 'VDW-DF-X' )
       CALL errore( 'set_dft_from_name', 'functional not yet implemented', 1 )
    ! Special case vdW-DF-Y
    CASE( 'VDW-DF-Y' )
       CALL errore( 'set_dft_from_name', 'functional not yet implemented', 1 )
    ! Special case vdW-DF-Z
    CASE( 'VDW-DF-Z' )
       CALL errore( 'set_dft_from_name', 'functional not yet implemented', 1 )
    ! Case for old RRKJ format, containing indices instead of label
    CASE DEFAULT
       IF ('INDEX:' ==  dftout(1:6)) THEN
          READ( dftout(7:18), '(6i2)') iexch, icorr, igcx, igcc, inlc, imeta
              dft_defined = set_dft_values(iexch, icorr, igcx, igcc, inlc, imeta)
              dftout = exc (iexch) //'-'//corr (icorr) //'-'//gradx (igcx) //'-' &
              &//gradc (igcc) //'-'// nonlocc(inlc)
       ENDIF
       !
       ! ----------------------------------------------------------------------
       ! CHECK LIBXC FUNCTIONALS BY INDEX NOTATION, IF PRESENT (USED in PHonon)
       ! ----------------------------------------------------------------------
       !
       IF (dftout(1:3) .EQ. 'XC-') THEN
#if defined(__LIBXC)
          is_libxc = .FALSE.
          !
          READ( dftout(4:6),   * ) iexch
          READ( dftout(8:10),  * ) icorr
          READ( dftout(12:14), * ) igcx
          READ( dftout(16:18), * ) igcc
          imeta  = 0
          imetac = 0 
          inlc   = 0
          !
          IF (iexch /= 0) is_libxc(1) = .TRUE.
          IF (icorr /= 0) is_libxc(2) = .TRUE.
          IF (igcx  /= 0) is_libxc(3) = .TRUE.
          IF (igcc  /= 0) is_libxc(4) = .TRUE.
          !
          dft_defined = .TRUE.
#else
          CALL errore( 'set_dft_from_name', 'libxc functionals needed, but &
                                            &libxc is not active', 1 )
#endif
       ENDIF
       !
    END SELECT
    !
    !
    ! ... A temporary fix to keep the q-e input notation for SCAN-functionals
    !     valid.
#if defined(__LIBXC)
    IF (imeta==5 .OR. imeta==6) THEN
       IF (imeta==6) scan_exx = .TRUE.
       imeta  = 263 
       imetac = 267
       is_libxc(5:6) = .TRUE.
    ELSEIF (imeta==3) THEN
       imeta  = 208
       imetac = 231
       is_libxc(5:6) = .TRUE.
    ENDIF
#else
    IF (imeta==3 .OR. imeta==5 .OR. imeta==6) &
          CALL errore( 'set_dft_from_name', 'libxc needed for this functional', 2 )
#endif
    !
    !----------------------------------------------------------------
    ! If the DFT was not yet defined, check every part of the string
    !----------------------------------------------------------------
    !
    IF (.NOT. dft_defined) THEN
       !
       is_libxc(:) = .FALSE.
       !
       iexch = matching( dftout, nxc,   exc   )
       icorr = matching( dftout, ncc,   corr  )
       igcx  = matching( dftout, ngcx,  gradx )
       igcc  = matching( dftout, ngcc,  gradc )
       imeta = matching( dftout, nmeta, meta  )
       imetac = 0
       inlc  = matching( dftout, ncnl, nonlocc )
       !
    ENDIF
    !
#if defined(__LIBXC)
    IF (.NOT. dft_defined) CALL matching_libxc( dftout )
    !
    !------------------------------------------------------------------
    ! Checks whether external parameters are required by the libxc
    ! functionals (if present)
    !------------------------------------------------------------------
    !
    id_vec(1) = iexch  ;  id_vec(2) = icorr
    id_vec(3) = igcx   ;  id_vec(4) = igcc
    id_vec(5) = imeta  ;  id_vec(6) = imetac
    !
    n_ext_params = 0
    DO ii = 1, 6
      IF (is_libxc(ii)) THEN
        CALL xc_f03_func_init( xc_func03, id_vec(ii), 1 )
        xc_info03 = xc_f03_func_get_info(xc_func03)
        n_ext_params = n_ext_params + xc_f03_func_info_get_n_ext_params(xc_info03)
        CALL xc_f03_func_end( xc_func03 )
      ENDIF
    ENDDO
    !
    IF ( n_ext_params/=0 ) THEN
       WRITE( stdout, '(/5X,"WARNING: one or more of the chosen libxc functionals depend",&
                       &/5X," on external parameters: their correct operation is not guaranteed.")' )
    ENDIF
#endif
    !
    !----------------------------------------------------------------
    ! Last check
    ! No more defaults, the code exits if the dft is not defined
    !----------------------------------------------------------------
    !
    ! Back compatibility - TO BE REMOVED
    !
    IF (igcx == 14) igcx = 3 ! PBE -> PBX
    IF (igcc ==  9) igcc = 4 ! PBE -> PBC
    !
    IF (igcx == 6) CALL infomsg( 'set_dft_from_name', 'OPTX untested! please test' )
    !
    ! check for unrecognized labels
    !
    IF ( iexch<=0 .AND. icorr<=0 .AND. igcx<=0 .AND. igcc<=0 .AND. imeta<=0 ) THEN
       IF ( inlc <= 0 .AND. TRIM(dftout) /= 'NOX-NOC') THEN
          CALL errore( 'set_dft_from_name', TRIM(dftout)//': unrecognized dft', 1 )
       ELSE
          ! if inlc is the only nonzero index the label is likely wrong
          CALL errore( 'set_dft_from_name', TRIM(dftout)//': strange dft, please check', inlc )
       ENDIF
    ENDIF
    !
    ! Fill variables and exit
    !
    dft = dftout
    !
    !dft_longname = exc (iexch) //'-'//corr (icorr) //'-'//gradx (igcx) //'-' &
    !     &//gradc (igcc) //'-'// nonlocc(inlc)
    !
    CALL set_auxiliary_flags
    !
    ! check dft has not been previously set differently
    !
    IF (save_iexch /= notset .AND. save_iexch /= iexch) THEN
       WRITE(stdout,*) iexch, save_iexch
       CALL errore( 'set_dft_from_name', ' conflicting values for iexch', 1 )
    ENDIF
    IF (save_icorr /= notset .AND. save_icorr /= icorr) THEN
       WRITE(stdout,*) icorr, save_icorr
       CALL errore( 'set_dft_from_name', ' conflicting values for icorr', 1 )
    ENDIF
    IF (save_igcx /= notset  .AND. save_igcx /= igcx)   THEN
       WRITE(stdout,*) igcx, save_igcx
       CALL errore( 'set_dft_from_name', ' conflicting values for igcx',  1 )
    ENDIF
    IF (save_igcc /= notset  .AND. save_igcc /= igcc)   THEN
       WRITE (stdout,*) igcc, save_igcc
       CALL errore( 'set_dft_from_name', ' conflicting values for igcc',  1 )
    ENDIF
    IF (save_meta /= notset  .AND. save_meta /= imeta)  THEN
       WRITE (stdout,*) inlc, save_meta
       CALL errore( 'set_dft_from_name', ' conflicting values for imeta', 1 )
    ENDIF
    IF (save_metac /= notset  .AND. save_metac /= imetac)  THEN
       WRITE (stdout,*) imetac, save_metac
       CALL errore( 'set_dft_from_name', ' conflicting values for imetac', 1 )
    ENDIF
    IF (save_inlc /= notset  .AND. save_inlc /= inlc)   THEN
       WRITE (stdout,*) inlc, save_inlc
       CALL errore( 'set_dft_from_name', ' conflicting values for inlc', 1 )
    ENDIF
    !
    RETURN
    !
  END SUBROUTINE set_dft_from_name
  !
  !-----------------------------------------------------------------
  INTEGER FUNCTION matching( dft, n, name )
    !-----------------------------------------------------------------
    !! Looks for matches between the names of each single term of the 
    !! xc-functional and the input dft string.
    !
    IMPLICIT NONE
    !
    INTEGER, INTENT(IN):: n
    CHARACTER(LEN=*), INTENT(IN):: name(0:n)
    CHARACTER(LEN=*), INTENT(IN):: dft
    INTEGER :: i
    LOGICAL, EXTERNAL :: matches
    !
    matching = notset
    !
    DO i = n, 0, -1
       IF ( matches(name(i), TRIM(dft)) ) THEN
          !
          IF ( matching == notset ) THEN
           !WRITE(*, '("matches",i2,2X,A,2X,A)') i, name(i), TRIM(dft)
           matching = i
          ELSE
             WRITE(*, '(2(2X,i2,2X,A))') i, TRIM(name(i)), &
                                  matching, TRIM(name(matching))
             CALL errore( 'set_dft', 'two conflicting matching values', 1 )
          ENDIF
       ENDIF
    ENDDO
    !
    IF (matching == notset) matching = 0
    !
  END FUNCTION matching
  !
  !
#if defined(__LIBXC)
  !--------------------------------------------------------------------------------
  SUBROUTINE matching_libxc( dft )
    !------------------------------------------------------------------------------
    !! It spans the libxc functionals and looks for matches with the input dft
    !! string. Then stores the corresponding indices.  
    !! It also makes some compatibility checks.
    !
    IMPLICIT NONE
    !
    CHARACTER(LEN=*), INTENT(IN) :: dft
    !
    CHARACTER(LEN=256) :: name
    INTEGER :: i, l, prev_len(6), fkind, fkind_v(3), family
    INTEGER, PARAMETER :: ID_MAX_LIBXC=600
    TYPE(xc_f90_pointer_t) :: xc_func, xc_info
    LOGICAL, EXTERNAL :: matches
    CHARACTER(LEN=1), EXTERNAL :: capital
    !
    prev_len(:) = 1
    !
    DO i = 1, ID_MAX_LIBXC
       !
       CALL xc_f90_functional_get_name( i, name )
       !
       DO l = 1, LEN_TRIM(name)
          name(l:l) = capital( name(l:l) )
       ENDDO
       !
       IF ( TRIM(name) .EQ. 'UNKNOWN' ) CYCLE
       !
       IF ( matches(TRIM(name), TRIM(dft)) ) THEN
          !
          !WRITE(*, '("matches libxc",i2,2X,A,2X,A)') i, TRIM(name), TRIM(dft)
          !
          fkind=-100 ; family=-100
          CALL xc_f90_func_init( xc_func, xc_info, i, 1 )
          fkind = xc_f90_info_kind( xc_info )
          family = xc_f90_info_family( xc_info )
          CALL xc_f90_func_end( xc_func )
          !   
          SELECT CASE( family )
          CASE( XC_FAMILY_LDA )
             IF (fkind==XC_EXCHANGE .OR. fkind==XC_EXCHANGE_CORRELATION) THEN
                IF ( LEN(TRIM(name)) > prev_len(1) ) iexch = i
                is_libxc(1) = .TRUE.
                prev_len(1) = LEN(TRIM(name))
             ELSEIF (fkind==XC_CORRELATION) THEN
                IF ( LEN(TRIM(name)) > prev_len(2) ) icorr = i
                is_libxc(2) = .TRUE.
                prev_len(2) = LEN(TRIM(name))
             ENDIF
             fkind_v(1) = fkind
             !
          CASE( XC_FAMILY_GGA, XC_FAMILY_HYB_GGA )
             IF (fkind==XC_EXCHANGE .OR. fkind==XC_EXCHANGE_CORRELATION) THEN
                IF ( LEN(TRIM(name)) > prev_len(3) ) igcx = i
                is_libxc(3) = .TRUE.
                prev_len(3) = LEN(TRIM(name))
             ELSEIF (fkind==XC_CORRELATION) THEN
                IF ( LEN(TRIM(name)) > prev_len(4) ) igcc = i
                is_libxc(4) = .TRUE.
                prev_len(4) = LEN(TRIM(name))
             ENDIF
             fkind_v(2) = fkind
             !
          CASE( XC_FAMILY_MGGA, XC_FAMILY_HYB_MGGA )
             IF (fkind==XC_EXCHANGE .OR. fkind==XC_EXCHANGE_CORRELATION) THEN
                IF ( LEN(TRIM(name)) > prev_len(5) ) imeta = i
                is_libxc(5) = .TRUE.
                prev_len(5) = LEN(TRIM(name))
             ELSEIF (fkind==XC_CORRELATION) THEN
                IF ( LEN(TRIM(name)) > prev_len(6) ) imetac = i
                is_libxc(6) = .TRUE.
                prev_len(6) = LEN(TRIM(name))
             ENDIF
             fkind_v(3) = fkind
             !
          END SELECT
          !
       ENDIF
       !
    ENDDO
    !
    ! ... overlaps check (between qe and libxc names)
    !
    IF (ANY(.NOT.is_libxc(:)).AND.ANY(is_libxc(:))) CALL check_overlaps_qe_libxc( dft )
    !
    ! ... Compatibility checks
    !
    ! LDA:
    IF (icorr/=0 .AND. fkind_v(1)==XC_EXCHANGE_CORRELATION)  &
       CALL infomsg( 'matching_libxc', 'WARNING: an EXCHANGE+CORRELATION functional has &
                    &been found together with a correlation one (LDA)' )
    ! GGA:
    IF (igcc/=0 .AND. fkind_v(2)==XC_EXCHANGE_CORRELATION)   &
       CALL infomsg( 'matching_libxc', 'WARNING: an EXCHANGE+CORRELATION functional has &
                    &been found together with a correlation one (GGA)' )
    !
    IF ( (is_libxc(3).AND.iexch/=0) .OR. (is_libxc(4).AND. icorr/=0) )    &
       CALL infomsg( 'matching_libxc', 'WARNING: an LDA functional has been found, but  &
                    &libxc GGA functionals already include the LDA part' )
    ! mGGA:
    ! (imeta defines both exchange and correlation term for q-e mGGA functionals)
    IF (imeta/=0 .AND. (.NOT. is_libxc(5)) .AND. imetac/=0)   &
       CALL errore( 'matching_libxc', 'Two conflicting metaGGA functionals &
                    &have been found', 1 )
    !
    IF (imetac/=0 .AND. fkind_v(3)==XC_EXCHANGE_CORRELATION)  &   
       CALL infomsg( 'matching_libxc', 'WARNING: an EXCHANGE+CORRELATION functional has &   
                     &been found together with a correlation one (mGGA)' )
    !   
  END SUBROUTINE matching_libxc
  !
  !--------------------------------------------------------------------------
  SUBROUTINE check_overlaps_qe_libxc( dft )
    !------------------------------------------------------------------------
    !! It fixes eventual overlap issues between qe and libxc names when qe and
    !! libxc functionals are used together.
    !
    IMPLICIT NONE
    !
    CHARACTER(LEN=*), INTENT(IN) :: dft
    !
    CHARACTER(LEN=4) :: qe_name
    CHARACTER(LEN=256) :: lxc_name
    INTEGER :: i, l, ch, qedft, nlxc
    INTEGER :: id_vec(6)
    LOGICAL, EXTERNAL :: matches
    CHARACTER(LEN=1), EXTERNAL :: capital
    !
    id_vec(1)=iexch ; id_vec(2)=icorr
    id_vec(3)=igcx  ; id_vec(4)=igcc
    id_vec(5)=imeta ; id_vec(6)=imetac
    !
    DO ch = 1, 5
       IF (.NOT.is_libxc(ch)) THEN
          !
          SELECT CASE( ch )
          CASE( 1 )
             qe_name = exc(iexch)
          CASE( 2 )
             qe_name = corr(icorr)
          CASE( 3 )
             qe_name = gradx(igcx)
          CASE( 4 )
             qe_name = gradc(igcc)
          CASE( 5 )
             qe_name = meta(imeta)
          END SELECT
          !
          qedft = 0
          i = 0
          DO WHILE ( i < LEN_TRIM(dft) )
            i = i + 1
            IF ( matches( TRIM(qe_name), TRIM(dft(i:i+3)) ) ) THEN
               qedft = qedft + 1
               i = i + LEN_TRIM(qe_name)-1
            ENDIF
          ENDDO
          !
          nlxc = 0
          DO i = 1, 6
            IF (is_libxc(i)) THEN
              CALL xc_f90_functional_get_name( id_vec(i), lxc_name )
              DO l = 1, LEN_TRIM(lxc_name)
                 lxc_name(l:l) = capital( lxc_name(l:l) )
              ENDDO
              IF (matches( TRIM(qe_name), TRIM(lxc_name))) nlxc = nlxc + 1
            ENDIF
          ENDDO
          !
          IF (qedft == nlxc) THEN
             SELECT CASE( ch )
             CASE( 1 )
                iexch = 0
             CASE( 2 )
                icorr = 0
             CASE( 3 )
                igcx  = 0
             CASE( 4 )
                igcc  = 0
             CASE( 5 )
                imeta = 0
             END SELECT
          ENDIF  
          !
       ENDIF
    ENDDO
    !
  END SUBROUTINE
#endif
  !
  !
  !-----------------------------------------------------------------------
  SUBROUTINE set_auxiliary_flags
    !-----------------------------------------------------------------------
    !! Set logical flags describing the complexity of the xc functional
    !! define the fraction of exact exchange used by hybrid fuctionals.
    !
    isnonlocc = (inlc > 0)
    ismeta    = (imeta+imetac > 0)
    isgradient= (igcx > 0) .OR.  (igcc > 0)  .OR. ismeta .OR. isnonlocc
    islda     = (iexch> 0) .AND. (icorr > 0) .AND. .NOT. isgradient
    ! PBE0/DF0
    IF ( iexch==6 .OR.  igcx == 8 ) exx_fraction = 0.25_DP
    ! CX0P
    IF ( iexch==6 .AND. igcx ==31 ) exx_fraction = 0.20_DP
    ! B86BPBEX
    IF ( iexch==6 .AND. igcx ==41 ) exx_fraction = 0.25_DP
    ! BHANDHLYP
    IF ( iexch==6 .AND. igcx ==42 ) exx_fraction = 0.50_DP
    ! HSE
    IF ( igcx ==12 ) THEN
       exx_fraction = 0.25_DP
       screening_parameter = 0.106_DP
    ENDIF
    ! gau-pbe
    IF ( igcx ==20 ) THEN
       exx_fraction = 0.24_DP
       gau_parameter = 0.150_DP
    ENDIF
    ! HF or OEP
    IF ( iexch==4 .OR. iexch==5 ) exx_fraction = 1.0_DP
    ! B3LYP or B3LYP-VWN-1-RPA
    IF ( iexch == 7 ) exx_fraction = 0.2_DP
    ! X3LYP
    IF ( iexch == 9 ) exx_fraction = 0.218_DP
    !
    ishybrid = ( exx_fraction /= 0.0_DP )
    !
    has_finite_size_correction = ( iexch==8 .OR. icorr==10)
    !
    RETURN
    !
  END SUBROUTINE set_auxiliary_flags
  !
  !
  !-----------------------------------------------------------------------
  LOGICAL FUNCTION set_dft_values( i1, i2, i3, i4, i5, i6 )
    !-----------------------------------------------------------------------
    !
    IMPLICIT NONE
    !
    INTEGER :: i1, i2, i3, i4, i5, i6
    !
    iexch = i1
    icorr = i2
    igcx  = i3
    igcc  = i4
    inlc  = i5
    imeta = i6
    imetac= 0
    !
    set_dft_values = .TRUE.
    !
    RETURN
    !
  END FUNCTION set_dft_values
  !
  !
  !-----------------------------------------------------------------------
  SUBROUTINE enforce_input_dft( dft_, nomsg )
    !---------------------------------------------------------------------
    !! Translates a string containing the exchange-correlation name
    !! into internal indices and force any subsequent call to 
    !! \(\textrm{set_dft_from_name}\) to return without changing them.
    !
    IMPLICIT NONE
    !
    CHARACTER(LEN=*), INTENT(IN) :: dft_
    LOGICAL, INTENT(IN), OPTIONAL :: nomsg
    !
    !qepy --> reset values
    dft = 'not set'
    discard_input_dft = .FALSE.
    !qepy <-- reset values

    CALL set_dft_from_name( dft_ )
    IF (dft == 'not set') CALL errore( 'enforce_input_dft', 'cannot fix unset dft', 1 )
    discard_input_dft = .TRUE.
    !
    IF ( PRESENT(nomsg) ) RETURN
    !
    WRITE(stdout,'(/,5x,a)') "IMPORTANT: XC functional enforced from input :"
    CALL write_dft_name
    WRITE(stdout,'(5x,a)') "Any further DFT definition will be discarded"
    WRITE(stdout,'(5x,a/)') "Please, verify this is what you really want"
    !
    RETURN
    !
  END SUBROUTINE enforce_input_dft
  !
  !
  !-----------------------------------------------------------------------
  SUBROUTINE enforce_dft_exxrpa( )
    !---------------------------------------------------------------------
    !
    IMPLICIT NONE
    !
    !character(len=*), intent(in) :: dft_
    !logical, intent(in), optional :: nomsg
    !
    iexch = 0; icorr = 0; igcx = 0; igcc = 0
    exx_fraction = 1.0_DP
    ishybrid = ( exx_fraction /= 0.0_DP )
    !
    WRITE(stdout,'(/,5x,a)') "XC functional enforced to be EXXRPA"
    CALL write_dft_name
    WRITE(stdout,'(5x,a)') "!!! Any further DFT definition will be discarded"
    WRITE(stdout,'(5x,a/)') "!!! Please, verify this is what you really want !"
    !
    RETURN
    !
  END SUBROUTINE enforce_dft_exxrpa
  !
  !
  !-----------------------------------------------------------------------
  SUBROUTINE init_dft_exxrpa( )
    !-----------------------------------------------------------------------
    !
    IMPLICIT NONE
    !
    exx_fraction = 1.0_DP
    ishybrid = ( exx_fraction /= 0.0_DP )
    !
    WRITE(stdout,'(/,5x,a)') "Only exx_fraction is set to 1.d0"
    WRITE(stdout,'(5x,a)') "XC functional still not changed"
    !
    CALL write_dft_name
    !
    RETURN
    !
  END SUBROUTINE init_dft_exxrpa
  !
  !
  !-----------------------------------------------------------------------
  SUBROUTINE start_exx
     IF (.NOT. ishybrid) &
        CALL errore( 'start_exx', 'dft is not hybrid, wrong call', 1 )
     exx_started = .TRUE.
  END SUBROUTINE start_exx
  !-----------------------------------------------------------------------
  SUBROUTINE stop_exx
     IF (.NOT. ishybrid) &
        CALL errore( 'stop_exx', 'dft is not hybrid, wrong call', 1 )
     exx_started = .FALSE.
  END SUBROUTINE stop_exx
  !-----------------------------------------------------------------------
  SUBROUTINE dft_force_hybrid( request )
    LOGICAL,OPTIONAL,INTENT(INOUT) :: request
    LOGICAL :: aux
    IF (PRESENT(request)) THEN
      aux = ishybrid
      ishybrid = request
      request = aux
    ELSE
      ishybrid= .TRUE.
    ENDIF
  END SUBROUTINE dft_force_hybrid
  !-----------------------------------------------------------------------
  FUNCTION exx_is_active()
     LOGICAL exx_is_active
     exx_is_active = exx_started
  END FUNCTION exx_is_active
  !-----------------------------------------------------------------------
  SUBROUTINE set_exx_fraction( exxf_ )
     IMPLICIT NONE
     REAL(DP) :: exxf_
     exx_fraction = exxf_
     WRITE( stdout,'(5x,a,f6.2)') 'EXX fraction changed: ', exx_fraction
  END SUBROUTINE set_exx_fraction
  !---------------------------------------------------------------------
  SUBROUTINE set_screening_parameter( scrparm_ )
     IMPLICIT NONE
     REAL(DP):: scrparm_
     screening_parameter = scrparm_
     WRITE( stdout,'(5x,a,f12.7)') 'EXX Screening parameter changed: ', &
          & screening_parameter
  END SUBROUTINE set_screening_parameter
  !----------------------------------------------------------------------
  FUNCTION get_screening_parameter()
     REAL(DP):: get_screening_parameter
     get_screening_parameter = screening_parameter
     RETURN
  END FUNCTION get_screening_parameter
  !---------------------------------------------------------------------
  SUBROUTINE set_gau_parameter( gauparm_ )
     IMPLICIT NONE
     REAL(DP):: gauparm_
     gau_parameter = gauparm_
     WRITE( stdout,'(5x,a,f12.7)') 'EXX Gau parameter changed: ', &
          & gau_parameter
  END SUBROUTINE set_gau_parameter
  !----------------------------------------------------------------------
  FUNCTION get_gau_parameter()
     REAL(DP):: get_gau_parameter
     get_gau_parameter = gau_parameter
     RETURN
  END FUNCTION get_gau_parameter
  !-----------------------------------------------------------------------
  FUNCTION get_iexch()
     INTEGER get_iexch
     get_iexch = iexch
     RETURN
  END FUNCTION get_iexch
  !-----------------------------------------------------------------------
  FUNCTION get_icorr()
     INTEGER get_icorr
     get_icorr = icorr
     RETURN
  END FUNCTION get_icorr
  !-----------------------------------------------------------------------
  FUNCTION get_igcx()
     INTEGER get_igcx
     get_igcx = igcx
     RETURN
  END FUNCTION get_igcx
  !-----------------------------------------------------------------------
  FUNCTION get_igcc()
     INTEGER get_igcc
     get_igcc = igcc
     RETURN
  END FUNCTION get_igcc
  !-----------------------------------------------------------------------
  FUNCTION get_meta()
     INTEGER get_meta
     get_meta = imeta
     RETURN
  END FUNCTION get_meta
  !
  FUNCTION get_metac()
    INTEGER get_metac
    get_metac = imetac
    RETURN
  END FUNCTION get_metac
  !-----------------------------------------------------------------------
  FUNCTION get_inlc()
     INTEGER get_inlc
     get_inlc = inlc
     RETURN
  END FUNCTION get_inlc
  !-----------------------------------------------------------------------
  FUNCTION get_nonlocc_name()
     CHARACTER(10) get_nonlocc_name
     get_nonlocc_name = TRIM(nonlocc(inlc))
     RETURN
  END FUNCTION get_nonlocc_name
  !-----------------------------------------------------------------------
  FUNCTION dft_is_nonlocc()
     LOGICAL :: dft_is_nonlocc
     dft_is_nonlocc = isnonlocc
     RETURN
  END FUNCTION dft_is_nonlocc
  !-----------------------------------------------------------------------
  FUNCTION get_exx_fraction()
     REAL(DP) :: get_exx_fraction
#if defined(__LIBXC)
     INTEGER :: family
     TYPE(xc_f90_pointer_t) :: xc_func, xc_info
     !
     IF ( is_libxc(3) ) THEN
        CALL xc_f90_func_init( xc_func, xc_info, igcx, 1 )  
        family = xc_f90_info_family( xc_info )
        IF (family == XC_FAMILY_HYB_GGA) CALL xc_f90_hyb_exx_coef( xc_func, exx_fraction )
        CALL xc_f90_func_end( xc_func )
     ENDIF
#endif
     get_exx_fraction = exx_fraction
     RETURN
  END FUNCTION get_exx_fraction
  !-----------------------------------------------------------------------
  FUNCTION get_dft_name()
     CHARACTER(LEN=25) :: get_dft_name
     get_dft_name = dft
     RETURN
  END FUNCTION get_dft_name
  !-----------------------------------------------------------------------
  FUNCTION dft_is_gradient()
     LOGICAL :: dft_is_gradient
     dft_is_gradient = isgradient
     RETURN
  END FUNCTION dft_is_gradient
  !-----------------------------------------------------------------------
  FUNCTION dft_is_meta()
     LOGICAL :: dft_is_meta
     dft_is_meta = ismeta
     RETURN
  END FUNCTION dft_is_meta
  !-----------------------------------------------------------------------
  FUNCTION dft_is_hybrid()
     LOGICAL :: dft_is_hybrid
     dft_is_hybrid = ishybrid
     RETURN
  END FUNCTION dft_is_hybrid
  !-----------------------------------------------------------------------
  FUNCTION igcc_is_lyp()
     LOGICAL :: igcc_is_lyp
     igcc_is_lyp = (get_igcc()==3 .OR. get_igcc()==7 .OR. get_igcc()==13)
     RETURN
  END FUNCTION igcc_is_lyp
  !-----------------------------------------------------------------------
  FUNCTION dft_has_finite_size_correction()
     LOGICAL :: dft_has_finite_size_correction
     dft_has_finite_size_correction = has_finite_size_correction
     RETURN
  END FUNCTION  dft_has_finite_size_correction
  !-----------------------------------------------------------------------
  SUBROUTINE set_finite_size_volume( volume )
     REAL, INTENT(IN) :: volume
     IF (.NOT. has_finite_size_correction) &
         CALL errore( 'set_finite_size_volume', &
                      'dft w/o finite_size_correction, wrong call', 1 )
     IF (volume <= 0.d0) &
         CALL errore( 'set_finite_size_volume', &
                      'volume is not positive, check omega and/or nk1,nk2,nk3', 1 )
     finite_size_cell_volume = volume
     finite_size_cell_volume_set = .TRUE.
  END SUBROUTINE set_finite_size_volume
  !-----------------------------------------------------------------------
  !
  SUBROUTINE get_finite_size_cell_volume( is_present, volume )
     LOGICAL, INTENT(OUT) :: is_present
     REAL(DP), INTENT(OUT) :: volume
     is_present = finite_size_cell_volume_set
     volume = -1.d0
     IF (is_present) volume = finite_size_cell_volume
  END SUBROUTINE get_finite_size_cell_volume
  !
  !------------------------------------------------------------------------
#if defined(__LIBXC)
  SUBROUTINE get_libxc_flags_exc( xc_info, eflag )
     ! Checks whether Exc is present or not in the output of a libxc 
     ! functional (e.g. TB09)
     TYPE(xc_f90_pointer_t) :: xc_info
     INTEGER :: ii, flags_tot
     INTEGER, INTENT(OUT) :: eflag
     flags_tot = xc_f90_info_flags(xc_info)
     eflag = 0
     DO ii = 15, 0, -1
       IF ( flags_tot-2**ii<0 ) CYCLE
       flags_tot = flags_tot-2**ii
       IF ( ii==0 ) eflag = 1
     ENDDO
     RETURN
  END SUBROUTINE
#endif
  !
  !-----------------------------------------------------------------------
  SUBROUTINE set_dft_from_indices( iexch_, icorr_, igcx_, igcc_, imeta_, inlc_ )
     INTEGER :: iexch_, icorr_, igcx_, igcc_, imeta_, inlc_
     IF ( discard_input_dft ) RETURN
     IF (iexch == notset) iexch = iexch_
     IF (iexch /= iexch_) THEN
        write (stdout,*) iexch, iexch_
        CALL errore( 'set_dft', ' conflicting values for iexch', 1 )
     ENDIF
     IF (icorr == notset) icorr = icorr_
     IF (icorr /= icorr_) THEN
        write (stdout,*) icorr, icorr_
        CALL errore( 'set_dft', ' conflicting values for icorr', 1 )
     ENDIF
     IF (igcx  == notset) igcx = igcx_
     IF (igcx /= igcx_) THEN
        write (stdout,*) igcx, igcx_
        CALL errore( 'set_dft', ' conflicting values for igcx', 1 )
     ENDIF
     IF (igcc  == notset) igcc = igcc_
     IF (igcc /= igcc_) THEN
        write (stdout,*) igcc, igcc_
        CALL errore( 'set_dft', ' conflicting values for igcc', 1 )
     ENDIF
     IF (imeta  == notset) imeta = imeta_
     IF (imeta /= imeta_) THEN
        write (stdout,*) imeta, imeta_
        CALL errore( 'set_dft', ' conflicting values for imeta', 1 )
     ENDIF     
     IF (inlc  == notset) inlc = inlc_
     IF (inlc /= inlc_) THEN
        write (stdout,*) inlc, inlc_
        CALL errore( 'set_dft', ' conflicting values for inlc', 1 )
     ENDIF
     dft = exc (iexch) //'-'//corr (icorr) //'-'//gradx (igcx) //'-' &
           &//gradc (igcc)//'-'//nonlocc (inlc)
     ! WRITE( stdout,'(a)') dft
     CALL set_auxiliary_flags
     RETURN
  END SUBROUTINE set_dft_from_indices
  !
  !
  !-------------------------------------------------------------------------
  FUNCTION get_dft_short()
    !---------------------------------------------------------------------
    !
    CHARACTER(LEN=18) :: get_dft_short
    CHARACTER(LEN=18) :: shortname
    !
    shortname = 'no shortname'
    !
    IF ( iexch==1 .AND. igcx==0 .AND. igcc==0) THEN
       shortname = TRIM(corr(icorr))
    ELSEIF (iexch==4 .AND. icorr==0  .AND. igcx==0 .AND. igcc== 0) THEN
       shortname = 'OEP'
    ELSEIF (iexch==1 .AND. icorr==11 .AND. igcx==0 .AND. igcc== 0) THEN
       shortname = 'VWN-RPA'
    ELSEIF (iexch==1 .AND. icorr==3  .AND. igcx==1 .AND. igcc== 3) THEN
       shortname = 'BLYP'
    ELSEIF (iexch==1 .AND. icorr==1  .AND. igcx==1 .AND. igcc== 0) THEN
       shortname = 'B88'
    ELSEIF (iexch==1 .AND. icorr==1  .AND. igcx==1 .AND. igcc== 1) THEN
       shortname = 'BP'
    ELSEIF (iexch==1 .AND. icorr==4  .AND. igcx==2 .AND. igcc== 2) THEN
       shortname = 'PW91'
    ELSEIF (iexch==1 .AND. icorr==4  .AND. igcx==3 .AND. igcc== 4) THEN
       shortname = 'PBE'
    ELSEIF (iexch==6 .AND. icorr==4  .AND. igcx==8 .AND. igcc== 4) THEN
       shortname = 'PBE0'
    ELSEIF (iexch==6 .AND. icorr==4  .AND. igcx==41.AND. igcc== 4) THEN
       shortname = 'B86BPBEX'
    ELSEIF (iexch==6 .AND. icorr==4  .AND. igcx==42.AND. igcc== 3) THEN
       shortname = 'BHANDHLYP'
    ELSEIF (iexch==1 .AND. icorr==4  .AND. igcx==4 .AND. igcc== 4) THEN
       shortname = 'revPBE'
    ELSEIF (iexch==1 .AND. icorr==4  .AND. igcx==10.AND. igcc== 8) THEN
       shortname = 'PBESOL'
    ELSEIF (iexch==1 .AND. icorr==4  .AND. igcx==19.AND. igcc==12) THEN
       shortname = 'Q2D'
    ELSEIF (iexch==1 .AND. icorr==4  .AND. igcx==12.AND. igcc== 4) THEN
       shortname = 'HSE'
    ELSEIF (iexch==1 .AND. icorr==4  .AND. igcx==20.AND. igcc== 4) THEN
       shortname = 'GAUPBE'
    ELSEIF (iexch==1 .AND. icorr==4  .AND. igcx==21.AND. igcc== 4) THEN
       shortname = 'PW86PBE'
    ELSEIF (iexch==1 .AND. icorr==4  .AND. igcx==22.AND. igcc== 4) THEN
       shortname = 'B86BPBE'
    ELSEIF (iexch==1 .AND. icorr==4  .AND. igcx==11.AND. igcc== 4) THEN
       shortname = 'WC'
    ELSEIF (iexch==7 .AND. icorr==12 .AND. igcx==9 .AND. igcc== 7) THEN
       shortname = 'B3LYP'
    ELSEIF (iexch==7 .AND. icorr==13 .AND. igcx==9 .AND. igcc== 7) THEN
       shortname = 'B3LYP-V1R'
    ELSEIF (iexch==9 .AND. icorr==14 .AND. igcx==28.AND. igcc==13) THEN
       shortname = 'X3LYP'
    ELSEIF (iexch==0 .AND. icorr==3  .AND. igcx==6 .AND. igcc== 3) THEN
       shortname = 'OLYP'
    ELSEIF (iexch==1 .AND. icorr==4  .AND. igcx==17.AND. igcc== 4) THEN
       shortname = 'SOGGA'
    ELSEIF (iexch==1 .AND. icorr==4  .AND. igcx==23.AND. igcc== 1) THEN
       shortname = 'OPTBK88'
    ELSEIF (iexch==1 .AND. icorr==4  .AND. igcx==24.AND. igcc== 1) THEN
       shortname = 'OPTB86B'
    ELSEIF (iexch==1 .AND. icorr==4  .AND. igcx==25.AND. igcc== 0) THEN
       shortname = 'EV93'
    ELSEIF (iexch==5 .AND. icorr==0  .AND. igcx==0 .AND. igcc== 0) THEN
       shortname = 'HF'
    ENDIF
    !
    IF (imeta==1) THEN
       shortname = 'TPSS'
    ELSEIF (imeta == 2) THEN
       shortname = 'M06L'
    ELSEIF (imeta == 3) THEN
       shortname = 'TB09'
    ELSEIF (imeta == 4) THEN
       IF ( iexch == 1 .AND. icorr == 1) THEN
          shortname = 'PZ+META'
       ELSEIF (iexch==1 .AND. icorr==4 .AND. igcx==3 .AND. igcc==4) THEN
          shortname = 'PBE+META'
       ENDIF
    ELSEIF (imeta == 5 ) THEN
       shortname = 'SCAN'
    ELSEIF (imeta == 6 ) THEN
       shortname = 'SCAN0'
    ENDIF
    !
    IF (inlc==1) THEN
       IF (iexch==1 .AND. icorr==4 .AND. igcx==4 .AND. igcc==0) THEN
          shortname = 'VDW-DF'
       ELSEIF (iexch==1 .AND. icorr==4 .AND. igcx==27 .AND. igcc==0) THEN
          shortname = 'VDW-DF-CX'
       ELSEIF (iexch==6 .AND. icorr==4 .AND. igcx==29 .AND. igcc==0) THEN
          shortname = 'VDW-DF-CX0'
       ELSEIF (iexch==6 .AND. icorr==4 .AND. igcx==31 .AND. igcc==0) THEN
          shortname = 'VDW-DF-CX0P'
       ELSEIF (iexch==1 .AND. icorr==4 .AND. igcx==16 .AND. igcc==0) THEN
          shortname = 'VDW-DF-C09'
       ELSEIF (iexch==1 .AND. icorr==4 .AND. igcx==24 .AND. igcc==0) THEN
          shortname = 'VDW-DF-OB86'
       ELSEIF (iexch==1 .AND. icorr==4 .AND. igcx==23 .AND. igcc==0) THEN
          shortname = 'VDW-DF-OBK8'
       ELSEIF (iexch==6 .AND. icorr==4 .AND. igcx==40 .AND. igcc==0) THEN
          shortname = 'VDW-DF-C090'
       ENDIF
    ELSEIF (inlc==2) THEN
       if (iexch==1 .AND. icorr==4 .AND. igcx==13 .AND. igcc==0) THEN
          shortname = 'VDW-DF2'
       ELSEIF (iexch==1 .AND. icorr==4 .AND. igcx==16 .AND. igcc==0) THEN
          shortname = 'VDW-DF2-C09'
       ELSEIF (iexch==1 .AND. icorr==4 .AND. igcx==26 .AND. igcc==0) THEN
          shortname = 'VDW-DF2-B86R'
       ELSEIF (iexch==6 .AND. icorr==4 .AND. igcx==30 .AND. igcc==0) THEN
          shortname = 'VDW-DF2-0'
       ELSEIF (iexch==6 .AND. icorr==4 .AND. igcx==38 .AND. igcc==0) THEN
          shortname = 'VDW-DF2-BR0'
       ENDIF
    ELSEIF (inlc==3) THEN
       shortname = 'RVV10'
    ENDIF
    !
#if defined(__LIBXC)
    IF ( ANY(is_libxc(:)) ) THEN
       shortname = 'XC-000-000-000-000'
       WRITE( shortname(4:6),   '(i3.3)' ) iexch
       WRITE( shortname(8:10),  '(i3.3)' ) icorr
       WRITE( shortname(12:14), '(i3.3)' ) igcx
       WRITE( shortname(16:18), '(i3.3)' ) igcc
    ENDIF
#endif
    !
    get_dft_short = shortname
    !
  END FUNCTION get_dft_short
  !
  !
  !---------------------------------------------------------------------
  FUNCTION get_dft_long()
    !---------------------------------------------------------------------
    !
    CHARACTER(LEN=25) :: get_dft_long
    CHARACTER(LEN=25) :: longname
    !
    WRITE(longname,'(4a5)') exc(iexch), corr(icorr), gradx(igcx), gradc(igcc)
    !
    IF ( imeta > 0 ) THEN
       longname = longname(1:20)//TRIM(meta(imeta))
    ELSEIF ( inlc > 0 ) THEN
       longname = longname(1:20)//TRIM(nonlocc(inlc))
    ENDIF
    !
    get_dft_long = longname
    !
  END FUNCTION get_dft_long
  !
  !
!-----------------------------------------------------------------------
SUBROUTINE write_dft_name
!-----------------------------------------------------------------------
   WRITE( stdout, '(5X,"Exchange-correlation= ",A)') TRIM( dft )
   WRITE( stdout, '(27X,"(",I4,3I4,3I4,")")' ) iexch, icorr, igcx, igcc, inlc, imeta, imetac
   IF ( get_exx_fraction() > 0.0_dp ) WRITE( stdout, &
        '(5X,"EXX-fraction              =",F12.2)') get_exx_fraction()
   RETURN
END SUBROUTINE write_dft_name
!
!
!-----------------------------------------------------------------------
!------- NONLOCAL CORRECTIONS DRIVERS ----------------------------------
!-----------------------------------------------------------------------
!
!-----------------------------------------------------------------------
SUBROUTINE nlc (rho_valence, rho_core, nspin, enl, vnl, v)
  !-----------------------------------------------------------------------
  !     non-local contribution to the correlation energy
  !
  !     input      :  rho_valence, rho_core
  !     definition :  E_nl = \int E_nl(rho',grho',rho'',grho'',|r'-r''|) dr
  !     output     :  enl = E^nl_c
  !                   vnl = D(E^nl_c)/D(rho)
  !                   v   = non-local contribution to the potential
  !
  !
  USE vdW_DF, ONLY: xc_vdW_DF, xc_vdW_DF_spin, inlc_ => inlc
  USE rVV10,  ONLY: xc_rVV10
  !
  IMPLICIT NONE
  !
  REAL(DP), INTENT(IN)    :: rho_valence(:,:), rho_core(:)
  INTEGER,  INTENT(IN)    :: nspin
  REAL(DP), INTENT(INOUT) :: v(:,:)
  REAL(DP), INTENT(INOUT) :: enl, vnl
  !
  IF ( inlc == 1 .OR. inlc == 2) THEN
     !
     inlc_ = inlc
     IF ( nspin == 1 ) THEN
        CALL xc_vdW_DF      (rho_valence, rho_core, enl, vnl, v)
     ELSE IF ( nspin == 2 ) THEN
        CALL xc_vdW_DF_spin (rho_valence, rho_core, enl, vnl, v)
     ELSE
        CALL errore ('nlc', 'vdW-DF not available for noncollinear spin case',1)
     END If
     !
  ELSE IF ( inlc == 3 ) THEN
     !
     IF ( imeta == 0 ) THEN
       CALL xc_rVV10 (rho_valence(:,1), rho_core, nspin, enl, vnl, v)
     ELSE
       CALL xc_rVV10 (rho_valence(:,1), rho_core, nspin, enl, vnl, v, 15.7_dp)
     END IF
     !
  ELSE
     !
     CALL errore ('nlc', 'inlc choice for E^nl_c not implemented',1)
     !
  END IF
  !
  RETURN
END SUBROUTINE nlc
!
!
#if defined(__LIBXC)
  SUBROUTINE get_libxc_version
     !
     IMPLICIT NONE
     !
     INTERFACE
        SUBROUTINE xc_version( major, minor, micro ) bind(c)
           USE iso_c_binding
           INTEGER(c_int) :: major, minor, micro
        END SUBROUTINE xc_version
     END INTERFACE
     !
     CALL xc_version( libxc_major, libxc_minor, libxc_micro )
     !
  END SUBROUTINE get_libxc_version
#endif
!
!
END MODULE funct

MODULE qepy_tddft_mod
   USE kinds,                ONLY : DP
   !
   IMPLICIT NONE
   PUBLIC
   !
CONTAINS

   SUBROUTINE qepy_cetddft_wfc2rho(iunit)
      USE kinds,                ONLY : DP
      USE io_files,             ONLY : iunwfc, nwordwfc
      USE wavefunctions,        ONLY : evc
      USE klist,                ONLY : nks
      USE buffers,              ONLY : get_buffer
      !
      USE tddft_module, ONLY: iunevcn, l_tddft_restart
      IMPLICIT NONE
      INTEGER, INTENT(IN),OPTIONAL :: iunit
      !
      IF ( present(iunit) ) THEN
        iunwfc = iunit
      ELSE
        iunwfc = iunevcn
     ENDIF
     if (nks==1) then
        call get_buffer(evc, nwordwfc, iunwfc, 1)
     endif
     call sum_band()
     l_tddft_restart = .true.
  END SUBROUTINE

END MODULE qepy_tddft_mod

!
! Copyright (C) 2001-2009 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
!----------------------------------------------------------------------------
!SUBROUTINE stop_run( exit_status )
  !!----------------------------------------------------------------------------
  !!! Close all files and synchronize processes before stopping:
  !!
  !!! * exit_status = 0: successfull execution, remove temporary files;
  !!! * exit_status =-1: code stopped by user request;
  !!! * exit_status = 1: convergence not achieved.
  !!
  !!! Do not remove temporary files needed for restart.
  !!
  !USE io_global,          ONLY : ionode
  !USE mp_global,          ONLY : mp_global_end
  !USE environment,        ONLY : environment_end
  !USE io_files,           ONLY : iuntmp, seqopn
  !!
  !IMPLICIT NONE
  !!
  !INTEGER, INTENT(IN) :: exit_status
  !LOGICAL             :: exst, opnd, lflag
  !!
  !lflag = ( exit_status == 0 ) 
  !IF ( lflag ) THEN
     !! 
     !! ... remove files needed only to restart
     !!
     !CALL seqopn( iuntmp, 'restart', 'UNFORMATTED', exst )
     !CLOSE( UNIT = iuntmp, STATUS = 'DELETE' )
     !!
     !IF ( ionode ) THEN
        !CALL seqopn( iuntmp, 'update', 'FORMATTED', exst )
        !CLOSE( UNIT = iuntmp, STATUS = 'DELETE' )
        !CALL seqopn( iuntmp, 'para', 'FORMATTED', exst )
        !CLOSE( UNIT = iuntmp, STATUS = 'DELETE' )
     !ENDIF
     !!
  !ENDIF
  !!
  !CALL close_files( lflag )
  !!
  !CALL print_clock_pw()
  !!
  !CALL clean_pw( .TRUE. )
  !!
  !CALL environment_end( 'PWSCF' )
  !!
  !CALL mp_global_end()
  !!
!END SUBROUTINE stop_run

SUBROUTINE qepy_stop_run( exit_status, print_flag, what, finalize )
  !----------------------------------------------------------------------------
  !! Close all files and synchronize processes before stopping:
  !
  !! * exit_status = 0: successfull execution, remove temporary files;
  !! * exit_status =-1: code stopped by user request;
  !! * exit_status = 1: convergence not achieved.
  !
  !! Do not remove temporary files needed for restart.
  !
  !qepy --> 
  ! Also add some from pwscf and run_pwscf
  ! Merge and modify the mp_global.mp_global_end
  !qepy <-- 
  !
  USE io_global,          ONLY : stdout, ionode
  USE mp_global,          ONLY : mp_global_end
  USE environment,        ONLY : environment_end
  USE io_files,           ONLY : iuntmp, seqopn
  USE qmmm,               ONLY : qmmm_shutdown
  USE qexsd_module,       ONLY : qexsd_set_status
  USE mp,                 ONLY : mp_comm_free, mp_barrier, mp_start, mp_end, mp_stop, mp_count_nodes
  USE mp_world,           ONLY : world_comm
  USE mp_bands,           ONLY : inter_bgrp_comm, intra_bgrp_comm
  USE mp_pools,           ONLY : inter_pool_comm, intra_pool_comm
  USE mp_exx,             ONLY : inter_egrp_comm, intra_egrp_comm
  USE mp_images,          ONLY : inter_image_comm, intra_image_comm
  USE mp_orthopools,      ONLY : mp_stop_orthopools
  USE mp_diag,            ONLY : ortho_comm
  !
  IMPLICIT NONE
  !
  INTEGER, INTENT(IN) :: exit_status
  INTEGER, INTENT(IN), OPTIONAL :: print_flag
  CHARACTER(LEN=*), INTENT(IN), OPTIONAL :: what
  LOGICAL, OPTIONAL   :: finalize
  CHARACTER(LEN=256)  :: what_ ='config-nowf'
  INTEGER             :: iprint = 0
  LOGICAL             :: exst, opnd, lflag
#if defined(__MPI)
  INTEGER :: ierr
#endif
  !
  !qepy --> pwscf and run_pwscf
  CALL qexsd_set_status( exit_status )
  CALL qmmm_shutdown()
  if ( ortho_comm  /= 0 .and. ortho_comm  /= world_comm ) CALL laxlib_free_ortho_group()
  !qepy <-- pwscf and run_pwscf
  !
  IF ( PRESENT(what)) THEN
     IF (len_trim(what)>1) what_= trim(what)
  ENDIF

  IF (TRIM(what_) == 'no') THEN 
     WRITE( UNIT = stdout, FMT = '(/,5X,"Not output data")' )
  ELSE
     CALL punch( what_)
  ENDIF

  IF ( PRESENT(print_flag)) THEN
     iprint = print_flag
  ENDIF


  lflag = ( exit_status == 0 ) 
  IF ( lflag ) THEN
     ! 
     ! ... remove files needed only to restart
     !
     CALL seqopn( iuntmp, 'restart', 'UNFORMATTED', exst )
     CLOSE( UNIT = iuntmp, STATUS = 'DELETE' )
     !
     IF ( ionode ) THEN
        CALL seqopn( iuntmp, 'update', 'FORMATTED', exst )
        CLOSE( UNIT = iuntmp, STATUS = 'DELETE' )
        CALL seqopn( iuntmp, 'para', 'FORMATTED', exst )
        CLOSE( UNIT = iuntmp, STATUS = 'DELETE' )
     ENDIF
     !
  ENDIF
  !
  CALL close_files( lflag )
  !
  IF ( iprint > 0 .and. iprint<10 ) THEN
     CALL print_clock_pw()
  ENDIF
  !
  CALL clean_pw( .TRUE. )
  !
  IF ( iprint > 0 .and. iprint<10 ) THEN
     CALL environment_end( 'PWSCF' )
  ENDIF
  !
  !CALL mp_global_end()
  !-----------------------------------------------------------------------
  !qepy --> add mp_global_end
  if ( intra_egrp_comm  /= 0 .and. intra_egrp_comm  /= world_comm ) CALL mp_comm_free ( intra_egrp_comm )
  if ( inter_egrp_comm  /= 0 .and. inter_egrp_comm  /= world_comm ) CALL mp_comm_free ( inter_egrp_comm )
  if ( intra_bgrp_comm  /= 0 .and. intra_bgrp_comm  /= world_comm ) CALL mp_comm_free ( intra_bgrp_comm )
  if ( inter_bgrp_comm  /= 0 .and. inter_bgrp_comm  /= world_comm ) CALL mp_comm_free ( inter_bgrp_comm )
  if ( intra_pool_comm  /= 0 .and. intra_pool_comm  /= world_comm ) CALL mp_comm_free ( intra_pool_comm )
  if ( inter_pool_comm  /= 0 .and. inter_pool_comm  /= world_comm ) CALL mp_comm_free ( inter_pool_comm )
  if ( intra_image_comm /= 0 .and. intra_image_comm /= world_comm ) CALL mp_comm_free ( intra_image_comm )
  if ( inter_image_comm /= 0 .and. inter_image_comm /= world_comm ) CALL mp_comm_free ( inter_image_comm )
  CALL mp_stop_orthopools( ) ! cleans orthopools if used in exx
  CALL mp_barrier( world_comm )
  CALL mp_end ( world_comm )
#if defined(__MPI)
  IF (present(finalize)) THEN
     IF (finalize) THEN
        CALL mpi_finalize(ierr)
        IF (ierr/=0) CALL mp_stop( 8002 )
     ENDIF
  END IF
#endif
  !qepy <-- add mp_global_end
  !-----------------------------------------------------------------------
  !
END SUBROUTINE qepy_stop_run
!
!-----------------------------------------
!SUBROUTINE do_stop( exit_status )
  !!---------------------------------------
  !!! Stop the run.
  !!
  !IMPLICIT NONE
  !!
  !INTEGER, INTENT(IN) :: exit_status
  !!
  !IF ( exit_status == -1 ) THEN
     !! -1 is not an acceptable value for stop in fortran;
     !! convert it to 255
     !STOP 255
  !ELSEIF ( exit_status == 0 ) THEN
     !STOP
  !ELSEIF ( exit_status == 1 ) THEN
     !STOP 1
  !ELSEIF ( exit_status == 2 ) THEN
     !STOP 2
  !ELSEIF ( exit_status == 3 ) THEN
     !STOP 3
  !ELSEIF ( exit_status == 4 ) THEN
     !STOP 4
  !ELSEIF ( exit_status == 255 ) THEN
     !STOP 255
  !ELSEIF ( exit_status == 254 ) THEN
     !STOP 254
  !ELSE
     !! unimplemented value
     !STOP 128
  !ENDIF
  !!
!END SUBROUTINE do_stop
!!
!!----------------------------------------------------------------------------
!SUBROUTINE closefile()
  !!----------------------------------------------------------------------------
  !!! Close all files and synchronize processes before stopping.  
  !!! Called by "sigcatch" when it receives a signal.
  !!
  !USE io_global,  ONLY :  stdout
  !!
  !WRITE( stdout,'(5X,"Signal Received, stopping ... ")')
  !!
  !CALL stop_run( 255 )
  !!
  !RETURN
  !!
!END SUBROUTINE closefile

!
! Copyright (C) 2001-2016 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
!----------------------------------------------------------------------------
! TB
! included gate related energy
!----------------------------------------------------------------------------
!
!----------------------------------------------------------------------------
SUBROUTINE qepy_electrons(embed)
  !----------------------------------------------------------------------------
  !! General self-consistency loop, also for hybrid functionals
  !! For non-hybrid functionals it just calls "electron_scf"
  !
  USE kinds,                ONLY : DP
  USE check_stop,           ONLY : check_stop_now, stopped_by_user
  USE io_global,            ONLY : stdout, ionode
  USE fft_base,             ONLY : dfftp
  USE gvecs,                ONLY : doublegrid
  USE gvect,                ONLY : ecutrho
  USE lsda_mod,             ONLY : nspin, magtot, absmag
  USE ener,                 ONLY : etot, hwf_energy, eband, deband, ehart, &
                                   vtxc, etxc, etxcc, ewld, demet, epaw, &
                                   elondon, edftd3, ef_up, ef_dw
  USE tsvdw_module,         ONLY : EtsvdW
  USE scf,                  ONLY : rho, rho_core, rhog_core, v, vltot, vrs, &
                                   kedtau, vnew
  USE control_flags,        ONLY : tr2, niter, conv_elec, restart, lmd, &
                                   do_makov_payne
  USE io_files,             ONLY : iunres, seqopn
  USE ldaU,                 ONLY : eth
  USE extfield,             ONLY : tefield, etotefield
  USE wvfct,                ONLY : nbnd, wg, et
  USE klist,                ONLY : nks
  USE noncollin_module,     ONLY : noncolin, magtot_nc, i_cons,  bfield, &
                                   lambda, report
  USE uspp,                 ONLY : okvan
  USE exx,                  ONLY : aceinit,exxinit, exxenergy2, exxenergy, exxbuff, &
                                   fock0, fock1, fock2, fock3, dexx, use_ace, local_thr 
  USE funct,                ONLY : dft_is_hybrid, exx_is_active
  USE control_flags,        ONLY : adapt_thr, tr2_init, tr2_multi, gamma_only
  !
  USE paw_variables,        ONLY : okpaw, ddd_paw, total_core_energy, only_paw
  USE paw_onecenter,        ONLY : PAW_potential
  USE paw_symmetry,         ONLY : PAW_symmetrize_ddd
  USE ions_base,            ONLY : nat
  USE loc_scdm,             ONLY : use_scdm, localize_orbitals
  USE loc_scdm_k,           ONLY : localize_orbitals_k
  !
  USE qepy_common,          ONLY : embed_base
  !
  IMPLICIT NONE
  !
  type(embed_base), intent(inout)    :: embed
  !
  ! ... a few local variables
  !
  REAL(DP) :: charge
  !! the total charge
  REAL(DP) :: exxen
  !! used to compute exchange energy
  REAL(DP), EXTERNAL :: exxenergyace
  INTEGER :: idum
  !! dummy counter on iterations
  INTEGER :: iter
  !! counter on iterations
  INTEGER :: printout, ik, ios
  !
  REAL(DP) :: tr2_min
  !! estimated error on energy coming from diagonalization
  REAL(DP) :: tr2_final
  !! final threshold for exx minimization 
  !! when using adaptive thresholds.
  LOGICAL :: first, exst
  REAL(DP) :: etot_cmp_paw(nat,2,2)
  LOGICAL :: DoLoc
  !
  !
  !qepy --> TODO: hybrid iterative
  if ( embed%iterative ) then
     CALL errore( 'qepy_electrons', 'Sorry, Hybrid XC not support iterative mode now',1)
  elseif ( embed%exttype > 1 ) then
     CALL errore( 'qepy_electrons', 'Hybrid mode only support external potential and local pseudopotential',1)
  end if
  !qepy <-- TODO: hybrid iterative
  DoLoc = local_thr.gt.0.0d0
  exxen = 0.0d0
  iter = 0
  first = .true.
  tr2_final = tr2
  IF ( dft_is_hybrid() ) THEN
     !printout = 0  ! do not print etot and energy components at each scf step
     printout = 1  ! print etot, not energy components at each scf step
  ELSE IF ( lmd ) THEN
     printout = 1  ! print etot, not energy components at each scf step
  ELSE
     printout = 2  ! print etot and energy components at each scf step
  ENDIF
  IF (dft_is_hybrid() .AND. adapt_thr ) tr2= tr2_init
  fock0 = 0.D0
  fock1 = 0.D0
  fock3 = 0.D0
  IF (.NOT. exx_is_active () ) fock2 = 0.D0
  !
  !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  !%%%%%%%%%%%%%%%%%%%%  Iterate hybrid functional  %%%%%%%%%%%%%%%%%%%%%
  !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  !
  IF ( restart ) THEN
     CALL seqopn (iunres, 'restart_e', 'formatted', exst)
     IF ( exst ) THEN
        ios = 0
        READ (iunres, *, iostat=ios) iter, tr2, dexx
        IF ( ios /= 0 ) THEN
           iter = 0
        ELSE IF ( iter < 0 .OR. iter > niter ) THEN
           iter = 0
        ELSE 
           READ (iunres, *) exxen, fock0, fock1, fock2
           ! FIXME: et and wg should be read from xml file
           READ (iunres, *) (wg(1:nbnd,ik),ik=1,nks)
           READ (iunres, *) (et(1:nbnd,ik),ik=1,nks)
           CLOSE ( unit=iunres, status='delete')
           ! ... if restarting here, exx was already active
           ! ... initialize stuff for exx
           first = .false.
           CALL exxinit(DoLoc)
           IF( DoLoc.and.gamma_only) THEN
             CALL localize_orbitals( )
           ELSE IF (DoLoc) THEN
             CALL localize_orbitals_k( )
           ENDIF 
           ! FIXME: ugly hack, overwrites exxbuffer from exxinit
           CALL seqopn (iunres, 'restart_exx', 'unformatted', exst)
           IF (exst) READ (iunres, iostat=ios) exxbuff
           IF (ios /= 0) WRITE(stdout,'(5x,"Error in EXX restart!")')
           IF (use_ace) CALL aceinit ( DoLoc )
           !
           CALL v_of_rho( rho, rho_core, rhog_core, &
               ehart, etxc, vtxc, eth, etotefield, charge, v)
           IF (okpaw) CALL PAW_potential(rho%bec, ddd_PAW, epaw,etot_cmp_paw)
           CALL set_vrs( vrs, vltot, v%of_r, kedtau, v%kin_r, dfftp%nnr, &
                         nspin, doublegrid )
           !
           WRITE(stdout,'(5x,"Calculation (EXX) restarted from iteration #", &
                        & i6)') iter 
        ENDIF
     ENDIF
     CLOSE ( unit=iunres, status='delete')
  ENDIF
  !
  DO idum=1,niter
     !
     iter = iter + 1
     !
     ! ... Self-consistency loop. For hybrid functionals the exchange potential
     ! ... is calculated with the orbitals at previous step (none at first step)
     !
     CALL qepy_electrons_scf ( printout, exxen, embed )
     !
     IF ( .NOT. dft_is_hybrid() ) RETURN
     !
     ! ... From now on: hybrid DFT only
     !
     IF ( stopped_by_user .OR. .NOT. conv_elec ) THEN
        conv_elec=.FALSE.
        IF ( .NOT. first) THEN
           WRITE(stdout,'(5x,"Calculation (EXX) stopped during iteration #", &
                        & i6)') iter
           CALL seqopn (iunres, 'restart_e', 'formatted', exst)
           WRITE (iunres, *) iter-1, tr2, dexx
           WRITE (iunres, *) exxen, fock0, fock1, fock2
           WRITE (iunres, *) (wg(1:nbnd,ik),ik=1,nks)
           WRITE (iunres, *) (et(1:nbnd,ik),ik=1,nks)
           CLOSE (unit=iunres, status='keep')
           CALL seqopn (iunres, 'restart_exx', 'unformatted', exst)
           WRITE (iunres) exxbuff
           CLOSE (unit=iunres, status='keep')
        ENDIF
        RETURN
     ENDIF
     !
     first =  first .AND. .NOT. exx_is_active ( )
     !
     ! "first" is true if the scf step was performed without exact exchange
     !
     IF ( first ) THEN
        !
        first = .false.
        !
        ! Activate exact exchange, set orbitals used in its calculation,
        ! then calculate exchange energy (will be useful at next step)
        !
        CALL exxinit(DoLoc)
        IF( DoLoc.and.gamma_only) THEN
          CALL localize_orbitals( )
        ELSE IF (DoLoc) THEN
          CALL localize_orbitals_k( )
        ENDIF 
        IF (use_ace) THEN
           CALL aceinit ( DoLoc ) 
           fock2 = exxenergyace()
        ELSE
           fock2 = exxenergy2()
        ENDIF
        exxen = 0.50d0*fock2 
        etot = etot - etxc 
        !
        ! Recalculate potential because XC functional has changed,
        ! start self-consistency loop on exchange
        !
        CALL qepy_v_of_rho( rho, rho_core, rhog_core, &
             ehart, etxc, vtxc, eth, etotefield, charge, v, embed)
        etot = etot + etxc + exxen
        !
        IF (okpaw) CALL PAW_potential(rho%bec, ddd_PAW, epaw,etot_cmp_paw)
        CALL set_vrs( vrs, vltot, v%of_r, kedtau, v%kin_r, dfftp%nnr, &
             nspin, doublegrid )
        !
     ELSE
        !
        ! fock1 is the exchange energy calculated for orbitals at step n,
        !       using orbitals at step n-1 in the expression of exchange
        !
        IF (use_ace) THEN
           fock1 = exxenergyace()
        ELSE
           fock1 = exxenergy2()
        ENDIF
        !
        ! Set new orbitals for the calculation of the exchange term
        !
        CALL exxinit(DoLoc)
        IF( DoLoc.and.gamma_only) THEN
          CALL localize_orbitals( )
        ELSE IF (DoLoc) THEN
          CALL localize_orbitals_k( )
        ENDIF 
        IF (use_ace) CALL aceinit ( DoLoc, fock3 )
        !
        ! fock2 is the exchange energy calculated for orbitals at step n,
        !       using orbitals at step n in the expression of exchange 
        ! fock0 is fock2 at previous step
        !
        fock0 = fock2
        IF (use_ace) THEN
           fock2 = exxenergyace()
        ELSE
           fock2 = exxenergy2()
        ENDIF
        !
        ! check for convergence. dexx is positive definite: if it isn't,
        ! there is some numerical problem. One such cause could be that
        ! the treatment of the divergence in exact exchange has failed. 
        ! FIXME: to be properly implemented for all cases
        !
!civn 
!       IF (use_ace .AND. (nspin == 1) .AND. gamma_only) THEN
        IF ( DoLoc ) THEN
          dexx =  0.5D0 * ((fock1-fock0)+(fock3-fock2)) 
        ELSE
          dexx = fock1 - 0.5D0*(fock0+fock2)
        ENDIF 
        !
        IF ( dexx < 0.0_dp ) THEN
           IF( Doloc ) THEN
              WRITE(stdout,'(5x,a,1e12.3)') "BEWARE: negative dexx:", dexx
              dexx = ABS ( dexx )
           ELSE
              CALL errore( 'electrons', 'dexx is negative! &
                   & Check that exxdiv_treatment is appropriate for the system,&
                   & or ecutfock may be too low', 1 )
           ENDIF
        ENDIF
        !
        !   remove the estimate exchange energy exxen used in the inner SCF
        !
        etot = etot + exxen + 0.5D0*fock2 - fock1
        hwf_energy = hwf_energy + exxen + 0.5D0*fock2 - fock1 ! [LP]
        exxen = 0.5D0*fock2 
        !
        IF ( dexx < tr2_final ) THEN
           WRITE( stdout, 9066 ) '!!', etot, hwf_energy
        ELSE
           WRITE( stdout, 9066 ) '  ', etot, hwf_energy
        ENDIF
        IF ( dexx>1.d-8 ) THEN
          WRITE( stdout, 9067 ) dexx
        ELSE
          WRITE( stdout, 9068 ) dexx
        ENDIF
        
        WRITE( stdout, 9062 ) - fock1
        IF (use_ace) THEN
           WRITE( stdout, 9063 ) 0.5D0*fock2
        ELSE
           WRITE( stdout, 9064 ) 0.5D0*fock2
        ENDIF
        !
        IF ( dexx < tr2_final ) THEN
           IF ( do_makov_payne ) CALL makov_payne( etot )
           WRITE( stdout, 9101 )
           RETURN
        ENDIF
        !
        IF ( adapt_thr ) THEN
           tr2 = MAX(tr2_multi * dexx, tr2_final)
           WRITE( stdout, 9121 ) tr2
        ENDIF
     ENDIF
     !
     WRITE( stdout,'(/5x,"EXX: now go back to refine exchange calculation")')
     !
     IF ( check_stop_now() ) THEN
        WRITE(stdout,'(5x,"Calculation (EXX) stopped after iteration #", &
                        & i6)') iter
        conv_elec=.FALSE.
        CALL seqopn (iunres, 'restart_e', 'formatted', exst)
        WRITE (iunres, *) iter, tr2, dexx
        WRITE (iunres, *) exxen, fock0, fock1, fock2
        ! FIXME: et and wg are written to xml file
        WRITE (iunres, *) (wg(1:nbnd,ik),ik=1,nks)
        WRITE (iunres, *) (et(1:nbnd,ik),ik=1,nks)
        CLOSE (unit=iunres, status='keep')
        RETURN
     ENDIF
     !
  ENDDO
  !
  WRITE( stdout, 9120 ) iter
  FLUSH( stdout )
  !
  RETURN
  !
  ! ... formats
  !
9062 FORMAT( '     - averaged Fock potential =',0PF17.8,' Ry' )
9063 FORMAT( '     + Fock energy (ACE)       =',0PF17.8,' Ry' )
9064 FORMAT( '     + Fock energy (full)      =',0PF17.8,' Ry' )
9066 FORMAT(/,A2,'   total energy              =',0PF17.8,' Ry' &
            /'     Harris-Foulkes estimate   =',0PF17.8,' Ry' )
9067 FORMAT('     est. exchange err (dexx)  =',0PF17.8,' Ry' )
9068 FORMAT('     est. exchange err (dexx)  =',1PE17.1,' Ry' )
9101 FORMAT(/'     EXX self-consistency reached' )
9120 FORMAT(/'     EXX convergence NOT achieved after ',i3,' iterations: stopping' )
9121 FORMAT(/'     scf convergence threshold =',1PE17.1,' Ry' )
  !
END SUBROUTINE qepy_electrons
!
!----------------------------------------------------------------------------
SUBROUTINE qepy_electrons_scf ( printout, exxen, embed)
  !----------------------------------------------------------------------------
  !! This routine is a driver of the self-consistent cycle.
  !! It uses the routine c_bands for computing the bands at fixed
  !! Hamiltonian, the routine sum_band to compute the charge density,
  !! the routine v_of_rho to compute the new potential and the routine
  !! mix_rho to mix input and output charge densities.
  !
  USE kinds,                ONLY : DP
  USE check_stop,           ONLY : check_stop_now, stopped_by_user
  USE io_global,            ONLY : stdout, ionode
  USE cell_base,            ONLY : at, bg, alat, omega, tpiba2
  USE ions_base,            ONLY : zv, nat, nsp, ityp, tau, compute_eextfor, atm
  USE basis,                ONLY : starting_pot
  USE bp,                   ONLY : lelfield
  USE fft_base,             ONLY : dfftp
  USE gvect,                ONLY : ngm, gstart, g, gg, gcutm
  USE gvecs,                ONLY : doublegrid, ngms
  USE klist,                ONLY : xk, wk, nelec, ngk, nks, nkstot, lgauss, &
                                   two_fermi_energies, tot_charge
  USE lsda_mod,             ONLY : lsda, nspin, magtot, absmag, isk
  USE vlocal,               ONLY : strf
  USE wvfct,                ONLY : nbnd, et
  USE gvecw,                ONLY : ecutwfc
  USE ener,                 ONLY : etot, hwf_energy, eband, deband, ehart, &
                                   vtxc, etxc, etxcc, ewld, demet, epaw, &
                                   elondon, edftd3, ef_up, ef_dw, exdm, ef
  USE scf,                  ONLY : scf_type, scf_type_COPY, bcast_scf_type,&
                                   create_scf_type, destroy_scf_type, &
                                   open_mix_file, close_mix_file, &
                                   rho, rho_core, rhog_core, v, vltot, vrs, &
                                   kedtau, vnew
  USE control_flags,        ONLY : mixing_beta, tr2, ethr, niter, nmix, &
                                   iprint, conv_elec, &
                                   restart, io_level, do_makov_payne,  &
                                   gamma_only, iverbosity, textfor,     &
                                   llondon, ldftd3, scf_must_converge, lxdm, ts_vdw
  USE control_flags,        ONLY : n_scf_steps, scf_error

  USE io_files,             ONLY : iunmix, output_drho
  USE ldaU,                 ONLY : eth, Hubbard_U, Hubbard_lmax, &
                                   niter_with_fixed_ns, lda_plus_u
  USE extfield,             ONLY : tefield, etotefield, gate, etotgatefield !TB
  USE noncollin_module,     ONLY : noncolin, magtot_nc, i_cons,  bfield, &
                                   lambda, report
  USE spin_orb,             ONLY : domag
  USE io_rho_xml,           ONLY : write_scf
  USE uspp,                 ONLY : okvan
  USE mp_bands,             ONLY : intra_bgrp_comm
  USE mp_pools,             ONLY : root_pool, me_pool, my_pool_id, &
                                   inter_pool_comm, intra_pool_comm
  USE mp,                   ONLY : mp_sum, mp_bcast
  !
  USE london_module,        ONLY : energy_london
  USE dftd3_api,            ONLY : dftd3_pbc_dispersion, &
                                   dftd3_init, dftd3_set_functional, &
                                   get_atomic_number, dftd3_input, &
                                   dftd3_calc
  USE dftd3_qe,             ONLY : dftd3, dftd3_in, energy_dftd3
  USE xdm_module,           ONLY : energy_xdm
  USE tsvdw_module,         ONLY : EtsvdW
  !
  USE paw_variables,        ONLY : okpaw, ddd_paw, total_core_energy, only_paw
  USE paw_onecenter,        ONLY : PAW_potential
  USE paw_symmetry,         ONLY : PAW_symmetrize_ddd
  USE dfunct,               ONLY : newd
  USE esm,                  ONLY : do_comp_esm, esm_printpot, esm_ewald
  USE fcp_variables,        ONLY : lfcpopt, lfcpdyn
  USE wrappers,             ONLY : memstat
  !
  USE plugin_variables,     ONLY : plugin_etot
  !
  USE qepy_common,          ONLY : embed_base
  !
  IMPLICIT NONE
  !
  INTEGER, INTENT (IN) :: printout
  !! * If printout>0, prints on output the total energy;
  !! * if printout>1, also prints decomposition into energy contributions.
  REAL(DP),INTENT (IN) :: exxen
  !! current estimate of the exchange energy
  type(embed_base), intent(inout)    :: embed
  !
  ! ... local variables
  !
  REAL(DP),save :: dr2
  !! the norm of the diffence between potential
  REAL(DP) :: charge
  !! the total charge
  REAL(DP) :: deband_hwf
  !! deband for the Harris-Weinert-Foulkes functional
  REAL(DP) :: mag
  !! local magnetization
  INTEGER :: i
  !! counter on polarization
  INTEGER :: idum
  !! dummy counter on iterations
  INTEGER,save :: iter
  !! counter on iterations
  INTEGER :: ios, kilobytes
  !
  REAL(DP) :: tr2_min
  !! estimated error on energy coming from diagonalization
  REAL(DP),save :: descf
  !! correction for variational energy
  REAL(DP) :: en_el=0.0_DP
  !! electric field contribution to the total energy
  REAL(DP) :: eext=0.0_DP
  !! external forces contribution to the total energy
  LOGICAL :: first, exst
  !! auxiliary variables for calculating and storing temporary copies of
  !! the charge density and of the HXC-potential
  !
  TYPE(scf_type),save :: rhoin
  !! used to store rho_in of current/next iteration
  !
  ! ... external functions
  !
  REAL(DP), EXTERNAL :: ewald, get_clock
  REAL(DP) :: etot_cmp_paw(nat,2,2)
  ! 
  REAL(DP) :: latvecs(3,3)
  !! auxiliary variables for grimme-d3
  INTEGER:: atnum(1:nat), na
  !! auxiliary variables for grimme-d3
  !
  INTEGER:: its
  !!
  REAL(DP) :: mixing_beta_new
  !qepy <-- add descf
  TYPE(scf_type),save :: rho_prev
  !! save the last step unmix density for descf
  REAL(DP) :: extene = 0.0_DP
  !! external energy
  LOGICAL :: add_descf
  !! add the descf to the total energy for last step
  !
  !
  add_descf = .FALSE.
  if ( embed%ldescf .and. embed%iterative .and. (.not. embed%initial) ) add_descf = .TRUE.
  if (embed%finish) goto 10
  if (embed%mix_coef>0.0_DP) goto 100
  !!! If we change some parts to functions will make the code clean.
  !!! But to keep the structure of the code, we add many goto functions.
  !qepy -->

  if (embed%initial) then
  embed%initial = .FALSE.
  iter = 0
  dr2  = 0.0_dp
  descf = 0.0_dp
  IF ( restart ) CALL restart_in_electrons( iter, dr2, ethr, et )
  !end if
  !
  WRITE( stdout, 9000 ) get_clock( 'PWSCF' )
  !
  CALL memstat( kilobytes )
  IF ( kilobytes > 0 ) WRITE( stdout, 9001 ) kilobytes/1000.0
  !
  CALL start_clock( 'electrons' )
  !
  FLUSH( stdout )
  !
  ! ... calculates the ewald contribution to total energy
  !
  !if (embed%initial) then
  if (embed%lewald) then
  IF ( do_comp_esm ) THEN
     ewld = esm_ewald()
  ELSE
     ewld = ewald( alat, nat, nsp, ityp, zv, at, bg, tau, &
                omega, g, gg, ngm, gcutm, gstart, gamma_only, strf )
  ENDIF
  endif
  if (iand(embed%exttype,1) == 1) then
     call qepy_setlocal(embed%exttype)
  endif
  !
  IF ( llondon ) THEN
     elondon = energy_london( alat , nat , ityp , at ,bg , tau )
  ELSE
     elondon = 0.d0
  ENDIF
  !
  ! Grimme-D3 correction to the energy
  !
  IF (ldftd3) THEN
     latvecs(:,:)=at(:,:)*alat
     tau(:,:)=tau(:,:)*alat
     DO na = 1, nat
        atnum(na) = get_atomic_number(TRIM(atm(ityp(na))))
     ENDDO
     call dftd3_pbc_dispersion(dftd3,tau,atnum,latvecs,energy_dftd3)
     edftd3=energy_dftd3*2.d0
     tau(:,:)=tau(:,:)/alat
  ELSE
     edftd3= 0.0
  ENDIF
  !
  !
  CALL create_scf_type( rhoin )
  !if (embed%ldescf) then
     CALL create_scf_type( rho_prev )
     CALL scf_type_COPY( rho, rho_prev )
  !endif
  !
  WRITE( stdout, 9002 )
  FLUSH( stdout )
  !
  CALL open_mix_file( iunmix, 'mix', exst )
  else
  dr2 = embed%dnorm
  end if ! if (embed%initial)
  !
  !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  !%%%%%%%%%%%%%%%%%%%%          iterate !          %%%%%%%%%%%%%%%%%%%%%
  !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  !
  CALL qepy_v_of_rho_all( rho, rho_core, rhog_core, &
     ehart, etxc, vtxc, eth, etotefield, charge, v, embed)

  if ( add_descf .and. embed%mix_coef<0.0_DP ) then
     descf = qepy_delta_escf(rho, rho_prev)
     goto 112
  endif
  if (.not. embed%ldescf) descf = 0._dp

113 DO idum = 1, niter
     !
     IF ( check_stop_now() ) THEN
        conv_elec=.FALSE.
        CALL save_in_electrons (iter, dr2, ethr, et )
        GO TO 10
     ENDIF
     iter = iter + 1
     !
     WRITE( stdout, 9010 ) iter, ecutwfc, mixing_beta
     !
     FLUSH( stdout )
     !
     ! ... Convergence threshold for iterative diagonalization is
     ! ... automatically updated during self consistency
     !
     IF ( iter > 1 ) THEN
        !
        IF ( iter == 2 ) ethr = 1.D-2
        ethr = MIN( ethr, 0.1D0*dr2 / MAX( 1.D0, nelec ) )
        ethr = MIN( ethr, embed%diag_conv)
        ! ... do not allow convergence threshold to become too small:
        ! ... iterative diagonalization may become unstable
        ethr = MAX( ethr, 1.D-13 )
        !
     ENDIF
     !
     first = ( iter == 1 )
     !
     if (first) ethr = MAX( ethr, 1.D-6 )
     !
     ! ... deband = - \sum_v <\psi_v | V_h + V_xc |\psi_v> is calculated a
     ! ... first time here using the input density and potential ( to be
     ! ... used to calculate the Harris-Weinert-Foulkes energy )
     !
     deband_hwf = delta_e()
     !
     ! ... save input density to rhoin
     !
     call scf_type_COPY( rho, rhoin )
     !
     scf_step: DO
        !
        ! ... tr2_min is set to an estimate of the error on the energy
        ! ... due to diagonalization - used only for the first scf iteration
        !
        tr2_min = 0.D0
        !
        IF ( first ) tr2_min = ethr*MAX( 1.D0, nelec ) 
        !
        ! ... diagonalization of the KS hamiltonian
        !
        IF ( lelfield ) THEN
           CALL c_bands_efield( iter )
        ELSE
           CALL c_bands( iter )
        ENDIF
        !
        IF ( stopped_by_user ) THEN
           conv_elec=.FALSE.
           CALL save_in_electrons( iter-1, dr2, ethr, et )
           GO TO 10
        ENDIF
        !
        ! ... xk, wk, isk, et, wg are distributed across pools;
        ! ... the first node has a complete copy of xk, wk, isk,
        ! ... while eigenvalues et and weights wg must be
        ! ... explicitly collected to the first node
        ! ... this is done here for et, in sum_band for wg
        !
        CALL poolrecover( et, nbnd, nkstot, nks )
        !
        ! ... the new density is computed here. For PAW:
        ! ... sum_band computes new becsum (stored in uspp modules)
        ! ... and a subtly different copy in rho%bec (scf module)
        !
        CALL sum_band()
        !
        ! ... the Harris-Weinert-Foulkes energy is computed here using only
        ! ... quantities obtained from the input density
        !
        hwf_energy = eband + deband_hwf + (etxc - etxcc) + ewld + ehart + demet
        If ( okpaw ) hwf_energy = hwf_energy + epaw
        IF ( lda_plus_u ) hwf_energy = hwf_energy + eth
        !
        IF ( lda_plus_u )  THEN
           !
           IF ( iverbosity > 0 .OR. first ) THEN
              IF (noncolin) THEN
                 CALL write_ns_nc()
              ELSE
                 CALL write_ns()
              ENDIF
           ENDIF
           !
           IF ( first .AND. starting_pot == 'atomic' ) THEN
              CALL ns_adj()
              IF (noncolin) THEN
                 rhoin%ns_nc = rho%ns_nc
              ELSE
                 rhoin%ns = rho%ns
              ENDIF
           ENDIF
           IF ( iter <= niter_with_fixed_ns ) THEN
              WRITE( stdout, '(/,5X,"RESET ns to initial values (iter <= mixing_fixed_ns)",/)')
              IF (noncolin) THEN
                 rho%ns_nc = rhoin%ns_nc
              ELSE
                 rho%ns = rhoin%ns
              ENDIF
           ENDIF
           !
        ENDIF
        !
        ! ... calculate total and absolute magnetization
        !
        IF ( lsda .OR. noncolin ) CALL compute_magnetization()
        !
        ! ... eband  = \sum_v \epsilon_v    is calculated by sum_band
        ! ... deband = - \sum_v <\psi_v | V_h + V_xc |\psi_v>
        ! ... eband + deband = \sum_v <\psi_v | T + Vion |\psi_v>
        !
        deband = delta_e()
        !
100     if ( embed%iterative ) then
           if (iter > 1 .and. (embed%mix_coef<0.0_DP)) then
              ! from second step directly return new density without mixing
              goto 111
           endif
        end if
        !
        !
        ! ... mix_rho mixes several quantities: rho in g-space, tauk (for
        ! ... meta-gga), ns and ns_nc (for lda+u) and becsum (for paw)
        ! ... The mixing could in principle be done on pool 0 only, but
        ! ... mix_rho contains a call to rho_ddot that in the PAW case
        ! ... is parallelized on the entire image
        !
        ! IF ( my_pool_id == root_pool ) 
        !
        if (embed%mix_coef>0.0_DP) then
           mixing_beta_new = embed%mix_coef
        else
           mixing_beta_new = mixing_beta
        endif
        if ( iter==1 .and. (embed%mix_coef>0.0_DP)) then
           if ( abs(mixing_beta_new-mixing_beta)>1E-6) then
              ! the mixing difference, so restart the mixing
              CALL close_mix_file( iunmix, 'delete' )
              CALL open_mix_file( iunmix, 'mix', exst )
              CALL scf_type_COPY( rho_prev, rhoin)
           else
              ! the first step already mixing, so do nothing
              if (embed%ldescf) CALL scf_type_COPY( rho, rho_prev )
              CALL scf_type_COPY( rhoin, rho )
              goto 111
           endif
        end if
        !
        CALL mix_rho( rho, rhoin, mixing_beta_new, dr2, tr2_min, iter, nmix, &
                      iunmix, conv_elec )
        !
        ! ... Results are broadcast from pool 0 to others to prevent trouble
        ! ... on machines unable to yield the same results for the same 
        ! ... calculations on the same data, performed on different procs
        !
        IF ( lda_plus_u )  THEN
           ! ... For LDA+U, ns and ns_nc are also broadcast inside each pool
           ! ... to ensure consistency on all processors of all pools
           IF (noncolin) THEN
              CALL mp_bcast( rhoin%ns_nc, root_pool, intra_pool_comm )
           ELSE
              CALL mp_bcast( rhoin%ns, root_pool, intra_pool_comm )
           ENDIF
        ENDIF
        !
        CALL bcast_scf_type( rhoin, root_pool, inter_pool_comm )
        CALL mp_bcast( dr2, root_pool, inter_pool_comm )
        CALL mp_bcast( conv_elec, root_pool, inter_pool_comm )
        !
        IF (.NOT. scf_must_converge .AND. idum == niter) conv_elec = .TRUE.
        !
        ! ... if convergence is achieved or if the self-consistency error
        ! ... (dr2) is smaller than the estimated error due to diagonalization
        ! ... (tr2_min), rhoin and rho are unchanged: rhoin contains the input
        ! ... density and rho contains the output density.
        ! ... In all other cases, rhoin contains the mixed charge density 
        ! ... (the new input density) while rho is unchanged
        !
        IF ( first .and. nat > 0) THEN
           !
           ! ... first scf iteration: check if the threshold on diagonalization
           ! ... (ethr) was small enough wrt the error in self-consistency (dr2)
           ! ... if not, perform a new diagonalization with reduced threshold
           !
           first = .FALSE.
           !
           IF ( dr2 < tr2_min ) THEN
              !
              WRITE( stdout, '(/,5X,"Threshold (ethr) on eigenvalues was ", &
                               &    "too large:",/,5X,                      &
                               & "Diagonalizing with lowered threshold",/)' )
              !
              ethr = 0.1D0*dr2 / MAX( 1.D0, nelec )
              !
              !qepy <--
              ethr = MAX( ethr, 1.D-13 )
              CALL scf_type_COPY( rho_prev, rhoin)
              CALL close_mix_file( iunmix, 'delete' )
              CALL open_mix_file( iunmix, 'mix', exst )
              !qepy -->
              CYCLE scf_step
              !
           ENDIF
           !
        ENDIF
        !-----------------------------------------------------------------------
        if ( embed%iterative ) then
           IF ( embed%exttype==0 .and. conv_elec ) THEN
              embed%finish = .TRUE.
           ELSEIF ( iter==1 .and. (embed%mix_coef<0.0_DP)) then
              ! first step directly return without mixing
              goto 111
           ELSE
              if (embed%ldescf) CALL scf_type_COPY( rho, rho_prev )
              CALL scf_type_COPY( rhoin, rho )
              goto 111
           ENDIF
        end if
        !-----------------------------------------------------------------------
        !
        IF ( .NOT. conv_elec ) THEN
           !
           ! ... no convergence yet: calculate new potential from mixed
           ! ... charge density (i.e. the new estimate)
           !
           CALL qepy_v_of_rho_all( rhoin, rho_core, rhog_core, &
              ehart, etxc, vtxc, eth, etotefield, charge, v, embed)
           !CALL v_of_rho( rhoin, rho_core, rhog_core, &
           !               ehart, etxc, vtxc, eth, etotefield, charge, v)
           !!
           !IF (okpaw) THEN
           !   CALL PAW_potential( rhoin%bec, ddd_paw, epaw,etot_cmp_paw )
           !   CALL PAW_symmetrize_ddd( ddd_paw )
           !ENDIF
           !
           ! ... estimate correction needed to have variational energy:
           ! ... T + E_ion (eband + deband) are calculated in sum_band
           ! ... and delta_e using the output charge density rho;
           ! ... E_H (ehart) and E_xc (etxc) are calculated in v_of_rho
           ! ... above, using the mixed charge density rhoin%of_r.
           ! ... delta_escf corrects for this difference at first order
           !
           !descf = delta_escf()
           descf = qepy_delta_escf(rhoin, rho)
           !
           ! ... now copy the mixed charge density in R- and G-space in rho
           !
           CALL scf_type_COPY( rhoin, rho )
           !
        ELSE 
           !
           ! ... convergence reached:
           ! ... 1) the output HXC-potential is saved in v
           ! ... 2) vnew contains V(out)-V(in) ( used to correct the forces ).
           !
           vnew%of_r(:,:) = v%of_r(:,:)
           !CALL v_of_rho( rho,rho_core,rhog_core, &
           !           ehart, etxc, vtxc, eth, etotefield, charge, v)
           CALL qepy_v_of_rho_all( rho, rho_core, rhog_core, &
              ehart, etxc, vtxc, eth, etotefield, charge, v, embed)
           vnew%of_r(:,:) = v%of_r(:,:) - vnew%of_r(:,:)
           !
           !IF (okpaw) THEN
           !   CALL PAW_potential( rho%bec, ddd_paw, epaw, etot_cmp_paw )
           !   CALL PAW_symmetrize_ddd( ddd_paw )
           !ENDIF
           !
           ! ... note that rho is here the output, not mixed, charge density
           ! ... so correction for variational energy is no longer needed
           !
           descf = 0._dp
           !
        ENDIF 
        !
        ! ... if we didn't cycle before we can exit the do-loop
        !
        EXIT scf_step
        !
     ENDDO scf_step
     !
     !plugin_etot = 0.0_dp
     !
     !CALL plugin_scf_energy(plugin_etot,rhoin)
     !!
     !CALL plugin_scf_potential(rhoin,conv_elec,dr2,vltot)
     !!
     !! ... define the total local potential (external + scf)
     !!
     !CALL sum_vrs( dfftp%nnr, nspin, vltot, v%of_r, vrs )
     !!
     !! ... interpolate the total local potential
     !!
     !CALL interpolate_vrs( dfftp%nnr, nspin, doublegrid, kedtau, v%kin_r, vrs )
     !!
     !! ... in the US case we have to recompute the self-consistent
     !! ... term in the nonlocal potential
     !! ... PAW: newd contains PAW updates of NL coefficients
     !!
     !CALL newd()
     !
     IF ( lelfield ) en_el =  calc_pol ( )
     !
     IF ( ( MOD(iter,report) == 0 ) .OR. ( report /= 0 .AND. conv_elec ) ) THEN
        !
        IF ( (noncolin .AND. domag) .OR. i_cons==1 .OR. nspin==2) CALL report_mag()
        !
     ENDIF
     !
     WRITE( stdout, 9000 ) get_clock( 'PWSCF' )
     !
111  IF ( conv_elec ) WRITE( stdout, 9101 )
 
     IF ( conv_elec ) THEN 
           scf_error = dr2
           n_scf_steps = iter
     ENDIF  

     !
     if ( embed%iterative ) then
        if ( embed%mix_coef < 0.0_DP ) return
        if ( add_descf .and. (.not. conv_elec) ) return
     endif
     !
112  IF ( conv_elec .OR. MOD( iter, iprint ) == 0 ) THEN
        !
        IF ( lda_plus_U .AND. iverbosity == 0 ) THEN
           IF (noncolin) THEN
              CALL write_ns_nc()
           ELSE
              CALL write_ns()
           ENDIF
        ENDIF
        CALL print_ks_energies()
        !
     ENDIF
     !
     if (embed%exttype<1 .and. (.not. embed%iterative) ) then
     IF ( ABS( charge - nelec ) / charge > 1.D-7 ) THEN
        WRITE( stdout, 9050 ) charge, nelec
        IF ( ABS( charge - nelec ) / charge > 1.D-3 ) THEN
           IF (.not.lgauss) THEN
              CALL errore( 'electrons', 'charge is wrong: smearing is needed', 1 )
           ELSE
              CALL errore( 'electrons', 'charge is wrong', 1 )
           ENDIF
        ENDIF
     ENDIF
     endif
     !
     etot = eband + ( etxc - etxcc ) + ewld + ehart + deband + demet + descf
     ! for hybrid calculations, add the current estimate of exchange energy
     ! (it will subtracted later if exx_is_active to be replaced with a better estimate)
     etot = etot - exxen
     hwf_energy = hwf_energy - exxen ! [LP]
     !
     IF (okpaw) etot = etot + epaw
     IF ( lda_plus_u ) etot = etot + eth
     !
     IF ( lelfield ) etot = etot + en_el
     ! not sure about the HWF functional in the above case
     IF( textfor ) THEN
        eext = alat*compute_eextfor()
        etot = etot + eext
        hwf_energy = hwf_energy + eext
     ENDIF
     IF (llondon) THEN
        etot = etot + elondon
        hwf_energy = hwf_energy + elondon
     ENDIF
     !
     ! grimme-d3 dispersion energy
     IF (ldftd3) THEN
        etot = etot + edftd3
        hwf_energy = hwf_energy + edftd3
     ENDIF
     !
     ! calculate the xdm energy contribution with converged density
     IF (lxdm .and. conv_elec) THEN
        exdm = energy_xdm()  
        etot = etot + exdm
        hwf_energy = hwf_energy + exdm
     ENDIF
     IF (ts_vdw) THEN
        ! factor 2 converts from Ha to Ry units
        etot = etot + 2.0d0*EtsvdW
        hwf_energy = hwf_energy + 2.0d0*EtsvdW
     ENDIF
     !
     IF ( tefield ) THEN
        etot = etot + etotefield
        hwf_energy = hwf_energy + etotefield
     ENDIF
     ! TB gate energy
     IF ( gate) THEN
        etot = etot + etotgatefield
        hwf_energy = hwf_energy + etotgatefield
     ENDIF
     !
     IF ( lfcpopt .or. lfcpdyn ) THEN
        etot = etot + ef * tot_charge
        hwf_energy = hwf_energy + ef * tot_charge
     ENDIF
     !
     ! ... adds possible external contribution from plugins to the energy
     !
     etot = etot + plugin_etot 
     !
     !qepy --> add extene
     hwf_energy = hwf_energy + plugin_etot
     extene = embed%extene
     IF (abs(extene)<1.D-15) THEN
        IF (ALLOCATED(embed%extpot)) THEN
           extene = sum(embed%extpot(:,:)*rho%of_r(:,:)) * omega / ( dfftp%nr1*dfftp%nr2*dfftp%nr3 )
        ELSE
           extene = 0.0_DP
        ENDIF
#if defined(__MPI)
        CALL mp_sum( extene,  intra_bgrp_comm )
#endif
     ENDIF
     etot = etot + extene
     hwf_energy = hwf_energy + extene
     !qepy <-- add extene
     !
     CALL print_energies ( printout )
     IF ( ( conv_elec .OR. MOD(iter,iprint) == 0 ) .AND. printout > 1 ) THEN
        IF (abs(extene)>1.D-15) WRITE ( stdout , '(A,F17.8,A)') &
           '     external contribution     =',extene,' Ry'
     ENDIF
     !call qepy_calc_energies(etot, exttype)
     embed%etotal=etot
     embed%dnorm = dr2
     !
     if ( embed%iterative ) then
        if ( add_descf .and. embed%mix_coef<0.0_DP ) then
           ! back to run diagonalize
           goto 113
        else
           return
        endif
     endif
     !
     IF ( conv_elec ) THEN
        !
        ! ... if system is charged add a Makov-Payne correction to the energy
        ! ... (not in case of hybrid functionals: it is added at the end)
        !
        IF ( do_makov_payne .AND. printout/= 0 ) CALL makov_payne( etot )
        !
        ! ... print out ESM potentials if desired
        !
        IF ( do_comp_esm ) CALL esm_printpot( rho%of_g )
        !
        WRITE( stdout, 9110 ) iter
        !
        ! ... jump to the end
        !
        GO TO 10
        !
     ENDIF
     !
     ! ... uncomment the following line if you wish to monitor the evolution
     ! ... of the force calculation during self-consistency
     !
     !CALL forces()
     !
     ! ... it can be very useful to track internal clocks during
     ! ... self-consistency for benchmarking purposes
#if defined(__PW_TRACK_ELECTRON_STEPS)
     CALL print_clock_pw()
#endif
     !
  ENDDO
  n_scf_steps = iter
  scf_error = dr2
  !
  WRITE( stdout, 9101 )
  WRITE( stdout, 9120 ) iter
  !
10  FLUSH( stdout )
  !qepy <--
  n_scf_steps = iter
  scf_error = dr2
  embed%etotal= etot
  embed%dnorm = dr2
  !qepy -->
  !
  ! ... exiting: write (unless disabled) the charge density to file
  ! ... (also write ldaU ns coefficients and PAW becsum)
  !
  IF ( io_level > -1 ) CALL write_scf( rho, nspin )
  !
  ! ... delete mixing info if converged, keep it if not
  !
  IF ( embed%finish) conv_elec = .true.
  IF ( conv_elec ) THEN
     CALL close_mix_file( iunmix, 'delete' )
  ELSE
     CALL close_mix_file( iunmix, 'keep' )
  ENDIF
  !
  IF ( output_drho /= ' ' ) CALL remove_atomic_rho()
  call destroy_scf_type ( rhoin )
  !if (embed%ldescf) then
     CALL destroy_scf_type( rho_prev )
  !endif
  CALL stop_clock( 'electrons' )
  !
  !qepy <-- reset embed
  embed%initial = .TRUE.
  embed%finish = .FALSE.
  embed%mix_coef = -1.0
  !qepy -->
  RETURN
  !
  ! ... formats
  !
9000 FORMAT(/'     total cpu time spent up to now is ',F10.1,' secs' )
9001 FORMAT(/'     per-process dynamical memory: ',f7.1,' Mb' )
9002 FORMAT(/'     Self-consistent Calculation' )
9010 FORMAT(/'     iteration #',I3,'     ecut=', F9.2,' Ry',5X,'beta=',F5.2 )
9050 FORMAT(/'     WARNING: integrated charge=',F15.8,', expected=',F15.8 )
9101 FORMAT(/'     End of self-consistent calculation' )
9110 FORMAT(/'     convergence has been achieved in ',i3,' iterations' )
9120 FORMAT(/'     convergence NOT achieved after ',i3,' iterations: stopping' )
  !
  CONTAINS
     !
     !-----------------------------------------------------------------------
     SUBROUTINE compute_magnetization()
       !-----------------------------------------------------------------------
       !
       IMPLICIT NONE
       !
       INTEGER :: ir
       !
       !
       IF ( lsda ) THEN
          !
          magtot = 0.D0
          absmag = 0.D0
          !
          DO ir = 1, dfftp%nnr
             !
             mag = rho%of_r(ir,2)
             !
             magtot = magtot + mag
             absmag = absmag + ABS( mag )
             !
          ENDDO
          !
          magtot = magtot * omega / ( dfftp%nr1*dfftp%nr2*dfftp%nr3 )
          absmag = absmag * omega / ( dfftp%nr1*dfftp%nr2*dfftp%nr3 )
          !
          CALL mp_sum( magtot, intra_bgrp_comm )
          CALL mp_sum( absmag, intra_bgrp_comm )
          !
          IF (two_fermi_energies.and.lgauss) bfield(3)=0.5D0*(ef_up-ef_dw)
          !
       ELSEIF ( noncolin ) THEN
          !
          magtot_nc = 0.D0
          absmag    = 0.D0
          !
          DO ir = 1,dfftp%nnr
             !
             mag = SQRT( rho%of_r(ir,2)**2 + &
                         rho%of_r(ir,3)**2 + &
                         rho%of_r(ir,4)**2 )
             !
             DO i = 1, 3
                !
                magtot_nc(i) = magtot_nc(i) + rho%of_r(ir,i+1)
                !
             ENDDO
             !
             absmag = absmag + ABS( mag )
             !
          ENDDO
          !
          CALL mp_sum( magtot_nc, intra_bgrp_comm )
          CALL mp_sum( absmag, intra_bgrp_comm )
          !
          DO i = 1, 3
             !
             magtot_nc(i) = magtot_nc(i) * omega / ( dfftp%nr1*dfftp%nr2*dfftp%nr3 )
             !
          ENDDO
          !
          absmag = absmag * omega / ( dfftp%nr1*dfftp%nr2*dfftp%nr3 )
          !
       ENDIF
       !
       RETURN
       !
     END SUBROUTINE compute_magnetization
     !
     !-----------------------------------------------------------------------
     FUNCTION delta_e()
       !-----------------------------------------------------------------------
       !! This function computes \(\textrm{delta_e}\), where:
       !
       !! $$\begin{alignat*}{2} \text{delta}\_\text{e} &= - \int\text{rho}\%\text{of}\_\text{r(r)}\cdot 
       !!                                                           \text{v}\%\text{of}\_\text{r(r)} && \\
       !!                          &= - \int \text{rho}\%\text{kin}\_\text{r(r)}\cdot \text{v}\%\text{kin}\_
       !!                                                           \text{r(r)} && \text{[for Meta-GGA]} \\
       !!                          &= - \sum \text{rho}\%\text{ns}\cdot \text{v}\%\text{ns} && 
       !!                                                                               \text{[for LDA+U]}\\
       !!                          &= - \sum \text{becsum}\cdot \text{D1}\_\text{Hxc} && \text{[for PAW]}
       !!                                                                                  \end{alignat*} $$
       !
       ! ... delta_e =  - \int rho%of_r(r)  v%of_r(r)
       !                - \int rho%kin_r(r) v%kin_r(r) [for Meta-GGA]
       !                - \sum rho%ns       v%ns       [for LDA+U]
       !                - \sum becsum       D1_Hxc     [for PAW]
       !
       USE funct,  ONLY : dft_is_meta
       !
       IMPLICIT NONE
       !
       REAL(DP) :: delta_e
       REAL(DP) :: delta_e_hub
       INTEGER  :: ir
       !
       delta_e = 0._DP
       IF ( nspin==2 ) THEN
          !
          DO ir = 1,dfftp%nnr
            delta_e = delta_e - ( rho%of_r(ir,1) + rho%of_r(ir,2) ) * v%of_r(ir,1) &  ! up
                              - ( rho%of_r(ir,1) - rho%of_r(ir,2) ) * v%of_r(ir,2)    ! dw
          ENDDO 
          delta_e = 0.5_DP*delta_e
          !
       ELSE
          delta_e = - SUM( rho%of_r(:,:)*v%of_r(:,:) )
       ENDIF
       !
       IF ( dft_is_meta() ) &
          delta_e = delta_e - SUM( rho%kin_r(:,:)*v%kin_r(:,:) )
       !
       delta_e = omega * delta_e / ( dfftp%nr1*dfftp%nr2*dfftp%nr3 )
       !
       CALL mp_sum( delta_e, intra_bgrp_comm )
       !
       IF (lda_plus_u) THEN
         IF (noncolin) THEN
           delta_e_hub = - SUM( rho%ns_nc(:,:,:,:)*v%ns_nc(:,:,:,:) )
           delta_e = delta_e + delta_e_hub
         ELSE
           delta_e_hub = - SUM( rho%ns(:,:,:,:)*v%ns(:,:,:,:) )
           IF (nspin==1) delta_e_hub = 2.d0 * delta_e_hub
           delta_e = delta_e + delta_e_hub
         ENDIF
       ENDIF
       !
       IF (okpaw) delta_e = delta_e - SUM( ddd_paw(:,:,:)*rho%bec(:,:,:) )
       !
       RETURN
       !
     END FUNCTION delta_e
     !
     !-----------------------------------------------------------------------
     FUNCTION qepy_delta_escf(rhoin, rho)
       !-----------------------------------------------------------------------
       !! This function calculates the difference between the Hartree and XC energy
       !! at first order in the charge density difference \(\textrm{delta_rho(r)}\):
       !
       !! $$\begin{alignat*}{2} \text{delta}\_\text{escf} &= - \int\text{rho}\%\text{of}\_\text{r(r)}\cdot
       !!                                                              \text{v}\%\text{of}\_\text{r(r)} && \\
       !!                          &= - \int \text{rho}\%\text{kin}\_\text{r(r)}\cdot \text{v}\%\text{kin}\_
       !!                                                              \text{r(r)} && \text{[for Meta-GGA]} \\
       !!                          &= - \sum \text{rho}\%\text{ns}\cdot \text{v}\%\text{ns} && 
       !!                                                                                \text{[for LDA+U]} \\
       !!                          &= - \sum \text{becsum}\cdot \text{D1} && \text{[for PAW]} \end{alignat*} $$
       !
       ! ... delta_escf = - \int \delta rho%of_r(r)  v%of_r(r)
       !                  - \int \delta rho%kin_r(r) v%kin_r(r) [for Meta-GGA]
       !                  - \sum \delta rho%ns       v%ns       [for LDA+U]
       !                  - \sum \delta becsum       D1         [for PAW] 
       !
       USE funct,  ONLY : dft_is_meta
       IMPLICIT NONE
       REAL(DP) :: delta_escf, delta_escf_hub, rho_dif(2)
       INTEGER  :: ir
       !
       TYPE(scf_type) :: rhoin, rho
       REAL(DP) :: qepy_delta_escf
       !
       delta_escf=0._dp
       IF ( nspin==2 ) THEN
          !
          DO ir=1, dfftp%nnr
             !
             rho_dif = rhoin%of_r(ir,:) - rho%of_r(ir,:)
             !
             delta_escf = delta_escf - ( rho_dif(1) + rho_dif(2) ) * v%of_r(ir,1) &  !up
                                     - ( rho_dif(1) - rho_dif(2) ) * v%of_r(ir,2)    !dw
          ENDDO
          delta_escf = 0.5_dp*delta_escf
          !
       ELSE
         delta_escf = -SUM( ( rhoin%of_r(:,:)-rho%of_r(:,:) )*v%of_r(:,:) )
       ENDIF
       !
       IF ( dft_is_meta() ) &
          delta_escf = delta_escf - &
                       SUM( (rhoin%kin_r(:,:)-rho%kin_r(:,:) )*v%kin_r(:,:))
       !
       delta_escf = omega * delta_escf / ( dfftp%nr1*dfftp%nr2*dfftp%nr3 )
       !
       CALL mp_sum( delta_escf, intra_bgrp_comm )
       !
       IF ( lda_plus_u ) THEN
         IF ( noncolin ) THEN
           delta_escf_hub = -SUM((rhoin%ns_nc(:,:,:,:)-rho%ns_nc(:,:,:,:))*v%ns_nc(:,:,:,:))
           delta_escf = delta_escf + delta_escf_hub
         ELSE
           delta_escf_hub = -SUM((rhoin%ns(:,:,:,:)-rho%ns(:,:,:,:))*v%ns(:,:,:,:))
           IF ( nspin==1 ) delta_escf_hub = 2.d0 * delta_escf_hub
           delta_escf = delta_escf + delta_escf_hub
         ENDIF
       ENDIF

       IF ( okpaw ) delta_escf = delta_escf - &
                                 SUM(ddd_paw(:,:,:)*(rhoin%bec(:,:,:)-rho%bec(:,:,:)))

       qepy_delta_escf = delta_escf
       RETURN
       !
     END FUNCTION qepy_delta_escf
     !
     !-----------------------------------------------------------------------
     FUNCTION calc_pol( ) RESULT ( en_el )
       !-----------------------------------------------------------------------
       !
       USE kinds,     ONLY : DP
       USE constants, ONLY : pi
       USE bp,        ONLY : lelfield, ion_pol, el_pol, fc_pol, l_el_pol_old, &
                             el_pol_acc, el_pol_old, efield, l3dstring, gdir, &
                             transform_el, efield_cart
       !
       IMPLICIT NONE
       REAL (DP) :: en_el
       !
       INTEGER :: i, j 
       REAL(DP):: sca, el_pol_cart(3),  el_pol_acc_cart(3)
       !
       IF (.NOT.l3dstring) THEN
          !
          CALL c_phase_field( el_pol(gdir), ion_pol(gdir), fc_pol(gdir), gdir )
          !
          IF (.NOT.l_el_pol_old) THEN
             l_el_pol_old = .TRUE.
             el_pol_old(gdir) = el_pol(gdir)
             en_el = -efield*(el_pol(gdir)+ion_pol(gdir))
             el_pol_acc(gdir) = 0.d0
          ELSE
             sca = (el_pol(gdir)-el_pol_old(gdir))/fc_pol(gdir)
             IF (sca < - pi) THEN
                el_pol_acc(gdir) = el_pol_acc(gdir)+2.d0*pi*fc_pol(gdir)
             ELSEIF (sca > pi) THEN
                el_pol_acc(gdir) = el_pol_acc(gdir)-2.d0*pi*fc_pol(gdir)
             ENDIF
             en_el = -efield*(el_pol(gdir)+ion_pol(gdir)+el_pol_acc(gdir))
             el_pol_old = el_pol
          ENDIF
          !
       ELSE
          !
          DO i = 1, 3
            CALL c_phase_field( el_pol(i), ion_pol(i), fc_pol(i), i )
          ENDDO
          el_pol_cart(:) = 0.d0
          DO i = 1, 3
             DO j = 1, 3
                !el_pol_cart(i)=el_pol_cart(i)+transform_el(j,i)*el_pol(j)
                el_pol_cart(i) = el_pol_cart(i)+at(i,j)*el_pol(j) / &
                                 (SQRT(at(1,j)**2.d0+at(2,j)**2.d0+at(3,j)**2.d0))
             ENDDO
          ENDDO
          !
          WRITE( stdout,'( "Electronic Dipole on Cartesian axes" )' )
          DO i = 1, 3
             WRITE(stdout,*) i, el_pol_cart(i)
          ENDDO
          !
          WRITE( stdout,'( "Ionic Dipole on Cartesian axes" )' )
          DO i = 1, 3
             WRITE(stdout,*) i, ion_pol(i)
          ENDDO
          !
          IF (.NOT.l_el_pol_old) THEN
             l_el_pol_old = .TRUE.
             el_pol_old(:) = el_pol(:)
             en_el = 0.d0
             DO i = 1, 3
                en_el = en_el-efield_cart(i)*(el_pol_cart(i)+ion_pol(i))
             ENDDO
             el_pol_acc(:) = 0.d0
          ELSE
             DO i = 1, 3
                sca = (el_pol(i)-el_pol_old(i))/fc_pol(i)
                IF (sca < - pi) THEN
                   el_pol_acc(i) = el_pol_acc(i)+2.d0*pi*fc_pol(i)
                ELSEIF (sca > pi) THEN
                   el_pol_acc(i) = el_pol_acc(i)-2.d0*pi*fc_pol(i)
                ENDIF
             ENDDO
             el_pol_acc_cart(:) = 0.d0
             DO i = 1, 3
                DO j = 1, 3
                   el_pol_acc_cart(i) = el_pol_acc_cart(i)+transform_el(j,i)*el_pol_acc(j)
                ENDDO
             ENDDO
             en_el = 0.d0
             DO i = 1, 3
                en_el = en_el-efield_cart(i)*(el_pol_cart(i)+ion_pol(i)+el_pol_acc_cart(i))
             ENDDO
             el_pol_old(:) = el_pol(:)
          ENDIF
          !
       ENDIF
       !
     END FUNCTION calc_pol
     !
     !-----------------------------------------------------------------------
     SUBROUTINE print_energies ( printout )
       !-----------------------------------------------------------------------
       !
       USE constants, ONLY : eps8
       INTEGER, INTENT (IN) :: printout
       !
   
       IF ( printout == 0 ) RETURN
       IF ( ( conv_elec .OR. MOD(iter,iprint) == 0 ) .AND. printout > 1 ) THEN
          !
          IF ( dr2 > eps8 ) THEN
             WRITE( stdout, 9081 ) etot, hwf_energy, dr2
          ELSE
             WRITE( stdout, 9083 ) etot, hwf_energy, dr2
          ENDIF
          IF ( only_paw ) WRITE( stdout, 9085 ) etot+total_core_energy
          !
          WRITE( stdout, 9060 ) &
               ( eband + deband ), ehart, ( etxc - etxcc ), ewld
          !
          IF ( llondon ) WRITE ( stdout , 9074 ) elondon
          IF ( ldftd3 )  WRITE ( stdout , 9078 ) edftd3
          IF ( lxdm )    WRITE ( stdout , 9075 ) exdm
          IF ( ts_vdw )  WRITE ( stdout , 9076 ) 2.0d0*EtsvdW
          IF ( textfor)  WRITE ( stdout , 9077 ) eext
          IF ( tefield )            WRITE( stdout, 9061 ) etotefield
          IF ( gate )               WRITE( stdout, 9062 ) etotgatefield ! TB
          IF ( lda_plus_u )         WRITE( stdout, 9065 ) eth
          IF ( ABS (descf) > eps8 ) WRITE( stdout, 9069 ) descf
          IF ( okpaw ) THEN
            WRITE( stdout, 9067 ) epaw
            ! Detailed printout of PAW energy components, if verbosity is high
            IF(iverbosity>0)THEN
            WRITE( stdout, 9068) SUM(etot_cmp_paw(:,1,1)), &
                                 SUM(etot_cmp_paw(:,1,2)), &
                                 SUM(etot_cmp_paw(:,2,1)), &
                                 SUM(etot_cmp_paw(:,2,2)), &
            SUM(etot_cmp_paw(:,1,1))+SUM(etot_cmp_paw(:,1,2))+ehart, &
            SUM(etot_cmp_paw(:,2,1))+SUM(etot_cmp_paw(:,2,2))+etxc-etxcc
            ENDIF
          ENDIF
          !
          ! ... With Fermi-Dirac population factor, etot is the electronic
          ! ... free energy F = E - TS , demet is the -TS contribution
          !
          IF ( lgauss ) WRITE( stdout, 9070 ) demet
          !
          ! ... With Fictitious charge particle (FCP), etot is the grand
          ! ... potential energy Omega = E - muN, -muN is the potentiostat
          ! ... contribution.
          !
          IF ( lfcpopt .OR. lfcpdyn ) WRITE( stdout, 9072 ) ef*tot_charge
          !
       ELSE IF ( conv_elec ) THEN
          !
          IF ( dr2 > eps8 ) THEN
             WRITE( stdout, 9081 ) etot, hwf_energy, dr2
          ELSE
             WRITE( stdout, 9083 ) etot, hwf_energy, dr2
          ENDIF
          !
       ELSE
          !
          IF ( dr2 > eps8 ) THEN
             WRITE( stdout, 9080 ) etot, hwf_energy, dr2
          ELSE
             WRITE( stdout, 9082 ) etot, hwf_energy, dr2
          ENDIF
       ENDIF
       !
       CALL plugin_print_energies()
       !
       IF ( lsda ) WRITE( stdout, 9017 ) magtot, absmag
       !
       IF ( noncolin .AND. domag ) &
            WRITE( stdout, 9018 ) magtot_nc(1:3), absmag
       !
       IF ( i_cons == 3 .OR. i_cons == 4 )  &
            WRITE( stdout, 9071 ) bfield(1), bfield(2), bfield(3)
       IF ( i_cons /= 0 .AND. i_cons < 4 ) &
            WRITE( stdout, 9073 ) lambda
       !
       FLUSH( stdout )
       !
       RETURN
       !
9017 FORMAT(/'     total magnetization       =', F9.2,' Bohr mag/cell', &
            /'     absolute magnetization    =', F9.2,' Bohr mag/cell' )
9018 FORMAT(/'     total magnetization       =',3F9.2,' Bohr mag/cell' &
       &   ,/'     absolute magnetization    =', F9.2,' Bohr mag/cell' )
9060 FORMAT(/'     The total energy is the sum of the following terms:',/,&
            /'     one-electron contribution =',F17.8,' Ry' &
            /'     hartree contribution      =',F17.8,' Ry' &
            /'     xc contribution           =',F17.8,' Ry' &
            /'     ewald contribution        =',F17.8,' Ry' )
9061 FORMAT( '     electric field correction =',F17.8,' Ry' )
9062 FORMAT( '     gate field correction     =',F17.8,' Ry' ) ! TB
9065 FORMAT( '     Hubbard energy            =',F17.8,' Ry' )
9067 FORMAT( '     one-center paw contrib.   =',F17.8,' Ry' )
9068 FORMAT( '      -> PAW hartree energy AE =',F17.8,' Ry' &
            /'      -> PAW hartree energy PS =',F17.8,' Ry' &
            /'      -> PAW xc energy AE      =',F17.8,' Ry' &
            /'      -> PAW xc energy PS      =',F17.8,' Ry' &
            /'      -> total E_H with PAW    =',F17.8,' Ry'& 
            /'      -> total E_XC with PAW   =',F17.8,' Ry' )
9069 FORMAT( '     scf correction            =',F17.8,' Ry' )
9070 FORMAT( '     smearing contrib. (-TS)   =',F17.8,' Ry' )
9071 FORMAT( '     Magnetic field            =',3F12.7,' Ry' )
9072 FORMAT( '     pot.stat. contrib. (-muN) =',F17.8,' Ry' )
9073 FORMAT( '     lambda                    =',F11.2,' Ry' )
9074 FORMAT( '     Dispersion Correction     =',F17.8,' Ry' )
9075 FORMAT( '     Dispersion XDM Correction =',F17.8,' Ry' )
9076 FORMAT( '     Dispersion T-S Correction =',F17.8,' Ry' )
9077 FORMAT( '     External forces energy    =',F17.8,' Ry' )
9078 FORMAT( '     DFT-D3 Dispersion         =',F17.8,' Ry' )
9080 FORMAT(/'     total energy              =',0PF17.8,' Ry' &
            /'     Harris-Foulkes estimate   =',0PF17.8,' Ry' &
            /'     estimated scf accuracy    <',0PF17.8,' Ry' )
9081 FORMAT(/'!    total energy              =',0PF17.8,' Ry' &
            /'     Harris-Foulkes estimate   =',0PF17.8,' Ry' &
            /'     estimated scf accuracy    <',0PF17.8,' Ry' )
9082 FORMAT(/'     total energy              =',0PF17.8,' Ry' &
            /'     Harris-Foulkes estimate   =',0PF17.8,' Ry' &
            /'     estimated scf accuracy    <',1PE17.1,' Ry' )
9083 FORMAT(/'!    total energy              =',0PF17.8,' Ry' &
            /'     Harris-Foulkes estimate   =',0PF17.8,' Ry' &
            /'     estimated scf accuracy    <',1PE17.1,' Ry' )
9085 FORMAT(/'     total all-electron energy =',0PF17.6,' Ry' )

  END SUBROUTINE print_energies
  !
END SUBROUTINE qepy_electrons_scf
!
!----------------------------------------------------------------------------
!FUNCTION exxenergyace( )
  !!--------------------------------------------------------------------------
  !!! Compute exchange energy using ACE
  !!
  !USE kinds,           ONLY : DP
  !USE buffers,         ONLY : get_buffer
  !USE exx,             ONLY : vexxace_gamma, vexxace_k, domat
  !USE klist,           ONLY : nks, ngk
  !USE wvfct,           ONLY : nbnd, npwx, current_k
  !USE lsda_mod,        ONLY : lsda, isk, current_spin
  !USE io_files,        ONLY : iunwfc, nwordwfc
  !USE mp_pools,        ONLY : inter_pool_comm
  !USE mp_bands,        ONLY : intra_bgrp_comm
  !USE mp,              ONLY : mp_sum
  !USE control_flags,   ONLY : gamma_only
  !USE wavefunctions,   ONLY : evc
  !!
  !IMPLICIT NONE
  !!
  !REAL(DP) :: exxenergyace
  !!! computed energy
  !!
  !! ... local variables
  !!
  !REAL(DP) :: ex
  !INTEGER :: ik, npw
  !!
  !domat = .TRUE.
  !exxenergyace=0.0_dp
  !!
  !DO ik = 1, nks
     !npw = ngk (ik)
     !current_k = ik
     !IF ( lsda ) current_spin = isk(ik)
     !IF (nks > 1) CALL get_buffer(evc, nwordwfc, iunwfc, ik)
     !IF (gamma_only) THEN
        !CALL vexxace_gamma( npw, nbnd, evc, ex )
     !ELSE
        !CALL vexxace_k( npw, nbnd, evc, ex )
     !ENDIF
     !exxenergyace = exxenergyace + ex
  !ENDDO
  !!
  !CALL mp_sum( exxenergyace, inter_pool_comm )
  !!
  !domat = .FALSE.
  !!
!END FUNCTION exxenergyace

FUNCTION qepy_delta_e(vr)
 !-----------------------------------------------------------------------
 !! This function computes \(\textrm{delta_e}\), where:
 !
 !! $$\begin{alignat*}{2} \text{delta}\_\text{e} &= - \int\text{rho}\%\text{of}\_\text{r(r)}\cdot 
 !!                                                           \text{v}\%\text{of}\_\text{r(r)} && \\
 !!                          &= - \int \text{rho}\%\text{kin}\_\text{r(r)}\cdot \text{v}\%\text{kin}\_
 !!                                                           \text{r(r)} && \text{[for Meta-GGA]} \\
 !!                          &= - \sum \text{rho}\%\text{ns}\cdot \text{v}\%\text{ns} && 
 !!                                                                               \text{[for LDA+U]}\\
 !!                          &= - \sum \text{becsum}\cdot \text{D1}\_\text{Hxc} && \text{[for PAW]}
 !!                                                                                  \end{alignat*} $$
 !
 ! ... delta_e =  - \int rho%of_r(r)  v%of_r(r)
 !                - \int rho%kin_r(r) v%kin_r(r) [for Meta-GGA]
 !                - \sum rho%ns       v%ns       [for LDA+U]
 !                - \sum becsum       D1_Hxc     [for PAW]
 !
 USE funct,  ONLY : dft_is_meta
 !
 USE kinds,                ONLY : DP
 USE lsda_mod,             ONLY : nspin
 USE fft_base,             ONLY : dfftp
 USE scf,                  ONLY : rho, v, vrs
 USE ldaU,                 ONLY : lda_plus_u
 USE paw_variables,        ONLY : okpaw, ddd_paw
 USE mp_bands,             ONLY : intra_bgrp_comm
 USE noncollin_module,     ONLY : noncolin
 USE cell_base,            ONLY : omega
 USE mp,                   ONLY : mp_sum
 !
 IMPLICIT NONE
 !
 REAL(DP) :: qepy_delta_e
 REAL(DP) :: vr(size(vrs,1),size(vrs,2))
 !
 REAL(DP) :: delta_e
 REAL(DP) :: delta_e_hub
 INTEGER  :: ir
 !
 delta_e = 0._DP
 IF ( nspin==2 ) THEN
    !
    DO ir = 1,dfftp%nnr
      delta_e = delta_e - ( rho%of_r(ir,1) + rho%of_r(ir,2) ) * vr(ir,1) &  ! up
                        - ( rho%of_r(ir,1) - rho%of_r(ir,2) ) * vr(ir,2)    ! dw
    ENDDO 
    delta_e = 0.5_DP*delta_e
    !
 ELSE
    delta_e = - SUM( rho%of_r(:,:)*vr(:,:) )
 ENDIF
 !
 IF ( dft_is_meta() ) &
    delta_e = delta_e - SUM( rho%kin_r(:,:)*v%kin_r(:,:) )
 !
 delta_e = omega * delta_e / ( dfftp%nr1*dfftp%nr2*dfftp%nr3 )
 !
 CALL mp_sum( delta_e, intra_bgrp_comm )
 !
 IF (lda_plus_u) THEN
   IF (noncolin) THEN
     delta_e_hub = - SUM( rho%ns_nc(:,:,:,:)*v%ns_nc(:,:,:,:) )
     delta_e = delta_e + delta_e_hub
   ELSE
     delta_e_hub = - SUM( rho%ns(:,:,:,:)*v%ns(:,:,:,:) )
     IF (nspin==1) delta_e_hub = 2.d0 * delta_e_hub
     delta_e = delta_e + delta_e_hub
   ENDIF
 ENDIF
 !
 IF (okpaw) delta_e = delta_e - SUM( ddd_paw(:,:,:)*rho%bec(:,:,:) )
 !
 qepy_delta_e = delta_e
 !
 RETURN
 !
END FUNCTION qepy_delta_e

!
! Copyright (C) 2001-2012 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
!
!----------------------------------------------------------------------------
MODULE oldxml_io_rho_xml
  !----------------------------------------------------------------------------
  !
  USE kinds,       ONLY : DP
  USE io_files,    ONLY : create_directory
  USE oldxml_xml_io_base, ONLY : write_rho, read_rho
#if !defined (__OLDXML)
  USE io_base,     ONLY : write_rhog, read_rhog
#endif
  !
  PRIVATE
  PUBLIC :: write_scf, read_scf
  !
  ! {read|write}_rho: read or write the charge density
  ! {read|write}_scf: as above, plus ldaU ns, PAW becsum, meta-GGA

  CONTAINS

    SUBROUTINE write_scf ( rho, nspin )
      !
      USE paw_variables,    ONLY : okpaw
      USE ldaU,             ONLY : lda_plus_u
      USE funct,            ONLY : dft_is_meta
      USE noncollin_module, ONLY : noncolin
      USE spin_orb,         ONLY : domag
      USE scf,              ONLY : scf_type
      !
      USE cell_base,        ONLY : bg, tpiba
      USE gvect,            ONLY : ig_l2g, mill
      USE control_flags,    ONLY : gamma_only
      USE io_files,         ONLY : seqopn, tmp_dir, prefix, postfix
      USE io_global,        ONLY : ionode, ionode_id, stdout
      USE mp_pools,         ONLY : my_pool_id
      USE mp_bands,         ONLY : my_bgrp_id, root_bgrp_id, &
                                   root_bgrp, intra_bgrp_comm
      USE mp_images,        ONLY : intra_image_comm
      USE mp,               ONLY : mp_bcast

      !
      IMPLICIT NONE
      TYPE(scf_type),   INTENT(IN)           :: rho
      INTEGER,          INTENT(IN)           :: nspin
      !
      CHARACTER (LEN=256) :: dirname
      LOGICAL :: lexist
      INTEGER :: nspin_, iunocc, iunpaw, ierr
      INTEGER, EXTERNAL :: find_free_unit

      dirname = TRIM(tmp_dir) // TRIM(prefix) // postfix
      CALL create_directory( dirname )
      ! in the following case do not read or write polarization
      IF ( noncolin .AND. .NOT.domag ) THEN
         nspin_ = 1
      ELSE
         nspin_ = nspin
      ENDIF
#if defined (__OLDXML)
      ! Write real space density
      CALL write_rho ( dirname, rho%of_r, nspin_ )
#else
      ! Write G-space density
      IF ( my_pool_id == 0 .AND. my_bgrp_id == root_bgrp_id ) &
           CALL write_rhog( dirname, root_bgrp, intra_bgrp_comm, &
           bg(:,1)*tpiba, bg(:,2)*tpiba, bg(:,3)*tpiba, &
           gamma_only, mill, ig_l2g, rho%of_g(:,1:nspin_) )
#endif

      ! Then write the other terms to separate files

      IF ( lda_plus_u ) THEN
         !
         iunocc = find_free_unit ()
         IF ( ionode ) THEN
            ! postfix(2:6) = without the dot (seqopn already adds it)
            CALL seqopn( iunocc, postfix(2:6)//'occup.txt', 'FORMATTED', lexist )
            if (noncolin) then
              WRITE( iunocc, * , iostat = ierr) rho%ns_nc
            else
              WRITE( iunocc, * , iostat = ierr) rho%ns
            endif
         END IF
         CALL mp_bcast( ierr, ionode_id, intra_image_comm )
         IF ( ierr/=0 ) CALL errore('write_scf', 'Writing ldaU ns', 1)
         IF ( ionode ) THEN
            CLOSE( UNIT = iunocc, STATUS = 'KEEP' )
         ENDIF
         !
      END IF
      !
      IF ( okpaw ) THEN
         !
         iunpaw = find_free_unit ()
         IF ( ionode ) THEN
            ! postfix(2:6) = without the dot (seqopn already adds it)
            CALL seqopn( iunpaw, postfix(2:6)//'paw.txt', 'FORMATTED', lexist )
            WRITE( iunpaw, * , iostat = ierr) rho%bec
         END IF
         CALL mp_bcast( ierr, ionode_id, intra_image_comm )
         IF ( ierr/=0 ) CALL errore('write_scf', 'Writing PAW becsum',1)
         IF ( ionode ) THEN
            CLOSE( UNIT = iunpaw, STATUS = 'KEEP' )
         ENDIF
         !
      END IF
      !
      IF ( dft_is_meta() ) THEN
         WRITE(stdout,'(5x,"Writing meta-gga kinetic term")')
          CALL write_rho ( dirname, rho%kin_r, nspin, 'kin' )
      ENDIF

      RETURN
    END SUBROUTINE write_scf

    SUBROUTINE read_scf ( rho, nspin, gamma_only )
      !
      USE scf,              ONLY : scf_type
      USE paw_variables,    ONLY : okpaw
      USE ldaU,             ONLY : lda_plus_u, starting_ns
      USE noncollin_module, ONLY : noncolin
      USE spin_orb,         ONLY : domag
      USE gvect,            ONLY : ig_l2g
      USE funct,            ONLY : dft_is_meta
      USE io_files,         ONLY : seqopn, prefix, tmp_dir, postfix
      USE io_global,        ONLY : ionode, ionode_id, stdout
      USE mp_bands,         ONLY : root_bgrp, intra_bgrp_comm
      USE mp_images,        ONLY : intra_image_comm
      USE mp,               ONLY : mp_bcast, mp_sum
      !
      IMPLICIT NONE
      TYPE(scf_type),   INTENT(INOUT)        :: rho
      INTEGER,          INTENT(IN)           :: nspin
      LOGICAL, OPTIONAL,INTENT(IN)           :: gamma_only
      !
      CHARACTER(LEN=256) :: dirname
      LOGICAL :: lexist
      INTEGER :: nspin_, iunocc, iunpaw, ierr
      INTEGER, EXTERNAL :: find_free_unit

      dirname = TRIM(tmp_dir) // TRIM(prefix) // postfix
      ! in the following case do not read or write polarization
      IF ( noncolin .AND. .NOT.domag ) THEN
         nspin_=1
      ELSE
         nspin_=nspin
      ENDIF
#if defined (__OLDXML)
      CALL read_rho ( dirname, rho%of_r, nspin_ )
#else
      CALL read_rhog( dirname, root_bgrp, intra_bgrp_comm, &
           ig_l2g, nspin_, rho%of_g, gamma_only )
#endif
      IF ( nspin > nspin_) rho%of_r(:,nspin_+1:nspin) = (0.0_dp, 0.0_dp)
      !
      IF ( lda_plus_u ) THEN
         !
         ! The occupations ns also need to be read in order to build up
         ! the potential
         !
         iunocc = find_free_unit ()
         IF ( ionode ) THEN
            ! postfix(2:6) = without the dot (seqopn already adds it)
            CALL seqopn( iunocc, postfix(2:6)//'occup.txt', 'FORMATTED', lexist )
            if (noncolin) then
              READ( UNIT = iunocc, FMT = *, iostat = ierr ) rho%ns_nc
            else
              READ( UNIT = iunocc, FMT = *, iostat = ierr ) rho%ns
            endif
         END IF
         CALL mp_bcast( ierr, ionode_id, intra_image_comm )
         IF ( ierr/=0 ) CALL errore('read_scf', 'Reading ldaU ns', 1)
         IF ( ionode ) THEN
            CLOSE( UNIT = iunocc, STATUS = 'KEEP')
         ELSE
            if (noncolin) then
              rho%ns_nc(:,:,:,:) = 0.D0
            else
              rho%ns(:,:,:,:) = 0.D0
            endif 
         END IF
         if (noncolin) then
           CALL mp_sum(rho%ns_nc, intra_image_comm)
         else
           CALL mp_sum(rho%ns, intra_image_comm)
         endif
         ! If projections on Hubbard manifold are read from file, there is no
         ! need to set starting values: reset them to prevent any problem
         starting_ns = -1.0_dp
      END IF
      !
      IF ( okpaw ) THEN
         !
         ! Also the PAW coefficients are needed:
         !
         iunpaw = find_free_unit ()
         IF ( ionode ) THEN
            ! postfix(2:6) = without the dot (seqopn already adds it)
            CALL seqopn( iunpaw, postfix(2:6)//'paw.txt', 'FORMATTED', lexist )
            READ( UNIT = iunpaw, FMT = *, iostat=ierr ) rho%bec
         END IF
         CALL mp_bcast( ierr, ionode_id, intra_image_comm )
         IF ( ierr/=0 ) CALL errore('read_scf', 'Reading PAW becsum',1)
         IF ( ionode ) THEN
            CLOSE( UNIT = iunpaw, STATUS = 'KEEP')
         ELSE
            rho%bec(:,:,:) = 0.D0
         END IF
         CALL mp_sum(rho%bec, intra_image_comm)
         !
      END IF
      !
      IF ( dft_is_meta() ) THEN
         WRITE(stdout,'(5x,"Reading meta-gga kinetic term")')
         CALL read_rho( dirname, rho%kin_r, nspin, 'kin' )
      END IF

      RETURN
    END SUBROUTINE read_scf
    !
END MODULE oldxml_io_rho_xml

!
! Copyright (C) 2001-2016 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
!----------------------------------------------------------------------------
SUBROUTINE qepy_electrons_nscf ( printout, exxen, embed)
  !----------------------------------------------------------------------------
  !! This routine is a driver of the self-consistent cycle.
  !! It uses the routine c_bands for computing the bands at fixed
  !! Hamiltonian, the routine sum_band to compute the charge density,
  !! the routine v_of_rho to compute the new potential and the routine
  !! mix_rho to mix input and output charge densities.
  !
  USE kinds,                ONLY : DP
  USE check_stop,           ONLY : check_stop_now, stopped_by_user
  USE io_global,            ONLY : stdout, ionode
  USE cell_base,            ONLY : at, bg, alat, omega, tpiba2
  USE ions_base,            ONLY : zv, nat, nsp, ityp, tau, compute_eextfor, atm
  USE basis,                ONLY : starting_pot
  USE bp,                   ONLY : lelfield
  USE fft_base,             ONLY : dfftp
  USE gvect,                ONLY : ngm, gstart, g, gg, gcutm
  USE gvecs,                ONLY : doublegrid, ngms
  USE klist,                ONLY : xk, wk, nelec, ngk, nks, nkstot, lgauss, &
                                   two_fermi_energies, tot_charge
  USE lsda_mod,             ONLY : lsda, nspin, magtot, absmag, isk
  USE vlocal,               ONLY : strf
  USE wvfct,                ONLY : nbnd, et
  USE gvecw,                ONLY : ecutwfc
  USE ener,                 ONLY : etot, hwf_energy, eband, deband, ehart, &
                                   vtxc, etxc, etxcc, ewld, demet, epaw, &
                                   elondon, edftd3, ef_up, ef_dw, exdm, ef
  USE scf,                  ONLY : scf_type, scf_type_COPY, bcast_scf_type,&
                                   create_scf_type, destroy_scf_type, &
                                   open_mix_file, close_mix_file, &
                                   rho, rho_core, rhog_core, v, vltot, vrs, &
                                   kedtau, vnew
  USE control_flags,        ONLY : mixing_beta, tr2, ethr, niter, nmix, &
                                   iprint, conv_elec, &
                                   restart, io_level, do_makov_payne,  &
                                   gamma_only, iverbosity, textfor,     &
                                   llondon, ldftd3, scf_must_converge, lxdm, ts_vdw
  USE control_flags,        ONLY : n_scf_steps, scf_error

  USE io_files,             ONLY : iunmix, output_drho
  USE ldaU,                 ONLY : eth, Hubbard_U, Hubbard_lmax, &
                                   niter_with_fixed_ns, lda_plus_u
  USE extfield,             ONLY : tefield, etotefield, gate, etotgatefield !TB
  USE noncollin_module,     ONLY : noncolin, magtot_nc, i_cons,  bfield, &
                                   lambda, report
  USE spin_orb,             ONLY : domag
  USE io_rho_xml,           ONLY : write_scf
  USE uspp,                 ONLY : okvan
  USE mp_bands,             ONLY : intra_bgrp_comm
  USE mp_pools,             ONLY : root_pool, me_pool, my_pool_id, &
                                   inter_pool_comm, intra_pool_comm
  USE mp,                   ONLY : mp_sum, mp_bcast
  !
  USE london_module,        ONLY : energy_london
  USE dftd3_api,            ONLY : dftd3_pbc_dispersion, &
                                   dftd3_init, dftd3_set_functional, &
                                   get_atomic_number, dftd3_input, &
                                   dftd3_calc
  USE dftd3_qe,             ONLY : dftd3, dftd3_in, energy_dftd3
  USE xdm_module,           ONLY : energy_xdm
  USE tsvdw_module,         ONLY : EtsvdW
  !
  USE paw_variables,        ONLY : okpaw, ddd_paw, total_core_energy, only_paw
  USE paw_onecenter,        ONLY : PAW_potential
  USE paw_symmetry,         ONLY : PAW_symmetrize_ddd
  USE dfunct,               ONLY : newd
  USE esm,                  ONLY : do_comp_esm, esm_printpot, esm_ewald
  USE fcp_variables,        ONLY : lfcpopt, lfcpdyn
  USE wrappers,             ONLY : memstat
  !
  USE plugin_variables,     ONLY : plugin_etot
  !
  USE qepy_common,          ONLY : embed_base
  !
  IMPLICIT NONE
  !
  INTEGER, INTENT (IN) :: printout
  !! * If printout>0, prints on output the total energy;
  !! * if printout>1, also prints decomposition into energy contributions.
  REAL(DP),INTENT (IN) :: exxen
  !! current estimate of the exchange energy
  type(embed_base), intent(inout)    :: embed
  !
  ! ... local variables
  !
  REAL(DP),save :: dr2
  !! the norm of the diffence between potential
  REAL(DP) :: charge
  !! the total charge
  REAL(DP) :: deband_hwf
  !! deband for the Harris-Weinert-Foulkes functional
  REAL(DP) :: mag
  !! local magnetization
  INTEGER :: i
  !! counter on polarization
  INTEGER :: idum
  !! dummy counter on iterations
  INTEGER,save :: iter
  !! counter on iterations
  INTEGER :: ios, kilobytes
  !
  REAL(DP) :: tr2_min
  !! estimated error on energy coming from diagonalization
  REAL(DP),save :: descf
  !! correction for variational energy
  REAL(DP) :: en_el=0.0_DP
  !! electric field contribution to the total energy
  REAL(DP) :: eext=0.0_DP
  !! external forces contribution to the total energy
  LOGICAL :: first, exst
  !! auxiliary variables for calculating and storing temporary copies of
  !! the charge density and of the HXC-potential
  !
  TYPE(scf_type),save :: rhoin
  !! used to store rho_in of current/next iteration
  !
  ! ... external functions
  !
  REAL(DP), EXTERNAL :: ewald, get_clock
  REAL(DP) :: etot_cmp_paw(nat,2,2)
  ! 
  REAL(DP) :: latvecs(3,3)
  !! auxiliary variables for grimme-d3
  INTEGER:: atnum(1:nat), na
  !! auxiliary variables for grimme-d3
  !
  INTEGER:: its
  !!
  REAL(DP) :: mixing_beta_new
  !qepy <-- add descf
  TYPE(scf_type),save :: rho_prev
  !! save the last step unmix density for descf
  !
  LOGICAL :: add_descf
  !! add the descf to the total energy for last step
  !
  !
  add_descf = .FALSE.
  if ( embed%ldescf .and. embed%iterative .and. (.not. embed%initial) ) add_descf = .TRUE.
  if (embed%finish) goto 10
  !!! If we change some parts to functions will make the code clean.
  !!! But to keep the structure of the code, we add many goto functions.
  !qepy -->

  if (embed%initial) then
  embed%initial = .FALSE.
  iter = 0
  dr2  = 0.0_dp
  descf = 0.0_dp
  IF ( restart ) CALL restart_in_electrons( iter, dr2, ethr, et )
  !end if
  !
  WRITE( stdout, 9000 ) get_clock( 'PWSCF' )
  !
  CALL memstat( kilobytes )
  IF ( kilobytes > 0 ) WRITE( stdout, 9001 ) kilobytes/1000.0
  !
  CALL start_clock( 'electrons' )
  !
  FLUSH( stdout )
  !
  ! ... calculates the ewald contribution to total energy
  !
  !if (embed%initial) then
  if (embed%exttype<1) then
  IF ( do_comp_esm ) THEN
     ewld = esm_ewald()
  ELSE
     ewld = ewald( alat, nat, nsp, ityp, zv, at, bg, tau, &
                omega, g, gg, ngm, gcutm, gstart, gamma_only, strf )
  ENDIF
  else if (iand(embed%exttype,1) == 1) then
     call qepy_setlocal(embed%exttype)
  endif
  !
  IF ( llondon ) THEN
     elondon = energy_london( alat , nat , ityp , at ,bg , tau )
  ELSE
     elondon = 0.d0
  ENDIF
  !
  ! Grimme-D3 correction to the energy
  !
  IF (ldftd3) THEN
     latvecs(:,:)=at(:,:)*alat
     tau(:,:)=tau(:,:)*alat
     DO na = 1, nat
        atnum(na) = get_atomic_number(TRIM(atm(ityp(na))))
     ENDDO
     call dftd3_pbc_dispersion(dftd3,tau,atnum,latvecs,energy_dftd3)
     edftd3=energy_dftd3*2.d0
     tau(:,:)=tau(:,:)/alat
  ELSE
     edftd3= 0.0
  ENDIF
  !
  !
  WRITE( stdout, 9002 )
  FLUSH( stdout )
  !
  else
  dr2 = embed%dnorm
  end if ! if (embed%initial)
  !
  CALL qepy_v_of_rho_all( rho, rho_core, rhog_core, &
     ehart, etxc, vtxc, eth, etotefield, charge, v, embed)

  IF ( check_stop_now() ) THEN
     conv_elec=.FALSE.
     CALL save_in_electrons (iter, dr2, ethr, et )
     GO TO 10
  ENDIF

  iter = iter + 1
  !
  WRITE( stdout, 9010 ) iter, ecutwfc, mixing_beta
  !
  FLUSH( stdout )
  !
  ! ... Convergence threshold for iterative diagonalization is
  ! ... automatically updated during self consistency
  !
  IF ( iter > 1 ) THEN
     !
     IF ( iter == 2 ) ethr = 1.D-2
     ethr = MIN( ethr, 0.1D0*dr2 / MAX( 1.D0, nelec ) )
     ethr = MIN( ethr, embed%diag_conv)
     ! ... do not allow convergence threshold to become too small:
     ! ... iterative diagonalization may become unstable
     ethr = MAX( ethr, 1.D-13 )
     !
  ENDIF
  !
  first = ( iter == 1 )
  !
  if (first) ethr = MAX( ethr, 1.D-6 )
  !
  ! ... tr2_min is set to an estimate of the error on the energy
  ! ... due to diagonalization - used only for the first scf iteration
  !
  tr2_min = 0.D0
  !
  IF ( first ) tr2_min = ethr*MAX( 1.D0, nelec ) 
  !
  ! ... diagonalization of the KS hamiltonian
  !
  IF ( lelfield ) THEN
     CALL c_bands_efield( iter )
  ELSE
     CALL c_bands( iter )
  ENDIF
  !
  IF ( stopped_by_user ) THEN
     conv_elec=.FALSE.
     CALL save_in_electrons( iter-1, dr2, ethr, et )
     GO TO 10
  ENDIF
  !
  ! ... xk, wk, isk, et, wg are distributed across pools;
  ! ... the first node has a complete copy of xk, wk, isk,
  ! ... while eigenvalues et and weights wg must be
  ! ... explicitly collected to the first node
  ! ... this is done here for et, in sum_band for wg
  !
  CALL poolrecover( et, nbnd, nkstot, nks )
  !
  ! ... the new density is computed here. For PAW:
  ! ... sum_band computes new becsum (stored in uspp modules)
  ! ... and a subtly different copy in rho%bec (scf module)
  !
  !CALL sum_band()
  RETURN

10  FLUSH( stdout )
  !qepy <--
  n_scf_steps = iter
  scf_error = dr2
  !qepy -->
  !
  ! ... exiting: write (unless disabled) the charge density to file
  ! ... (also write ldaU ns coefficients and PAW becsum)
  !
  IF ( io_level > -1 ) CALL write_scf( rho, nspin )
  !
  ! ... delete mixing info if converged, keep it if not
  !
  IF ( embed%finish) conv_elec = .true.
  IF ( output_drho /= ' ' ) CALL remove_atomic_rho()
  CALL stop_clock( 'electrons' )
  !
  !qepy <-- reset embed
  embed%initial = .TRUE.
  embed%finish = .FALSE.
  embed%mix_coef = -1.0
  !qepy -->
  IF ( conv_elec ) THEN
     WRITE( stdout, 9101 )
     WRITE( stdout, 9110 ) iter
  ELSE
     WRITE( stdout, 9120 ) iter
  ENDIF
  RETURN
  !
  ! ... formats
  !
9000 FORMAT(/'     total cpu time spent up to now is ',F10.1,' secs' )
9001 FORMAT(/'     per-process dynamical memory: ',f7.1,' Mb' )
9002 FORMAT(/'     Self-consistent Calculation' )
9010 FORMAT(/'     iteration #',I3,'     ecut=', F9.2,' Ry',5X,'beta=',F5.2 )
9050 FORMAT(/'     WARNING: integrated charge=',F15.8,', expected=',F15.8 )
9101 FORMAT(/'     End of self-consistent calculation' )
9110 FORMAT(/'     convergence has been achieved in ',i3,' iterations' )
9120 FORMAT(/'     convergence NOT achieved after ',i3,' iterations: stopping' )
  !
END SUBROUTINE qepy_electrons_nscf

!
! Copyright (C) 2001-2011 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
!----------------------------------------------------------------------------
SUBROUTINE qepy_hinit1(exttype)
  !----------------------------------------------------------------------------
  !! Atomic configuration dependent hamiltonian initialization,
  !! potential, wavefunctions for Hubbard U.  
  !! Important note: it does not recompute structure factors and core charge,
  !! they must be computed before this routine is called.
  !
  USE ions_base,           ONLY : nat, nsp, ityp, tau
  USE cell_base,           ONLY : at, bg, omega, tpiba2
  USE fft_base,            ONLY : dfftp
  USE gvecs,               ONLY : doublegrid
  USE ldaU,                ONLY : lda_plus_u
  USE lsda_mod,            ONLY : nspin
  USE scf,                 ONLY : vrs, vltot, v, kedtau
  USE control_flags,       ONLY : tqr
  USE realus,              ONLY : generate_qpointlist, betapointlist, &
                                  init_realspace_vars, real_space
  USE wannier_new,         ONLY : use_wannier
  USE martyna_tuckerman,   ONLY : tag_wg_corr_as_obsolete
  USE scf,                 ONLY : rho
  USE paw_variables,       ONLY : okpaw, ddd_paw
  USE paw_onecenter,       ONLY : paw_potential
  USE paw_symmetry,        ONLY : paw_symmetrize_ddd
  USE dfunct,              ONLY : newd
  !
  IMPLICIT NONE
  !
  integer,                         intent(in)      :: exttype
  !
  ! these routines can be used to patch quantities that are dependent
  ! on the ions and cell parameters
  !
  CALL plugin_init_ions()
  CALL plugin_init_cell()
  !
  ! ... calculate the total local potential
  !
  CALL qepy_setlocal(exttype)
  !
  IF ( tqr ) CALL generate_qpointlist()
  !
  IF ( real_space ) THEN
     CALL betapointlist()
     CALL init_realspace_vars()
  ENDIF
  !
  CALL tag_wg_corr_as_obsolete
  !
  ! ... plugin contribution to local potential
  !
  CALL plugin_scf_potential( rho, .FALSE., -1.d0, vltot )
  !
  ! ... define the total local potential (external+scf)
  !
  CALL set_vrs( vrs, vltot, v%of_r, kedtau, v%kin_r, dfftp%nnr, nspin, &
                doublegrid )
  !
  ! ... update the D matrix and the PAW coefficients
  !
  IF ( okpaw ) THEN
     CALL compute_becsum( 1 )
     CALL PAW_potential( rho%bec, ddd_paw )
     CALL PAW_symmetrize_ddd( ddd_paw )
  ENDIF
  ! 
  CALL newd()
  !
  ! ... and recalculate the products of the S with the atomic wfcs used 
  ! ... in LDA+U calculations
  !
  IF ( lda_plus_u  ) CALL orthoUwfc() 
  IF ( use_wannier ) CALL orthoatwfc( .TRUE. )
  !
  !
  RETURN
  !
END SUBROUTINE qepy_hinit1

!
! Copyright (C) 2016-2019 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
!----------------------------------------------------------------------------
SUBROUTINE qepy_read_file()
  !----------------------------------------------------------------------------
  !
  ! Wrapper routine, for backwards compatibility
  !
  USE io_global,        ONLY : stdout
  USE control_flags,    ONLY : io_level
  USE buffers,          ONLY : open_buffer, close_buffer, save_buffer
  USE io_files,         ONLY : nwordwfc, iunwfc, restart_dir
  USE wvfct,            ONLY : nbnd, npwx
  USE noncollin_module, ONLY : npol
  USE klist,            ONLY : nks
  USE wavefunctions,    ONLY : evc
  USE pw_restart_new,   ONLY : read_collected_wfc
  !
  IMPLICIT NONE
  !
  INTEGER :: ik
  LOGICAL :: exst, wfc_is_collected
  !
  wfc_is_collected = .true.
  CALL qepy_read_file_new( wfc_is_collected )
  !
  ! ... Open unit iunwfc, for Kohn-Sham orbitals - we assume that wfcs
  ! ... have been written to tmp_dir, not to a different directory!
  ! ... io_level = 1 so that a real file is opened
  !
  nwordwfc = nbnd*npwx*npol
  io_level = 1
  CALL open_buffer ( iunwfc, 'wfc', nwordwfc, io_level, exst )
  !
  ! ... read wavefunctions in collected format, write them to file
  !
  IF ( wfc_is_collected ) THEN
     !
     WRITE( stdout, '(5x,A)') &
          'Reading collected, re-writing distributed wavefunctions'
     DO ik = 1, nks
        CALL read_collected_wfc ( restart_dir(), ik, evc )
        CALL save_buffer ( evc, nwordwfc, iunwfc, ik )
     END DO
     !
  ELSE
     WRITE( stdout, '(5x,A)') &
          'read_file: Wavefunctions in collected format not available'
  END IF
  !
  !CALL close_buffer  ( iunwfc, 'KEEP' )
  !
END SUBROUTINE qepy_read_file
!
!----------------------------------------------------------------------------
SUBROUTINE qepy_read_file_new ( needwf )
  !----------------------------------------------------------------------------
  !
  ! Reads xml data file produced by pw.x or cp.x, performs initializations
  ! related to the contents of the xml file
  ! If needwf=.t. performs wavefunction-related initialization as well
  ! Does not read wfcs but returns in "wfc_is_collected" info on the wfc file
  !
  USE io_global,      ONLY : stdout
  USE io_files,       ONLY : nwordwfc, iunwfc, wfc_dir, tmp_dir, restart_dir
  USE gvect,          ONLY : ngm, g
  USE gvecw,          ONLY : gcutw
  USE klist,          ONLY : nkstot, nks, xk, wk
  USE lsda_mod,       ONLY : isk
  USE wvfct,          ONLY : nbnd, et, wg
  USE qepy_pw_restart_new, ONLY : qepy_read_xml_file
  !
  IMPLICIT NONE
  !
  LOGICAL, INTENT(INOUT) :: needwf
  !
  LOGICAL :: wfc_is_collected
  !
  WRITE( stdout, '(/,5x,A)') &
       'Reading xml data from directory:', TRIM( restart_dir() )
  !
  ! ... Read the contents of the xml data file
  !
  CALL qepy_read_xml_file ( wfc_is_collected )
  !
  ! ... more initializations: pseudopotentials / G-vectors / FFT arrays /
  ! ... charge density / potential / ... , but not KS orbitals
  !
  CALL qepy_post_xml_init ( )
  !
  IF ( needwf ) THEN
     IF ( .NOT. wfc_is_collected ) WRITE( stdout, '(5x,A)') &
          'qepy_read_file_new: Wavefunctions not in collected format?!?'
     !
     ! ... initialization of KS orbitals
     !
     wfc_dir = tmp_dir ! this is likely obsolete and no longer used
     !
     ! ... distribute across pools k-points and related variables.
     ! ... nks is defined by the following routine as the number 
     ! ... of k-points in the current pool
     !
     CALL divide_et_impera( nkstot, xk, wk, isk, nks )
     CALL poolscatter( nbnd, nkstot, et, nks, et )
     CALL poolscatter( nbnd, nkstot, wg, nks, wg )
     !
     ! ... allocate_wfc_k also computes no. of plane waves and k+G indices
     ! ... FIXME: the latter should be read from file, not recomputed
     !
     CALL allocate_wfc_k()
     !
  END IF
  needwf = wfc_is_collected
  !
END SUBROUTINE qepy_read_file_new
!----------------------------------------------------------------------------
SUBROUTINE qepy_post_xml_init (  )
  !----------------------------------------------------------------------------
  !
  ! ... Various initializations needed to start a calculation:
  ! ... pseudopotentials, G vectors, FFT arrays, rho, potential
  !
  USE kinds,                ONLY : DP
  USE io_global,            ONLY : stdout
  USE uspp_param,           ONLY : upf
  USE read_pseudo_mod,      ONLY : readpp
  USE uspp,                 ONLY : becsum
  USE paw_variables,        ONLY : okpaw, ddd_PAW
  USE paw_init,             ONLY : paw_init_onecenter, allocate_paw_internals
  USE paw_onecenter,        ONLY : paw_potential
  USE dfunct,               ONLY : newd
  USE funct,                ONLY : get_inlc, get_dft_name
  USE ldaU,                 ONLY : lda_plus_u, eth, init_lda_plus_u, U_projection
  USE esm,                  ONLY : do_comp_esm, esm_init
  USE Coul_cut_2D,          ONLY : do_cutoff_2D, cutoff_fact 
  USE ions_base,            ONLY : nat, nsp, tau, ityp
  USE recvec_subs,          ONLY : ggen, ggens
  USE gvect,                ONLY : gg, ngm, g, gcutm, mill, ngm_g, ig_l2g, &
                                   eigts1, eigts2, eigts3, gstart, gshells
  USE gvecs,                ONLY : ngms, gcutms 
  USE fft_rho,              ONLY : rho_g2r
  USE fft_base,             ONLY : dfftp, dffts
  USE scf,                  ONLY : rho, rho_core, rhog_core, v
  USE io_rho_xml,           ONLY : read_scf
  USE vlocal,               ONLY : strf
  USE control_flags,        ONLY : gamma_only
  USE control_flags,        ONLY : ts_vdw, tqr, tq_smoothing, tbeta_smoothing
  USE cellmd,               ONLY : cell_factor, lmovecell
  USE wvfct,                ONLY : nbnd, nbndx, et, wg
  USE lsda_mod,             ONLY : nspin
  USE noncollin_module,     ONLY : noncolin
  USE spin_orb,             ONLY : lspinorb
  USE cell_base,            ONLY : at, bg, set_h_ainv
  USE symm_base,            ONLY : d1, d2, d3
  USE realus,               ONLY : betapointlist, generate_qpointlist, &
                                   init_realspace_vars,real_space
  !
  !qepy --> import
  USE control_flags,        ONLY : mixing_beta, tr2, ethr, niter, nmix, &
                                   iprint, conv_elec, &
                                   restart, io_level, do_makov_payne,  &
                                   iverbosity, textfor,     &
                                   llondon, ldftd3, scf_must_converge, lxdm
  
  USE london_module,        ONLY : energy_london, init_london, C6_ij
  USE dftd3_api,            ONLY : dftd3_pbc_dispersion, &
                                   dftd3_init, dftd3_set_functional, &
                                   get_atomic_number, dftd3_input, &
                                   dftd3_calc
  USE dftd3_qe,             ONLY : dftd3, dftd3_in, energy_dftd3, dftd3_xc, dftd3_printout
  USE xdm_module,           ONLY : energy_xdm, init_xdm
  USE input_parameters,     ONLY : dftd3_threebody, dftd3_version
  USE funct,                ONLY : get_dft_short
  USE tsvdw_module,         ONLY : tsvdw_initialize
  !qepy <-- import
  IMPLICIT NONE
  !
  INTEGER  :: inlc
  REAL(DP) :: ehart, etxc, vtxc, etotefield, charge
  CHARACTER(LEN=20) :: dft_name
  !qepy --> variablesi
  CHARACTER(LEN=256):: dft_
  REAL (DP), EXTERNAL :: get_clock
  !qepy <-- variables
  !
  ! ... set G cutoffs and cell factor (FIXME: from setup.f90?)
  !
  CALL set_gcut()
  if (cell_factor == 0.d0) cell_factor = 1.D0
  nbndx = nbnd
  !
  ! ... read pseudopotentials
  ! ... the following call prevents readpp from setting dft from PP files
  !
  dft_name = get_dft_name ()
  CALL readpp ( dft_name )
  !
  ! ... misc PP initialization (from setup.f90)
  !
  okpaw = ANY ( upf(1:nsp)%tpawp )
  IF ( .NOT. lspinorb ) CALL average_pp ( nsp )
  !! average_pp must be called before init_lda_plus_u
  IF ( lda_plus_u ) CALL init_lda_plus_u ( upf(1:nsp)%psd, noncolin )
  !
  ! ... allocate memory for G- and R-space fft arrays (from init_run.f90)
  !
  CALL pre_init()
  ! NB: data_structure uses k-points to compute gkcut
  CALL data_structure ( gamma_only )
  CALL allocate_fft()
  CALL ggen ( dfftp, gamma_only, at, bg, gcutm, ngm_g, ngm, &
       g, gg, mill, ig_l2g, gstart ) 
  CALL ggens( dffts, gamma_only, at, g, gg, mill, gcutms, ngms ) 
  CALL gshells ( lmovecell ) 
  !
  IF (do_comp_esm) CALL esm_init()
  IF (do_cutoff_2D) CALL cutoff_fact()
  !
  ! ... allocate the potentials
  !
  CALL allocate_locpot()
  CALL allocate_nlpot()
  IF (okpaw) THEN
     CALL allocate_paw_internals()
     CALL paw_init_onecenter()
     CALL d_matrix(d1,d2,d3)
  ENDIF
  !
  ! ... read the charge density in G-space
  !
  CALL read_scf( rho, nspin, gamma_only )
  !
  ! ... bring the charge density to real space
  !
  CALL rho_g2r ( dfftp, rho%of_g, rho%of_r )
  !
  ! ... re-compute the local part of the pseudopotential vltot and
  ! ... the core correction charge (if any) - from hinit0.f90
  !
  CALL init_vloc()
  IF (tbeta_smoothing) CALL init_us_b0()
  IF (tq_smoothing) CALL init_us_0()
  CALL init_us_1()
  IF ( lda_plus_U .AND. ( U_projection == 'pseudo' ) ) CALL init_q_aeps()
  CALL init_at_1()
  !
  CALL struc_fact( nat, tau, nsp, ityp, ngm, g, bg, dfftp%nr1, dfftp%nr2,&
                   dfftp%nr3, strf, eigts1, eigts2, eigts3 )
  CALL setlocal()
  CALL set_rhoc()
  !
  ! ... for real-space PP's
  !
  IF ( tqr ) CALL generate_qpointlist()
  IF (real_space ) THEN
     CALL betapointlist()
     CALL init_realspace_vars()
     WRITE (stdout,'(5X,"Real space initialisation completed")')    
  ENDIF
  !
  ! ... recalculate the potential - FIXME: couldn't make ts-vdw work
  !
  !qepy --> init vdw
  IF ( ts_vdw) THEN
      CALL tsvdw_initialize()
      CALL set_h_ainv()
     !CALL infomsg('qepy_read_file_new','*** vdW-TS term will be missing in potential ***')
     !ts_vdw = .false.
  END IF
  !
  !IF ( llondon ) THEN
  !   IF ( .NOT. ALLOCATED(C6_ij)) CALL init_london()
  !ENDIF
  !IF (lxdm) THEN
  !   IF ( get_clock('init_xdm')< 0.0_DP) CALL init_xdm()
  !ENDIF
  !IF (ldftd3) !   IF ( .NOT. ALLOCATED(dftd3%r0ab)) THEN
  IF (llondon) CALL init_london()
  IF (lxdm) CALL init_xdm()
  IF (ldftd3) THEN
     if (dftd3_version==2) dftd3_threebody=.false.
     dftd3_in%threebody = dftd3_threebody
     CALL dftd3_init(dftd3, dftd3_in)
     CALL dftd3_printout(dftd3, dftd3_in)
     dft_ = get_dft_short( )
     dft_ = dftd3_xc ( dft_ )
     CALL dftd3_set_functional(dftd3, func=dft_, version=dftd3_version,tz=.false.)
  ENDIF
  !qepy <-- init
  CALL v_of_rho( rho, rho_core, rhog_core, &
       ehart, etxc, vtxc, eth, etotefield, charge, v )
  !
  ! ... More PAW and USPP initializations
  !
  IF (okpaw) THEN
     becsum = rho%bec
     CALL PAW_potential(rho%bec, ddd_PAW)
  ENDIF 
  CALL newd()
  !
  RETURN
  !
  CONTAINS
    !
    !------------------------------------------------------------------------
    SUBROUTINE set_gcut()
      !------------------------------------------------------------------------
      !
      USE constants, ONLY : pi, eps8
      USE cell_base, ONLY : alat, tpiba, tpiba2
      USE gvect,     ONLY : ecutrho, gcutm
      USE gvecs,     ONLY : gcutms, dual, doublegrid
      USE gvecw,     ONLY : gcutw, ecutwfc
      !
      !
      ! ... Set the units in real and reciprocal space
      !
      tpiba  = 2.D0 * pi / alat
      tpiba2 = tpiba**2
      !
      ! ... Compute the cut-off of the G vectors
      !
      gcutw =        ecutwfc / tpiba2
      gcutm = dual * ecutwfc / tpiba2
      ecutrho=dual * ecutwfc
      !
      doublegrid = ( dual > 4.0_dp + eps8 )
      IF ( doublegrid ) THEN
         gcutms = 4.D0 * ecutwfc / tpiba2
      ELSE
         gcutms = gcutm
      END IF
      !
    END SUBROUTINE set_gcut
    !
  END SUBROUTINE qepy_post_xml_init

!
! Copyright (C) 2004-2009 Dario Alfe' and Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
!-----------------------------------------------------------------------
!SUBROUTINE write_casino_wfn(gather,blip,multiplicity,binwrite,single_precision_blips,n_points_for_test,postfix)

   !USE kinds, ONLY: DP,sgl
   !USE ions_base, ONLY : nat, ntyp => nsp, ityp, tau, zv, atm
   !USE cell_base, ONLY: omega, alat, tpiba2, at, bg
   !USE run_info,  ONLY: title    ! title of the run
   !USE constants, ONLY: tpi, e2, eps6
   !USE ener, ONLY: ewld, ehart, etxc, vtxc, etot, etxcc, demet, ef
   !USE fft_base,  ONLY: dfftp
   !USE fft_interfaces, ONLY : fwfft
   !USE gvect, ONLY: ngm, gstart, g, gg, gcutm, igtongl
   !USE klist , ONLY: nks, nelec, xk, wk, degauss, ngauss, igk_k, ngk
   !USE lsda_mod, ONLY: lsda, nspin
   !USE scf, ONLY: rho, rho_core, rhog_core, v
   !USE ldaU, ONLY : eth
   !USE vlocal, ONLY: vloc, strf
   !USE wvfct, ONLY: npwx, nbnd, wg, et
   !USE gvecw, ONLY: ecutwfc
   !USE control_flags, ONLY : gamma_only
   !USE uspp, ONLY: nkb, vkb, dvan
   !USE uspp_param, ONLY: nh
   !USE io_global, ONLY: stdout, ionode, ionode_id
   !USE io_files, ONLY: nd_nmbr, nwordwfc, iunwfc, prefix, tmp_dir, seqopn
   !USE wavefunctions, ONLY : evc
   !USE funct, ONLY : dft_is_meta
   !USE mp_pools, ONLY: inter_pool_comm, intra_pool_comm, nproc_pool, me_pool
   !USE mp_bands, ONLY: intra_bgrp_comm
   !USE mp, ONLY: mp_sum, mp_gather, mp_bcast, mp_get
   !USE buffers,              ONLY : get_buffer

   !USE pw2blip

   !IMPLICIT NONE
   !LOGICAL, INTENT(in) :: gather,blip,binwrite,single_precision_blips
   !REAL(dp), INTENT(in) :: multiplicity
   !INTEGER, INTENT(in) :: n_points_for_test
   !CHARACTER(*), INTENT(in) :: postfix

   !INTEGER, PARAMETER :: n_overlap_tests = 12
   !REAL(dp), PARAMETER :: eps = 1.d-10
   !INTEGER, PARAMETER :: io = 77, iob = 78
   !INTEGER :: npw, ig, ibnd, ik, ispin, nbndup, nbnddown, &
              !nk, ig7, ikk, id, ip, iorb, iorb_node, inode, ierr, norb
   !INTEGER :: jk(nproc_pool), jspin(nproc_pool), jbnd(nproc_pool)
   !INTEGER :: jk2(nproc_pool), jspin2(nproc_pool), jbnd2(nproc_pool)
   !INTEGER, ALLOCATABLE :: idx(:), igtog(:), gtoig(:)
   !LOGICAL :: exst,dowrite
   !REAL(DP) :: ek, eloc, enl, etot_
   !INTEGER, EXTERNAL :: atomic_number
   !REAL (DP), EXTERNAL :: ewald, w1gauss

   !! number of g vectors (union of all k points)
   !INTEGER ngtot_l ! on this processor
   !INTEGER, ALLOCATABLE :: ngtot_d(:), ngtot_cumsum(:), indx(:)
   !INTEGER ngtot_g ! sum over processors
   !REAL(DP), ALLOCATABLE :: g_l(:,:), g_g(:,:), g2(:)
   !COMPLEX(DP), ALLOCATABLE :: evc_l(:), evc_g(:), evc_g2(:), avc_tmp(:,:,:), cavc_tmp(:,:,:)
   !LOGICAL dotransform

   !REAL(dp) :: av_overlap(5,2),avsq_overlap(5,2)

!!----------------------------------------------------------------------------!
!! Random number generator, using the method suggested by D.E. Knuth in       !
!! Seminumerical Algorithms (vol 2 of The Art of Computer Programming).       !
!! The method is based on lagged Fibonacci sequences with subtraction.        !
!!----------------------------------------------------------------------------!
   !INTEGER,PARAMETER :: KK=100,LL=37 ! Leave these.
   !REAL(DP) :: ranstate(kk)  ! Determines output of gen_ran_array.

   !INTEGER,PARAMETER :: default_seed=310952  ! Random seed, betw. 0 & 2^30-3.
   !INTEGER,PARAMETER :: Nran=1009,Nkeep=100 ! See comment on p. 188 of Knuth.
   !INTEGER,SAVE :: ran_array_idx=-1
   !REAL(DP),SAVE :: ran_array(Nran)

   !dowrite=ionode.or..not.(gather.or.blip)

   !ALLOCATE (idx (ngm) )
   !ALLOCATE (igtog (ngm) )
   !ALLOCATE (gtoig (ngm) )
   !idx(:) = 0
   !igtog(:) = 0

   !IF( lsda )THEN
      !nbndup = nbnd
      !nbnddown = nbnd
      !nk = nks/2
      !!     nspin = 2
   !ELSE
      !nbndup = nbnd
      !nbnddown = 0
      !nk = nks
      !!     nspin = 1
   !ENDIF

   !CALL calc_energies

   !DO ispin = 1, nspin
      !DO ik = 1, nk
         !ikk = ik + nk*(ispin-1)
         !idx( igk_k(1:ngk(ikk),ikk) ) = 1
      !ENDDO
   !ENDDO

   !ngtot_l = 0
   !DO ig = 1, ngm
      !IF( idx(ig) >= 1 )THEN
         !ngtot_l = ngtot_l + 1
         !igtog(ngtot_l) = ig
         !gtoig(ig) = ngtot_l
      !ENDIF
   !ENDDO

   !DEALLOCATE (idx)

   !IF(dowrite)THEN
      !IF(blip)THEN
         !IF(binwrite)THEN
            !WRITE (6,'(a)')'Writing file '//trim(prefix)//'.bwfn.data.b1'//trim(postfix)//' for program CASINO.'
            !OPEN( iob, file=trim(tmp_dir)//trim(prefix)//'.bwfn.data.b1'//trim(postfix), &
                  !form='unformatted', action='write', access='sequential')
         !ELSE
            !WRITE (6,'(a)')'Writing file '//trim(prefix)//'.bwfn.data'//trim(postfix)//' for program CASINO.'
            !OPEN( io, file=trim(tmp_dir)//trim(prefix)//'.bwfn.data'//trim(postfix), &
                  !form='formatted', action='write', access='sequential')
         !ENDIF
      !ELSE
         !IF(gather)THEN
            !WRITE (6,'(a)')'Writing file '//trim(prefix)//'.pwfn.data'//trim(postfix)//' for program CASINO.'
            !OPEN( io, file=trim(tmp_dir)//trim(prefix)//'.pwfn.data'//trim(postfix), & 
                  !form='formatted', action='write', access='sequential')
         !ELSE
            !WRITE (6,'(a)')'Writing one file per node '//trim(prefix)//'.pwfn.data'//trim(postfix)//'.XX for program CASINO'
            !CALL seqopn( io, 'pwfn.data'//trim(postfix), 'formatted',exst)
         !ENDIF
      !ENDIF
      !WRITE (6,'(a)')
   !ENDIF

   !ALLOCATE ( g_l(3,ngtot_l), evc_l(ngtot_l) )
   !DO ig = 1, ngtot_l
      !g_l(:,ig) = g(:,igtog(ig))
   !ENDDO

   !IF(gather.or.blip)THEN
      !ALLOCATE ( ngtot_d(nproc_pool), ngtot_cumsum(nproc_pool) )
      !CALL mp_gather( ngtot_l, ngtot_d, ionode_id, intra_pool_comm )
      !CALL mp_bcast( ngtot_d, ionode_id, intra_pool_comm )
      !id = 0
      !DO ip = 1,nproc_pool
         !ngtot_cumsum(ip) = id
         !id = id + ngtot_d(ip)
      !ENDDO
      !ngtot_g = id

      !ALLOCATE ( g_g(3,ngtot_g), g2(ngtot_g), evc_g(ngtot_g) )
      !IF(blip.and.gamma_only)THEN
         !ALLOCATE( evc_g2(ngtot_g) )
      !ENDIF
      !CALL mp_gather( g_l, g_g, ngtot_d, ngtot_cumsum, ionode_id, intra_pool_comm)

      !IF(blip)THEN
         !CALL mp_bcast( g_g, ionode_id, intra_pool_comm )
         !g2(:) = sum(g_g(:,:)**2,dim=1)
         !CALL pw2blip_init(ngtot_g,g_g,multiplicity)
         !IF(dowrite)THEN
            !WRITE (6,'(a)')'Blip grid: '//trim(i2s(blipgrid(1)))//'x'//trim(i2s(blipgrid(2)))//'x'//trim(i2s(blipgrid(3)))
            !WRITE (6,'(a)')
         !ENDIF
      !ELSEIF(dowrite)THEN
         !ALLOCATE ( indx(ngtot_g) )
         !CALL create_index2(g_g,indx)
      !ENDIF
   !ELSEIF(dowrite)THEN
      !ALLOCATE ( indx(ngtot_l) )
      !CALL create_index2(g_l,indx)
   !ENDIF

   !IF(dowrite)THEN
      !CALL write_header
      !IF(blip)THEN
         !CALL write_gvecs_blip
      !ELSEIF(gather)THEN
         !CALL write_gvecs(g_g,indx)
      !ELSE
         !CALL write_gvecs(g_l,indx)
      !ENDIF
      !CALL write_wfn_head
   !ENDIF

   !IF(dowrite.and.blip.and.binwrite)THEN
      !IF(gamma_only)THEN
         !ALLOCATE(avc_tmp(blipgrid(1),blipgrid(2),blipgrid(3)))
      !ELSE
         !ALLOCATE(cavc_tmp(blipgrid(1),blipgrid(2),blipgrid(3)))
      !ENDIF
   !ENDIF

   !! making some assumptions about the parallel layout:
   !IF(ionode_id/=0)CALL errore('write_casino_wfn','ionode_id/=0: ',ionode_id)

   !iorb = 0
   !norb = nk*nspin*nbnd

   !DO ik = 1, nk
      !DO ispin = 1, nspin
         !ikk = ik + nk*(ispin-1)
         !npw = ngk(ikk)
         !IF( nks > 1 ) CALL get_buffer(evc,nwordwfc,iunwfc,ikk)
         !DO ibnd = 1, nbnd
            !evc_l(:) = (0.d0, 0d0)
            !evc_l(gtoig(igk_k(1:npw,ikk))) = evc(1:npw,ibnd)
            !IF(blip)THEN
               !iorb = iorb + 1
               !IF(gamma_only)THEN
                  !iorb_node = mod((iorb-1)/2,nproc_pool) ! the node that should compute this orbital
                  !IF(mod(iorb,2)==0)THEN
                     !jk2(iorb_node+1) = ik
                     !jspin2(iorb_node+1) = ispin
                     !jbnd2(iorb_node+1) = ibnd
                     !dotransform = (iorb_node==nproc_pool-1)
                  !ELSE
                     !jk(iorb_node+1) = ik
                     !jspin(iorb_node+1) = ispin
                     !jbnd(iorb_node+1) = ibnd
                     !dotransform = .false.
                  !ENDIF
               !ELSE
                  !iorb_node = mod(iorb-1,nproc_pool) ! the node that should compute this orbital
                  !jk(iorb_node+1) = ik
                  !jspin(iorb_node+1) = ispin
                  !jbnd(iorb_node+1) = ibnd
                  !dotransform=(iorb_node==nproc_pool-1)
               !ENDIF
               !DO inode=0,nproc_pool-1
                  !IF(gamma_only.and.mod(iorb,2)==0)THEN
                     !CALL mp_get(&
                        !evc_g2(ngtot_cumsum(inode+1)+1:ngtot_cumsum(inode+1)+ngtot_d(inode+1)),&
                        !evc_l(:),me_pool,iorb_node,inode,1234,intra_pool_comm)
                  !ELSE
                     !CALL mp_get(&
                        !evc_g(ngtot_cumsum(inode+1)+1:ngtot_cumsum(inode+1)+ngtot_d(inode+1)),&
                        !evc_l(:),me_pool,iorb_node,inode,1234,intra_pool_comm)
                  !ENDIF
               !ENDDO
               !IF(dotransform .or. iorb == norb)THEN
                  !IF(me_pool <= iorb_node)THEN
                     !IF(gamma_only.and.(me_pool/=iorb_node.or.iorb/=norb.or.mod(norb,2)==0))THEN
                        !CALL pw2blip_transform2(evc_g(:),evc_g2(:))
                     !ELSE
                        !CALL pw2blip_transform(evc_g(:))
                     !ENDIF
                  !ENDIF
                  !IF(me_pool <= iorb_node) CALL test_overlap
                  !DO inode=0,iorb_node
                     !CALL pw2blip_get(inode)
                     !IF(gamma_only)THEN
                        !IF(ionode)WRITE(6,*)"Transformed real orbital k="//trim(i2s(jk(inode+1)))//&
                           !&", spin="//trim(i2s(jspin(inode+1)))//&
                           !&", band="//trim(i2s(jbnd(inode+1)))//" on node "//trim(i2s(inode))
                        !CALL print_overlap(inode,1)
                        !IF(blipreal==2)THEN
                           !IF(ionode)WRITE(6,*)"Transformed real orbital k="//trim(i2s(jk2(inode+1)))//&
                              !&", spin="//trim(i2s(jspin2(inode+1)))//&
                              !&", band="//trim(i2s(jbnd2(inode+1)))//" on node "//trim(i2s(inode))
                        !ENDIF
                        !CALL print_overlap(inode,2)
                     !ELSE
                        !IF(ionode)WRITE(6,*)"Transformed complex orbital k="//trim(i2s(jk(inode+1)))//&
                           !&", spin="//trim(i2s(jspin(inode+1)))//&
                           !&", band="//trim(i2s(jbnd(inode+1)))//" on node "//trim(i2s(inode))
                        !CALL print_overlap(inode,1)
                     !ENDIF
                     !IF(gamma_only)THEN
                        !IF(ionode)CALL write_bwfn_data_gamma(1,jk(inode+1),jspin(inode+1),jbnd(inode+1))
                        !IF(blipreal==2)THEN
                           !IF(ionode)CALL write_bwfn_data_gamma(2,jk2(inode+1),jspin2(inode+1),jbnd2(inode+1))
                        !ENDIF
                     !ELSE
                        !IF(ionode)CALL write_bwfn_data(jk(inode+1),jspin(inode+1),jbnd(inode+1))
                     !ENDIF
                  !ENDDO
               !ENDIF

            !ELSEIF(gather)THEN
               !CALL mp_gather( evc_l, evc_g, ngtot_d, ngtot_cumsum, ionode_id, intra_pool_comm)
               !IF(dowrite)CALL write_pwfn_data(ik,ispin,ibnd,evc_g,indx)
            !ELSE
               !CALL write_pwfn_data(ik,ispin,ibnd,evc_l,indx)
            !ENDIF
         !ENDDO
      !ENDDO
   !ENDDO
   !IF(dowrite)THEN
      !IF(binwrite)THEN
         !CLOSE(iob)
      !ELSE
         !CLOSE(io)
      !ENDIF
   !ENDIF
   !IF(dowrite.and.blip.and.binwrite)THEN
      !IF(gamma_only)THEN
         !DEALLOCATE(avc_tmp)
      !ELSE
         !DEALLOCATE(cavc_tmp)
      !ENDIF
   !ENDIF

   !IF(blip)CALL pw2blip_cleanup
   !DEALLOCATE (igtog, g_l, evc_l )
   !IF(blip.or.gather) DEALLOCATE ( ngtot_d, ngtot_cumsum, g_g, evc_g )
   !IF(dowrite.and..not.blip) DEALLOCATE (indx)

!CONTAINS

   SUBROUTINE qepy_calc_energies(embed)
      USE becmod, ONLY: becp, calbec, allocate_bec_type, deallocate_bec_type, is_allocated_bec_type
      USE exx,    ONLY : exxenergy2, fock2
      USE funct,  ONLY : dft_is_hybrid
      USE kinds, ONLY: DP,sgl
      USE ions_base, ONLY : nat, ntyp => nsp, ityp, tau, zv, atm
      USE cell_base, ONLY: omega, alat, tpiba2, at, bg
      USE run_info,  ONLY: title    ! title of the run
      USE constants, ONLY: tpi, e2, eps6
      !qepy --> 
      !USE ener, ONLY: ewld, ehart, etxc, vtxc, etot, etxcc, demet, ef
      !qepy <-- 
      USE fft_base,  ONLY: dfftp
      USE fft_interfaces, ONLY : fwfft
      USE gvect, ONLY: ngm, gstart, g, gg, gcutm, igtongl
      USE klist , ONLY: nks, nelec, xk, wk, degauss, ngauss, igk_k, ngk
      USE lsda_mod, ONLY: lsda, nspin
      USE scf, ONLY: rho, rho_core, rhog_core, v, vnew, vrs
      USE ldaU, ONLY : eth
      USE vlocal, ONLY: vloc, strf
      USE wvfct, ONLY: npwx, nbnd, wg, et
      USE gvecw, ONLY: ecutwfc
      USE control_flags, ONLY : gamma_only
      USE uspp, ONLY: nkb, vkb, dvan
      USE uspp_param, ONLY: nh
      USE io_global, ONLY: stdout, ionode, ionode_id
      USE io_files, ONLY: nd_nmbr, nwordwfc, iunwfc, prefix, tmp_dir, seqopn
      USE wavefunctions, ONLY : evc
      USE funct, ONLY : dft_is_meta
      USE mp_pools, ONLY: inter_pool_comm, intra_pool_comm, nproc_pool, me_pool
      USE mp_bands, ONLY: intra_bgrp_comm
      USE mp, ONLY: mp_sum, mp_gather, mp_bcast, mp_get
      USE buffers,              ONLY : get_buffer

      USE pw2blip
      !
      !qepy --> import more
      USE qepy_common,          ONLY : embed_base
      USE ener,                 ONLY : etot, hwf_energy, eband, deband, ehart, &
                                       vtxc, etxc, etxcc, ewld, demet, epaw, &
                                       elondon, edftd3, ef_up, ef_dw, exdm, ef
      USE control_flags,        ONLY : mixing_beta, tr2, ethr, niter, nmix, &
                                       iprint, conv_elec, &
                                       restart, io_level, do_makov_payne,  &
                                       iverbosity, textfor,     &
                                       llondon, ldftd3, scf_must_converge, lxdm, ts_vdw
    
      USE ldaU,                 ONLY : lda_plus_u
      USE extfield,             ONLY : tefield, etotefield, gate, etotgatefield !TB
      USE london_module,        ONLY : energy_london
      USE dftd3_api,            ONLY : dftd3_pbc_dispersion, &
                                       dftd3_init, dftd3_set_functional, &
                                       get_atomic_number, dftd3_input, &
                                       dftd3_calc
      USE dftd3_qe,             ONLY : dftd3, dftd3_in, energy_dftd3, dftd3_xc, dftd3_printout
      USE xdm_module,           ONLY : energy_xdm
      USE tsvdw_module,         ONLY : EtsvdW
      !
      USE paw_variables,        ONLY : okpaw, ddd_paw, total_core_energy, only_paw
      USE paw_onecenter,        ONLY : PAW_potential
      USE paw_symmetry,         ONLY : PAW_symmetrize_ddd
      USE dfunct,               ONLY : newd
      USE esm,                  ONLY : do_comp_esm, esm_printpot, esm_ewald
      USE fcp_variables,        ONLY : lfcpopt, lfcpdyn
      USE ions_base,            ONLY : compute_eextfor
      USE bp,                   ONLY : lelfield
      USE klist,                ONLY : tot_charge
      USE noncollin_module,     ONLY : noncolin, magtot_nc, i_cons,  bfield, &
                                       lambda, report
      USE lsda_mod,             ONLY : lsda, nspin, magtot, absmag, isk
      USE spin_orb,             ONLY : domag
      !qepy <-- import more
      !
      IMPLICIT NONE

      type(embed_base), intent(inout)    :: embed
      !
      COMPLEX(DP), ALLOCATABLE :: aux(:)
      INTEGER :: npw, ibnd, j, ig, ik,ikk, ispin, na, nt, ijkb0, ikb,jkb, ih,jh
      REAL(dp), ALLOCATABLE :: g2kin(:)
      !qepy --> remove etotefield
      !REAL(DP) :: charge, etotefield, elocg
      REAL(DP) :: charge, elocg
      !qepy <-- remove etotefield
      REAL(DP) :: ek, eloc, enl, etot_
      REAL (DP), EXTERNAL :: ewald, w1gauss
      INTEGER :: nk
      !
      REAL(DP) :: eext
      REAL(DP) :: latvecs(3,3)
      INTEGER  :: atnum(1:nat)
      REAL(DP) :: etot_cmp_paw(nat,2,2)
      CHARACTER(LEN=256):: dft_
      REAL (DP), EXTERNAL :: get_clock
      !
      REAL(DP) :: extene
      REAL(DP) :: ehf
      REAL(DP) :: deband_hwf
      REAL(DP), EXTERNAL :: qepy_delta_e
      !

      IF( lsda )THEN
         !nbndup = nbnd
         !nbnddown = nbnd
         nk = nks/2
         !     nspin = 2
      ELSE
         !nbndup = nbnd
         !nbnddown = 0
         nk = nks
         !     nspin = 1
      ENDIF

      ALLOCATE (aux(dfftp%nnr))
      !qepy
      if (is_allocated_bec_type(becp)) call deallocate_bec_type(becp)
      !
      CALL allocate_bec_type ( nkb, nbnd, becp )

      ek  = 0.d0
      eloc= 0.d0
      enl = 0.d0
      demet=0.d0
      fock2=0.d0
      !
      ALLOCATE ( g2kin(npwx) )
      DO ispin = 1, nspin
         !
         !     calculate the local contribution to the total energy
         !
         !      bring rho to G-space
         !
         if (iand(embed%exttype,1) == 0) then ! 
         aux(:) = cmplx( rho%of_r(:,ispin), 0.d0,kind=DP)
         CALL fwfft ('Rho', aux, dfftp)
         !
         DO nt=1,ntyp
            DO ig = 1, ngm
               elocg = vloc(igtongl(ig),nt) * &
                       dble ( strf(ig,nt) * conjg(aux(dfftp%nl(ig))) )
               eloc = eloc + elocg
               IF( gamma_only .and. ig>=gstart) eloc = eloc + elocg
            ENDDO
         ENDDO
         end if

         DO ik = 1, nk
            ikk = ik + nk*(ispin-1)
            npw = ngk(ikk)
            IF( nks > 1 ) CALL get_buffer (evc, nwordwfc, iunwfc, ikk )
            IF ( nkb > 0 ) THEN
               CALL init_us_2 (npw, igk_k(1,ikk), xk (1, ikk), vkb)
               CALL calbec ( npw, vkb, evc, becp )
            ENDIF
            !
            ! -TS term for metals (if any)
            !
            IF( degauss > 0.0_dp)THEN
               DO ibnd = 1, nbnd
                  demet = demet + wk (ik) * &
                     degauss * w1gauss ( (ef-et(ibnd,ik)) / degauss, ngauss)
               ENDDO
            ENDIF
            !
            ! calculate the kinetic energy
            !
            g2kin(1:npw) = ( ( xk(1,ikk) + g(1,igk_k(1:npw,ikk)) )**2 + &
                             ( xk(2,ikk) + g(2,igk_k(1:npw,ikk)) )**2 + &
                             ( xk(3,ikk) + g(3,igk_k(1:npw,ikk)) )**2 ) * tpiba2
            DO ibnd = 1, nbnd
               DO j = 1, npw
                  IF(gamma_only)THEN !.and.j>1)then
                     ek = ek +  2*conjg(evc(j,ibnd)) * evc(j,ibnd) * &
                                    g2kin(j) * wg(ibnd,ikk)
                  ELSE
                     ek = ek +  conjg(evc(j,ibnd)) * evc(j,ibnd) * &
                                    g2kin(j) * wg(ibnd,ikk)
                  ENDIF
               ENDDO

               !
               ! Calculate Non-local energy
               !
               ijkb0 = 0
               DO nt = 1, ntyp
                  DO na = 1, nat
                     IF(ityp (na) == nt)THEN
                        DO ih = 1, nh (nt)
                           ikb = ijkb0 + ih
                           IF(gamma_only)THEN
                              enl=enl+becp%r(ikb,ibnd)*becp%r(ikb,ibnd) &
                                 *wg(ibnd,ikk)* dvan(ih,ih,nt)
                           ELSE
                              enl=enl+conjg(becp%k(ikb,ibnd))*becp%k(ikb,ibnd) &
                                 *wg(ibnd,ikk)* dvan(ih,ih,nt)
                           ENDIF
                           DO jh = ( ih + 1 ), nh(nt)
                              jkb = ijkb0 + jh
                              IF(gamma_only)THEN
                                 enl=enl + &
                                    (becp%r(ikb,ibnd)*becp%r(jkb,ibnd)+&
                                       becp%r(jkb,ibnd)*becp%r(ikb,ibnd))&
                                    * wg(ibnd,ikk) * dvan(ih,jh,nt)
                              ELSE
                                 enl=enl + &
                                    (conjg(becp%k(ikb,ibnd))*becp%k(jkb,ibnd)+&
                                       conjg(becp%k(jkb,ibnd))*becp%k(ikb,ibnd))&
                                    * wg(ibnd,ikk) * dvan(ih,jh,nt)
                              ENDIF

                           ENDDO

                        ENDDO
                        ijkb0 = ijkb0 + nh (nt)
                     ENDIF
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
      ENDDO

      DEALLOCATE ( g2kin )
      extene=0.0_DP
      IF (ALLOCATED(embed%extpot)) THEN
         extene = sum(embed%extpot(:,:)*rho%of_r(:,:)) * omega / ( dfftp%nr1*dfftp%nr2*dfftp%nr3 )
      ENDIF
      !
      deband_hwf = qepy_delta_e(vrs)
      !
#if defined(__MPI)
      CALL mp_sum( eloc,  intra_bgrp_comm )
      CALL mp_sum( ek,    intra_bgrp_comm )
      CALL mp_sum( ek,    inter_pool_comm )
      CALL mp_sum( enl,   inter_pool_comm )
      CALL mp_sum( demet, inter_pool_comm )
      CALL mp_sum( extene,  intra_bgrp_comm )
#endif
      eloc = eloc * omega
      !
      ! compute ewald contribution
      !
      if (embed%lewald) then
         IF ( do_comp_esm ) THEN
            ewld = esm_ewald()
         ELSE
         ewld = ewald( alat, nat, ntyp, ityp, zv, at, bg, tau, omega, &
              g, gg, ngm, gcutm, gstart, gamma_only, strf )
         ENDIF
      else
         ewld=0.0_DP
      end if
      !
      ! compute hartree and xc contribution
      !
      !qepy --> also paw
      call qepy_v_of_rho_all( rho, rho_core, rhog_core, &
                     ehart, etxc, vtxc, eth, etotefield, charge, v, embed)
      !qepy <-- also paw
      !
      ! compute exact exchange contribution (if present)
      !
      IF(dft_is_hybrid()) fock2 = 0.5_DP * exxenergy2()
      !
      etot_=(ek + (etxc-etxcc)+ehart+eloc+enl+ewld)+demet+fock2
      !
      !
      !IF ( ABS(etot-etot_) > ABS(eps6*etot) ) THEN
         !WRITE (stdout,'(5X,"Etot: ",f15.8," Ry from PWscf vs ", &
                !& f15.8," Ry from pw2casino!")') etot, etot_
         !CALL errore("pw2casino","Mismatch in computed energy",1)
      !ELSE
         !etot = etot_
      !END IF
      !
      !qepy --> additional energies (electrons_scf)
      IF ( llondon ) THEN
         elondon = energy_london( alat , nat , ityp , at ,bg , tau )
      ELSE
         elondon = 0.d0
      ENDIF
      !
      ! Grimme-D3 correction to the energy
      !
      IF (ldftd3) THEN
         latvecs(:,:)=at(:,:)*alat
         tau(:,:)=tau(:,:)*alat
         DO na = 1, nat
            atnum(na) = get_atomic_number(TRIM(atm(ityp(na))))
         ENDDO
         call dftd3_pbc_dispersion(dftd3,tau,atnum,latvecs,energy_dftd3)
         edftd3=energy_dftd3*2.d0
         tau(:,:)=tau(:,:)/alat
      ELSE
         edftd3= 0.0
      ENDIF
      !
      IF (okpaw) etot_ = etot_ + epaw
      IF ( lda_plus_u ) etot_ = etot_ + eth
      !
      !IF ( lelfield ) en_el =  calc_pol ( )
      !IF ( lelfield ) etot_ = etot_ + en_el
      ! not sure about the HWF functional in the above case
      IF( textfor ) THEN
         eext = alat*compute_eextfor()
         etot_ = etot_ + eext
      ENDIF
      IF (llondon) THEN
         etot_ = etot_ + elondon
      ENDIF
      !
      ! grimme-d3 dispersion energy
      IF (ldftd3) THEN
         etot_ = etot_ + edftd3
      ENDIF
      !
      ! calculate the xdm energy contribution with converged density
      !IF (lxdm .and. conv_elec) THEN
      IF (lxdm) THEN
         exdm = energy_xdm()  
         etot_ = etot_ + exdm
      ENDIF
      IF (ts_vdw) THEN
         ! factor 2 converts from Ha to Ry units
         etot_ = etot_ + 2.0d0*EtsvdW
      ENDIF
      !
      IF ( tefield ) THEN
         etot_ = etot_ + etotefield
      ENDIF
      ! TB gate energy
      IF ( gate) THEN
         etot_ = etot_ + etotgatefield
      ENDIF
      !
      IF ( lfcpopt .or. lfcpdyn ) THEN
         etot_ = etot_ + ef * tot_charge
      ENDIF
      !
      !deband_hwf = deband
      !ehf = etot_ + eband + deband_hwf - eloc - enl - ek
      ehf = etot_ + eband + deband_hwf - enl - ek
      !qepy <-- additional energies (electrons_scf)
      !
      CALL deallocate_bec_type (becp)
      DEALLOCATE (aux)

      WRITE (stdout,*)
      WRITE (stdout,*) 'Energies determined by pw2casino tool'
      WRITE (stdout,*) '-------------------------------------'
      WRITE (stdout,*) 'Kinetic energy   ', ek/e2, ' au  =  ', ek, ' Ry'
      WRITE (stdout,*) 'Local energy     ', eloc/e2, ' au  =  ', eloc, ' Ry'
      WRITE (stdout,*) 'Non-Local energy ', enl/e2, ' au  =  ', enl, ' Ry'
      WRITE (stdout,*) 'Ewald energy     ', ewld/e2, ' au  =  ', ewld, ' Ry'
      WRITE (stdout,*) 'xc contribution  ',(etxc-etxcc)/e2, ' au  =  ', etxc-etxcc, ' Ry'
      WRITE (stdout,*) 'hartree energy   ', ehart/e2, ' au  =  ', ehart, ' Ry'
      IF(dft_is_hybrid()) & 
      WRITE (stdout,*) 'EXX energy       ', fock2/e2, ' au  =  ', fock2, ' Ry' 
      IF( degauss > 0.0_dp ) &
      WRITE (stdout,*) 'Smearing (-TS)   ', demet/e2, ' au  =  ', demet, ' Ry'
      WRITE (stdout,*) 'Total energy     ', etot/e2, ' au  =  ', etot, ' Ry'
      WRITE (stdout,*) '-------------------------------------'
      WRITE (stdout,*) 'Total energy0    ', etot_/e2, ' au  =  ', etot_, ' Ry'
      WRITE (stdout,*) 'External energy0 ', extene/e2, ' au  =  ', extene, ' Ry'
      IF ( llondon    ) WRITE( stdout, 9074 ) elondon
      IF ( ldftd3     ) WRITE( stdout, 9078 ) edftd3
      IF ( lxdm       ) WRITE( stdout, 9075 ) exdm
      IF ( ts_vdw     ) WRITE( stdout, 9076 ) 2.0d0*EtsvdW
      IF ( textfor    ) WRITE( stdout, 9077 ) eext
      IF ( tefield    ) WRITE( stdout, 9061 ) etotefield
      IF ( gate       ) WRITE( stdout, 9062 ) etotgatefield  ! TB
      IF ( lda_plus_u ) WRITE( stdout, 9065 ) eth
      IF ( okpaw ) THEN
        WRITE( stdout, 9067 ) epaw
        ! Detailed printout of PAW energy components, if verbosity is high
        !IF(iverbosity>0)THEN
        WRITE( stdout, 9068) SUM(etot_cmp_paw(:,1,1)), &
                             SUM(etot_cmp_paw(:,1,2)), &
                             SUM(etot_cmp_paw(:,2,1)), &
                             SUM(etot_cmp_paw(:,2,2)), &
        SUM(etot_cmp_paw(:,1,1))+SUM(etot_cmp_paw(:,1,2))+ehart, &
        SUM(etot_cmp_paw(:,2,1))+SUM(etot_cmp_paw(:,2,2))+etxc-etxcc
        !ENDIF
      ENDIF
      IF ( lfcpopt .OR. lfcpdyn ) WRITE( stdout, 9072 ) ef*tot_charge
      IF ( lsda ) WRITE( stdout, 9017 ) magtot, absmag
      IF ( noncolin .AND. domag ) &
           WRITE( stdout, 9018 ) magtot_nc(1:3), absmag
      IF ( i_cons == 3 .OR. i_cons == 4 )  &
           WRITE( stdout, 9071 ) bfield(1), bfield(2), bfield(3)
      IF ( i_cons /= 0 .AND. i_cons < 4 ) &
           WRITE( stdout, 9073 ) lambda
      !
      FLUSH( stdout )
9017 FORMAT(/'     total magnetization       =', F9.2,' Bohr mag/cell', &
            /'     absolute magnetization    =', F9.2,' Bohr mag/cell' )
9018 FORMAT(/'     total magnetization       =',3F9.2,' Bohr mag/cell' &
       &   ,/'     absolute magnetization    =', F9.2,' Bohr mag/cell' )
9061 FORMAT( '     electric field correction =',F17.8,' Ry' )
9062 FORMAT( '     gate field correction     =',F17.8,' Ry' ) ! TB
9065 FORMAT( '     Hubbard energy            =',F17.8,' Ry' )
9067 FORMAT( '     one-center paw contrib.   =',F17.8,' Ry' )
9068 FORMAT( '      -> PAW hartree energy AE =',F17.8,' Ry' &
            /'      -> PAW hartree energy PS =',F17.8,' Ry' &
            /'      -> PAW xc energy AE      =',F17.8,' Ry' &
            /'      -> PAW xc energy PS      =',F17.8,' Ry' &
            /'      -> total E_H with PAW    =',F17.8,' Ry'& 
            /'      -> total E_XC with PAW   =',F17.8,' Ry' )
9069 FORMAT( '     scf correction            =',F17.8,' Ry' )
9070 FORMAT( '     smearing contrib. (-TS)   =',F17.8,' Ry' )
9071 FORMAT( '     Magnetic field            =',3F12.7,' Ry' )
9072 FORMAT( '     pot.stat. contrib. (-muN) =',F17.8,' Ry' )
9073 FORMAT( '     lambda                    =',F11.2,' Ry' )
9074 FORMAT( '     Dispersion Correction     =',F17.8,' Ry' )
9075 FORMAT( '     Dispersion XDM Correction =',F17.8,' Ry' )
9076 FORMAT( '     Dispersion T-S Correction =',F17.8,' Ry' )
9077 FORMAT( '     External forces energy    =',F17.8,' Ry' )
9078 FORMAT( '     DFT-D3 Dispersion         =',F17.8,' Ry' )
      WRITE (stdout,*) '-------------------------------------'
      WRITE (stdout,*)
      embed%etotal=etot_
      !
      embed%energies%etot             = etot_                      !'Total energy'
      embed%energies%ek               = ek                         !'Kinetic energy'
      embed%energies%eloc             = eloc                       !'Local energy'
      embed%energies%enl              = enl                        !'Non-Local energy'
      embed%energies%ewld             = ewld                       !'Ewald energy'
      embed%energies%exc              = etxc-etxcc                 !'xc contribution'
      embed%energies%ehart            = ehart                      !'hartree energy'
      embed%energies%fock2            = fock2                      !'EXX energy'
      embed%energies%demet            = demet                      !'Smearing (-TS)'
      !
      embed%energies%ehf              = ehf
      !
      IF (llondon) THEN
         embed%energies%elondon       = elondon                    !'Dispersion Correction'
      ELSE
         embed%energies%elondon       = 0.d0
      ENDIF
      IF (ldftd3) THEN
         embed%energies%edftd3        = edftd3                     !'DFT-D3 Dispersion'
      ELSE
         embed%energies%edftd3        = 0.d0
      ENDIF
      IF (lxdm) THEN
         embed%energies%exdm          = exdm                       !'Dispersion XDM Correction'
      ELSE
         embed%energies%exdm          = 0.d0
      ENDIF
      IF (ts_vdw) THEN
         embed%energies%etsvdw        = 2.0d0*EtsvdW               !'Dispersion T-S Correction'
      ELSE
         embed%energies%etsvdw        = 0.d0
      ENDIF
      IF( textfor ) THEN
         embed%energies%eext          = eext                       !'External forces energy'
      ELSE
         embed%energies%eext          = 0.d0
      ENDIF
      IF ( tefield ) THEN
         embed%energies%etotefield    = etotefield                 !'electric field correction'
      ELSE
         embed%energies%etotefield    = 0.d0
      ENDIF
      IF ( gate) THEN
         embed%energies%etotgatefield = etotgatefield              !'gate field correction'
      ELSE
         embed%energies%etotgatefield = 0.d0
      ENDIF
      IF ( lda_plus_u ) THEN
         embed%energies%eth           = eth                        !'Hubbard energy'
      ELSE
         embed%energies%eth           = 0.d0
      ENDIF
      IF (okpaw) THEN
         embed%energies%epaw          = epaw                       !'one-center paw contrib.'
      ELSE
         embed%energies%epaw          = 0.d0
      ENDIF
      IF ( lfcpopt .or. lfcpdyn ) THEN
         embed%energies%ept           = ef * tot_charge            !'potentiostat contribution'
      ELSE
         embed%energies%ept           = 0.d0
      ENDIF
      !
      embed%energies%extene           = extene                     !'External energy0'
      ! some energies details -->
      embed%energies%etxc             = etxc                       ! the exchange and correlation energy
      embed%energies%etxcc            = etxcc                      ! the nlcc exchange and correlation
      IF (okpaw) THEN
         embed%energies%paw_ehart_ae  = SUM(etot_cmp_paw(:,1,1))   !'PAW hartree energy AE'
         embed%energies%paw_ehart_ps  = SUM(etot_cmp_paw(:,1,2))   !'PAW hartree energy PS'
         embed%energies%paw_exc_ae    = SUM(etot_cmp_paw(:,2,1))   !'PAW xc energy AE'
         embed%energies%paw_exc_ps    = SUM(etot_cmp_paw(:,2,2))   !'PAW xc energy PS'
      ELSE
         embed%energies%paw_ehart_ae  = 0.d0
         embed%energies%paw_ehart_ps  = 0.d0
         embed%energies%paw_exc_ae    = 0.d0
         embed%energies%paw_exc_ps    = 0.d0
      ENDIF
      ! <--

   END SUBROUTINE qepy_calc_energies


   !SUBROUTINE test_overlap
!! Carry out the overlap test described in the CASINO manual.
!! Repeat the whole test n_overlap_tests times, to compute error bars.
      !INTEGER i,j,k
      !REAL(dp) r(3)
      !COMPLEX(dp) xb(5),xp(5) ! 1->val, 2:4->grad, 5->lap
      !REAL(dp) xbb(5,2),xpp(5,2)
      !COMPLEX(dp) xbp(5,2)
      !REAL(dp) overlap(5,2),sum_overlap(5,2),sumsq_overlap(5,2)

      !IF(n_points_for_test<=0)RETURN
      !IF(n_overlap_tests<=0)RETURN

      !CALL init_rng(12345678)

      !sum_overlap(:,:)=0.d0 ; sumsq_overlap(:,:)=0.d0
      !DO j=1,n_overlap_tests
         !xbb(:,:)=0.d0 ; xpp(:,:)=0.d0 ; xbp(:,:)=0.d0

         !DO i=1,n_points_for_test
            !r(1)=ranx() ; r(2)=ranx() ; r(3)=ranx()
            !CALL blipeval(r,xb(1),xb(2:4),xb(5))
            !CALL pweval(r,xp(1),xp(2:4),xp(5))

            !IF(gamma_only)THEN
               !xbb(:,1)=xbb(:,1)+dble(xb(:))**2
               !xbp(:,1)=xbp(:,1)+dble(xb(:))*dble(xp(:))
               !xpp(:,1)=xpp(:,1)+dble(xp(:))**2
               !IF(blipreal==2)THEN
                  !! two orbitals - use complex and imaginary part independently
                  !xbb(:,2)=xbb(:,2)+aimag(xb(:))**2
                  !xbp(:,2)=xbp(:,2)+aimag(xb(:))*aimag(xp(:))
                  !xpp(:,2)=xpp(:,2)+aimag(xp(:))**2
               !ENDIF
            !ELSE
               !xbb(:,1)=xbb(:,1)+dble(xb(:))**2+aimag(xb(:))**2
               !xbp(:,1)=xbp(:,1)+xb(:)*conjg(xp(:))
               !xpp(:,1)=xpp(:,1)+dble(xp(:))**2+aimag(xp(:))**2
            !ENDIF
         !ENDDO ! i
         !overlap(:,:)=0.d0
         !DO k=1,5
            !IF(xbb(k,1)/=0.d0.and.xpp(k,1)/=0.d0)THEN
               !overlap(k,1)=(dble(xbp(k,1))**2+aimag(xbp(k,1))**2)/(xbb(k,1)*xpp(k,1))
            !ENDIF ! xb & xd nonzero
         !ENDDO ! k

         !IF(blipreal==2)THEN
            !DO k=1,5
               !IF(xbb(k,2)/=0.d0.and.xpp(k,2)/=0.d0)THEN
                  !overlap(k,2)=(dble(xbp(k,2))**2+aimag(xbp(k,2))**2)/(xbb(k,2)*xpp(k,2))
               !ENDIF ! xb & xd nonzero
            !ENDDO ! k
         !ELSE
         !ENDIF
         !sum_overlap(:,:)=sum_overlap(:,:)+overlap(:,:)
         !sumsq_overlap(:,:)=sumsq_overlap(:,:)+overlap(:,:)**2
      !ENDDO ! j
      !av_overlap(:,:)=sum_overlap(:,:)/dble(n_overlap_tests)
      !avsq_overlap(:,:)=sumsq_overlap(:,:)/dble(n_overlap_tests)

   !END SUBROUTINE test_overlap


   !SUBROUTINE pweval(r,val,grad,lap)
      !DOUBLE PRECISION,INTENT(in) :: r(3)
      !COMPLEX(dp),INTENT(out) :: val,grad(3),lap

      !INTEGER ig
      !REAL(dp) dot_prod
      !COMPLEX(dp) eigr,eigr2

      !REAL(dp),PARAMETER :: pi=3.141592653589793238462643d0
      !COMPLEX(dp),PARAMETER :: iunity=(0.d0,1.d0)

      !val=0.d0 ; grad(:)=0.d0 ; lap=0.d0
      !DO ig=1,ngtot_g
         !dot_prod=tpi*sum(dble(g_int(:,ig))*r(:))
         !eigr=evc_g(ig)*cmplx(cos(dot_prod),sin(dot_prod),KIND=dp)
         !IF(.not.gamma_only)THEN
            !val=val+eigr
            !grad(:)=grad(:)+(eigr*iunity)*dble(g_int(:,ig))
            !lap=lap-eigr*g2(ig)
         !ELSEIF(blipreal==1)THEN
            !IF(all(g_int(:,ig)==0))eigr=eigr*0.5d0
            !val=val+dble(eigr)
            !grad(:)=grad(:)-aimag(eigr)*dble(g_int(:,ig))
            !lap=lap-dble(eigr)*g2(ig)
         !ELSEIF(blipreal==2)THEN
            !eigr2=evc_g2(ig)*cmplx(cos(dot_prod),sin(dot_prod),KIND=dp)
            !IF(all(g_int(:,ig)==0))THEN
               !eigr=eigr*0.5d0
               !eigr2=eigr2*0.5d0
            !ENDIF
            !val=val+cmplx(dble(eigr),dble(eigr2),KIND=dp)
            !grad(:)=grad(:)+cmplx(-aimag(eigr),-aimag(eigr2),KIND=dp)*dble(g_int(:,ig))
            !lap=lap-cmplx(dble(eigr),dble(eigr2),KIND=dp)*g2(ig)
         !ENDIF
      !ENDDO ! ig
      !IF(gamma_only)THEN
         !val = val*2.d0
         !grad(:) = grad(:)*2.d0
         !lap = lap*2.d0
      !ENDIF
      !grad(:)=matmul(bg(:,:),grad(:))*(tpi/alat)
      !lap=lap*(tpi/alat)**2
   !END SUBROUTINE pweval


   !SUBROUTINE print_overlap(inode,whichband)
!!-------------------------------------------------------------------------!
!! Write out the overlaps of the value, gradient and Laplacian of the blip !
!! orbitals.  Give error bars where possible.                              !
!!-------------------------------------------------------------------------!
      !INTEGER,INTENT(in) :: inode
      !INTEGER,INTENT(in) :: whichband ! 1 or 2, indexing within a pair of real orbitals
      !REAL(dp) :: av(5),avsq(5),err(5)
      !INTEGER k
      !CHARACTER(12) char12_arr(5)

      !IF(n_points_for_test<=0)RETURN
      !IF(n_overlap_tests<=0)RETURN

      !CALL mp_get(av(:),av_overlap(:,whichband),me_pool,ionode_id,inode,6434,intra_pool_comm)
      !CALL mp_get(avsq(:),avsq_overlap(:,whichband),me_pool,ionode_id,inode,6434,intra_pool_comm)

      !IF(.not.ionode)RETURN
      !IF(blipreal==1.and.whichband==2)RETURN

      !IF(n_overlap_tests<2)THEN
         !WRITE(stdout,*)'Error: need at least two overlap tests, to estimate error bars.'
         !STOP
      !ENDIF ! Too few overlap tests
      !err(:)=sqrt(max(avsq(:)-av(:)**2,0.d0)/dble(n_overlap_tests-1))
      !DO k=1,5
         !char12_arr(k)=trim(write_mean(av(k),err(k)))
      !! Not room to quote error bar.  Just quote mean.
         !IF(index(char12_arr(k),')')==0)WRITE(char12_arr(k),'(f12.9)')av(k)
      !ENDDO ! k
      !WRITE(stdout,'(2(1x,a),2x,3(1x,a))')char12_arr(1:5)
   !END SUBROUTINE print_overlap


   !FUNCTION to_c80(c)
      !CHARACTER(*),INTENT(in) :: c
      !CHARACTER(80) :: to_c80
      !to_c80=c
   !END FUNCTION to_c80

   !SUBROUTINE write_header
      !INTEGER j, na, nt, at_num
      !REAL(dp) :: kvec(3,nk),ksq(nk),kprod(6,nk)

      !IF(blip.and.binwrite)THEN
         !WRITE(iob)&
            !to_c80(title)    ,&
            !to_c80("PWSCF")  ,&
            !to_c80("DFT")    ,&
            !to_c80("unknown"),&
            !to_c80("unknown"),&
            !dble(ecutwfc/2)  ,&
            !lsda             ,&
            !dble(etot/e2)    ,&
            !dble(ek/e2)      ,&
            !dble(eloc/e2)    ,&
            !dble(enl/e2)     ,&
            !dble(ehart/e2)   ,&
            !dble(ewld/e2)    ,&
            !nint(nelec)      ,&
            !nat              ,&
            !ngtot_g          ,&
            !nk               ,&
            !blipgrid(1:3)    ,&
            !nbnd             ,&
            !gamma_only       ,&
            !.true.           ,&
            !(/0,0/)          ,&
            !alat*at(1:3,1)   ,&
            !alat*at(1:3,2)   ,&
            !alat*at(1:3,3)   ,&
            !2                ,&
            !nbnd

!!     some old PGI compiler seems to choke on this commented version....
!!             to_c80(title)    ,& ! title
!!             to_c80("PWSCF")  ,& ! code
!!             to_c80("DFT")    ,& ! method
!!             to_c80("unknown"),& ! functional
!!             to_c80("unknown"),& ! pseudo_type
!!             dble(ecutwfc/2)  ,&  ! plane_wave_cutoff
!!             lsda             ,&  ! spin_polarized,
!!             dble(etot/e2)    ,&  ! total_energy
!!             dble(ek/e2)      ,&  ! kinetic_energy
!!             dble(eloc/e2)    ,&  ! local_potential_energy
!!             dble(enl/e2)     ,&  ! non_local_potential_energy
!!             dble(ehart/e2)   ,&  ! electron_electron_energy
!!             dble(ewld/e2)    ,&  ! eionion
!!             nint(nelec)      ,&  ! num_electrons
!!             nat              ,&  ! nbasis
!!             ngtot_g          ,&  ! nwvec
!!             nk               ,&  ! nkvec
!!             blipgrid(1:3)    ,&  ! nr
!!             nbnd             ,&  ! maxband
!!             gamma_only       ,&  ! gamma_only
!!             .true.           ,&  ! ext_orbs_present
!!             (/0,0/)          ,&  ! no_loc_orbs
!!             alat*at(1:3,1)   ,&  ! pa1
!!             alat*at(1:3,2)   ,&  ! pa2
!!             alat*at(1:3,3)   ,&  ! pa3
!!             2                ,&  ! nspin_check
!!             nbnd                 ! num_nonloc_max

         !kvec(:,:) = tpi/alat*xk(1:3,1:nk)
         !kprod(1,:)=kvec(1,:)*kvec(1,:)
         !kprod(2,:)=kvec(2,:)*kvec(2,:)
         !kprod(3,:)=kvec(3,:)*kvec(3,:)
         !kprod(4,:)=kvec(1,:)*kvec(2,:)
         !kprod(5,:)=kvec(1,:)*kvec(3,:)
         !kprod(6,:)=kvec(2,:)*kvec(3,:)
         !ksq(:)=kprod(1,:)+kprod(2,:)+kprod(3,:)

         !WRITE(iob)&
            !kvec                                          ,&
            !ksq                                           ,&
            !kprod                                         ,&
            !(atomic_number(trim(atm(ityp(na)))),na=1,nat) ,&
            !(alat*tau(1:3,na),na=1,nat)                   ,&
            !(nbnd,j=1,nk*2)                               ,&
            !et(1:nbnd,1:nk*nspin)/e2                      ,&
            !(.true.,j=1,nbnd*nk*nspin)                    ,&
            !(/nbnd,nbnd/)

!!             kvec                                          ,& ! kvec
!!             ksq                                           ,& ! ksq
!!             kprod                                         ,& ! kprod
!!             (atomic_number(trim(atm(ityp(na)))),na=1,nat) ,& ! atno   -- atomic numbers
!!             (alat*tau(1:3,na),na=1,nat)                   ,& ! basis  -- atom positions
!!             (nbnd,j=1,nk*2)                               ,& ! nband
!!             et(1:nbnd,1:nk*nspin)/e2                      ,& ! eigenvalue
!!             (.true.,j=1,nbnd*nk*nspin)                    ,& ! on_this_cpu
!!             (/nbnd,nbnd/)                                    ! num_nonloc

         !WRITE(iob)single_precision_blips                    ! single_precision_blips

         !! IF(no_loc_orbs>0)THEN
         !!    ...
         !! ENDIF

         !WRITE(iob)&
          !(0,j=1,nbnd*nk*2) ,&
          !(0,j=1,nbnd*nk*2) ,&
          !(0,j=1,nbnd*nk*2) ,&
          !(0,j=1,nbnd*nk*2)

!!           (0,j=1,nbnd*nk*2) ,& ! orb_map_band
!!           (0,j=1,nbnd*nk*2) ,& ! orb_map_ik
!!           (0,j=1,nbnd*nk*2) ,& ! orb_map_iorb
!!           (0,j=1,nbnd*nk*2)    ! occupied
         !RETURN
      !ENDIF

      !WRITE(io,'(a)') title
      !WRITE(io,'(a)')
      !WRITE(io,'(a)') ' BASIC INFO'
      !WRITE(io,'(a)') ' ----------'
      !WRITE(io,'(a)') ' Generated by:'
      !WRITE(io,'(a)') '  PWSCF'
      !WRITE(io,'(a)') ' Method:'
      !WRITE(io,'(a)') '  DFT'
      !WRITE(io,'(a)') ' DFT Functional:'
      !WRITE(io,'(a)') '  unknown'
      !WRITE(io,'(a)') ' Pseudopotential'
      !WRITE(io,'(a)') '  unknown'
      !WRITE(io,'(a)') ' Plane wave cutoff (au)'
      !WRITE(io,*) ecutwfc/2
      !WRITE(io,'(a)') ' Spin polarized:'
      !WRITE(io,*)lsda
      !IF( degauss > 0.0_dp )THEN
         !WRITE(io,'(a)') ' Total energy (au per primitive cell; includes -TS term)'
         !WRITE(io,*)etot/e2, demet/e2
      !ELSE
         !WRITE(io,'(a)') ' Total energy (au per primitive cell)'
         !WRITE(io,*)etot/e2
      !ENDIF
      !WRITE(io,'(a)') ' Kinetic energy (au per primitive cell)'
      !WRITE(io,*)ek/e2
      !WRITE(io,'(a)') ' Local potential energy (au per primitive cell)'
      !WRITE(io,*)eloc/e2
      !WRITE(io,'(a)') ' Non local potential energy(au per primitive cell)'
      !WRITE(io,*)enl/e2
      !WRITE(io,'(a)') ' Electron electron energy (au per primitive cell)'
      !WRITE(io,*)ehart/e2
      !WRITE(io,'(a)') ' Ion-ion energy (au per primitive cell)'
      !WRITE(io,*)ewld/e2
      !WRITE(io,'(a)') ' Number of electrons per primitive cell'
      !WRITE(io,*)nint(nelec)
      !! uncomment the following ifyou want the Fermi energy - KN 2/4/09
      !!  WRITE(io,'(a)') ' Fermi energy (au)'
      !!  WRITE(io,*) ef/e2
      !WRITE(io,'(a)') ' '
      !WRITE(io,'(a)') ' GEOMETRY'
      !WRITE(io,'(a)') ' -------- '
      !WRITE(io,'(a)') ' Number of atoms per primitive cell '
      !WRITE(io,*) nat
      !WRITE(io,'(a)')' Atomic number and position of the atoms(au) '
      !DO na = 1, nat
         !nt = ityp(na)
         !at_num = atomic_number(trim(atm(nt)))
         !WRITE(io,'(i6,3f20.14)') at_num, (alat*tau(j,na),j=1,3)
      !ENDDO
      !WRITE(io,'(a)') ' Primitive lattice vectors (au) '
      !WRITE(io,100) alat*at(1,1), alat*at(2,1), alat*at(3,1)
      !WRITE(io,100) alat*at(1,2), alat*at(2,2), alat*at(3,2)
      !WRITE(io,100) alat*at(1,3), alat*at(2,3), alat*at(3,3)
      !WRITE(io,'(a)') ' '

  !100 FORMAT (3(1x,f20.15))

   !END SUBROUTINE write_header


   !SUBROUTINE write_gvecs(g,indx)
      !REAL(DP),INTENT(in) :: g(:,:)
      !INTEGER,INTENT(in) :: indx(:)
      !INTEGER ig

      !IF(binwrite)RETURN

      !WRITE(io,'(a)') ' G VECTORS'
      !WRITE(io,'(a)') ' ---------'
      !WRITE(io,'(a)') ' Number of G-vectors'
      !WRITE(io,*) size(g,2)
      !WRITE(io,'(a)') ' Gx Gy Gz (au)'
      !DO ig = 1, size(g,2)
         !WRITE(io,'(3(1x,f20.15))') &
         !&tpi/alat*g(1,indx(ig)),tpi/alat*g(2,indx(ig)),tpi/alat*g(3,indx(ig))
      !ENDDO

      !WRITE(io,'(a)') ' '
   !END SUBROUTINE write_gvecs


   !SUBROUTINE write_gvecs_blip
      !IF(binwrite)RETURN

      !WRITE(io,'(a)') ' G VECTORS'
      !WRITE(io,'(a)') ' ---------'
      !WRITE(io,'(a)') ' Number of G-vectors'
      !WRITE(io,*) 0
      !WRITE(io,'(a)') ' Gx Gy Gz (au)'
      !WRITE(io,'(a)') ' Blip grid'
      !WRITE(io,'(3(1x,3i4))') blipgrid

      !WRITE(io,'(a)') ' '
   !END SUBROUTINE write_gvecs_blip


   !SUBROUTINE write_wfn_head
      !IF(binwrite)RETURN

      !WRITE(io,'(a)') ' WAVE FUNCTION'
      !WRITE(io,'(a)') ' -------------'
      !WRITE(io,'(a)') ' Number of k-points'
      !WRITE(io,*) nk
   !END SUBROUTINE write_wfn_head


   !SUBROUTINE write_pwfn_data(ik,ispin,ibnd,evc,indx)
      !INTEGER,INTENT(in) :: ik,ispin,ibnd
      !COMPLEX(DP),INTENT(in) :: evc(:)
      !INTEGER,INTENT(in) :: indx(:)
      !INTEGER ig,j,ikk

      !IF(binwrite)RETURN

      !ikk = ik + nk*(ispin-1)
      !IF(ispin==1.and.ibnd==1)THEN
         !WRITE(io,'(a)') ' k-point # ; # of bands (up spin/down spin); &
               !&           k-point coords (au)'
         !WRITE(io,'(3i4,3f20.16)') ik, nbndup, nbnddown, &
               !(tpi/alat*xk(j,ik),j=1,3)
      !ENDIF
      !IF(binwrite)RETURN

      !! KN: if you want to print occupancies, replace these two lines ...
      !WRITE(io,'(a)') ' Band, spin, eigenvalue (au)'
      !WRITE(io,*) ibnd, ispin, et(ibnd,ikk)/e2
      !! ...with the following two - KN 2/4/09
      !! WRITE(io,'(a)') ' Band, spin, eigenvalue (au), occupation number'
      !! WRITE(io,*) ibnd, ispin, et(ibnd,ikk)/e2, wg(ibnd,ikk)/wk(ikk)
      !WRITE(io,'(a)') ' Eigenvectors coefficients'
      !DO ig=1, size(indx,1)
         !WRITE(io,*)evc(indx(ig))
      !ENDDO
   !END SUBROUTINE write_pwfn_data


   !SUBROUTINE write_bwfn_data(ik,ispin,ibnd)
      !INTEGER,INTENT(in) :: ik,ispin,ibnd
      !INTEGER lx,ly,lz,ikk,j,l1,l2,l3

      !IF(binwrite)THEN
         !DO l3=1,blipgrid(3)
            !DO l2=1,blipgrid(2)
               !DO l1=1,blipgrid(1)
                  !cavc_tmp(l1,l2,l3) = cavc(l1-1,l2-1,l3-1)
               !ENDDO
            !ENDDO
         !ENDDO

         !IF(single_precision_blips)THEN
            !WRITE(iob)cmplx(cavc_tmp(:,:,:),kind=sgl)
         !ELSE
            !WRITE(iob)cmplx(cavc_tmp(:,:,:),kind=DP)
         !ENDIF
         !RETURN
      !ENDIF

      !ikk = ik + nk*(ispin-1)
      !IF(ispin==1.and.ibnd==1)THEN
         !WRITE(io,'(a)') ' k-point # ; # of bands (up spin/down spin); &
               !&           k-point coords (au)'
         !WRITE(io,'(3i4,3f20.16)') ik, nbndup, nbnddown, &
               !(tpi/alat*xk(j,ik),j=1,3)
      !ENDIF
      !! KN: if you want to print occupancies, replace these two lines ...
      !WRITE(io,'(a)') ' Band, spin, eigenvalue (au), localized'
      !WRITE(io,*) ibnd, ispin, et(ibnd,ikk)/e2,'F'
      !! ...with the following two - KN 2/4/09
      !! WRITE(io,'(a)') ' Band, spin, eigenvalue (au), occupation number'
      !! WRITE(io,*) ibnd, ispin, et(ibnd,ikk)/e2, wg(ibnd,ikk)/wk(ikk)
      !WRITE(io,*)'Complex blip coefficients for extended orbital'
      !DO lx=0,blipgrid(1)-1
         !DO ly=0,blipgrid(2)-1
            !DO lz=0,blipgrid(3)-1
               !WRITE(io,*)cavc(lx,ly,lz)
            !ENDDO ! lz
         !ENDDO ! ly
      !ENDDO ! lx
   !END SUBROUTINE write_bwfn_data


   !SUBROUTINE write_bwfn_data_gamma(re_im,ik,ispin,ibnd)
      !INTEGER,INTENT(in) :: ik,ispin,ibnd,re_im
      !INTEGER lx,ly,lz,ikk,j,l1,l2,l3

      !IF(binwrite)THEN
         !IF(re_im==1)THEN
            !DO l3=1,blipgrid(3)
               !DO l2=1,blipgrid(2)
                  !DO l1=1,blipgrid(1)
                     !avc_tmp(l1,l2,l3) = avc1(l1-1,l2-1,l3-1)
                  !ENDDO
               !ENDDO
            !ENDDO
         !ELSE
            !DO l3=1,blipgrid(3)
               !DO l2=1,blipgrid(2)
                  !DO l1=1,blipgrid(1)
                     !avc_tmp(l1,l2,l3) = avc2(l1-1,l2-1,l3-1)
                  !ENDDO
               !ENDDO
            !ENDDO
         !ENDIF

         !IF(single_precision_blips)THEN
            !WRITE(iob)real(avc_tmp(:,:,:),kind=sgl)
         !ELSE
            !WRITE(iob)real(avc_tmp(:,:,:),kind=DP)
         !ENDIF
         !RETURN
      !ENDIF

      !ikk = ik + nk*(ispin-1)
      !IF(ispin==1.and.ibnd==1)THEN
         !WRITE(io,'(a)') ' k-point # ; # of bands (up spin/down spin); &
               !&           k-point coords (au)'
         !WRITE(io,'(3i4,3f20.16)') ik, nbndup, nbnddown, &
               !(tpi/alat*xk(j,ik),j=1,3)
      !ENDIF
      !! KN: if you want to print occupancies, replace these two lines ...
      !WRITE(io,'(a)') ' Band, spin, eigenvalue (au), localized'
      !WRITE(io,*) ibnd, ispin, et(ibnd,ikk)/e2,'F'
      !! ...with the following two - KN 2/4/09
      !! WRITE(io,'(a)') ' Band, spin, eigenvalue (au), occupation number'
      !! WRITE(io,*) ibnd, ispin, et(ibnd,ikk)/e2, wg(ibnd,ikk)/wk(ikk)
      !WRITE(io,*)'Real blip coefficients for extended orbital'
      !DO lx=0,blipgrid(1)-1
         !DO ly=0,blipgrid(2)-1
            !DO lz=0,blipgrid(3)-1
               !IF(re_im==1)THEN
                  !WRITE(io,*)avc1(lx,ly,lz)
               !ELSE
                  !WRITE(io,*)avc2(lx,ly,lz)
               !ENDIF
            !ENDDO ! lz
         !ENDDO ! ly
      !ENDDO ! lx
   !END SUBROUTINE write_bwfn_data_gamma


   !SUBROUTINE create_index2(y,x_index)
      !DOUBLE PRECISION,INTENT(in) :: y(:,:)
      !INTEGER,INTENT(out) :: x_index(size(y,2))
      !DOUBLE PRECISION y2(size(y,2))
      !INTEGER i
      !DO i = 1,size(y,2)
         !y2(i) = sum(y(:,i)**2)
      !ENDDO
      !CALL create_index(y2,x_index)
   !END SUBROUTINE create_index2


   !SUBROUTINE create_index(y,x_index)
 !!-----------------------------------------------------------------------------!
 !! This subroutine creates an index array x_index for the n items of data in   !
 !! the array y.  Adapted from Numerical Recipes.                               !
 !! Copied from merge_pwfn.f90, included with CASINO distribution               !
 !!-----------------------------------------------------------------------------!
      !IMPLICIT NONE
      !DOUBLE PRECISION,INTENT(in) :: y(:)
      !INTEGER,INTENT(out) :: x_index(:)
      !INTEGER,PARAMETER :: ins_sort_thresh=7,stacksize=80
      !INTEGER n,i,x_indexj,ir,itemp,j,jstack,k,l,lp1,istack(stacksize)
      !DOUBLE PRECISION yj
      !n=size(x_index)
      !DO j=1,n
         !x_index(j)=j
      !ENDDO ! j
      !IF(n<=1)RETURN
      !jstack=0
      !l=1
      !ir=n
      !DO
         !IF(ir-l<ins_sort_thresh)THEN
    !jloop : DO j=l+1,ir
               !x_indexj=x_index(j) ; yj=y(x_indexj)
               !DO i=j-1,l,-1
                  !IF(y(x_index(i))<=yj)THEN
                     !x_index(i+1)=x_indexj
                     !CYCLE jloop
                  !ENDIF! y(x_index(i))<=yj
                  !x_index(i+1)=x_index(i)
               !ENDDO ! i
               !x_index(l)=x_indexj
            !ENDDO jloop ! j
            !IF(jstack==0)RETURN
            !ir=istack(jstack)
            !l=istack(jstack-1)
            !jstack=jstack-2
         !ELSE
            !k=(l+ir)/2
            !lp1=l+1
            !itemp=x_index(k)    ; x_index(k)=x_index(lp1)  ; x_index(lp1)=itemp
            !IF(y(x_index(l))>y(x_index(ir)))THEN
               !itemp=x_index(l)   ; x_index(l)=x_index(ir)   ; x_index(ir)=itemp
            !ENDIF
            !IF(y(x_index(lp1))>y(x_index(ir)))THEN
               !itemp=x_index(lp1) ; x_index(lp1)=x_index(ir) ; x_index(ir)=itemp
            !ENDIF
            !IF(y(x_index(l))>y(x_index(lp1)))THEN
               !itemp=x_index(l)   ; x_index(l)=x_index(lp1)  ; x_index(lp1)=itemp
            !ENDIF
            !i=lp1
            !j=ir
            !x_indexj=x_index(lp1)
            !yj=y(x_indexj)
            !DO
               !DO
                  !i=i+1
                  !IF(y(x_index(i))>=yj)exit
               !ENDDO ! i
               !DO
                  !j=j-1
                  !IF(y(x_index(j))<=yj)exit
               !ENDDO ! j
               !IF(j<i)exit
               !itemp=x_index(i) ; x_index(i)=x_index(j) ; x_index(j)=itemp
            !ENDDO
            !x_index(lp1)=x_index(j)
            !x_index(j)=x_indexj
            !jstack=jstack+2
            !IF(jstack>stacksize)THEN
               !WRITE(6,*)'stacksize is too small.'
               !STOP
            !ENDIF! jstack>stacksize
            !IF(ir-i+1>=j-l)THEN
               !istack(jstack)=ir
               !istack(jstack-1)=i
               !ir=j-1
            !ELSE
               !istack(jstack)=j-1
               !istack(jstack-1)=l
               !l=i
            !ENDIF! ir-i+1>=j-l
         !ENDIF! ir-l<ins_sort_thresh
      !ENDDO
   !END SUBROUTINE create_index


   !CHARACTER(20) FUNCTION i2s(n)
      !INTEGER,INTENT(in) :: n
      !INTEGER m,j

      !m = abs(n)
      !DO j=len(i2s),2,-1
         !i2s(j:j)=achar(ichar('0')+mod(m,10))
         !m=m/10
         !IF(m==0)exit
      !ENDDO

      !IF(n<0)THEN
         !j = j-1
         !i2s(j:j)='-'
      !ENDIF

      !i2s=i2s(j:len(i2s))
   !END FUNCTION i2s


   !CHARACTER(72) FUNCTION write_mean(av,std_err_in_mean,err_prec_in)
!!-----------------------------------------------------------------------------!
!! Write out a mean value with the standard error in the mean in the form      !
!! av(std_err_in_mean), e.g. 0.123546(7).  err_prec_in specifies the number of !
!! digits of precision to which the error should be quoted (by default 1).     !
!!-----------------------------------------------------------------------------!
      !DOUBLE PRECISION,INTENT(in) :: av,std_err_in_mean
      !INTEGER,INTENT(in),OPTIONAL :: err_prec_in
      !INTEGER lowest_digit_to_quote,err_quote,err_prec,int_part,dec_part,i
      !INTEGER,PARAMETER :: err_prec_default=1
      !DOUBLE PRECISION av_quote
      !CHARACTER(1) sgn
      !CHARACTER(72) zero_pad

      !IF(std_err_in_mean<=0.d0)THEN
         !write_mean='ERROR: NON-POSITIVE ERROR BAR!!!'
         !RETURN
      !ENDIF ! Error is negative

      !IF(present(err_prec_in))THEN
         !IF(err_prec_in>=1)THEN
            !err_prec=err_prec_in
         !ELSE
            !write_mean='ERROR: NON-POSITIVE PRECISION!!!'
            !RETURN
         !ENDIF ! err_prec_in sensible.
      !ELSE
         !err_prec=err_prec_default
      !ENDIF ! Accuracy of error supplied.

!! Work out lowest digit of precision that should be retained in the
!! mean (i.e. the digit in terms of which the error is specified).
!! Calculate the error in terms of this digit and round.
      !lowest_digit_to_quote=floor(log(std_err_in_mean)/log(10.d0))+1-err_prec
      !err_quote=nint(std_err_in_mean*10.d0**dble(-lowest_digit_to_quote))
      !IF(err_quote==10**err_prec)THEN
         !lowest_digit_to_quote=lowest_digit_to_quote+1
         !err_quote=err_quote/10
      !ENDIF ! err_quote rounds up to next figure.

      !IF(err_quote>=10**err_prec.or.err_quote<10**(err_prec-1))THEN
         !write_mean='ERROR: BUG IN WRITE_MEAN!!!'
         !RETURN
      !ENDIF ! Check error is in range.

!! Truncate the mean to the relevant precision.  Establish its sign,
!! then take the absolute value and work out the integer part.
      !av_quote=anint(av*10.d0**dble(-lowest_digit_to_quote)) &
         !&*10.d0**dble(lowest_digit_to_quote)
      !IF(av_quote<0.d0)THEN
         !sgn='-'
         !av_quote=-av_quote
      !ELSE
         !sgn=' '
      !ENDIF ! Sign
      !IF(aint(av_quote)>dble(huge(1)))THEN
         !write_mean='ERROR: NUMBERS ARE TOO LARGE IN WRITE_MEAN!'
         !RETURN
      !ENDIF ! Vast number
      !int_part=floor(av_quote)

      !IF(lowest_digit_to_quote<0)THEN
!! If the error is in a decimal place then construct string using
!! integer part and decimal part, noting that the latter may need to
!! be padded with zeros, e.g. if we want "0001" rather than "1".
         !IF(anint((av_quote-dble(int_part)) &
            !&*10.d0**dble(-lowest_digit_to_quote))>dble(huge(1)))THEN
            !write_mean='ERROR: NUMBERS ARE TOO LARGE IN WRITE_MEAN!'
            !RETURN
         !ENDIF ! Vast number
         !dec_part=nint((av_quote-dble(int_part))*10.d0**dble(-lowest_digit_to_quote))
         !zero_pad=' '
         !IF(dec_part<0)THEN
            !write_mean='ERROR: BUG IN WRITE_MEAN! (2)'
            !RETURN
         !ENDIF ! dec
         !DO i=1,-lowest_digit_to_quote-no_digits_int(dec_part)
            !zero_pad(i:i)='0'
         !ENDDO ! i
         !write_mean=sgn//trim(i2s(int_part))//'.'//trim(zero_pad) &
         !&//trim(i2s(dec_part))//'('//trim(i2s(err_quote))//')'
      !ELSE
!! If the error is in a figure above the decimal point then, of
!! course, we don't have to worry about a decimal part.
         !write_mean=sgn//trim(i2s(int_part))//'(' &
            !&//trim(i2s(err_quote*10**lowest_digit_to_quote))//')'
      !ENDIF ! lowest_digit_to_quote<0

   !END FUNCTION write_mean


   !INTEGER FUNCTION no_digits_int(i)
   !!----------------------------------------------------------------------!
   !! Calculate the number of digits in integer i.  For i>0 this should be !
   !! floor(log(i)/log(10))+1, but sometimes rounding errors cause this    !
   !! expression to give the wrong result.                                 !
   !!----------------------------------------------------------------------!
      !INTEGER,INTENT(in) :: i
      !INTEGER j,k
      !j=i ; k=1
      !DO
         !j=j/10
         !IF(j==0)exit
         !k=k+1
      !ENDDO
      !no_digits_int=k
   !END FUNCTION no_digits_int



   !SUBROUTINE init_rng(seed)
!!--------------------------------------------!
!! Initialize the RNG: see Knuth's ran_start. !
!!--------------------------------------------!
      !INTEGER,INTENT(in) :: seed
      !INTEGER j,s,t,sseed
      !INTEGER,PARAMETER :: MM=2**30,TT=70
      !REAL(DP) ss,x(KK+KK-1)
      !REAL(DP),PARAMETER :: ULP=1.d0/2.d0**52,ULP2=2.d0*ULP
      !IF(seed<0)THEN
         !sseed=MM-1-mod(-1-seed,MM)
      !ELSE
         !sseed=mod(seed,MM)
      !ENDIF ! seed<0
      !ss=ULP2*dble(sseed+2)
      !DO j=1,KK
         !x(j)=ss
         !ss=ss+ss
         !IF(ss>=1.d0)ss=ss-1.d0+ULP2
      !ENDDO ! j
      !x(2)=x(2)+ULP
      !s=sseed
      !t=TT-1
      !DO
         !DO j=KK,2,-1
            !x(j+j-1)=x(j)
            !x(j+j-2)=0.d0
         !ENDDO ! j
         !DO j=KK+KK-1,KK+1,-1
            !x(j-(KK-LL))=mod(x(j-(KK-LL))+x(j),1.d0)
            !x(j-KK)=mod(x(j-KK)+x(j),1.d0)
         !ENDDO ! j
         !IF(mod(s,2)==1)THEN
            !DO j=KK,1,-1
               !x(j+1)=x(j)
            !ENDDO ! j
            !x(1)=x(KK+1)
            !x(LL+1)=mod(x(LL+1)+x(KK+1),1.d0)
         !ENDIF ! s odd
         !IF(s/=0)THEN
            !s=s/2
         !ELSE
            !t=t-1
         !ENDIF ! s/=0
         !IF(t<=0)exit
      !ENDDO
      !ranstate(1+KK-LL:KK)=x(1:LL)
      !ranstate(1:KK-LL)=x(LL+1:KK)
      !DO j=1,10
         !CALL gen_ran_array(x,KK+KK-1)
      !ENDDO ! j
      !ran_array_idx=Nkeep
   !END SUBROUTINE init_rng


   !REAL(dp) FUNCTION ranx()
!!------------------------------------------------------------------------------!
!! Return a random number uniformly distributed in [0,1).                       !
!! Uses M. Luescher's suggestion: generate 1009 random numbers at a time using  !
!! Knuth's algorithm, but only use the first 100.                               !
!!------------------------------------------------------------------------------!
      !IF(ran_array_idx==-1)THEN
         !CALL init_rng(default_seed) ! Initialize the RNG.
      !ENDIF ! First call.
      !IF(ran_array_idx==Nkeep)THEN
         !CALL gen_ran_array(ran_array,Nran) ! Generate a new array of random nos.
         !ran_array_idx=0
      !ENDIF ! i=Nkeep
      !ran_array_idx=ran_array_idx+1
      !ranx=ran_array(ran_array_idx)
   !END FUNCTION ranx


   !SUBROUTINE gen_ran_array(ran_array,N)
!!---------------------------------------------------------------!
!! Generate an array of N random numbers: see Knuth's ran_array. !
!!---------------------------------------------------------------!
      !INTEGER,INTENT(in) :: N
      !REAL(DP),INTENT(out) :: ran_array(N)
      !INTEGER j
      !ran_array(1:KK)=ranstate(1:KK)
      !DO j=KK+1,N
         !ran_array(j)=mod(ran_array(j-KK)+ran_array(j-LL),1.d0)
      !ENDDO ! j
      !DO j=1,LL
         !ranstate(j)=mod(ran_array(N+j-KK)+ran_array(N+j-LL),1.d0)
      !ENDDO ! j
      !DO j=LL+1,KK
         !ranstate(j)=mod(ran_array(N+j-KK)+ranstate(j-LL),1.d0)
      !ENDDO ! j
   !END SUBROUTINE gen_ran_array


!END SUBROUTINE write_casino_wfn

!
! Copyright (C) Quantum ESPRESSO group
!
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
!----------------------------------------------------------------------
! FFT base Module.
! Written by Carlo Cavazzoni, modified by Paolo Giannozzi
! Rewritten by Stefano de Gironcoli
!----------------------------------------------------------------------
!
!=----------------------------------------------------------------------=!
   MODULE qepy_scatter_mod
!=----------------------------------------------------------------------=!

        USE fft_types, ONLY: fft_type_descriptor
        USE fft_param
        USE mp,                   ONLY : mp_bcast

        IMPLICIT NONE

        INTERFACE gather_grid
           MODULE PROCEDURE gather_real_grid, gather_complex_grid
        END INTERFACE

        INTERFACE scatter_grid
           MODULE PROCEDURE scatter_real_grid, scatter_complex_grid
        END INTERFACE

        SAVE

        PRIVATE

        PUBLIC :: fft_type_descriptor
        PUBLIC :: gather_grid, scatter_grid
        PUBLIC :: fft_scatter_xy, fft_scatter_yz, fft_scatter_tg, fft_scatter_tg_opt
        PUBLIC :: cgather_sym, cgather_sym_many, cscatter_sym_many

!=----------------------------------------------------------------------=!
      CONTAINS
!=----------------------------------------------------------------------=!
!
!
!-----------------------------------------------------------------------
SUBROUTINE fft_scatter_xy ( desc, f_in, f_aux, nxx_, isgn )
  !-----------------------------------------------------------------------
  !
  ! transpose of the fft xy planes across the desc%comm2 communicator
  !
  ! a) From Y-oriented columns to X-oriented partial slices (isgn > 0)
  !    Active columns along the Y direction corresponding to a subset of the 
  !    active X values and a range of Z values (in this order) are stored 
  !    consecutively for each processor and are such that the subgroup owns
  !    all data for a range of Z values.
  !
  !    The Y pencil -> X-oriented partial slices transposition is performed 
  !    in the subgroup of processors (desc%comm2) owning this range of Z values.
  !
  !    The transpose takes place in two steps:
  !    1) on each processor the columns are sliced into sections along Y
  !       that are stored one after the other. On each processor, slices for
  !       processor "iproc2" are desc%nr2p(iproc2)*desc%nr1p(me2)*desc%my_nr3p big.
  !    2) all processors communicate to exchange slices (all sectin of columns with 
  !       Y in the slice belonging to "me" must be received, all the others 
  !       must be sent to "iproc2")
  !
  !    Finally one gets the "partial slice" representation: each processor has 
  !    all the X values of desc%my_nr2p Y and desc%my_nr3p Z values. 
  !    Data are organized with the X index running fastest, then Y, then Z.
  !
  !    f_in  contains the input Y columns, is destroyed on output
  !    f_aux contains the output X-oriented partial slices.
  !
  !  b) From planes to columns (isgn < 0)
  !
  !    Quite the same in the opposite direction
  !    f_aux contains the input X-oriented partial slices, is destroyed on output
  !    f_in  contains the output Y columns.
  !
  IMPLICIT NONE

  TYPE (fft_type_descriptor), INTENT(in) :: desc
  INTEGER, INTENT(in)           :: nxx_, isgn
  COMPLEX (DP), INTENT(inout)   :: f_in (nxx_), f_aux (nxx_)

  INTEGER :: nr1_temp(1)

#if defined(__MPI)
  CALL start_clock ('fft_scatt_xy')
  !
  if ( abs (isgn) == 1 ) then          ! It's a potential FFT
     CALL impl_xy( MAXVAL ( desc%nr2p ), desc%nproc2, desc%my_nr2p, desc%nr1p, desc%indp, desc%iplp)
  else if ( abs (isgn) == 2 ) then     ! It's a wavefunction FFT
     CALL impl_xy( MAXVAL ( desc%nr2p ), desc%nproc2, desc%my_nr2p, desc%nr1w, desc%indw, desc%iplw)
  else if ( abs (isgn) == 3 ) then     ! It's a wavefunction FFT with task group
     ! in task group FFTs whole Y colums are distributed
     nr1_temp = desc%nr1w_tg
     CALL impl_xy( desc%nr2x, 1, desc%nr2x, nr1_temp, desc%indw_tg, desc%iplw)
  end if
  !
  CALL stop_clock ('fft_scatt_xy')

  RETURN

  CONTAINS

  SUBROUTINE impl_xy(nr2px, nproc2, my_nr2p, nr1p_, indx, iplx)
  IMPLICIT NONE
  !
  INTEGER, INTENT(in):: nr2px, nproc2, my_nr2p
  INTEGER, INTENT(in):: nr1p_(nproc2), indx(desc%nr1x,nproc2), iplx(desc%nr1x)
  !
  INTEGER :: ierr, me2, iproc2, ncpx
  INTEGER :: i, it, j, k, kfrom, kdest, mc, m1, m3, i1, icompact, sendsize
  !
#if defined(__NON_BLOCKING_SCATTER)
  INTEGER :: sh(desc%nproc2), rh(desc%nproc2)
#endif

  me2    = desc%mype2 + 1
  ncpx = MAXVAL(nr1p_) * desc%my_nr3p       ! maximum number of Y columns to be disributed
  ! calculate the message size
  sendsize = ncpx * nr2px       ! dimension of the scattered chunks (safe value)

  ierr = 0
  IF (isgn.gt.0) THEN
     !
     IF (nproc2==1) GO TO 10
     !
     ! "forward" scatter from columns to planes
     !
     ! step one: store contiguously the slices
     !
!$omp parallel do collapse(2) private(kdest,kfrom)
     DO iproc2 = 1, nproc2
        DO k = 0, nr1p_(me2)*desc%my_nr3p-1
           kdest = ( iproc2 - 1 ) * sendsize + nr2px * k
           kfrom = desc%nr2p_offset(iproc2) + desc%nr2x *k
           DO i = 1, desc%nr2p( iproc2 )
              f_aux ( kdest + i ) =  f_in ( kfrom + i )
           ENDDO
        ENDDO
     ENDDO
!$omp end parallel do
#if defined(__NON_BLOCKING_SCATTER)
     DO iproc2 = 1, nproc2
        CALL mpi_isend( f_aux( (iproc2-1)*sendsize + 1 ), sendsize, &
                        MPI_DOUBLE_COMPLEX, iproc2-1, me2, desc%comm2, &
                        sh( iproc2 ), ierr )
     ENDDO
#endif
     !
     ! step two: communication  across the    nproc3    group
     !
#if defined(__NON_BLOCKING_SCATTER)
     DO iproc2 = 1, nproc2
        !
        ! now post the receive
        !
        CALL mpi_irecv( f_in( (iproc2-1)*sendsize + 1 ), sendsize, &
                        MPI_DOUBLE_COMPLEX, iproc2-1, MPI_ANY_TAG, &
                        desc%comm2, rh( iproc2 ), ierr )
        !IF( abs(ierr) /= 0 ) CALL fftx_error__ ('fft_scatter', ' forward receive info<>0', abs(ierr) )
     ENDDO
     
     call mpi_waitall( nproc2, sh, MPI_STATUSES_IGNORE, ierr )
     !
#else
     CALL mpi_alltoall (f_aux(1), sendsize, MPI_DOUBLE_COMPLEX, f_in(1), &
                        sendsize, MPI_DOUBLE_COMPLEX, desc%comm2, ierr)
     !
     IF( abs(ierr) /= 0 ) CALL fftx_error__ ('fft_scatter', 'info<>0', abs(ierr) )
#endif
     !
10   CONTINUE
     !
#if defined(__NON_BLOCKING_SCATTER)
     if (nproc2 > 1) call mpi_waitall( nproc2, rh, MPI_STATUSES_IGNORE, ierr )
#endif
     !
!$omp parallel
!$omp do collapse(2) private(it,m3,i1,m1,icompact)
     DO iproc2 = 1, nproc2
        DO i = 0, ncpx-1
           IF(i>=nr1p_(iproc2)*desc%my_nr3p) CYCLE ! control i from 0 to nr1p_(iproc2)*desc%my_nr3p-1
           it = ( iproc2 - 1 ) * sendsize + nr2px * i
           m3 = i/nr1p_(iproc2)+1
           i1 = mod(i,nr1p_(iproc2))+1
           m1 = indx(i1,iproc2)
           icompact = m1 + (m3-1)*desc%nr1x*my_nr2p
           DO j = 1, my_nr2p
              !f_aux( m1 + (j-1)*desc%nr1x + (m3-1)*desc%nr1x*my_nr2p ) = f_in( j + it )
              f_aux( icompact ) = f_in( j + it )
              icompact = icompact + desc%nr1x
           ENDDO
        ENDDO
     ENDDO
!$omp end do nowait
     !
     ! clean extra array elements in each stick
     !
!$omp do
     DO k = 1, my_nr2p*desc%my_nr3p
        DO i1 = 1, desc%nr1x
           IF(iplx(i1)==0) f_aux(desc%nr1x*(k-1)+i1) = (0.0_DP, 0.0_DP)
        ENDDO
     ENDDO
!$omp end do nowait
!$omp end parallel
     !
  ELSE
     !
     !  "backward" scatter from planes to columns
     !
!$omp parallel do collapse(2) private(it,m3,i1,m1,icompact)
     DO iproc2 = 1, nproc2
        DO i = 0, ncpx-1
           IF(i>=nr1p_(iproc2)*desc%my_nr3p) CYCLE ! control i from 0 to nr1p_(iproc2)*desc%my_nr3p-1
           it = ( iproc2 - 1 ) * sendsize + nr2px * i
           m3 = i/nr1p_(iproc2)+1
           i1 = mod(i,nr1p_(iproc2))+1
           m1 = indx(i1,iproc2)
           icompact = m1 + (m3-1)*desc%nr1x*my_nr2p
           DO j = 1, my_nr2p
              !f_in( j + it ) = f_aux( m1 + (j-1)*desc%nr1x + (m3-1)*desc%nr1x*my_nr2p )
              f_in( j + it ) = f_aux( icompact )
              icompact = icompact + desc%nr1x
           ENDDO
        ENDDO
     ENDDO
!$omp end parallel do
#if defined(__NON_BLOCKING_SCATTER)
     DO iproc2 = 1, nproc2
        IF( nproc2 > 1 ) CALL mpi_isend( f_in( ( iproc2 - 1 ) * sendsize + 1 ), &
                              sendsize, MPI_DOUBLE_COMPLEX, iproc2-1, me2, &
                              desc%comm2, sh( iproc2 ), ierr )
     ENDDO
#endif
     IF (nproc2==1) GO TO 20

     !
     !  step two: communication
     !
#if ! defined(__NON_BLOCKING_SCATTER)
     CALL mpi_alltoall (f_in(1), sendsize, MPI_DOUBLE_COMPLEX, f_aux(1), &
                        sendsize, MPI_DOUBLE_COMPLEX, desc%comm2, ierr)

     IF( abs(ierr) /= 0 ) CALL fftx_error__ ('fft_scatter', 'info<>0', abs(ierr) )
#else
     DO iproc2 = 1, nproc2
        CALL mpi_irecv( f_aux( (iproc2-1)*sendsize + 1 ), sendsize, &
                        MPI_DOUBLE_COMPLEX, iproc2-1, MPI_ANY_TAG, &
                        desc%comm2, rh(iproc2), ierr )
        ! IF( abs(ierr) /= 0 ) CALL fftx_error__ ('fft_scatter', ' backward receive info<>0', abs(ierr) )
     ENDDO
        
     call mpi_waitall( nproc2, sh, MPI_STATUSES_IGNORE, ierr )
     call mpi_waitall( nproc2, rh, MPI_STATUSES_IGNORE, ierr )
#endif
     !
     !  step one: store contiguously the columns
     !
!$omp parallel do collapse(2) private(kdest,kfrom)
     DO iproc2 = 1, nproc2
        DO k = 0, nr1p_(me2)*desc%my_nr3p-1
           kdest = ( iproc2 - 1 ) * sendsize + nr2px * k
           kfrom = desc%nr2p_offset(iproc2) + desc%nr2x * k
           DO i = 1, desc%nr2p( iproc2 )
              f_in ( kfrom + i ) = f_aux ( kdest + i )
           ENDDO
        ENDDO
     ENDDO
!$omp end parallel do
     !
     ! clean extra array elements in each stick
     !
     IF( desc%nr2x /= desc%nr2 ) THEN
        DO k = 1, nr1p_(me2)*desc%my_nr3p
           f_in(desc%nr2x*(k-1)+desc%nr2+1:desc%nr2x*k) = (0.0_DP, 0.0_DP)
        ENDDO
     ENDIF

20   CONTINUE

  ENDIF

  END SUBROUTINE impl_xy

#endif

END SUBROUTINE fft_scatter_xy
!
!-----------------------------------------------------------------------
SUBROUTINE fft_scatter_yz ( desc, f_in, f_aux, nxx_, isgn )
  !-----------------------------------------------------------------------
  !
  ! transpose of the fft yz planes across the desc%comm3 communicator
  !
  ! a) From Z-oriented columns to Y-oriented colums (isgn > 0)
  !    Active columns (or sticks or pencils) along the Z direction for each 
  !    processor are stored consecutively and are such that they correspond 
  !    to a subset of the active X values.
  !
  !    The pencil -> slices transposition is performed in the subgroup 
  !    of processors (desc%comm3) owning these X values.
  !
  !    The transpose takes place in two steps:
  !    1) on each processor the columns are sliced into sections along Z
  !       that are stored one after the other. On each processor, slices for
  !       processor "iproc3" are desc%nr3p(iproc3)*desc%nsw/nsp(me) big.
  !    2) all processors communicate to exchange slices (all columns with 
  !       Z in the slice belonging to "me" must be received, all the others 
  !       must be sent to "iproc3")
  !
  !    Finally one gets the "slice" representation: each processor has 
  !    desc%nr3p(mype3) Z values of all the active pencils along Y for the
  !    X values of the current group. Data are organized with the Y index
  !    running fastest, then the reordered X values, then Z.
  !
  !    f_in  contains the input Z columns, is destroyed on output
  !    f_aux contains the output Y colums.
  !
  !  b) From planes to columns (isgn < 0)
  !
  !    Quite the same in the opposite direction
  !    f_aux contains the input Y columns, is destroyed on output
  !    f_in  contains the output Z columns.
  !
  IMPLICIT NONE

  TYPE (fft_type_descriptor), INTENT(in) :: desc
  INTEGER, INTENT(in)           :: nxx_, isgn
  COMPLEX (DP), INTENT(inout)   :: f_in (nxx_), f_aux (nxx_)

#if defined(__MPI)
  !
  CALL start_clock ('fft_scatt_yz')

  if ( abs (isgn) == 1 ) then      ! It's a potential FFT
     CALL impl_yz(desc%mype2+1, desc%mype2+1, desc%nsp, desc%ir1p, desc%nsp_offset)
  else if ( abs (isgn) == 2 ) then ! It's a wavefunction FFT
     CALL impl_yz(desc%mype2+1, desc%mype2+1, desc%nsw, desc%ir1w, desc%nsw_offset)
  else if ( abs (isgn) == 3 ) then ! It's a wavefunction FFT with task group
     CALL impl_yz(1, desc%nproc2, desc%nsw, desc%ir1w_tg, desc%nsw_offset)
  end if

  CALL stop_clock ('fft_scatt_yz')

  RETURN

  CONTAINS

  SUBROUTINE impl_yz(me2_start, me2_end, ncp_, ir1p_, me2_iproc3_offset)
  IMPLICIT NONE
  !
  INTEGER, INTENT(in) :: me2_start, me2_end
  INTEGER, INTENT(in) :: ncp_(desc%nproc), ir1p_(desc%nr1x), me2_iproc3_offset(desc%nproc2, desc%nproc3)
  !
  INTEGER :: ierr, me2, me3, nproc3, iproc3, ncpx, nr3px, ip
  INTEGER :: i, it, k, kfrom, kdest, mc, m1, m2, i1, sendsize
  INTEGER :: my_nr1p_
  !
#if defined(__NON_BLOCKING_SCATTER)
  INTEGER :: sh(desc%nproc3), rh(desc%nproc3)
#endif
  !
  me3    = desc%mype3 + 1
  nproc3 = desc%nproc3
  !
  my_nr1p_ = count (ir1p_ > 0)
  !
  ! calculate the message size
  !
  nr3px = MAXVAL ( desc%nr3p )  ! maximum number of Z values to be exchanged
  ncpx  = MAXVAL ( ncp_ )       ! maximum number of Z columns to be exchanged
  sendsize = ncpx * nr3px * ( me2_end - me2_start + 1 )  ! dimension of the scattered chunks
  !
  ierr = 0
  IF (isgn.gt.0) THEN
     !
     IF (nproc3==1) GO TO 10
     !
     ! "forward" scatter from columns to planes
     !
     ! step one: store contiguously the slices
     !
!$omp parallel do collapse(3) private(kdest,kfrom)
     DO iproc3 = 1, nproc3
        DO me2 = me2_start, me2_end
           DO k = 0, ncpx-1   ! was ncp_(me3)
              IF (k>=ncp_(desc%iproc(me2,me3))) CYCLE ! control k from 0 to ncp_(desc%iproc(me2,me3))-1
              kdest = ( iproc3 - 1 ) * sendsize + nr3px * ( me2_iproc3_offset( me2 - me2_start + 1, me3 ) + k )
              kfrom = desc%nr3p_offset(iproc3) + desc%nr3x * ( me2_iproc3_offset( me2 - me2_start + 1, me3 ) + k )
              DO i = 1, desc%nr3p( iproc3 )
                 f_aux ( kdest + i ) =  f_in ( kfrom + i )
              ENDDO
           ENDDO
        ENDDO
     ENDDO
!$omp end parallel do
#if defined(__NON_BLOCKING_SCATTER)
     DO iproc3 = 1, nproc3
        CALL mpi_isend( f_aux( ( iproc3 - 1 ) * sendsize + 1 ), sendsize, &
                        MPI_DOUBLE_COMPLEX, iproc3-1, me3, desc%comm3, &
                        sh( iproc3 ), ierr )
     ENDDO
#endif
     !
     ! step two: communication  across the    nproc3    group
     !
#if defined(__NON_BLOCKING_SCATTER)
     DO iproc3 = 1, nproc3
        !
        ! now post the receive
        !
        CALL mpi_irecv( f_in( (iproc3-1)*sendsize + 1 ), sendsize, &
                        MPI_DOUBLE_COMPLEX, iproc3-1, MPI_ANY_TAG, &
                        desc%comm3, rh( iproc3 ), ierr )
        !IF( abs(ierr) /= 0 ) CALL fftx_error__ ('fft_scatter', ' forward receive info<>0', abs(ierr) )
        !
        !
     ENDDO
     
     call mpi_waitall( nproc3, sh, MPI_STATUSES_IGNORE, ierr )
     !
#else
     CALL mpi_alltoall (f_aux(1), sendsize, MPI_DOUBLE_COMPLEX, f_in(1), &
                        sendsize, MPI_DOUBLE_COMPLEX, desc%comm3, ierr)

     IF( abs(ierr) /= 0 ) CALL fftx_error__ ('fft_scatter', 'info<>0', abs(ierr) )
#endif     
     !
10   CONTINUE
     !
#if defined(__NON_BLOCKING_SCATTER)
     if (nproc3 > 1) call mpi_waitall( nproc3, rh, MPI_STATUSES_IGNORE, ierr )
#endif
     !
!$omp parallel
     ! ensures that no garbage is present in the output
     !
!$omp do
     DO k = 1, desc%my_nr3p*my_nr1p_*desc%nr2x
        f_aux(k) = (0.0_DP, 0.0_DP)
     ENDDO
!$omp end do
!$omp do collapse(3) private(ip,it,mc,m1,m2,i1)
     DO iproc3 = 1, desc%nproc3
        DO me2 = me2_start, me2_end
           DO i = 1, ncpx ! was ncp_(iproc3)
              ip = desc%iproc( me2, iproc3)
              IF ( i>ncp_(ip) ) CYCLE
              it = ( iproc3 - 1 ) * sendsize + nr3px * ( me2_iproc3_offset( me2 - me2_start + 1, iproc3 ) + i - 1 )
              mc = desc%ismap( i + desc%iss(ip) ) ! this is  m1+(m2-1)*nr1x  of the  current pencil
              m1 = mod (mc-1,desc%nr1x) + 1
              m2 = (mc-1)/desc%nr1x + 1
              i1 = m2 + ( ir1p_(m1) - 1 ) * desc%nr2x
              DO k = 1, desc%my_nr3p
                 f_aux( i1 ) = f_in( k + it )
                 i1 = i1 + desc%nr2x*my_nr1p_
              ENDDO
           ENDDO
        ENDDO
     ENDDO
!$omp end do nowait
!$omp end parallel
     !
  ELSE
     !
     !  "backward" scatter from planes to columns
     !
!$omp parallel do collapse(3) private(ip,it,mc,m1,m2,i1)
     DO iproc3 = 1, desc%nproc3
        DO me2 = me2_start, me2_end
           DO i = 1, ncpx
              ip = desc%iproc( me2, iproc3)
              IF ( i>ncp_(ip) ) CYCLE
              it = ( iproc3 - 1 ) * sendsize + nr3px * ( me2_iproc3_offset( me2 - me2_start + 1, iproc3 ) + i - 1 )
              mc = desc%ismap( i + desc%iss(ip) ) ! this is  m1+(m2-1)*nr1x  of the  current pencil
              m1 = mod (mc-1,desc%nr1x) + 1
              m2 = (mc-1)/desc%nr1x + 1
              i1 = m2 + ( ir1p_(m1) - 1 ) * desc%nr2x
              DO k = 1, desc%my_nr3p
                 f_in( k + it ) = f_aux( i1 )
                 i1 = i1 + desc%nr2x * my_nr1p_
              ENDDO
           ENDDO
        ENDDO
     ENDDO
!$omp end parallel do
#if defined(__NON_BLOCKING_SCATTER)
     DO iproc3 = 1, desc%nproc3
        IF( nproc3 > 1 ) CALL mpi_isend( f_in( ( iproc3 - 1 ) * sendsize + 1 ), &
                                        sendsize, MPI_DOUBLE_COMPLEX, iproc3-1, &
                                        me3, desc%comm3, sh( iproc3 ), ierr )
     ENDDO
#endif
     
     IF( nproc3 == 1 ) GO TO 20
     !
     !  step two: communication
     !
#if ! defined(__NON_BLOCKING_SCATTER)
     CALL mpi_alltoall (f_in(1), sendsize, MPI_DOUBLE_COMPLEX, f_aux(1), &
                        sendsize, MPI_DOUBLE_COMPLEX, desc%comm3, ierr)

     IF( abs(ierr) /= 0 ) CALL fftx_error__ ('fft_scatter', 'info<>0', abs(ierr) )
#else
     DO iproc3 = 1, desc%nproc3
        CALL mpi_irecv( f_aux( (iproc3-1)*sendsize + 1 ), sendsize, &
                        MPI_DOUBLE_COMPLEX, iproc3-1, MPI_ANY_TAG, &
                        desc%comm3, rh(iproc3), ierr )
        ! IF( abs(ierr) /= 0 ) CALL fftx_error__ ('fft_scatter', ' backward receive info<>0', abs(ierr) )
     ENDDO
        
     call mpi_waitall( desc%nproc3, sh, MPI_STATUSES_IGNORE, ierr )
     call mpi_waitall( desc%nproc3, rh, MPI_STATUSES_IGNORE, ierr )
#endif
     !
     !  step one: store contiguously the columns
     !
!$omp parallel do collapse(3) private(kdest,kfrom)
     DO iproc3 = 1, nproc3
        DO me2 = me2_start, me2_end
           DO k = 0, ncpx-1   ! was ncp_(me3)
              IF (k>=ncp_(desc%iproc(me2,me3))) CYCLE ! control k from 0 to ncp_(desc%iproc(me2,me3))-1
              kdest = ( iproc3 - 1 ) * sendsize + nr3px * ( me2_iproc3_offset( me2 - me2_start + 1, me3 ) + k )
              kfrom = desc%nr3p_offset(iproc3) + desc%nr3x * ( me2_iproc3_offset( me2 - me2_start + 1, me3 ) + k )
              DO i = 1, desc%nr3p( iproc3 )
                 f_in ( kfrom + i ) = f_aux ( kdest + i )
              ENDDO
           ENDDO
        ENDDO
     ENDDO
!$omp end parallel do

     ! clean extra array elements in each stick

     IF( desc%nr3x /= desc%nr3 ) THEN
        DO k = 1, ncp_(desc%mype+1)
           f_in(desc%nr3x*(k-1)+desc%nr3+1:desc%nr3x*k) = (0.0_DP, 0.0_DP)
        END DO
     END IF

20   CONTINUE

  ENDIF

  END SUBROUTINE impl_yz

#endif

END SUBROUTINE fft_scatter_yz
!
!-----------------------------------------------------------------------
SUBROUTINE fft_scatter_tg ( desc, f_in, f_aux, nxx_, isgn )
  !-----------------------------------------------------------------------
  !
  ! task group wavefunction redistribution
  !
  ! a) (isgn >0 ) From many-wfc partial-plane arrangement to single-wfc whole-plane one
  !
  ! b) (isgn <0 ) From single-wfc whole-plane arrangement to many-wfc partial-plane one
  !
  ! in both cases:
  !    f_in  contains the input data, is overwritten with the desired output
  !    f_aux is used as working array, may contain garbage in output
  !
  IMPLICIT NONE

  TYPE (fft_type_descriptor), INTENT(in) :: desc
  INTEGER, INTENT(in)           :: nxx_, isgn
  COMPLEX (DP), INTENT(inout)   :: f_in (nxx_), f_aux (nxx_)

  INTEGER :: ierr

  CALL start_clock ('fft_scatt_tg')

  if ( abs (isgn) /= 3 ) call fftx_error__ ('fft_scatter_tg', 'wrong call', 1 )

#if defined(__MPI)
  !
  f_aux = f_in
  if ( isgn > 0 ) then

     CALL MPI_ALLTOALLV( f_aux,  desc%tg_snd, desc%tg_sdsp, MPI_DOUBLE_COMPLEX, &
                         f_in, desc%tg_rcv, desc%tg_rdsp, MPI_DOUBLE_COMPLEX, desc%comm2, ierr)
     IF( ierr /= 0 ) CALL fftx_error__( 'fft_scatter_tg', ' alltoall error 1 ', abs(ierr) )

  else

     CALL MPI_ALLTOALLV( f_aux,  desc%tg_rcv, desc%tg_rdsp, MPI_DOUBLE_COMPLEX, &
                         f_in, desc%tg_snd, desc%tg_sdsp, MPI_DOUBLE_COMPLEX, desc%comm2, ierr)
     IF( ierr /= 0 ) CALL fftx_error__( 'fft_scatter_tg', ' alltoall error 2 ', abs(ierr) )
   end if

#endif
  CALL stop_clock ('fft_scatt_tg')

  RETURN

END SUBROUTINE fft_scatter_tg
!
!-----------------------------------------------------------------------
SUBROUTINE fft_scatter_tg_opt ( desc, f_in, f_out, nxx_, isgn )
  !-----------------------------------------------------------------------
  !
  ! task group wavefunction redistribution
  !
  ! a) (isgn >0 ) From many-wfc partial-plane arrangement to single-wfc whole-plane one
  !
  ! b) (isgn <0 ) From single-wfc whole-plane arrangement to many-wfc partial-plane one
  !
  ! in both cases:
  !    f_in  contains the input data
  !    f_out contains the output data
  !
  IMPLICIT NONE

  TYPE (fft_type_descriptor), INTENT(in) :: desc
  INTEGER, INTENT(in)           :: nxx_, isgn
  COMPLEX (DP), INTENT(inout)   :: f_in (nxx_), f_out (nxx_)

  INTEGER :: ierr

  CALL start_clock ('fft_scatt_tg')

  if ( abs (isgn) /= 3 ) call fftx_error__ ('fft_scatter_tg', 'wrong call', 1 )

#if defined(__MPI)
  !
  if ( isgn > 0 ) then

     CALL MPI_ALLTOALLV( f_in,  desc%tg_snd, desc%tg_sdsp, MPI_DOUBLE_COMPLEX, &
                         f_out, desc%tg_rcv, desc%tg_rdsp, MPI_DOUBLE_COMPLEX, desc%comm2, ierr)
     IF( ierr /= 0 ) CALL fftx_error__( 'fft_scatter_tg', ' alltoall error 1 ', abs(ierr) )

  else

     CALL MPI_ALLTOALLV( f_in,  desc%tg_rcv, desc%tg_rdsp, MPI_DOUBLE_COMPLEX, &
                         f_out, desc%tg_snd, desc%tg_sdsp, MPI_DOUBLE_COMPLEX, desc%comm2, ierr)
     IF( ierr /= 0 ) CALL fftx_error__( 'fft_scatter_tg', ' alltoall error 2 ', abs(ierr) )
   end if

#endif
  CALL stop_clock ('fft_scatt_tg')

  RETURN

END SUBROUTINE fft_scatter_tg_opt
!
!----------------------------------------------------------------------------
SUBROUTINE gather_real_grid ( dfft, f_in, f_out )
  !----------------------------------------------------------------------------
  !
  ! ... gathers a distributed real-space FFT grid to dfft%root, that is,
  ! ... the first processor of input descriptor dfft - version for real arrays
  !
  ! ... REAL*8  f_in  = distributed variable (dfft%nnr)
  ! ... REAL*8  f_out = gathered variable (dfft%nr1x*dfft%nr2x*dfft%nr3x)
  !
  IMPLICIT NONE
  !
  REAL(DP), INTENT(in) :: f_in (:)
  REAL(DP), INTENT(inout):: f_out(:)
  TYPE ( fft_type_descriptor ), INTENT(IN) :: dfft
  !
#if defined(__MPI)
  !
  INTEGER :: proc, info, offset_in, offset_aux, ir3
  ! ... the following are automatic arrays
  INTEGER :: displs(0:dfft%nproc-1), recvcount(0:dfft%nproc-1)
  REAL(DP), ALLOCATABLE ::  f_aux(:) 
  !
  IF( size( f_in ) < dfft%nnr ) &
     CALL fftx_error__( ' gather_real_grid ', ' f_in too small ', dfft%nnr-size( f_in ) )
  !
  CALL start_clock( 'rgather_grid' )

  !write (6,*) 'gather grid ok 0 ', dfft%nproc, dfft%nproc2, dfft%nproc3
  ALLOCATE ( f_aux(dfft%nr1x * dfft%nr2x * dfft%my_nr3p) )
  ! 1) gather within the comm2 communicator
  displs = 0
  DO proc =0, ( dfft%nproc2 -1 )
     recvcount(proc) = dfft%nr1x * dfft%nr2p(proc+1) 
     if (proc > 0) displs(proc) = displs(proc-1) + recvcount(proc-1)
  end do
  offset_in = 1; offset_aux = 1
  do ir3 = 1, dfft%my_nr3p
    !write (6,*) 'gather grid ok 1 ir3=', ir3
     info = 0
     CALL MPI_GATHERV( f_in(offset_in) , recvcount(dfft%mype2), MPI_DOUBLE_PRECISION, &
                       f_aux(offset_aux), recvcount, displs, MPI_DOUBLE_PRECISION, dfft%root,      &
                       dfft%comm2, info )
     CALL fftx_error__( 'gather_real_grid', 'info<>0', info )
    !write (6,*) 'gather grid ok 2 ir3=', ir3
     offset_in  = offset_in + dfft%nr1x * dfft%my_nr2p
     offset_aux = offset_aux + dfft%nr1x * dfft%nr2
  end do

  ! 2) gather within the comm3 communicator 
  displs = 0
  DO proc = 0, ( dfft%nproc3 - 1 )
     recvcount(proc) = dfft%nr1x * dfft%nr2x * dfft%nr3p(proc+1) 
     if (proc > 0) displs(proc) = displs(proc-1) + recvcount(proc-1)
  ENDDO
  info = 0
  !write (6,*) 'gather grid ok 3'
  CALL MPI_GATHERV( f_aux, recvcount(dfft%mype3), MPI_DOUBLE_PRECISION, &
                    f_out, recvcount, displs, MPI_DOUBLE_PRECISION, dfft%root,      &
                    dfft%comm3, info )
  !write (6,*) 'gather grid ok 4'
  CALL fftx_error__( ' gather_real_grid', 'info<>0', info )
  !
  ! ... the following check should be performed only on processor dfft%root
  ! ... otherwise f_out must be allocated on all processors even if not used
  !
  info = size( f_out ) - displs( dfft%nproc3-1 ) - recvcount( dfft%nproc3-1 )
  CALL mp_bcast( info, dfft%root, dfft%comm)
  IF( info < 0 ) &
     CALL fftx_error__( ' gather_real_grid ', ' f_out too small ', -info )
  !
  DEALLOCATE ( f_aux )
  !
  CALL stop_clock( 'rgather_grid' )
  !
#else
  CALL fftx_error__(' gather_real_grid', 'do not use in serial execution', 1)
#endif
  !
  RETURN
  !
END SUBROUTINE gather_real_grid

!----------------------------------------------------------------------------
SUBROUTINE gather_complex_grid ( dfft, f_in, f_out )
  !----------------------------------------------------------------------------
  !
  ! ... gathers a distributed real-space FFT grid to dfft%root, that is,
  ! ... the first processor of input descriptor dfft - complex arrays
  !
  ! ... COMPLEX*16  f_in  = distributed variable (dfft%nnr)
  ! ... COMPLEX*16  f_out = gathered variable (dfft%nr1x*dfft%nr2x*dfft%nr3x)
  !
  IMPLICIT NONE
  !
  COMPLEX(DP), INTENT(in) :: f_in (:)
  COMPLEX(DP), INTENT(inout):: f_out(:)
  TYPE ( fft_type_descriptor ), INTENT(IN) :: dfft
  COMPLEX(DP), ALLOCATABLE ::  f_aux(:) 
  !
#if defined(__MPI)
  !
  INTEGER :: proc, info, offset_in, offset_aux, ir3
  ! ... the following are automatic arrays
  INTEGER :: displs(0:dfft%nproc-1), recvcount(0:dfft%nproc-1)
  !
  
  CALL start_clock( 'cgather_grid' )
  !write (*,*) 'gcgather_grid size(f_in),dfft%nnr',size(f_in), dfft%nnr ; FLUSH(6)
  IF( 2*size( f_in ) < dfft%nnr ) &
     CALL fftx_error__( ' gather_complex_grid ', ' f_in too small ', dfft%nnr-size( f_in ) )
  !
  !write (6,*) 'gather grid ok 0 ', dfft%nproc, dfft%nproc2, dfft%nproc3
  ALLOCATE ( f_aux(dfft%nr1x * dfft%nr2x * dfft%my_nr3p ) )
  ! 1) gather within the comm2 communicator
  displs = 0
  DO proc =0, ( dfft%nproc2 -1 )
     recvcount(proc) = 2 * dfft%nr1x * dfft%nr2p(proc+1) 
     if (proc > 0) displs(proc) = displs(proc-1) + recvcount(proc-1)
  end do
  offset_in = 1; offset_aux = 1
  do ir3 = 1, dfft%my_nr3p
     info = 0
     !write (6,*) 'gather grid ok 1 ir3=', ir3
     CALL MPI_GATHERV( f_in(offset_in) , recvcount(dfft%mype2), MPI_DOUBLE_PRECISION, &
                       f_aux(offset_aux), recvcount, displs, MPI_DOUBLE_PRECISION, dfft%root,      &
                       dfft%comm2, info )
     CALL fftx_error__( 'gather_complex_grid', 'info<>0', info )
     !write (6,*) 'gather grid ok 2 ir3=', ir3
     offset_in  = offset_in + dfft%nr1x * dfft%my_nr2p
     offset_aux = offset_aux + dfft%nr1x * dfft%nr2
  end do

  ! 2) gather within the comm3 communicator 
  displs = 0
  DO proc = 0, ( dfft%nproc3 - 1 )
     recvcount(proc) = 2 * dfft%nr1x * dfft%nr2x * dfft%nr3p(proc+1) 
     if (proc > 0) displs(proc) = displs(proc-1) + recvcount(proc-1)
  ENDDO
  !
  ! ... the following check should be performed only on processor dfft%root
  ! ... otherwise f_out must be allocated on all processors even if not used
  !
  !write (*,*) 'gcgather_grid 2*size(f_out)',2*size(f_out) ; FLUSH(6)
  !write (*,*) 'gcgather_grid displ+recv',dfft%nproc3, displs(dfft%nproc3-1) + recvcount(dfft%nproc3-1); FLUSH(6)
  info = 2*size( f_out ) - displs( dfft%nproc3 - 1 ) - recvcount( dfft%nproc3-1 ) ; FLUSH(6)
  CALL mp_bcast( info, dfft%root, dfft%comm)
  IF( info < 0 ) CALL fftx_error__( ' gather_complex_grid ', ' f_out too small ', -info )

  info = 0
  !write (6,*) 'gather grid ok 3'
  CALL MPI_GATHERV( f_aux, recvcount(dfft%mype3), MPI_DOUBLE_PRECISION, &
                    f_out, recvcount, displs, MPI_DOUBLE_PRECISION, dfft%root,      &
                    dfft%comm3, info )
  !write (6,*) 'gather grid ok 4'
  CALL fftx_error__( 'gather_complex_grid', 'info<>0', info )
  !
  DEALLOCATE ( f_aux )
  !
  CALL stop_clock( 'cgather_grid' )
  !
#else
  CALL fftx_error__('gather_complex_grid', 'do not use in serial execution', 1)
#endif
  !
  RETURN
  !
END SUBROUTINE gather_complex_grid

!----------------------------------------------------------------------------
SUBROUTINE scatter_real_grid ( dfft, f_in, f_out )
  !----------------------------------------------------------------------------
  !
  ! ... scatters a real-space FFT grid from dfft%root, first processor of
  ! ... input descriptor dfft, to all others - opposite of "gather_grid"
  !
  ! ... REAL*8  f_in  = gathered variable (dfft%nr1x*dfft%nr2x*dfft%nr3x)
  ! ... REAL*8  f_out = distributed variable (dfft%nnr)
  !
  IMPLICIT NONE
  !
  REAL(DP), INTENT(in) :: f_in (:)
  REAL(DP), INTENT(inout):: f_out(:)
  TYPE ( fft_type_descriptor ), INTENT(IN) :: dfft
  REAL(DP), ALLOCATABLE ::  f_aux(:) 
  !
#if defined(__MPI)
  !
  INTEGER :: proc, info, offset_in, offset_aux, ir3
  ! ... the following are automatic arrays
  INTEGER :: displs(0:dfft%nproc-1), sendcount(0:dfft%nproc-1)
  !
  !
  CALL start_clock( 'rscatter_grid' )
  !
  !write (6,*) 'scatter grid ok 0'
  ALLOCATE ( f_aux(dfft%nr1x * dfft%nr2x * dfft%my_nr3p) )
  ! 1) scatter within the comm3 communicator 
  displs = 0
  DO proc = 0, ( dfft%nproc3 - 1 )
     sendcount(proc) = dfft%nr1x * dfft%nr2x * dfft%nr3p(proc+1) 
     if (proc > 0) displs(proc) = displs(proc-1) + sendcount(proc-1)
  ENDDO
  info = size( f_in ) - displs( dfft%nproc3 - 1 ) - sendcount( dfft%nproc3 - 1 )
  CALL mp_bcast( info, dfft%root, dfft%comm)
  IF( info < 0 ) CALL fftx_error__( ' scatter_real_grid ', ' f_in too small ', -info )
  info = 0
  !write (6,*) 'scatter grid ok 1'
  CALL MPI_SCATTERV( f_in, sendcount, displs, MPI_DOUBLE_PRECISION,   &
                     f_aux, sendcount(dfft%mype3), MPI_DOUBLE_PRECISION, &
                     dfft%root, dfft%comm3, info )
  !write (6,*) 'scatter grid ok 2'
  CALL fftx_error__( 'scatter_real_grid', 'info<>0', info )

  ! 2) scatter within the comm2 communicator
  IF( size( f_out ) < dfft%nnr ) &
     CALL fftx_error__( ' scatter_real_grid ', ' f_out too small ', dfft%nnr-size( f_out ) )
  !
  displs = 0 ; f_out = 0.0D0
  DO proc =0, ( dfft%nproc2 -1 )
     sendcount(proc) = dfft%nr1x * dfft%nr2p(proc+1) 
     if (proc > 0) displs(proc) = displs(proc-1) + sendcount(proc-1)
  end do
  offset_in = 1 ; offset_aux = 1
  do ir3 = 1, dfft%my_nr3p
     info = 0
  !write (6,*) 'scatter grid ok 3, ir3=', ir3
     CALL MPI_SCATTERV( f_aux(offset_aux), sendcount, displs, MPI_DOUBLE_PRECISION,   &
                        f_out(offset_in), sendcount(dfft%mype2), MPI_DOUBLE_PRECISION, &
                        dfft%root, dfft%comm2, info )
  !write (6,*) 'scatter grid ok 4, ir3=', ir3
     CALL fftx_error__( 'scatter_real_grid', 'info<>0', info )
     offset_in  = offset_in + dfft%nr1x * dfft%my_nr2p
     offset_aux = offset_aux + dfft%nr1x * dfft%nr2
  end do
  !
  DEALLOCATE ( f_aux )
  !
  CALL stop_clock( 'rscatter_grid' )
  !
#else
  CALL fftx_error__('scatter_real_grid', 'do not use in serial execution', 1)
#endif
  !
  RETURN
  !
END SUBROUTINE scatter_real_grid
!----------------------------------------------------------------------------
SUBROUTINE scatter_complex_grid ( dfft, f_in, f_out )
  !----------------------------------------------------------------------------
  !
  ! ... scatters a real-space FFT grid from dfft%root, first processor of
  ! ... input descriptor dfft, to all others - opposite of "gather_grid"
  !
  ! ... COMPLEX*16  f_in  = gathered variable (dfft%nr1x*dfft%nr2x*dfft%nr3x)
  ! ... COMPLEX*16  f_out = distributed variable (dfft%nnr)
  !
  IMPLICIT NONE
  !
  COMPLEX(DP), INTENT(in) :: f_in (:)
  COMPLEX(DP), INTENT(inout):: f_out(:)
  TYPE ( fft_type_descriptor ), INTENT(IN) :: dfft
  COMPLEX(DP), ALLOCATABLE ::  f_aux(:) 
  !
#if defined(__MPI)
  !
  INTEGER :: proc, info, offset_in, offset_aux, ir3
  ! ... the following are automatic arrays
  INTEGER :: displs(0:dfft%nproc-1), sendcount(0:dfft%nproc-1)
  !
  CALL start_clock( 'cscatter_grid' )
  !
  !write (6,*) 'scatter grid ok 0'
  ALLOCATE ( f_aux(dfft%nr1x * dfft%nr2x * dfft%my_nr3p ) )
  ! 1) scatter within the comm3 communicator 
  displs = 0
  DO proc = 0, ( dfft%nproc3 - 1 )
     sendcount(proc) = 2 * dfft%nr1x * dfft%nr2x * dfft%nr3p(proc+1) 
     if (proc > 0) displs(proc) = displs(proc-1) + sendcount(proc-1)
  ENDDO
  !
  !write(*,*) 'cscatter_grid 2*size(f_in) ', 2*size(f_in); FLUSH(6)
  !write(*,*) 'cscatter_grid displ+send ', dfft%nproc3, displs(dfft%nproc3-1) + sendcount(dfft%nproc3-1); FLUSH(6)
  info = 2*size( f_in ) - displs( dfft%nproc3 - 1 ) - sendcount( dfft%nproc3 - 1 )
  CALL mp_bcast( info, dfft%root, dfft%comm)
  IF( info < 0 ) &
     CALL fftx_error__( ' scatter_complex_grid ', ' f_in too small ', -info )
  !
  info = 0
  !write (6,*) 'scatter grid ok 1'
  CALL MPI_SCATTERV( f_in, sendcount, displs, MPI_DOUBLE_PRECISION,   &
                     f_aux, sendcount(dfft%mype3), MPI_DOUBLE_PRECISION, &
                     dfft%root, dfft%comm3, info )
  !write (6,*) 'scatter grid ok 2'
  CALL fftx_error__( ' scatter_complex_grid', 'info<>0', info )

  ! 2) scatter within the comm2 communicator
  !write(*,*) 'cscatter_grid size(f_out), dfft%nnr ', size(f_out),dfft%nnr; FLUSH(6)
  IF( size( f_out ) < dfft%nnr ) &
     CALL fftx_error__( ' scatter_complex_grid ', ' f_out too small ', dfft%nnr-size( f_out ) )
  !
  displs = 0 ; f_out = 0.0D0
  DO proc =0, ( dfft%nproc2 -1 )
     sendcount(proc) = 2 * dfft%nr1x * dfft%nr2p(proc+1) 
     if (proc > 0) displs(proc) = displs(proc-1) + sendcount(proc-1)
  end do
  offset_in = 1 ; offset_aux = 1
  do ir3 = 1, dfft%my_nr3p
     info = 0
  !write (6,*) 'scatter grid ok 3, ir3=', ir3
     CALL MPI_SCATTERV( f_aux(offset_aux), sendcount, displs, MPI_DOUBLE_PRECISION,   &
                        f_out(offset_in), sendcount(dfft%mype2), MPI_DOUBLE_PRECISION, &
                        dfft%root, dfft%comm2, info )
  !write (6,*) 'scatter grid ok 4, ir3=', ir3
     CALL fftx_error__( 'scatter_complex_grid', 'info<>0', info )
     offset_in  = offset_in + dfft%nr1x * dfft%my_nr2p
     offset_aux = offset_aux + dfft%nr1x * dfft%nr2x
  end do
  !
  ! ... the following check should be performed only on processor dfft%root
  ! ... otherwise f_in must be allocated on all processors even if not used
  !
  DEALLOCATE ( f_aux )
  !
  CALL stop_clock( 'cscatter_grid' )
  !
#else
  CALL fftx_error__('scatter_complex_grid', 'do not use in serial execution', 1)
#endif
  !
  RETURN
  !
END SUBROUTINE scatter_complex_grid
!
! ... "gather"-like subroutines
!
!-----------------------------------------------------------------------
SUBROUTINE cgather_sym( dfftp, f_in, f_out )
  !-----------------------------------------------------------------------
  !
  ! ... gather complex data for symmetrization (used in phonon code)
  ! ... Differs from gather_grid because mpi_allgatherv is used instead
  ! ... of mpi_gatherv - all data is gathered on ALL processors
  ! ... COMPLEX*16  f_in  = distributed variable (nrxx)
  ! ... COMPLEX*16  f_out = gathered variable (nr1x*nr2x*nr3x)
  !
  IMPLICIT NONE
  !
  TYPE (fft_type_descriptor), INTENT(in) :: dfftp
  COMPLEX(DP) :: f_in( : ), f_out(:)
  COMPLEX(DP), ALLOCATABLE ::  f_aux(:) 
  !
#if defined(__MPI)
  !
  INTEGER :: proc, info, offset_in, offset_aux, ir3
  ! ... the following are automatic arrays
  INTEGER :: displs(0:dfftp%nproc-1), recvcount(0:dfftp%nproc-1)
  !
  CALL start_clock( 'cgather' )

  ALLOCATE ( f_aux(dfftp%nr1x * dfftp%nr2x * dfftp%my_nr3p ) )
  !
  CALL MPI_BARRIER( dfftp%comm, info )
  !
  ! 1) gather within the comm2 communicator
  displs = 0
  DO proc =0, ( dfftp%nproc2 -1 )
     recvcount(proc) = 2 * dfftp%nr1x * dfftp%nr2p(proc+1) 
     if (proc > 0) displs(proc) = displs(proc-1) + recvcount(proc-1)
  end do
  offset_in = 1; offset_aux = 1
  do ir3 = 1, dfftp%my_nr3p
     info = 0
     CALL MPI_ALLGATHERV( f_in(offset_in), recvcount(dfftp%mype2), MPI_DOUBLE_PRECISION, &
                          f_aux(offset_aux),recvcount, displs, MPI_DOUBLE_PRECISION, &
                          dfftp%comm2, info )
     CALL fftx_error__( 'cgather_sym', 'info<>0', info )
     offset_in  = offset_in  + dfftp%nr1x * dfftp%my_nr2p
     offset_aux = offset_aux + dfftp%nr1x * dfftp%nr2x
  end do

  ! 2) gather within the comm3 communicator 
  displs = 0
  DO proc = 0, ( dfftp%nproc3 - 1 )
     recvcount(proc) = 2 * dfftp%nr1x * dfftp%nr2x * dfftp%nr3p(proc+1) 
     if (proc > 0) displs(proc) = displs(proc-1) + recvcount(proc-1)
  ENDDO
  info = 0
  CALL MPI_ALLGATHERV( f_aux, recvcount(dfftp%mype3), MPI_DOUBLE_PRECISION, &
                       f_out, recvcount, displs, MPI_DOUBLE_PRECISION, &
                       dfftp%comm3, info )
  CALL fftx_error__( 'cgather_sym', 'info<>0', info )
  !
  ! ... the following check should be performed only on processor dfft%root
  ! ... otherwise f_out must be allocated on all processors even if not used
  !
  DEALLOCATE ( f_aux )
  !
  CALL stop_clock( 'cgather' )
  !
#else
  CALL fftx_error__('cgather_sym', 'do not use in serial execution', 1)
#endif
  !
  RETURN
  !
END SUBROUTINE cgather_sym
!
!
!-----------------------------------------------------------------------
SUBROUTINE cgather_sym_many( dfftp, f_in, f_out, nbnd, nbnd_proc, start_nbnd_proc )
  !-----------------------------------------------------------------------
  !
  ! ... Written by A. Dal Corso
  !
  ! ... This routine generalizes cgather_sym, receiveng nbnd complex 
  ! ... distributed functions and collecting nbnd_proc(dfftp%mype+1) 
  ! ... functions in each processor.
  ! ... start_nbnd_proc(dfftp%mype+1), says where the data for each processor
  ! ... start in the distributed variable
  ! ... COMPLEX*16  f_in  = distributed variable (nrxx,nbnd)
  ! ... COMPLEX*16  f_out = gathered variable (nr1x*nr2x*nr3x,nbnd_proc(dfftp%mype+1))
  !
  IMPLICIT NONE
  !
  TYPE (fft_type_descriptor), INTENT(in) :: dfftp
  INTEGER :: nbnd, nbnd_proc(dfftp%nproc), start_nbnd_proc(dfftp%nproc)
  COMPLEX(DP) :: f_in(dfftp%nnr,nbnd)
  COMPLEX(DP) :: f_out(dfftp%nr1x*dfftp%nr2x*dfftp%nr3x,nbnd_proc(dfftp%mype+1))
  COMPLEX(DP), ALLOCATABLE ::  f_aux(:) 
  !
#if defined(__MPI)
  !
  INTEGER :: proc_, proc2_, proc3_, proc, info, offset_in, offset_aux, ir3, nr2px
  INTEGER :: ibnd, jbnd, iii
  INTEGER :: displs(0:dfftp%nproc-1), recvcount(0:dfftp%nproc-1)
  !
  !
  CALL start_clock( 'cgather' )
  !
  ALLOCATE ( f_aux(dfftp%nr1x * dfftp%nr2x * dfftp%my_nr3p ) )
  !
  CALL MPI_BARRIER( dfftp%comm, info )
  !
  f_out = (0.d0,0.d0)

  !write (*,*) 'enter cgather ', nbnd
  !write (*,*) nbnd_proc
  !write (*,*) start_nbnd_proc
  !write (*,*) 'dfftp%nproc',dfftp%nproc 
  !do ibnd =1,3
  !write (*,*) 'evc = ',ibnd
  !write (*,*) f_in(1:3,ibnd)
  !end do


  nr2px = MAXVAL ( dfftp%nr2p )  ! maximum number of Y values to be disributed

  DO proc_ = 0, dfftp%nproc - 1
     ! define the processor index of the two sub-communicators
     proc2_ = dfftp%iproc2(proc_ + 1) -1 ; proc3_ = dfftp%iproc3(proc_ + 1) -1
     !write (*,*) ' proc_, proc2_, proc3_, dfftp%mype2', proc_, proc2_, proc3_, dfftp%mype2
     DO ibnd = 1, nbnd_proc(proc_ +1)
        jbnd = start_nbnd_proc(proc_ +1) + ibnd - 1
        !write (*,*) ' proc_, ibnd, jbnd ', proc_, ibnd, jbnd
        f_aux(:) = (0.d0,0.d0)
        ! 1) gather within the comm2 communicator
        displs = 0
        DO proc =0, ( dfftp%nproc2 -1 )
           recvcount(proc) = 2 * dfftp%nr1x * dfftp%nr2p(proc+1)
           if (proc > 0) displs(proc) = displs(proc-1) + recvcount(proc-1)
        end do
        !write (*,*) 'dfftp%nr1x ', dfftp%nr1x
        !write (*,*) 'dfftp%nr2x ', dfftp%nr2x
        !write (*,*) 'dfftp%nr3x ', dfftp%nr3x
        !write (*,*) 'dfftp%nr2p ', dfftp%nr2p, ' nnr3px ', nr2px
        !write (*,*) 'recvcount ', recvcount(0:dfftp%nproc2 -1)
        !write (*,*) 'displs ', displs(0:dfftp%nproc2 -1)
        offset_in = 1; offset_aux = 1
        do ir3 = 1, dfftp%my_nr3p
           info = 0
           CALL MPI_GATHERV( f_in(offset_in,jbnd), recvcount(dfftp%mype2), MPI_DOUBLE_PRECISION, &
                             f_aux(offset_aux), recvcount, displs, MPI_DOUBLE_PRECISION, &
                             proc2_, dfftp%comm2, info )
           CALL fftx_error__( 'cgather_sym_many', 'info<>0', info )
           offset_in  = offset_in  + dfftp%nr1x * dfftp%my_nr2p
           offset_aux = offset_aux + dfftp%nr1x * dfftp%nr2x
        end do
        !write(*,*) ' -> f_in(...+1:...+3,jbnd) ',jbnd
        !offset_in = 0
        !do iii =1,2*dfftp%nr2x
        !   write(*,'(i4,3("(",2f10.7,") "))') iii, f_in(offset_in+1:offset_in+3, jbnd)
        !   offset_in  = offset_in  + dfftp%nr1x 
        !enddo
        IF (dfftp%mype2==proc2_) THEN
        !   write(*,*) ' -> f_aux(...+1:...+3)'
        !   offset_aux = 0
        !   do iii =1,4*dfftp%nr2x
        !      write(*,'(i4,3("(",2f10.7,") "))') iii, f_aux(offset_aux+1:offset_aux+3)
        !      offset_aux = offset_aux + dfftp%nr1x
        !   enddo
        !   write(*,*) ' -> F_AUX(...+1:...+3)'
        !   offset_aux = 0
        !   do iii =1,dfftp%my_nr3p
        !      write(*,'(i4,3("(",2f10.7,") "))') iii, f_aux(offset_aux+1:offset_aux+3)
        !      offset_aux  = offset_aux  + dfftp%nr1x*dfftp%nr2x
        !   enddo
           ! 2) gather within the comm3 communicator 
           displs = 0
           DO proc = 0, ( dfftp%nproc3 - 1 )
              recvcount(proc) = 2 * dfftp%nr1x * dfftp%nr2x * dfftp%nr3p(proc+1) 
              if (proc > 0) displs(proc) = displs(proc-1) + recvcount(proc-1)
           ENDDO
           info = 0
           CALL MPI_GATHERV( f_aux, recvcount(dfftp%mype3), MPI_DOUBLE_PRECISION, &
                             f_out(1,ibnd), recvcount, displs, MPI_DOUBLE_PRECISION, &
                             proc3_, dfftp%comm3, info )
           CALL fftx_error__( 'cgather_sym_many', 'info<>0', info )
   
        !   IF (dfftp%mype3==proc3_) THEN
        !      write(*,*) ' -> f_out(...+1:...+3,ibnd) ',ibnd
        !      offset_in  = 0
        !      do iii =1,dfftp%nr3x
        !         write(*,'(i4,3("(",2f10.7,") "))') iii, f_out(offset_in+1:offset_in+3, ibnd)
        !         offset_in  = offset_in  + dfftp%nr1x*dfftp%nr2x
        !      enddo
        !   END IF
        END IF

     END DO
  END DO
  !
  DEALLOCATE ( f_aux )
  !
  CALL stop_clock( 'cgather' )
  !
#else
  CALL fftx_error__('cgather_sym_many', 'do not use in serial execution', 1)
#endif
  !
  RETURN
  !
END SUBROUTINE cgather_sym_many
!
!----------------------------------------------------------------------------
SUBROUTINE cscatter_sym_many( dfftp, f_in, f_out, target_ibnd, nbnd, nbnd_proc, &
                              start_nbnd_proc   )
  !----------------------------------------------------------------------------
  !
  ! ... Written by A. Dal Corso
  !
  ! ... generalizes cscatter_sym. It assumes that each processor has
  ! ... a certain number of bands (nbnd_proc(dfftp%mype+1)). The processor 
  ! ... that has target_ibnd scatters it to all the other processors 
  ! ... that receive a distributed part of the target function. 
  ! ... start_nbnd_proc(dfftp%mype+1) is used to identify the processor
  ! ... that has the required band
  !
  ! ... COMPLEX*16  f_in  = gathered variable (nr1x*nr2x*nr3x, nbnd_proc(dfftp%mype+1) )
  ! ... COMPLEX*16  f_out = distributed variable (nrxx)
  !
  IMPLICIT NONE
  !
  TYPE (fft_type_descriptor), INTENT(in) :: dfftp
  INTEGER :: nbnd, nbnd_proc(dfftp%nproc), start_nbnd_proc(dfftp%nproc)
  COMPLEX(DP) :: f_in(dfftp%nr1x*dfftp%nr2x*dfftp%nr3x,nbnd_proc(dfftp%mype+1))
  COMPLEX(DP) :: f_out(dfftp%nnr)
  COMPLEX(DP), ALLOCATABLE ::  f_aux(:) 
  INTEGER :: target_ibnd
  !
#if defined(__MPI)
  !
  INTEGER :: proc_, proc2_, proc3_, proc, info, offset_out, offset_aux, ir3
  INTEGER :: displs(0:dfftp%nproc-1), sendcount(0:dfftp%nproc-1)
  INTEGER :: ibnd, jbnd
  !
  CALL start_clock( 'cscatter_sym' )
  !
  ALLOCATE ( f_aux(dfftp%nr1x * dfftp%nr2x * dfftp%my_nr3p ) )
  !
  f_out = (0.0_DP, 0.0_DP)
  !
  CALL MPI_BARRIER( dfftp%comm, info )
  !
  DO proc_ = 0, dfftp%nproc - 1
     ! define the processor index of the two sub-communicators
     proc2_ = dfftp%iproc2(proc_ + 1) -1 ; proc3_ = dfftp%iproc3(proc_ + 1) -1
     DO ibnd = 1, nbnd_proc(proc_+1)
        jbnd = start_nbnd_proc(proc_+1) + ibnd - 1
        IF (jbnd/=target_ibnd) CYCLE
        IF (dfftp%mype2==proc2_) THEN
           ! 1) scatter within the comm3 communicator 
           displs = 0
           DO proc = 0, ( dfftp%nproc3 - 1 )
              sendcount(proc) = 2 * dfftp%nr1x * dfftp%nr2x * dfftp%nr3p(proc+1) 
              if (proc > 0) displs(proc) = displs(proc-1) + sendcount(proc-1)
           ENDDO
           info = 0
           CALL MPI_SCATTERV( f_in(1,ibnd), sendcount, displs, MPI_DOUBLE_PRECISION,   &
                              f_aux, sendcount(dfftp%mype3), MPI_DOUBLE_PRECISION, &
                              proc3_, dfftp%comm3, info )
        ELSE
           f_aux=(0.d0,0.d0)
        END IF
        ! 2) scatter within the comm2 communicator
        displs = 0 ; f_out = 0.0D0
        DO proc =0, ( dfftp%nproc2 -1 )
           sendcount(proc) = 2 * dfftp%nr1x * dfftp%nr2p(proc+1) 
           if (proc > 0) displs(proc) = displs(proc-1) + sendcount(proc-1)
        end do
        offset_out = 1 ; offset_aux = 1
        do ir3 = 1, dfftp%my_nr3p
           info = 0
           CALL MPI_SCATTERV( f_aux(offset_aux), sendcount, displs, MPI_DOUBLE_PRECISION,   &
                              f_out(offset_out), sendcount(dfftp%mype2), MPI_DOUBLE_PRECISION, &
                              proc2_, dfftp%comm2, info )
           CALL fftx_error__( 'gather_grid', 'info<>0', info )
           offset_out = offset_out + dfftp%nr1x * dfftp%my_nr2p
           offset_aux = offset_aux + dfftp%nr1x * dfftp%nr2x
        end do
     ENDDO
  ENDDO
  !
  DEALLOCATE ( f_aux )
  !
  CALL stop_clock( 'cscatter_sym' )
  !
#else
  CALL fftx_error__('cscatter_sym_many', 'do not use in serial execution', 1)
#endif
  !
  RETURN
  !
END SUBROUTINE cscatter_sym_many


!=----------------------------------------------------------------------=!
   END MODULE qepy_scatter_mod
!=----------------------------------------------------------------------=!
!
!
!---------------------------------------------------------------------
!subroutine fftsort (n, ia)  
  !!---------------------------------------------------------------------
  !! sort an integer array ia(1:n) into ascending order using heapsort algorithm.
  !! n is input, ia is replaced on output by its sorted rearrangement.
  !! create an index table (ind) by making an exchange in the index array
  !! whenever an exchange is made on the sorted data array (ia).
  !! in case of equal values in the data array (ia) the values in the
  !! index array (ind) are used to order the entries.
  !! if on input ind(1)  = 0 then indices are initialized in the routine,
  !! if on input ind(1) != 0 then indices are assumed to have been
  !!                initialized before entering the routine and these
  !!                indices are carried around during the sorting process
  !!
  !! no work space needed !
  !! free us from machine-dependent sorting-routines !
  !!
  !! adapted from Numerical Recipes pg. 329 (new edition)
  !!
  !implicit none  
  !!-input/output variables
  !integer :: n  
  !integer :: ia (2,n)  
  !!-local variables
  !integer :: i, ir, j, l
  !integer :: iia(2)  
  !! nothing to order
  !if (n.lt.2) return  
  !! initialize indices for hiring and retirement-promotion phase
  !l = n / 2 + 1  
  !ir = n  
!10 continue  
  !! still in hiring phase
  !if (l.gt.1) then  
     !l = l - 1  
     !iia(:) = ia (:,l)  
     !! in retirement-promotion phase.
  !else  
     !! clear a space at the end of the array
     !iia(:) = ia (:,ir)  
     !!
     !! retire the top of the heap into it
     !ia (:,ir) = ia (:,1)  
     !!
     !! decrease the size of the corporation
     !ir = ir - 1  
     !! done with the last promotion
     !if (ir.eq.1) then  
        !! the least competent worker at all !
        !ia (:,1) = iia(:)  
        !!
        !return  
     !endif
  !endif
  !! wheter in hiring or promotion phase, we
  !i = l  
  !! set up to place iia in its proper level
  !j = l + l  
  !!
  !do while (j.le.ir)  
     !if (j.lt.ir) then  
        !if (ia (1,j) .lt. ia (1,j + 1) ) then  
           !j = j + 1  
        !endif
     !endif
     !! demote iia
     !if (iia(1).lt.ia (1,j) ) then  
        !ia (:,i) = ia (:,j)  
        !i = j  
        !j = j + j  
     !else  
        !! set j to terminate do-while loop
        !j = ir + 1  
     !endif
  !enddo
  !ia (:,i) = iia(:)  
  !goto 10  
  !!
!end subroutine fftsort

! 
! Copyright (C) 2001-2013 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
!
!----------------------------------------------------------------------------
SUBROUTINE qepy_wfcinit(starting)
  !----------------------------------------------------------------------------
  !
  ! ... This routine computes an estimate of the starting wavefunctions
  ! ... from superposition of atomic wavefunctions and/or random wavefunctions.
  ! ... It also open needed files or memory buffers
  !
  USE io_global,            ONLY : stdout, ionode, ionode_id
  USE basis,                ONLY : natomwfc, starting_wfc
  USE bp,                   ONLY : lelfield
  USE klist,                ONLY : xk, nks, ngk, igk_k
  USE control_flags,        ONLY : io_level, lscf
  USE fixed_occ,            ONLY : one_atom_occupations
  USE ldaU,                 ONLY : lda_plus_u, U_projection, wfcU
  USE lsda_mod,             ONLY : lsda, current_spin, isk
  USE io_files,             ONLY : nwordwfc, nwordwfcU, iunhub, iunwfc,&
                                   diropn, xmlfile, restart_dir
  USE buffers,              ONLY : open_buffer, get_buffer, save_buffer
  USE uspp,                 ONLY : nkb, vkb
  USE wavefunctions,        ONLY : evc
  USE wvfct,                ONLY : nbnd, npwx, current_k
  USE wannier_new,          ONLY : use_wannier
  USE pw_restart_new,       ONLY : read_collected_wfc
  USE mp,                   ONLY : mp_bcast
  USE mp_images,            ONLY : intra_image_comm
  USE qexsd_module,         ONLY : qexsd_readschema
  USE qes_types_module,     ONLY : output_type
  USE qes_libs_module,      ONLY : qes_reset
  !
  IMPLICIT NONE
  !
  INTEGER :: ik, ierr
  LOGICAL :: exst, exst_mem, exst_file, opnd_file, twfcollect_file = .FALSE.
  CHARACTER (LEN=256)  :: dirname
  TYPE ( output_type ) :: output_obj
  !
  CHARACTER(LEN=*), INTENT(IN), OPTIONAL :: starting
  !
  IF (present(starting)) THEN
     IF (len_trim(starting)>1) starting_wfc= trim(starting)
  ENDIF
  !
  CALL start_clock( 'wfcinit' )
  !
  ! ... Orthogonalized atomic functions needed for LDA+U and other cases
  !
  IF ( use_wannier .OR. one_atom_occupations ) CALL orthoatwfc ( use_wannier )
  IF ( lda_plus_u ) CALL orthoUwfc()
  !
  ! ... open files/buffer for wavefunctions (nwordwfc set in openfil)
  ! ... io_level > 1 : open file, otherwise: open buffer
  !
  CALL open_buffer( iunwfc, 'wfc', nwordwfc, io_level, exst_mem, exst_file )
  !
  IF ( TRIM(starting_wfc) == 'file') THEN
     dirname = restart_dir ( ) 
     IF (ionode) CALL qexsd_readschema ( xmlfile(), ierr, output_obj )
     CALL mp_bcast(ierr, ionode_id, intra_image_comm)
     IF ( ierr <= 0 ) THEN 
        !
        IF (ionode) twfcollect_file = output_obj%band_structure%wf_collected   
        CALL mp_bcast(twfcollect_file, ionode_id, intra_image_comm)
        !
        IF ( twfcollect_file ) THEN
           !
           DO ik = 1, nks
              CALL read_collected_wfc ( dirname, ik, evc )
              CALL save_buffer ( evc, nwordwfc, iunwfc, ik )
           END DO
           !
        ELSE IF ( .NOT. exst_file) THEN
           !              !
           WRITE( stdout, '(5X,"Cannot read wfcs: file not found")' )
           starting_wfc = 'atomic+random'
           !
        ELSE
        !
        ! ... wavefunctions are read from file (or buffer) not here but
        !  ...in routine c_bands. If however there is a single k-point,
        ! ... c_bands doesn't read wavefunctions, so we read them here
        ! ... (directly from file to avoid a useless buffer allocation)
        !
           IF ( nks == 1 ) THEN
              inquire (unit = iunwfc, opened = opnd_file)
              if (.not.opnd_file) CALL diropn( iunwfc, 'wfc', 2*nwordwfc, exst )
              CALL davcio ( evc, 2*nwordwfc, iunwfc, nks, -1 )
             if(.not.opnd_file) CLOSE ( UNIT=iunwfc, STATUS='keep' )
           END IF
        END IF
     END IF 
     CALL qes_reset  ( output_obj )
  END IF
  !
  ! ... state what will happen
  !
  IF ( TRIM(starting_wfc) == 'file' ) THEN
     !
     WRITE( stdout, '(5X,"Starting wfcs from file")' )
     !
  ELSE IF ( starting_wfc == 'atomic' ) THEN
     !
     IF ( natomwfc >= nbnd ) THEN
        WRITE( stdout, '(5X,"Starting wfcs are ",I4," atomic wfcs")' ) natomwfc
     ELSE
        WRITE( stdout, '(5X,"Starting wfcs are ",I4," atomic + ", &
             &           I4," random wfcs")' ) natomwfc, nbnd-natomwfc
     END IF
     !
  ELSE IF ( TRIM(starting_wfc) == 'atomic+random' .AND. natomwfc > 0) THEN
     !
     IF ( natomwfc >= nbnd ) THEN
        WRITE( stdout, '(5X,"Starting wfcs are ",I4," randomized atomic wfcs")')&
             natomwfc
     ELSE
        WRITE( stdout, '(5X,"Starting wfcs are ",I4," randomized atomic wfcs + "&
             &          ,I4," random wfcs")' ) natomwfc, nbnd-natomwfc
     END IF
     !
  ELSE
     !
     WRITE( stdout, '(5X,"Starting wfcs are random")' )
     !
  END IF
  !
  ! ... exit here if starting from file or for non-scf calculations.
  ! ... In the latter case the starting wavefunctions are not 
  ! ... calculated here but just before diagonalization (to reduce I/O)
  !
  IF (  ( .NOT. lscf .AND. .NOT. lelfield ) .OR. TRIM(starting_wfc) == 'file' ) THEN
     !
     CALL stop_clock( 'wfcinit' )
     RETURN
     !
  END IF
  !
  ! ... calculate and write all starting wavefunctions to buffer
  !
  DO ik = 1, nks
     !
     ! ... Hpsi initialization: k-point index, spin, kinetic energy
     !
     current_k = ik
     IF ( lsda ) current_spin = isk(ik)
     call g2_kin (ik)
     !
     ! ... More Hpsi initialization: nonlocal pseudopotential projectors |beta>
     !
     IF ( nkb > 0 ) CALL init_us_2( ngk(ik), igk_k(1,ik), xk(1,ik), vkb )
     !
     ! ... Needed for LDA+U
     !
     IF ( nks > 1 .AND. lda_plus_u .AND. (U_projection .NE. 'pseudo') ) &
        CALL get_buffer( wfcU, nwordwfcU, iunhub, ik )
     !
     ! ... calculate starting wavefunctions (calls Hpsi)
     !
     CALL init_wfc ( ik )
     !qepy --> lsda up==down
     IF ( lsda .and. ik > nks/2) &
         CALL get_buffer ( evc, nwordwfc, iunwfc, ik-nks/2 )
     !qepy <-- lsda up==down
     !
     ! ... write  starting wavefunctions to file
     !
     IF ( nks > 1 .OR. (io_level > 1) .OR. lelfield ) &
         CALL save_buffer ( evc, nwordwfc, iunwfc, ik )
     !
  END DO
  !
  CALL stop_clock( 'wfcinit' )
  RETURN
  !
END SUBROUTINE qepy_wfcinit
!
!----------------------------------------------------------------------------
!SUBROUTINE init_wfc ( ik )
!  !----------------------------------------------------------------------------
!  !
!  ! ... This routine computes starting wavefunctions for k-point ik
!  !
!  USE kinds,                ONLY : DP
!  USE bp,                   ONLY : lelfield
!  USE becmod,               ONLY : allocate_bec_type, deallocate_bec_type, &
!                                   bec_type, becp
!  USE constants,            ONLY : tpi
!  USE cell_base,            ONLY : tpiba2
!  USE basis,                ONLY : natomwfc, starting_wfc
!  USE gvect,                ONLY : g, gstart
!  USE klist,                ONLY : xk, ngk, igk_k
!  USE wvfct,                ONLY : nbnd, npwx, et
!  USE uspp,                 ONLY : nkb, okvan
!  USE noncollin_module,     ONLY : npol
!  USE wavefunctions, ONLY : evc
!  USE random_numbers,       ONLY : randy
!  USE mp_bands,             ONLY : intra_bgrp_comm, inter_bgrp_comm, &
!                                   nbgrp, root_bgrp_id
!  USE mp,                   ONLY : mp_bcast
!  USE funct,                ONLY : dft_is_hybrid, stop_exx
!  !
!  IMPLICIT NONE
!  !
!  INTEGER, INTENT(in) :: ik
!  !
!  INTEGER :: ibnd, ig, ipol, n_starting_wfc, n_starting_atomic_wfc
!  LOGICAL :: lelfield_save
!  !
!  REAL(DP) :: rr, arg
!  REAL(DP), ALLOCATABLE :: etatom(:) ! atomic eigenvalues
!  !
!  COMPLEX(DP), ALLOCATABLE :: wfcatom(:,:,:) ! atomic wfcs for initialization
!  !
!  !
!  IF ( starting_wfc(1:6) == 'atomic' ) THEN
!     !
!     n_starting_wfc = MAX( natomwfc, nbnd )
!     n_starting_atomic_wfc = natomwfc
!     !
!  ELSE IF ( starting_wfc == 'random' ) THEN
!     !
!     n_starting_wfc = nbnd
!     n_starting_atomic_wfc = 0
!     !
!  ELSE
!     !
!     ! ...case 'file' should not be done here
!     !
!     CALL errore ( 'init_wfc', &
!          'invalid value for startingwfc: ' // TRIM ( starting_wfc ) , 1 )
!     !
!  END IF
!  !
!  ALLOCATE( wfcatom( npwx, npol, n_starting_wfc ) )
!  !
!  IF ( starting_wfc(1:6) == 'atomic' ) THEN
!     !
!     CALL start_clock( 'wfcinit:atomic' ); !write(*,*) 'start wfcinit:atomic' ; FLUSH(6)
!     CALL atomic_wfc( ik, wfcatom )
!     CALL stop_clock( 'wfcinit:atomic' ); !write(*,*) 'stop wfcinit:atomic' ; FLUSH(6)
!     !
!     IF ( starting_wfc == 'atomic+random' .AND. &
!         n_starting_wfc == n_starting_atomic_wfc ) THEN
!         !
!         ! ... in this case, introduce a small randomization of wavefunctions
!         ! ... to prevent possible "loss of states"
!         !
!         DO ibnd = 1, n_starting_atomic_wfc
!            !
!            DO ipol = 1, npol
!               !
!               DO ig = 1, ngk(ik)
!                  !
!                  rr  = randy()
!                  arg = tpi * randy()
!                  !
!                  wfcatom(ig,ipol,ibnd) = wfcatom(ig,ipol,ibnd) * &
!                     ( 1.0_DP + 0.05_DP * CMPLX( rr*COS(arg), rr*SIN(arg) ,kind=DP) ) 
!                  !
!               END DO
!               !
!            END DO
!            !
!         END DO
!         !
!     END IF
!     !
!  END IF
!  !
!  ! ... if not enough atomic wfc are available,
!  ! ... fill missing wfcs with random numbers
!  !
!  DO ibnd = n_starting_atomic_wfc + 1, n_starting_wfc
!     !
!     DO ipol = 1, npol
!        ! 
!        wfcatom(:,ipol,ibnd) = (0.0_dp, 0.0_dp)
!        !
!        DO ig = 1, ngk(ik)
!           !
!           rr  = randy()
!           arg = tpi * randy()
!           !
!           wfcatom(ig,ipol,ibnd) = &
!                CMPLX( rr*COS( arg ), rr*SIN( arg ) ,kind=DP) / &
!                       ( ( xk(1,ik) + g(1,igk_k(ig,ik)) )**2 + &
!                         ( xk(2,ik) + g(2,igk_k(ig,ik)) )**2 + &
!                         ( xk(3,ik) + g(3,igk_k(ig,ik)) )**2 + 1.0_DP )
!        END DO
!        !
!     END DO
!     !
!  END DO
  
!  ! when band parallelization is active, the first band group distributes
!  ! the wfcs to the others making sure all bgrp have the same starting wfc
!  ! FIXME: maybe this should be done once evc are computed, not here?
!  !
!  IF( nbgrp > 1 ) CALL mp_bcast( wfcatom, root_bgrp_id, inter_bgrp_comm )
!  !
!  ! ... Diagonalize the Hamiltonian on the basis of atomic wfcs
!  !
!  ALLOCATE( etatom( n_starting_wfc ) )
!  !
!  ! ... Allocate space for <beta|psi>
!  !
!  CALL allocate_bec_type ( nkb, n_starting_wfc, becp, intra_bgrp_comm )
!  !
!  ! ... the following trick is for electric fields with Berry's phase:
!  ! ... by setting lelfield = .false. one prevents the calculation of
!  ! ... electric enthalpy in the Hamiltonian (cannot be calculated
!  ! ... at this stage: wavefunctions at previous step are missing)
!  ! 
!  lelfield_save = lelfield
!  lelfield = .FALSE.
!  !
!  ! ... subspace diagonalization (calls Hpsi)
!  !
!  IF ( dft_is_hybrid()  ) CALL stop_exx() 
!  CALL start_clock( 'wfcinit:wfcrot' ); !write(*,*) 'start wfcinit:wfcrot' ; FLUSH(6)
!  CALL rotate_wfc ( npwx, ngk(ik), n_starting_wfc, gstart, nbnd, wfcatom, npol, okvan, evc, etatom )
!  CALL stop_clock( 'wfcinit:wfcrot' ); !write(*,*) 'stop wfcinit:wfcrot' ; FLUSH(6)
!  !
!  lelfield = lelfield_save
!  !
!  ! ... copy the first nbnd eigenvalues
!  ! ... eigenvectors are already copied inside routine rotate_wfc
!  !
!  et(1:nbnd,ik) = etatom(1:nbnd)
!  !
!  CALL deallocate_bec_type ( becp )
!  DEALLOCATE( etatom )
!  DEALLOCATE( wfcatom )
!  !
!  RETURN
!  !
!END SUBROUTINE init_wfc

!
! Copyright (C) 2006 WanT Group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
! TB
! included gate related variables in qexml_write_efield and qexml_read_efield
!
!----------------------------------------------------------------------------
MODULE oldxml_qexml_module
  !----------------------------------------------------------------------------
  !
  ! This module contains some common subroutines used to read and write
  ! in XML format the data produced by Quantum ESPRESSO package.
  !
  ! Written by Andrea Ferretti (2006).
  ! Modified by Simone Ziraldo (2013).
  !
  ! Important parts of the implementation are taken from xml_io_base.f90
  ! (written by Carlo Sbraccia) in the Quantum ESPRESSO distribution,
  ! under the GNU-GPL licensing:
  !
  ! Copyright (C) 2005 Quantum ESPRESSO group
  ! This file is distributed under the terms of the
  ! GNU General Public License. See the file `License'
  ! in the root directory of the present distribution,
  ! or http://www.gnu.org/copyleft/gpl.txt .
  !
#if defined(__OLDXML)
  !
  USE iotk_module
  USE kinds, ONLY : DP
  IMPLICIT NONE
  !
  PRIVATE
  SAVE
  !
  ! definitions for the fmt
  !
  CHARACTER(5), PARAMETER :: fmt_name = "QEXML"
  CHARACTER(5), PARAMETER :: fmt_version = "1.4.0"
  !
  ! some default for kinds
  !
  !INTEGER,   PARAMETER :: dbl = selected_real_kind( 14, 200 )
  !
  ! internal data to be set
  !
  CHARACTER(256)   :: datadir_in, datadir_out
  INTEGER          :: iunit, ounit
  !
  ! vars to manage back compatibility
  !
  CHARACTER(10)    :: qexml_current_version = " "
  CHARACTER(10)    :: qexml_default_version = trim( fmt_version  )
  LOGICAL          :: qexml_current_version_init = .false.
  LOGICAL          :: qexml_version_before_1_4_0 = .false.
  !
  CHARACTER(iotk_attlenx) :: attr
  !
  !
  ! end of declarations
  !
  PUBLIC :: qexml_current_version, qexml_default_version
  PUBLIC :: qexml_current_version_init
  !
  PUBLIC :: qexml_init,  qexml_openfile, qexml_closefile
  !
  PUBLIC :: qexml_write_header, qexml_write_control, qexml_write_status_cp, qexml_write_cell,  &
            qexml_write_moving_cell, qexml_write_ions, qexml_write_symmetry, qexml_write_efield, &
            qexml_write_planewaves, qexml_write_spin, qexml_write_magnetization, &
            qexml_write_xc, qexml_write_exx, qexml_write_occ, qexml_write_bz, qexml_write_para, &
            qexml_write_bands_pw,qexml_write_bands_cp, qexml_write_bands_info, qexml_write_eig, &
            qexml_write_gk, qexml_write_wfc, qexml_write_rho, qexml_write_esm
  !
  PUBLIC :: qexml_read_header, qexml_read_status_cp, qexml_read_cell, qexml_read_moving_cell, qexml_read_ions,      &
            qexml_read_symmetry, qexml_read_efield,                   &
            qexml_read_planewaves, qexml_read_spin, qexml_read_xc,    &
            qexml_read_occ, qexml_read_bz, qexml_read_phonon,         &
            qexml_read_bands_pw, qexml_read_bands_cp, qexml_read_bands_info,                  &
            qexml_read_gk, qexml_read_wfc, qexml_read_rho, qexml_read_magnetization, &
            qexml_read_exx, qexml_read_para, qexml_read_esm
  
  !
  PUBLIC :: qexml_wfc_filename, qexml_create_directory, &
            qexml_kpoint_dirname, qexml_restart_dirname
  !
CONTAINS
!
!-------------------------------------------
! ... basic (public) subroutines
!-------------------------------------------
!
    !------------------------------------------------------------------------
    SUBROUTINE qexml_init( unit_in, unit_out, dir, dir_in, dir_out, &
                           datafile, datafile_in, datafile_out )
      !------------------------------------------------------------------------
      !
      ! just init module data
      !
      IMPLICIT NONE
      INTEGER,                INTENT(in) :: unit_in
      INTEGER,      OPTIONAL, INTENT(in) :: unit_out
      CHARACTER(*), OPTIONAL, INTENT(in) :: dir
      CHARACTER(*), OPTIONAL, INTENT(in) :: dir_in, dir_out
      CHARACTER(*), OPTIONAL, INTENT(in) :: datafile
      CHARACTER(*), OPTIONAL, INTENT(in) :: datafile_in, datafile_out
      !
      iunit       = unit_in
      ounit       = unit_in
      IF ( present( unit_out ) ) ounit  = unit_out
      !
      !
      datadir_in  = "./"
      datadir_out = "./"
      !
      ! first check whether datafile is given
      !
      IF ( present( datafile ) ) THEN
          !
          datadir_in = datafile
          CALL qexml_basename ( datadir_in,  "data-file.xml")
          !
          datadir_out = datadir_in
          !
      ENDIF
      !
      IF ( present( datafile_in ) ) THEN
          !
          datadir_in = datafile_in
          CALL qexml_basename ( datadir_in,  "data-file.xml")
          !
      ENDIF
      !
      IF ( present( datafile_out ) ) THEN
          !
          datadir_out = datafile_out
          CALL qexml_basename ( datadir_out,  "data-file.xml")
          !
      ENDIF
      !
      ! the presence of directories overwrites any info
      ! about datafiles
      !
      IF ( present( dir ) ) THEN
          datadir_in  = trim(dir)
          datadir_out = trim(dir)
      ENDIF
      !
      IF ( present( dir_in ) ) THEN
          datadir_in  = trim(dir_in)
      ENDIF
      !
      IF ( present( dir_out ) ) THEN
          datadir_out  = trim(dir_out)
      ENDIF
      !
    END SUBROUTINE qexml_init
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_openfile( filename, action, binary, ierr)
      !------------------------------------------------------------------------
      !
      ! open data file
      !
      IMPLICIT NONE
      !
      CHARACTER(*),       INTENT(in)  :: filename
      CHARACTER(*),       INTENT(in)  :: action      ! ("read"|"write")
      LOGICAL, OPTIONAL,  INTENT(in)  :: binary
      INTEGER,            INTENT(out) :: ierr
      !
      LOGICAL :: binary_

      ierr = 0
      binary_ = .false.
      IF ( present(binary) ) binary_ = binary
      !
      SELECT CASE ( trim(action) )
      !
      CASE ( "read", "READ" )
          !
          CALL iotk_open_read ( iunit, FILE = trim(filename), IERR=ierr )
          IF ( ierr/=0 ) RETURN
          !
          CALL qexml_read_header( FORMAT_VERSION=qexml_current_version, IERR=ierr )
          IF ( ierr/=0 ) qexml_current_version = trim( qexml_default_version )
          !
          !
      CASE ( "write", "WRITE" )
          !
          CALL iotk_open_write( iunit, FILE = trim(filename), BINARY=binary_, IERR=ierr )
          IF ( ierr/=0 ) RETURN
          !
          qexml_current_version = trim( qexml_default_version )
          !
      CASE DEFAULT
          ierr = 1
      END SELECT
      !
      ! init logical variables for versioning
      !
      qexml_version_before_1_4_0 = .false.
      !
      IF ( trim( qexml_version_compare( qexml_current_version, "1.4.0" )) == "older" ) &
         qexml_version_before_1_4_0 = .true.
      !
      qexml_current_version_init = .true.
      !
      !
    END SUBROUTINE qexml_openfile
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_closefile( action, ierr)
      !------------------------------------------------------------------------
      !
      ! close data file
      !
      IMPLICIT NONE
      !
      CHARACTER(*),  INTENT(in)  :: action      ! ("read"|"write")
      INTEGER,       INTENT(out) :: ierr
      !
      ierr = 0
      !
      SELECT CASE ( trim(action) )
      CASE ( "read", "READ" )
          !
          CALL iotk_close_read( iunit, IERR=ierr )
          !
      CASE ( "write", "WRITE" )
          !
          CALL iotk_close_write( iunit, IERR=ierr )
          !
      CASE DEFAULT
          ierr = 2
      END SELECT
      !
    END SUBROUTINE qexml_closefile
!
!-------------------------------------------
! ... basic (private) subroutines
!-------------------------------------------
!
    !------------------------------------------------------------------------
    FUNCTION int_to_char( i )
      !------------------------------------------------------------------------
      !
      IMPLICIT NONE
      !
      INTEGER, INTENT(in) :: i
      CHARACTER (len=6)   :: int_to_char
      !
      !
      IF ( i < 10 ) THEN
         !
         WRITE( UNIT = int_to_char , FMT = "(I1)" ) i
         !
      ELSEIF ( i < 100 ) THEN
         !
         WRITE( UNIT = int_to_char , FMT = "(I2)" ) i
         !
       ELSEIF ( i < 1000 ) THEN
         !
         WRITE( UNIT = int_to_char , FMT = "(I3)" ) i
         !
       ELSEIF ( i < 10000 ) THEN
         !
         WRITE( UNIT = int_to_char , FMT = "(I4)" ) i
         !
       ELSE
         !
       WRITE( UNIT = int_to_char , FMT = "(I5)" ) i
       !
      ENDIF
      !
    END FUNCTION int_to_char
    !
    !
    !--------------------------------------------------------------------------
    SUBROUTINE qexml_basename( str, extension )
      !--------------------------------------------------------------------------
      !
      ! perform the basename operation on the string str, eliminating
      ! any ending (rightmost) occurrence of extension
      !
      CHARACTER(*),  INTENT(inout) :: str
      CHARACTER(*),  INTENT(in)    :: extension
      !
      INTEGER :: ind, strlen, extlen, i
      !
      IF( len_trim(extension) == 0  .or. len_trim(str) == 0 ) RETURN
      !
      strlen = len_trim( str )
      extlen = len_trim( extension )
      ind    = index( str, trim(extension), BACK=.true. )
      !
      IF ( ind <= 0 .or. ind > strlen ) RETURN
      !
      ! we want to cut only the last part of the name
      ! any intermediate matching is rejected
      !
      IF ( strlen -ind +1 /= extlen ) RETURN
      !
      DO i = ind, strlen
         str(i:i) = ' '
      ENDDO
      !
    END SUBROUTINE qexml_basename
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_version_parse(str, major, minor, patch, ierr)
      !--------------------------------------------------------------------------
      !
      ! Determine the major, minor and patch numbers from
      ! a version string with the fmt "i.j.k"
      !
      ! The ierr variable assumes the following values
      !
      ! ierr < 0     emtpy string
      ! ierr = 0     no problem
      ! ierr > 0     fatal error
      !
      IMPLICIT NONE
      CHARACTER(*),     INTENT(in)    :: str
      INTEGER,          INTENT(out)   :: major, minor, patch, ierr
      !
      INTEGER       :: i1, i2, length
      INTEGER       :: ierrtot
      CHARACTER(10) :: num(3)

      !
      major = 0
      minor = 0
      patch = 0

      length = len_trim( str )
      !
      IF ( length == 0 ) THEN
         !
         ierr = -1
         RETURN
         !
      ENDIF

      i1 = scan( str, ".")
      i2 = scan( str, ".", BACK=.true.)
      !
      IF ( i1 == 0 .or. i2 == 0 .or. i1 == i2 ) THEN
         !
         ierr = 1
         RETURN
         !
      ENDIF
      !
      num(1) = str(    1 : i1-1 )
      num(2) = str( i1+1 : i2-1 )
      num(3) = str( i2+1 : )
      !
      ierrtot = 0
      !
      READ( num(1), *, IOSTAT=ierr ) major
      IF (ierr/=0) RETURN
      !
      READ( num(2), *, IOSTAT=ierr ) minor
      IF (ierr/=0) RETURN
      !
      READ( num(3), *, IOSTAT=ierr ) patch
      IF (ierr/=0) RETURN
      !
    END SUBROUTINE qexml_version_parse
    !
    !--------------------------------------------------------------------------
    FUNCTION qexml_version_compare(str1, str2)
      !--------------------------------------------------------------------------
      !
      ! Compare two version strings; the result is
      !
      ! "newer":   str1 is newer that str2
      ! "equal":   str1 is equal   to str2
      ! "older":   str1 is older than str2
      ! " ":       str1 or str2 has a wrong format
      !
      IMPLICIT NONE
      CHARACTER(*)  :: str1, str2
      CHARACTER(10) :: qexml_version_compare
      !
      INTEGER   :: version1(3), version2(3)
      INTEGER   :: basis, icheck1, icheck2
      INTEGER   :: ierr
      !

      qexml_version_compare = " "
      !
      CALL qexml_version_parse( str1, version1(1), version1(2), version1(3), ierr)
      IF ( ierr/=0 ) RETURN
      !
      CALL qexml_version_parse( str2, version2(1), version2(2), version2(3), ierr)
      IF ( ierr/=0 ) RETURN
      !
      !
      basis = 1000
      !
      icheck1 = version1(1) * basis**2 + version1(2)* basis + version1(3)
      icheck2 = version2(1) * basis**2 + version2(2)* basis + version2(3)
      !
      IF ( icheck1 > icheck2 ) THEN
         !
         qexml_version_compare = 'newer'
         !
      ELSEIF( icheck1 == icheck2 ) THEN
         !
         qexml_version_compare = 'equal'
         !
      ELSE
         !
         qexml_version_compare = 'older'
         !
      ENDIF
      !
    END FUNCTION qexml_version_compare
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_create_directory( dirname, ierr )
      !------------------------------------------------------------------------
      !
      USE wrappers,      ONLY : f_mkdir_safe
      !
      CHARACTER(len=*), INTENT(in)  :: dirname
      INTEGER,          INTENT(out) :: ierr
      !
      INTEGER  :: iunaux
      !
      ierr = 0
      CALL iotk_free_unit( iunaux )
      !
      ierr = f_mkdir_safe( TRIM(dirname) )
      !
      IF ( ierr/=0 ) RETURN
      !
      ! ... check whether the scratch directory is writable
      !
      OPEN( iunaux , FILE = trim( dirname ) // '/test', IOSTAT = ierr )
      IF ( ierr/=0 ) RETURN
      !
      CLOSE( iunaux , STATUS = 'DELETE' )
      !
      RETURN
      !
    END SUBROUTINE qexml_create_directory
    !
    !
    !------------------------------------------------------------------------
    FUNCTION qexml_kpoint_dirname( basedir, ik )
      !------------------------------------------------------------------------
      !
      CHARACTER(LEN=256)           :: qexml_kpoint_dirname
      CHARACTER(LEN=*), INTENT(IN) :: basedir
      INTEGER,          INTENT(IN) :: ik
      !
      CHARACTER(LEN=256) :: kdirname
      CHARACTER(LEN=5)   :: kindex
      CHARACTER(LEN=6)   :: kindex1
      !
      IF (ik<99999) THEN
         WRITE( kindex, FMT = '( I5.5 )' ) ik     
         kdirname = TRIM( basedir ) // '/K' // kindex
      ELSEIF (ik<999999) THEN
         WRITE( kindex1, FMT = '( I6.6 )' ) ik     
         kdirname = TRIM( basedir ) // '/K' // kindex1
      ELSE
         call errore('qexml_kpoint_dirname','ik too large, increase format',1)
      ENDIF
      !
      qexml_kpoint_dirname = TRIM( kdirname )
      !
      RETURN
      !
    END FUNCTION qexml_kpoint_dirname
    !
    !
    !------------------------------------------------------------------------
    FUNCTION qexml_wfc_filename( basedir, name, ik, ipol, tag, extension, dir )
      !------------------------------------------------------------------------
      !
      CHARACTER(len=256)                 :: qexml_wfc_filename
      CHARACTER(len=*),       INTENT(in) :: basedir
      CHARACTER(len=*),       INTENT(in) :: name
      INTEGER,                INTENT(in) :: ik
      INTEGER,      OPTIONAL, INTENT(in) :: ipol
      CHARACTER(*), OPTIONAL, INTENT(in) :: tag
      CHARACTER(*), OPTIONAL, INTENT(in) :: extension
      LOGICAL,      OPTIONAL, INTENT(in) :: dir
      !
      CHARACTER(len=256) :: filename, tag_, ext_
      LOGICAL :: dir_true
      !
      !
      filename = ' '
      tag_     = ' '
      ext_     = '.dat'
      dir_true = .true.
      !
      IF ( present( tag ) )         tag_ = '_'//trim(tag)
      IF ( present( extension ) )   ext_ = '.'//trim(extension)
      !
      IF ( present( ipol ) ) THEN
         !
         WRITE( filename, FMT = '( I1 )' ) ipol
         !
      ENDIF
      IF (PRESENT(dir)) dir_true=dir
      !
      IF (dir_true) THEN
         filename = TRIM( qexml_kpoint_dirname( basedir, ik ) ) // '/' // &
                 & TRIM( name ) // TRIM( filename ) // TRIM( tag_ ) // TRIM( ext_)
      ELSE
         filename = TRIM( qexml_kpoint_dirname( basedir, ik ) ) // '_' // &
                 & TRIM( name ) // TRIM( filename ) // TRIM( tag_ ) // TRIM( ext_)
      ENDIF
      !
      !
      qexml_wfc_filename = trim( filename )
      !
      RETURN
      !
    END FUNCTION qexml_wfc_filename
    !
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_copy_file( file_in, file_out, ierr )
      !------------------------------------------------------------------------
      !
      CHARACTER(len=*),  INTENT(in) :: file_in, file_out
      INTEGER,           INTENT(out):: ierr
      !
      CHARACTER(len=256) :: string
      INTEGER            :: iun_in, iun_out, ios
      !
      !
      ierr = 0
      !
      CALL iotk_free_unit( iun_in,  ierr )
      IF ( ierr /= 0) RETURN
      CALL iotk_free_unit( iun_out, ierr )
      IF ( ierr /= 0) RETURN
      !
      OPEN( UNIT = iun_in,  FILE = file_in,  STATUS = "OLD", IOSTAT=ierr )
      IF ( ierr /= 0) RETURN
      OPEN( UNIT = iun_out, FILE = file_out, STATUS = "UNKNOWN", IOSTAT=ierr )
      IF ( ierr /= 0) RETURN
      !
      copy_loop: DO
         !
         READ( UNIT = iun_in, FMT = '(A256)', IOSTAT = ios ) string
         !
         IF ( ios < 0 ) exit copy_loop
         !
         WRITE( UNIT = iun_out, FMT = '(A)' ) trim( string )
         !
      ENDDO copy_loop
      !
      CLOSE( UNIT = iun_in )
      CLOSE( UNIT = iun_out )
      !
      RETURN
      !
    END SUBROUTINE qexml_copy_file
    !
    !
    !------------------------------------------------------------------------
    FUNCTION check_file_exst( filename )
      !------------------------------------------------------------------------
      !
      IMPLICIT NONE
      !
      LOGICAL          :: check_file_exst
      CHARACTER(len=*) :: filename
      !
      LOGICAL :: lexists
      !
      INQUIRE( FILE = trim( filename ), EXIST = lexists )
      !
      check_file_exst = lexists
      RETURN
      !
    END FUNCTION check_file_exst
    !
    !
    !------------------------------------------------------------------------
    FUNCTION qexml_restart_dirname( outdir, prefix, runit )
      !------------------------------------------------------------------------
      !
      CHARACTER(len=256)           :: qexml_restart_dirname
      CHARACTER(len=*), INTENT(in) :: outdir, prefix
      INTEGER,          INTENT(IN) :: runit
      !
      CHARACTER(len=256)         :: dirname
      INTEGER                    :: strlen
      CHARACTER(LEN=6), EXTERNAL :: int_to_char
      !
      ! ... main restart directory
      !
      dirname = TRIM( prefix ) // '_' // TRIM( int_to_char( runit ) )// '.save/'
      !
      IF ( len( outdir ) > 1 ) THEN
         !
         strlen = len_trim( outdir )
         IF ( outdir(strlen:strlen) == '/' ) strlen = strlen -1
         !
         dirname = outdir(1:strlen) // '/' // dirname
         !
      ENDIF
      !
      qexml_restart_dirname = trim( dirname )
      !
      RETURN
      !
    END FUNCTION qexml_restart_dirname
!
!-------------------------------------------
! ... write subroutines
!-------------------------------------------
!
    !------------------------------------------------------------------------
    SUBROUTINE qexml_write_header( creator_name, creator_version )
      !------------------------------------------------------------------------
      !
      IMPLICIT NONE
      CHARACTER(len=*), INTENT(in) :: creator_name, creator_version
      CHARACTER(iotk_attlenx)  :: attr
      !
      CALL iotk_write_begin( ounit, "HEADER" )
      !
      CALL iotk_write_attr(attr, "NAME",trim(fmt_name), FIRST=.true.)
      CALL iotk_write_attr(attr, "VERSION",trim(fmt_version) )
      CALL iotk_write_empty( ounit, "FORMAT", ATTR=attr )
      !
      CALL iotk_write_attr(attr, "NAME",trim(creator_name), FIRST=.true.)
      CALL iotk_write_attr(attr, "VERSION",trim(creator_version) )
      CALL iotk_write_empty( ounit, "CREATOR", ATTR=attr )
      !
      CALL iotk_write_end( ounit, "HEADER" )
      !
    END SUBROUTINE qexml_write_header
    !
    !
    !------------------------------------------------------------------------  
    SUBROUTINE qexml_write_control( pp_check_flag, lkpoint_dir, q_real_space, tq_smoothing, tbeta_smoothing, beta_real_space)
      !------------------------------------------------------------------------
      !
      IMPLICIT NONE
      LOGICAL, OPTIONAL, INTENT(IN) :: pp_check_flag, lkpoint_dir, q_real_space, tq_smoothing, tbeta_smoothing, beta_real_space


      CALL iotk_write_begin( ounit, "CONTROL" )
      !
      !  This flag is used to check if the file can be used for post-processing
      IF ( PRESENT( pp_check_flag ) ) &
         CALL iotk_write_dat( ounit, "PP_CHECK_FLAG", pp_check_flag )
      !
      !  This flag says how eigenvalues are saved
      IF ( PRESENT( lkpoint_dir ) ) &
         CALL iotk_write_dat( ounit, "LKPOINT_DIR", lkpoint_dir )
      !
      !  This flag says if Q in real space has to be used
      IF ( PRESENT( q_real_space ) ) &
         CALL iotk_write_dat( ounit, "Q_REAL_SPACE", q_real_space )
      ! This flag says if Beta functions were treated in real space
      IF ( PRESENT( beta_real_space ) ) &
         CALL iotk_write_dat( ounit, "BETA_REAL_SPACE", beta_real_space )
      ! This flag says if the Q are being smoothed 
      IF ( PRESENT( tq_smoothing ) ) &
         CALL iotk_write_dat( ounit, "TQ_SMOOTHING", tq_smoothing )
      ! This flag says if the beta are being smoothed 
      IF ( PRESENT( tbeta_smoothing ) ) &
         CALL iotk_write_dat( ounit, "TBETA_SMOOTHING", tbeta_smoothing )
      !
      CALL iotk_write_end( ounit, "CONTROL" )
      !
    END SUBROUTINE qexml_write_control
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_write_status_cp( nfi,simtime,time_units,title, &
                                  ekin, eht, esr, eself, epseu, enl, exc, vave, enthal, &
                                  energy_units)
      !------------------------------------------------------------------------
      !
      INTEGER, INTENT(in) :: nfi
      REAL(DP), INTENT(in) :: simtime, ekin,eht,esr,eself,epseu,enl,exc,vave,enthal
      CHARACTER(len=*), INTENT(in) :: time_units, title, energy_units
      
      CALL iotk_write_begin( ounit, "STATUS" )
      !
      CALL iotk_write_attr( attr, "ITERATION", nfi, FIRST = .TRUE. )
      CALL iotk_write_empty( ounit, "STEP", attr )
      !
      CALL iotk_write_attr( attr, "UNITS", time_units, FIRST = .TRUE. )
      CALL iotk_write_dat( ounit, "TIME", simtime, ATTR = attr )
      !
      CALL iotk_write_dat( ounit, "TITLE", title )
      !
      CALL iotk_write_attr( attr, "UNITS", energy_units, FIRST = .TRUE. )
      CALL iotk_write_dat( ounit, "KINETIC_ENERGY", ekin,   ATTR = attr )
      CALL iotk_write_dat( ounit, "HARTREE_ENERGY", eht,    ATTR = attr )
      CALL iotk_write_dat( ounit, "EWALD_TERM",     esr,    ATTR = attr )
      CALL iotk_write_dat( ounit, "GAUSS_SELFINT",  eself,  ATTR = attr )
      CALL iotk_write_dat( ounit, "LPSP_ENERGY",    epseu,  ATTR = attr )
      CALL iotk_write_dat( ounit, "NLPSP_ENERGY",   enl,    ATTR = attr )
      CALL iotk_write_dat( ounit, "EXC_ENERGY",     exc,    ATTR = attr )
      CALL iotk_write_dat( ounit, "AVERAGE_POT",    vave,   ATTR = attr )
      CALL iotk_write_dat( ounit, "ENTHALPY",       enthal, ATTR = attr )
      !
      CALL iotk_write_end( ounit, "STATUS" )
      !
    END SUBROUTINE qexml_write_status_cp
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_write_cell( ibravais_latt, celldm, alat, &
                                 a1, a2, a3, b1, b2, b3, alat_units, a_units, b_units, &
                                 do_mp, do_mt, do_esm, do_cutoff_2D) 
      !------------------------------------------------------------------------
      !
      INTEGER,          INTENT(in) :: ibravais_latt
      REAL(DP),        INTENT(in) :: celldm(6), alat
      REAL(DP),        INTENT(in) :: a1(3), a2(3), a3(3)
      REAL(DP),        INTENT(in) :: b1(3), b2(3), b3(3)
      CHARACTER(len=*), INTENT(in) :: alat_units, a_units, b_units
      LOGICAL,          INTENT(in) :: do_mp, do_mt, do_esm , do_cutoff_2D
      !
      CHARACTER(len=256) :: bravais_lattice, es_corr
      !
      CALL iotk_write_begin( ounit, "CELL" )
      !
      SELECT CASE ( ibravais_latt )
        CASE(  0 )
           bravais_lattice = "free"
        CASE(  1 )
           bravais_lattice = "cubic P (sc)"
        CASE(  2 )
           bravais_lattice = "cubic F (fcc)"
        CASE(  3 )
           bravais_lattice = "cubic I (bcc)"
        CASE(  4 )
           bravais_lattice = "Hexagonal and Trigonal P"
        CASE(  5 )
           bravais_lattice = "Trigonal R"
        CASE(  6 )
           bravais_lattice = "Tetragonal P (st)"
        CASE(  7 )
           bravais_lattice = "Tetragonal I (bct)"
        CASE(  8 )
           bravais_lattice = "Orthorhombic P"
        CASE(  9 )
           bravais_lattice = "Orthorhombic base-centered(bco)"
        CASE( 10 )
           bravais_lattice = "Orthorhombic face-centered"
        CASE( 11 )
           bravais_lattice = "Orthorhombic body-centered"
        CASE( 12 )
           bravais_lattice = "Monoclinic P"
        CASE( 13 )
           bravais_lattice = "Monoclinic base-centered"
        CASE( 14 )
           bravais_lattice = "Triclinic P"
      END SELECT
      !
      IF(do_mp)THEN
        es_corr = "Makov-Payne"
      ELSE IF(do_mt) THEN
        es_corr = "Martyna-Tuckerman"
      ELSE IF(do_esm) THEN
        es_corr = "ESM"
      ELSE IF(do_cutoff_2D) THEN
        es_corr = "2D"
      ELSE
        es_corr = "None"
      ENDIF
      !
      CALL iotk_write_dat( ounit, &
                           "NON-PERIODIC_CELL_CORRECTION", TRIM( es_corr ) )
      !
      CALL iotk_write_dat( ounit, &
                           "BRAVAIS_LATTICE", trim( bravais_lattice ) )
      !
      !
      CALL iotk_write_attr( attr, "UNITS", trim(alat_units), FIRST = .true. )
      CALL iotk_write_dat( ounit, "LATTICE_PARAMETER", alat, ATTR = attr )
      !
      CALL iotk_write_dat( ounit, "CELL_DIMENSIONS", celldm(1:6) )
      !
      CALL iotk_write_attr ( attr,   "UNITS", trim(a_units), FIRST = .true. )
      CALL iotk_write_begin( ounit, "DIRECT_LATTICE_VECTORS" )
      CALL iotk_write_empty( ounit, "UNITS_FOR_DIRECT_LATTICE_VECTORS", &
                                     ATTR=attr )
      CALL iotk_write_dat(   ounit, "a1", a1(:) * alat, COLUMNS=3 )
      CALL iotk_write_dat(   ounit, "a2", a2(:) * alat, COLUMNS=3 )
      CALL iotk_write_dat(   ounit, "a3", a3(:) * alat, COLUMNS=3 )
      CALL iotk_write_end(   ounit, "DIRECT_LATTICE_VECTORS" )
      !
      CALL iotk_write_attr ( attr,   "UNITS", trim(b_units), FIRST = .true. )
      CALL iotk_write_begin( ounit, "RECIPROCAL_LATTICE_VECTORS" )
      CALL iotk_write_empty( ounit, "UNITS_FOR_RECIPROCAL_LATTICE_VECTORS", &
                                     ATTR=attr )
      CALL iotk_write_dat(   ounit, "b1", b1(:), COLUMNS=3 )
      CALL iotk_write_dat(   ounit, "b2", b2(:), COLUMNS=3 )
      CALL iotk_write_dat(   ounit, "b3", b3(:), COLUMNS=3 )
      CALL iotk_write_end(   ounit, "RECIPROCAL_LATTICE_VECTORS" )
      !
      CALL iotk_write_end( ounit, "CELL" )
      !
    END SUBROUTINE qexml_write_cell
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_write_moving_cell(lmovecell, cell_factor)
      !------------------------------------------------------------------------
      !
      LOGICAL, INTENT(IN) :: lmovecell
      REAL(DP), INTENT(IN) :: cell_factor
      !
      CALL iotk_write_begin( ounit, "MOVING_CELL" )
      CALL iotk_write_dat( ounit, "CELL_FACTOR", cell_factor)
      CALL iotk_write_end( ounit, "MOVING_CELL"  )
      !
    END SUBROUTINE qexml_write_moving_cell
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_write_ions( nsp, nat, atm, ityp, psfile, pseudo_dir,  &
                                 amass, amass_units, tau, tau_units, &
                                 if_pos, dirname, pos_unit )
      !------------------------------------------------------------------------
      !
      USE wrappers, ONLY: f_copy
      !
      INTEGER,          INTENT(in) :: nsp, nat
      INTEGER,          INTENT(in) :: ityp(:)
      CHARACTER(len=*), INTENT(in) :: atm(:)
      CHARACTER(len=*), INTENT(in) :: psfile(:)
      CHARACTER(len=*), INTENT(in) :: pseudo_dir
      CHARACTER(len=*), INTENT(in) :: dirname
      REAL(DP),        INTENT(in) :: amass(:)
      CHARACTER(len=*), INTENT(in) :: amass_units
      REAL(DP),        INTENT(in) :: tau(:,:)
      CHARACTER(len=*), INTENT(in) :: tau_units
      INTEGER,          INTENT(in) :: if_pos(:,:)
      REAL(DP),         INTENT(in) :: pos_unit
      !
      INTEGER            :: i, flen, flen2, ierrl
      CHARACTER(len=256) :: file_pseudo_in, file_pseudo_out
      LOGICAL            :: pseudo_exists
      !
      !
      CALL iotk_write_begin( ounit, "IONS" )
      !
      CALL iotk_write_dat( ounit, "NUMBER_OF_ATOMS", nat )
      !
      CALL iotk_write_dat( ounit, "NUMBER_OF_SPECIES", nsp )
      !
      flen = len_trim( pseudo_dir )
      flen2 = len_trim( dirname )
      !
      CALL iotk_write_attr ( attr, "UNITS", trim(amass_units), FIRST = .true. )
      CALL iotk_write_empty( ounit, "UNITS_FOR_ATOMIC_MASSES", ATTR = attr )
      !
      DO i = 1, nsp
         !
         CALL iotk_write_begin( ounit, "SPECIE"//trim(iotk_index(i)) )
         !
         CALL iotk_write_dat( ounit, "ATOM_TYPE", atm(i) )
         !
         CALL iotk_write_dat( ounit, "MASS", amass(i) )
         !
         CALL iotk_write_dat( ounit, "PSEUDO", trim( psfile(i) ) )
         !
         CALL iotk_write_end( ounit, "SPECIE"//trim(iotk_index(i)) )
         !
         ! copy pseudopotential file into data directory
         !
         IF ( pseudo_dir(flen:flen) /= '/' ) THEN
            file_pseudo_in = pseudo_dir(1:flen) // '/' // TRIM(psfile(i))
         ELSE
            file_pseudo_in = pseudo_dir(1:flen) // TRIM(psfile(i))
         ENDIF
         !
         IF ( dirname(flen2:flen2) /= '/' ) THEN
            file_pseudo_out = dirname(1:flen2) // '/' // TRIM(psfile(i))
         ELSE
            file_pseudo_out = dirname(1:flen2) // TRIM(psfile(i))
         END IF
         !
         IF ( file_pseudo_in .ne. file_pseudo_out ) THEN
            !
            INQUIRE ( FILE=file_pseudo_in, EXIST = pseudo_exists )
            IF ( pseudo_exists ) THEN
               ierrl = f_copy( file_pseudo_in, file_pseudo_out )
            ELSE
               CALL infomsg( 'write_ions', &
                   'file ' // TRIM( file_pseudo_in) // ' not present' )
            END IF
            !
         END IF
         !
      ENDDO
      !
      !
      CALL iotk_write_dat( ounit, "PSEUDO_DIR", trim( pseudo_dir) )
      !
      CALL iotk_write_attr( attr, "UNITS", trim(tau_units), FIRST = .true. )
      CALL iotk_write_empty( ounit, "UNITS_FOR_ATOMIC_POSITIONS", ATTR = attr )
      !
      DO i = 1, nat
         !
         CALL iotk_write_attr( attr, "SPECIES", atm( ityp(i) ), FIRST = .true. )
         CALL iotk_write_attr( attr, "INDEX",  ityp(i) )
         CALL iotk_write_attr( attr, "tau",    tau(:,i)*pos_unit )
         CALL iotk_write_attr( attr, "if_pos", if_pos(:,i) )
         CALL iotk_write_empty( ounit, "ATOM" // trim( iotk_index( i ) ), attr )
         !
      ENDDO
      !
      CALL iotk_write_end( ounit, "IONS" )
      !
    END SUBROUTINE qexml_write_ions
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_write_symmetry( ibrav, nrot, nsym, invsym, noinv, &
                               time_reversal, no_t_rev, ft, &
                               s, sname, s_units, irt, nat, t_rev )
      !------------------------------------------------------------------------
      !
      INTEGER,          INTENT(in) :: ibrav, nrot, nsym
      LOGICAL,          INTENT(in) :: invsym, noinv, time_reversal, no_t_rev
      INTEGER,          INTENT(in) :: s(:,:,:), irt(:,:), nat, t_rev(:)
      REAL(DP),         INTENT(in) :: ft(:,:)
      CHARACTER(LEN=*), INTENT(in) :: sname(:),s_units
      !
      INTEGER  :: i
      !
      !
      CALL iotk_write_begin( ounit, "SYMMETRIES" )
      !
      CALL iotk_write_dat( ounit, "NUMBER_OF_SYMMETRIES", nsym )
      CALL iotk_write_dat( ounit, "NUMBER_OF_BRAVAIS_SYMMETRIES", nrot )
      !
      CALL iotk_write_dat( ounit, "INVERSION_SYMMETRY", invsym )
      !
      CALL iotk_write_dat( ounit, "DO_NOT_USE_TIME_REVERSAL", noinv )
      !
      CALL iotk_write_dat( ounit, "TIME_REVERSAL_FLAG", time_reversal )
      !
      CALL iotk_write_dat( ounit, "NO_TIME_REV_OPERATIONS", no_t_rev )
      !
      CALL iotk_write_dat( ounit, "NUMBER_OF_ATOMS", nat )
      !
      CALL iotk_write_attr( attr, "UNITS", TRIM(s_units), FIRST = .TRUE. )
      CALL iotk_write_empty( ounit, "UNITS_FOR_SYMMETRIES", ATTR = attr )
      !
      DO i = 1, nsym
         !
         CALL iotk_write_begin( ounit, "SYMM" // TRIM( iotk_index( i ) ) )
         !
         CALL iotk_write_attr ( attr, "NAME", TRIM( sname(i) ), FIRST=.TRUE. )
         CALL iotk_write_attr ( attr, "T_REV", t_rev(i) )
         CALL iotk_write_empty( ounit, "INFO", ATTR = attr )
         !
         CALL iotk_write_dat( ounit, "ROTATION", s(:,:,i), COLUMNS=3 )
         CALL iotk_write_dat( ounit, "FRACTIONAL_TRANSLATION", ft(:,i), COLUMNS=3 )
         !
         IF ( nat > 0 ) &
            CALL iotk_write_dat( ounit, "EQUIVALENT_IONS", irt(i,1:nat), COLUMNS=8 )
         !
         CALL iotk_write_end( ounit, "SYMM" // TRIM( iotk_index( i ) ) )
         !
      ENDDO
      !
      ! ... the following are the symmetries of the Bravais lattice alone
      ! ... (they may be more than crystal, i.e. basis+lattice, symmetries)
      !
      DO i = nsym+1, nrot
         !
         CALL iotk_write_begin( ounit, "SYMM" // TRIM( iotk_index( i ) ) )
         !
         CALL iotk_write_attr ( attr, "NAME", TRIM( sname(i) ), FIRST=.TRUE. )
         CALL iotk_write_empty( ounit, "INFO", ATTR = attr )
         CALL iotk_write_dat( ounit, "ROTATION", s(:,:,i), COLUMNS=3 )
         !
         CALL iotk_write_end( ounit, "SYMM" // TRIM( iotk_index( i ) ) )
         !
      ENDDO
      !
      CALL iotk_write_end( ounit, "SYMMETRIES" )
      !
    END SUBROUTINE qexml_write_symmetry
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_write_efield( tefield, dipfield, edir, emaxpos, eopreg, eamp, &
                                   gate, zgate, relaxz, block, block_1, block_2,&
                                   block_height)
     !------------------------------------------------------------------------
     !
      LOGICAL, INTENT(in)   :: tefield        ! if .TRUE. a finite electric field
                                              ! is added to the local potential
      LOGICAL, INTENT(in)   :: dipfield       ! if .TRUE. the dipole field is subtracted
      LOGICAL, INTENT(in)   :: gate           ! if .TRUE. counter charge is represented by charged plate
      LOGICAL, INTENT(in)   :: block          ! add potential barrier
      LOGICAL, INTENT(in)   :: relaxz         ! relax in z direction  
      INTEGER, INTENT(in)   :: edir           ! direction of the field
      REAL(DP), INTENT(in) :: emaxpos        ! position of the maximum of the field (0<emaxpos<1)
      REAL(DP), INTENT(in) :: eopreg         ! amplitude of the inverse region (0<eopreg<1)
      REAL(DP), INTENT(in) :: eamp           ! field amplitude (in a.u.) (1 a.u. = 51.44 10^11 V/m)
      REAL(DP), INTENT(in) :: zgate          ! position of charged plate in units of cell vector in z direction
      REAL(DP), INTENT(in) :: block_1        ! potential barrier
      REAL(DP), INTENT(in) :: block_2
      REAL(DP), INTENT(in) :: block_height
      !
      !
      CALL iotk_write_begin( ounit, "ELECTRIC_FIELD" )
      !
      CALL iotk_write_dat( ounit, "HAS_ELECTRIC_FIELD", tefield )
      !
      CALL iotk_write_dat( ounit, "HAS_DIPOLE_CORRECTION", dipfield )
      !
      CALL iotk_write_dat( ounit, "FIELD_DIRECTION", edir )
      !
      CALL iotk_write_dat( ounit, "MAXIMUM_POSITION", emaxpos )
      !
      CALL iotk_write_dat( ounit, "INVERSE_REGION", eopreg )
      !
      CALL iotk_write_dat( ounit, "FIELD_AMPLITUDE", eamp )
      !
      CALL iotk_write_dat( ounit, "CHARGED_PLATE", gate )
      !
      CALL iotk_write_dat( ounit, "GATE_POS", zgate )
      !
      CALL iotk_write_dat( ounit, "RELAX_Z", relaxz )
      !
      CALL iotk_write_dat( ounit, "BLOCK", block )
      !
      CALL iotk_write_dat( ounit, "BLOCK_1", block_1 )
      !
      CALL iotk_write_dat( ounit, "BLOCK_2", block_2 )
      !
      CALL iotk_write_dat( ounit, "BLOCK_HEIGHT", block_height )
      !
      CALL iotk_write_end( ounit, "ELECTRIC_FIELD" )
      !
    END SUBROUTINE qexml_write_efield
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_write_planewaves( ecutwfc, ecutrho, npwx, gamma_only, &
                                       nr1, nr2, nr3,  ngm,  nr1s, nr2s, nr3s, ngms, &
                                       nr1b, nr2b, nr3b, igv, lgvec, cutoff_units )
      !------------------------------------------------------------------------
#if defined __HDF5
      USE hdf5_qe
      USE mp_pools,  ONLY : inter_pool_comm
      USE io_files,  ONLY : tmp_dir
      USE mp_world,  ONLY : mpime
#endif

      !
      INTEGER,       INTENT(in) :: npwx, nr1, nr2, nr3, ngm, &
                                   nr1s, nr2s, nr3s, ngms, nr1b, nr2b, nr3b
      INTEGER,       INTENT(in) :: igv(:,:)
      REAL(DP),     INTENT(in) :: ecutwfc, ecutrho
      LOGICAL,       INTENT(in) :: gamma_only, lgvec
      CHARACTER(*),  INTENT(in) :: cutoff_units
#if defined __HDF5
      CHARACTER(LEN=256) :: filename_hdf5
      integer           :: ierr
#endif

      !
      !
#if defined __HDF5
      filename_hdf5=trim(tmp_dir) //"g.hdf5"
      CALL prepare_for_writing_final(g_hdf5_write,inter_pool_comm,filename_hdf5)
      CALL add_attributes_hdf5(g_hdf5_write,ecutwfc,"WFC_CUTOFF")
      CALL add_attributes_hdf5(g_hdf5_write,ecutrho,"RHO_CUTOFF")
      CALL add_attributes_hdf5(g_hdf5_write,npwx,"MAX_NUMBER_OF_GK-VECTORS")
      CALL add_attributes_hdf5(g_hdf5_write,gamma_only,"GAMMA_ONLY")
      CALL add_attributes_hdf5(g_hdf5_write,trim(cutoff_units),"UNITS_FOR_CUTOFF")
      CALL add_attributes_hdf5(g_hdf5_write,nr1,"nr1")
      CALL add_attributes_hdf5(g_hdf5_write,nr2,"nr2")
      CALL add_attributes_hdf5(g_hdf5_write,nr3,"nr3")
      CALL add_attributes_hdf5(g_hdf5_write,ngm,"GVECT_NUMBER")
      CALL add_attributes_hdf5(g_hdf5_write,nr1s,"nr1s")
      CALL add_attributes_hdf5(g_hdf5_write,nr2s,"nr2s")
      CALL add_attributes_hdf5(g_hdf5_write,nr3s,"nr3s")
      CALL add_attributes_hdf5(g_hdf5_write,ngms,"SMOOTH_GVECT_NUMBER")
      CALL add_attributes_hdf5(g_hdf5_write,nr1s,"nr1b")
      CALL add_attributes_hdf5(g_hdf5_write,nr2s,"nr2b")
      CALL add_attributes_hdf5(g_hdf5_write,nr3s,"nr3b")
#endif

      CALL iotk_write_begin( ounit, "PLANE_WAVES" )
      !
      CALL iotk_write_attr ( attr, "UNITS", trim(cutoff_units), FIRST = .true. )
      CALL iotk_write_empty( ounit, "UNITS_FOR_CUTOFF", ATTR = attr )
      !
      CALL iotk_write_dat( ounit, "WFC_CUTOFF", ecutwfc )
      !
      CALL iotk_write_dat( ounit, "RHO_CUTOFF", ecutrho )
      !
      CALL iotk_write_dat( ounit, "MAX_NUMBER_OF_GK-VECTORS", npwx )
      !
      CALL iotk_write_dat( ounit, "GAMMA_ONLY", gamma_only )
      !
      CALL iotk_write_attr( attr, "nr1", nr1, FIRST = .true. )
      CALL iotk_write_attr( attr, "nr2", nr2 )
      CALL iotk_write_attr( attr, "nr3", nr3 )
      CALL iotk_write_empty( ounit, "FFT_GRID", ATTR = attr )
      !
      CALL iotk_write_dat( ounit, "GVECT_NUMBER", ngm )
      !
      CALL iotk_write_attr( attr, "nr1s", nr1s, FIRST = .true. )
      CALL iotk_write_attr( attr, "nr2s", nr2s )
      CALL iotk_write_attr( attr, "nr3s", nr3s )
      CALL iotk_write_empty( ounit, "SMOOTH_FFT_GRID", ATTR = attr )
      !
      CALL iotk_write_dat( ounit, "SMOOTH_GVECT_NUMBER", ngms )
      !
      IF ( lgvec ) THEN
         !
         ! ... write the G-vectors
         !
#if defined __HDF5
         CALL write_g(g_hdf5_write,igv(1:3,1:ngm))
#else
         CALL iotk_link( ounit, "G-VECTORS", "./gvectors.dat", &
                         CREATE = .true., BINARY = .true. )
         !
         CALL iotk_write_begin( ounit, "G-VECTORS" )
         !
         CALL iotk_write_attr( attr, "nr1s", nr1s, FIRST = .true. )
         CALL iotk_write_attr( attr, "nr2s", nr2s )
         CALL iotk_write_attr( attr, "nr3s", nr3s )
         CALL iotk_write_attr( attr, "gvect_number", ngm )
         CALL iotk_write_attr( attr, "gamma_only", gamma_only )
         CALL iotk_write_attr( attr, "units", "crystal" )
         CALL iotk_write_empty( ounit, "INFO", ATTR = attr )
         !

         CALL iotk_write_dat  ( ounit, "g", igv(1:3,1:ngm), COLUMNS = 3 )
         CALL iotk_write_end  ( ounit, "G-VECTORS" )
#endif
      ENDIF
      !
      CALL iotk_write_attr( attr, "nr1b", nr1b , FIRST = .true. )
      CALL iotk_write_attr( attr, "nr2b", nr2b )
      CALL iotk_write_attr( attr, "nr3b", nr3b )
      CALL iotk_write_empty( ounit, "SMALLBOX_FFT_GRID", ATTR = attr )
      !
      CALL iotk_write_end( ounit, "PLANE_WAVES" )
#if defined __HDF5
      CALL h5fclose_f(g_hdf5_write%file_id,ierr)
#endif
      !
    END SUBROUTINE qexml_write_planewaves
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_write_gk( ik, npwk, npwkx, gamma_only, xk, k_units, index, igk )
      !------------------------------------------------------------------------
      !
      INTEGER,      INTENT(in) :: ik
      INTEGER,      INTENT(in) :: npwk, npwkx
      LOGICAL,      INTENT(in) :: gamma_only
      REAL(DP),    INTENT(in) :: xk(3)
      CHARACTER(*), INTENT(in) :: k_units
      LOGICAL,      INTENT(in) :: index(:), igk(:,:)
      !
      INTEGER        :: iunaux
      CHARACTER(256) :: filename

      CALL iotk_free_unit( iunaux )
      filename = qexml_wfc_filename( datadir_out, 'gkvectors', ik )
      !
      CALL iotk_open_write( iunaux, FILE = trim( filename ), &
                            ROOT="GK-VECTORS", BINARY = .true. )
      !
      CALL iotk_write_dat( iunaux, "NUMBER_OF_GK-VECTORS", npwk )
      CALL iotk_write_dat( iunaux, "MAX_NUMBER_OF_GK-VECTORS", npwkx )
      CALL iotk_write_dat( iunaux, "GAMMA_ONLY", gamma_only )
      !
      CALL iotk_write_attr ( attr, "UNITS", trim(k_units), FIRST = .true. )
      CALL iotk_write_dat( iunaux, "K-POINT_COORDS", xk, ATTR = attr )
      !
      CALL iotk_write_dat( iunaux, "INDEX", index(1:npwk) )
      CALL iotk_write_dat( iunaux, "GRID", igk(1:npwk,ik), COLUMNS = 3 )
      !
      CALL iotk_close_write( iunaux )
      !
    END SUBROUTINE qexml_write_gk
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_write_spin( lsda, noncolin, npol, lspinorb, domag )
      !------------------------------------------------------------------------
      !
      LOGICAL, INTENT(in) :: lsda, noncolin, lspinorb, domag
      INTEGER, INTENT(in) :: npol
      !
      !
      CALL iotk_write_begin( ounit, "SPIN" )
      !
      CALL iotk_write_dat( ounit, "LSDA", lsda )
      !
      CALL iotk_write_dat( ounit, "NON-COLINEAR_CALCULATION", noncolin )
      !
      IF ( noncolin ) &
         CALL iotk_write_dat( ounit, "SPINOR_DIM", npol )
      !
      CALL iotk_write_dat( ounit, "SPIN-ORBIT_CALCULATION", lspinorb )
      CALL iotk_write_dat( ounit, "SPIN-ORBIT_DOMAG", domag )
      !
      CALL iotk_write_end( ounit, "SPIN" )
      !
    END SUBROUTINE qexml_write_spin
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_write_magnetization(starting_magnetization, angle1, angle2, &
                                   nsp, two_fermi_energies, i_cons, mcons, bfield, &
                                   ef_up, ef_dw, nelup, neldw, lambda, energy_units)
      !------------------------------------------------------------------------
      !
      !
      IMPLICIT NONE
      INTEGER,  INTENT(IN) :: nsp, i_cons
      REAL(DP), INTENT(IN) :: starting_magnetization(nsp), &
                              angle1(nsp), angle2(nsp), mcons(3,nsp), &
                              bfield(3), ef_up, ef_dw, nelup, neldw, lambda
      LOGICAL,  INTENT(IN) :: two_fermi_energies
      CHARACTER(*),       INTENT(IN) :: energy_units
      !
      INTEGER :: i
      !
      CALL iotk_write_begin( ounit, "MAGNETIZATION_INIT" )

      CALL iotk_write_dat( ounit,"CONSTRAINT_MAG", i_cons)

      CALL iotk_write_dat( ounit, "NUMBER_OF_SPECIES", nsp ) 

      DO i = 1, nsp
         !
         CALL iotk_write_begin( ounit, "SPECIE"//TRIM(iotk_index(i)) )
         !
         CALL iotk_write_dat( ounit, "STARTING_MAGNETIZATION",  &
                                       starting_magnetization(i) )
         CALL iotk_write_dat( ounit, "ANGLE1", &
                                       angle1(i) )
         CALL iotk_write_dat( ounit, "ANGLE2", &
                                       angle2(i) )
         IF (i_cons==1.OR.i_cons==2) THEN
            CALL iotk_write_dat( ounit, "CONSTRANT_1", mcons(1,i) )
            CALL iotk_write_dat( ounit, "CONSTRANT_2", mcons(2,i) )
            CALL iotk_write_dat( ounit, "CONSTRANT_3", mcons(3,i) )
         ENDIF
         !
         CALL iotk_write_end( ounit, "SPECIE"//TRIM(iotk_index(i)) )
         !
      ENDDO
      !
      IF (i_cons==3) THEN
         !
         CALL iotk_write_dat( ounit, "FIXED_MAGNETIZATION_1", mcons(1,1) )
         CALL iotk_write_dat( ounit, "FIXED_MAGNETIZATION_2", mcons(2,1) )
         CALL iotk_write_dat( ounit, "FIXED_MAGNETIZATION_3", mcons(3,1) )
         !
      ELSE IF (i_cons==4) THEN
         !
         CALL iotk_write_dat( ounit, "MAGNETIC_FIELD_1", bfield(1) )
         CALL iotk_write_dat( ounit, "MAGNETIC_FIELD_2", bfield(2) )
         CALL iotk_write_dat( ounit, "MAGNETIC_FIELD_3", bfield(3) )
         !
      ENDIF
      !
      CALL iotk_write_dat(ounit,"TWO_FERMI_ENERGIES",two_fermi_energies)
      !
      IF (two_fermi_energies) THEN
         !
         CALL iotk_write_attr ( attr, "UNITS", trim(energy_units), FIRST = .TRUE. )
         CALL iotk_write_empty( ounit, "UNITS_FOR_ENERGIES", ATTR = attr )
         !
         CALL iotk_write_dat( ounit, "FIXED_MAGNETIZATION", mcons(3,1) )
         CALL iotk_write_dat( ounit, "ELECTRONS_UP", nelup )
         CALL iotk_write_dat( ounit, "ELECTRONS_DOWN", neldw )
         CALL iotk_write_dat( ounit, "FERMI_ENERGY_UP", ef_up )
         CALL iotk_write_dat( ounit, "FERMI_ENERGY_DOWN", ef_dw )
         !
      ENDIF
      !
      IF (i_cons>0) CALL iotk_write_dat(ounit,"LAMBDA",lambda)
      !
      CALL iotk_write_end( ounit, "MAGNETIZATION_INIT" )
      !
    RETURN
    !
    END SUBROUTINE qexml_write_magnetization
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_write_xc( dft, nsp, lda_plus_u, lda_plus_u_kind, U_projection, &
                         Hubbard_lmax, Hubbard_l, Hubbard_U, Hubbard_J, Hubbard_J0, &
                         Hubbard_beta, Hubbard_alpha,                               &
                         inlc, vdw_table_name, pseudo_dir, acfdt_in_pw, dirname, & 
                         llondon, london_s6, london_rcut, london_c6, london_rvdw, &
                         lxdm, ts_vdw, vdw_isolated )
      !------------------------------------------------------------------------
      !
      CHARACTER(LEN=*),   INTENT(IN) :: dft
      LOGICAL,            INTENT(IN) :: lda_plus_u
      INTEGER,  OPTIONAL, INTENT(IN) :: lda_plus_u_kind
      INTEGER,  OPTIONAL, INTENT(IN) :: nsp
      CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: U_projection
      INTEGER,  OPTIONAL, INTENT(IN) :: Hubbard_lmax
      INTEGER,  OPTIONAL, INTENT(IN) :: Hubbard_l(:)
      REAL(DP), OPTIONAL, INTENT(IN) :: Hubbard_U(:), Hubbard_J(:,:), Hubbard_alpha(:), &
                                        Hubbard_J0(:), Hubbard_beta(:)
      INTEGER,  OPTIONAL, INTENT(IN) :: inlc
      CHARACTER(LEN=*), OPTIONAL,   INTENT(IN) :: vdw_table_name, pseudo_dir, dirname
      LOGICAL, OPTIONAL,  INTENT(IN) :: acfdt_in_pw
      !
      LOGICAL,  OPTIONAL, INTENT(IN) :: llondon, lxdm, ts_vdw, vdw_isolated
      REAL(DP), OPTIONAL, INTENT(IN) :: london_s6, london_rcut, london_c6(:), london_rvdw(:)

      INTEGER            :: i, flen, ierrl
      CHARACTER(LEN=256) :: file_table
      !
      CALL iotk_write_begin( ounit, "EXCHANGE_CORRELATION" )
      !
      CALL iotk_write_dat( ounit, "DFT", dft )
      !
      IF ( lda_plus_u .OR. (PRESENT(llondon) .AND. llondon) ) THEN         
         ! N.B.: nsp is needed for LDA+U and DFT-D2
         IF ( .NOT. PRESENT( nsp ) ) &
              CALL errore( 'write_xc', ' variable nsp not present', 1 )
         CALL iotk_write_dat( ounit, "NUMBER_OF_SPECIES", nsp )
      ENDIF
      !
      IF ( lda_plus_u ) THEN
         !
         IF ( .NOT. PRESENT( Hubbard_lmax ) .OR. &
              .NOT. PRESENT( Hubbard_l )    .OR. & 
              .NOT. PRESENT( Hubbard_U )    ) &
            CALL errore( 'write_xc', &
                         ' variables for LDA+U not present', 1 )
         !
         CALL iotk_write_dat( ounit, "LDA_PLUS_U_CALCULATION", lda_plus_u )
         CALL iotk_write_dat( ounit, "HUBBARD_LMAX", Hubbard_lmax )
         CALL iotk_write_dat( ounit, "HUBBARD_L", Hubbard_l(1:nsp) )
         CALL iotk_write_dat( ounit, "HUBBARD_U", Hubbard_U(1:nsp) )
         !
         IF ( PRESENT( lda_plus_u_kind ) ) THEN
            CALL iotk_write_dat( ounit, "LDA_PLUS_U_KIND", lda_plus_u_kind )
            CALL iotk_write_dat( ounit, "U_PROJECTION_TYPE", trim(U_projection) )
         END IF
         !
         IF ( PRESENT( Hubbard_J ) ) &
              CALL iotk_write_dat( ounit, "HUBBARD_J", Hubbard_J(1:3,1:nsp), COLUMNS = 3)
         !
         IF ( PRESENT( Hubbard_J0 ) ) &
         CALL iotk_write_dat( ounit, "HUBBARD_J0", Hubbard_J0(1:nsp) )
         !
         IF ( PRESENT( Hubbard_alpha ) ) &
         CALL iotk_write_dat( ounit, "HUBBARD_ALPHA", Hubbard_alpha(1:nsp) )
         !
         IF ( PRESENT( Hubbard_beta ) ) &
         CALL iotk_write_dat( ounit, "HUBBARD_BETA", Hubbard_beta(1:nsp) )
         !
      END IF
      !
      ! Vdw kernel table
      !
      IF ( present(inlc) ) THEN
         IF ( inlc > 0 ) THEN
            IF ( .NOT. PRESENT( vdw_table_name ) .OR. &
                 .NOT. PRESENT( pseudo_dir )     .OR. &
                 .NOT. PRESENT( dirname ))            &
                 CALL errore( 'write_xc', ' variable vdw_table_name not present', 1 )
        
            CALL iotk_write_dat( ounit, "NON_LOCAL_DF", inlc )
            CALL iotk_write_dat( ounit, "VDW_KERNEL_NAME", TRIM(vdw_table_name))
            !
            ! Copy the file in .save directory
            !
            flen = LEN_TRIM( pseudo_dir )
            IF ( pseudo_dir(flen:flen) /= '/' ) THEN
               file_table = pseudo_dir(1:flen) // '/' // vdw_table_name
            ELSE
               file_table = pseudo_dir(1:flen) // vdw_table_name
            END IF
            !
            CALL qexml_copy_file( TRIM( file_table ), TRIM( dirname ) // "/" // TRIM( vdw_table_name ),ierrl )
            !
         ENDIF
      ENDIF
      !
      IF ( PRESENT (llondon) ) THEN
         IF ( llondon ) THEN
            IF ( .NOT. PRESENT( london_s6 )  .OR. &
                 .NOT. PRESENT( london_rcut ).OR. &
                 .NOT. PRESENT( london_c6 )  .OR. &
                 .NOT. PRESENT( london_rvdw ) ) & 
                 CALL errore( 'write_xc', &
                              ' variables for DFT+D not present', 1 )
            CALL iotk_write_begin( ounit, "DFT_D2" )
            !
            CALL iotk_write_dat( ounit, "SCALING_FACTOR", london_s6 )
            CALL iotk_write_dat( ounit, "CUTOFF_RADIUS",  london_rcut )
            CALL iotk_write_dat( ounit, "C6",             london_c6(1:nsp) )
            CALL iotk_write_dat( ounit, "RADIUS_VDW",     london_rvdw(1:nsp) )
            !
            CALL iotk_write_end  ( ounit, "DFT_D2" )
         ENDIF
      ENDIF
      !
      IF ( PRESENT (lxdm) ) THEN
         IF ( lxdm) CALL iotk_write_dat( ounit, "XDM", lxdm )
      ENDIF
      !
      IF ( PRESENT (ts_vdw) ) THEN
         IF ( ts_vdw) THEN
            IF ( .NOT. PRESENT (vdw_isolated) ) &
               CALL errore( 'write_xc', &
                            ' variables for TS not present', 1 )
            CALL iotk_write_begin( ounit, "TKATCHENKO-SCHEFFLER" )
            CALL iotk_write_dat( ounit, "ISOLATED_SYSTEM", vdw_isolated )
            CALL iotk_write_end( ounit, "TKATCHENKO-SCHEFFLER" )
         END IF
      END IF
      !
      IF ( PRESENT (acfdt_in_pw) ) THEN
         CALL iotk_write_dat( ounit, "ACFDT_IN_PW", acfdt_in_pw )
      ENDIF
      !
      IF ( PRESENT (acfdt_in_pw) ) THEN
         CALL iotk_write_dat( ounit, "ACFDT_IN_PW", acfdt_in_pw )
      ENDIF
      !
      CALL iotk_write_end( ounit, "EXCHANGE_CORRELATION" )
      !
 END SUBROUTINE qexml_write_xc
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_write_exx( x_gamma_extrapolation, nqx1, nqx2, nqx3, &
                          exxdiv_treatment, yukawa, ecutvcut, exx_fraction, &
                          gau_parameter, screening_parameter, exx_is_active, ecutfock )
      !------------------------------------------------------------------------
      !
      LOGICAL,            INTENT(IN) :: x_gamma_extrapolation, exx_is_active
      INTEGER,            INTENT(IN) :: nqx1, nqx2, nqx3
      CHARACTER(LEN=*),   INTENT(IN) :: exxdiv_treatment
      REAL(DP),           INTENT(IN) :: yukawa, ecutvcut, exx_fraction, ecutfock
      REAL(DP),           INTENT(IN) :: screening_parameter
      REAL(DP),           INTENT(IN) :: gau_parameter
      !
      CALL iotk_write_begin(ounit, "EXACT_EXCHANGE" )
      call iotk_write_dat(ounit, "x_gamma_extrapolation", x_gamma_extrapolation)
      call iotk_write_dat(ounit, "nqx1", nqx1)
      call iotk_write_dat(ounit, "nqx2", nqx2)
      call iotk_write_dat(ounit, "nqx3", nqx3)
      call iotk_write_dat(ounit, "exxdiv_treatment", exxdiv_treatment)
      call iotk_write_dat(ounit, "yukawa", yukawa)
      call iotk_write_dat(ounit, "ecutvcut", ecutvcut)
      call iotk_write_dat(ounit, "exx_fraction", exx_fraction)
      call iotk_write_dat(ounit, "screening_parameter", screening_parameter)
      call iotk_write_dat(ounit, "gau_parameter", gau_parameter)
      call iotk_write_dat(ounit, "exx_is_active", exx_is_active)
      call iotk_write_dat(ounit, "ecutfock", ecutfock)
      CALL iotk_write_end(ounit, "EXACT_EXCHANGE" )
      !
    END SUBROUTINE qexml_write_exx
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_write_esm( esm_nfit, esm_efield, esm_w, esm_a, esm_bc )
      !------------------------------------------------------------------------
      !
      INTEGER,            INTENT(IN) :: esm_nfit
      REAL(DP),           INTENT(IN) :: esm_efield, esm_w, esm_a
      CHARACTER(LEN=*),   INTENT(IN) :: esm_bc
      !
      CALL iotk_write_begin(ounit, "ESM" )
      call iotk_write_dat(ounit, "esm_nfit", esm_nfit)
      call iotk_write_dat(ounit, "esm_efield", esm_efield)
      call iotk_write_dat(ounit, "esm_w", esm_w)
      call iotk_write_dat(ounit, "esm_a", esm_a)
      call iotk_write_dat(ounit, "esm_bc", esm_bc)
      CALL iotk_write_end(ounit, "ESM" )
      !
    END SUBROUTINE qexml_write_esm
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_write_occ( lgauss, ngauss, degauss, degauss_units, &
         ltetra, tetra_type, ntetra, tetra, tfixed_occ, &
         lsda, nstates_up, nstates_dw, input_occ )
      !------------------------------------------------------------------------
      !
      LOGICAL,                INTENT(in) :: lgauss, ltetra, tfixed_occ, lsda
      INTEGER,      OPTIONAL, INTENT(in) :: ngauss, ntetra, tetra_type, &
           nstates_up, nstates_dw
      INTEGER,      OPTIONAL, INTENT(in) :: tetra(:,:)
      REAL(DP),    OPTIONAL, INTENT(in) :: degauss, input_occ(:,:)
      CHARACTER(*), OPTIONAL, INTENT(in) :: degauss_units
      !
      INTEGER :: i
      !
      !
      CALL iotk_write_begin( ounit, "OCCUPATIONS" )
      !
      CALL iotk_write_dat( ounit, "SMEARING_METHOD", lgauss )
      !
      IF ( lgauss ) THEN
         !
         CALL iotk_write_dat( ounit, "SMEARING_TYPE", ngauss )
         !
         CALL iotk_write_attr( attr, "UNITS", trim(degauss_units), FIRST = .true. )
         !
         CALL iotk_write_dat( ounit, "SMEARING_PARAMETER", degauss , ATTR = attr )
         !
      ENDIF
      !
      CALL iotk_write_dat( ounit, "TETRAHEDRON_METHOD", ltetra )
      !
      IF ( ltetra ) THEN
         !
         CALL iotk_write_dat( ounit, "NUMBER_OF_TETRAHEDRA", ntetra )
         !
         CALL iotk_write_dat( ounit, "TETRAHEDRON_TYPE", tetra_type)
         !
         IF(tetra_type == 0) then
            !
            DO i = 1, ntetra
               !
               CALL iotk_write_dat( ounit, "TETRAHEDRON" // &
                                  & iotk_index( i ), tetra(1:4,i) )
               !
            ENDDO
            !
         END IF
         !
      ENDIF
      !
      CALL iotk_write_dat( ounit, "FIXED_OCCUPATIONS", tfixed_occ )
      !
      IF ( tfixed_occ ) THEN
         !
         CALL iotk_write_attr( attr, "lsda" , lsda, FIRST = .true. )
         CALL iotk_write_attr( attr, "nstates_up", nstates_up )
         CALL iotk_write_attr( attr, "nstates_down", nstates_dw )
         !
         CALL iotk_write_empty( ounit, 'INFO', ATTR = attr )
         !
         CALL iotk_write_dat( ounit, "INPUT_OCC_UP", input_occ(1:nstates_up,1) )
         !
         IF ( lsda ) &
            CALL iotk_write_dat( ounit, "INPUT_OCC_DOWN", input_occ(1:nstates_dw,2) )
         !
      ENDIF
      !
      CALL iotk_write_end( ounit, "OCCUPATIONS" )
      !
    END SUBROUTINE qexml_write_occ
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_write_bz( num_k_points, xk, wk, k1, k2, k3, &
                               nk1, nk2, nk3, k_units, qnorm, &
                               nks_start, xk_start, wk_start )
      !------------------------------------------------------------------------
      !
      INTEGER,      INTENT(in) :: num_k_points, k1, k2, k3, nk1, nk2, nk3
      REAL(DP),    INTENT(in) :: xk(:,:), wk(:)
      CHARACTER(*), INTENT(in) :: k_units
      REAL(DP), INTENT(IN) :: qnorm
      INTEGER,  INTENT(IN), OPTIONAL ::  nks_start
      REAL(DP), INTENT(IN), OPTIONAL :: xk_start(:,:), wk_start(:)
      !
      INTEGER :: ik
      !
      !
      CALL iotk_write_begin( ounit, "BRILLOUIN_ZONE" )
      !
      CALL iotk_write_dat( ounit, "NUMBER_OF_K-POINTS", num_k_points )
      !
      CALL iotk_write_attr( attr, "UNITS", trim(k_units), FIRST = .true. )
      CALL iotk_write_empty( ounit, "UNITS_FOR_K-POINTS", attr )
      !
      CALL iotk_write_attr( attr, "nk1", nk1, FIRST = .true. )
      CALL iotk_write_attr( attr, "nk2", nk2 )
      CALL iotk_write_attr( attr, "nk3", nk3 )
      CALL iotk_write_empty( ounit, "MONKHORST_PACK_GRID", attr )
      CALL iotk_write_attr( attr, "k1", k1, FIRST = .true. )
      CALL iotk_write_attr( attr, "k2", k2 )
      CALL iotk_write_attr( attr, "k3", k3 )
      CALL iotk_write_empty( ounit, "MONKHORST_PACK_OFFSET", attr )
      !
      DO ik = 1, num_k_points
         !
         CALL iotk_write_attr( attr, "XYZ", xk(:,ik), FIRST = .true. )
         !
         CALL iotk_write_attr( attr, "WEIGHT", wk(ik) )
         !
         CALL iotk_write_empty( ounit, "K-POINT" // &
                              & trim( iotk_index(ik) ), attr )
         !
      ENDDO
      !
      ! ... these are k-points and weights in the Irreducible BZ
      !
      IF (present(nks_start).and.present(xk_start).and.present(wk_start)) THEN
         !
         CALL iotk_write_dat( ounit, "STARTING_K-POINTS", nks_start )
         !
         DO ik = 1, nks_start
            !
            CALL iotk_write_attr( attr, "XYZ", xk_start(:,ik), FIRST = .TRUE. )
            !
            CALL iotk_write_attr( attr, "WEIGHT", wk_start(ik) )
            !
            CALL iotk_write_empty( ounit, "K-POINT_START" // &
                              & TRIM( iotk_index(ik) ), attr )
            !
         END DO
      ENDIF
      !
      CALL iotk_write_dat( ounit, "NORM-OF-Q", qnorm )
      !
      CALL iotk_write_end( ounit, "BRILLOUIN_ZONE" )
      !
    END SUBROUTINE qexml_write_bz
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_write_para( kunit, nproc, nproc_pool, nproc_image, &
                                 ntask_groups, nproc_bgrp, nproc_ortho ) 
      !------------------------------------------------------------------------
      !
      INTEGER,  INTENT(IN) :: kunit, nproc, nproc_pool, nproc_image, &
                              ntask_groups, nproc_bgrp, nproc_ortho 
      !
      !
      CALL iotk_write_begin( ounit, "PARALLELISM" )
      CALL iotk_write_dat( ounit, &
                              "GRANULARITY_OF_K-POINTS_DISTRIBUTION", kunit )
      CALL iotk_write_dat( ounit, "NUMBER_OF_PROCESSORS", nproc )
      CALL iotk_write_dat( ounit, &
                              "NUMBER_OF_PROCESSORS_PER_POOL", nproc_pool )
      CALL iotk_write_dat( ounit, &
                              "NUMBER_OF_PROCESSORS_PER_IMAGE", nproc_image )
      CALL iotk_write_dat( ounit, "NUMBER_OF_PROCESSORS_PER_TASKGROUP", &
                                              ntask_groups )
      CALL iotk_write_dat( ounit, "NUMBER_OF_PROCESSORS_PER_BAND_GROUP", &
                                              nproc_bgrp )
      CALL iotk_write_dat( ounit, "NUMBER_OF_PROCESSORS_PER_DIAGONALIZATION", &
                                              nproc_ortho )
      CALL iotk_write_end( ounit, "PARALLELISM" )
      !
      !
    END SUBROUTINE qexml_write_para
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_write_bands_info( num_k_points, natomwfc, &
                                       nbnd, nbnd_up, nbnd_down, &
                                       nspin, nelec, nel_up, nel_down, &
                                       energy_units, k_units, &
                                       ef, two_fermi_energies ,&
                                       ef_up, ef_down, noncolin )
      !------------------------------------------------------------------------
      !
      INTEGER,       INTENT(in) ::  num_k_points, natomwfc, nbnd, nbnd_up, nbnd_down, &
                                    nspin, nel_up, nel_down
      REAL(DP),     INTENT(in) ::   nelec
      CHARACTER(*),  INTENT(in) :: energy_units, k_units
      LOGICAL,       INTENT(in), OPTIONAL :: noncolin,two_fermi_energies
      REAL(DP),     INTENT(in), OPTIONAL :: ef,ef_up,ef_down
      !
      !
      CALL iotk_write_begin( ounit, "BAND_STRUCTURE_INFO" )
      !
      CALL iotk_write_dat  ( ounit, "NUMBER_OF_K-POINTS", num_k_points )
      !
      CALL iotk_write_dat  ( ounit, "NUMBER_OF_SPIN_COMPONENTS", nspin )
      !
      IF (present(noncolin)) CALL iotk_write_dat  ( ounit, "NON-COLINEAR_CALCULATION", noncolin )
      !
      CALL iotk_write_dat  ( ounit, "NUMBER_OF_ATOMIC_WFC", natomwfc )
      !
      IF ( nspin == 2 ) THEN
         !
         CALL iotk_write_attr( attr, "UP", nbnd_up, FIRST = .TRUE. )
         CALL iotk_write_attr( attr, "DW", nbnd_down )
         CALL iotk_write_dat( ounit, &
                              "NUMBER_OF_BANDS", nbnd, ATTR = attr )
         CALL iotk_write_attr( attr, "UP", nel_up, FIRST = .TRUE. )
         CALL iotk_write_attr( attr, "DW", nel_down )
         CALL iotk_write_dat( ounit, &
                              "NUMBER_OF_ELECTRONS", nelec, ATTR = attr )
      ELSE
         !
         CALL iotk_write_dat  ( ounit, "NUMBER_OF_BANDS", nbnd )
         CALL iotk_write_dat  ( ounit, "NUMBER_OF_ELECTRONS", nelec )
         !
      END IF
      !
      CALL iotk_write_attr ( attr, "UNITS", trim(k_units), FIRST = .TRUE. )
      CALL iotk_write_empty( ounit, "UNITS_FOR_K-POINTS", ATTR = attr )
      !
      CALL iotk_write_attr ( attr, "UNITS", trim(energy_units), FIRST = .TRUE. )
      CALL iotk_write_empty( ounit, "UNITS_FOR_ENERGIES", ATTR = attr )
      !
      !
      !
      IF (present(two_fermi_energies) ) THEN
         IF (two_fermi_energies) THEN
            !
            CALL iotk_write_dat( ounit,"TWO_FERMI_ENERGIES",two_fermi_energies)
            CALL iotk_write_dat( ounit, "ELECTRONS_UP", nel_up )
            CALL iotk_write_dat( ounit, "ELECTRONS_DOWN", nel_down )
            CALL iotk_write_dat( ounit, "FERMI_ENERGY_UP", ef_up )
            CALL iotk_write_dat( ounit, "FERMI_ENERGY_DOWN", ef_down )
            !
         ELSE
            !
            IF (present(ef)) CALL iotk_write_dat( ounit, "FERMI_ENERGY", ef )
            !
         ENDIF
      ELSE
         !
         IF (present(ef)) CALL iotk_write_dat( ounit, "FERMI_ENERGY", ef )
         !
      ENDIF
      !
      CALL iotk_write_end  ( ounit, "BAND_STRUCTURE_INFO" )
      !
      !
    END SUBROUTINE qexml_write_bands_info
    !
    !
    !------------------------------------------------------------------------  
    SUBROUTINE qexml_write_bands_pw( nbnd, num_k_points, nspin, xk, wk, wg , et, energy_units,  lkpoint_dir ,auxunit, dirname )
      !------------------------------------------------------------------------
      !
      INTEGER, INTENT(in) :: nbnd,num_k_points,nspin,auxunit
      REAL(DP), INTENT(in) :: xk(:,:),wk(:),wg(:,:),et(:,:)
      CHARACTER(len=*), INTENT(IN) :: energy_units
      LOGICAL, INTENT(in) :: lkpoint_dir
      CHARACTER(len=*), INTENT(in) :: dirname
      
      !
      REAL(DP), ALLOCATABLE :: raux(:)
      INTEGER :: ik,ispin,ik_eff
      CHARACTER(LEN=256)    :: filename
      !
      !
      CALL iotk_write_begin( ounit, "EIGENVALUES" )
      !
      ALLOCATE( raux( nbnd) )
      !
      DO ik = 1, num_k_points
         !
         !
         CALL iotk_write_begin( ounit, "K-POINT" // TRIM( iotk_index( ik ) ) )
         !
         CALL iotk_write_dat( ounit, "K-POINT_COORDS", xk(:,ik), COLUMNS=3 )
         !
         CALL iotk_write_dat( ounit, "WEIGHT", wk(ik) )
         !
         !
         IF ( nspin == 2 ) THEN
            !
            ispin = 1
            !
            IF (lkpoint_dir) THEN
               !
               filename = qexml_wfc_filename(".",'eigenval1', ik, EXTENSION='xml',&
                                     DIR=lkpoint_dir )
               !
               CALL iotk_link( ounit, "DATAFILE.1", &
                               filename, CREATE = .FALSE., BINARY = .FALSE. )
            ELSE
               CALL iotk_write_begin( auxunit, &
                             "DATA_EIG"//TRIM( iotk_index( ik ) )//"_SPIN_UP" )
            ENDIF
            !
            IF ( wk(ik) == 0.D0 ) THEN
               !
               raux = wg(:,ik)
               !
            ELSE
               !
               raux = wg(:,ik) / wk(ik)
               !
            END IF
            !
            !
            IF (lkpoint_dir) THEN
               filename = qexml_wfc_filename( dirname, 'eigenval1', ik, &
                    EXTENSION='xml',  DIR=lkpoint_dir )
               !
               CALL qexml_write_eig( auxunit, filename, nbnd, et(:, ik), &
                     trim(energy_units), OCC = raux(:), IK=ik, ISPIN=ispin )
            ELSE
               filename=' '
               CALL qexml_write_eig( auxunit, filename, nbnd, et(:, ik), &
                     trim(energy_units), OCC = raux(:), IK=ik, ISPIN=ispin,  &
                                LKPOINT_DIR=.FALSE. )
            ENDIF
            !
            ispin = 2
            !
            ik_eff = ik + num_k_points
            !
            IF (lkpoint_dir) THEN
               filename = qexml_wfc_filename( ".", 'eigenval2', ik, &
                          EXTENSION='xml',  DIR=lkpoint_dir )
               !
               CALL iotk_link( ounit, "DATAFILE.2", &
                    filename, CREATE = .FALSE., BINARY = .FALSE. )
            ELSE
               CALL iotk_write_end( auxunit, &
                    "DATA_EIG"//TRIM( iotk_index( ik ) )//"_SPIN_UP" )
               CALL iotk_write_begin( auxunit, &
                    "DATA_EIG"//TRIM( iotk_index( ik ) )//"_SPIN_DW" )
            ENDIF
            !
            IF ( wk(ik_eff) == 0.D0 ) THEN
               !
               raux = wg(:,ik_eff)
               !
            ELSE
               !
               raux = wg(:,ik_eff) / wk(ik_eff)
               !
            END IF
            !
            IF (lkpoint_dir) THEN
               filename = qexml_wfc_filename( dirname, 'eigenval2', ik, &
                    EXTENSION = 'xml',  DIR=lkpoint_dir )
               !
               CALL qexml_write_eig( auxunit, filename, nbnd, et(:, ik_eff) , &
                    trim(energy_units), OCC = raux(:), IK = ik, ISPIN = ispin)
            ELSE
               filename=' '
               CALL qexml_write_eig( auxunit, filename, nbnd, et(:, ik_eff) , &
                    trim(energy_units), OCC = raux(:), IK = ik, &
                    ISPIN = ispin, LKPOINT_DIR=.false.)
               CALL iotk_write_end( auxunit, &
                    "DATA_EIG"//TRIM( iotk_index( ik ) )//"_SPIN_DW" )
            ENDIF
               !
         ELSE
            !
            IF (lkpoint_dir) THEN
               filename = qexml_wfc_filename( ".", 'eigenval', ik, &
                    EXTENSION='xml',  DIR=lkpoint_dir )
               !
               CALL iotk_link( ounit, "DATAFILE", &
                    filename, CREATE = .FALSE., BINARY = .FALSE. )
            ELSE
               CALL iotk_write_begin( auxunit, &
                    "DATA_EIG"//TRIM( iotk_index( ik ) ) )
            ENDIF
            !
            IF ( wk(ik) == 0.D0 ) THEN
               !
               raux(:) = wg(:,ik)
               !
            ELSE
               !
               raux(:) = wg(:,ik) / wk(ik)
               !
            END IF
            !
            IF (lkpoint_dir) THEN
               filename = qexml_wfc_filename( dirname, 'eigenval', ik, &
                    EXTENSION='xml',  DIR=lkpoint_dir )
               !
               CALL qexml_write_eig( auxunit, filename, nbnd, et(:, ik), &
                               trim(energy_units), OCC = raux(:), IK = ik )
            ELSE
               filename=' '
               CALL qexml_write_eig( auxunit, filename, nbnd, et(:, ik), &
                    trim(energy_units), OCC = raux(:), IK = ik, &
                    LKPOINT_DIR=.false. )
               CALL iotk_write_end( auxunit, &
                    "DATA_EIG"//TRIM( iotk_index( ik ) ) )
            ENDIF
            !
         END IF
         !
         CALL iotk_write_end( ounit, "K-POINT" // TRIM( iotk_index( ik ) ) )
         !
      ENDDO
      !
      !
      DEALLOCATE ( raux )
      !
      !
      CALL iotk_write_end( ounit, "EIGENVALUES" )
      !
    END SUBROUTINE qexml_write_bands_pw
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_write_bands_cp( nbnd, num_k_points, nspin, iupdwn, nupdwn, xk, wk, et, tksw, &
         occ0, occm, energy_units, k_units, auxunit ,dirname )
      !------------------------------------------------------------------------
      !
      !
      INTEGER, INTENT(in) :: nbnd,num_k_points,nspin, iupdwn(2),nupdwn(2),auxunit
      REAL(DP), INTENT(in) :: xk(:,:),wk(:),et(:,:)
      CHARACTER(len=*), INTENT(in) :: dirname,k_units,energy_units
      LOGICAL, INTENT(in) :: tksw
      REAL(DP), INTENT(in) :: occ0(:)
      REAL(DP), INTENT(in) :: occm(:)
      !
      !
      REAL(DP), ALLOCATABLE :: dtmp(:)
      INTEGER :: iss, ik
      CHARACTER(LEN=4)     :: cspin
      CHARACTER(LEN=256)    :: filename
      !
      !
      CALL iotk_write_begin( ounit, "EIGENVALUES" )
      !
      DO ik = 1, num_k_points
         !
         CALL iotk_write_begin( ounit, "K-POINT" // TRIM( iotk_index(ik) ) )
         !
         CALL iotk_write_attr( attr, "UNITS", "2 pi / a", FIRST = .TRUE. )
         CALL iotk_write_dat( ounit, "K-POINT_COORDS", xk(:,ik), ATTR = attr )
         !
         CALL iotk_write_dat( ounit, "WEIGHT", wk(ik) )
         !
         ALLOCATE( dtmp ( nbnd ) )
         !
         DO iss = 1, nspin
            !
            cspin = iotk_index( iss )
            !
            dtmp = 0.0d0
            !
            IF( tksw ) THEN
               !
               !
               IF( nspin == 2 ) THEN
                  IF( iss == 1 ) filename = qexml_wfc_filename( ".", 'eigenval1', ik, EXTENSION='xml' )
                  IF( iss == 2 ) filename = qexml_wfc_filename( ".", 'eigenval2', ik, EXTENSION='xml' )
                  !
                  IF( iss == 1 ) CALL iotk_link( ounit, "DATAFILE.1", &
                       filename, CREATE = .FALSE., BINARY = .FALSE. )
                  IF( iss == 2 ) CALL iotk_link( ounit, "DATAFILE.2", &
                       filename, CREATE = .FALSE., BINARY = .FALSE. )
                  
                  IF( iss == 1 ) filename = qexml_wfc_filename( dirname, 'eigenval1', ik, EXTENSION='xml' )
                  IF( iss == 2 ) filename = qexml_wfc_filename( dirname, 'eigenval2', ik, EXTENSION='xml' )
               ELSE
                  filename = qexml_wfc_filename( ".", 'eigenval', ik, EXTENSION='xml' )
                  CALL iotk_link( ounit, "DATAFILE", filename, CREATE = .FALSE., BINARY = .FALSE. )
                  filename = qexml_wfc_filename( dirname, 'eigenval', ik, EXTENSION='xml' )
               END IF
               
               dtmp ( 1:nupdwn( iss ) ) = occ0( iupdwn( iss ) : iupdwn( iss ) + nupdwn( iss ) - 1 ) / wk(ik)
               !
               CALL qexml_write_eig( auxunit, filename, nbnd, et( 1:nbnd, iss) , energy_units, &
                    OCC = dtmp(:), IK=ik, ISPIN=iss )
            END IF
               !
            CALL iotk_write_dat( ounit, "OCC0"  // TRIM( cspin ), &
                                    occ0( iupdwn( iss ) : iupdwn( iss ) + nupdwn( iss ) - 1 ) )
            !
            CALL iotk_write_dat( ounit, "OCCM" // TRIM( cspin ), &
                 occm( iupdwn( iss ) : iupdwn( iss ) + nupdwn( iss ) - 1 ) )
            !
         END DO
         !
         DEALLOCATE( dtmp )
         !
         CALL iotk_write_end( ounit, "K-POINT" // TRIM( iotk_index(ik) ) )
         !
      END DO
      !
      CALL iotk_write_end( ounit, "EIGENVALUES" )
      !
      !
    END SUBROUTINE qexml_write_bands_cp
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_write_eig( iuni, filename, nbnd, eig, energy_units, &
                          occ, ik, ispin, lkpoint_dir )
      !------------------------------------------------------------------------
      !
      IMPLICIT NONE
      !
      INTEGER,            INTENT(IN) :: iuni
      INTEGER,            INTENT(IN) :: nbnd
      REAL(DP),           INTENT(IN) :: eig(:)
      CHARACTER(*),       INTENT(IN) :: energy_units
      REAL(DP), OPTIONAL, INTENT(IN) :: occ(:)
      INTEGER,  OPTIONAL, INTENT(IN) :: ik, ispin
      LOGICAL,  OPTIONAL, INTENT(IN) :: lkpoint_dir
      CHARACTER(LEN=256), INTENT(IN) :: filename
      LOGICAL :: lkpoint_dir0
      !
      lkpoint_dir0=.TRUE.
      IF (present(lkpoint_dir)) lkpoint_dir0=lkpoint_dir
      !
      !
      IF (lkpoint_dir0) CALL iotk_open_write ( iuni, &
                           FILE = TRIM( filename ), BINARY = .FALSE. )
      !
      CALL iotk_write_attr ( attr, "nbnd", nbnd, FIRST=.TRUE. )
      IF ( PRESENT( ik) )    CALL iotk_write_attr ( attr, "ik", ik )
      IF ( PRESENT( ispin) ) CALL iotk_write_attr ( attr, "ispin", ispin )
      CALL iotk_write_empty( iuni, "INFO", ATTR = attr )
      !
      CALL iotk_write_attr ( attr, "UNITS", TRIM(energy_units), FIRST = .TRUE. )
      CALL iotk_write_empty( iuni, "UNITS_FOR_ENERGIES", ATTR=attr)
      !
      CALL iotk_write_dat( iuni, "EIGENVALUES", eig(:) )
      !
      IF ( PRESENT( occ ) ) THEN
         !
         CALL iotk_write_dat( iuni, "OCCUPATIONS", occ(:) )
         !
      ENDIF
      !
      IF (lkpoint_dir0) CALL iotk_close_write ( iuni )
      !
      !
    END SUBROUTINE qexml_write_eig
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_write_wfc( nbnd, nkpts, nspin, ik, ispin, ipol, igk, ngw, igwx, &
                                gamma_only, wf, wf_kindip, scale_factor )
      !------------------------------------------------------------------------
      !
      IMPLICIT NONE
      !
      INTEGER,                INTENT(in) :: nbnd, nkpts, nspin
      INTEGER,                INTENT(in) :: ik
      INTEGER,      OPTIONAL, INTENT(in) :: ispin, ipol
      INTEGER,                INTENT(in) :: ngw, igwx
      LOGICAL,                INTENT(in) :: gamma_only
      INTEGER,      OPTIONAL, INTENT(in) :: igk(:)
      COMPLEX(DP), OPTIONAL, INTENT(in) :: wf(:,:)
      COMPLEX(DP), OPTIONAL, INTENT(in) :: wf_kindip(:,:)
      REAL(DP),    OPTIONAL, INTENT(in) :: scale_factor
      !
      INTEGER         :: iunaux, ierr
      INTEGER         :: ig, ib
      CHARACTER(256)  :: filename
      COMPLEX(DP),  ALLOCATABLE :: wtmp(:)

      ierr = 0
      !
      IF ( present( ispin ) .and. present( ipol )  ) THEN
         !
         ierr = 1
         RETURN
         !
      ENDIF
      !
      ! open the file to write
      !
      CALL iotk_free_unit( iunaux )
      !
      IF ( present( ispin ) ) THEN
         !
         filename = trim( qexml_wfc_filename( datadir_out, 'evc', ik, ispin ) )
         !
      ELSEIF ( present( ipol )  ) THEN
         !
         filename = trim( qexml_wfc_filename( datadir_out, 'evc', ik, ipol ) )
         !
      ELSE
         !
         filename = trim( qexml_wfc_filename( datadir_out, 'evc', ik ) )
         !
      ENDIF
      !
      CALL iotk_open_write ( iunaux, FILE = trim(filename), ROOT="WFC", BINARY=.true., IERR=ierr )
      IF (ierr/=0)  RETURN
      !
      !
      CALL iotk_write_attr( attr, "ngw",          ngw, FIRST = .true. )
      CALL iotk_write_attr( attr, "igwx",         igwx )
      CALL iotk_write_attr( attr, "gamma_only",   gamma_only )
      CALL iotk_write_attr( attr, "nbnd",         nbnd )
      CALL iotk_write_attr( attr, "ik",           ik )
      CALL iotk_write_attr( attr, "nk",           nkpts )
      CALL iotk_write_attr( attr, "ispin",        ispin )
      CALL iotk_write_attr( attr, "nspin",        nspin )
      IF ( present( scale_factor) ) CALL iotk_write_attr( attr, "scale_factor", scale_factor )
      !
      CALL iotk_write_empty( iunaux, "INFO", attr )
      !
      !
      IF ( present( wf ) ) THEN
         !
         ! write wfcs without any G-reordering
         !
         DO ib = 1, nbnd
            !
            CALL iotk_write_dat( iunaux, "evc" // trim(iotk_index( ib )), wf( 1: ngw, ib) )
            !
         ENDDO
         !
      ENDIF
      !
      !
      IF ( present( wf_kindip ) ) THEN
         !
         ! we need to reorder wfcs in terms of G-vectors
         ! we need the igk map
         !
         IF ( .not. present( igk ) ) THEN
            ierr = 71
            RETURN
         ENDIF
         !
         ALLOCATE( wtmp( ngw ) )
         !
         DO ib = 1, nbnd
            !
            DO ig = 1, ngw
               !
               wtmp( ig ) = wf_kindip( igk(ig), ib)
               !
            ENDDO
            !
            CALL iotk_write_dat( iunaux, "evc" // trim(iotk_index( ib )), wtmp( 1: ngw) )
            !
         ENDDO
         !
         DEALLOCATE( wtmp )
         !
      ENDIF
      !
      !
      CALL iotk_close_write( iunaux )
      !
    END SUBROUTINE qexml_write_wfc
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_write_rho( nr1, nr2, nr3, rho, nr1x, nr2x, rhov, binary )
      !------------------------------------------------------------------------
      !
      ! Writes charge density rho, one plane at a time.
      !
      IMPLICIT NONE
      !
      INTEGER,             INTENT(in) :: nr1, nr2, nr3
      INTEGER,   OPTIONAL, INTENT(in) :: nr1x, nr2x
      REAL(DP), OPTIONAL, INTENT(in) :: rho(:,:,:), rhov(:)
      LOGICAL,   OPTIONAL, INTENT(in) :: binary
      !
      INTEGER        :: iunaux, nr1x_, nr2x_, ip, i1, i2, i
      LOGICAL        :: binary_
      CHARACTER(256) :: filename
      REAL(DP), ALLOCATABLE :: plane(:,:)
      !
      !
      CALL iotk_free_unit( iunaux )
      !
      binary_ = .true.
      IF ( present (binary) ) binary_ = binary
      !
      IF ( binary_ ) THEN
         !
         filename = trim( datadir_out ) // '/' //'charge-density.dat'
         !
      ELSE
         !
         filename = trim( datadir_out ) // '/' //'charge-density.xml'
         !
      ENDIF
      !
      CALL iotk_open_write( iunaux, FILE = trim(filename), BINARY=binary_ )
      !
      !
      CALL iotk_write_begin( iunaux, "CHARGE-DENSITY" )
      !
      CALL iotk_write_attr( attr, "nr1", nr1, FIRST = .true. )
      CALL iotk_write_attr( attr, "nr2", nr2 )
      CALL iotk_write_attr( attr, "nr3", nr3 )
      !
      CALL iotk_write_empty( iunaux, "INFO", attr )
      !
      !
      IF ( present( rho ) ) THEN
         !
         DO ip = 1, nr3
            !
            CALL iotk_write_dat( iunaux, "z"//trim(iotk_index(ip)), rho(1:nr1,1:nr2,ip) )
            !
         ENDDO
         !
      ELSEIF ( present( rhov ) ) THEN
         !
         nr1x_ = nr1
         IF ( present( nr1x )) nr1x_ = nr1x
         nr2x_ = nr2
         IF ( present( nr2x )) nr2x_ = nr2x
         !
         IF ( nr1x_ /= nr1 .or. nr2x_ /= nr2 ) THEN
            !
            ! we need to separately reconstruct the rho-plane
            !
            ALLOCATE( plane(nr1, nr2 ) )
            !
            DO ip = 1, nr3
               !
               DO i2 = 1, nr2
               DO i1 = 1, nr1
                   !
                   i = (nr1x_ * nr2x_) * ( ip -1 ) + nr1x_ * ( i2 -1 ) + i1
                   !
                   plane( i1, i2) = rhov( i )
                   !
               ENDDO
               ENDDO
               !
               CALL iotk_write_dat( iunaux, "z"//trim(iotk_index(ip)), plane )
               !
            ENDDO
            !
            DEALLOCATE( plane )
            !
         ELSE
            !
            DO ip = 1, nr3
               !
               i1  = ( nr1 * nr2 ) * ( ip -1 ) + 1
               i2  = ( nr1 * nr2 ) * ip
               !
               CALL iotk_write_dat( iunaux, "z"//trim(iotk_index(ip)), rhov(i1:i2) )
               !
            ENDDO
            !
         ENDIF
         !
      ENDIF
      !
      !
      CALL iotk_write_end( iunaux, "CHARGE-DENSITY" )
      !
      CALL iotk_close_write( iunaux )
      !
      !
    END SUBROUTINE qexml_write_rho
!
!-------------------------------------------
! ... read subroutines
!-------------------------------------------
!
    !------------------------------------------------------------------------
    SUBROUTINE qexml_read_header( creator_name, creator_version, &
                                  format_name, format_version, ierr )
      !------------------------------------------------------------------------
      !
      IMPLICIT NONE
      CHARACTER(len=*),  OPTIONAL, INTENT(out) :: creator_name, creator_version
      CHARACTER(len=*),  OPTIONAL, INTENT(out) :: format_name, format_version
      INTEGER,           INTENT(out) :: ierr
      !
      CHARACTER(256) :: creator_name_, creator_version_
      CHARACTER(256) :: format_name_,     format_version_
      !
      ierr = 0
      !
      !
      CALL iotk_scan_begin( iunit, "HEADER", IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_empty( iunit, "FORMAT", ATTR=attr, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_attr(attr, "NAME", format_name_, IERR=ierr)
      IF (ierr/=0) RETURN
      CALL iotk_scan_attr(attr, "VERSION", format_version_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_empty( iunit, "CREATOR", ATTR=attr, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_attr(attr, "NAME", creator_name_, IERR=ierr)
      IF (ierr/=0) RETURN
      CALL iotk_scan_attr(attr, "VERSION", creator_version_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_end( iunit, "HEADER", IERR=ierr )
      IF (ierr/=0) RETURN
      !
      !
      IF ( present(creator_name) )     creator_name    = trim(creator_name_)
      IF ( present(creator_version) )  creator_version = trim(creator_version_)
      IF ( present(format_name) )      format_name     = trim(format_name_)
      IF ( present(format_version) )   format_version  = trim(format_version_)
      !
    END SUBROUTINE qexml_read_header
    !
    !
    !------------------------------------------------------------------------  
    SUBROUTINE qexml_read_status_cp( nfi,simtime,time_units,title, &
                                  ekin, eht, esr, eself, epseu, enl, exc, vave, enthal, &
                                  energy_units, found, ierr )
      !------------------------------------------------------------------------
      !
      INTEGER, OPTIONAL, INTENT(OUT) :: nfi
      REAL(DP), OPTIONAL, INTENT(OUT) :: simtime, ekin,eht,esr,eself,epseu,enl,exc,vave,enthal
      CHARACTER(len=*), OPTIONAL, INTENT(OUT) :: time_units, title, energy_units
      LOGICAL,INTENT(OUT) :: found
      INTEGER, INTENT(OUT) :: ierr
      !
      INTEGER :: nfi_
      REAL(DP) :: simtime_, ekin_,eht_,esr_,eself_,epseu_,enl_,exc_,vave_,enthal_
      CHARACTER(len=256) :: time_units_, title_, energy_units_
      !
      CALL iotk_scan_begin( iunit, "STATUS", ATTR=attr, FOUND = found )
      IF ( .NOT.found ) RETURN
      !
      CALL iotk_scan_empty( iunit, "STEP", ATTR = attr, IERR = ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_attr( attr, "ITERATION", nfi_, IERR = ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat( iunit, "TIME", simtime_, ATTR = attr, IERR = ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_attr( attr, "UNITS", time_units_, IERR = ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat( iunit, "TITLE", title_, IERR = ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat( iunit, "KINETIC_ENERGY", ekin_,   ATTR = attr, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_attr( attr, "UNITS", energy_units_, IERR = ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat( iunit, "HARTREE_ENERGY", eht_,   IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat( iunit, "EWALD_TERM",     esr_,   IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat( iunit, "GAUSS_SELFINT",  eself_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat( iunit, "LPSP_ENERGY",    epseu_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat( iunit, "NLPSP_ENERGY",   enl_,   IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat( iunit, "EXC_ENERGY",     exc_,   IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat( iunit, "AVERAGE_POT",    vave_,  IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat( iunit, "ENTHALPY",       enthal_,IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_end( iunit, "STATUS", IERR=ierr )
      IF (ierr/=0) RETURN
      !
      !
      IF (present(nfi)) nfi = nfi_
      IF (present(simtime)) simtime = simtime_
      IF (present(time_units)) time_units = time_units_
      IF (present(title)) title = title_
      IF (present(ekin)) ekin = ekin_
      IF (present(eht)) eht = eht_
      IF (present(esr)) esr = esr_
      IF (present(eself)) eself = eself_
      IF (present(epseu)) epseu = epseu_
      IF (present(enl)) enl = enl_
      IF (present(exc)) exc = exc_
      IF (present(vave)) vave = vave_
      IF (present(enthal)) enthal = enthal_
      IF (present(energy_units)) energy_units = energy_units_
      !
    END SUBROUTINE qexml_read_status_cp
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_read_cell( bravais_lattice, celldm, alat, &
                    a1, a2, a3, b1, b2, b3, alat_units, a_units, b_units, &
                    es_corr, ierr )
      !------------------------------------------------------------------------
      !
      CHARACTER(len=*),  OPTIONAL, INTENT(out) :: bravais_lattice
      REAL(DP),         OPTIONAL, INTENT(out) :: celldm(6), alat
      REAL(DP),         OPTIONAL, INTENT(out) :: a1(3), a2(3), a3(3)
      REAL(DP),         OPTIONAL, INTENT(out) :: b1(3), b2(3), b3(3)
      CHARACTER(len=*),  OPTIONAL, INTENT(out) :: alat_units, a_units, b_units
      CHARACTER(len=*),  OPTIONAL, INTENT(out) :: es_corr
      INTEGER,                     INTENT(out) :: ierr
      !
      CHARACTER(256)     :: bravais_lattice_
      CHARACTER(256)     :: alat_units_, a_units_, b_units_,es_corr_
      REAL(DP)          :: celldm_(6), alat_
      REAL(DP)          :: a1_(3), a2_(3), a3_(3)
      REAL(DP)          :: b1_(3), b2_(3), b3_(3)
      !

      ierr=0
      !
      !
      CALL iotk_scan_begin( iunit, "CELL" )
      !
      CALL iotk_scan_dat( iunit, "BRAVAIS_LATTICE", bravais_lattice_, IERR=ierr )
      IF ( ierr /= 0 ) RETURN
      !
      !
      CALL iotk_scan_dat( iunit, "NON-PERIODIC_CELL_CORRECTION", es_corr_, IERR=ierr)
      IF ( ierr /= 0 ) RETURN
      !
      !
      CALL iotk_scan_dat( iunit, "LATTICE_PARAMETER", alat_, ATTR=attr, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      !
      CALL iotk_scan_attr( attr, "UNITS", alat_units_, IERR=ierr )
      IF ( ierr /= 0 ) RETURN
      !
      !
      CALL iotk_scan_dat( iunit, "CELL_DIMENSIONS", celldm_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      !
      CALL iotk_scan_begin( iunit, "DIRECT_LATTICE_VECTORS", IERR=ierr )
      IF (ierr/=0) RETURN
      !
      !
      CALL iotk_scan_empty( iunit, "UNITS_FOR_DIRECT_LATTICE_VECTORS", &
                            ATTR=attr, IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_attr( attr, "UNITS", a_units_, IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_dat(   iunit, "a1", a1_(:), ATTR=attr, IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_dat(   iunit, "a2", a2_(:), IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_dat(   iunit, "a3", a3_(:), IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_end(   iunit, "DIRECT_LATTICE_VECTORS", IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_begin( iunit, "RECIPROCAL_LATTICE_VECTORS", IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_empty( iunit, "UNITS_FOR_RECIPROCAL_LATTICE_VECTORS", &
                            ATTR=attr, IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_attr( attr, "UNITS", b_units_, IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_dat(   iunit, "b1", b1_(:), ATTR=attr, IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_dat(   iunit, "b2", b2_(:), IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_dat(   iunit, "b3", b3_(:), IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_end(   iunit, "RECIPROCAL_LATTICE_VECTORS", IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_end( iunit, "CELL", IERR=ierr )
      IF (ierr/=0) RETURN
      !
      !
      IF ( present(bravais_lattice) )  bravais_lattice = bravais_lattice_
      IF ( present(celldm) )        celldm       = celldm_
      IF ( present(alat) )          alat         = alat_
      IF ( present(a1) )            a1           = a1_
      IF ( present(a2) )            a2           = a2_
      IF ( present(a3) )            a3           = a3_
      IF ( present(b1) )            b1           = b1_
      IF ( present(b2) )            b2           = b2_
      IF ( present(b3) )            b3           = b3_
      IF ( present(alat_units) )    alat_units   = trim(alat_units_)
      IF ( present(a_units) )       a_units      = trim(a_units_)
      IF ( present(b_units) )       b_units      = trim(b_units_)
      IF ( present(es_corr) )       es_corr      = trim(es_corr_)
      !
    END SUBROUTINE qexml_read_cell
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_read_moving_cell(lmovecell, cell_factor, ierr)
      !------------------------------------------------------------------------
      !
      LOGICAL,  INTENT(OUT) :: lmovecell
      REAL(DP), INTENT(OUT) :: cell_factor
      INTEGER,  INTENT(OUT) :: ierr
      !
      LOGICAL :: found
      !
      CALL iotk_scan_begin( iunit, "MOVING_CELL", found=lmovecell, IERR=ierr )
      !
      IF (lmovecell) THEN
         CALL iotk_scan_dat( iunit, "CELL_FACTOR", cell_factor, IERR=ierr)
         IF (ierr/=0) RETURN
         !
         CALL iotk_scan_end( iunit, "MOVING_CELL", IERR=ierr )
         IF (ierr/=0) RETURN
      END IF
      !
    END SUBROUTINE qexml_read_moving_cell
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_read_ions( nsp, nat, atm, ityp, psfile, amass, amass_units, &
                                tau, tau_units, if_pos, pseudo_dir, ierr )
      !------------------------------------------------------------------------
      !
      INTEGER,          OPTIONAL, INTENT(out) :: nsp, nat
      INTEGER,          OPTIONAL, INTENT(out) :: ityp(:)
      CHARACTER(len=*), OPTIONAL, INTENT(out) :: atm(:)
      CHARACTER(len=*), OPTIONAL, INTENT(out) :: psfile(:)
      REAL(DP),         OPTIONAL, INTENT(out) :: amass(:)
      CHARACTER(len=*), OPTIONAL, INTENT(out) :: amass_units
      REAL(DP),         OPTIONAL, INTENT(out) :: tau(:,:)
      INTEGER,          OPTIONAL, INTENT(out) :: if_pos(:,:)
      CHARACTER(len=*), OPTIONAL, INTENT(out) :: tau_units
      CHARACTER(len=*), OPTIONAL, INTENT(out) :: pseudo_dir
      INTEGER,                    INTENT(out) :: ierr
      !
      INTEGER                     :: nat_, nsp_
      CHARACTER(256)              :: tau_units_, amass_units_
      INTEGER,        ALLOCATABLE :: ityp_(:)
      CHARACTER(3),   ALLOCATABLE :: atm_(:)
      CHARACTER(256), ALLOCATABLE :: psfile_(:)
      CHARACTER(256)              :: pseudo_dir_
      REAL(DP),       ALLOCATABLE :: amass_(:)
      REAL(DP),       ALLOCATABLE :: tau_(:,:)
      INTEGER,        ALLOCATABLE :: if_pos_(:,:)
      !
      INTEGER :: i
      !
      ierr=0
      !
      CALL iotk_scan_begin( iunit, "IONS", IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat( iunit, "NUMBER_OF_ATOMS", nat_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat( iunit, "NUMBER_OF_SPECIES", nsp_ )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_empty( iunit, "UNITS_FOR_ATOMIC_MASSES", ATTR=attr, IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_attr( attr, "UNITS", amass_units_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      IF ( present(nat) )   nat = nat_
      IF ( present(nsp) )   nsp = nsp_
      !
      ALLOCATE( atm_(nsp_) )
      ALLOCATE( amass_(nsp_) )
      ALLOCATE( psfile_(nsp_) )
      !
      DO i = 1, nsp_
         !
         IF ( qexml_version_before_1_4_0 ) THEN
            !
            CALL iotk_scan_dat( iunit, "ATOM_TYPE", atm_(i), IERR=ierr )
            IF (ierr/=0) RETURN
            CALL iotk_scan_dat( iunit, trim( atm_(i) ) // "_MASS", amass_(i), IERR=ierr )
            IF (ierr/=0) RETURN
            CALL iotk_scan_dat( iunit, "PSEUDO_FOR_" // trim( atm_(i) ), &
                                psfile_(i), IERR=ierr )
            IF (ierr/=0) RETURN
            !
         ELSE
            !
            ! current version
            !
            CALL iotk_scan_begin( iunit, "SPECIE"//trim(iotk_index(i)), IERR=ierr )
            IF (ierr/=0) RETURN
            !
            CALL iotk_scan_dat( iunit, "ATOM_TYPE", atm_(i), IERR=ierr )
            IF (ierr/=0) RETURN
            CALL iotk_scan_dat( iunit, "MASS", amass_(i), IERR=ierr )
            IF (ierr/=0) RETURN
            CALL iotk_scan_dat( iunit, "PSEUDO", psfile_(i), IERR=ierr )
            IF (ierr/=0) RETURN
            !
            CALL iotk_scan_end( iunit, "SPECIE"//trim(iotk_index(i)), IERR=ierr )
            IF (ierr/=0) RETURN
            !
         ENDIF
         !
      ENDDO
      !
      CALL iotk_scan_dat( iunit, "PSEUDO_DIR", pseudo_dir_ )
      !
      CALL iotk_scan_empty( iunit, "UNITS_FOR_ATOMIC_POSITIONS", ATTR=attr, IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_attr( attr, "UNITS", tau_units_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      ALLOCATE( ityp_(nat_) )
      ALLOCATE( tau_(3,nat_) )
      ALLOCATE( if_pos_(3,nat_) )
      !
      DO i = 1, nat_
         !
         CALL iotk_scan_empty( iunit, &
                               "ATOM" // trim( iotk_index(i) ), ATTR=attr, IERR=ierr )
         IF (ierr/=0) RETURN
         !
         CALL iotk_scan_attr( attr, "INDEX",  ityp_(i), IERR=ierr )
         IF (ierr/=0) RETURN
         CALL iotk_scan_attr( attr, "tau",    tau_(:,i), IERR=ierr )
         IF (ierr/=0) RETURN
         CALL iotk_scan_attr( attr, "if_pos", if_pos_(:,i), IERR=ierr )
         IF (ierr/=0) RETURN
         !
      ENDDO
      !
      CALL iotk_scan_end( iunit, "IONS", IERR=ierr )
      IF (ierr/=0) RETURN
      !
      !
      IF ( present(nsp) )         nsp    = nsp_
      IF ( present(nat) )         nat    = nat_
      IF ( present(atm) )         atm(1:nsp_)    = atm_
      IF ( present(amass) )       amass(1:nsp_)  = amass_
      IF ( present(amass_units) ) amass_units    = trim(amass_units_)
      IF ( present(psfile) )      psfile(1:nsp_) = psfile_(1:nsp_)
      IF ( present(ityp) )        ityp(1:nat_)   = ityp_
      IF ( present(tau_units) )   tau_units      = trim(tau_units_)
      IF ( present(tau) )         tau(1:3, 1:nat_)    = tau_
      IF ( present(if_pos) )      if_pos(1:3, 1:nat_) = if_pos_
      IF ( present(pseudo_dir) )  pseudo_dir = pseudo_dir_
      !
      DEALLOCATE( atm_ )
      DEALLOCATE( amass_ )
      DEALLOCATE( psfile_ )
      DEALLOCATE( ityp_ )
      DEALLOCATE( tau_ )
      DEALLOCATE( if_pos_ )
      !
    END SUBROUTINE qexml_read_ions
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_read_magnetization(starting_magnetization, angle1, angle2, &
                                   nsp, two_fermi_energies, i_cons, mcons, bfield, &
                                   ef_up, ef_dw, nelup, neldw, lambda, energy_units, found, ierr)
      !------------------------------------------------------------------------
      !
      IMPLICIT NONE
      INTEGER,      OPTIONAL, INTENT(OUT) :: nsp, i_cons
      REAL(DP),     OPTIONAL, INTENT(OUT) :: starting_magnetization(:), &
                                             angle1(:), angle2(:), mcons(:,:), &
                                             bfield(:), ef_up, ef_dw, nelup, neldw, lambda
      LOGICAL,      OPTIONAL, INTENT(OUT) :: two_fermi_energies
      LOGICAL,      OPTIONAL, INTENT(OUT) :: found
      CHARACTER(*), OPTIONAL, INTENT(OUT) :: energy_units
      INTEGER,                INTENT(OUT) :: ierr
      !
      INTEGER  :: i
      INTEGER  :: nsp_, i_cons_
      LOGICAL  :: two_fermi_energies_,found_,found2
      REAL(DP) :: ef_up_, ef_dw_, nelup_, neldw_, lambda_, bfield_(3)
      REAL(DP), ALLOCATABLE :: angle1_(:), angle2_(:)
      REAL(DP), ALLOCATABLE :: mcons_(:,:), starting_magnetization_(:) 
      CHARACTER(256) :: energy_units_
      !
      !
      CALL iotk_scan_begin( iunit, "MAGNETIZATION_INIT", IERR=ierr, FOUND = found_ )
      !
      IF (found_) THEN
         !
         CALL iotk_scan_dat(iunit,"CONSTRAINT_MAG", i_cons_)
         !
         CALL iotk_scan_dat( iunit, "NUMBER_OF_SPECIES", nsp_ )
         !
         ALLOCATE( starting_magnetization_(nsp_) )
         ALLOCATE( angle1_(nsp_) )
         ALLOCATE( angle2_(nsp_) )

         IF ( i_cons_ ==1 .OR. i_cons_ ==2 ) ALLOCATE( mcons_(3,nsp_) )
         !
         DO i=1,nsp_
            !
            CALL iotk_scan_begin( iunit, "SPECIE"//TRIM(iotk_index(i)) )
            !
            CALL iotk_scan_dat( iunit, "STARTING_MAGNETIZATION", &
                 starting_magnetization_(i) )
            CALL iotk_scan_dat( iunit, "ANGLE1", angle1_(i) )
            CALL iotk_scan_dat( iunit, "ANGLE2", angle2_(i) )
            !
            !
            IF (i_cons_==1.OR.i_cons_==2) THEN
               !
               CALL iotk_scan_dat( iunit, "CONSTRANT_1", mcons_(1,i) )
               CALL iotk_scan_dat( iunit, "CONSTRANT_2", mcons_(2,i) )
               CALL iotk_scan_dat( iunit, "CONSTRANT_3", mcons_(3,i) )
               !
            ENDIF
            !
            CALL iotk_scan_end( iunit, "SPECIE"//TRIM(iotk_index(i)) )
            !
         ENDDO
         !
         IF ( i_cons_ ==1 .OR. i_cons_ ==2 ) THEN
            !
            mcons_(1:3,1:nsp_) = mcons_
            !
            DEALLOCATE( mcons_ )
            !
         ENDIF
         !
         IF (i_cons_==3) THEN
            !
            ALLOCATE( mcons_(3,1) )
            !
            CALL iotk_scan_dat( iunit, "FIXED_MAGNETIZATION_1", mcons_(1,1) )
            CALL iotk_scan_dat( iunit, "FIXED_MAGNETIZATION_2", mcons_(2,1) )
            CALL iotk_scan_dat( iunit, "FIXED_MAGNETIZATION_3", mcons_(3,1) )
            !
            IF (present(mcons) ) mcons(1:3,1:1) = mcons_
            !
            DEALLOCATE( mcons_)
            !
         ELSE IF (i_cons_==4) THEN
            ! 
            CALL iotk_scan_dat( iunit, "MAGNETIC_FIELD_1", bfield_(1) )
            CALL iotk_scan_dat( iunit, "MAGNETIC_FIELD_2", bfield_(2) )
            CALL iotk_scan_dat( iunit, "MAGNETIC_FIELD_3", bfield_(3) )
            !
            IF (present(bfield)) bfield(1:3) = bfield_(1:3)
            !
         ENDIF
         !
         CALL iotk_scan_dat(iunit,"TWO_FERMI_ENERGIES", &
              two_fermi_energies_,FOUND=found2 )
         IF ( .not. found2 ) two_fermi_energies_=.FALSE.
         !
         IF (two_fermi_energies_) THEN
            !
            CALL iotk_scan_empty( iunit, "UNITS_FOR_ENERGIES", ATTR=attr, IERR=ierr )
            IF (ierr/=0) RETURN
            CALL iotk_scan_attr( attr, "UNITS", energy_units_, IERR=ierr )
            !
            ALLOCATE( mcons_(3,1) )
            !
            CALL iotk_scan_dat( iunit, "FIXED_MAGNETIZATION", mcons_(3,1) )
            CALL iotk_scan_dat( iunit, "ELECTRONS_UP", nelup_ )
            CALL iotk_scan_dat( iunit, "ELECTRONS_DOWN", neldw_ )
            CALL iotk_scan_dat( iunit, "FERMI_ENERGY_UP", ef_up_ )
            CALL iotk_scan_dat( iunit, "FERMI_ENERGY_DOWN", ef_dw_ )
            !
            IF (present(mcons) ) mcons(3,1) = mcons_(3,1)
            IF (present(ef_up) ) ef_up = ef_up_
            IF (present(ef_dw) ) ef_dw = ef_dw_
            IF (present(nelup) ) nelup = nelup_
            IF (present(neldw) ) neldw = neldw_
            IF (present(energy_units) ) energy_units = trim(energy_units_)
            !
            DEALLOCATE( mcons_)
            !
         ENDIF
         !
         lambda_ = 0.0d0
         IF (i_cons_ > 0) CALL iotk_scan_dat(iunit,"LAMBDA",lambda_)
         !
         CALL iotk_scan_end( iunit, "MAGNETIZATION_INIT" )
         !
         IF (present(nsp)) nsp = nsp_
         IF (present(two_fermi_energies)) two_fermi_energies = two_fermi_energies_
         IF (present(i_cons)) i_cons = i_cons_
         !
         IF (present(lambda) ) lambda = lambda_
         IF (present(starting_magnetization) ) starting_magnetization(1:nsp_) = starting_magnetization_
         IF (present(angle1) ) angle1(1:nsp_) = angle1_(1:nsp_)
         IF (present(angle2) ) angle2(1:nsp_) = angle2_(1:nsp_)
         !
      END IF
      !
      IF (present(found)) found = found_
      IF ( (.NOT. present(found)) .AND. ( .NOT. found_) ) ierr = 1
      !
      !
    END SUBROUTINE qexml_read_magnetization
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_read_symmetry( nsym, nrot, invsym, noinv, time_reversal, no_t_rev, &
                                    trasl, s, sname, s_units, t_rev, &
                                    irt, nat, found, ierr )
      !------------------------------------------------------------------------
      !
      INTEGER,          OPTIONAL, INTENT(out) :: nsym, nrot
      LOGICAL,          OPTIONAL, INTENT(out) :: invsym, noinv, time_reversal, no_t_rev
      INTEGER,          OPTIONAL, INTENT(out) :: s(:,:,:)
      REAL(DP),         OPTIONAL, INTENT(out) :: trasl(:,:)
      CHARACTER(len=*), OPTIONAL, INTENT(out) :: sname(:)
      CHARACTER(len=*), OPTIONAL, INTENT(out) :: s_units
      INTEGER,          OPTIONAL, INTENT(out) :: t_rev(:)
      INTEGER,          OPTIONAL, INTENT(out) :: irt(:,:), nat
      LOGICAL,                    INTENT(out) :: found
      INTEGER,                    INTENT(out) :: ierr
      !
      INTEGER              :: nsym_
      INTEGER              :: nrot_
      CHARACTER(256)       :: sname_(48), s_units_
      LOGICAL              :: invsym_, noinv_, time_reversal_, no_t_rev_
      INTEGER              :: s_(3,3,48)
      REAL(DP)             :: trasl_(3,48)
      INTEGER              :: t_rev_(48)
      INTEGER              :: nat_
      INTEGER, ALLOCATABLE :: irt_(:,:)
      INTEGER              :: i
      LOGICAL              :: found_tmp
      !
      !
      ierr=0
      !
      !
      CALL iotk_scan_begin( iunit, "SYMMETRIES", FOUND=found ,IERR=ierr )
      IF ((ierr/=0).OR.(.NOT.found)) RETURN
      !
      CALL iotk_scan_dat( iunit, "NUMBER_OF_SYMMETRIES", nsym_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat( iunit, "NUMBER_OF_BRAVAIS_SYMMETRIES", &
                                 nrot_, FOUND=found_tmp, IERR=ierr )
      IF (ierr/=0) RETURN
      IF (.NOT. found_tmp) nrot_ = nsym_
      !
      CALL iotk_scan_dat( iunit, "INVERSION_SYMMETRY", invsym_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat( iunit, "DO_NOT_USE_TIME_REVERSAL", &
                                  noinv_, FOUND = found_tmp, IERR=ierr )
      IF (ierr/=0) RETURN
      IF (.NOT. found_tmp) noinv_ = .FALSE.
      !
      CALL iotk_scan_dat( iunit, "TIME_REVERSAL_FLAG", &
                                  time_reversal_, FOUND = found_tmp, IERR=ierr )
      IF (ierr/=0) RETURN
      IF (.NOT. found_tmp) time_reversal_ = .TRUE.
      !
      CALL iotk_scan_dat( iunit, "NO_TIME_REV_OPERATIONS", &
                                   no_t_rev_, FOUND = found_tmp, IERR=ierr )
      IF (ierr/=0) RETURN
      IF (.NOT. found_tmp) no_t_rev_ = .FALSE.
      !
      CALL iotk_scan_dat( iunit, "NUMBER_OF_ATOMS", nat_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      ALLOCATE( irt_(48, nat_) )
      !
      CALL iotk_scan_empty( iunit, "UNITS_FOR_SYMMETRIES", ATTR=attr, IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_attr( attr, "UNITS", s_units_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      DO i = 1, nsym_
          !
          CALL iotk_scan_begin( iunit, "SYMM"//trim( iotk_index( i ) ), IERR=ierr )
          IF (ierr/=0) RETURN
          !
          CALL iotk_scan_empty( iunit, "INFO", ATTR=attr, IERR=ierr )
          IF (ierr/=0) RETURN
          !
          CALL iotk_scan_attr( attr, "NAME", sname_(i), IERR=ierr )
          IF (ierr/=0) RETURN
          CALL iotk_scan_attr( attr, "T_REV", t_rev_(i), IERR=ierr )
          IF (ierr/=0) RETURN
          !
          CALL iotk_scan_dat( iunit, "ROTATION", s_(1:3,1:3,i), IERR=ierr )
          IF (ierr/=0) RETURN
          !
          CALL iotk_scan_dat( iunit, "FRACTIONAL_TRANSLATION", trasl_(1:3,i), IERR=ierr )
          IF (ierr/=0) RETURN
          !
          CALL iotk_scan_dat( iunit, "EQUIVALENT_IONS", irt_(i,1:nat_), IERR=ierr )
          IF (ierr/=0) RETURN
          !
          CALL iotk_scan_end( iunit, "SYMM"//trim( iotk_index( i ) ), IERR=ierr )
          IF (ierr/=0) RETURN
          !
      ENDDO
      !
      DO i = nsym_+1, nrot_
         !    
         CALL iotk_scan_begin( iunit, "SYMM" // TRIM( iotk_index( i ) ), IERR=ierr )
         IF (ierr/=0) RETURN
         !
         CALL iotk_scan_empty( iunit, "INFO", ATTR = attr, IERR=ierr )
         IF (ierr/=0) RETURN
         !
         CALL iotk_scan_attr( attr, "NAME",  sname_(i), IERR=ierr )
         IF (ierr/=0) RETURN
         !
         CALL iotk_scan_dat( iunit, "ROTATION", s_(1:3,1:3,i), IERR=ierr )
         IF (ierr/=0) RETURN
         !
         CALL iotk_scan_end( iunit, "SYMM" // TRIM( iotk_index( i ) ), IERR=ierr )
         IF (ierr/=0) RETURN
         !
      END DO
      !
      CALL iotk_scan_end( iunit, "SYMMETRIES", IERR=ierr )
      IF (ierr/=0) RETURN
      !
      !
      IF ( present(nsym) )        nsym          = nsym_
      IF ( present(nrot) )        nrot          = nrot_
      IF ( present(invsym) )      invsym        = invsym_
      IF ( present(noinv) )       noinv         = noinv_
      IF ( present(time_reversal) ) time_reversal = time_reversal_
      IF ( present(no_t_rev) )    no_t_rev      = no_t_rev_
      IF ( present(nat) )         nat           = nat_
      IF ( present(trasl) )       trasl(1:3, 1:nsym_)   = trasl_(1:3, 1:nsym_)
      IF ( present(s) )           s(1:3, 1:3, 1:nrot_)  = s_(1:3, 1:3, 1:nrot_)
      IF ( present(irt) )         irt(1:nsym_, 1:nat_)  = irt_(1:nsym_, 1:nat_)
      IF ( present(sname) )  THEN
          DO i = 1, nrot_
                                  sname( i )            = trim( sname_( i ) )
          ENDDO
      ENDIF
      IF ( present(s_units) )     s_units               = trim( s_units_ )
      IF ( present(t_rev) )       t_rev( 1:nsym_ )      = t_rev_( 1:nsym_ )
      !
      DEALLOCATE( irt_ )
      !
    END SUBROUTINE qexml_read_symmetry
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_read_efield( tefield, dipfield, edir, emaxpos, eopreg, eamp, &
                                  gate, zgate, relaxz, block, block_1, block_2,&
                                  block_height, found, ierr )
      !----------------------------------------------------------------------
      !
      IMPLICIT NONE
      !
      LOGICAL,   OPTIONAL, INTENT(out) :: tefield, dipfield, gate, relaxz, block
      INTEGER,   OPTIONAL, INTENT(out) :: edir
      REAL(DP),  OPTIONAL, INTENT(out) :: emaxpos, eopreg, eamp, zgate, block_1, block_2, block_height
      LOGICAL,             INTENT(out) :: found
      INTEGER,             INTENT(out) :: ierr
      !
      LOGICAL   :: tefield_, dipfield_, gate_, block_, relaxz_
      INTEGER   :: edir_
      REAL(DP)  :: emaxpos_, eopreg_, eamp_, zgate_, block_1_, block_2_, block_height_
      !
      ierr = 0
      !
      CALL iotk_scan_begin( iunit, "ELECTRIC_FIELD", FOUND=found, IERR=ierr )
      IF ( ( .NOT. found ).OR.( ierr /= 0 ) ) RETURN
      !
      !
      CALL iotk_scan_dat( iunit, "HAS_ELECTRIC_FIELD", tefield_, IERR=ierr )
      IF ( ierr /= 0 ) RETURN
      !
      CALL iotk_scan_dat( iunit, "HAS_DIPOLE_CORRECTION", dipfield_, IERR=ierr )
      IF ( ierr /= 0 ) RETURN
      !
      CALL iotk_scan_dat( iunit, "FIELD_DIRECTION", edir_, IERR=ierr )
      IF ( ierr /= 0 ) RETURN
      !
      CALL iotk_scan_dat( iunit, "MAXIMUM_POSITION", emaxpos_, IERR=ierr )
      IF ( ierr /= 0 ) RETURN
      !
      CALL iotk_scan_dat( iunit, "INVERSE_REGION", eopreg_, IERR=ierr )
      IF ( ierr /= 0 ) RETURN
      !
      CALL iotk_scan_dat( iunit, "FIELD_AMPLITUDE", eamp_, IERR=ierr )
      IF ( ierr /= 0 ) RETURN
      !
      !-----------------------------------------------------------------------
      !Earlier versions do not have the following field (e.g. 5.1.0).
      gate_= .FALSE.
      block_= .FALSE.
      relaxz_ = .FALSE.
      zgate_ = 0.0
      block_1_ = 0.0
      block_2_ = 0.0
      block_height_ = 0.0
      !-----------------------------------------------------------------------
      CALL iotk_scan_dat( iunit, "CHARGED_PLATE", gate_, FOUND=found, IERR=ierr )
      IF ( found .and. ( ierr /= 0 ) ) RETURN
      !
      CALL iotk_scan_dat( iunit, "GATE_POS", zgate_, FOUND=found, IERR=ierr )
      IF ( found .and. ( ierr /= 0 ) ) RETURN
      !
      CALL iotk_scan_dat( iunit, "RELAX_Z", relaxz_, FOUND=found, IERR=ierr )
      IF ( found .and. ( ierr /= 0 ) ) RETURN
      !
      CALL iotk_scan_dat( iunit, "BLOCK", block_, FOUND=found, IERR=ierr )
      IF ( found .and. ( ierr /= 0 ) ) RETURN
      !
      CALL iotk_scan_dat( iunit, "BLOCK_1", block_1_, FOUND=found, IERR=ierr )
      IF ( found .and. ( ierr /= 0 ) ) RETURN
      !
      CALL iotk_scan_dat( iunit, "BLOCK_2", block_2_, FOUND=found, IERR=ierr )
      IF ( found .and. ( ierr /= 0 ) ) RETURN
      !
      CALL iotk_scan_dat( iunit, "BLOCK_HEIGHT", block_height_, FOUND=found, IERR=ierr )
      IF ( found .and. ( ierr /= 0 ) ) RETURN
      !
      CALL iotk_scan_end( iunit, "ELECTRIC_FIELD", IERR=ierr )
      IF ( ierr /= 0 ) RETURN
      !
      !
      IF ( present(tefield) )        tefield      = tefield_
      IF ( present(dipfield) )       dipfield     = dipfield_
      IF ( present(edir) )           edir         = edir_
      IF ( present(emaxpos) )        emaxpos      = emaxpos_
      IF ( present(eopreg) )         eopreg       = eopreg_
      IF ( present(eamp) )           eamp         = eamp_
      IF ( present(gate) )           gate         = gate_
      IF ( present(zgate) )          zgate        = zgate_
      IF ( present(relaxz) )         relaxz       = relaxz_
      IF ( present(block) )          block        = block_
      IF ( present(block_1) )        block_1      = block_1_
      IF ( present(block_2) )        block_2      = block_2_
      IF ( present(block_height) )   block_height = block_height_
      !
    END SUBROUTINE qexml_read_efield
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_read_exx( x_gamma_extrapolation, nqx1, nqx2, nqx3, &
                          exxdiv_treatment, yukawa, ecutvcut, exx_fraction, &
                          screening_parameter, gau_parameter, exx_is_active, ecutfock, &
                          found, ierr )
      !----------------------------------------------------------------------
      !
      IMPLICIT NONE
      !
      LOGICAL,          OPTIONAL, INTENT(OUT) :: x_gamma_extrapolation, exx_is_active
      INTEGER,          OPTIONAL, INTENT(OUT) :: nqx1, nqx2, nqx3
      CHARACTER(LEN=*), OPTIONAL, INTENT(OUT) :: exxdiv_treatment
      REAL(DP),         OPTIONAL, INTENT(OUT) :: yukawa, ecutvcut, exx_fraction
      REAL(DP),         OPTIONAL, INTENT(OUT) :: screening_parameter, ecutfock
      REAL(DP),         OPTIONAL, INTENT(OUT) :: gau_parameter
      LOGICAL,                    INTENT(out) :: found
      INTEGER,                    INTENT(out) :: ierr
      !
      LOGICAL  :: x_gamma_extrapolation_, exx_is_active_
      INTEGER  :: nqx1_, nqx2_, nqx3_
      REAL(DP) :: yukawa_, ecutvcut_, exx_fraction_
      REAL(DP) :: screening_parameter_, ecutfock_
      REAL(DP) :: gau_parameter_
      CHARACTER(LEN=80) :: exxdiv_treatment_
      !
      !
      ierr = 0
      !
      CALL iotk_scan_begin( iunit, "EXACT_EXCHANGE", FOUND=found, IERR=ierr )
      IF ( ( .NOT. found ).OR.( ierr /= 0 ) ) RETURN
      !
      call iotk_scan_dat(iunit, "x_gamma_extrapolation", x_gamma_extrapolation_, IERR=ierr)
      IF ( ierr /= 0 ) RETURN
      !
      call iotk_scan_dat(iunit, "nqx1", nqx1_, IERR=ierr)
      IF ( ierr /= 0 ) RETURN
      !
      call iotk_scan_dat(iunit, "nqx2", nqx2_, IERR=ierr)
      IF ( ierr /= 0 ) RETURN
      !
      call iotk_scan_dat(iunit, "nqx3", nqx3_, IERR=ierr)
      IF ( ierr /= 0 ) RETURN
      !
      call iotk_scan_dat(iunit, "exxdiv_treatment", exxdiv_treatment_, IERR=ierr)
      IF ( ierr /= 0 ) RETURN
      !
      call iotk_scan_dat(iunit, "yukawa", yukawa_, IERR=ierr)
      IF ( ierr /= 0 ) RETURN
      !
      call iotk_scan_dat(iunit, "ecutvcut", ecutvcut_, IERR=ierr)
      IF ( ierr /= 0 ) RETURN
      !
      call iotk_scan_dat(iunit, "exx_fraction", exx_fraction_, IERR=ierr)
      IF ( ierr /= 0 ) RETURN
      !
      call iotk_scan_dat(iunit, "screening_parameter", screening_parameter_, IERR=ierr)
      IF ( ierr /= 0 ) RETURN
      !
      ! Check if existing, for back-compatibility
      call iotk_scan_dat(iunit, "gau_parameter", gau_parameter_, FOUND=found, IERR=ierr)
      IF ( .NOT. found )  gau_parameter_=0.0_dp
      IF ( ierr /= 0 ) RETURN
      !
      call iotk_scan_dat(iunit, "exx_is_active", exx_is_active_, IERR=ierr)
      IF ( ierr /= 0 ) RETURN
      !
      ! Check if existing, for back-compatibility
      call iotk_scan_dat(iunit, "ecutfock", ecutfock_, IERR=ierr, FOUND=found)
      IF ( .NOT. found )  ecutfock_=-1.0_dp
      IF ( ierr /= 0 ) RETURN
      !
      CALL iotk_scan_end(iunit, "EXACT_EXCHANGE", IERR=ierr)
      IF ( ierr /= 0 ) RETURN
      !
      !
      IF ( present(x_gamma_extrapolation) ) x_gamma_extrapolation = x_gamma_extrapolation_
      IF ( present(nqx1) )                                   nqx1 = nqx1_
      IF ( present(nqx2) )                                   nqx2 = nqx2_
      IF ( present(nqx3) )                                   nqx3 = nqx3_
      IF ( present(exxdiv_treatment) )           exxdiv_treatment = exxdiv_treatment_
      IF ( present(yukawa) )                               yukawa = yukawa_
      IF ( present(ecutvcut) )                           ecutvcut = ecutvcut_
      IF ( present(exx_fraction) )                   exx_fraction = exx_fraction_
      IF ( present(screening_parameter) )     screening_parameter = screening_parameter_
      IF ( present(ecutfock) )                           ecutfock = ecutfock_
      IF ( present(gau_parameter) )                 gau_parameter = gau_parameter_
      IF ( present(exx_is_active) )                 exx_is_active = exx_is_active_
      !
      found = .TRUE.
      !
    END SUBROUTINE qexml_read_exx
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_read_esm( esm_nfit, esm_efield, esm_w, esm_a, esm_bc, ierr )
      !----------------------------------------------------------------------
      !
      IMPLICIT NONE
      !
      INTEGER,          OPTIONAL, INTENT(OUT) :: esm_nfit
      REAL(DP),         OPTIONAL, INTENT(OUT) :: esm_efield, esm_w, esm_a
      CHARACTER(LEN=*), OPTIONAL, INTENT(OUT) :: esm_bc
      INTEGER,                    INTENT(out) :: ierr
      !
      INTEGER  :: esm_nfit_
      REAL(DP) :: esm_efield_, esm_w_, esm_a_
      CHARACTER(LEN=3) :: esm_bc_
      !
      !
      ierr = 0
      !
      CALL iotk_scan_begin( iunit, "ESM", IERR=ierr )
      IF ( ierr /= 0 ) RETURN
      !
      call iotk_scan_dat(iunit, "esm_nfit", esm_nfit_, IERR=ierr)
      IF ( ierr /= 0 ) RETURN
      !
      call iotk_scan_dat(iunit, "esm_efield", esm_efield_, IERR=ierr)
      IF ( ierr /= 0 ) RETURN
      !
      call iotk_scan_dat(iunit, "esm_w", esm_w_, IERR=ierr)
      IF ( ierr /= 0 ) RETURN
      !
      call iotk_scan_dat(iunit, "esm_a", esm_a_, IERR=ierr)
      IF ( ierr /= 0 ) RETURN
      !
      call iotk_scan_dat(iunit, "esm_bc", esm_bc_, IERR=ierr)
      IF ( ierr /= 0 ) RETURN
      !
      CALL iotk_scan_end(iunit, "ESM", IERR=ierr)
      IF ( ierr /= 0 ) RETURN
      !
      !
      IF ( present(esm_nfit) )    esm_nfit    = esm_nfit_
      IF ( present(esm_efield) )  esm_efield  = esm_efield_
      IF ( present(esm_w) )       esm_w       = esm_w_
      IF ( present(esm_a) )       esm_a       = esm_a_
      IF ( present(esm_bc) )      esm_bc      = esm_bc_
      !
    END SUBROUTINE qexml_read_esm
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_read_planewaves( ecutwfc, ecutrho, npwx, gamma_only, &
                                      nr1, nr2, nr3,  ngm,  nr1s, nr2s, nr3s, ngms, &
                                      nr1b, nr2b, nr3b,  igv, cutoff_units, ierr )
      !------------------------------------------------------------------------
      !
      !
      INTEGER,      OPTIONAL, INTENT(out) :: npwx, nr1, nr2, nr3, ngm, &
                                             nr1s, nr2s, nr3s, ngms, nr1b, nr2b, nr3b
      INTEGER,      OPTIONAL, INTENT(out) :: igv(:,:)
      REAL(DP),     OPTIONAL, INTENT(out) :: ecutwfc, ecutrho
      LOGICAL,      OPTIONAL, INTENT(out) :: gamma_only
      CHARACTER(*), OPTIONAL, INTENT(out) :: cutoff_units
      INTEGER,                INTENT(out) :: ierr
      !
      INTEGER        :: npwx_, nr1_, nr2_, nr3_, ngm_, &
                        nr1s_, nr2s_, nr3s_, ngms_, nr1b_, nr2b_, nr3b_
      REAL(DP)       :: ecutwfc_, ecutrho_
      CHARACTER(256) :: cutoff_units_
      LOGICAL        :: gamma_only_
      !
      ierr = 0
      !
      CALL iotk_scan_begin( iunit, "PLANE_WAVES", IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_empty( iunit, "UNITS_FOR_CUTOFF", ATTR=attr, IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_attr( attr, "UNITS", cutoff_units_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat( iunit, "WFC_CUTOFF", ecutwfc_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat( iunit, "RHO_CUTOFF", ecutrho_ , IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat( iunit, "MAX_NUMBER_OF_GK-VECTORS", npwx_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat( iunit, "GAMMA_ONLY", gamma_only_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_empty( iunit, "FFT_GRID", ATTR = attr, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_attr( attr, "nr1", nr1_, IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_attr( attr, "nr2", nr2_, IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_attr( attr, "nr3", nr3_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat( iunit, "GVECT_NUMBER", ngm_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_empty( iunit, "SMOOTH_FFT_GRID", ATTR = attr, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_attr( attr, "nr1s", nr1s_, IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_attr( attr, "nr2s", nr2s_, IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_attr( attr, "nr3s", nr3s_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat( iunit, "SMOOTH_GVECT_NUMBER", ngms_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      !
      IF ( present( igv ) ) THEN
          !
          CALL iotk_scan_begin( iunit, "G-VECTORS", IERR=ierr )
          IF (ierr/=0) RETURN
          !
          CALL iotk_scan_dat( iunit, "g", igv(1:3,1:ngm_), IERR=ierr )
          IF (ierr/=0) RETURN
          !
          CALL iotk_scan_end( iunit, "G-VECTORS", IERR=ierr )
          IF (ierr/=0) RETURN
          !
      ENDIF
      !
      !
      CALL iotk_scan_empty( iunit, "SMALLBOX_FFT_GRID", ATTR = attr, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_attr( attr, "nr1b", nr1b_, IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_attr( attr, "nr2b", nr2b_, IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_attr( attr, "nr3b", nr3b_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_end( iunit, "PLANE_WAVES", IERR=ierr )
      IF (ierr/=0) RETURN
      !
      !
      IF ( present( ecutwfc ) )           ecutwfc      = ecutwfc_
      IF ( present( ecutrho ) )           ecutrho      = ecutrho_
      IF ( present( npwx ) )              npwx         = npwx_
      IF ( present( gamma_only ) )        gamma_only   = gamma_only_
      IF ( present( nr1 ) )               nr1          = nr1_
      IF ( present( nr2 ) )               nr2          = nr2_
      IF ( present( nr3 ) )               nr3          = nr3_
      IF ( present( ngm ) )               ngm          = ngm_
      IF ( present( nr1s ) )              nr1s         = nr1s_
      IF ( present( nr2s ) )              nr2s         = nr2s_
      IF ( present( nr3s ) )              nr3s         = nr3s_
      IF ( present( ngms ) )              ngms         = ngms_
      IF ( present( nr1b ) )              nr1b         = nr1b_
      IF ( present( nr2b ) )              nr2b         = nr2b_
      IF ( present( nr3b ) )              nr3b         = nr3b_
      IF ( present( cutoff_units ) )      cutoff_units = trim( cutoff_units_ )
      !
    END SUBROUTINE qexml_read_planewaves
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_read_gk( ik, npwk, npwkx, gamma_only, xk, k_units, index, igk, ierr )
      !------------------------------------------------------------------------
      !
      INTEGER,                INTENT(in)  :: ik
      INTEGER,      OPTIONAL, INTENT(out) :: npwk, npwkx
      LOGICAL,      OPTIONAL, INTENT(out) :: gamma_only
      REAL(DP),     OPTIONAL, INTENT(out) :: xk(3)
      CHARACTER(*), OPTIONAL, INTENT(out) :: k_units
      INTEGER,      OPTIONAL, INTENT(out) :: igk(:,:), index(:)
      INTEGER,                INTENT(out) :: ierr
      !
      CHARACTER(256) :: filename, k_units_
      INTEGER   :: npwk_, npwkx_
      LOGICAL   :: gamma_only_
      REAL(DP) :: xk_(3)
      INTEGER   :: iunaux
      !

      ierr = 0
      !
      CALL iotk_free_unit( iunaux )
      filename = qexml_wfc_filename( datadir_in, 'gkvectors', ik )
      !
      CALL iotk_open_read ( iunaux, FILE = trim(filename), IERR=ierr )
      IF (ierr/=0)  RETURN
      !
      CALL iotk_scan_dat( iunaux, 'NUMBER_OF_GK-VECTORS', npwk_, IERR=ierr)
      IF (ierr/=0)  RETURN
      !
      CALL iotk_scan_dat( iunaux, 'MAX_NUMBER_OF_GK-VECTORS', npwkx_, IERR=ierr)
      IF (ierr/=0)  RETURN
      !
      IF ( qexml_version_before_1_4_0 ) THEN
         !
         IF ( present( gamma_only ) ) THEN
             !
             CALL qexml_read_planewaves( GAMMA_ONLY=gamma_only_, IERR=ierr)
             IF (ierr/=0)  RETURN
             !
         ENDIF
         !
      ELSE
         !
         CALL iotk_scan_dat( iunaux, 'GAMMA_ONLY', gamma_only_, IERR=ierr)
         IF (ierr/=0)  RETURN
         !
      ENDIF
      !
      CALL iotk_scan_dat( iunaux, 'K-POINT_COORDS', xk_, ATTR=attr, IERR=ierr)
      IF (ierr/=0)  RETURN
      CALL iotk_scan_attr( attr, 'UNITS', k_units_, IERR=ierr)
      IF (ierr/=0)  RETURN
      !
      IF ( present( index ) ) THEN
          !
          CALL iotk_scan_dat( iunaux, 'INDEX', index(1:npwk_), IERR=ierr)
          IF (ierr/=0)  RETURN
          !
      ENDIF
      !
      IF ( present( igk ) ) THEN
          !
          CALL iotk_scan_dat( iunaux, 'GRID', igk(1:3, 1:npwk_), IERR=ierr)
          IF (ierr/=0)  RETURN
          !
      ENDIF
      !
      CALL iotk_close_read ( iunaux, IERR=ierr )
      IF (ierr/=0)  RETURN
      !
      !
      IF ( present( npwk ) )       npwk          = npwk_
      IF ( present( npwkx ) )      npwkx         = npwkx_
      IF ( present( gamma_only ) ) gamma_only    = gamma_only_
      IF ( present( xk ) )         xk(1:3)       = xk_(1:3)
      IF ( present( k_units ) )    k_units       = trim(k_units_)
      !
    END SUBROUTINE qexml_read_gk
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_read_spin( lsda, noncolin, npol, lspinorb, domag, ierr )
      !------------------------------------------------------------------------
      !
      LOGICAL, OPTIONAL, INTENT(out) :: lsda, noncolin, lspinorb, domag
      INTEGER, OPTIONAL, INTENT(out) :: npol
      INTEGER,           INTENT(out) :: ierr
      !
      LOGICAL   :: lsda_, noncolin_, lspinorb_, domag_,found
      INTEGER   :: npol_
      !

      ierr = 0
      !
      CALL iotk_scan_begin( iunit, "SPIN", IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat( iunit, "LSDA", lsda_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat( iunit, "NON-COLINEAR_CALCULATION", noncolin_, IERR=ierr, FOUND=found )
      IF (ierr/=0) RETURN
      IF ( .not. found ) noncolin_ = .FALSE.
      !
      npol_ = 1
      !
      IF ( noncolin_ ) THEN
          !
          CALL iotk_scan_dat( iunit, "SPINOR_DIM", npol_, IERR=ierr )
          IF (ierr/=0) RETURN
          !
      ENDIF
      !
      CALL iotk_scan_dat( iunit, "SPIN-ORBIT_CALCULATION", lspinorb_, IERR=ierr, FOUND=found )
      IF (ierr/=0) RETURN
      IF ( .NOT. found ) lspinorb_ = .FALSE.
      !
      CALL iotk_scan_dat( iunit, "SPIN-ORBIT_DOMAG", domag_, IERR=ierr, FOUND=found )
      IF ( .NOT. found ) domag_ = .FALSE.
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_end( iunit, "SPIN", IERR=ierr )
      IF (ierr/=0) RETURN
      !
      !
      IF ( present( lsda ) )       lsda      = lsda_
      IF ( present( noncolin ) )   noncolin  = noncolin_
      IF ( present( npol ) )       npol      = npol_
      IF ( present( lspinorb ) )   lspinorb  = lspinorb_
      IF ( present( domag ) )      domag     = domag_
      !

    END SUBROUTINE qexml_read_spin
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_read_xc( dft, lda_plus_u, lda_plus_u_kind, U_projection, &
                              Hubbard_lmax, Hubbard_l, nsp, Hubbard_U, Hubbard_J,&
                              Hubbard_J0, Hubbard_alpha, Hubbard_beta, &
                              inlc, vdw_table_name, acfdt_in_pw, llondon, london_s6, &
                              london_rcut, london_c6, london_rvdw, &
                              lxdm, ts_vdw, vdw_isolated, ierr )
      !----------------------------------------------------------------------
      !
      CHARACTER(len=*), OPTIONAL, INTENT(out) :: dft
      LOGICAL,          OPTIONAL, INTENT(out) :: lda_plus_u
      INTEGER,          OPTIONAL, INTENT(out) :: lda_plus_u_kind
      !
      INTEGER,          OPTIONAL, INTENT(out) :: Hubbard_lmax
      INTEGER,          OPTIONAL, INTENT(out) :: Hubbard_l(:)
      INTEGER,          OPTIONAL, INTENT(out) :: nsp
      REAL(DP),         OPTIONAL, INTENT(out) :: Hubbard_U(:), Hubbard_J(:,:),&
                                                 Hubbard_alpha(:), &
                                                 Hubbard_J0(:), Hubbard_beta(:)
      INTEGER,          OPTIONAL, INTENT(out) :: inlc
      CHARACTER(LEN=*), OPTIONAL, INTENT(out) :: U_projection
      CHARACTER(LEN=*), OPTIONAL, INTENT(out) :: vdw_table_name
      LOGICAL,          OPTIONAL, INTENT(out) :: acfdt_in_pw
      LOGICAL,  OPTIONAL, INTENT(out) :: llondon, lxdm, ts_vdw, vdw_isolated
      REAL(DP), OPTIONAL, INTENT(out) :: london_s6, london_rcut, london_c6(:), london_rvdw(:)
      !
      INTEGER,                    INTENT(out) :: ierr
      !
      CHARACTER(LEN=256)      :: dft_, vdw_table_name_, U_projection_
      LOGICAL                 :: lda_plus_u_, found, found_nsp
      LOGICAL                 :: acfdt_in_pw_
      INTEGER                 :: Hubbard_lmax_, nsp_,lda_plus_u_kind_, inlc_
      INTEGER,    ALLOCATABLE :: Hubbard_l_(:)
      REAL(DP),   ALLOCATABLE :: Hubbard_U_(:), Hubbard_J_(:,:)
      REAL(DP),   ALLOCATABLE :: Hubbard_alpha_(:), Hubbard_J0_(:), Hubbard_beta_(:)
      LOGICAL                 :: llondon_, lxdm_, ts_vdw_, vdw_isolated_
      REAL(DP)                :: london_s6_=0._dp, london_rcut_=0._dp
      REAL(DP),   ALLOCATABLE :: london_c6_(:), london_rvdw_(:)
      !
      ierr = 0
      !
      !
      CALL iotk_scan_begin( iunit, "EXCHANGE_CORRELATION", IERR=ierr )
      IF ( ierr/=0 ) RETURN
      !
      CALL iotk_scan_dat( iunit, "DFT", dft_, IERR=ierr )
      IF ( ierr/=0 ) RETURN
      !
      CALL iotk_scan_dat( iunit, "NUMBER_OF_SPECIES", nsp_, FOUND=found_nsp, IERR=ierr )
      IF ( ierr/=0 ) RETURN
      !
      CALL iotk_scan_dat( iunit, "LDA_PLUS_U_CALCULATION", lda_plus_u_, FOUND=found, IERR=ierr )
      IF ( ierr/=0 ) RETURN
      IF ( .NOT. found ) lda_plus_u_ = .FALSE.
      !
      IF ( lda_plus_u_ ) THEN
         !
         IF ( .not.found_nsp ) RETURN
         !
         CALL iotk_scan_dat( iunit, "HUBBARD_LMAX", Hubbard_lmax_, IERR=ierr )
         IF ( ierr/=0 ) RETURN
         !
         ALLOCATE( Hubbard_l_(1:nsp_) )
         ALLOCATE( Hubbard_U_(nsp_) )
         !
         CALL iotk_scan_dat( iunit, "HUBBARD_L", Hubbard_l_, IERR=ierr )
         IF ( ierr/=0 ) RETURN
         !
         CALL iotk_scan_dat( iunit, "HUBBARD_U", Hubbard_U_, IERR=ierr )
         IF ( ierr/=0 ) RETURN
         !
         IF ( PRESENT (lda_plus_u_kind) ) THEN
            CALL iotk_scan_dat( iunit, "LDA_PLUS_U_KIND", lda_plus_u_kind_, FOUND = found, IERR=ierr )
            IF ( ierr/=0 ) RETURN
         END IF
         !
         IF ( PRESENT (U_projection) ) THEN
            CALL iotk_scan_dat( iunit, "U_PROJECTION_TYPE", U_projection_, FOUND = found, IERR=ierr )
            IF ( ierr/=0 ) RETURN
            IF ( .NOT. found ) U_projection_='atomic' ! for compatibility
         END IF
         !
         IF ( PRESENT (Hubbard_J) ) THEN
            ALLOCATE( Hubbard_J_(3,nsp_) )
            CALL iotk_scan_dat( iunit, "HUBBARD_J", Hubbard_J_, FOUND = found, IERR=ierr )
            IF ( ierr/=0 ) RETURN
         END IF
         !
         IF ( PRESENT (Hubbard_J0) ) THEN
            ALLOCATE( Hubbard_J0_(nsp_) )
            CALL iotk_scan_dat( iunit, "HUBBARD_J0", Hubbard_J0_, FOUND = found, IERR=ierr )
            IF ( ierr/=0 ) RETURN
         END IF
         !
         IF ( PRESENT (Hubbard_alpha) ) THEN
            ALLOCATE( Hubbard_alpha_(nsp_) )
            CALL iotk_scan_dat( iunit, "HUBBARD_ALPHA", Hubbard_alpha_, FOUND = found, IERR=ierr )
            IF ( ierr/=0 ) RETURN
         END IF
         !
         IF ( PRESENT (Hubbard_beta) ) THEN
            ALLOCATE( Hubbard_beta_(nsp_) )
            CALL iotk_scan_dat( iunit, "HUBBARD_BETA", Hubbard_beta_, FOUND = found, IERR=ierr )
            IF ( ierr/=0 ) RETURN
         END IF
         !
      ENDIF
      !
      CALL iotk_scan_dat( iunit, "NON_LOCAL_DF", inlc_, FOUND = found )
      IF ( found ) THEN
         !
         IF ( inlc_ > 0 ) CALL iotk_scan_dat( iunit, "VDW_KERNEL_NAME", vdw_table_name_ )
         !
      ELSE
         !
         inlc_ = 0
         vdw_table_name_ = ' '
         !
      ENDIF
      !
      CALL iotk_scan_dat( iunit, "ACFDT_IN_PW", acfdt_in_pw_, FOUND=found, IERR=ierr )
      IF ( ierr/=0 ) RETURN
      IF ( .NOT. found ) acfdt_in_pw_ = .FALSE.
!      IF (acfdt_in_pw) dft_name = 'NOX NOC NOGX NOGC'
      !
      CALL iotk_scan_dat( iunit, "ACFDT_IN_PW", acfdt_in_pw_, FOUND=found, IERR=ierr )
      IF ( ierr/=0 ) RETURN
      IF ( .NOT. found ) acfdt_in_pw_ = .FALSE.
!      IF (acfdt_in_pw) dft_name = 'NOX NOC NOGX NOGC'
      !
      CALL iotk_scan_begin( iunit, "DFT_D2", FOUND=found, IERR=ierr )
      IF ( ierr/=0 ) RETURN
      llondon_ = found
      IF ( llondon_ ) THEN
         !         
         IF ( .not. found_nsp ) RETURN
         !
         ALLOCATE( london_c6_(nsp_) )
         ALLOCATE( london_rvdw_(nsp_) )
         !
         london_c6_(:) = -1.0_DP
         london_rvdw_(:) = -1.0_DP
         !
         CALL iotk_scan_dat( iunit, "SCALING_FACTOR", london_s6_ )
         CALL iotk_scan_dat( iunit, "CUTOFF_RADIUS",  london_rcut_)
         CALL iotk_scan_dat( iunit, "C6",             london_c6_ )
         CALL iotk_scan_dat( iunit, "RADIUS_VDW",     london_rvdw_ )
         CALL iotk_scan_end( iunit, "DFT_D2" )
      ENDIF
      !
      CALL iotk_scan_dat( iunit, "XDM", lxdm_, FOUND = found, IERR=ierr )
      IF ( ierr/=0 ) RETURN
      IF (.NOT. found) lxdm_ = .FALSE.
      !
      CALL iotk_scan_begin( iunit,"TKATCHENKO-SCHEFFLER", FOUND=found, IERR=ierr )
      IF ( ierr/=0 ) RETURN
      ts_vdw_ = found
      IF ( ts_vdw_ ) THEN
         CALL iotk_scan_dat( iunit, "ISOLATED_SYSTEM", vdw_isolated_ )
         CALL iotk_scan_end( iunit, "TKATCHENKO-SCHEFFLER" )
      END IF
      !
      CALL iotk_scan_end( iunit, "EXCHANGE_CORRELATION", IERR=ierr )
      IF ( ierr/=0 ) RETURN
      !
      IF ( present( dft ) )           dft           = dft_
      IF ( present( lda_plus_u ) )    lda_plus_u    = lda_plus_u_
      !
      IF ( lda_plus_u_ )  THEN
         !
         IF ( present( nsp ) )             nsp                   = nsp_
         IF ( present( lda_plus_u_kind ) ) lda_plus_u_kind       = lda_plus_u_kind_
         IF ( present( U_projection ) )    U_projection          = U_projection_
         IF ( present( Hubbard_lmax ) )    Hubbard_lmax          = Hubbard_lmax_
         IF ( present( Hubbard_l ) )       Hubbard_l(1:nsp_)     = Hubbard_l_(:)
         IF ( present( Hubbard_U ) )       Hubbard_U(1:nsp_)     = Hubbard_U_(1:nsp_)
         IF ( present( Hubbard_J ) )       Hubbard_J(1:3,1:nsp_) = Hubbard_J_(1:3,1:nsp_)
         IF ( present( Hubbard_J0 ) )      Hubbard_J0(1:nsp_)    = Hubbard_J0_(1:nsp_)
         IF ( present( Hubbard_alpha ) )   Hubbard_alpha(1:nsp_) = Hubbard_alpha_(1:nsp_)
         IF ( present( Hubbard_beta )  )   Hubbard_beta(1:nsp_)  = Hubbard_beta_(1:nsp_)
         !
         DEALLOCATE( Hubbard_l_ )
         DEALLOCATE( Hubbard_U_ )
         DEALLOCATE( Hubbard_J_ )
         DEALLOCATE( Hubbard_J0_ )
         DEALLOCATE( Hubbard_alpha_ )
         DEALLOCATE( Hubbard_beta_ )
         !
      ENDIF
      !
      IF (present(inlc) ) inlc = inlc_
      IF (present( vdw_table_name) )  vdw_table_name =  vdw_table_name_
      !
      IF ( present( acfdt_in_pw ) )    acfdt_in_pw    = acfdt_in_pw_
      IF (present(llondon) ) THEN
         llondon = llondon_
         IF (present(london_s6) )   london_s6   = london_s6_
         IF (present(london_rcut) ) london_rcut = london_rcut_
         IF ( llondon ) THEN
            !
            IF (present(london_c6) )   london_c6(1:nsp_)  =london_c6_(1:nsp_)
            IF (present(london_rvdw) ) london_rvdw(1:nsp_)=london_rvdw_(1:nsp_)
            DEALLOCATE( london_c6_ )
            DEALLOCATE( london_rvdw_ )
           !
        END IF
        !
      ELSE IF (present(lxdm) ) THEN
         lxdm = lxdm_
      ELSE IF (present(ts_vdw) ) THEN
         ts_vdw = ts_vdw_
         IF (present(vdw_isolated) ) vdw_isolated=vdw_isolated_
      END IF
      !
    END SUBROUTINE qexml_read_xc
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_read_occ( lgauss, ngauss, degauss, degauss_units, &
                               ltetra, tetra_type, ntetra, tetra, tfixed_occ, &
                               nstates_up, nstates_dw, input_occ, ierr )
      !------------------------------------------------------------------------
      !
      LOGICAL,      OPTIONAL, INTENT(out) :: lgauss, ltetra, tfixed_occ
      INTEGER,      OPTIONAL, INTENT(out) :: ngauss, ntetra, tetra_type
      INTEGER,      OPTIONAL, INTENT(out) :: tetra(:,:)
      INTEGER,      OPTIONAL, INTENT(out) :: nstates_up, nstates_dw
      REAL(DP),     OPTIONAL, INTENT(out) :: degauss, input_occ(:,:)
      CHARACTER(*), OPTIONAL, INTENT(out) :: degauss_units
      INTEGER,                INTENT(out) :: ierr
      !
      LOGICAL        :: lgauss_, ltetra_, tfixed_occ_
      INTEGER        :: ngauss_, ntetra_, nstates_up_, nstates_dw_, tetra_type_
      LOGICAL        :: lsda_
      REAL(DP)      :: degauss_
      CHARACTER(256) :: degauss_units_
      INTEGER,  ALLOCATABLE :: tetra_(:,:)
      INTEGER :: i
      LOGICAL :: lfound,found
      !
      ierr = 0
      !
      CALL iotk_scan_begin( iunit, "OCCUPATIONS", IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat( iunit, "SMEARING_METHOD", lgauss_, FOUND=found, IERR=ierr )
      IF (ierr/=0) RETURN
      IF ( .NOT. found ) lgauss_ = .FALSE.
      !
      !
      ngauss_=0
      degauss_=-1.0d0 
      degauss_units_="none"
      !
      IF ( lgauss_ ) THEN
         !
         CALL iotk_scan_dat( iunit, "SMEARING_TYPE", ngauss_, IERR=ierr )
         IF (ierr/=0) RETURN
         !
         CALL iotk_scan_dat( iunit, "SMEARING_PARAMETER", degauss_ , &
                                     ATTR=attr, IERR=ierr )
         IF (ierr/=0) RETURN
         !
         CALL iotk_scan_attr( ATTR, "UNITS", degauss_units_, IERR=ierr )
         IF (ierr/=0) RETURN
         !
      ENDIF
      !
      CALL iotk_scan_dat( iunit, "TETRAHEDRON_METHOD", ltetra_, FOUND=found, IERR=ierr )
      IF (ierr/=0) RETURN
      IF ( .NOT. found ) ltetra_ = .FALSE.
      !
      !
      ntetra_ = 0
      IF ( ltetra_ ) THEN
         !
         CALL iotk_scan_dat( iunit, "NUMBER_OF_TETRAHEDRA", ntetra_, IERR=ierr )
         IF (ierr/=0) RETURN
         !
         CALL iotk_scan_dat( iunit, "TETRAHEDRON_TYPE", tetra_type_, IERR=ierr )
         !
         IF(tetra_type_ == 0) then
            !
            ALLOCATE( tetra_(4, ntetra_) )
            !
            DO i = 1, ntetra_
               !
               CALL iotk_scan_dat( iunit, "TETRAHEDRON"//iotk_index(i), &
                                               tetra_(1:4,i), IERR=ierr )
               IF (ierr/=0) RETURN
               !
            ENDDO
            !
         END IF
         !
      ENDIF
      !
      CALL iotk_scan_dat( iunit, "FIXED_OCCUPATIONS", tfixed_occ_, FOUND=found, IERR=ierr )
      IF (ierr/=0) RETURN
      IF ( .NOT. found ) tfixed_occ_ = .FALSE.
      !
      nstates_up_=0.0d0
      nstates_dw_=0.0d0
      !
      IF ( tfixed_occ_  .and. ( present(input_occ)   .or. &
                                present(nstates_up)  .or. present(nstates_dw) ) ) THEN
         !
         CALL iotk_scan_empty( iunit, "INFO", ATTR=attr, IERR=ierr)
         IF (ierr /=0 ) RETURN
         !
         CALL iotk_scan_attr( attr, "lsda", lsda_, IERR=ierr )
         IF (ierr /=0 ) RETURN
         !
         IF ( qexml_version_before_1_4_0 ) THEN
            !
            CALL iotk_scan_attr( attr, "nelup", nstates_up_, IERR=ierr )
            IF (ierr /=0 ) RETURN
            CALL iotk_scan_attr( attr, "neldw", nstates_dw_, IERR=ierr )
            IF (ierr /=0 ) RETURN
            !
         ELSE
            !
            ! current version
            !
            CALL iotk_scan_attr( attr, "nstates_up", nstates_up_, IERR=ierr )
            IF (ierr /=0 ) RETURN
            CALL iotk_scan_attr( attr, "nstates_down", nstates_dw_, IERR=ierr )
            IF (ierr /=0 ) RETURN
            !
         ENDIF
         !
         IF ( present( input_occ ) ) THEN
            !
            !
            CALL iotk_scan_dat( iunit, "INPUT_OCC_UP", input_occ(1:nstates_up_,1), IERR=ierr )
            IF (ierr/=0) RETURN
            !
            IF ( lsda_  ) THEN
               !
               CALL iotk_scan_dat( iunit, "INPUT_OCC_DOWN", input_occ(1:nstates_dw_,2), IERR=ierr )
               IF (ierr/=0) RETURN
               !
            ENDIF
            !
         ENDIF
         !
      ENDIF
      !
      CALL iotk_scan_end( iunit, "OCCUPATIONS", IERR=ierr )
      IF (ierr/=0) RETURN
      !
      !
      IF ( present( lgauss ))           lgauss      = lgauss_
      IF ( present( ltetra ))           ltetra      = ltetra_
      IF ( present( tfixed_occ ))       tfixed_occ  = tfixed_occ_
      IF ( present( ngauss ))           ngauss      = ngauss_
      IF ( present( ntetra ))           ntetra      = ntetra_
      IF ( present( tetra_type ) .and. ltetra_)       tetra_type  = tetra_type_
      IF ( present( degauss ))          degauss     = degauss_
      IF ( present( degauss_units ))    degauss_units  = trim(degauss_units_)
      IF ( present( nstates_up ))       nstates_up  = nstates_up_
      IF ( present( nstates_dw ))       nstates_dw  = nstates_dw_
      !
      IF ( ltetra_ .and. (tetra_type_ == 0)) THEN
         !
         IF ( present( tetra ) )         tetra(1:4, 1:ntetra_)  = tetra_
         !
         DEALLOCATE( tetra_ )
         !
      ENDIF

    END SUBROUTINE qexml_read_occ
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_read_bz( num_k_points, xk, wk, k1, k2, k3, nk1, nk2, nk3, &
                              nks_start, xk_start, wk_start, qnorm, &
                              k_units, ierr )
      !------------------------------------------------------------------------
      !
      INTEGER,       OPTIONAL, INTENT(out) :: num_k_points, k1, k2, k3, nk1, nk2, nk3, &
                                              nks_start
      REAL(DP),     OPTIONAL, INTENT(out) :: xk(:,:), wk(:), qnorm
      REAL(DP),     OPTIONAL, ALLOCATABLE, INTENT(out) :: xk_start(:,:), wk_start(:)
      CHARACTER(*),  OPTIONAL, INTENT(out) :: k_units
      INTEGER,                 INTENT(out) :: ierr
      !
      INTEGER                :: num_k_points_, k1_, k2_, k3_, nk1_, nk2_, nk3_,nks_start_
      CHARACTER(256)         :: k_units_
      REAL(DP)               :: qnorm_
      REAL(DP), ALLOCATABLE  :: xk_(:,:), wk_(:)
      REAL(DP), ALLOCATABLE  :: xk_start_(:,:), wk_start_(:)
      !
      INTEGER :: ik, i
      LOGICAL :: found
      !
      ierr = 0
      !
      CALL iotk_scan_begin( iunit, "BRILLOUIN_ZONE", IERR=ierr )
      IF ( ierr/=0 ) RETURN
      !
      CALL iotk_scan_dat( iunit, "NUMBER_OF_K-POINTS", num_k_points_, IERR=ierr )
      IF ( ierr/=0 ) RETURN
      !
      !
      CALL iotk_scan_empty( iunit, "UNITS_FOR_K-POINTS", ATTR=attr, IERR=ierr )
      IF ( ierr/=0 ) RETURN
      CALL iotk_scan_attr( attr, "UNITS", k_units_, IERR=ierr )
      IF ( ierr/=0 ) RETURN
      !
      CALL iotk_scan_empty( iunit, "MONKHORST_PACK_GRID", ATTR=attr, IERR=ierr )
      IF ( ierr/=0 ) RETURN
      !
      CALL iotk_scan_attr( attr, "nk1", nk1_, IERR=ierr  )
      IF ( ierr/=0 ) RETURN
      CALL iotk_scan_attr( attr, "nk2", nk2_, IERR=ierr )
      IF ( ierr/=0 ) RETURN
      CALL iotk_scan_attr( attr, "nk3", nk3_, IERR=ierr )
      IF ( ierr/=0 ) RETURN
      !
      !
      CALL iotk_scan_empty( iunit, "MONKHORST_PACK_OFFSET", ATTR=attr, IERR=ierr )
      IF ( ierr/=0 ) RETURN
      !
      CALL iotk_scan_attr( attr, "k1", k1_, IERR=ierr )
      IF ( ierr/=0 ) RETURN
      CALL iotk_scan_attr( attr, "k2", k2_, IERR=ierr )
      IF ( ierr/=0 ) RETURN
      CALL iotk_scan_attr( attr, "k3", k3_, IERR=ierr )
      IF ( ierr/=0 ) RETURN
      !
      !
      ALLOCATE( xk_( 3, num_k_points_ ) )
      ALLOCATE( wk_(    num_k_points_ ) )
      !
      DO ik = 1, num_k_points_
         !
         CALL iotk_scan_empty( iunit, "K-POINT" // trim( iotk_index(ik) ), &
                               ATTR=attr, IERR=ierr )
         IF ( ierr/=0 ) RETURN
         !
         CALL iotk_scan_attr( attr, "XYZ", xk_(:,ik), IERR=ierr )
         IF ( ierr/=0 ) RETURN
         !
         CALL iotk_scan_attr( attr, "WEIGHT", wk_(ik), IERR=ierr )
         IF ( ierr/=0 ) RETURN
         !
      ENDDO
      !
      nks_start_=0
      !
      IF ( present(nks_start) .or. present(xk_start) .or. present(wk_start) ) THEN
         !
         CALL iotk_scan_dat( iunit, "STARTING_K-POINTS", nks_start_, &
              FOUND = found )
         IF (.NOT. found) nks_start_=0
         !
         IF (nks_start_ > 0 ) THEN
            !
            ALLOCATE( xk_start_(3,nks_start_) )
            ALLOCATE( wk_start_(nks_start_) )
            !
         END IF
         !
         DO ik = 1, nks_start_
            !
            CALL iotk_scan_empty( iunit, "K-POINT_START" // &
                 & TRIM( iotk_index( ik ) ), ATTR=attr )
            !
            CALL iotk_scan_attr( attr, "XYZ", xk_start_(:,ik) )
            !
            CALL iotk_scan_attr( attr, "WEIGHT", wk_start_(ik) )
            !
         END DO
         !
      END IF
      !   
      CALL iotk_scan_dat( iunit, "NORM-OF-Q", qnorm_, FOUND = found )
      IF (.not. found) qnorm_=0.0_DP
      !
      !
      CALL iotk_scan_end( iunit, "BRILLOUIN_ZONE", IERR=ierr )
      IF ( ierr/=0 ) RETURN
      !
      !
      IF ( present( num_k_points ) )       num_k_points  = num_k_points_
      IF ( present( nk1 ) )                nk1           = nk1_
      IF ( present( nk2 ) )                nk2           = nk2_
      IF ( present( nk3 ) )                nk3           = nk3_
      IF ( present( k1 ) )                 k1            =  k1_
      IF ( present( k2 ) )                 k2            =  k2_
      IF ( present( k3 ) )                 k3            =  k3_
      IF ( present( k_units ) )            k_units       =  trim(k_units_)
      IF ( present( xk ) )                 xk(1:3,1:num_k_points_) = xk_(:,:)
      IF ( present( wk ) )                 wk(1:num_k_points_)     = wk_(:)
      IF ( present( nks_start ) )          nks_start     =  nks_start_
      !
      IF ( nks_start_>0 .AND. present( xk_start ) ) THEN
         IF (.NOT.ALLOCATED(xk_start)) ALLOCATE(xk_start(3,nks_start_))
         xk_start(1:3,1:nks_start_) =  xk_start_(:,:)
      ENDIF
      IF ( nks_start_>0 .AND. present( wk_start ) ) THEN
         IF (.NOT.ALLOCATED(wk_start)) ALLOCATE(wk_start(nks_start_))
         wk_start(1:nks_start_) =  wk_start_(:)
      ENDIF
      !
      IF ( present( qnorm ) )              qnorm         = qnorm_
      !
      DEALLOCATE( xk_ )
      DEALLOCATE( wk_ )
      IF (ALLOCATED(xk_start_)) DEALLOCATE(xk_start_)
      IF (ALLOCATED(wk_start_)) DEALLOCATE(wk_start_)
      !
    END SUBROUTINE qexml_read_bz
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_read_para( kunit, nproc, nproc_pool, nproc_image, &
                    ntask_groups, nproc_bgrp, nproc_ortho, found, ierr )
      !------------------------------------------------------------------------
      !
      INTEGER, OPTIONAL, INTENT(OUT) :: kunit, nproc, nproc_pool, nproc_image, &
           ntask_groups, nproc_bgrp, nproc_ortho
      LOGICAL, INTENT(OUT) :: found
      INTEGER, INTENT(OUT) :: ierr
      !
      INTEGER :: kunit_, nproc_, nproc_pool_, nproc_image_, ntask_groups_, &
                 nproc_bgrp_, nproc_ortho_
      !
      LOGICAL :: found2
      !
      !
      CALL iotk_scan_begin( iunit, "PARALLELISM", FOUND=found,IERR=ierr )
      IF ((.NOT. found ) .OR. (ierr /= 0 ) ) RETURN
      !
      CALL iotk_scan_dat( iunit, &
                              "GRANULARITY_OF_K-POINTS_DISTRIBUTION", kunit_ )
      !
      CALL iotk_scan_dat( iunit, "NUMBER_OF_PROCESSORS", nproc_, FOUND=found2 )
      IF ( .NOT. found2) nproc_=1  !compatibility
      !
      CALL iotk_scan_dat( iunit, &
                              "NUMBER_OF_PROCESSORS_PER_POOL", nproc_pool_, FOUND=found2 )
      IF ( .NOT. found2) nproc_pool_=1 ! compatibility
      !
      CALL iotk_scan_dat( iunit, &
                              "NUMBER_OF_PROCESSORS_PER_IMAGE", nproc_image_, FOUND=found2 )
      IF ( .NOT. found2) nproc_image_=1 ! compatibility
      !
      CALL iotk_scan_dat( iunit, "NUMBER_OF_PROCESSORS_PER_TASKGROUP", &
                                              ntask_groups_, FOUND=found2 )
      IF ( .NOT. found2) ntask_groups_=1 ! compatibility
      !
      CALL iotk_scan_dat( iunit, "NUMBER_OF_PROCESSORS_PER_BAND_GROUP", &
                                              nproc_bgrp_, FOUND=found2 )
      IF ( .NOT. found2) nproc_bgrp_=1 ! compatibility
      !
      CALL iotk_scan_dat( iunit, "NUMBER_OF_PROCESSORS_PER_DIAGONALIZATION", &
                                              nproc_ortho_, FOUND=found2 )
      IF ( .NOT. found2) nproc_ortho_=1 ! compatibility
      !
      CALL iotk_scan_end( iunit, "PARALLELISM" )
      !
      !
      IF (present(kunit)) kunit = kunit_
      IF (present(nproc)) nproc = nproc_
      IF (present(nproc_pool)) nproc_pool = nproc_pool_
      IF (present(nproc_image)) nproc_image = nproc_image_
      IF (present(ntask_groups)) ntask_groups = ntask_groups_
      IF (present(nproc_bgrp)) nproc_bgrp = nproc_bgrp_
      IF (present(nproc_ortho)) nproc_ortho = nproc_ortho_
      !
    END SUBROUTINE qexml_read_para
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_read_phonon( modenum, xqq, q_units, ierr )
      !------------------------------------------------------------------------
      !
      INTEGER,       OPTIONAL, INTENT(out) :: modenum
      REAL(DP),     OPTIONAL, INTENT(out) :: xqq(:)
      CHARACTER(*),  OPTIONAL, INTENT(out) :: q_units
      INTEGER,                 INTENT(out) :: ierr
      !
      INTEGER         :: modenum_
      CHARACTER(256)  :: q_units_
      !

      ierr = 0
      !
      CALL iotk_scan_begin( iunit, "PHONON", IERR=ierr )
      IF ( ierr/=0 ) RETURN
      !
      CALL iotk_scan_dat( iunit, "NUMBER_OF_MODES", modenum_, IERR=ierr )
      IF ( ierr/=0 ) RETURN
      !
      CALL iotk_scan_empty( iunit, "UNITS_FOR_Q-POINT", attr, IERR=ierr )
      IF ( ierr/=0 ) RETURN
      CALL iotk_scan_attr( attr, "UNITS", q_units_, IERR=ierr )
      IF ( ierr/=0 ) RETURN
      !
      IF ( present (xqq) ) THEN
         !
         CALL iotk_scan_dat( iunit, "Q-POINT", xqq(:), IERR=ierr )
         IF ( ierr/=0 ) RETURN
         !
      ENDIF
      !
      CALL iotk_scan_end( iunit, "PHONON", IERR=ierr )
      IF ( ierr/=0 ) RETURN
      !
      !
      IF ( present (modenum) )      modenum = modenum_
      IF ( present (q_units) )      q_units = trim(q_units_)
      !
    END SUBROUTINE qexml_read_phonon
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_read_bands_info( num_k_points, natomwfc, &
                                      nbnd, nbnd_up, nbnd_down, &
                                      nspin, nelec, nel_up, nel_down, &
                                      ef, two_fermi_energies, &
                                      ef_up, ef_dw ,energy_units, k_units, &
                                      noncolin, ierr )
      !------------------------------------------------------------------------
      !
      INTEGER,      OPTIONAL, INTENT(out) :: nbnd, nbnd_up, nbnd_down, num_k_points, nspin, natomwfc, nel_up,nel_down
      LOGICAL,      OPTIONAL, INTENT(out) :: noncolin, two_fermi_energies
      REAL(DP),     OPTIONAL, INTENT(out) :: ef, nelec, ef_up, ef_dw
      CHARACTER(*), OPTIONAL, INTENT(out) :: energy_units, k_units
      INTEGER,                INTENT(out) :: ierr
      !
      INTEGER        :: nbnd_, nbnd_up_, nbnd_down_, num_k_points_, nspin_, natomwfc_, nel_up_, nel_down_
      LOGICAL        :: noncolin_, two_fermi_energies_
      REAL(DP)       :: ef_, nelec_, ef_up_, ef_dw_
      CHARACTER(256) :: energy_units_, k_units_
      !
      LOGICAL :: found
      !
      ierr = 0
      !
      !
      CALL iotk_scan_begin( iunit, "BAND_STRUCTURE_INFO", IERR=ierr )
      IF (ierr/=0) RETURN
      !
      !
      CALL iotk_scan_dat  ( iunit, "NUMBER_OF_K-POINTS", num_k_points_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat  ( iunit, "NUMBER_OF_SPIN_COMPONENTS", nspin_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat  ( iunit, "NON-COLINEAR_CALCULATION", noncolin_, FOUND=found, IERR=ierr )
      IF (ierr/=0) RETURN
      IF (.NOT. found) noncolin_ = .FALSE.
      !
      CALL iotk_scan_dat  ( iunit, "NUMBER_OF_ATOMIC_WFC", natomwfc_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      nbnd_up_   = 0
      nbnd_down_ = 0
      nel_up_    = 0.0d0
      nel_down_  = 0.0d0
      !
      IF ( nspin_ == 2 ) THEN
         !
         CALL iotk_scan_dat( iunit, &
                              "NUMBER_OF_BANDS", nbnd_, ATTR = attr, IERR = ierr )
         IF (ierr/=0) RETURN
         !
         CALL iotk_scan_attr( attr, "UP", nbnd_up_, IERR = ierr )
         IF (ierr/=0) RETURN
         !
         CALL iotk_scan_attr( attr, "DW", nbnd_down_, IERR = ierr )
         IF (ierr/=0) RETURN
         !
         CALL iotk_scan_dat( iunit, &
                              "NUMBER_OF_ELECTRONS", nelec_, ATTR = attr, IERR = ierr )
         IF (ierr/=0) RETURN
         !
         CALL iotk_scan_attr( attr, "UP", nel_up_, IERR = ierr )
         IF (ierr/=0) RETURN
         !
         CALL iotk_scan_attr( attr, "DW", nel_down_, IERR = ierr )
         IF (ierr/=0) RETURN
         !
      ELSE
         !
         CALL iotk_scan_dat( iunit, "NUMBER_OF_BANDS", nbnd_, IERR = ierr )
         IF (ierr/=0) RETURN
         !
         CALL iotk_scan_dat( iunit, "NUMBER_OF_ELECTRONS", nelec_, IERR = ierr )
         IF (ierr/=0) RETURN
         !
      END IF
      !
      CALL iotk_scan_empty( iunit, "UNITS_FOR_K-POINTS", ATTR = attr, IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_attr ( attr,   "UNITS", k_units_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_empty( iunit, "UNITS_FOR_ENERGIES", ATTR = attr, IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_attr ( attr,   "UNITS", energy_units_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_dat( iunit, "TWO_FERMI_ENERGIES", two_fermi_energies_, FOUND = found)
      IF ( .not. found ) two_fermi_energies_=.FALSE.
      !
      ef_up_  =0.0d0
      ef_dw_  =0.0d0
      ef_     =0.0d0
      !
      IF ( two_fermi_energies_ ) THEN
         !
         CALL iotk_scan_dat( iunit, "FERMI_ENERGY_UP", ef_up_, IERR=ierr )
         IF (ierr/=0) RETURN
         CALL iotk_scan_dat( iunit, "FERMI_ENERGY_DOWN", ef_dw_, IERR=ierr )
         IF (ierr/=0) RETURN
         CALL iotk_scan_dat( iunit, "ELECTRONS_UP", nel_up_, IERR=ierr )
         IF (ierr/=0) RETURN
         CALL iotk_scan_dat( iunit, "ELECTRONS_DOWN", nel_down_, IERR=ierr )
         IF (ierr/=0) RETURN
         !
      ELSE
         !
         CALL iotk_scan_dat  ( iunit, "FERMI_ENERGY", ef_ , FOUND=found )
         IF (ierr/=0) RETURN
         !
         !
      END IF
      !
      CALL iotk_scan_end( iunit, "BAND_STRUCTURE_INFO", IERR=ierr )
      IF (ierr/=0) RETURN
      !
      !
      IF ( present( nbnd ) )             nbnd           = nbnd_
      IF ( present( nbnd_up ) )          nbnd_up        = nbnd_up_
      IF ( present( nbnd_down ) )        nbnd_down      = nbnd_down_
      IF ( present( num_k_points ) )     num_k_points   = num_k_points_
      IF ( present( nspin ) )            nspin          = nspin_
      IF ( present( noncolin ) )         noncolin       = noncolin_
      IF ( present( natomwfc ) )         natomwfc       = natomwfc_
      IF ( present( nelec ) )            nelec          = nelec_
      IF ( present( nel_up ) )           nel_up         = nel_up_
      IF ( present( nel_down ) )         nel_down       = nel_down_
      IF ( present( ef ) )               ef             = ef_
      IF ( present( two_fermi_energies ) ) two_fermi_energies = two_fermi_energies_
      IF ( present( ef_up ) )            ef_up          = ef_up_
      IF ( present( ef_dw ) )            ef_dw          = ef_dw_
      IF ( present( energy_units ) )     energy_units   = trim( energy_units_ )
      IF ( present( k_units ) )          k_units        = trim( k_units_ )
      !
      !
    END SUBROUTINE qexml_read_bands_info
    !
    !
    !--------------------------------------------------------------------------
    SUBROUTINE qexml_read_bands_pw( num_k_points, nbnd, nkstot, lsda, lkpoint_dir, &
                                    filename, isk, et, wg , ierr )
      !------------------------------------------------------------------------ 
      !
      INTEGER,   INTENT(in) :: num_k_points, nbnd, nkstot
      LOGICAL,   INTENT(in) :: lsda, lkpoint_dir
      CHARACTER(LEN=*), INTENT(in) :: filename
      INTEGER,   INTENT(out), OPTIONAL :: isk(:)
      REAL(DP),  INTENT(out), OPTIONAL :: et(:,:), wg(:,:)
      INTEGER,   INTENT(out):: ierr
      !
      INTEGER  :: ik, ik_eff, iunaux
      INTEGER  :: isk_(nkstot)
      REAL(DP) :: et_(nbnd, nkstot),wg_(nbnd, nkstot)
      LOGICAL  :: found
      !
      !
      IF ( .NOT. lkpoint_dir) THEN
         !
         CALL iotk_free_unit( iunaux )
         !
         CALL iotk_open_read ( iunaux, FILE = trim(filename), IERR=ierr )
         IF (ierr/=0)  RETURN
         !
      END IF
      !
      !
      CALL iotk_scan_begin( iunit, "EIGENVALUES", IERR=ierr )
      IF (ierr/=0) RETURN
      !
      k_points_loop: DO ik = 1, num_k_points
         !
         CALL iotk_scan_begin( iunit, "K-POINT" // TRIM( iotk_index( ik ) ) )
         !
         IF ( lsda ) THEN
            !
            isk_(ik) = 1
            !
            IF (lkpoint_dir) THEN
               CALL iotk_scan_begin(iunit, "DATAFILE"//TRIM(iotk_index(1)) , FOUND = found)
               IF (.NOT. found ) GO TO 10 ! workaround: PW-CP compatibility
               CALL iotk_scan_dat  ( iunit, "EIGENVALUES", et_(:,ik)  )
               CALL iotk_scan_dat  ( iunit, "OCCUPATIONS", wg_(:,ik) )
               CALL iotk_scan_end  ( iunit, "DATAFILE"//TRIM(iotk_index(1)) )
            ELSE
               CALL iotk_scan_begin( iunaux, &
                    "DATA_EIG"//TRIM( iotk_index(ik) )//"_SPIN_UP", FOUND=found )
               IF (.NOT. found ) GO TO 10 ! workaround: PW-CP compatibility
               CALL iotk_scan_dat  ( iunaux, "EIGENVALUES", et_(:,ik)  )
               CALL iotk_scan_dat  ( iunaux, "OCCUPATIONS", wg_(:,ik) )
               CALL iotk_scan_end( iunaux, &
                    "DATA_EIG"//TRIM( iotk_index( ik ) )//"_SPIN_UP")
            ENDIF
            !
10          CONTINUE
            !
            ik_eff = ik + num_k_points
            isk_(ik_eff) = 2
            !
            IF (lkpoint_dir) THEN
               CALL iotk_scan_begin(iunit,"DATAFILE"//TRIM(iotk_index(2)) &
                    , FOUND = found)
               IF (.NOT. found ) GO TO 20 ! workaround: PW-CP compatibility
               CALL iotk_scan_dat  ( iunit, "EIGENVALUES", et_(:,ik_eff) )
               CALL iotk_scan_dat  ( iunit, "OCCUPATIONS", wg_(:,ik_eff) )
               CALL iotk_scan_end( iunit, "DATAFILE"//TRIM(iotk_index(2)) )
            ELSE
               CALL iotk_scan_begin( iunaux, &
               "DATA_EIG"//TRIM( iotk_index(ik) )//"_SPIN_DW", FOUND=found )
               IF (.NOT. found ) GO TO 20 ! workaround: PW-CP compatibility
               CALL iotk_scan_dat  ( iunaux, "EIGENVALUES", et_(:,ik_eff) )
               CALL iotk_scan_dat  ( iunaux, "OCCUPATIONS", wg_(:,ik_eff) )
               CALL iotk_scan_end( iunaux, &
                    "DATA_EIG"//TRIM( iotk_index( ik ) )//"_SPIN_DW")
            ENDIF
            !
20          CONTINUE
            !
         ELSE
            !
            isk_(ik) = 1
            !
            IF (lkpoint_dir) THEN
               CALL iotk_scan_begin( iunit, "DATAFILE" , FOUND = found)
               IF (.NOT. found ) GO TO 15 ! workaround: PW-CP compatibility
               CALL iotk_scan_dat  ( iunit, "EIGENVALUES", et_(:,ik) )
               CALL iotk_scan_dat  ( iunit, "OCCUPATIONS", wg_(:,ik) )
               CALL iotk_scan_end  ( iunit, "DATAFILE" )
            ELSE
               CALL iotk_scan_begin( iunaux, &
                    "DATA_EIG"//TRIM( iotk_index(ik) ), FOUND = found )
               IF (.NOT. found ) GO TO 15 ! workaround: PW-CP compatibility
               CALL iotk_scan_dat  ( iunaux, "EIGENVALUES", et_(:,ik) )
               CALL iotk_scan_dat  ( iunaux, "OCCUPATIONS", wg_(:,ik) )
               CALL iotk_scan_end( iunaux, &
                    "DATA_EIG"//TRIM( iotk_index( ik ) ))
            ENDIF
15          CONTINUE
            !
         END IF
         !
         CALL iotk_scan_end( iunit, "K-POINT" // TRIM( iotk_index( ik ) ) )
         !
      END DO k_points_loop
      !
      CALL iotk_scan_end( iunit, "EIGENVALUES", IERR=ierr )
      IF (ierr/=0) RETURN
      !
      IF (.NOT.lkpoint_dir) THEN
         CALL iotk_close_read ( iunaux, IERR=ierr )
         IF (ierr/=0)  RETURN
      END IF
      !
      IF ( present( isk ) )              isk( 1:nkstot )         = isk_(:)
      IF ( present( et ) )                et( 1:nbnd, 1:nkstot ) = et_(:,:)
      IF ( present( wg ) )                wg( 1:nbnd, 1:nkstot ) = wg_(:,:)
      !
    END SUBROUTINE qexml_read_bands_pw
    !
    !
    !-----------------------------------------------------------------------------
    SUBROUTINE qexml_read_bands_cp( num_k_points, nbnd_tot, nudx , nspin, iupdwn, &
      nupdwn, occ0, occm, ierr )
    !-----------------------------------------------------------------------------
      !
      INTEGER,  INTENT(OUT) :: ierr
      REAL(DP), INTENT(OUT) :: occ0(:)
      REAL(DP), INTENT(OUT) :: occm(:)
      !
      INTEGER, INTENT(in)  :: num_k_points, nspin, nbnd_tot, nudx
      INTEGER,               INTENT(IN) :: iupdwn(:)
      INTEGER,               INTENT(IN) :: nupdwn(:)
      !
      INTEGER :: ik, iss, ik_eff
      CHARACTER(LEN=4)      :: cspin
      REAL(DP), ALLOCATABLE :: occ_(:)
      REAL(DP)              :: wk_
      LOGICAL :: found
      !
#if !defined __HDF5
      CALL iotk_scan_begin( iunit, "EIGENVALUES", IERR=ierr )
#endif
      IF (ierr /= 0) RETURN
      !
      !
      k_points_loop1: DO ik = 1, num_k_points
         !
#if !defined __HDF5
         CALL iotk_scan_begin( iunit, "K-POINT" // TRIM( iotk_index(ik) ) )
#endif
         !
         CALL iotk_scan_dat( iunit, "WEIGHT", wk_ )
         !
         !
         DO iss = 1, nspin
            !
            cspin = iotk_index( iss )
            !
            ik_eff = ik + ( iss - 1 ) * num_k_points
            !
            ALLOCATE( occ_ ( MAX( nudx , nbnd_tot ) ) )
            !
            occ_ = 0.0d0
            !
            CALL iotk_scan_dat( iunit, "OCC0" // TRIM( cspin ), occ_ ( 1 :  nupdwn( iss ) ), FOUND = found )
            !
            IF( .NOT. found ) THEN
               !
               IF( nspin == 1 ) THEN
                  CALL iotk_scan_begin( iunit, "DATAFILE", FOUND = found )
               ELSE
                  CALL iotk_scan_begin( iunit, "DATAFILE"//TRIM(cspin), FOUND = found )
               END IF
               !
               CALL iotk_scan_dat  ( iunit, "OCCUPATIONS", occ_( 1:nbnd_tot ) )
               IF( nspin == 1 ) THEN
                  CALL iotk_scan_end( iunit, "DATAFILE" )
               ELSE
                  CALL iotk_scan_end( iunit, "DATAFILE"//TRIM(cspin) )
               END IF
               !
               IF( found ) THEN
                  occ0( iupdwn( iss ) : iupdwn( iss ) + nupdwn( iss ) - 1 ) = occ_ ( 1:nupdwn( iss ) ) * wk_
                  occm( iupdwn( iss ) : iupdwn( iss ) + nupdwn( iss ) - 1 ) = occ_ ( 1:nupdwn( iss ) ) * wk_
               END IF
               !
            ELSE
               !
               occ0( iupdwn( iss ) : iupdwn( iss ) + nupdwn( iss ) - 1 ) = occ_ ( 1:nupdwn( iss ) )
               !
               CALL iotk_scan_dat( iunit, "OCCM" // TRIM( cspin ), occ_ ( 1 :  nupdwn( iss ) ), FOUND = found )
               !
               IF( found ) THEN
                  occm( iupdwn( iss ) : iupdwn( iss ) + nupdwn( iss ) - 1 ) = occ_ ( 1:nupdwn( iss ) )
               END IF
               !
            END IF
            !
            DEALLOCATE ( occ_ )
            !
            IF( .NOT. found ) THEN
               ierr = 1
               RETURN
            END IF
            !
         END DO
         !
#if !defined __HDF5
         CALL iotk_scan_end( iunit, "K-POINT" // TRIM( iotk_index(ik) ), IERR = ierr )
#endif
         IF (ierr /= 0) RETURN
         !
      END DO k_points_loop1
      !
#if !defined __HDF5
      CALL iotk_scan_end  ( iunit, "EIGENVALUES", IERR = ierr )
#endif
      IF (ierr /= 0) RETURN
      !
      !
    END SUBROUTINE qexml_read_bands_cp
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_read_wfc( ibnds, ibnde, ik, ispin, ipol, igk, ngw, igwx, &
                               gamma_only, wf, wf_kindip, ierr )
      !------------------------------------------------------------------------
      !
      ! read wfc from IBNDS to IBNDE, for kpt IK and spin ISPIN
      ! WF is the wfc on its proper k+g grid, while WF_KINDIP is the same wfc
      ! but on a truncated rho grid (k-point indipendent)
      !
      INTEGER,                 INTENT(in)  :: ibnds, ibnde, ik
      INTEGER,       OPTIONAL, INTENT(in)  :: ispin, ipol
      INTEGER,       OPTIONAL, INTENT(in)  :: igk(:)
      INTEGER,       OPTIONAL, INTENT(out) :: ngw, igwx
      LOGICAL,       OPTIONAL, INTENT(out) :: gamma_only
      COMPLEX(DP),  OPTIONAL, INTENT(out) :: wf(:,:), wf_kindip(:,:)
      INTEGER,                 INTENT(out) :: ierr
      !
      INTEGER :: iunaux
      INTEGER :: ngw_, igwx_, ig, ib, lindex
      LOGICAL :: gamma_only_
      COMPLEX(DP),  ALLOCATABLE :: wf_(:)
      CHARACTER(256)             :: filename

      ierr = 0
      !
      !
      ! few check
      !
      IF ( present( ispin ) .and. present( ipol )  ) THEN
         !
         ierr = 1
         RETURN
         !
      ENDIF
      !
      !
      ! read the main data
      !
      CALL iotk_free_unit( iunaux )
      !
      IF ( present( ispin ) ) THEN
         !
         filename = trim( qexml_wfc_filename( datadir_in, 'evc', ik, ispin ) )
         !
      ELSEIF ( present( ipol )  ) THEN
         !
         filename = trim( qexml_wfc_filename( datadir_in, 'evc', ik, ipol ) )
         !
      ELSE
         !
         filename = trim( qexml_wfc_filename( datadir_in, 'evc', ik ) )
         !
      ENDIF
      !
      CALL iotk_open_read ( iunaux, FILE = trim(filename), IERR=ierr )
      IF (ierr/=0)  RETURN
      !
      !
      CALL iotk_scan_empty( iunaux, "INFO", ATTR=attr, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_attr( attr, "ngw",  ngw_, IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_attr( attr, "igwx", igwx_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      !
      IF ( qexml_version_before_1_4_0 ) THEN
         !
         IF ( present( gamma_only ) ) THEN
             !
             CALL qexml_read_planewaves( GAMMA_ONLY=gamma_only_, IERR=ierr)
             IF (ierr/=0)  RETURN
             !
         ENDIF
         !
      ELSE
         !
         CALL iotk_scan_attr( attr, 'gamma_only', gamma_only_, IERR=ierr)
         IF (ierr/=0)  RETURN
         !
      ENDIF
      !
      !
      IF ( present( wf )  )  THEN
          !
          lindex = 0
          !
          DO ib = ibnds, ibnde
              !
              lindex = lindex + 1
              !
              CALL iotk_scan_dat( iunaux, "evc"//trim(iotk_index(ib)), &
                                  wf( 1:igwx_, lindex ), IERR=ierr )
              IF (ierr/=0) RETURN
              !
          ENDDO
          !
      ENDIF
      !
      IF ( present( wf_kindip )  )  THEN
          !
          ALLOCATE( wf_(igwx_ ), STAT=ierr )
          IF (ierr/=0) RETURN
          !
          IF ( .not. present( igk ) ) THEN
              ierr = 3
              RETURN
          ENDIF
          !
          IF ( maxval( igk( 1: igwx_ ) ) > size( wf_kindip, 1)  ) THEN
              ierr = 4
              RETURN
          ENDIF
          !
          !
          lindex = 0
          !
          DO ib = ibnds, ibnde
              !
              lindex = lindex + 1
              !
              CALL iotk_scan_dat( iunaux, "evc"//trim(iotk_index( ib ) ), &
                                           wf_(1:igwx_), IERR=ierr )
              IF (ierr/=0) RETURN
              !
              ! use the igk map to do the transformation
              !
              wf_kindip(:, lindex) = 0.0_DP
              !
              DO ig = 1, igwx_
                  !
                  wf_kindip( igk( ig ), lindex ) = wf_( ig )
                  !
              ENDDO
              !
          ENDDO
          !
          DEALLOCATE( wf_, STAT=ierr )
          IF (ierr/=0) RETURN
          !
      ENDIF
      !
      CALL iotk_close_read ( iunaux, IERR=ierr )
      IF (ierr/=0)  RETURN
      !
      !
      IF ( present( ngw ) )                 ngw   = ngw_
      IF ( present( igwx ) )               igwx   = igwx_
      IF ( present( gamma_only ) )   gamma_only   = gamma_only_
      !
    END SUBROUTINE qexml_read_wfc
    !
    !
    !------------------------------------------------------------------------
    SUBROUTINE qexml_read_rho( nr1, nr2, nr3, rho, ip, rhoz, ierr  )
      !------------------------------------------------------------------------
      !
      ! Reads charge density rho, as a whole or one plane at a time.
      ! if RHO is specified, the whole charge density is read;
      ! if RHOZ is specified only the IP-th plane is read
      !
      IMPLICIT NONE
      !
      INTEGER,   OPTIONAL, INTENT(out) :: nr1, nr2, nr3
      INTEGER,   OPTIONAL, INTENT(in)  :: ip
      REAL(DP), OPTIONAL, INTENT(out) :: rho(:,:,:), rhoz(:)
      INTEGER,             INTENT(out) :: ierr
      !
      INTEGER        :: nr1_, nr2_, nr3_, ip_
      INTEGER        :: iunaux
      LOGICAL        :: lexists
      CHARACTER(256) :: filename

      ierr = 0
      !
      !
      CALL iotk_free_unit( iunaux )
      !
      filename = trim( datadir_in ) // '/' // 'charge-density.dat'
      lexists  = check_file_exst( trim(filename) )
      !
      IF ( .not. lexists ) THEN
          !
          filename = trim( datadir_in ) // '/' // 'charge-density.xml'
          lexists  = check_file_exst( trim(filename) )
          !
      ENDIF
      !
      IF ( .not. lexists ) THEN
          !
          ierr = -1
          RETURN
          !
      ENDIF
      !
      CALL iotk_open_read( iunaux, FILE = filename, IERR=ierr )
      IF ( ierr/=0 ) RETURN
      !
      !
      CALL iotk_scan_begin( iunaux, "CHARGE-DENSITY", IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_empty( iunaux, "INFO", ATTR=attr, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_scan_attr( attr, "nr1", nr1_, IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_attr( attr, "nr2", nr2_, IERR=ierr )
      IF (ierr/=0) RETURN
      CALL iotk_scan_attr( attr, "nr3", nr3_, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      !
      IF ( present( rhoz ) ) THEN
         !
         IF ( .not. present( ip ) ) THEN
            ierr = 71
            RETURN
         ENDIF
         !
         CALL iotk_scan_dat( iunaux, "z"//trim(iotk_index(ip)), rhoz, IERR=ierr)
         IF (ierr/=0) RETURN
         !
      ENDIF
      !
      !
      IF ( present( rho ) ) THEN
         !
         DO ip_ = 1, nr3_
            !
            CALL iotk_scan_dat( iunaux, "z"//trim(iotk_index(ip_)), rho(1:nr1_,1:nr2_,ip_), &
                                IERR=ierr)
            IF (ierr/=0) RETURN
            !
         ENDDO
         !
      ENDIF
      !
      CALL iotk_scan_end( iunaux, "CHARGE-DENSITY", IERR=ierr )
      IF (ierr/=0) RETURN
      !
      CALL iotk_close_read( iunaux, IERR=ierr )
      IF (ierr/=0) RETURN
      !
      !
      IF ( present( nr1 ) )     nr1 = nr1_
      IF ( present( nr2 ) )     nr2 = nr2_
      IF ( present( nr3 ) )     nr3 = nr3_
      !
    END SUBROUTINE qexml_read_rho
    !
#endif
    !
END MODULE oldxml_qexml_module

!
! Copyright (C) 2001-2014 Quantum-ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!

!-----------------------------------------------------------------------
SUBROUTINE qepy_update_hamiltonian(istep, embed)
  !-----------------------------------------------------------------------
  !
  ! ... Update the hamiltonian
  !
  USE kinds,         ONLY : dp
  USE ldaU,          ONLY : lda_plus_U
  USE scf,           ONLY : rho, rho_core, rhog_core, vltot, v, kedtau, vrs
  USE fft_base,      ONLY : dfftp
  USE gvecs,         ONLY : doublegrid
  USE io_global,     ONLY : stdout
  USE lsda_mod,      ONLY : nspin
  USE uspp,          ONLY : okvan
  USE dfunct,        ONLY : newd
  USE tddft_module,  ONLY : nupdate_Dnm, iverbosity
  USE wvfct,         ONLY : nbnd
  USE scf,           ONLY : rho
  USE cell_base,     ONLY : alat, omega, at, bg
  USE ions_base,     ONLY : nsp, zv, nat, tau, ityp
  USE gvect,         ONLY : ngm, gstart, g, gg, gcutm
  USE control_flags, ONLY : gamma_only
  USE becmod,        ONLY : becp, calbec, allocate_bec_type, &
                            is_allocated_bec_type, deallocate_bec_type
  USE uspp,          ONLY : nkb
  USE pwcom
  !
  USE qepy_common,             ONLY : embed_base
  !
  implicit none
  integer, intent(in) :: istep
  real(dp) :: charge, eth, etotefield
  real(dp), external :: ewald, delta_eband
  !
  TYPE(embed_base), INTENT(INOUT)    :: embed
  !

  call start_clock('updateH')
  
  ! calculate total charge density
  !rho%of_g(:,:) = (0.d0,0.d0)
  !rho%of_r(:,:) = 0.d0
  !call sum_band()
  if (okvan .and. is_allocated_bec_type(becp)) call deallocate_bec_type(becp)

  if (lda_plus_U) then
    call new_ns
    if (iverbosity > 10) call write_ns()
  end if
    
  ! calculate HXC-potential
  !call v_of_rho( rho, rho_core, rhog_core, ehart, etxc, vtxc, eth, etotefield, charge, v )
  call qepy_v_of_rho( rho, rho_core, rhog_core, ehart, etxc, vtxc, eth, etotefield, charge, v, embed)
    
  ! calculate total local potential (external + scf)
  !call setlocal
  !call set_vrs(vrs, vltot, v%of_r, kedtau, v%kin_r, dfftp%nnr, nspin, doublegrid)    
  call qepy_setlocal(embed%exttype)
  !
  call embed%allocate_extpot()
  v%of_r = v%of_r + embed%extpot
  !
  CALL sum_vrs( dfftp%nnr, nspin, vltot, v%of_r, vrs )
  !
  ! ... interpolate the total local potential
  !
  CALL interpolate_vrs( dfftp%nnr, nspin, doublegrid, kedtau, v%kin_r, vrs )
  
  ! calculate new D_nm matrix for ultrasoft pseudopotential
  if (okvan) then
    if (istep == -1 .or. ( (nupdate_Dnm /= 0 .and. mod(istep,nupdate_Dnm) == 0) ) ) then
      call newd()
      if (iverbosity > 10) write(stdout,'(5X,''call newd'')')
    endif
  endif

  if (embed%tddft%nstep > 1) then
  ! calculate band energy and Ewald energy
  deband = delta_eband()
  ewld = ewald( alat, nat, nsp, ityp, zv, at, bg, tau, &
                omega, g, gg, ngm, gcutm, gstart, gamma_only, strf )

  ! calculate new energy
  etot = eband + deband + ( etxc - etxcc ) + ewld + ehart
  call sum_energies
  endif

  ! intialization step
  if (istep == -1) &
      write(stdout,'(''ENERGY '',2X,I6,5F16.8)') istep, etot, eband + deband, ehart, etxc+etxcc, ewld
    
  call stop_clock('updateH')

END SUBROUTINE qepy_update_hamiltonian


!-----------------------------------------------------------------------
!FUNCTION delta_eband() RESULT(delta_e)
!  !-----------------------------------------------------------------------
!  ! ... delta_e = - \int rho%of_r(r)  v%of_r(r)
!  !               - \int rho%kin_r(r) v%kin_r(r) [for Meta-GGA]
!  !               - \sum rho%ns       v%ns       [for LDA+U]
!  !               - \sum becsum       D1_Hxc     [for PAW]
!  USE kinds,            ONLY : dp
!  USE scf,              ONLY : scf_type, rho, v
!  USE funct,            ONLY : dft_is_meta
!  USE fft_base,         ONLY : dfftp
!  USE noncollin_module, ONLY : noncolin
!  USE mp,               ONLY : mp_sum, mp_barrier
!  USE mp_bands,         ONLY : intra_bgrp_comm
!  USE paw_variables,    ONLY : okpaw, ddd_paw
!  USE ldaU,             ONLY : lda_plus_U
!  USE cell_base,        ONLY : omega
!  USE lsda_mod,         ONLY : nspin
!  IMPLICIT NONE
!  REAL(DP) :: delta_e, delta_e_hub
!  integer :: ir

!  delta_e = 0.d0
!  IF ( nspin==2 ) THEN
!     !
!     DO ir = 1,dfftp%nnr
!       delta_e = delta_e - ( rho%of_r(ir,1) + rho%of_r(ir,2) ) * v%of_r(ir,1) &  ! up
!                         - ( rho%of_r(ir,1) - rho%of_r(ir,2) ) * v%of_r(ir,2)    ! dw
!     ENDDO
!     delta_e = 0.5_dp*delta_e
!     !
!  ELSE
!     delta_e = - SUM( rho%of_r(:,:)*v%of_r(:,:) )
!  ENDIF
!  !
!  IF ( dft_is_meta() ) &
!     delta_e = delta_e - SUM( rho%kin_r(:,:)*v%kin_r(:,:) )
!  !
!  delta_e = omega * delta_e / ( dfftp%nr1*dfftp%nr2*dfftp%nr3 )
!  !
!  CALL mp_sum( delta_e, intra_bgrp_comm )
!  !
!  if (lda_plus_u) then
!    if (noncolin) then
!      delta_e_hub = - SUM (rho%ns_nc(:,:,:,:)*v%ns_nc(:,:,:,:))
!      delta_e = delta_e + delta_e_hub
!    else
!      delta_e_hub = - SUM (rho%ns(:,:,:,:)*v%ns(:,:,:,:))
!      if (nspin==1) delta_e_hub = 2.d0 * delta_e_hub
!      delta_e = delta_e + delta_e_hub
!    endif
!  end if
!  !
!  IF (okpaw) delta_e = delta_e - SUM(ddd_paw(:,:,:)*rho%bec(:,:,:))
!  !
!  RETURN
!  !
!END FUNCTION delta_eband


!!-----------------------------------------------------------------------
!SUBROUTINE sum_energies
!!-----------------------------------------------------------------------
!  USE kinds,              ONLY : dp
!  USE paw_variables,      ONLY : okpaw
!  USE ldaU,               ONLY : lda_plus_u, eth
!  USE control_flags,      ONLY : llondon, lxdm, ts_vdw
!  USE xdm_module,         ONLY : energy_xdm
!  USE extfield,           ONLY : tefield, etotefield
!  USE tsvdw_module,       ONLY : EtsvdW
!  USE plugin_variables,   ONLY : plugin_etot
!  USE pwcom
!  implicit none
!  real(dp) :: eext = 0.d0

!  if (okpaw) etot = etot + epaw
!  if (lda_plus_u) etot = etot + eth

!  if (llondon) then
!     etot = etot + elondon
!     hwf_energy = hwf_energy + elondon
!  endif

!  if (lxdm) then
!     exdm = energy_xdm()
!     etot = etot + exdm
!     hwf_energy = hwf_energy + exdm
!  endif

!  if (ts_vdw) then
!     ! factor 2 converts from Ha to Ry units
!     etot = etot + 2.0d0*EtsvdW
!     hwf_energy = hwf_energy + 2.0d0*EtsvdW
!  endif

!  if (tefield) then
!     etot = etot + etotefield
!     hwf_energy = hwf_energy + etotefield
!  endif

!  ! adds possible external contribution from plugins to the energy
!  etot = etot + plugin_etot + eext

!  return

!!-----------------------------------------------------------------------
!END SUBROUTINE sum_energies
!!-----------------------------------------------------------------------

MODULE qepy_api
   USE kinds,                ONLY : DP
   USE qepy_common, ONLY : embed_base
   !
   IMPLICIT NONE
   PUBLIC
   !
CONTAINS

   SUBROUTINE qepy_update_ions(embed, pos, ikind, lattice)
      !-----------------------------------------------------------------------
      ! This is function Combined 'run_pwscf' and 'move_ions'.
      !***********************************************************************
      ! pos:
      !   ionic positions in bohr
      ! ikind:
      !   ikind = 0  all
      !   ikind = 1  atomic configuration dependent information
      ! lattice:
      !   lattice parameter in bohr
      !***********************************************************************
      !-----------------------------------------------------------------------
      USE mp_images,            ONLY : intra_image_comm
      USE extrapolation,        ONLY : update_file, update_pot
      USE io_global,            ONLY : ionode_id, ionode
      USE ions_base,            ONLY : nat, ityp, tau
      USE symm_base,            ONLY : checkallsym
      USE mp,                   ONLY : mp_bcast
      USE control_flags,        ONLY : treinit_gvecs
      USE cell_base,            ONLY : alat, at, bg, omega, cell_force, &
                                     fix_volume, fix_area, ibrav, enforce_ibrav
      USE cellmd,               ONLY : omega_old, at_old, press, lmovecell, calc, cell_factor
      !
      INTEGER                  :: ierr
      TYPE(embed_base), INTENT(INOUT) :: embed
      REAL(DP), INTENT(IN) :: pos(:,:)
      INTEGER,INTENT(IN),OPTIONAL  :: ikind
      REAL(DP), INTENT(IN), OPTIONAL  :: lattice(3,3)
      !
      INTEGER   :: iflag
      LOGICAL :: lmovecell_
      !
      IF ( present(ikind) ) THEN
         iflag = ikind
      ELSE
         iflag = 0
      ENDIF
      !
      IF ( present(lattice) ) THEN
         IF (.not. lmovecell) THEN
            call errore("qepy_update_ions","lattice update only works for calculation= 'vc-relax' and 'vc-md'.",1)
            ! This is due to the `gshells` function in the initialization will set `ngl`, which is one of the shape of `vloc`.
         ENDIF
         lmovecell_ = .TRUE.
      ELSE
         lmovecell_ = .FALSE.
      ENDIF

      CALL update_file()

      IF ( ionode ) THEN
         tau(:,:)=pos(:,:) / alat
         IF ( lmovecell_ ) THEN
            !
            IF (ALLOCATED(embed%extpot)) DEALLOCATE(embed%extpot)
            !
            at_old = at
            omega_old = omega
            IF (fix_volume) CALL impose_deviatoric_strain( alat*at, lattice )
            IF (fix_area)   CALL impose_deviatoric_strain_2d( alat*at, lattice )
            at = lattice / alat
            IF(enforce_ibrav) CALL remake_cell( ibrav, alat, at(1,1),at(1,2),at(1,3) )
            CALL recips( at(1,1),at(1,2),at(1,3), bg(1,1),bg(1,2),bg(1,3) )
            CALL volume( alat, at(1,1),at(1,2),at(1,3), omega )
            !
         ENDIF
         CALL checkallsym( nat, tau, ityp)
      ENDIF
      !
      CALL mp_bcast( tau, ionode_id, intra_image_comm )
      !
      IF ( lmovecell_ ) THEN
         !
         CALL mp_bcast( at,        ionode_id, intra_image_comm )
         CALL mp_bcast( at_old,    ionode_id, intra_image_comm )
         CALL mp_bcast( omega,     ionode_id, intra_image_comm )
         CALL mp_bcast( omega_old, ionode_id, intra_image_comm )
         CALL mp_bcast( bg,        ionode_id, intra_image_comm )
         !
      ENDIF
      IF (iflag == 0 ) THEN
         CALL punch( 'config-nowf' )
         IF ( treinit_gvecs ) THEN
            CALL reset_gvectors()
         ELSE
            CALL update_pot()
            CALL qepy_hinit1(embed%exttype)
         END IF
      ELSE IF (iflag == 1 ) THEN
         CALL set_rhoc()
         CALL qepy_hinit1(embed%exttype)
      END IF
   END SUBROUTINE

END MODULE qepy_api

MODULE qepy_mod
   USE kinds,                   ONLY : DP
   USE scatter_mod,             ONLY : gather_grid, scatter_grid
   USE qepy_common,             ONLY : embed
   USE fft_base,                ONLY : dfftp
   !
   IMPLICIT NONE
   PUBLIC
   !
   INTERFACE mp_gather
      MODULE PROCEDURE mp_gather_real, mp_gather_complex
   END INTERFACE
   !
   INTERFACE mp_scatter
      MODULE PROCEDURE mp_scatter_real, mp_scatter_complex
   END INTERFACE
   !
   INTERFACE qepy_get_value
      MODULE PROCEDURE qepy_get_value_real_1, qepy_get_value_real_2
   END INTERFACE
   !
CONTAINS

   SUBROUTINE mp_gather_real(fin, fout)
      USE kinds,                ONLY : DP
      USE fft_base,             ONLY : dfftp
      !
      IMPLICIT NONE
      REAL(DP), INTENT(IN) :: fin(:)
      REAL(DP), INTENT(OUT) :: fout(:)
      !
      IF (dfftp%nproc > 1) THEN
         CALL gather_grid(dfftp, fin, fout)
      ELSE
         fout(:) = fin(:)
      ENDIF
   END SUBROUTINE

   SUBROUTINE mp_scatter_real(fin, fout)
      USE kinds,                ONLY : DP
      USE fft_base,             ONLY : dfftp
      !
      IMPLICIT NONE
      REAL(DP), INTENT(IN) :: fin(:)
      REAL(DP), INTENT(OUT) :: fout(:)
      !
      IF (dfftp%nproc > 1) THEN
         CALL scatter_grid(dfftp, fin, fout)
      ELSE
         fout(:) = fin(:)
      ENDIF
   END SUBROUTINE

   SUBROUTINE mp_gather_complex(fin, fout)
      USE kinds,                ONLY : DP
      USE fft_base,             ONLY : dfftp
      !
      IMPLICIT NONE
      COMPLEX(DP), INTENT(IN) :: fin(:)
      COMPLEX(DP), INTENT(OUT) :: fout(:)
      !
      IF (dfftp%nproc > 1) THEN
         CALL gather_grid(dfftp, fin, fout)
      ELSE
         fout(:) = fin(:)
      ENDIF
   END SUBROUTINE

   SUBROUTINE mp_scatter_complex(fin, fout)
      USE kinds,                ONLY : DP
      USE fft_base,             ONLY : dfftp
      !
      IMPLICIT NONE
      COMPLEX(DP), INTENT(IN) :: fin(:)
      COMPLEX(DP), INTENT(OUT) :: fout(:)
      !
      IF (dfftp%nproc > 1) THEN
         CALL scatter_grid(dfftp, fin, fout)
      ELSE
         fout(:) = fin(:)
      ENDIF
   END SUBROUTINE

   SUBROUTINE qepy_get_value_real_1(fin, fout, gather, scatter)
      USE kinds,                ONLY : DP
      USE fft_base,             ONLY : dfftp
      !
      IMPLICIT NONE
      real(DP), INTENT(IN)        :: fin(:)
      real(DP), INTENT(OUT)       :: fout(:)
      LOGICAL,INTENT(in),OPTIONAL :: gather
      LOGICAL,INTENT(in),OPTIONAL :: scatter
      !
      INTEGER                     :: nnr
      LOGICAL                     :: gather_
      LOGICAL                     :: scatter_
      !
      gather_ = .FALSE.
      scatter_ = .FALSE.
      !
      IF ( present(gather) ) gather_ = gather
      IF ( present(scatter) ) scatter_ = scatter
      !
      IF ( gather_ ) THEN
         CALL mp_gather(fin, fout)
      ELSE IF ( scatter_ ) THEN
         CALL mp_scatter(fin, fout)
      ELSE
         !nnr = dfftp%nr1x* dfftp%my_nr2p* dfftp%my_nr3p
         nnr = size(fin)
         fout(1:nnr) = fin
         fout(nnr:size(fout)) = 0.0_DP
      ENDIF
      !
   END SUBROUTINE

   SUBROUTINE qepy_get_value_real_2(fin, fout, gather, scatter)
      USE kinds,                ONLY : DP
      !
      IMPLICIT NONE
      real(DP), INTENT(IN)        :: fin(:,:)
      real(DP), INTENT(OUT)       :: fout(:,:)
      LOGICAL,INTENT(in),OPTIONAL :: gather
      LOGICAL,INTENT(in),OPTIONAL :: scatter
      !
      INTEGER                     :: ispin, nspin
      LOGICAL                     :: gather_
      LOGICAL                     :: scatter_
      !
      gather_ = .FALSE.
      scatter_ = .FALSE.
      !
      IF ( present(gather) ) gather_ = gather
      IF ( present(scatter) ) scatter_ = scatter
      !
      nspin = size(fin, 2)
      DO ispin = 1, nspin
         call qepy_get_value_real_1(fin(:, ispin), fout(:, ispin), gather_, scatter_)
      END DO
      !
   END SUBROUTINE

   SUBROUTINE qepy_get_rho(rhor, gather)
      USE kinds,                ONLY : DP
      use scf,                  ONLY : rho, rhoz_or_updw
      USE fft_base,             ONLY : dfftp, dffts
      USE lsda_mod,             ONLY : lsda, nspin, current_spin, isk
      !
      IMPLICIT NONE
      REAL(DP), INTENT(OUT) :: rhor(:,:)
      LOGICAL,INTENT(in),OPTIONAL :: gather
      !
      LOGICAL :: gather_
      !
      gather_ = .true.
      IF ( present(gather) ) gather_ = gather
      !
      IF (nspin > 1) CALL rhoz_or_updw( rho, 'only_r', '->updw' )
      !
      call qepy_get_value(rho%of_r, rhor, gather = gather_)
      !
      IF (nspin > 1) CALL rhoz_or_updw( rho, 'only_r', '->rhoz' )
   END SUBROUTINE

   SUBROUTINE qepy_set_rho(rhor, gather)
      USE kinds,                ONLY : DP
      USE fft_rho,              ONLY : rho_g2r, rho_r2g
      USE fft_base,             ONLY : dfftp, dffts
      use scf,                  ONLY : rho, rhoz_or_updw
      USE lsda_mod,             ONLY : lsda, nspin, current_spin, isk
      !
      IMPLICIT NONE
      REAL(DP), INTENT(IN) :: rhor(:,:)
      LOGICAL,INTENT(in),OPTIONAL :: gather
      !
      LOGICAL :: gather_
      !
      gather_ = .true.
      IF ( present(gather) ) gather_ = gather
      !
      IF (nspin > 1) CALL rhoz_or_updw( rho, 'only_r', '->updw' )
      !
      call qepy_get_value(rhor, rho%of_r, scatter = gather_)
      !
      IF (nspin > 1) CALL rhoz_or_updw( rho, 'only_r', '->rhoz' )
      CALL rho_r2g(dfftp, rho%of_r, rho%of_g )
   END SUBROUTINE

   SUBROUTINE qepy_get_rho_core(rhoc, gather)
      USE kinds,                ONLY : DP
      use scf,                  ONLY : rho_core !! the core charge in real space
      USE fft_base,             ONLY : dfftp, dffts
      IMPLICIT NONE
      REAL(DP), INTENT(OUT) :: rhoc(:)
      LOGICAL,INTENT(in),OPTIONAL :: gather
      !
      LOGICAL :: gather_
      !
      gather_ = .true.
      IF ( present(gather) ) gather_ = gather
      !
      call qepy_get_value(rho_core, rhoc, gather = gather_)
      !
   END SUBROUTINE

   SUBROUTINE qepy_set_rho_core(rhoc, gather)
      USE kinds,                ONLY : DP
      use scf,                  ONLY : rho_core !! the core charge in real space
      USE fft_base,             ONLY : dfftp, dffts
      IMPLICIT NONE
      REAL(DP), INTENT(IN) :: rhoc(:)
      LOGICAL,INTENT(in),OPTIONAL :: gather
      !
      LOGICAL :: gather_
      !
      gather_ = .true.
      IF ( present(gather) ) gather_ = gather
      !
      call qepy_get_value(rhoc, rho_core, scatter = gather_)
      !
   END SUBROUTINE

   SUBROUTINE qepy_set_extpot(vin, gather)
      USE kinds,                ONLY : DP
      USE fft_rho,              ONLY : rho_g2r, rho_r2g
      USE fft_base,             ONLY : dfftp, dffts
      USE lsda_mod,             ONLY : lsda, nspin, current_spin, isk
      USE mp,                   ONLY : mp_bcast
      !
      IMPLICIT NONE
      REAL(DP), INTENT(IN) :: vin(:,:)
      LOGICAL,INTENT(in),OPTIONAL :: gather
      !
      INTEGER :: ispin, ns
      LOGICAL :: gather_
      !
      gather_ = .true.
      IF ( present(gather) ) gather_ = gather
      !
      call embed%allocate_extpot()
      !
      ns = size(vin,2)
      CALL mp_bcast(ns, dfftp%root, dfftp%comm)
      !
      call qepy_get_value(vin(:,1:ns), embed%extpot(:,1:ns), scatter = gather_)
      !
      DO ispin = ns+1, nspin
         embed%extpot(:,ispin) = embed%extpot(:,1)
      END DO
      !
   END SUBROUTINE

   FUNCTION qepy_get_grid(nr, gather) RESULT( nrw )
      USE kinds,                ONLY : DP
      USE fft_base,             ONLY : dfftp
      !
      IMPLICIT NONE
      INTEGER,INTENT(OUT),OPTIONAL :: nr(3)
      LOGICAL,INTENT(in),OPTIONAL  :: gather
      !
      INTEGER                      :: nrw(3)
      !
      IF ( present(gather) ) THEN
         nrw = qepy_get_grid_shape(dfftp, gather)
      ELSE
         nrw = qepy_get_grid_shape(dfftp)
      ENDIF
      !
      IF ( present(nr) ) nr = nrw
   END FUNCTION

   FUNCTION qepy_get_grid_shape(dfft, gather) RESULT( nrw )
      USE kinds,                ONLY : DP
      USE fft_types,            ONLY : fft_type_descriptor
      !
      IMPLICIT NONE
      TYPE(fft_type_descriptor),INTENT(IN) :: dfft
      LOGICAL,INTENT(in),OPTIONAL          :: gather
      !
      LOGICAL                              :: gather_
      INTEGER                              :: nrw(3)
      !
      gather_ = .true.
      IF ( present(gather) ) gather_ = gather
      !
      IF ( gather_ ) THEN
         nrw =(/dfft%nr1, dfft%nr2, dfft%nr3/)
      ELSE
         nrw =(/dfft%nr1x, dfft%my_nr2p, dfft%my_nr3p/)
      ENDIF
      !
   END FUNCTION

   FUNCTION qepy_get_grid_smooth(nr, gather) RESULT(nrw)
      USE kinds,                ONLY : DP
      USE fft_base,             ONLY : dffts
      !
      IMPLICIT NONE
      INTEGER,INTENT(OUT),OPTIONAL :: nr(3)
      LOGICAL,INTENT(in),OPTIONAL  :: gather
      !
      INTEGER                      :: nrw(3)
      !
      IF ( present(gather) ) THEN
         nrw = qepy_get_grid_shape(dffts, gather)
      ELSE
         nrw = qepy_get_grid_shape(dffts)
      ENDIF
      !
      IF ( present(nr) ) nr = nrw
   END FUNCTION

   SUBROUTINE qepy_set_stdout(fname, uni, append)
      USE io_global,            ONLY : stdout, ionode
      !
      INTEGER                  :: ierr
      CHARACTER(LEN=*),INTENT(IN),OPTIONAL  :: fname
      INTEGER,INTENT(in),OPTIONAL :: uni
      LOGICAL,INTENT(in),OPTIONAL :: append
      !
      LOGICAL :: exst
      !
      IF ( .NOT. present(fname) ) return
      IF ( present(uni) ) THEN
         stdout = uni
      ELSE
         stdout = 666
      ENDIF
      !
      exst = .false.
      IF ( present(append)) THEN
         IF (append) INQUIRE (file = TRIM(fname), exist = exst)
      ENDIF
      !
      IF (exst) THEN
         OPEN (UNIT = stdout, FILE = TRIM(fname), FORM = 'formatted', POSITION = 'append', iostat = ierr )
      ELSE
         OPEN (UNIT = stdout, FILE = TRIM(fname), FORM = 'formatted', STATUS = 'unknown', iostat = ierr )
      ENDIF
   END SUBROUTINE

   SUBROUTINE qepy_write_stdout(fstr)
      USE io_global,            ONLY : stdout, ionode
      !
      INTEGER                  :: ierr
      CHARACTER(LEN=*),INTENT(IN)  :: fstr
      !
      IF(ionode) WRITE(stdout,'(A)') fstr
   END SUBROUTINE

   SUBROUTINE qepy_close_stdout(fname)
      USE io_global,            ONLY : stdout, ionode
      !
      INTEGER                  :: ierr
      CHARACTER(LEN=*),INTENT(IN)  :: fname
      !
      IF(ionode) close(stdout)
   END SUBROUTINE

   SUBROUTINE qepy_get_evc(ik, wfc)
      USE kinds,                ONLY : DP
      USE io_files,             ONLY : iunwfc, nwordwfc
      USE buffers,              ONLY : get_buffer
      USE wavefunctions,        ONLY : evc
      USE klist,                ONLY : nks
      !
      IMPLICIT NONE
      INTEGER,INTENT(IN) :: ik
      COMPLEX(DP), INTENT(OUT),OPTIONAL :: wfc(:,:)
      !
      IF ( nks > 1 ) CALL get_buffer ( evc, nwordwfc, iunwfc, ik )
      IF ( present(wfc) ) THEN
         wfc = evc
      ENDIF
   END SUBROUTINE

   SUBROUTINE qepy_get_wf(ik, ibnd, wf, gather)
      USE kinds,                ONLY : DP
      USE io_files,             ONLY : iunwfc, nwordwfc
      USE buffers,              ONLY : get_buffer
      USE wavefunctions,        ONLY : evc, psic
      USE klist,                ONLY : nks, igk_k, ngk
      USE fft_base,             ONLY : dfftp, dffts
      USE fft_interfaces,       ONLY : invfft
      USE control_flags,        ONLY : diago_full_acc, gamma_only, lxdm, tqr
      USE bp,                   ONLY : lelfield
      !
      IMPLICIT NONE
      INTEGER,INTENT(IN) :: ik, ibnd
      COMPLEX(DP), INTENT(OUT) :: wf(:)
      LOGICAL,INTENT(in),OPTIONAL :: gather
      !
      INTEGER :: j, nnr, npw
      LOGICAL :: gather_
      !
      gather_ = .true.
      IF ( present(gather) ) gather_ = gather
      !
      IF ( dffts%has_task_groups ) THEN
         call errore('qepy_get_wf', 'Sorry this one not support task-group version', 1)
      ENDIF
      !
      IF ( nks > 1 .OR. lelfield ) CALL get_buffer ( evc, nwordwfc, iunwfc, ik )
      psic(:) = (0.0_DP, 0.0_DP)
      npw = ngk(ik)
      IF ( gamma_only ) THEN
         psic(dffts%nl (1:npw))  = evc(1:npw,ibnd)
         psic(dffts%nlm(1:npw)) = CONJG( evc(1:npw,ibnd) )
      ELSE
         !$omp parallel
         !$omp do
         DO j = 1, npw
            psic(dffts%nl(igk_k(j,ik))) = evc(j,ibnd)
         ENDDO
         !$omp end do nowait
         !$omp end parallel
      END IF
      CALL invfft ('Wave', psic, dffts)
      !
      IF ( gather_ ) THEN
         CALL mp_gather(psic(1:dffts%nnr), wf)
      ELSE
         nnr = min(size(wf), dffts%nnr)
         wf(1:nnr) = psic(1:nnr)
         wf(nnr:size(wf)) = (0.0_DP, 0.0_DP)
      ENDIF
   END SUBROUTINE

   SUBROUTINE qepy_get_vkb(ik, vk, gather)
      USE kinds,                ONLY : DP
      USE io_files,             ONLY : iunwfc, nwordwfc
      USE buffers,              ONLY : get_buffer
      USE wavefunctions,        ONLY : evc, psic
      USE klist,                ONLY : nks, igk_k, ngk, xk
      USE uspp,                 ONLY : vkb, nkb
      USE fft_base,             ONLY : dfftp, dffts
      USE fft_interfaces,       ONLY : invfft
      USE control_flags,        ONLY : diago_full_acc, gamma_only, lxdm, tqr
      !
      IMPLICIT NONE
      INTEGER,INTENT(IN) :: ik
      COMPLEX(DP), INTENT(OUT) :: vk(:,:)
      LOGICAL,INTENT(in),OPTIONAL :: gather
      !
      INTEGER :: i, j, nnr, npw
      LOGICAL :: gather_
      !
      gather_ = .true.
      IF ( present(gather) ) gather_ = gather
      !
      IF ( dffts%has_task_groups ) THEN
         call errore('qepy_get_vkb', 'Sorry this one not support task-group version', 1)
      ENDIF
      !
      IF ( nkb > 0 ) CALL init_us_2( ngk(ik), igk_k(1,ik), xk(1,ik), vkb )
      !
      vk(:,:) = (0.0_DP, 0.0_DP)
      DO i = 1, nkb
         psic(:) = (0.0_DP, 0.0_DP)
         npw = ngk(ik)
         IF ( gamma_only ) THEN
            psic(dffts%nl (1:npw))  = vkb(1:npw,i)
            psic(dffts%nlm(1:npw)) = CONJG( vkb(1:npw,i) )
         ELSE
            !$omp parallel
            !$omp do
            DO j = 1, npw
               psic(dffts%nl(igk_k(j,ik))) = vkb(j,i)
            ENDDO
            !$omp end do nowait
            !$omp end parallel
         END IF
         CALL invfft ('Wave', psic, dffts)
         !
         IF ( gather_ ) THEN
            CALL mp_gather(psic(1:dffts%nnr), vk(:, i))
         ELSE
            nnr = min(size(vk, 1), dffts%nnr)
            vk(1:nnr, i) = psic(1:nnr)
         ENDIF
      ENDDO
   END SUBROUTINE

   SUBROUTINE qepy_set_extforces(forces)
      USE kinds,                ONLY : DP
      USE ions_base,            ONLY : nat, ntyp => nsp
      !
      IMPLICIT NONE
      REAL(DP), INTENT(IN) :: forces(:,:)
      !
      call embed%allocate_extforces()
      embed%extforces(:,:) = forces(:,1:nat)
      !
   END SUBROUTINE

   SUBROUTINE qepy_calc_effective_potential(potential, gather)
      USE kinds,                ONLY : DP
      USE ions_base,            ONLY : nat, ntyp => nsp
      USE scf,                  ONLY : rho, rho_core, rhog_core, v, vltot, vrs
      USE ener,                 ONLY : etot, hwf_energy, eband, deband, ehart, &
                                       vtxc, etxc, etxcc, ewld, demet, epaw, &
                                       elondon, edftd3, ef_up, ef_dw
      USE ldaU,                 ONLY : eth
      USE extfield,             ONLY : tefield, etotefield
      USE lsda_mod,             ONLY : nspin
      !
      IMPLICIT NONE
      REAL(DP), INTENT(OUT),OPTIONAL  :: potential(:,:)
      LOGICAL,INTENT(in),OPTIONAL     :: gather
      !
      REAL(DP) :: charge
      !
      LOGICAL :: gather_
      !
      gather_ = .true.
      IF ( present(gather) ) gather_ = gather
      !
      CALL qepy_v_of_rho_all( rho, rho_core, rhog_core, &
         ehart, etxc, vtxc, eth, etotefield, charge, v)
      !
      IF ( present(potential) ) THEN
         call qepy_get_value(vrs, potential, gather = gather_)
      ENDIF
      !
   END SUBROUTINE

   SUBROUTINE qepy_set_effective_potential(potential, gather)
      USE kinds,                ONLY : DP
      USE scf,                  ONLY : kedtau, v, vltot, vrs
      USE lsda_mod,             ONLY : nspin
      USE gvecs,                ONLY : doublegrid
      !
      IMPLICIT NONE
      REAL(DP),INTENT(IN)             :: potential(:,:)
      LOGICAL,INTENT(in),OPTIONAL     :: gather
      !
      LOGICAL :: gather_
      !
      gather_ = .true.
      IF ( present(gather) ) gather_ = gather
      !
      call qepy_get_value(potential, vrs, gather = gather_)
      !
      CALL interpolate_vrs( dfftp%nnr, nspin, doublegrid, kedtau, v%kin_r, vrs )
      !
   END SUBROUTINE

   SUBROUTINE qepy_calc_density(rhor, gather)
      USE kinds,                ONLY : DP
      USE wvfct,                ONLY : nbnd, et
      USE klist,                ONLY : nks, nkstot
      !
      IMPLICIT NONE
      REAL(DP), INTENT(OUT),OPTIONAL :: rhor(:,:)
      LOGICAL,INTENT(in),OPTIONAL :: gather
      !
      CALL poolrecover( et, nbnd, nkstot, nks )
      CALL sum_band()
      !
      IF ( present(rhor) ) THEN
         IF ( present(gather) ) THEN
            call qepy_get_rho(rhor, gather)
         ELSE
            call qepy_get_rho(rhor)
         ENDIF
      ENDIF
   END SUBROUTINE

   SUBROUTINE qepy_diagonalize(iter, threshold)
      USE klist,                ONLY : nks, nkstot
      USE bp,                   ONLY : lelfield
      USE control_flags,        ONLY : ethr
      !
      IMPLICIT NONE
      INTEGER,INTENT(in),OPTIONAL :: iter
      REAL(DP),INTENT(in),OPTIONAL :: threshold
      !
      INTEGER                     :: it = 1
      !
      IF ( present(iter) ) it = iter
      IF ( present(threshold) ) ethr = threshold
      !
      IF ( lelfield ) THEN
         CALL c_bands_efield( it )
      ELSE
         CALL c_bands( it )
      ENDIF
   END SUBROUTINE

   SUBROUTINE qepy_update_ions(pos, ikind, lattice)
      !-----------------------------------------------------------------------
      ! This is function Combined 'run_pwscf' and 'move_ions'.
      !***********************************************************************
      ! pos:
      !   ionic positions in bohr
      ! ikind:
      !   ikind = 0  all
      !   ikind = 1  atomic configuration dependent information
      ! lattice:
      !   lattice parameter in bohr
      !***********************************************************************
      !-----------------------------------------------------------------------
      USE mp_images,            ONLY : intra_image_comm
      USE extrapolation,        ONLY : update_file, update_pot
      USE io_global,            ONLY : ionode_id, ionode
      USE ions_base,            ONLY : nat, ityp, tau
      USE symm_base,            ONLY : checkallsym
      USE mp,                   ONLY : mp_bcast
      USE control_flags,        ONLY : treinit_gvecs
      USE cell_base,            ONLY : alat, at, bg, omega, cell_force, &
                                     fix_volume, fix_area, ibrav, enforce_ibrav
      USE cellmd,               ONLY : omega_old, at_old, press, lmovecell, calc, cell_factor
      !
      !
      INTEGER                  :: ierr
      REAL(DP), INTENT(IN) :: pos(:,:)
      INTEGER,INTENT(IN),OPTIONAL  :: ikind
      REAL(DP), INTENT(IN), OPTIONAL  :: lattice(3,3)
      !
      INTEGER   :: iflag
      LOGICAL :: lmovecell_
      !
      IF ( present(ikind) ) THEN
         iflag = ikind
      ELSE
         iflag = 0
      ENDIF
      !
      IF ( present(lattice) ) THEN
         IF (.not. lmovecell) THEN
            call errore("qepy_update_ions","lattice update only works for calculation= 'vc-relax' and 'vc-md'.",1)
            ! This is due to the `gshells` function in the initialization will set `ngl`, which is one of the shape of `vloc`.
         ENDIF
         lmovecell_ = .TRUE.
      ELSE
         lmovecell_ = .FALSE.
      ENDIF

      CALL update_file()

      IF ( ionode ) THEN
         tau(:,:)=pos(:,:) / alat
         IF ( lmovecell_ ) THEN
            !
            IF (ALLOCATED(embed%extpot)) DEALLOCATE(embed%extpot)
            !
            at_old = at
            omega_old = omega
            IF (fix_volume) CALL impose_deviatoric_strain( alat*at, lattice )
            IF (fix_area)   CALL impose_deviatoric_strain_2d( alat*at, lattice )
            at = lattice / alat
            IF(enforce_ibrav) CALL remake_cell( ibrav, alat, at(1,1),at(1,2),at(1,3) )
            CALL recips( at(1,1),at(1,2),at(1,3), bg(1,1),bg(1,2),bg(1,3) )
            CALL volume( alat, at(1,1),at(1,2),at(1,3), omega )
            !
         ENDIF
         CALL checkallsym( nat, tau, ityp)
      ENDIF
      !
      CALL mp_bcast( tau, ionode_id, intra_image_comm )
      !
      IF ( lmovecell_ ) THEN
         !
         CALL mp_bcast( at,        ionode_id, intra_image_comm )
         CALL mp_bcast( at_old,    ionode_id, intra_image_comm )
         CALL mp_bcast( omega,     ionode_id, intra_image_comm )
         CALL mp_bcast( omega_old, ionode_id, intra_image_comm )
         CALL mp_bcast( bg,        ionode_id, intra_image_comm )
         !
      ENDIF
      IF (iflag == 0 ) THEN
         CALL punch( 'config-nowf' )
         IF ( treinit_gvecs ) THEN
            CALL reset_gvectors()
         ELSE
            CALL update_pot()
            CALL hinit1()
         END IF
      ELSE IF (iflag == 1 ) THEN
         CALL set_rhoc()
         CALL hinit1()
      END IF
   END SUBROUTINE

   SUBROUTINE qepy_restart_from_xml()
      USE symm_base,            ONLY : irt
      USE force_mod,            ONLY : force
      USE ions_base,            ONLY : extfor
      USE extfield,             ONLY : forcefield, forcegate
      USE pw_restart_new,       ONLY : read_xml_file
      !
      LOGICAL              :: wfc_is_collected
      !
      IF (ALLOCATED(irt)) DEALLOCATE(irt)
      IF (ALLOCATED(force)) DEALLOCATE(force)
      IF (ALLOCATED(extfor)) DEALLOCATE(extfor)
      IF (ALLOCATED(forcefield)) DEALLOCATE(forcefield)
      IF (ALLOCATED(forcegate)) DEALLOCATE(forcegate)
      !
      CALL read_xml_file(wfc_is_collected)
      !
   END SUBROUTINE

   SUBROUTINE qepy_sum_band(occupations)
      USE fixed_occ,            ONLY : tfixed_occ, f_inp
      !
      REAL(DP),INTENT(in),OPTIONAL :: occupations(:,:)
      !
      IF ( present(occupations) ) THEN
         IF (ALLOCATED(f_inp)) DEALLOCATE(f_inp)
         ALLOCATE(f_inp(size(occupations,1), size(occupations,2)))
         f_inp(:,:) = occupations(:,:)
         tfixed_occ = .TRUE.
      ELSE
         tfixed_occ = .FALSE.
         IF (ALLOCATED(f_inp)) DEALLOCATE(f_inp)
      ENDIF
      !
      CALL sum_band()
      !
   END SUBROUTINE

   SUBROUTINE qepy_get_tau(tau, gather)
      USE kinds,                ONLY : DP
      use scf,                  ONLY : rho
      USE wavefunctions,        ONLY : psic
      USE fft_base,                ONLY : dfftp
      USE lsda_mod,             ONLY : nspin
      USE fft_interfaces,       ONLY : invfft
      USE control_flags,        ONLY : diago_full_acc, gamma_only, lxdm, tqr
      !
      IMPLICIT NONE
      REAL(DP), INTENT(OUT) :: tau(:,:)
      LOGICAL,INTENT(in),OPTIONAL :: gather
      !
      LOGICAL :: gather_
      INTEGER :: is
      !
      gather_ = .true.
      IF ( present(gather) ) gather_ = gather
      !
      !DO is = 1, nspin
         !psic(:) = ( 0.D0, 0.D0 )
         !psic(dfftp%nl(:)) = rho%kin_g(:,is)
         !IF ( gamma_only ) psic(dfftp%nlm(:)) = CONJG( rho%kin_g(:,is) )
         !CALL invfft ('Rho', psic, dfftp)
         !rho%kin_r(:,is) = psic(:)
      !END DO
      !
      call qepy_get_value(rho%kin_r, tau, gather = gather_)
   END SUBROUTINE

   SUBROUTINE qepy_open_files(io_level)
      USE kinds,                ONLY : DP
      USE io_files,             ONLY : nwordwfc, iunwfc
      USE control_flags,        ONLY : io_level_ => io_level
      USE buffers,              ONLY : open_buffer
      !
      IMPLICIT NONE
      INTEGER,INTENT(in),OPTIONAL :: io_level
      !
      INTEGER                     :: level
      LOGICAL :: exst_mem, exst_file, opnd
      !
      IF ( present(io_level) ) THEN
         level = io_level
      ELSE
         level = io_level_
      ENDIF
      !
      INQUIRE( UNIT = iunwfc, OPENED = opnd )
      IF ( .not. opnd ) CALL open_buffer( iunwfc, 'wfc', nwordwfc, level, exst_mem, exst_file )
      !
   END SUBROUTINE

   SUBROUTINE qepy_set_dft(dft)
      USE kinds,                ONLY : DP
      USE funct,                ONLY : dft_is_meta, enforce_input_dft
      USE fft_base,             ONLY : dffts
      USE lsda_mod,             ONLY : nspin
      USE gvect,                ONLY : ngm
      USE scf,                  ONLY : rho, vnew, v, kedtau
      !
      IMPLICIT NONE
      CHARACTER(LEN=*),INTENT(IN),OPTIONAL  :: dft
      !
      LOGICAL :: is_meta
      !
      is_meta = dft_is_meta()
      IF ( present(dft) ) THEN
         call enforce_input_dft(dft)
      ELSE
         call enforce_input_dft('M06L')
      ENDIF
      !
      IF ( dft_is_meta() .and. (.not. is_meta) ) THEN
         IF (ALLOCATED(kedtau)) DEALLOCATE(kedtau)
         ALLOCATE( kedtau(dffts%nnr,nspin) )
         !
         IF (ALLOCATED(rho%kin_r)) DEALLOCATE(rho%kin_r)
         IF (ALLOCATED(rho%kin_g)) DEALLOCATE(rho%kin_g)
         ALLOCATE( rho%kin_r(dfftp%nnr,nspin) )
         ALLOCATE( rho%kin_g(ngm,nspin) )
         !
         IF (ALLOCATED(v%kin_r)) DEALLOCATE(v%kin_r)
         IF (ALLOCATED(v%kin_g)) DEALLOCATE(v%kin_g)
         ALLOCATE( v%kin_r(dfftp%nnr,nspin) )
         ALLOCATE( v%kin_g(ngm,nspin) )
         !
         IF (ALLOCATED(vnew%kin_r)) DEALLOCATE(vnew%kin_r)
         IF (ALLOCATED(vnew%kin_g)) DEALLOCATE(vnew%kin_g)
         ALLOCATE( vnew%kin_r(dfftp%nnr,nspin) )
         ALLOCATE( vnew%kin_g(ngm,nspin) )
      ENDIF
      !
   END SUBROUTINE

END MODULE qepy_mod

!
! Copyright (C) 2001-2018 Quantum-ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!

!-----------------------------------------------------------------------
!PROGRAM tddft_main
SUBROUTINE qepy_tddft_main_initial(infile, my_world_comm)
  !-----------------------------------------------------------------------
  !
  ! ... This is the main driver of the real time TDDFT propagation.
  ! ... Authors: Xiaofeng Qian and Davide Ceresoli
  ! ...
  ! ... References:
  ! ...   Xiaofeng Qian, Ju Li, Xi Lin, and Sidney Yip, PRB 73, 035408 (2006)
  ! ...
  USE kinds,           ONLY : DP
  USE io_global,       ONLY : stdout, meta_ionode, meta_ionode_id
  USE tddft_module,    ONLY : job, molecule, max_seconds
  USE check_stop,      ONLY : check_stop_init
  USE control_flags,   ONLY : io_level, gamma_only, use_para_diag
  USE mp_global,       ONLY : mp_startup
  USE mp_bands,        ONLY : nbgrp
  USE mp_world,        ONLY : world_comm
  USE environment,     ONLY : environment_start, environment_end
  USE wvfct,           ONLY : nbnd
  USE io_global,       ONLY : stdout
  USE noncollin_module,ONLY : noncolin
  ! for pluginization
  USE input_parameters, ONLY : nat_ => nat, ntyp_ => ntyp
  USE input_parameters, ONLY : assume_isolated_ => assume_isolated, &
                               ibrav_ => ibrav
  USE ions_base,        ONLY : nat, ntyp => nsp
  USE cell_base,        ONLY : ibrav
  !USE tddft_version
  USE iotk_module  
  !------------------------------------------------------------------------
  IMPLICIT NONE
  CHARACTER (LEN=9)   :: code = 'TDDFT'
  LOGICAL, EXTERNAL  :: check_para_diag
  !
  CHARACTER(len=*) :: infile
  INTEGER, INTENT(IN), OPTIONAL :: my_world_comm
  !------------------------------------------------------------------------

  ! begin with the initialization part
#ifdef __MPI
  IF ( PRESENT(my_world_comm)) THEN
     CALL mp_startup(my_world_comm=my_world_comm, start_images=.TRUE. )
  ELSE
     CALL mp_startup( start_images=.TRUE. )
  ENDIF
#else
  IF ( PRESENT(my_world_comm)) THEN
     CALL mp_startup(my_world_comm=my_world_comm, start_images=.false. )
  ELSE
     CALL mp_startup( start_images=.false. )
  ENDIF
#endif
  call environment_start (code)

  ! read plugin command line arguments, if any
  if (meta_ionode) call plugin_arguments()
  call plugin_arguments_bcast( meta_ionode_id, world_comm )

#ifndef __BANDS
  if (nbgrp > 1) &
    !call errore('tddft_main', 'configure and recompile TDDFT with --enable-band-parallel', 1)
    call errore('tddft_main', 'reinstall the TDDFT with -D__BANDS', 1)
#endif

  write(stdout,*)
  !write(stdout,'(5X,''***** This is TDDFT git revision '',A,'' *****'')') tddft_git_revision
  write(stdout,'(5X,''***** you can cite: X. Qian et al. Phys. Rev. B 73, 035408 (2006)         *****'')')
  write(stdout,'(5X,''***** in publications or presentations arising from this work.            *****'')')
  write(stdout,*)

  call qepy_tddft_readin(infile)
  !call check_stop_init( max_seconds )

  io_level = 1
 
  !! read ground state wavefunctions
  !call read_file
END SUBROUTINE qepy_tddft_main_initial
!
SUBROUTINE qepy_tddft_main_setup(embed)
  !-----------------------------------------------------------------------
  !
  ! ... This is the main driver of the real time TDDFT propagation.
  ! ... Authors: Xiaofeng Qian and Davide Ceresoli
  ! ...
  ! ... References:
  ! ...   Xiaofeng Qian, Ju Li, Xi Lin, and Sidney Yip, PRB 73, 035408 (2006)
  ! ...
  USE kinds,           ONLY : DP
  USE io_global,       ONLY : stdout, meta_ionode, meta_ionode_id
  USE mp,              ONLY : mp_bcast
  USE tddft_module,    ONLY : job, molecule, max_seconds
  USE check_stop,      ONLY : check_stop_init
  USE control_flags,   ONLY : io_level, gamma_only, use_para_diag
  USE mp_global,       ONLY : mp_startup
  USE mp_bands,        ONLY : nbgrp
  USE mp_world,        ONLY : world_comm
  USE environment,     ONLY : environment_start, environment_end
  USE wvfct,           ONLY : nbnd
  USE io_global,       ONLY : stdout
  USE noncollin_module,ONLY : noncolin
  ! for pluginization
  USE input_parameters, ONLY : nat_ => nat, ntyp_ => ntyp
  USE input_parameters, ONLY : assume_isolated_ => assume_isolated, &
                               ibrav_ => ibrav
  USE ions_base,        ONLY : nat, ntyp => nsp
  USE cell_base,        ONLY : ibrav
  !USE tddft_version
  USE iotk_module  
  !
  USE qepy_common,             ONLY : embed_base
  !
  !------------------------------------------------------------------------
  IMPLICIT NONE
  CHARACTER (LEN=9)   :: code = 'TDDFT'
  LOGICAL, EXTERNAL  :: check_para_diag
  !
  TYPE(embed_base), INTENT(INOUT)    :: embed
  !------------------------------------------------------------------------
#ifdef __MPI
  use_para_diag = check_para_diag(nbnd)
#else
  use_para_diag = .false.
#endif

  io_level = 1

  call tddft_openfil

  if (gamma_only) call errore ('tdddft_main', 'Cannot run TDFFT with gamma_only == .true. ', 1)
#ifdef __BANDS
  if (nbgrp > 1 .and. (twfcollect .eqv. .false.)) &
    call errore('tddft_main', 'Cannot use band-parallelization without wf_collect in SCF', 1)
#endif
  if (noncolin) call errore('tdddft_main', 'non-collinear not supported yet', 1)

  nat_ = nat
  ntyp_ = ntyp
  ibrav_ = ibrav
  assume_isolated_ = 'none'
  call plugin_read_input()
  call qepy_tddft_allocate()
  call qepy_tddft_setup(embed)
  call tddft_summary()

#ifdef __BANDS
  call init_parallel_over_band(inter_bgrp_comm, nbnd)
#endif

  ! calculation
  !select case (trim(job))
  !case ('optical')
  !   if (molecule) then
  !      call qepy_molecule_optical_absorption(embed)
  !   else
  !      call errore('tddft_main', 'solids are not yet implemented', 1)
  !   endif

  !case default
  !   call errore('tddft_main', 'wrong or undefined job in input', 1)

  !end select
  
END subroutine qepy_tddft_main_setup
!
SUBROUTINE qepy_stop_tddft(print_flag)
  USE environment,     ONLY : environment_start, environment_end
  !
  IMPLICIT NONE
  INTEGER, INTENT(IN), OPTIONAL :: print_flag
  INTEGER             :: iprint
  CHARACTER (LEN=9)   :: code = 'TDDFT'
  !
  IF ( PRESENT(print_flag)) THEN
     iprint = print_flag
  ELSE
     iprint = 0
  ENDIF

  ! print timings and stop the code
  call qepy_tddft_closefil
  IF ( iprint > 0 .and. iprint<10 ) THEN
  call print_clock_tddft
  call environment_end(code)
  ENDIF
  !call stop_code( .true. )
  !STOP
END SUBROUTINE qepy_stop_tddft

!END PROGRAM tddft_main

!
! Copyright (C) 2001-2013 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
!----------------------------------------------------------------------------
subroutine pwscf()
  !! Author: Paolo Giannozzi
  !
  !! Version: v6.1
  !
  !! License: GNU
  !
  !! Summary: Main program calling one or more instances of Plane Wave Self-Consistent Field code
  !
  !! This is the main program for executable "pw.x".  |
  !! * If called as "pw.x -ipi server-address" or "pw.x --ipi server-address",
  !! works in "server" mode, calls [[run_driver]].
  !! * If called as "manypw.x" via a link, works in "manypw" mode, runs many
  !! instances (images) of pw.x (see [[run_manypw]])
  !! * If called as "dist.x" via a link, works in "dry run" mode, computes
  !! distances, angles, neighbors, writes to file "dist.out" and stops. 
  !! Otherwise: see [[run_pwscf]]
  !!
  !! @Note
  !! 10/01/17 Samuel Ponce: Add Ford documentation
  !! @endnote
  !!
  !! @warning
  !! Example of Warning
  !!
  !! @todo
  !! Have automatic parallelisation. 
  !!
  !! @bug
  !! No bug.
  !!
  USE environment,          ONLY : environment_start
  USE mp_global,            ONLY : mp_startup
  USE mp_world,             ONLY : world_comm
  USE mp_pools,             ONLY : intra_pool_comm
  USE mp_bands,             ONLY : intra_bgrp_comm, inter_bgrp_comm
  USE mp_diag,              ONLY : mp_start_diag
  USE mp_exx,               ONLY : negrp
  USE read_input,           ONLY : read_input_file
  USE command_line_options, ONLY : input_file_, command_line, ndiag_
  !
  IMPLICIT NONE
  !
  CHARACTER(len=256) :: srvaddress
  !! Get the address of the server 
  CHARACTER(len=256) :: get_server_address
  !! Get the address of the server 
  INTEGER :: exit_status
  !! Status at exit
  LOGICAL :: use_images, do_diag_in_band_group = .TRUE.
  !! true if running "manypw.x"
  LOGICAL, EXTERNAL :: matches
  !! checks if first string is contained in the second
  !
  CALL mp_startup( start_images=.TRUE. )
  !
  IF( negrp > 1 .OR. do_diag_in_band_group ) THEN
     ! used to be the default : one diag group per bgrp
     ! with strict hierarchy: POOL > BAND > DIAG
     ! if using exx groups from mp_exx still use this diag method
     CALL mp_start_diag( ndiag_, world_comm, intra_bgrp_comm, &
                         do_distr_diag_inside_bgrp_ = .TRUE. )
  ELSE
     ! new default: one diag group per pool ( individual k-point level )
     ! with band group and diag group both being children of POOL comm
     CALL mp_start_diag( ndiag_, world_comm, intra_pool_comm, &
                         do_distr_diag_inside_bgrp_ = .FALSE. )
  ENDIF
  !
  CALL set_mpi_comm_4_solvers( intra_pool_comm, intra_bgrp_comm, &
                               inter_bgrp_comm )
  !
  CALL environment_start( 'PWSCF' )
  !
  ! ... Check if running standalone or in "driver" mode
  !
  srvaddress = get_server_address( command_line ) 
  !
  ! ... Check if running standalone or in "manypw" mode
  !
  use_images = matches( 'manypw.x', command_line )
  !
  ! ... Perform actual calculation
  !
  IF ( TRIM(srvaddress) == ' ' ) THEN
    ! When running standalone:
    IF ( use_images ) THEN
       ! as manypw.x
       CALL run_manypw( )
       CALL run_pwscf( exit_status )
       !
     ELSE
       ! as pw.x
       CALL read_input_file( 'PW', input_file_ )
       CALL run_pwscf( exit_status )
       !
    ENDIF
  ELSE
     ! When running as library
     !
     CALL read_input_file('PW+iPi', input_file_ )
     CALL run_driver( srvaddress, exit_status )
     !
  ENDIF
  !
  CALL laxlib_free_ortho_group()
  CALL stop_run( exit_status )
  CALL do_stop( exit_status )
  !
  !STOP
  !
END subroutine pwscf

!
! Copyright (C) 2001-2019 Quantum-ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!

!-----------------------------------------------------------------------
subroutine qepy_molecule_optical_absorption(embed)
  !----------------------------------------------------------------------
  !  ... Compute optical absorption spectrum by real-time TDDFT 
  !  ... References:
  !      (1) Phys. Rev. B 73, 035408 (2006)
  !      (2) http://www.netlib.org/linalg/html_templates/Templates.html
  !                                             Xiaofeng Qian, MIT (2008)
  !----------------------------------------------------------------------
  USE kinds,                       ONLY : dp
  USE io_global,                   ONLY : stdout, ionode
  USE io_files,                    ONLY : nwordwfc, iunwfc
  USE ions_base,                   ONLY : nat, if_pos
  USE cell_base,                   ONLY : at, tpiba, alat
  USE wavefunctions,               ONLY : evc
  USE klist,                       ONLY : nks, nkstot, wk, xk, nelec, ngk, igk_k
  USE wvfct,                       ONLY : nbnd, npwx, wg, g2kin, current_k
  USE lsda_mod,                    ONLY : current_spin, lsda, isk, nspin
  USE becmod,                      ONLY : becp, calbec, allocate_bec_type, &
                                          is_allocated_bec_type, deallocate_bec_type
  USE mp_pools,                    ONLY : inter_pool_comm
  USE mp,                          ONLY : mp_sum, mp_barrier
  USE gvect,                       ONLY : g
  USE fft_base,                    ONLY : dfftp, dffts
  USE buffers,                     ONLY : get_buffer, save_buffer
  USE fixed_occ,                   ONLY : tfixed_occ 
  USE uspp,                        ONLY : nkb, vkb
  USE dynamics_module,             ONLY : vel, verlet, allocate_dyn_vars, deallocate_dyn_vars
  USE pwcom
  USE tddft_module
  !
  USE qepy_common,             ONLY : embed_base
  USE qepy_tddft_common,       ONLY : tddft_psi, b, &
                                      tddft_hpsi, tddft_spsi, &
                                      tddft_Ppsi, &
                                      charge, dipole, quadrupole, &
                                      circular, circular_local
  USE uspp,                    ONLY : nkb, vkb, okvan
  !
  IMPLICIT NONE

  !-- tddft variables ----------------------------------------------------
  !complex(dp), allocatable :: tddft_psi(:,:,:), b(:,:)
  !complex(dp), allocatable :: tddft_hpsi(:,:), tddft_spsi(:,:)
  !complex(dp), allocatable :: tddft_Ppsi(:,:)        ! PAW correction to forces (Ehrenfest)
  !real(dp), allocatable :: charge(:), dipole(:,:), quadrupole(:,:,:)
  !complex(dp), allocatable :: circular(:,:), circular_local(:)

  integer :: istep, lter, flag_global
  integer :: ik, is, ibnd
  complex(dp),save :: ee                     ! i*dt/2
  real(dp),save :: anorm, wclock
  integer, external :: find_free_unit
  real(dp), external :: get_clock
  external tddft_ch_psi_all
  !
  TYPE(embed_base), INTENT(INOUT)    :: embed
  INTEGER :: iter
  !
  INTEGER :: iuntemp ! unit for swap

  ! TODO: restart
  IF (embed%tddft%finish) goto 111
  IF (embed%tddft%initial) THEN
  ! allocate memory
  call allocate_optical()

  ee = i_complex * dt / 2.d0  ! i*dt/2: do not change
  
  !evc = cmplx(0.d0,0.d0)
  call tddft_cgsolver_initialize(npwx, nbnd_occ_max)
  if (iverbosity > 0) then
    write(stdout,'(5X,''Done with tddft_cgsolver_initialize'')')
    flush(stdout)
  endif
 
  ! print the legend
  if (ionode) call print_legend
  
  ! check if we are restarting
  if (l_tddft_restart) then

     do ik = 1, nks
        current_k = ik
        current_spin = isk(ik)
        npw = ngk(ik)
 
        ! initialize at k-point k
        call g2_kin(ik)
        call init_us_2(npw, igk_k(1,ik), xk(1,ik), vkb)
        
        ! read wfcs from file and compute becp
        evc = (0.d0, 0.d0)
        call get_buffer (evc, nwordwfc, iunevcn, ik)
     end do
     
     !qepy <--
     ! replace the iunwfc with iunevcn for sum_band
     iuntemp = iunwfc
     iunwfc = iunevcn
     if (okvan .and. is_allocated_bec_type(becp)) call deallocate_bec_type(becp)
     call sum_band()
     !qepy -->
     call qepy_update_hamiltonian(-1, embed)
     iunwfc = iuntemp
 
     if (iverbosity > 0) write(stdout,'(5X,''Done with restart'')')
  else
     embed%tddft%istep = 0
  endif


  if (ehrenfest) then
     call allocate_dyn_vars()
     vel(:,:) = 0.d0
     !allocate(if_pos(3,nat)) ! Ehrenfest work around
     !if_pos(:,:) = 1
  endif

  IF (.NOT.ALLOCATED(if_pos)) THEN
  allocate(if_pos(3,nat)) ! Forces
  ENDIF
  if_pos(:,:) = 1

  if (isave_rho /= 0) call save_rho(0)

  ! enter the main TDDFT loop
  wclock = get_clock('TDDFT')
  embed%tddft%initial = .FALSE.
  endif ! end IF (embed%tddft%initial)
  do iter = 1, nstep
    embed%tddft%istep = embed%tddft%istep + 1
    istep = embed%tddft%istep
     
    call qepy_update_hamiltonian(istep, embed)

    ! calculate dipole moment along x, y, and z direction
    call molecule_compute_dipole( charge, dipole )
    !call molecule_compute_quadrupole( quadrupole )

    ! loop over k-points     
    do ik = 1, nks
      current_k = ik
      current_spin = isk(ik)
      npw = ngk(ik)
 
      ! initialize at k-point k
      call g2_kin(ik)
      call init_us_2(npw, igk_k(1,ik), xk(1,ik), vkb)
      
      !print*, 'iunit', iunwfc, iunevcn, istep
      if (nks>1 .or. ( l_tddft_restart .and. (istep == 1) ) ) then
      ! read wfcs from file and compute becp
      evc = (0.d0, 0.d0)
      if (istep == 1) then
        call get_buffer (evc, nwordwfc, iunwfc, ik)
      else
        call get_buffer (evc, nwordwfc, iunevcn, ik)
      endif
      endif
      if (.not. is_allocated_bec_type(becp)) call allocate_bec_type(nkb, nbnd, becp)
      call calbec( npw, vkb, evc, becp )
      if (nks>1) then
      !if ( (istep > 1) .or. (l_tddft_restart .and. (istep == 1)) ) then
      if ( istep > 1 ) then
        call get_buffer (tddft_psi, nwordtdwfc, iuntdwfc, ik)
      endif
      endif
      if ( l_tddft_restart .and. (istep == 1) ) then
        call get_buffer (tddft_psi, nwordtdwfc, iuntdwfc, ik)
      endif

      ! apply electric field
      if (istep == 1 .and. (.not. l_tddft_restart)) &
        call apply_electric_field(tddft_psi)
        
      ! calculate circular dichroism along x, y, and z direction
      if (l_circular_dichroism)  then
        circular_local = (0.d0, 0.d0)
        circular = (0.d0, 0.d0)
        call compute_circular_dichroism(circular_local)
        circular(1:3, current_spin) = circular_local(1:3)
      end if
        
      ! guess the wavefunction at the next timestep
      tddft_psi(:,:,1) = (0.d0,0.d0)
      do ibnd = 1, nbnd_occ(ik)
        tddft_psi(:,ibnd,1) = 2.d0*evc(:,ibnd) - tddft_psi(:,ibnd,2)
      enddo

      ! calculate H |psi_current>, S |psi_current>
      call h_psi(npwx, npw, nbnd_occ(ik), evc, tddft_hpsi)
      call s_psi(npwx, npw, nbnd_occ(ik), evc, tddft_spsi)
              
      ! calculate (S - H*dt*i/2) |\psi_current>
      b(1:npw, 1:nbnd_occ(ik)) = tddft_spsi(1:npw,1:nbnd_occ(ik)) - ee * tddft_hpsi(1:npw,1:nbnd_occ(ik))
        
      ! solve A * x = b
      call tddft_cgsolver(tddft_ch_psi_all, b, tddft_psi(:,:,1), npwx, npw, &
                          conv_threshold, ik, lter, flag_global, anorm, &
                          nbnd_occ(ik), ee)
 
      ! update the wavefunctions
      tddft_psi(:,:,2) = tddft_psi(:,:,1)
      evc(:,1:nbnd_occ(ik)) = tddft_psi(:,1:nbnd_occ(ik),1)

      ! save wavefunctions to disk
      call save_buffer (evc, nwordwfc, iunevcn, ik)
      call save_buffer (tddft_psi(:,:,1:2), nwordtdwfc, iuntdwfc, ik)
        
    enddo ! ik

#ifdef __MPI
    ! reduce over k-points
    if (l_circular_dichroism) call mp_sum(circular, inter_pool_comm)
    call mp_sum(charge, inter_pool_comm)
    call mp_sum(dipole, inter_pool_comm)
#endif

    ! update the hamiltonian (recompute charge and potential)
    !call qepy_update_hamiltonian(istep, embed)
    !qepy <--
    ! replace the iunwfc with iunevcn for sum_band
    iuntemp = iunwfc
    iunwfc = iunevcn
    if (okvan .and. is_allocated_bec_type(becp)) call deallocate_bec_type(becp)
    call sum_band()
    iunwfc = iuntemp
    !qepy -->

    ! print observables
    if (ionode) then
      do is = 1, nspin
        write(stdout,'(''ENERGY '',2X,I6,E24.15,4F16.8)') istep, etot, eband + deband, ehart, etxc+etxcc, ewld
        write(stdout,'(''CHARGE '',I1,1X,I6,3E24.15)') is, istep, charge(is)
        write(stdout,'(''DIP    '',I1,1X,I6,3E24.15)') is, istep, dipole(:,is)
        if (iverbosity > 11) write(stdout,'(''CPUTIME'',F16.6)') get_clock('TDDFT') - wclock
        wclock = get_clock('TDDFT')
        !write(stdout,'(''QUAD   '',I1,1X,I6,9E18.9)') is, istep, quadrupole(:,:,is)
        !write(stdout,'(''ANG    '',I1,1X,I6,3E16.6)') is, istep, circular(:,is)
      enddo
    endif

    ! output fields
    if (isave_rho /= 0) then
        if (mod(istep,isave_rho) == 0) call save_rho(istep)
    endif

    ! Ehrenfest dynamics
    if (ehrenfest) then
       if (is_allocated_bec_type(becp)) call deallocate_bec_type(becp)
       call forces()
       call verlet()
       call trajectoryXYZ()
    endif
     
    flush(stdout)
    !qepy -->
    IF (.NOT.ALLOCATED(embed%tddft%dipole)) ALLOCATE(embed%tddft%dipole(3, nspin))
    IF (size(embed%tddft%dipole,2) /= nspin) THEN
       DEALLOCATE(embed%tddft%dipole)
       ALLOCATE(embed%tddft%dipole(3, nspin))
    ENDIF
    embed%tddft%dipole = dipole
    if (embed%tddft%iterative) return
    !qepy <--
     
  enddo      ! end of TDDFT loop
  write(stdout,*)

  ! finish  
111 call optical_finalize()
    embed%tddft%initial = .TRUE.
    embed%tddft%finish = .FALSE.
  !call tddft_cgsolver_finalize()
  !call deallocate_optical()
  !if (ehrenfest) call deallocate_dyn_vars() 
    
CONTAINS
  SUBROUTINE optical_finalize()
     call tddft_cgsolver_finalize()
     call deallocate_optical()
     if (ehrenfest) call deallocate_dyn_vars() 
  END SUBROUTINE optical_finalize

  !====================================================================
  ! Print the legend key
  !====================================================================    
  SUBROUTINE print_legend
    write(stdout,'(5X,''Output quantities:'')')
    write(stdout,'(5X,''  ENERGY istep etot eband ehart etxc ewld'')')
    write(stdout,'(5X,''  CHARGE spin  istep  charge'')')
    write(stdout,'(5X,''  DIP    spin  istep  dipole(1:3)'')')
    !write(stdout,'(5X,''  QUAD   spin  istep  quadrupole(1:3,1:3)'')')
    !write(stdout,'(5X,''  ANG    spin  istep  Re[L(1:3)]  Im[L(1:3)]'')')
    write(stdout,*)
    flush(stdout)
  END SUBROUTINE print_legend

  
  !====================================================================
  ! Initialize and allocate memory
  !====================================================================    
  SUBROUTINE allocate_optical()
    USE becmod, ONLY : becp, allocate_bec_type, is_allocated_bec_type
    IMPLICIT NONE
    integer :: ik
    
    nbnd_occ_max = 0
    do ik = 1, nks
      if (nbnd_occ(ik) > nbnd_occ_max) nbnd_occ_max = nbnd_occ(ik)
    enddo

    if (.not. is_allocated_bec_type(becp)) call allocate_bec_type(nkb, nbnd, becp)
   
    allocate (tddft_psi (npwx,nbnd,2))
    allocate (tddft_hpsi(npwx,nbnd_occ_max))
    allocate (tddft_spsi(npwx,nbnd_occ_max))
    allocate (b(npwx,nbnd_occ_max))
    tddft_psi = (0.d0,0.d0)
    tddft_hpsi = (0.d0,0.d0)
    tddft_spsi = (0.d0,0.d0)
    b = (0.d0,0.d0)

    if (ehrenfest) allocate(tddft_Ppsi(npwx,nbnd))
 
    allocate (charge(nspin), dipole(3,nspin), quadrupole(3,3,nspin))
    allocate (circular(3,nspin), circular_local(3))
    charge = 0.d0
    dipole = 0.d0
    quadrupole = 0.d0
    circular = (0.d0, 0.d0)
    circular_local = (0.d0, 0.d0)

    allocate (r_pos(3,dfftp%nnr), r_pos_s(3,dffts%nnr))
    call molecule_setup_r
    
  END SUBROUTINE allocate_optical
  
  
  !====================================================================
  ! Deallocate memory
  !====================================================================    
  SUBROUTINE deallocate_optical()
    USE becmod, ONLY : becp, deallocate_bec_type
    IMPLICIT NONE

    call deallocate_bec_type(becp)
    deallocate (tddft_psi, tddft_hpsi, tddft_spsi, b)
    deallocate (charge, dipole, quadrupole, circular, circular_local)
    deallocate (r_pos, r_pos_s)
    if (ehrenfest) deallocate(tddft_Ppsi)

  END SUBROUTINE deallocate_optical
   
   
  !====================================================================
  ! compute circular dichroism (EXPERIMENTAL, NORM-CONSERVING ONLY)
  !====================================================================      
  subroutine compute_circular_dichroism(cd)
    USE fft_base,               ONLY : dfftp
    USE fft_interfaces,         ONLY : invfft
    IMPLICIT NONE
    REAL(DP) :: xx(dfftp%nnr), yy(dfftp%nnr), zz(dfftp%nnr), gk
    INTEGER  :: ik, ibnd, i, j, k, j0, k0, idx, ir, ipol, ind, i_current_spin, ig
    complex(dp) :: p_psi(npwx), p_psi_r(dfftp%nnr, 3), cd(3, nspin), psic1(dfftp%nnr)
    
    xx(:) = 0.d0
    yy(:) = 0.d0
    zz(:) = 0.d0
    
    ! Loop in the charge array
    j0 = dfftp%my_i0r2p ; k0 = dfftp%my_i0r3p
    DO ir = 1, dfftp%nr1x*dfftp%my_nr2p*dfftp%my_nr3p
       !
       ! ... three dimensional indexes
       !
       idx = ir -1
       k   = idx / (dfftp%nr1x*dfftp%my_nr2p)
       idx = idx - (dfftp%nr1x*dfftp%my_nr2p)*k
       k   = k + k0
       j   = idx / dfftp%nr1x
       idx = idx - dfftp%nr1x * j
       j   = j + j0
       i   = idx

             xx(ir) = &
                  dble( i-1 )/dble(dfftp%nr1) * at(1,1) * alat + &
                  dble( j-1 )/dble(dfftp%nr2) * at(1,2) * alat + &
                  dble( k-1 )/dble(dfftp%nr3) * at(1,3) * alat
             
             yy(ir) = &
                  dble( i-1 )/dble(dfftp%nr1) * at(2,1) * alat + &
                  dble( j-1 )/dble(dfftp%nr2) * at(2,2) * alat + &
                  dble( k-1 )/dble(dfftp%nr3) * at(2,3) * alat
             
             zz(ir) = &
                  dble( i-1 )/dble(dfftp%nr1) * at(3,1) * alat + &
                  dble( j-1 )/dble(dfftp%nr2) * at(3,2) * alat + &
                  dble( k-1 )/dble(dfftp%nr3) * at(3,3) * alat
             
    end do
    
    cd(:,:) = (0.d0, 0.d0)
    
    do ik = 1, nks
       
       if (nbnd_occ(ik) > 0) then
          
       i_current_spin = isk(ik)
       
       do ibnd = 1, nbnd_occ(ik)
          
          p_psi_r(:, :) = (0.d0, 0.d0)
          do ipol = 1, 3
             p_psi(:) = (0.d0, 0.d0)
             do ig = 1, npw
                gk = xk(ipol,ik) + g(ipol,igk_k(ig,ik))
                p_psi(ig) = gk * tpiba * tddft_psi(ig, ibnd, ik)
             end do
             psic1(:) = (0.d0, 0.d0)
             psic1(dffts%nl(igk_k(1:npw,ik))) = p_psi(:)
             call invfft('Wave', psic1, dfftp)
             p_psi_r(:,ipol) = psic1(:)
          end do
          
          ! transform wavefunction from reciprocal space into real space
          psic1(:) = (0.d0, 0.d0)
          psic1(dffts%nl(igk_k(1:npw,ik))) = tddft_psi(1:npw, ibnd, ik)
          call invfft('Wave', psic1, dfftp)
          
          do ind = 1, dfftp%nnr
             cd(1, i_current_spin) = cd(1, i_current_spin) + &
                  conjg(psic1(ind)) * ( yy(ind) * p_psi_r(ind,3) - zz(ind) * p_psi_r(ind,2) )
             cd(2, i_current_spin) = cd(2, i_current_spin) + &
                  conjg(psic1(ind)) * ( zz(ind) * p_psi_r(ind,1) - xx(ind) * p_psi_r(ind,3) )
             cd(3, i_current_spin) = cd(3, i_current_spin) + &
                  conjg(psic1(ind)) * ( xx(ind) * p_psi_r(ind,2) - yy(ind) * p_psi_r(ind,1) )
          end do
          
          
       end do

       end if
       
    end do
    cd = cd  / dble(dfftp%nnr)
    
    
    RETURN
  end subroutine compute_circular_dichroism

END SUBROUTINE qepy_molecule_optical_absorption

!
! Copyright (C) 2001-2011 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
!
!----------------------------------------------------------------------
SUBROUTINE qepy_stress(sigma, icalc, embed)
  !----------------------------------------------------------------------
  !! Computes the total stress.
  !
  USE io_global,        ONLY : stdout
  USE kinds,            ONLY : DP
  USE cell_base,        ONLY : omega, alat, at, bg
  USE ions_base,        ONLY : nat, ntyp => nsp, ityp, tau, zv, atm
  USE constants,        ONLY : ry_kbar
  USE ener,             ONLY : etxc, vtxc
  USE gvect,            ONLY : ngm, gstart, g, gg, gcutm
  USE fft_base,         ONLY : dfftp
  USE ldaU,             ONLY : lda_plus_u, U_projection
  USE lsda_mod,         ONLY : nspin
  USE scf,              ONLY : rho, rho_core, rhog_core
  USE control_flags,    ONLY : iverbosity, gamma_only, llondon, ldftd3, lxdm, ts_vdw
  USE noncollin_module, ONLY : noncolin
  USE funct,            ONLY : dft_is_meta, dft_is_gradient
  USE symme,            ONLY : symmatrix
  USE bp,               ONLY : lelfield
  USE uspp,             ONLY : okvan
  USE london_module,    ONLY : stres_london
  USE dftd3_api,        ONLY : get_atomic_number, dftd3_calc
  USE dftd3_qe,         ONLY : dftd3_pbc_gdisp, dftd3
  USE xdm_module,       ONLY : stress_xdm
  USE exx,              ONLY : exx_stress
  USE funct,            ONLY : dft_is_hybrid
  USE tsvdw_module,     ONLY : HtsvdW
  USE ener,             ONLY : etot ! for ESM stress
  USE esm,              ONLY : do_comp_esm, esm_bc ! for ESM stress
  USE esm,              ONLY : esm_stres_har, esm_stres_ewa, esm_stres_loclong ! for ESM stress
  !
  USE qepy_common,          ONLY : embed_base
  !
  IMPLICIT NONE
  !
  REAL(DP), INTENT(OUT) :: sigma(3,3)
  !! The stress tensor
  !
  ! ... local variables
  !
  REAL(DP) :: sigmakin(3,3),  sigmaloc(3,3), sigmahar(3,3),                &
              sigmaxc(3,3),   sigmaxcc(3,3), sigmaewa(3,3), sigmanlc(3,3), &
              sigmabare(3,3), sigmah(3,3),   sigmael(3,3),  sigmaion(3,3), &
              sigmalon(3,3),  sigmad3(3,3),  sigmaxdm(3,3), sigma_ts(3,3), &
              sigma_nonloc_dft(3,3), sigmaexx(3,3)
  REAL(DP) :: sigmaloclong(3,3)  ! for ESM stress
  INTEGER  :: l, m
  !
  ! Auxiliary variables for Grimme-D3
  !
  INTEGER  :: atnum(1:nat)
  REAL(DP) :: latvecs(3,3)
  REAL(DP) :: stress_dftd3(3,3)
  REAL(DP), ALLOCATABLE :: force_d3(:,:)
  !
  integer, intent(in), optional   :: icalc
  type(embed_base),intent(inout),optional :: embed
  !
  integer                       :: calctype
  !
  if ( present(icalc) ) then
     calctype = icalc
  else
     calctype = 0
  end if
  !
  WRITE( stdout, '(//5x,"Computing stress (Cartesian axis) and pressure"/)' )
  !
  IF ( noncolin .AND. dft_is_gradient() ) THEN
     CALL infomsg( 'stres', 'noncollinear stress + GGA not implemented' )
     RETURN
  ELSE IF ( lelfield .AND. okvan ) THEN
     CALL infomsg( 'stres', 'stress with USPP and electric fields (Berry) not implemented' )
     RETURN
  END IF
  !
  CALL start_clock( 'stress' )
  !
  !   contribution from local  potential
  !
  CALL stres_loc( sigmaloc ) ! In ESM, sigmaloc has only short term.
  !
  !  hartree contribution
  !
  IF (.NOT.( do_comp_esm .AND. ( esm_bc /= 'pbc' ) )) CALL stres_har( sigmahar )
  !
  !  xc contribution (diagonal)
  !
  sigmaxc(:,:) = 0.d0
  DO l = 1, 3
     sigmaxc (l, l) = - (etxc - vtxc) / omega
  ENDDO
  !
  !  xc contribution: add gradient corrections (non diagonal)
  !
  CALL stres_gradcorr( rho%of_r, rho%of_g, rho_core, rhog_core, rho%kin_r, &
       nspin, dfftp, g, alat, omega, sigmaxc )
  !
  ! core correction contribution
  !
  CALL stres_cc( sigmaxcc )
  !
  IF ( do_comp_esm .AND. ( esm_bc /= 'pbc' ) ) THEN  ! for ESM stress
     CALL esm_stres_loclong( sigmaloclong, rho%of_g(:,1) ) ! long range part
     sigmaloc(:,:) = sigmaloc(:,:) + sigmaloclong(:,:)
  END IF
  !
  !  hartree contribution - for ESM stress
  !
  IF ( do_comp_esm .AND. ( esm_bc /= 'pbc' ) )  CALL esm_stres_har( sigmahar, rho%of_g(:,1) )
  !
  !  add meta-GGA contribution 
  !
  CALL stres_mgga( sigmaxc )
  !
  !  ewald contribution
  !
  IF ( do_comp_esm .AND. ( esm_bc /= 'pbc' ) ) THEN ! for ESM stress
     CALL esm_stres_ewa( sigmaewa )
  ELSE
     CALL stres_ewa( alat, nat, ntyp, ityp, zv, at, bg, tau, omega, g, &
          gg, ngm, gstart, gamma_only, gcutm, sigmaewa )
  END IF
  !
  !  semi-empirical dispersion contribution
  !
  sigmalon( : , : ) = 0.d0
  !
  IF ( llondon ) &
    sigmalon = stres_london( alat , nat , ityp , at , bg , tau , omega )
  !
  ! Grimme-D3 dispersion contribution
  !
  sigmad3(:,:) = 0.d0
  !
  IF ( ldftd3 ) THEN
    ALLOCATE( force_d3(3,nat) )
    force_d3( : , : ) = 0.0_DP
    latvecs(:,:) = at(:,:)*alat
    tau(:,:) = tau(:,:)*alat
    atnum(:) = get_atomic_number(atm(ityp(:)))
    CALL dftd3_pbc_gdisp( dftd3, tau, atnum, latvecs, &
                         force_d3, stress_dftd3 )
    sigmad3 = 2.d0*stress_dftd3
    tau(:,:)=tau(:,:)/alat
    DEALLOCATE( force_d3 )
  END IF
  !
  ! xdm dispersion
  sigmaxdm = 0._dp
  IF (lxdm) sigmaxdm = stress_xdm()
  !
  !  kinetic + nonlocal contribuition
  !
  CALL stres_knl( sigmanlc, sigmakin )
  !
  DO l = 1, 3
     DO m = 1, 3
        sigmabare(l, m) = sigmaloc(l, m) + sigmanlc(l, m)
     ENDDO
  ENDDO
  !
  !  Hubbard contribution
  !  (included by stres_knl if using beta as local projectors)
  !
  sigmah(:,:) = 0.d0
  IF ( lda_plus_u .AND. U_projection /= 'pseudo' ) CALL stres_hub( sigmah )
  !
  !   Electric field contribution
  !
  sigmael(:,:)=0.d0
  sigmaion(:,:)=0.d0
  !the following is for calculating the improper stress tensor
!  call stress_bp_efield (sigmael )
!  call stress_ion_efield (sigmaion )

  sigma_ts = 0.0_DP
  IF ( ts_vdw ) sigma_ts = -2.0_DP*alat*MATMUL( HtsvdW, TRANSPOSE(at) )/omega
  !
  !   DFT-non_local contribution
  !
  sigma_nonloc_dft(:,:) = 0.d0
  CALL stres_nonloc_dft( rho%of_r(:,1), rho_core, nspin, sigma_nonloc_dft )
  !
  ! SUM
  !
  sigma(:,:) = sigmakin(:,:) + sigmaloc(:,:) + sigmahar(:,:) +  &
               sigmaxc(:,:)  + sigmaxcc(:,:) + sigmaewa(:,:) +  &
               sigmanlc(:,:) + sigmah(:,:)   + sigmael(:,:)  +  &
               sigmaion(:,:) + sigmalon(:,:) + sigmad3(:,:)  + sigmaxdm(:,:) + &
               sigma_nonloc_dft(:,:) + sigma_ts(:,:)
  !
  IF (dft_is_hybrid()) THEN
     sigmaexx = exx_stress()
     CALL symmatrix( sigmaexx )
     sigma(:,:) = sigma(:,:) + sigmaexx(:,:)
  ELSE
     sigmaexx = 0.d0
  ENDIF
  !qepy --> add extstress
  if (present(embed)) then
     sigma(:,:) = sigma(:,:) + embed%extstress
  endif
  !qepy <-- add extstress
  ! Resymmetrize the total stress. This should not be strictly necessary,
  ! but prevents loss of symmetry in long vc-bfgs runs

  CALL symmatrix( sigma )
  !
  ! write results in Ry/(a.u.)^3 and in kbar
  !
  IF ( do_comp_esm .AND. ( esm_bc /= 'pbc' ) ) THEN ! for ESM stress
     WRITE( stdout, 9000) (sigma(1,1) + sigma(2,2)) * ry_kbar/3d0, &
     sigma(1,1), sigma(1,2), 0.d0, sigma(1,1)*ry_kbar, sigma(1,2)*ry_kbar, 0.d0,&
     sigma(2,1), sigma(2,2), 0.d0, sigma(2,1)*ry_kbar, sigma(2,2)*ry_kbar, 0.d0,&
     0.d0      , 0.d0      , 0.d0, 0.d0              , 0.d0              , 0.d0
  ELSE
     WRITE( stdout, 9000) (sigma(1,1) + sigma(2,2) + sigma(3,3)) * ry_kbar/3d0, &
                          (sigma(l,1), sigma(l,2), sigma(l,3),                  &
                           sigma(l,1)*ry_kbar, sigma(l,2)*ry_kbar,              &
                           sigma(l,3)*ry_kbar, l=1,3)
  END IF

  IF ( iverbosity > 0 ) WRITE( stdout, 9005) &
     (sigmakin(l,1)*ry_kbar,sigmakin(l,2)*ry_kbar,sigmakin(l,3)*ry_kbar, l=1,3), &
     (sigmaloc(l,1)*ry_kbar,sigmaloc(l,2)*ry_kbar,sigmaloc(l,3)*ry_kbar, l=1,3), &
     (sigmanlc(l,1)*ry_kbar,sigmanlc(l,2)*ry_kbar,sigmanlc(l,3)*ry_kbar, l=1,3), &
     (sigmahar(l,1)*ry_kbar,sigmahar(l,2)*ry_kbar,sigmahar(l,3)*ry_kbar, l=1,3), &
     (sigmaxc (l,1)*ry_kbar,sigmaxc (l,2)*ry_kbar,sigmaxc (l,3)*ry_kbar, l=1,3), &
     (sigmaxcc(l,1)*ry_kbar,sigmaxcc(l,2)*ry_kbar,sigmaxcc(l,3)*ry_kbar, l=1,3), &
     (sigmaewa(l,1)*ry_kbar,sigmaewa(l,2)*ry_kbar,sigmaewa(l,3)*ry_kbar, l=1,3), &
     (sigmah  (l,1)*ry_kbar,sigmah  (l,2)*ry_kbar,sigmah  (l,3)*ry_kbar, l=1,3), &
     (sigmalon(l,1)*ry_kbar,sigmalon(l,2)*ry_kbar,sigmalon(l,3)*ry_kbar, l=1,3), &
     (sigmad3 (l,1)*ry_kbar,sigmad3 (l,2)*ry_kbar,sigmad3 (l,3)*ry_kbar, l=1,3), &
     (sigmaxdm(l,1)*ry_kbar,sigmaxdm(l,2)*ry_kbar,sigmaxdm(l,3)*ry_kbar, l=1,3), &
     (sigma_nonloc_dft(l,1)*ry_kbar,sigma_nonloc_dft(l,2)*ry_kbar,sigma_nonloc_dft(l,3)*ry_kbar, l=1,3),&
     (sigma_ts(l,1)*ry_kbar,sigma_ts(l,2)*ry_kbar,sigma_ts(l,3)*ry_kbar, l=1,3)

  IF ( dft_is_hybrid() .AND. (iverbosity > 0) ) WRITE( stdout, 9006) &
     (sigmaexx(l,1)*ry_kbar,sigmaexx(l,2)*ry_kbar,sigmaexx(l,3)*ry_kbar, l=1,3)
9006 format (5x,'EXX     stress (kbar)',3f10.2/2(26x,3f10.2/)/ )
  !
  IF ( lelfield .AND. iverbosity > 0 ) THEN
     WRITE(stdout,*) "Stress tensor electronic el field part:"
     WRITE(stdout,*) (sigmael(l,1),sigmael(l,2),sigmael(l,3), l=1,3)
     WRITE(stdout,*) "Stress tensor electronic el field part:"
     WRITE(stdout,*) (sigmaion(l,1),sigmaion(l,2),sigmaion(l,3), l=1,3)
  ENDIF
  !
  CALL stop_clock( 'stress' )
  !
  RETURN
9000 format (10x,'total   stress  (Ry/bohr**3) ',18x,'(kbar)', &
             &5x,'P=',f12.2/3 (3f13.8,4x,3f12.2/))
9005 format &
         &  (5x,'kinetic stress (kbar)',3f10.2/2(26x,3f10.2/)/ &
         &   5x,'local   stress (kbar)',3f10.2/2(26x,3f10.2/)/ &
         &   5x,'nonloc. stress (kbar)',3f10.2/2(26x,3f10.2/)/ &
         &   5x,'hartree stress (kbar)',3f10.2/2(26x,3f10.2/)/ &
         &   5x,'exc-cor stress (kbar)',3f10.2/2(26x,3f10.2/)/ &
         &   5x,'corecor stress (kbar)',3f10.2/2(26x,3f10.2/)/ &
         &   5x,'ewald   stress (kbar)',3f10.2/2(26x,3f10.2/)/ &
         &   5x,'hubbard stress (kbar)',3f10.2/2(26x,3f10.2/)/ &
         &   5x,'london  stress (kbar)',3f10.2/2(26x,3f10.2/)/ &
         &   5x,'DFT-D3  stress (kbar)',3f10.2/2(26x,3f10.2/)/ &
         &   5x,'XDM     stress (kbar)',3f10.2/2(26x,3f10.2/)/ &
         &   5x,'dft-nl  stress (kbar)',3f10.2/2(26x,3f10.2/)/ &
         &   5x,'TS-vdW  stress (kbar)',3f10.2/2(26x,3f10.2/)/ )
  !
END SUBROUTINE qepy_stress

!
! Copyright (C) 2001-2014 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!

!-----------------------------------------------------------------------
SUBROUTINE qepy_tddft_setup(embed)
  !-----------------------------------------------------------------------
  !
  ! ... TDDFT setup
  !
  USE kinds,         ONLY : dp
  USE io_global,     ONLY : stdout
  USE wvfct,         ONLY : nbnd, et, wg
  USE lsda_mod,      ONLY : nspin
  USE scf,           ONLY : v, vrs, vltot, kedtau
  USE fft_base,      ONLY : dfftp
  USE gvecs,         ONLY : doublegrid
  USE klist,         ONLY : degauss, ngauss, nks, lgauss, wk, two_fermi_energies
  USE klist,         ONLY : ltetra
  USE noncollin_module,  ONLY : noncolin
  USE constants,     ONLY : degspin, pi
  USE mp_pools,      ONLY : inter_pool_comm 
  USE mp,            ONLY : mp_max, mp_min 
  USE dfunct,        ONLY : newd
  USE pwcom,         ONLY : ef
  USE constants,     ONLY : rytoev
  USE tddft_module
  !
  USE qepy_common,             ONLY : embed_base
  !

  implicit none
  integer :: ik, ibnd
  real(dp) :: emin, emax, xmax, small, fac, target
  !
  TYPE(embed_base), INTENT(INOUT)    :: embed
  !
    
  call start_clock ('tddft_setup')
    
  ! initialize pseudopotentials and projectors for LDA+U
  call init_us_1
  call init_at_1

  ! computes the total local potential (external+scf) on the smooth grid
  !call setlocal
  call qepy_setlocal(embed%exttype)
  call set_vrs (vrs, vltot, v%of_r, kedtau, v%kin_r, dfftp%nnr, nspin, doublegrid)
    
  ! compute the D for the pseudopotentials
  call newd
    
  !! set non linear core correction stuff (IS THIS REALLY NEEDED?)
  !! nlcc_any = ANY ( upf(1:ntyp)%nlcc )
  !!if (nlcc_any) allocate (drc( ngm, ntyp))
  !! setup all gradient correction stuff
  !!call setup_dgc

  ! some pre-conditions
  if (ltetra) call errore('tddft_setup','TDDFT + tetrahedra not implemented', 1)
  if (noncolin) call errore('tddft_setup','TDDFT + non-collinear not implemented', 1)
  if (two_fermi_energies) &
     call errore('gipaw_setup','TDDFT + two Fermi energies not implemented', 1)

  ! computes the number of occupied bands for each k point
  IF (ALLOCATED(nbnd_occ)) DEALLOCATE(nbnd_occ)
  allocate(nbnd_occ(nks))
  nbnd_occ(:) = 0
  if (lgauss) then
     write(stdout,*)
     write(stdout,'(5X,''smearing ngauss='',I4,2X,''degauss='',F8.4,'' Ry'')') &
          ngauss, degauss
     ! discard conduction bands such that w0gauss(x,n) < small
     ! hint:
     !   small = 1.0333492677046d-2  ! corresponds to 2 gaussian sigma
     !   small = 6.9626525973374d-5  ! corresponds to 3 gaussian sigma
     !   small = 6.3491173359333d-8  ! corresponds to 4 gaussian sigma
     small = 6.3491173359333d-8

     ! appropriate limit for gaussian broadening (used for all ngauss)
     xmax = sqrt(-log(sqrt(pi)*small))

     ! appropriate limit for Fermi-Dirac
     if (ngauss == -99) then
        fac = 1.d0 / sqrt(small)
        xmax = 2.d0 * log(0.5d0*(fac + sqrt(fac*fac-4.d0)))
     endif
     target = ef + xmax * degauss
     do ik = 1, nks
        do ibnd = 1, nbnd
!DEBUG           if (ionode) write(70,*) et(ibnd,ik), wg(ibnd,ik)/wk(ik)
           if (et(ibnd,ik) < target) nbnd_occ(ik) = ibnd
        enddo
        if (nbnd_occ (ik) == nbnd) &
           write(stdout,'(5X,''Possibly too few bands at k-point:'',I6)') ik
     enddo
  else 
    ! general case
     do ik = 1, nks
       do ibnd = 1, nbnd
         if (wk(ik) > 0.d0) then
           if (wg(ibnd,ik)/wk(ik) > 1d-4 ) nbnd_occ(ik) = ibnd
          endif
       end do
     end do
  end if
    
  ! computes alpha_pv
  emin = et (1, 1)
  do ik = 1, nks
    do ibnd = 1, nbnd
      emin = min (emin, et (ibnd, ik) )
    enddo
  enddo
#ifdef __MPI
  ! find the minimum across pools
  call mp_min( emin, inter_pool_comm )
#endif

  if (lgauss) then
     ! metal
     emax = target
     alpha_pv = emax - emin
  else
     ! insulator
     emax = et(1,1)
     do ik = 1, nks
        do ibnd = 1, nbnd_occ(ik)
           emax = max(emax, et(ibnd,ik))
        enddo
     enddo
#ifdef __MPI
     ! find the maximum across pools
     call mp_max( emax, inter_pool_comm )
#endif
     alpha_pv = 2.d0 * (emax - emin)
  endif

  ! avoid zero value for alpha_pv
  alpha_pv = max(alpha_pv, 1.0d-2)
  write(stdout,'(5X,''alpha_pv='',F12.4,'' eV'')') alpha_pv*rytoev

  ! wavepacket
  if (wavepacket) then
     call setup_wavepacket
  endif

  ! initialize hamiltonian
  call qepy_update_hamiltonian(-1, embed)

  call stop_clock('tddft_setup')
  
END SUBROUTINE qepy_tddft_setup

!
! Copyright (C) 2013-2017 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
!----------------------------------------------------------------------------
SUBROUTINE qepy_run_pwscf( exit_status, oldxml, embed )
  !----------------------------------------------------------------------------
  !! Author: Paolo Giannozzi  
  !! License: GNU  
  !! Summary: Run an instance of the Plane Wave Self-Consistent Field code
  !
  !! Run an instance of the Plane Wave Self-Consistent Field code 
  !! MPI initialization and input data reading is performed in the 
  !! calling code - returns in exit_status the exit code for pw.x, 
  !! returned in the shell. Values are:  
  !! * 0: completed successfully
  !! * 1: an error has occurred (value returned by the errore() routine)
  !! * 2-127: convergence error
  !!    * 2: scf convergence error
  !!    * 3: ion convergence error
  !! * 128-255: code exited due to specific trigger
  !!    * 255: exit due to user request, or signal trapped,
  !!          or time > max_seconds
  !!     (note: in the future, check_stop_now could also return a value
  !!     to specify the reason of exiting, and the value could be used
  !!     to return a different value for different reasons)
  !
  !! @Note
  !! 10/01/17 Samuel Ponce: Add Ford documentation
  !! @endnote
  !!
  !
  USE io_global,            ONLY : stdout, ionode, ionode_id
  USE parameters,           ONLY : ntypx, npk, lmaxx
  USE cell_base,            ONLY : fix_volume, fix_area
  USE control_flags,        ONLY : conv_elec, gamma_only, ethr, lscf, treinit_gvecs
  USE control_flags,        ONLY : conv_ions, istep, nstep, restart, lmd, lbfgs
  USE cellmd,               ONLY : lmovecell, cell_factor
  USE command_line_options, ONLY : command_line
  USE force_mod,            ONLY : lforce, lstres, sigma, force
  USE check_stop,           ONLY : check_stop_init, check_stop_now
  USE mp_images,            ONLY : intra_image_comm
  USE extrapolation,        ONLY : update_file, update_pot
  USE scf,                  ONLY : rho
  USE lsda_mod,             ONLY : nspin
  USE fft_base,             ONLY : dfftp
  USE qmmm,                 ONLY : qmmm_initialization, qmmm_shutdown, &
                                   qmmm_update_positions, qmmm_update_forces
  USE qexsd_module,         ONLY : qexsd_set_status
  USE funct,                ONLY : dft_is_hybrid, stop_exx 
  USE mp_world, ONLY: world_comm
  !
  USE kinds,                ONLY : DP
  USE qepy_common,          ONLY : embed_base
  !
  IMPLICIT NONE
  !
  INTEGER, INTENT(OUT) :: exit_status
  !! Gives the exit status at the end
  !
  LOGICAL, EXTERNAL :: matches
  ! checks if first string is contained in the second
  !
  ! ... local variables
  !
  INTEGER :: idone 
  ! counter of electronic + ionic steps done in this run
  INTEGER :: ions_status = 3
  ! ions_status =  3  not yet converged
  ! ions_status =  2  converged, restart with nonzero magnetization
  ! ions_status =  1  converged, final step with current cell needed
  ! ions_status =  0  converged, exiting
  LOGICAL, INTENT(IN), OPTIONAL :: oldxml
  type(embed_base), intent(inout), optional :: embed
  !
  exit_status = 0
  IF ( ionode ) WRITE( UNIT = stdout, FMT = 9010 ) ntypx, npk, lmaxx
  !
  !qepy --> lmovecell
  if (present(embed)) then
     if (.not. lmovecell) then
        lmovecell = embed%lmovecell
     endif
  endif
  if (lmovecell) then
     if (cell_factor < 1.2d0 ) cell_factor = 2.d0
  endif
  !qepy <-- lmovecell
  IF (ionode) CALL plugin_arguments()
  CALL plugin_arguments_bcast( ionode_id, intra_image_comm )
  !
  ! ... needs to come before iosys() so some input flags can be
  !     overridden without needing to write PWscf specific code.
  ! 
  CALL qmmm_initialization()
  !
  ! ... convert to internal variables
  !
  CALL iosys()
  !
  ! ... If executable names is "dist.x", compute atomic distances, angles,
  ! ... nearest neighbors, write them to file "dist.out", exit
  !
  IF ( matches('dist.x',command_line) ) THEN
     IF (ionode) CALL run_dist( exit_status )
     RETURN
  ENDIF
  !
  IF ( gamma_only ) WRITE( UNIT = stdout, &
     & FMT = '(/,5X,"gamma-point specific algorithms are used")' )
  !
  ! call to void routine for user defined / plugin patches initializations
  !
  CALL plugin_initialization()
  !
  CALL check_stop_init()
  !
  CALL setup()
  !
  CALL qmmm_update_positions()
  !
  ! ... dry run: code will stop here if called with exit file present
  ! ... useful for a quick and automated way to check input data
  !
  IF ( nstep == 0 .OR. check_stop_now() ) THEN
     CALL pre_init()
     CALL data_structure( gamma_only )
     CALL summary()
     CALL memory_report()
     CALL qexsd_set_status(255)
     CALL punch( 'config-init' )
     exit_status = 255
     RETURN
  ENDIF
  !
  !CALL init_run()
  if (present(oldxml)) then
  CALL qepy_init_run(oldxml)
  else
  CALL qepy_init_run(.FALSE.)
  endif
  !
  IF ( check_stop_now() ) THEN
     CALL qexsd_set_status( 255 )
     CALL punch( 'config' )
     exit_status = 255
     RETURN
  ENDIF
  exit_status = 255
  !qepy -->
  !fix: force allocate with NaN
  force=0.0_dp
  !qepy <--
  !
  !main_loop: DO idone = 1, nstep
     !!
     !! ... electronic self-consistency or band structure calculation
     !!
     !IF ( .NOT. lscf) THEN
        !CALL non_scf()
     !ELSE
        !CALL electrons()
     !END IF
     !!
     !! ... code stopped by user or not converged
     !!
     !IF ( check_stop_now() .OR. .NOT. conv_elec ) THEN
        !IF ( check_stop_now() ) exit_status = 255
        !IF ( .NOT. conv_elec )  exit_status =  2
        !CALL qexsd_set_status(exit_status)
        !CALL punch( 'config' )
        !RETURN
     !ENDIF
     !!
     !! ... ionic section starts here
     !!
     !CALL start_clock( 'ions' ); !write(*,*)' start ions' ; FLUSH(6)
     !conv_ions = .TRUE.
     !!
     !! ... recover from a previous run, if appropriate
     !!
     !!IF ( restart .AND. lscf ) CALL restart_in_ions()
     !!
     !! ... file in CASINO format written here if required
     !!
     !IF ( lmd ) THEN
        !CALL pw2casino( istep )
     !ELSE
        !CALL pw2casino( 0 )
     !END IF
     !!
     !! ... force calculation
     !!
     !IF ( lforce ) CALL forces()
     !!
     !! ... stress calculation
     !!
     !IF ( lstres ) CALL stress( sigma )
     !!
     !IF ( lmd .OR. lbfgs ) THEN
        !!
        !IF (fix_volume) CALL impose_deviatoric_stress( sigma )
        !IF (fix_area)   CALL impose_deviatoric_stress_2d( sigma )
        !!
        !! ... save data needed for potential and wavefunction extrapolation
        !!
        !CALL update_file()
        !!
        !! ... ionic step (for molecular dynamics or optimization)
        !!
        !CALL move_ions ( idone, ions_status )
        !conv_ions = ( ions_status == 0 ) .OR. &
                    !( ions_status == 1 .AND. treinit_gvecs )
        !!
        !! ... then we save restart information for the new configuration
        !!
        !IF ( idone <= nstep .AND. .NOT. conv_ions ) THEN 
            !CALL qexsd_set_status( 255 )
            !CALL punch( 'config-nowf' )
        !END IF
        !!
        !IF (dft_is_hybrid() )  CALL stop_exx()
     !END IF
     !!
     !CALL stop_clock( 'ions' ); !write(*,*)' stop ions' ; FLUSH(6)
     !!
     !! ... send out forces to MM code in QM/MM run
     !!
     !CALL qmmm_update_forces( force, rho%of_r, nspin, dfftp )
     !!
     !! ... exit condition (ionic convergence) is checked here
     !!
     !IF ( lmd .OR. lbfgs ) CALL add_qexsd_step( idone )
     !IF ( conv_ions ) EXIT main_loop
     !!
     !! ... receive new positions from MM code in QM/MM run
     !!
     !CALL qmmm_update_positions()
     !!
     !! ... terms of the hamiltonian depending upon nuclear positions
     !! ... are reinitialized here
     !!
     !IF ( lmd .OR. lbfgs ) THEN
        !!
        !IF ( ions_status == 1 ) THEN
           !!
           !! ... final scf calculation with G-vectors for final cell
           !!
           !lbfgs=.FALSE.; lmd=.FALSE.
           !WRITE( UNIT = stdout, FMT=9020 ) 
           !CALL reset_gvectors( )
           !!
        !ELSE IF ( ions_status == 2 ) THEN
           !!
           !! ... check whether nonzero magnetization is real
           !!
           !CALL reset_magn()
           !!
        !ELSE
           !!
           !IF ( treinit_gvecs ) THEN
              !!
              !! ... prepare for next step with freshly computed G vectors
              !!
              !IF ( lmovecell) CALL scale_h()
              !CALL reset_gvectors ( )
              !!
           !ELSE
              !!
              !! ... update the wavefunctions, charge density, potential
              !! ... update_pot initializes structure factor array as well
              !!
              !CALL update_pot()
              !!
              !! ... re-initialize atomic position-dependent quantities
              !!
              !CALL hinit1()
              !!
           !END IF
           !!
        !END IF
        !!
     !ENDIF
     !! ... Reset convergence threshold of iterative diagonalization for
     !! ... the first scf iteration of each ionic step (after the first)
     !!
     !ethr = 1.0D-6
     !!
  !ENDDO main_loop
  !!
  !! ... save final data file
  !!
  !CALL qexsd_set_status( exit_status )
  !CALL punch( 'all' )
  !!
  !CALL qmmm_shutdown()
  !!
  !IF ( .NOT. conv_ions )  exit_status =  3
  RETURN
  !
9010 FORMAT( /,5X,'Current dimensions of program PWSCF are:', &
           & /,5X,'Max number of different atomic species (ntypx) = ',I2,&
           & /,5X,'Max number of k-points (npk) = ',I6,       &
           & /,5X,'Max angular momentum in pseudopotentials (lmaxx) = ',i2)
9020 FORMAT( /,5X,'Final scf calculation at the relaxed structure.', &
          &  /,5X,'The G-vectors are recalculated for the final unit cell', &
          &  /,5X,'Results may differ from those at the preceding step.' )
  !
END SUBROUTINE qepy_run_pwscf
!
!
!-------------------------------------------------------------
!SUBROUTINE reset_gvectors( )
!!-------------------------------------------------------------
  !!
  !!! Prepare a new scf calculation with newly recomputed grids,
  !!! restarting from scratch, not from available data of previous
  !!! steps (dimensions and file lengths will be different in general)
  !!! Useful as a check of variable-cell optimization: 
  !!! once convergence is achieved, compare the final energy with the
  !!! energy computed with G-vectors and plane waves for the final cell
  !!
  !USE io_global,  ONLY : stdout
  !USE basis,      ONLY : starting_wfc, starting_pot
  !USE fft_base,   ONLY : dfftp
  !USE fft_base,   ONLY : dffts
  !USE funct,      ONLY : dft_is_hybrid
  !! 
  !IMPLICIT NONE
  !!
  !! ... get magnetic moments from previous run before charge is deleted
  !!
  !CALL reset_starting_magnetization()
  !!
  !! ... clean everything (FIXME: clean only what has to be cleaned)
  !!
  !CALL clean_pw( .FALSE. )
  !CALL close_files(.TRUE.)
  !!
  !IF (TRIM(starting_wfc) == 'file') starting_wfc = 'atomic+random'
  !starting_pot='atomic'
  !!
  !! ... re-set FFT grids and re-compute needed stuff (FIXME: which?)
  !!
  !dfftp%nr1=0; dfftp%nr2=0; dfftp%nr3=0
  !dffts%nr1=0; dffts%nr2=0; dffts%nr3=0
  !!
  !CALL init_run()
  !!
  !! ... re-set and re-initialize EXX-related stuff
  !!
  !IF ( dft_is_hybrid() ) CALL reset_exx( )
  !!
!END SUBROUTINE reset_gvectors
!!
!!
!!-------------------------------------------------------------
!SUBROUTINE reset_exx( )
!!-------------------------------------------------------------
  !USE fft_types,  ONLY : fft_type_deallocate 
  !USE exx_base,   ONLY : exx_grid_init, exx_mp_init, exx_div_check, & 
                         !coulomb_fac, coulomb_done 
  !USE exx,        ONLY : dfftt, exx_fft_create, deallocate_exx 
  !USE exx_band,   ONLY : igk_exx 
  !! 
  !IMPLICIT NONE
  !!
  !! ... re-set EXX-related stuff...
  !!
  !IF (ALLOCATED(coulomb_fac) ) DEALLOCATE( coulomb_fac, coulomb_done )
  !CALL deallocate_exx( )
  !IF (ALLOCATED(igk_exx)) DEALLOCATE(igk_exx) 
  !dfftt%nr1=0; dfftt%nr2=0; dfftt%nr3=0 
  !CALL fft_type_deallocate( dfftt ) ! FIXME: is this needed?
  !!
  !! ... re-compute needed EXX-related stuff
  !!
  !CALL exx_grid_init( REINIT = .TRUE. )
  !CALL exx_mp_init()
  !CALL exx_fft_create()
  !CALL exx_div_check()
  !! 
!END SUBROUTINE reset_exx
!!
!!
!!----------------------------------------------------------------
!SUBROUTINE reset_magn()
  !!----------------------------------------------------------------
  !!! LSDA optimization: a final configuration with zero 
  !!! absolute magnetization has been found and we check 
  !!! if it is really the minimum energy structure by 
  !!! performing a new scf iteration without any "electronic" history.
  !!
  !USE io_global,    ONLY : stdout
  !USE dfunct,       ONLY : newd
  !!
  !IMPLICIT NONE
  !!
  !WRITE( UNIT = stdout, FMT = 9010 )
  !WRITE( UNIT = stdout, FMT = 9020 )
  !!
  !! ... re-initialize the potential (no need to re-initialize wavefunctions)
  !!
  !CALL potinit()
  !CALL newd()
  !!
!9010 FORMAT( /5X,'lsda relaxation :  a final configuration with zero', &
           !& /5X,'                   absolute magnetization has been found' )
!9020 FORMAT( /5X,'the program is checking if it is really ', &
           !&     'the minimum energy structure',             &
           !& /5X,'by performing a new scf iteration ',       & 
           !&     'without any "electronic" history' )               
  !!
!END SUBROUTINE reset_magn
!!
!!
!!-------------------------------------------------------------------
!SUBROUTINE reset_starting_magnetization() 
  !!-------------------------------------------------------------------
  !!! On input, the scf charge density is needed.  
  !!! On output, new values for starting_magnetization, angle1, angle2
  !!! estimated from atomic magnetic moments - to be used in last step.
  !!
  !USE kinds,              ONLY : DP
  !USE constants,          ONLY : pi
  !USE ions_base,          ONLY : nsp, ityp, nat
  !USE lsda_mod,           ONLY : nspin, starting_magnetization
  !USE scf,                ONLY : rho
  !USE spin_orb,           ONLY : domag
  !USE noncollin_module,   ONLY : noncolin, angle1, angle2
  !!
  !IMPLICIT NONE
  !!
  !! ... local variables
  !!
  !INTEGER  :: i, nt, iat
  !! loop counter on species
  !! number of atoms per species
  !! loop counter on atoms
  !REAL(DP) :: norm_tot, norm_xy
  !! modulus of atomic magnetization
  !! xy-projection of atomic magnetization
  !REAL(DP) :: theta, phi
  !! angle between magnetization and z-axis
  !! angle between xy-magnetization and x-axis
  !REAL(DP), ALLOCATABLE :: r_loc(:)
  !! auxiliary array for density
  !REAL(DP), ALLOCATABLE :: m_loc(:,:)
  !! auxiliary array for magnetization
  !!
  !IF ( (noncolin .AND. domag) .OR. nspin==2) THEN
     !ALLOCATE( r_loc(nat), m_loc(nspin-1,nat) )
     !CALL get_locals( r_loc,m_loc, rho%of_r )
  !ELSE
     !RETURN
  !ENDIF
  !!
  !DO i = 1, nsp
     !!
     !starting_magnetization(i) = 0.0_DP
     !angle1(i) = 0.0_DP
     !angle2(i) = 0.0_DP
     !nt = 0
     !!
     !DO iat = 1, nat
        !IF (ityp(iat) == i) THEN
           !nt = nt + 1
           !IF (noncolin) THEN
              !norm_tot = SQRT(m_loc(1,iat)**2+m_loc(2,iat)**2+m_loc(3,iat)**2)
              !norm_xy  = SQRT(m_loc(1,iat)**2+m_loc(2,iat)**2)
              !IF (norm_tot > 1.d-10) THEN
                 !theta = ACOS(m_loc(3,iat)/norm_tot)
                 !IF (norm_xy > 1.d-10) THEN
                    !phi = ACOS(m_loc(1,iat)/norm_xy)
                    !IF (m_loc(2,iat) < 0.d0) phi = - phi
                 !ELSE
                    !phi = 2.d0*pi
                 !ENDIF
              !ELSE
                 !theta = 2.d0*pi
                 !phi = 2.d0*pi
              !ENDIF
              !angle1(i) = angle1(i) + theta
              !angle2(i) = angle2(i) + phi
              !starting_magnetization(i) = starting_magnetization(i) + &
                                          !norm_tot/r_loc(iat)
           !ELSE
              !starting_magnetization(i) = starting_magnetization(i) + &
                                          !m_loc(1,iat)/r_loc(iat)
           !ENDIF
        !ENDIF
     !ENDDO
     !!
     !IF ( nt > 0 ) THEN
        !starting_magnetization(i) = starting_magnetization(i) / DBLE(nt)
        !angle1(i) = angle1(i) / DBLE(nt)
        !angle2(i) = angle2(i) / DBLE(nt)
     !ENDIF
     !!
  !ENDDO
  !!
  !DEALLOCATE( r_loc, m_loc )
  !!
!END SUBROUTINE reset_starting_magnetization

!
! Copyright (C) 2001-2013 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
!----------------------------------------------------------------------------
SUBROUTINE qepy_pwscf(infile, my_world_comm, oldxml, embed)
  !! Author: Paolo Giannozzi
  !
  !! Version: v6.1
  !
  !! License: GNU
  !
  !! Summary: Main program calling one or more instances of Plane Wave Self-Consistent Field code
  !
  !! This is the main program for executable "pw.x".  |
  !! * If called as "pw.x -ipi server-address" or "pw.x --ipi server-address",
  !! works in "server" mode, calls [[run_driver]].
  !! * If called as "manypw.x" via a link, works in "manypw" mode, runs many
  !! instances (images) of pw.x (see [[run_manypw]])
  !! * If called as "dist.x" via a link, works in "dry run" mode, computes
  !! distances, angles, neighbors, writes to file "dist.out" and stops. 
  !! Otherwise: see [[run_pwscf]]
  !!
  !! @Note
  !! 10/01/17 Samuel Ponce: Add Ford documentation
  !! @endnote
  !!
  !! @warning
  !! Example of Warning
  !!
  !! @todo
  !! Have automatic parallelisation. 
  !!
  !! @bug
  !! No bug.
  !!
  USE environment,          ONLY : environment_start
  USE mp_global,            ONLY : mp_startup
  USE mp_world,             ONLY : world_comm
  USE mp_pools,             ONLY : intra_pool_comm
  USE mp_bands,             ONLY : intra_bgrp_comm, inter_bgrp_comm
  USE mp_diag,              ONLY : mp_start_diag
  USE mp_exx,               ONLY : negrp
  USE read_input,           ONLY : read_input_file
  USE command_line_options, ONLY : input_file_, command_line, ndiag_
  USE qepy_common,          ONLY : embed_base, messenger
  !
  IMPLICIT NONE
  !
  CHARACTER(len=*) :: infile
  INTEGER, INTENT(IN), OPTIONAL :: my_world_comm
  LOGICAL, INTENT(IN), OPTIONAL :: oldxml
  type(embed_base), intent(inout), optional :: embed
  !
  LOGICAL               :: oldver
  CHARACTER(len=256) :: srvaddress
  !! Get the address of the server 
  CHARACTER(len=256) :: get_server_address
  !! Get the address of the server 
  INTEGER :: exit_status
  !! Status at exit
  LOGICAL :: use_images, do_diag_in_band_group = .TRUE.
  !! true if running "manypw.x"
  LOGICAL, EXTERNAL :: matches
  !! checks if first string is contained in the second
  !
  if (present(oldxml)) then
     oldver = oldxml
  else
     oldver = .FALSE.
  endif
  !
  !
  IF ( PRESENT(my_world_comm)) THEN
     CALL mp_startup(my_world_comm=my_world_comm, start_images=.TRUE. )
  ELSE
     CALL mp_startup( start_images=.TRUE. )
  ENDIF
  !
  IF( negrp > 1 .OR. do_diag_in_band_group ) THEN
     ! used to be the default : one diag group per bgrp
     ! with strict hierarchy: POOL > BAND > DIAG
     ! if using exx groups from mp_exx still use this diag method
     CALL mp_start_diag( ndiag_, world_comm, intra_bgrp_comm, &
                         do_distr_diag_inside_bgrp_ = .TRUE. )
  ELSE
     ! new default: one diag group per pool ( individual k-point level )
     ! with band group and diag group both being children of POOL comm
     CALL mp_start_diag( ndiag_, world_comm, intra_pool_comm, &
                         do_distr_diag_inside_bgrp_ = .FALSE. )
  ENDIF
  !
  CALL set_mpi_comm_4_solvers( intra_pool_comm, intra_bgrp_comm, &
                               inter_bgrp_comm )
  !
  CALL environment_start( 'PWSCF' )
  !
  ! ... Check if running standalone or in "driver" mode
  !
  !srvaddress = get_server_address( command_line ) 
  !
  ! ... Check if running standalone or in "manypw" mode
  !
  !use_images = matches( 'manypw.x', command_line )
  !
  ! ... Perform actual calculation
  !
  !IF ( TRIM(srvaddress) == ' ' ) THEN
    !! When running standalone:
    !IF ( use_images ) THEN
       !! as manypw.x
       !CALL run_manypw( )
       !CALL run_pwscf( exit_status )
       !!
     !ELSE
       !! as pw.x
       !CALL read_input_file( 'PW', input_file_ )
       !CALL run_pwscf( exit_status )
       !!
    !ENDIF
  !ELSE
     !! When running as library
     !!
     !CALL read_input_file('PW+iPi', input_file_ )
     !CALL run_driver( srvaddress, exit_status )
     !!
  !ENDIF
  !
  input_file_=trim(infile)
  CALL read_input_file( 'PW', input_file_ )
  if (present(embed)) then
     call qepy_run_pwscf(exit_status, oldver, embed)
  else
     call qepy_run_pwscf(exit_status, oldver, messenger)
  endif
END SUBROUTINE qepy_pwscf
   !
SUBROUTINE qepy_pwscf_finalise()
   IMPLICIT NONE
   INTEGER :: exit_status

   CALL laxlib_free_ortho_group()
   CALL qepy_stop_run( exit_status )
   !CALL do_stop( exit_status )
END SUBROUTINE qepy_pwscf_finalise

SUBROUTINE qepy_initial(input)
  !
  USE io_global,   ONLY : ionode
  USE mp_global,   ONLY : mp_startup
  USE environment, ONLY : environment_start, environment_end
  USE qepy_common, ONLY : input_base
  USE io_files,    ONLY : tmp_dir, prefix
  USE check_stop,  ONLY : check_stop_init
  !
  IMPLICIT NONE
  !
  TYPE(input_base), OPTIONAL :: input
  !
  LOGICAL            :: start_images = .false.
  !CHARACTER(len=256) :: code = 'QEPY'
  !
  IF (PRESENT(input)) THEN
     start_images = input%start_images
  ENDIF
  !
  IF ( PRESENT(input)) THEN
     IF (input%my_world_comm /= 0 ) THEN
        CALL mp_startup(my_world_comm=input%my_world_comm, start_images=start_images )
     ELSE
        CALL mp_startup(start_images=start_images )
     ENDIF
  ELSE
     CALL mp_startup(start_images=start_images )
  ENDIF
  !
  IF (PRESENT(input)) THEN
     prefix = input%prefix
     tmp_dir = input%tmp_dir
     CALL environment_start ( input%code )
  ENDIF
  !
  CALL check_stop_init()
  !
END SUBROUTINE qepy_initial

SUBROUTINE qepy_finalise_end(input)
  !
  USE environment, ONLY : environment_start, environment_end
  USE qepy_common, ONLY : input_base
  USE mp_global,   ONLY : mp_global_end
  !
  IMPLICIT NONE
  !
  TYPE(input_base), OPTIONAL :: input
  !
  IF (PRESENT(input)) THEN
     CALL environment_end ( input%code )
  ENDIF
  CALL mp_global_end()
END SUBROUTINE qepy_finalise_end

!
! Copyright (C) 2001-2014 Quantum-ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!

!-----------------------------------------------------------------------
SUBROUTINE qepy_tddft_readin(infile)
  !-----------------------------------------------------------------------
  !
  ! ... Read in the tddft input file. The input file consists of a
  ! ... single namelist &inputtddft. See doc/user-manual.pdf for the
  ! ... list of input keywords.
  !
  USE tddft_module
  USE io_files,         ONLY : prefix, tmp_dir  
  USE io_global,        ONLY : ionode
  USE constants,        ONLY : bohr_radius_angs, au_sec
  USE mp_images,        ONLY : my_image_id

  ! -- local variables ---------------------------------------------------
  implicit none
  integer :: ios
  character(len=256), external :: trimcheck
  character(len=80) :: verbosity
  !
  CHARACTER(len=*), INTENT(IN), OPTIONAL  :: infile
  INTEGER, EXTERNAL :: find_free_unit
  INTEGER :: iun, i
  CHARACTER(len=256) :: fstr
  CHARACTER(len=1), EXTERNAL :: lowercase
  !
  namelist /inputtddft/ job, prefix, tmp_dir, conv_threshold, verbosity, &
                        dt, e_strength, e_direction, nstep, nupdate_Dnm, &
                        l_circular_dichroism, l_tddft_restart, max_seconds, &
                        molecule, ehrenfest, isave_rho, wavepacket, wp_pos, &
                        wp_d, wp_ekin

  if (.not. ionode .or. my_image_id > 0) goto 400

  ! define input defult values
  call get_environment_variable( 'ESPRESSO_TMPDIR', tmp_dir ) 
  if (trim(tmp_dir) == ' ') tmp_dir = './scratch/'
  tmp_dir = trimcheck(tmp_dir)
  job          = ''
  prefix       = 'pwscf'
  tmp_dir      = './scratch/'    
  verbosity    = 'low'
  dt           = 2.d0                      ! time step (default: 2 attosecond)
  e_strength   = 0.01d0                    ! impulse electric field strength (default: 0.01/Ang)
  e_direction  = 1                         ! impulse electric field direction: 1-x 2-y 3-z
  conv_threshold = 1.0d-12                 ! convergence threshold    
  nstep        = 1000                      ! total time steps
  nupdate_Dnm  = 1                         ! update USPP Dnm every step
  l_circular_dichroism = .false.
  l_tddft_restart      = .false.
  max_seconds  =  1.d7
  molecule     = .true.

  ehrenfest    = .false.                   ! Ehrenfest dynamics
  isave_rho    = 0                         ! save density in XSF format

  wavepacket   = .false.
  wp_pos(1:3) = 0.d0
  wp_d(1:3) = 0.d0
  wp_ekin = 0.d0
 
  ! read input    
  IF ( PRESENT(infile)) THEN
     iun = find_free_unit()
     OPEN ( UNIT = iun, FILE = infile, FORM = 'FORMATTED', &
        STATUS = 'OLD', IOSTAT = ios)
     IF (ios /= 0) GOTO 200
     DO 
        READ(iun, '(A200)', IOSTAT=ios) fstr
        IF (ios /= 0) GOTO 200
        fstr=ADJUSTL(fstr)
        IF (fstr(1:1)=='&') THEN
           DO i=2, LEN_TRIM(fstr)
              fstr(i:i)=lowercase(fstr(i:i))
           ENDDO
           IF (fstr=='&inputtddft') THEN
              BACKSPACE(iun)
              EXIT
           ENDIF
        ENDIF
     ENDDO
     READ( iun, inputtddft, ERR = 200, IOSTAT = ios )
     CLOSE( iun )
  ELSE
  call input_from_file()
  read( 5, inputtddft, err = 200, iostat = ios )
  ENDIF

  ! check input
  if (max_seconds < 0.1d0) call errore ('tddft_readin', ' wrong max_seconds', 1)
200 call errore('tddft_readin', 'reading inputtddft namelist', abs(ios))

  select case (verbosity)
     case('low')
       iverbosity = 1
     case('medium')
       iverbosity = 11
     case('high')
       iverbosity = 21
     case default
       call errore('tdddft_readin', 'verbosity can be ''low'', ''medium'' or ''high''', 1)
  end select

  ! convert to atomic units
  e_strength = e_strength * bohr_radius_angs ! change from 1/Ang to 1/Bohr
  dt = dt * 1.d-18 / (2.d0*au_sec)           ! change from femto-second to a.u. (Rydberg unit)
400 continue

#ifdef __MPI
  ! broadcast input variables  
  call tddft_bcast_input
#endif

END SUBROUTINE qepy_tddft_readin


!#ifdef __MPI
!!-----------------------------------------------------------------------
!SUBROUTINE tddft_bcast_input
!  !-----------------------------------------------------------------------
!  !
!  ! ... Broadcast input data to all processors 
!  !
!  USE mp_world,      ONLY : world_comm
!  USE mp,            ONLY : mp_bcast
!  USE io_files,      ONLY : prefix, tmp_dir
!  USE tddft_module

!  implicit none
!  integer, parameter :: root = 0    

!  call mp_bcast(job, root, world_comm)
!  call mp_bcast(prefix, root, world_comm)
!  call mp_bcast(tmp_dir, root, world_comm)
!  call mp_bcast(dt, root, world_comm)
!  call mp_bcast(e_strength, root, world_comm)
!  call mp_bcast(e_direction, root, world_comm)
!  call mp_bcast(conv_threshold, root, world_comm)
!  call mp_bcast(nstep, root, world_comm)
!  call mp_bcast(nupdate_Dnm , root, world_comm)
!  call mp_bcast(l_circular_dichroism, root, world_comm)
!  call mp_bcast(l_tddft_restart, root, world_comm)
!  call mp_bcast(iverbosity, root, world_comm)
!  call mp_bcast(max_seconds, root, world_comm)
!  call mp_bcast(molecule, root, world_comm)
!  call mp_bcast(ehrenfest, root, world_comm)
!  call mp_bcast(isave_rho, root, world_comm)
!  call mp_bcast(wavepacket, root, world_comm)
!  call mp_bcast(wp_pos, root, world_comm)
!  call mp_bcast(wp_d, root, world_comm)
!  call mp_bcast(wp_ekin, root, world_comm)

!END SUBROUTINE tddft_bcast_input
!#endif
  

!!-----------------------------------------------------------------------
SUBROUTINE qepy_tddft_allocate
  !-----------------------------------------------------------------------
  !
  ! ... Allocate memory for TDDFT
  !
  USE tddft_module
  USE klist,         ONLY : nkstot
  USE wvfct,         ONLY : btype, nbndx
  USE tddft_module

  implicit none

  ! needed by sum_band
  IF (.NOT.ALLOCATED(btype)) THEN
  allocate(btype(nbndx,nkstot))
  btype = 1
  ENDIF
    
END SUBROUTINE qepy_tddft_allocate


!!-----------------------------------------------------------------------
!SUBROUTINE tddft_summary
!  !-----------------------------------------------------------------------
!  !
!  ! ... Print a short summary of the calculation
!  !
!  USE io_global,        ONLY : stdout
!  USE lsda_mod,         ONLY : nspin
!  USE wvfct,            ONLY : nbnd
!  USE paw_variables,    ONLY : okpaw
!  USE uspp,             ONLY : okvan
!  USE tddft_module
!  implicit none
!  integer :: is
 
!  write(stdout,*)

!  write(stdout,'(5X,''Calculation type      : '',A12)') job
!  if (molecule) then
!     write(stdout,'(5X,''System is             : molecule'')')
!  else
!     write(stdout,'(5X,''System is             : crystal'')')
!  endif
!  if (ehrenfest) then
!     write(stdout,'(5X,''Ehrenfest dynamics'')')
!     if (okpaw .or. okvan) call infomsg('tddft_summary', 'Ehrenfest dynamics not yet supported with USPP and PAW')
!  endif
!  write(stdout,'(5X,''Number or steps       : '',I12)') nstep
!  write(stdout,'(5X,''Time step             : '',F12.4,'' rydberg_atomic_time'')') dt
!  write(stdout,'(5X,''Electric field dir.   : '',I12,'' (1=x,2=y,3=z)'')') e_direction
!  write(stdout,'(5X,''Electric field impulse: '',F12.4,'' bohrradius^-1'')') e_strength

!  write(stdout,*)

!  if (tfixed_occ) then
!     write(stdout,'(5X,''Occupations from input:'')')
!     do is = 1, nspin
!       write(stdout,'(5X,''ispin='',I1,'': '')',advance='no') is
!       write(stdout,'(10(F5.2,2X))') f_inp(1:nbnd,is)
!     enddo
!    write(stdout,*)
!  endif
     
!  flush( stdout )

!END SUBROUTINE tddft_summary
  
  

!!-----------------------------------------------------------------------
!SUBROUTINE tddft_openfil
!  !-----------------------------------------------------------------------
!  !
!  ! ... Open files needed for TDDFT
!  !
!  USE tddft_module   
!  USE wvfct,            ONLY : nbnd, npwx
!  USE ldaU,             ONLY : lda_plus_U, nwfcU
!  USE io_files,         ONLY : iunhub, iunwfc,nwordwfcU, nwordwfc, seqopn
!  USE noncollin_module, ONLY : npol
!  USE buffers,          ONLY : open_buffer
!  USE control_flags,    ONLY : io_level    
!  IMPLICIT NONE  
!  character*1, parameter :: dir(3) = (/'x', 'y', 'z'/)
!  logical :: exst

!  !
!  ! ... nwordwfc is the record length (IN REAL WORDS)
!  ! ... for the direct-access file containing wavefunctions
!  ! ... io_level > 0 : open a file; io_level <= 0 : open a buffer
!  !
!  nwordwfc = nbnd*npwx*npol
!  CALL open_buffer( iunwfc, 'wfc', nwordwfc, io_level, exst )

!  ! do not overwrite wfc
!  nwordwfc = nbnd*npwx*npol
!  CALL open_buffer( iunevcn, 'wfc'//dir(e_direction), nwordwfc, io_level, exst )

!  ! for restart
!  nwordtdwfc = nbnd*npwx*npol*2
!  CALL open_buffer( iuntdwfc, 'tmp'//dir(e_direction), nwordtdwfc, io_level, exst )

!  ! ... Needed for LDA+U
!  ! ... iunhub contains the (orthogonalized) atomic wfcs * S
!  nwordwfcU = npwx*nwfcU*npol
!  IF ( lda_plus_u ) &
!     CALL open_buffer( iunhub, 'hub', nwordwfcU, io_level, exst )

!END SUBROUTINE tddft_openfil


!-----------------------------------------------------------------------
SUBROUTINE qepy_tddft_closefil
  !-----------------------------------------------------------------------
  !
  ! ... Close files opened by TDDFT
  !
  USE ldaU,             ONLY : lda_plus_U  
  USE io_files,         ONLY : iunhub, iunwfc
  USE buffers,          ONLY : close_buffer
  USE tddft_module
  IMPLICIT NONE
  logical :: opnd

  call close_buffer( iunwfc, 'keep' )
  call close_buffer( iunevcn, 'keep' )
  call close_buffer( iuntdwfc, 'keep' )
  if ( lda_plus_u ) call close_buffer ( iunhub, status = 'keep' )
  inquire (unit = iunwfc, opened = opnd)
  inquire (unit = iunevcn, opened = opnd)
  inquire (unit = iuntdwfc, opened = opnd)

END SUBROUTINE qepy_tddft_closefil



!!-----------------------------------------------------------------------
!SUBROUTINE print_clock_tddft
!  !-----------------------------------------------------------------------
!  !
!  ! ... Print clocks
!  !
!  USE io_global,  ONLY : stdout
!  IMPLICIT NONE

!  write(stdout,*) '    Initialization:'
!  call print_clock ('tddft_setup')
!  write(stdout,*)
!  write(stdout,*) '    Linear response'
!  call print_clock ('greenf')
!  call print_clock ('cgsolve')
!  call print_clock ('ch_psi')
!  call print_clock ('h_psi')
!  call print_clock ('s_psi')
!  write(stdout,*) '    Real time evolution'
!  call print_clock ('updateH')
!  call print_clock ('dipole')
!  call print_clock ('quadrupole')
!  call print_clock ('circular')
!  write(stdout,*)
!  write(stdout,*) '    General routines'
!  call print_clock ('calbec')
!  call print_clock ('fft')
!  call print_clock ('ffts')
!  call print_clock ('fftw')
!  call print_clock ('cinterpolate')
!  call print_clock ('davcio')
!  call print_clock ('write_rec')
!  write(stdout,*)

!#ifdef __MPI
!  write(stdout,*) '    Parallel routines'
!  call print_clock ('reduce')  
!  call print_clock( 'fft_scatter' )
!  call print_clock( 'ALLTOALL' )
!  write(stdout,*)
!#endif
!  call print_clock ('TDDFT') 

!END SUBROUTINE print_clock_tddft



!!-----------------------------------------------------------------------
!SUBROUTINE tddft_memory_report
!  !-----------------------------------------------------------------------
!  !
!  ! ... Print estimated memory usage
!  !
!  USE io_global,                 ONLY : stdout
!  USE noncollin_module,          ONLY : npol
!  USE uspp,                      ONLY : nkb
!  USE fft_base,                  ONLY : dffts
!  USE pwcom
!  IMPLICIT NONE
!  integer, parameter :: Mb=1024*1024, complex_size=16, real_size=8

!  ! the conversions to double prevent integer overflow in very large run
!  write(stdout,'(5x,"Largest allocated arrays",5x,"est. size (Mb)",5x,"dimensions")')

!  write(stdout,'(8x,"KS wavefunctions at k     ",f10.2," Mb",5x,"(",i8,",",i5,")")') &
!     complex_size*nbnd*npol*DBLE(npwx)/Mb, npwx*npol,nbnd

!  write(stdout,'(8x,"First-order wavefunctions ",f10.2," Mb",5x,"(",i8,",",i5,",",i3")")') &
!     complex_size*nbnd*npol*DBLE(npwx)*10/Mb, npwx*npol,nbnd,10

!  write(stdout,'(8x,"Charge/spin density       ",f10.2," Mb",5x,"(",i8,",",i5,")")') &
!     real_size*dble(dffts%nnr)*nspin/Mb, dffts%nnr, nspin
  
!  write(stdout,'(8x,"NL pseudopotentials       ",f10.2," Mb",5x,"(",i8,",",i5,")")') &
!     complex_size*nkb*DBLE(npwx)/Mb, npwx, nkb
!  write(stdout,*)

!END SUBROUTINE tddft_memory_report

#!/usr/bin/env sh
check_exit() {
	if [ $1 -ne 0 ]
	then
		echo "!!!ERROR: something wrong in the test : exit code = $1"
		exit $1
	fi
}

serial='y'
parallel=''
if [ $# -gt 1 ]
then
	parallel='y'
elif [ $# -eq 1 ]
then
	if [ "$1" = "p" ]
	then
		serial=''
		parallel='y'
	fi
fi

if [ $serial ]; then
	echo "####################Test serial version####################"
	for f in *py
	do
		python3 -m pytest --cov-report term-missing --cov=./ $f
		check_exit $?
	done
fi

if [ $parallel ]; then
	echo "####################Test MPI version#######################"
	for f in *py
	do
		mpirun -n 2 python3 -m pytest --with-mpi $f
		check_exit $?
	done
fi

#!/bin/sh
LC_ALL=C
export LC_ALL
QEDIR=${qedir}
if [ ! $QEDIR ];then
	QEDIR=../../../
fi
#QESUBS=`ls -d ${QEDIR}/*/`
${QEDIR}/install/moduledep.sh  > make.depend
${QEDIR}/install/includedep.sh >> make.depend

# handle special cases
sed -i '/@/d'                 make.depend
